
from grammar import *

class Reproducer:
    def __init__(self, f):
        self.f = f
        self.fn = None
        self.ln = None

    def write(self, n):
        self.write_ast(n)
        self.f.write('\n')

    def write_ast(self, n):
        for a in n.src:
            if isinstance(a, ASTNode):
                if a is n:
                    self.f.write("$recursion$ ")
                    print("Recursion")
                else:
                    self.write_ast(a)
            elif isinstance(a, Token):
                self.write_tkn(a)
            else:
                self.f.write("$unknown$ ")
                print("Unknown src type ",type(a))

    def write_tkn(self, a):
        if a.src is None:
            pass
        elif a.src.f != self.fn:
            self.f.write('\n#line {} "{}"\n'.format(a.src.b[0], a.src.f))
            self.fn = a.src.f
            self.ln = a.src.b[0]
        elif a.src.b[0] < self.ln or a.src.b[0] > self.ln+5:
            self.f.write('\n#line {} "{}"\n'.format(a.src.b[0], a.src.f))
            self.ln = a.src.b[0]
        elif a.src.b[0] > self.ln:
            self.f.write('\n'*(a.src.b[0] - self.ln))
            self.ln = a.src.b[0]
        self.f.write(a.text+' ')
