from grammar.grammar import ANY, TYP, EOF, Ref, NonTerminal
from .syntax import CXXLexical
from .syntax import CPPSyntax
from .syntax import CXXSyntax
import grammar

class CXXTokenizer (CXXLexical, grammar.gen_regular.ConflictFirstListed, grammar.engine.SourceTrace, grammar.eng_fsm.LexicalAnalyser, grammar.eng_fsm.FiniteStateMachine):
    from grammar.eng_fsm import FSMTable, State
    TABLE = FSMTable('CXXLexical', 2)
    TABLE.states = [
        State('', {'-': (107, 'LITERAL_TOKEN'), '/': (108, 'LITERAL_TOKEN'), ')': (31, 'LITERAL_TOKEN'), '+': (109, 'LITERAL_TOKEN'), '%': (110, 'LITERAL_TOKEN'), "'": (111, None), '!': (112, 'LITERAL_TOKEN'), '=': (113, 'LITERAL_TOKEN'), '?': (31, 'LITERAL_TOKEN'), '9': (114, 'INTEGER_LITERAL'), ';': (31, 'LITERAL_TOKEN'), '5': (114, 'INTEGER_LITERAL'), '7': (114, 'INTEGER_LITERAL'), '1': (114, 'INTEGER_LITERAL'), '3': (114, 'INTEGER_LITERAL'), '\t': (115, 'SPACE'), 'm': (20, 'IDENTIFIER'), 'o': (11, 'IDENTIFIER'), 'i': (116, 'IDENTIFIER'), 'k': (117, 'IDENTIFIER'), 'e': (118, 'IDENTIFIER'), 'g': (119, 'IDENTIFIER'), 'a': (120, 'IDENTIFIER'), 'c': (121, 'IDENTIFIER'), '}': (31, 'LITERAL_TOKEN'), 'y': (117, 'IDENTIFIER'), '{': (31, 'LITERAL_TOKEN'), 'u': (122, 'IDENTIFIER'), 'w': (123, 'IDENTIFIER'), 'q': (117, 'IDENTIFIER'), 's': (52, 'IDENTIFIER'), 'M': (117, 'IDENTIFIER'), 'O': (117, 'IDENTIFIER'), 'I': (117, 'IDENTIFIER'), 'K': (117, 'IDENTIFIER'), 'E': (117, 'IDENTIFIER'), 'G': (117, 'IDENTIFIER'), 'A': (117, 'IDENTIFIER'), 'C': (117, 'IDENTIFIER'), ']': (31, 'LITERAL_TOKEN'), '_': (117, 'IDENTIFIER'), 'Y': (117, 'IDENTIFIER'), '[': (31, 'LITERAL_TOKEN'), 'U': (117, 'IDENTIFIER'), 'W': (117, 'IDENTIFIER'), 'Q': (117, 'IDENTIFIER'), 'S': (117, 'IDENTIFIER'), ',': (31, 'LITERAL_TOKEN'), '.': (124, 'LITERAL_TOKEN'), '(': (31, 'LITERAL_TOKEN'), '*': (125, 'LITERAL_TOKEN'), '&': (126, 'LITERAL_TOKEN'), ' ': (115, 'SPACE'), '"': (127, None), '<': (128, 'LITERAL_TOKEN'), '>': (129, 'LITERAL_TOKEN'), '8': (114, 'INTEGER_LITERAL'), ':': (30, 'LITERAL_TOKEN'), '4': (114, 'INTEGER_LITERAL'), '6': (114, 'INTEGER_LITERAL'), '0': (39, 'INTEGER_LITERAL'), '2': (114, 'INTEGER_LITERAL'), '\n': (31, 'SPACE'), 'l': (76, 'IDENTIFIER'), 'n': (130, 'IDENTIFIER'), 'h': (117, 'IDENTIFIER'), 'j': (117, 'IDENTIFIER'), 'd': (131, 'IDENTIFIER'), 'f': (132, 'IDENTIFIER'), 'b': (133, 'IDENTIFIER'), '|': (134, 'LITERAL_TOKEN'), '~': (31, 'LITERAL_TOKEN'), 'x': (117, 'IDENTIFIER'), 'z': (117, 'IDENTIFIER'), 't': (135, 'IDENTIFIER'), 'v': (136, 'IDENTIFIER'), 'p': (137, 'IDENTIFIER'), 'r': (64, 'IDENTIFIER'), 'L': (138, 'IDENTIFIER'), 'N': (117, 'IDENTIFIER'), 'H': (117, 'IDENTIFIER'), 'J': (117, 'IDENTIFIER'), 'D': (117, 'IDENTIFIER'), 'F': (117, 'IDENTIFIER'), '@': (31, 'LITERAL_TOKEN'), 'B': (117, 'IDENTIFIER'), '^': (89, 'LITERAL_TOKEN'), 'X': (117, 'IDENTIFIER'), 'Z': (117, 'IDENTIFIER'), 'T': (117, 'IDENTIFIER'), 'V': (117, 'IDENTIFIER'), 'P': (117, 'IDENTIFIER'), 'R': (117, 'IDENTIFIER')}, 0),
        State('', {'-': (107, 'LITERAL_TOKEN'), '/': (108, 'LITERAL_TOKEN'), ')': (31, 'LITERAL_TOKEN'), '+': (109, 'LITERAL_TOKEN'), '%': (110, 'LITERAL_TOKEN'), "'": (111, None), '!': (112, 'LITERAL_TOKEN'), '#': (100, None), '=': (113, 'LITERAL_TOKEN'), '?': (31, 'LITERAL_TOKEN'), '9': (114, 'INTEGER_LITERAL'), ';': (31, 'LITERAL_TOKEN'), '5': (114, 'INTEGER_LITERAL'), '7': (114, 'INTEGER_LITERAL'), '1': (114, 'INTEGER_LITERAL'), '3': (114, 'INTEGER_LITERAL'), '\t': (206, 'SPACE'), 'm': (20, 'IDENTIFIER'), 'o': (11, 'IDENTIFIER'), 'i': (116, 'IDENTIFIER'), 'k': (117, 'IDENTIFIER'), 'e': (118, 'IDENTIFIER'), 'g': (119, 'IDENTIFIER'), 'a': (120, 'IDENTIFIER'), 'c': (121, 'IDENTIFIER'), '}': (31, 'LITERAL_TOKEN'), 'y': (117, 'IDENTIFIER'), '{': (31, 'LITERAL_TOKEN'), 'u': (122, 'IDENTIFIER'), 'w': (123, 'IDENTIFIER'), 'q': (117, 'IDENTIFIER'), 's': (52, 'IDENTIFIER'), 'M': (117, 'IDENTIFIER'), 'O': (117, 'IDENTIFIER'), 'I': (117, 'IDENTIFIER'), 'K': (117, 'IDENTIFIER'), 'E': (117, 'IDENTIFIER'), 'G': (117, 'IDENTIFIER'), 'A': (117, 'IDENTIFIER'), 'C': (117, 'IDENTIFIER'), ']': (31, 'LITERAL_TOKEN'), '_': (117, 'IDENTIFIER'), 'Y': (117, 'IDENTIFIER'), '[': (31, 'LITERAL_TOKEN'), 'U': (117, 'IDENTIFIER'), 'W': (117, 'IDENTIFIER'), 'Q': (117, 'IDENTIFIER'), 'S': (117, 'IDENTIFIER'), ',': (31, 'LITERAL_TOKEN'), '.': (124, 'LITERAL_TOKEN'), '(': (31, 'LITERAL_TOKEN'), '*': (125, 'LITERAL_TOKEN'), '&': (126, 'LITERAL_TOKEN'), ' ': (206, 'SPACE'), '"': (127, None), '<': (128, 'LITERAL_TOKEN'), '>': (129, 'LITERAL_TOKEN'), '8': (114, 'INTEGER_LITERAL'), ':': (30, 'LITERAL_TOKEN'), '4': (114, 'INTEGER_LITERAL'), '6': (114, 'INTEGER_LITERAL'), '0': (39, 'INTEGER_LITERAL'), '2': (114, 'INTEGER_LITERAL'), '\n': (31, 'SPACE'), 'l': (76, 'IDENTIFIER'), 'n': (130, 'IDENTIFIER'), 'h': (117, 'IDENTIFIER'), 'j': (117, 'IDENTIFIER'), 'd': (131, 'IDENTIFIER'), 'f': (132, 'IDENTIFIER'), 'b': (133, 'IDENTIFIER'), '|': (134, 'LITERAL_TOKEN'), '~': (31, 'LITERAL_TOKEN'), 'x': (117, 'IDENTIFIER'), 'z': (117, 'IDENTIFIER'), 't': (135, 'IDENTIFIER'), 'v': (136, 'IDENTIFIER'), 'p': (137, 'IDENTIFIER'), 'r': (64, 'IDENTIFIER'), 'L': (138, 'IDENTIFIER'), 'N': (117, 'IDENTIFIER'), 'H': (117, 'IDENTIFIER'), 'J': (117, 'IDENTIFIER'), 'D': (117, 'IDENTIFIER'), 'F': (117, 'IDENTIFIER'), '@': (31, 'LITERAL_TOKEN'), 'B': (117, 'IDENTIFIER'), '^': (89, 'LITERAL_TOKEN'), 'X': (117, 'IDENTIFIER'), 'Z': (117, 'IDENTIFIER'), 'T': (117, 'IDENTIFIER'), 'V': (117, 'IDENTIFIER'), 'P': (117, 'IDENTIFIER'), 'R': (117, 'IDENTIFIER')}, 1),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (4, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 2),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 3),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (104, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 4),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (6, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 5),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (170, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 6),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (8, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 7),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (255, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 8),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (10, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 9),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (60, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 10),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (12, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 11),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (166, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 12),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (14, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 13),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (82, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 14),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (16, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 15),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (228, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 16),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'ACCESS_KEYWORD'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 17),
        State('', {'d': (19, None), 'e': (19, None), 'f': (19, None), 'a': (19, None), 'b': (19, None), 'c': (19, None), '8': (19, None), '9': (19, None), '4': (19, None), '5': (19, None), '6': (19, None), '7': (19, None), '0': (19, None), '1': (19, None), '2': (19, None), '3': (19, None), 'D': (19, None), 'E': (19, None), 'F': (19, None), 'A': (19, None), 'B': (19, None), 'C': (19, None)}, 18),
        State('', {'d': (37, None), 'e': (37, None), 'f': (37, None), 'a': (37, None), 'b': (37, None), 'c': (37, None), '8': (37, None), '9': (37, None), '4': (37, None), '5': (37, None), '6': (37, None), '7': (37, None), '0': (37, None), '1': (37, None), '2': (37, None), '3': (37, None), 'D': (37, None), 'E': (37, None), 'F': (37, None), 'A': (37, None), 'B': (37, None), 'C': (37, None)}, 19),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (21, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 20),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (236, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 21),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (7, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 22),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (24, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 23),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'LITERAL_TOKEN'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 24),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (26, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (27, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 25),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'LITERAL_TOKEN'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 26),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (33, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 27),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (29, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 28),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (46, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 29),
        State('', {':': (31, 'LITERAL_TOKEN')}, 30),
        State('', {}, 31),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'LITERAL_TOKEN'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 32),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'LITERAL_TOKEN'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 33),
        State('', {'l': (31, 'FLOATING_LITERAL'), 'L': (31, 'FLOATING_LITERAL'), 'E': (35, None), 'f': (31, 'FLOATING_LITERAL'), '1': (34, 'FLOATING_LITERAL'), '8': (34, 'FLOATING_LITERAL'), '9': (34, 'FLOATING_LITERAL'), 'e': (35, None), '4': (34, 'FLOATING_LITERAL'), '5': (34, 'FLOATING_LITERAL'), '6': (34, 'FLOATING_LITERAL'), '7': (34, 'FLOATING_LITERAL'), '0': (34, 'FLOATING_LITERAL'), 'F': (31, 'FLOATING_LITERAL'), '2': (34, 'FLOATING_LITERAL'), '3': (34, 'FLOATING_LITERAL')}, 34),
        State('', {'-': (158, None), '+': (158, None), '8': (159, 'FLOATING_LITERAL'), '9': (159, 'FLOATING_LITERAL'), '4': (159, 'FLOATING_LITERAL'), '5': (159, 'FLOATING_LITERAL'), '6': (159, 'FLOATING_LITERAL'), '7': (159, 'FLOATING_LITERAL'), '0': (159, 'FLOATING_LITERAL'), '1': (159, 'FLOATING_LITERAL'), '2': (159, 'FLOATING_LITERAL'), '3': (159, 'FLOATING_LITERAL')}, 35),
        State('', {ANY(): (37, None), 'x': (18, None), '\n': ('e', None), '4': (38, None), '5': (38, None), '6': (38, None), '7': (38, None), '0': (38, None), '1': (38, None), '2': (38, None), '3': (38, None)}, 36),
        State('', {"'": (31, 'CHARACTER_LITERAL')}, 37),
        State('', {"'": (31, 'CHARACTER_LITERAL'), '4': (235, None), '5': (235, None), '6': (235, None), '7': (235, None), '0': (235, None), '1': (235, None), '2': (235, None), '3': (235, None)}, 38),
        State('', {'l': (40, 'INTEGER_LITERAL'), 'L': (40, 'INTEGER_LITERAL'), '.': (41, 'FLOATING_LITERAL'), 'h': (40, 'INTEGER_LITERAL'), 'H': (40, 'INTEGER_LITERAL'), '0': (42, 'INTEGER_LITERAL'), '5': (42, 'INTEGER_LITERAL'), '8': (43, None), '9': (43, None), 'U': (40, 'INTEGER_LITERAL'), '4': (42, 'INTEGER_LITERAL'), 'u': (40, 'INTEGER_LITERAL'), '6': (42, 'INTEGER_LITERAL'), '7': (42, 'INTEGER_LITERAL'), 'x': (44, None), '1': (42, 'INTEGER_LITERAL'), '2': (42, 'INTEGER_LITERAL'), '3': (42, 'INTEGER_LITERAL')}, 39),
        State('', {'l': (40, 'INTEGER_LITERAL'), 'L': (40, 'INTEGER_LITERAL'), 'h': (40, 'INTEGER_LITERAL'), 'u': (40, 'INTEGER_LITERAL'), 'H': (40, 'INTEGER_LITERAL'), 'U': (40, 'INTEGER_LITERAL')}, 40),
        State('', {'l': (31, 'FLOATING_LITERAL'), 'L': (31, 'FLOATING_LITERAL'), 'E': (35, None), 'f': (31, 'FLOATING_LITERAL'), 'F': (31, 'FLOATING_LITERAL'), '8': (41, 'FLOATING_LITERAL'), '9': (41, 'FLOATING_LITERAL'), 'e': (35, None), '4': (41, 'FLOATING_LITERAL'), '5': (41, 'FLOATING_LITERAL'), '6': (41, 'FLOATING_LITERAL'), '7': (41, 'FLOATING_LITERAL'), '0': (41, 'FLOATING_LITERAL'), '1': (41, 'FLOATING_LITERAL'), '2': (41, 'FLOATING_LITERAL'), '3': (41, 'FLOATING_LITERAL')}, 41),
        State('', {'l': (40, 'INTEGER_LITERAL'), 'L': (40, 'INTEGER_LITERAL'), '.': (41, 'FLOATING_LITERAL'), 'h': (40, 'INTEGER_LITERAL'), 'H': (40, 'INTEGER_LITERAL'), '8': (43, None), '9': (43, None), '2': (42, 'INTEGER_LITERAL'), 'u': (40, 'INTEGER_LITERAL'), '4': (42, 'INTEGER_LITERAL'), '5': (42, 'INTEGER_LITERAL'), '6': (42, 'INTEGER_LITERAL'), '7': (42, 'INTEGER_LITERAL'), '0': (42, 'INTEGER_LITERAL'), '1': (42, 'INTEGER_LITERAL'), 'U': (40, 'INTEGER_LITERAL'), '3': (42, 'INTEGER_LITERAL')}, 42),
        State('', {'.': (41, 'FLOATING_LITERAL'), '8': (43, None), '9': (43, None), '4': (43, None), '5': (43, None), '6': (43, None), '7': (43, None), '0': (43, None), '1': (43, None), '2': (43, None), '3': (43, None)}, 43),
        State('', {'d': (51, 'INTEGER_LITERAL'), 'e': (51, 'INTEGER_LITERAL'), 'f': (51, 'INTEGER_LITERAL'), 'a': (51, 'INTEGER_LITERAL'), 'b': (51, 'INTEGER_LITERAL'), 'c': (51, 'INTEGER_LITERAL'), '8': (51, 'INTEGER_LITERAL'), '9': (51, 'INTEGER_LITERAL'), '4': (51, 'INTEGER_LITERAL'), '5': (51, 'INTEGER_LITERAL'), '6': (51, 'INTEGER_LITERAL'), '7': (51, 'INTEGER_LITERAL'), '0': (51, 'INTEGER_LITERAL'), '1': (51, 'INTEGER_LITERAL'), '2': (51, 'INTEGER_LITERAL'), '3': (51, 'INTEGER_LITERAL'), 'D': (51, 'INTEGER_LITERAL'), 'E': (51, 'INTEGER_LITERAL'), 'F': (51, 'INTEGER_LITERAL'), 'A': (51, 'INTEGER_LITERAL'), 'B': (51, 'INTEGER_LITERAL'), 'C': (51, 'INTEGER_LITERAL')}, 44),
        State('', {ANY(): (45, None), '\n': (31, 'SPACE')}, 45),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'BOOLEAN_LITERAL'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 46),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (48, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 47),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (203, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 48),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (50, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 49),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (237, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 50),
        State('', {'l': (40, 'INTEGER_LITERAL'), 'h': (40, 'INTEGER_LITERAL'), 'd': (51, 'INTEGER_LITERAL'), 'e': (51, 'INTEGER_LITERAL'), 'f': (51, 'INTEGER_LITERAL'), 'a': (51, 'INTEGER_LITERAL'), 'b': (51, 'INTEGER_LITERAL'), 'c': (51, 'INTEGER_LITERAL'), '8': (51, 'INTEGER_LITERAL'), '9': (51, 'INTEGER_LITERAL'), 'u': (40, 'INTEGER_LITERAL'), '4': (51, 'INTEGER_LITERAL'), '5': (51, 'INTEGER_LITERAL'), '6': (51, 'INTEGER_LITERAL'), '7': (51, 'INTEGER_LITERAL'), '0': (51, 'INTEGER_LITERAL'), '1': (51, 'INTEGER_LITERAL'), '2': (51, 'INTEGER_LITERAL'), '3': (51, 'INTEGER_LITERAL'), 'L': (40, 'INTEGER_LITERAL'), 'H': (40, 'INTEGER_LITERAL'), 'D': (51, 'INTEGER_LITERAL'), 'E': (51, 'INTEGER_LITERAL'), 'F': (51, 'INTEGER_LITERAL'), 'A': (51, 'INTEGER_LITERAL'), 'B': (51, 'INTEGER_LITERAL'), 'C': (51, 'INTEGER_LITERAL'), 'U': (40, 'INTEGER_LITERAL')}, 51),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (5, 'IDENTIFIER'), 'i': (53, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (54, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (55, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 52),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (208, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (209, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 53),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (245, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (262, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 54),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (231, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 55),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'LITERAL_TOKEN'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 56),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (58, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 57),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (261, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 58),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'LITERAL_TOKEN'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 59),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'DECLARE_KEYWORD'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 60),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'LITERAL_TOKEN'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 61),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (63, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 62),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (15, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 63),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (65, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 64),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (62, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (264, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 65),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (67, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 66),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (207, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 67),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (69, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (70, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 68),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (96, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 69),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (247, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 70),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (72, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 71),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (92, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 72),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (74, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 73),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (201, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 74),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'LITERAL_TOKEN'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 75),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (77, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 76),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (103, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 77),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (79, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 78),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'DECLARE_KEYWORD'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 79),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (81, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 80),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'ACCESS_KEYWORD'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 81),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (178, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 82),
        State('', {ANY(): (83, None), '*': (84, None)}, 83),
        State('', {ANY(): (83, None), '/': (31, 'SPACE')}, 84),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (86, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 85),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (182, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 86),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (88, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 87),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (165, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 88),
        State('', {'=': (31, 'LITERAL_TOKEN')}, 89),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (91, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 90),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (269, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 91),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (93, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 92),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (223, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 93),
        State('', {'*': (31, 'LITERAL_TOKEN')}, 94),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (32, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 95),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (250, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 96),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'TYPE_KEYWORD'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 97),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (99, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 98),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (153, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 99),
        State('', {ANY(): (101, 'CPP'), '\\': (102, None), '\n': ('e', None)}, 100),
        State('', {ANY(): (101, 'CPP'), '\\': (102, None), '\n': ('e', None)}, 101),
        State('', {ANY(): (101, 'CPP')}, 102),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'TYPE_KEYWORD'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 103),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (105, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 104),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'LITERAL_TOKEN'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 105),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'TYPE_KEYWORD'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 106),
        State('', {'-': (31, 'LITERAL_TOKEN'), '>': (94, 'LITERAL_TOKEN'), '=': (31, 'LITERAL_TOKEN')}, 107),
        State('', {'=': (31, 'LITERAL_TOKEN'), '/': (45, None), '*': (83, None)}, 108),
        State('', {'=': (31, 'LITERAL_TOKEN'), '+': (31, 'LITERAL_TOKEN')}, 109),
        State('', {'=': (31, 'LITERAL_TOKEN')}, 110),
        State('', {ANY(): (37, None), '\\': (36, None), "'": ('e', None), '\n': ('e', None)}, 111),
        State('', {'=': (31, 'LITERAL_TOKEN')}, 112),
        State('', {'=': (31, 'LITERAL_TOKEN')}, 113),
        State('', {'l': (40, 'INTEGER_LITERAL'), 'L': (40, 'INTEGER_LITERAL'), '.': (41, 'FLOATING_LITERAL'), 'h': (40, 'INTEGER_LITERAL'), 'H': (40, 'INTEGER_LITERAL'), '8': (114, 'INTEGER_LITERAL'), '9': (114, 'INTEGER_LITERAL'), '2': (114, 'INTEGER_LITERAL'), 'u': (40, 'INTEGER_LITERAL'), '4': (114, 'INTEGER_LITERAL'), '5': (114, 'INTEGER_LITERAL'), '6': (114, 'INTEGER_LITERAL'), '7': (114, 'INTEGER_LITERAL'), '0': (114, 'INTEGER_LITERAL'), '1': (114, 'INTEGER_LITERAL'), 'U': (40, 'INTEGER_LITERAL'), '3': (114, 'INTEGER_LITERAL')}, 114),
        State('', {' ': (115, 'SPACE'), '\t': (115, 'SPACE')}, 115),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (200, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'LITERAL_TOKEN'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 116),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 117),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (176, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (179, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (68, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 118),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (193, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 119),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (266, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 120),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (186, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (187, 'IDENTIFIER'), 'h': (188, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (171, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 121),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (146, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (222, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 122),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (197, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (198, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 123),
        State('', {'8': (34, 'FLOATING_LITERAL'), '9': (34, 'FLOATING_LITERAL'), '*': (31, 'LITERAL_TOKEN'), '4': (34, 'FLOATING_LITERAL'), '5': (34, 'FLOATING_LITERAL'), '6': (34, 'FLOATING_LITERAL'), '7': (34, 'FLOATING_LITERAL'), '0': (34, 'FLOATING_LITERAL'), '1': (34, 'FLOATING_LITERAL'), '2': (34, 'FLOATING_LITERAL'), '3': (34, 'FLOATING_LITERAL')}, 124),
        State('', {'=': (31, 'LITERAL_TOKEN')}, 125),
        State('', {'=': (31, 'LITERAL_TOKEN'), '&': (31, 'LITERAL_TOKEN')}, 126),
        State('', {ANY(): (127, None), '\\': (155, None), '\n': ('e', None), '"': (31, 'STRING_LITERAL')}, 127),
        State('', {'<': (183, 'LITERAL_TOKEN'), '=': (31, 'LITERAL_TOKEN')}, 128),
        State('', {'=': (31, 'LITERAL_TOKEN'), '>': (205, 'LITERAL_TOKEN')}, 129),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (61, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (259, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 130),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (229, 'LITERAL_TOKEN'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (230, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (195, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 131),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (215, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (211, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (28, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (216, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 132),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (232, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (87, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 133),
        State('', {'|': (31, 'LITERAL_TOKEN'), '=': (31, 'LITERAL_TOKEN')}, 134),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (25, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (49, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (184, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (185, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 135),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (268, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (98, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 136),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (139, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (140, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 137),
        State('', {"'": (111, None), '"': (127, None), '8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 138),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (163, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 139),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (271, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (13, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 140),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (142, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 141),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (267, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 142),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'LITERAL_TOKEN'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 143),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (145, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 144),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (233, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 145),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (147, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (148, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 146),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (192, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 147),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (240, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 148),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (59, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 149),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'TYPE_KEYWORD'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 150),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (152, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 151),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (73, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (95, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 152),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (154, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 153),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (56, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 154),
        State('', {ANY(): (127, None), '\n': ('e', None)}, 155),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (157, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 156),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (263, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 157),
        State('', {'8': (159, 'FLOATING_LITERAL'), '9': (159, 'FLOATING_LITERAL'), '4': (159, 'FLOATING_LITERAL'), '5': (159, 'FLOATING_LITERAL'), '6': (159, 'FLOATING_LITERAL'), '7': (159, 'FLOATING_LITERAL'), '0': (159, 'FLOATING_LITERAL'), '1': (159, 'FLOATING_LITERAL'), '2': (159, 'FLOATING_LITERAL'), '3': (159, 'FLOATING_LITERAL')}, 158),
        State('', {'l': (31, 'FLOATING_LITERAL'), 'L': (31, 'FLOATING_LITERAL'), 'f': (31, 'FLOATING_LITERAL'), '1': (159, 'FLOATING_LITERAL'), '8': (159, 'FLOATING_LITERAL'), '9': (159, 'FLOATING_LITERAL'), '4': (159, 'FLOATING_LITERAL'), '5': (159, 'FLOATING_LITERAL'), '6': (159, 'FLOATING_LITERAL'), '7': (159, 'FLOATING_LITERAL'), '0': (159, 'FLOATING_LITERAL'), 'F': (31, 'FLOATING_LITERAL'), '2': (159, 'FLOATING_LITERAL'), '3': (159, 'FLOATING_LITERAL')}, 159),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (161, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 160),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (214, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 161),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'LITERAL_TOKEN'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 162),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (80, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 163),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (2, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 164),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'LITERAL_TOKEN'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 165),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (156, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 166),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (22, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 167),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (169, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 168),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'TYPE_KEYWORD'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 169),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'TYPE_KEYWORD'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 170),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (172, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (173, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 171),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (199, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 172),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'LITERAL_TOKEN'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 173),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (175, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 174),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (85, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 175),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (177, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 176),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'LITERAL_TOKEN'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 177),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'ACCESS_KEYWORD'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 178),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (202, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 179),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (181, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 180),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (258, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 181),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (162, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 182),
        State('', {'=': (31, 'LITERAL_TOKEN')}, 183),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (151, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 184),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'LITERAL_TOKEN'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (253, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 185),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (23, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 186),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (218, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 187),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (150, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 188),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'LITERAL_TOKEN'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 189),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (191, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 190),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (210, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 191),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'LITERAL_TOKEN'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 192),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (194, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 193),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'LITERAL_TOKEN'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 194),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (196, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 195),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (225, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 196),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (217, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 197),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (242, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 198),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'LITERAL_TOKEN'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 199),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (9, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'TYPE_KEYWORD'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 200),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'LITERAL_TOKEN'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 201),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'LITERAL_TOKEN'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 202),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'LITERAL_TOKEN'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 203),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (143, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 204),
        State('', {'=': (31, 'LITERAL_TOKEN')}, 205),
        State('', {' ': (206, 'SPACE'), '\t': (206, 'SPACE'), '#': (100, None)}, 206),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'DECLARE_KEYWORD'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 207),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (168, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 208),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (224, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 209),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'TYPE_KEYWORD'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 210),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'LITERAL_TOKEN'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 211),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (213, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 212),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (204, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 213),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'TYPE_KEYWORD'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 214),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (221, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 215),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (90, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 216),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (243, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 217),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (212, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (251, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 218),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (220, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 219),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (238, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 220),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (106, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 221),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (272, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 222),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'LITERAL_TOKEN'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 223),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (189, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 224),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (219, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 225),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (227, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 226),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (265, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 227),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'DECLARE_KEYWORD'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 228),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (160, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 229),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (144, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (249, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 230),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (149, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 231),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (244, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 232),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'LITERAL_TOKEN'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 233),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (17, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 234),
        State('', {"'": (31, 'CHARACTER_LITERAL'), '4': (37, None), '5': (37, None), '6': (37, None), '7': (37, None), '0': (37, None), '1': (37, None), '2': (37, None), '3': (37, None)}, 235),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (66, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 236),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (57, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 237),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (239, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 238),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (141, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 239),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (226, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 240),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (75, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 241),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (190, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 242),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'LITERAL_TOKEN'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 243),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'TYPE_KEYWORD'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 244),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (246, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 245),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (270, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 246),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (248, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 247),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (78, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 248),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (47, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 249),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'LITERAL_TOKEN'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 250),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (71, 'LITERAL_TOKEN'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 251),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'LITERAL_TOKEN'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 252),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'BOOLEAN_LITERAL'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 253),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'LITERAL_TOKEN'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 254),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'LITERAL_TOKEN'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 255),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (252, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 256),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'LITERAL_TOKEN'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 257),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (234, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 258),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (174, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 259),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'LITERAL_TOKEN'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 260),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'LITERAL_TOKEN'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 261),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (241, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 262),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (260, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 263),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (256, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 264),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'TYPE_KEYWORD'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 265),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (254, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 266),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'LITERAL_TOKEN'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 267),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (164, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (97, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 268),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'DECLARE_KEYWORD'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 269),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (167, 'DECLARE_KEYWORD'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 270),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (3, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (180, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 271),
        State('', {'8': (3, 'IDENTIFIER'), '9': (3, 'IDENTIFIER'), '4': (3, 'IDENTIFIER'), '5': (3, 'IDENTIFIER'), '6': (3, 'IDENTIFIER'), '7': (3, 'IDENTIFIER'), '0': (3, 'IDENTIFIER'), '1': (3, 'IDENTIFIER'), '2': (3, 'IDENTIFIER'), '3': (3, 'IDENTIFIER'), 'l': (3, 'IDENTIFIER'), 'm': (3, 'IDENTIFIER'), 'n': (257, 'IDENTIFIER'), 'o': (3, 'IDENTIFIER'), 'h': (3, 'IDENTIFIER'), 'i': (3, 'IDENTIFIER'), 'j': (3, 'IDENTIFIER'), 'k': (3, 'IDENTIFIER'), 'd': (3, 'IDENTIFIER'), 'e': (3, 'IDENTIFIER'), 'f': (3, 'IDENTIFIER'), 'g': (3, 'IDENTIFIER'), 'a': (3, 'IDENTIFIER'), 'b': (3, 'IDENTIFIER'), 'c': (3, 'IDENTIFIER'), 'x': (3, 'IDENTIFIER'), 'y': (3, 'IDENTIFIER'), 'z': (3, 'IDENTIFIER'), 't': (3, 'IDENTIFIER'), 'u': (3, 'IDENTIFIER'), 'v': (3, 'IDENTIFIER'), 'w': (3, 'IDENTIFIER'), 'p': (3, 'IDENTIFIER'), 'q': (3, 'IDENTIFIER'), 'r': (3, 'IDENTIFIER'), 's': (3, 'IDENTIFIER'), 'L': (3, 'IDENTIFIER'), 'M': (3, 'IDENTIFIER'), 'N': (3, 'IDENTIFIER'), 'O': (3, 'IDENTIFIER'), 'H': (3, 'IDENTIFIER'), 'I': (3, 'IDENTIFIER'), 'J': (3, 'IDENTIFIER'), 'K': (3, 'IDENTIFIER'), 'D': (3, 'IDENTIFIER'), 'E': (3, 'IDENTIFIER'), 'F': (3, 'IDENTIFIER'), 'G': (3, 'IDENTIFIER'), 'A': (3, 'IDENTIFIER'), 'B': (3, 'IDENTIFIER'), 'C': (3, 'IDENTIFIER'), '_': (3, 'IDENTIFIER'), 'X': (3, 'IDENTIFIER'), 'Y': (3, 'IDENTIFIER'), 'Z': (3, 'IDENTIFIER'), 'T': (3, 'IDENTIFIER'), 'U': (3, 'IDENTIFIER'), 'V': (3, 'IDENTIFIER'), 'W': (3, 'IDENTIFIER'), 'P': (3, 'IDENTIFIER'), 'Q': (3, 'IDENTIFIER'), 'R': (3, 'IDENTIFIER'), 'S': (3, 'IDENTIFIER')}, 272),
        ]

class CPPParser (CPPSyntax, grammar.eng_sr.ShiftReduceEngine):
    from grammar.eng_sr import ShiftReduceTable, State, Rule
    _2 = NonTerminal('_2')
    _5 = NonTerminal('_5')
    _4 = NonTerminal('_4')
    _1 = NonTerminal('_1')
    cpp = CPPSyntax.cpp
    path = CPPSyntax.path

    TABLE = ShiftReduceTable('CPPSyntax')
    TABLE.states = [
        #STATE 0
        State([('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 7), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 7), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 7), ('START -> cpp <EOF>', 9), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 7), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 7), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 7), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 7), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 7), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 7), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 7), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 7), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 7)], {cpp: ('g', 60), '#': ('s', 24)}, 0),
        #STATE 1
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 35), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 32)], {ANY(): ('s', 2), EOF: ('r', 0)}, 1),
        #STATE 2
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 33)], {ANY(): ('r', 5), EOF: ('r', 5)}, 2),
        #STATE 3
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 20), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 20), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 20), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 20)], {'e': ('s', 4)}, 3),
        #STATE 4
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {_1: ('g', 50), ' ': ('s', 9), '\t': ('s', 9), _2: ('g', 10)}, 4),
        #STATE 5
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 16), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 16)], {'r': ('s', 6)}, 5),
        #STATE 6
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 17), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 17)], {'o': ('s', 19)}, 6),
        #STATE 7
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 40), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {_1: ('g', 8), EOF: ('r', 1), ' ': ('s', 9), '\t': ('s', 9), _2: ('g', 10)}, 7),
        #STATE 8
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 14), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {_2: ('g', 41), ' ': ('s', 9), '\t': ('s', 9), EOF: ('r', 16)}, 8),
        #STATE 9
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 13)], {'<': ('r', 3), ANY(): ('r', 3), '\t': ('r', 3), 'e': ('r', 3), ' ': ('r', 3), EOF: ('r', 3), '"': ('r', 3), 'i': ('r', 3)}, 9),
        #STATE 10
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 13)], {'<': ('r', 14), ANY(): ('r', 14), '\t': ('r', 14), 'e': ('r', 14), ' ': ('r', 14), EOF: ('r', 14), '"': ('r', 14), 'i': ('r', 14)}, 10),
        #STATE 11
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 19), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 19), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 19), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 19)], {'d': ('s', 12)}, 11),
        #STATE 12
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 20), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 20), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 20), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 20)], {'e': ('s', 33)}, 12),
        #STATE 13
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 32), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 31), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 32), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 32)], {ANY(): ('s', 14), _4: ('g', 1), EOF: ('r', 2)}, 13),
        #STATE 14
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 33)], {ANY(): ('r', 11), EOF: ('r', 11)}, 14),
        #STATE 15
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 39), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 39)], {'"': ('s', 16)}, 15),
        #STATE 16
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 40), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {_1: ('g', 59), EOF: ('r', 19), ' ': ('s', 9), '\t': ('s', 9), _2: ('g', 10)}, 16),
        #STATE 17
        State([('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 17), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 17), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 17), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 17)], {'l': ('s', 18)}, 17),
        #STATE 18
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 18), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 18), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 18), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 18)], {'u': ('s', 49)}, 18),
        #STATE 19
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 18), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 18)], {'r': ('s', 20)}, 19),
        #STATE 20
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {_2: ('g', 10), ' ': ('s', 9), '\t': ('s', 9), _1: ('g', 42)}, 20),
        #STATE 21
        State([('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 16), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 16), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 16), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 16)], {'c': ('s', 22)}, 21),
        #STATE 22
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 17), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 17), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 17), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 17)], {'l': ('s', 48)}, 22),
        #STATE 23
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 35), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 32)], {ANY(): ('s', 2), EOF: ('r', 4)}, 23),
        #STATE 24
        State([('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 14), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 14), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 14), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 14), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 14), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 14), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {_2: ('g', 10), 'i': ('s', 25), _1: ('g', 26), 'e': ('s', 27), ' ': ('s', 9), '\t': ('s', 9)}, 24),
        #STATE 25
        State([('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 15), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 15), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 15), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 15)], {'n': ('s', 28)}, 25),
        #STATE 26
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 14), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 14), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 14), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 14), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 14), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 14)], {_2: ('g', 41), ' ': ('s', 9), '\t': ('s', 9), 'e': ('s', 54), 'i': ('s', 52)}, 26),
        #STATE 27
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 15), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 15)], {'r': ('s', 51)}, 27),
        #STATE 28
        State([('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 16), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 16), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 16), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 16)], {'c': ('s', 17)}, 28),
        #STATE 29
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 31), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 32), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 32), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 32)], {ANY(): ('s', 14), _4: ('g', 23), EOF: ('r', 6)}, 29),
        #STATE 30
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {_1: ('g', 31), ' ': ('s', 9), '\t': ('s', 9), _2: ('g', 10)}, 30),
        #STATE 31
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 25), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 25)], {ANY(): ('s', 13), _2: ('g', 41), ' ': ('s', 9), '\t': ('s', 9)}, 31),
        #STATE 32
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 18), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 18)], {'r': ('s', 30)}, 32),
        #STATE 33
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {_2: ('g', 10), ' ': ('s', 9), '\t': ('s', 9), _1: ('g', 55)}, 33),
        #STATE 34
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 28), ('path -> [^">]!+!', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 28), ('path -> [^">]!+!', 8), ('path -> [^">]!+!', 8)], {ANY(): ('s', 35), path: ('g', 36), _5: ('g', 37)}, 34),
        #STATE 35
        State([('path -> [^">]!+!', 13)], {ANY(): ('r', 10), '>': ('r', 10), '"': ('r', 10)}, 35),
        #STATE 36
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 39), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 39)], {'"': ('s', 38)}, 36),
        #STATE 37
        State([('path -> [^">]!+!', 15), ('path -> [^">]!+!', 8)], {ANY(): ('s', 43), '>': ('r', 13), '"': ('r', 13)}, 37),
        #STATE 38
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 40), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {_1: ('g', 39), EOF: ('r', 7), ' ': ('s', 9), '\t': ('s', 9), _2: ('g', 10)}, 38),
        #STATE 39
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 14), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {_2: ('g', 41), ' ': ('s', 9), '\t': ('s', 9), EOF: ('r', 18)}, 39),
        #STATE 40
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 14), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {_2: ('g', 41), ' ': ('s', 9), '\t': ('s', 9), EOF: ('r', 8)}, 40),
        #STATE 41
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 13)], {'<': ('r', 12), ANY(): ('r', 12), '\t': ('r', 12), 'e': ('r', 12), ' ': ('r', 12), EOF: ('r', 12), '"': ('r', 12), 'i': ('r', 12)}, 41),
        #STATE 42
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 25), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 25), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {ANY(): ('s', 29), _2: ('g', 41), ' ': ('s', 9), '\t': ('s', 9)}, 42),
        #STATE 43
        State([('path -> [^">]!+!', 13)], {ANY(): ('r', 9), '>': ('r', 9), '"': ('r', 9)}, 43),
        #STATE 44
        State([('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 39), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 39)], {'>': ('s', 45)}, 44),
        #STATE 45
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 40)], {_2: ('g', 10), EOF: ('r', 15), ' ': ('s', 9), '\t': ('s', 9), _1: ('g', 40)}, 45),
        #STATE 46
        State([('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 28), ('path -> [^">]!+!', 8), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 28), ('path -> [^">]!+!', 8), ('path -> [^">]!+!', 8)], {ANY(): ('s', 35), path: ('g', 47), _5: ('g', 37)}, 46),
        #STATE 47
        State([('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 39), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 39)], {'>': ('s', 7)}, 47),
        #STATE 48
        State([('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 18), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 18), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 18), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 18)], {'u': ('s', 11)}, 48),
        #STATE 49
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 19), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 19), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 19), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 19)], {'d': ('s', 3)}, 49),
        #STATE 50
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 27), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 27), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 27), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 27), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {'<': ('s', 46), _2: ('g', 41), ' ': ('s', 9), '\t': ('s', 9), '"': ('s', 34)}, 50),
        #STATE 51
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 16), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 16)], {'r': ('s', 53)}, 51),
        #STATE 52
        State([('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 15), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 15), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 15), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 15)], {'n': ('s', 21)}, 52),
        #STATE 53
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 17), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 17)], {'o': ('s', 32)}, 53),
        #STATE 54
        State([('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 15), ('cpp -> #[ \\t]*error[ \\t]+[^ \\t]!.!*!', 15)], {'r': ('s', 5)}, 54),
        #STATE 55
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 27), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 27), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 27), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 27)], {'<': ('s', 56), _2: ('g', 41), ' ': ('s', 9), '\t': ('s', 9), '"': ('s', 57)}, 55),
        #STATE 56
        State([('path -> [^">]!+!', 8), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 28), ('path -> [^">]!+!', 8), ('path -> [^">]!+!', 8), ('cpp -> #[ \\t]*include[ \\t]+<{path:file}>[ \\t]*', 28)], {ANY(): ('s', 35), _5: ('g', 37), path: ('g', 44)}, 56),
        #STATE 57
        State([('path -> [^">]!+!', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 28), ('path -> [^">]!+!', 8), ('path -> [^">]!+!', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 28)], {ANY(): ('s', 35), _5: ('g', 37), path: ('g', 15)}, 57),
        #STATE 58
        State([('START -> cpp <EOF>', 18)], {}, 58),
        #STATE 59
        State([('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 14), ('cpp -> #[ \\t]*include[ \\t]+"{path:file}"[ \\t]*', 8)], {_2: ('g', 41), ' ': ('s', 9), '\t': ('s', 9), EOF: ('r', 17)}, 59),
        #STATE 60
        State([('START -> cpp <EOF>', 13)], {EOF: ('a', None)}, 60),
        ]

    TABLE.rules = [
        Rule(cpp, 9, 'error_d', ([Ref(7), Ref(8)], {})),
        Rule(cpp, 12, 'include_std', ([], {'file': Ref(10)})),
        Rule(cpp, 8, 'error_d', ([Ref(7), []], {})),
        Rule(_2, 1, 'COPY', ([Ref(0)], {})),
        Rule(cpp, 10, 'error_d', ([Ref(8), Ref(9)], {})),
        Rule(_4, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(cpp, 9, 'error_d', ([Ref(8), []], {})),
        Rule(cpp, 12, 'include_local', ([], {'file': Ref(10)})),
        Rule(cpp, 14, 'include_std', ([], {'file': Ref(11)})),
        Rule(_5, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(_5, 1, 'LIST', ([Ref(0)], {})),
        Rule(_4, 1, 'LIST', ([Ref(0)], {})),
        Rule(_1, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(path, 1, 'match_path', ([Ref(0)], {})),
        Rule(_1, 1, 'LIST', ([Ref(0)], {})),
        Rule(cpp, 13, 'include_std', ([], {'file': Ref(11)})),
        Rule(cpp, 13, 'include_std', ([], {'file': Ref(10)})),
        Rule(cpp, 14, 'include_local', ([], {'file': Ref(11)})),
        Rule(cpp, 13, 'include_local', ([], {'file': Ref(10)})),
        Rule(cpp, 13, 'include_local', ([], {'file': Ref(11)})),
        ]

class CXXParser (CXXSyntax, grammar.engine.Reproduce, grammar.eng_glr.GLREngine):
    from grammar.eng_sr import ShiftReduceTable, State, Rule
    parameter_declaration = CXXSyntax.parameter_declaration
    function_definition = CXXSyntax.function_definition
    function_head = CXXSyntax.function_head
    shift_expression = CXXSyntax.shift_expression
    cast_expression = CXXSyntax.cast_expression
    relational_expression = CXXSyntax.relational_expression
    conversion_declarator = CXXSyntax.conversion_declarator
    _123 = NonTerminal('_123')
    and_expression = CXXSyntax.and_expression
    pm_expression = CXXSyntax.pm_expression
    exclusive_or_expression = CXXSyntax.exclusive_or_expression
    class_head = CXXSyntax.class_head
    compound_statement = CXXSyntax.compound_statement
    unnamed_namespace_definition = CXXSyntax.unnamed_namespace_definition
    logical_and_expression = CXXSyntax.logical_and_expression
    _130 = NonTerminal('_130')
    member_specification = CXXSyntax.member_specification
    ctor_initializer = CXXSyntax.ctor_initializer
    conditional_expression = CXXSyntax.conditional_expression
    member_cd_declarator = CXXSyntax.member_cd_declarator
    multiplicative_expression = CXXSyntax.multiplicative_expression
    member_declarator = CXXSyntax.member_declarator
    expression = CXXSyntax.expression
    translation_unit = CXXSyntax.translation_unit
    constant_initializer = CXXSyntax.constant_initializer
    base_clause = CXXSyntax.base_clause
    mem_initializer = CXXSyntax.mem_initializer
    labeled_statement = CXXSyntax.labeled_statement
    expression_statement = CXXSyntax.expression_statement
    additive_expression = CXXSyntax.additive_expression
    conversion_function_id = CXXSyntax.conversion_function_id
    conversion_type_id = CXXSyntax.conversion_type_id
    namespace_alias_definition = CXXSyntax.namespace_alias_definition
    condition = CXXSyntax.condition
    iteration_statement = CXXSyntax.iteration_statement
    mem_initializer_id = CXXSyntax.mem_initializer_id
    for_init_statement = CXXSyntax.for_init_statement
    jump_statement = CXXSyntax.jump_statement
    function_body = CXXSyntax.function_body
    operator_function_id = CXXSyntax.operator_function_id
    operator = CXXSyntax.operator
    qualified_namespace_specifier = CXXSyntax.qualified_namespace_specifier
    template_declaration = CXXSyntax.template_declaration
    template_parameter = CXXSyntax.template_parameter
    declaration_statement = CXXSyntax.declaration_statement
    decl_attrib = CXXSyntax.decl_attrib
    type_descriptor = CXXSyntax.type_descriptor
    _15 = NonTerminal('_15')
    raw_type_descriptor = CXXSyntax.raw_type_descriptor
    named_type_specifier = CXXSyntax.named_type_specifier
    unqualified_id = CXXSyntax.unqualified_id
    simple_type_specifier = CXXSyntax.simple_type_specifier
    _73 = NonTerminal('_73')
    declaration = CXXSyntax.declaration
    elaborated_type_specifier = CXXSyntax.elaborated_type_specifier
    enum_specifier = CXXSyntax.enum_specifier
    equality_expression = CXXSyntax.equality_expression
    handler = CXXSyntax.handler
    exception_specification = CXXSyntax.exception_specification
    exception_declaration = CXXSyntax.exception_declaration
    using_directive = CXXSyntax.using_directive
    throw_expression = CXXSyntax.throw_expression
    _128 = NonTerminal('_128')
    _127 = NonTerminal('_127')
    _84 = NonTerminal('_84')
    original_namespace_definition = CXXSyntax.original_namespace_definition
    class_name = CXXSyntax.class_name
    literal = CXXSyntax.literal
    namespace_body = CXXSyntax.namespace_body
    nested_name_specifier = CXXSyntax.nested_name_specifier
    primary_expression = CXXSyntax.primary_expression
    INTEGER_LITERAL = CXXSyntax.INTEGER_LITERAL
    id_expression = CXXSyntax.id_expression
    simple_declaration = CXXSyntax.simple_declaration
    _75 = NonTerminal('_75')
    qualified_id = CXXSyntax.qualified_id
    class_specifier = CXXSyntax.class_specifier
    asm_definition = CXXSyntax.asm_definition
    linkage_specification = CXXSyntax.linkage_specification
    postfix_expression = CXXSyntax.postfix_expression
    declarator = CXXSyntax.declarator
    type_parameter = CXXSyntax.type_parameter
    direct_declarator = CXXSyntax.direct_declarator
    unary_operator = CXXSyntax.unary_operator
    _100 = NonTerminal('_100')
    cv_qualifier = CXXSyntax.cv_qualifier
    _1 = NonTerminal('_1')
    init_declarator = CXXSyntax.init_declarator
    _74 = NonTerminal('_74')
    _80 = NonTerminal('_80')
    cd_id = CXXSyntax.cd_id
    template_id = CXXSyntax.template_id
    direct_new_declarator = CXXSyntax.direct_new_declarator
    abstract_declarator = CXXSyntax.abstract_declarator
    class_key = CXXSyntax.class_key
    direct_abstract_declarator = CXXSyntax.direct_abstract_declarator
    inclusive_or_expression = CXXSyntax.inclusive_or_expression
    pseudo_destructor_name = CXXSyntax.pseudo_destructor_name
    template_name = CXXSyntax.template_name
    DECLARE_KEYWORD = CXXSyntax.DECLARE_KEYWORD
    logical_or_expression = CXXSyntax.logical_or_expression
    ACCESS_KEYWORD = CXXSyntax.ACCESS_KEYWORD
    IDENTIFIER = CXXSyntax.IDENTIFIER
    unary_expression = CXXSyntax.unary_expression
    _113 = NonTerminal('_113')
    template_argument = CXXSyntax.template_argument
    member_declaration = CXXSyntax.member_declaration
    initializer = CXXSyntax.initializer
    ptr_operator = CXXSyntax.ptr_operator
    type_name = CXXSyntax.type_name
    explicit_instantiation = CXXSyntax.explicit_instantiation
    assignment_expression = CXXSyntax.assignment_expression
    _114 = NonTerminal('_114')
    new_placement = CXXSyntax.new_placement
    new_expression = CXXSyntax.new_expression
    using_declaration = CXXSyntax.using_declaration
    explicit_specialization = CXXSyntax.explicit_specialization
    _57 = NonTerminal('_57')
    assignment_operator = CXXSyntax.assignment_operator
    declarator_id = CXXSyntax.declarator_id
    FLOATING_LITERAL = CXXSyntax.FLOATING_LITERAL
    CHARACTER_LITERAL = CXXSyntax.CHARACTER_LITERAL
    try_block = CXXSyntax.try_block
    BOOLEAN_LITERAL = CXXSyntax.BOOLEAN_LITERAL
    STRING_LITERAL = CXXSyntax.STRING_LITERAL
    pure_specifier = CXXSyntax.pure_specifier
    CPP_INCLUDE = CXXSyntax.CPP_INCLUDE
    CPP_ERROR = CXXSyntax.CPP_ERROR
    cd_declarator = CXXSyntax.cd_declarator
    function_try_block = CXXSyntax.function_try_block
    constant_expression = CXXSyntax.constant_expression
    new_declarator = CXXSyntax.new_declarator
    enumerator_definition = CXXSyntax.enumerator_definition
    statement = CXXSyntax.statement
    initializer_clause = CXXSyntax.initializer_clause
    type_id = CXXSyntax.type_id
    _117 = NonTerminal('_117')
    enumerator = CXXSyntax.enumerator
    _107 = NonTerminal('_107')
    _120 = NonTerminal('_120')
    base_specifier = CXXSyntax.base_specifier
    new_type_id = CXXSyntax.new_type_id
    _81 = NonTerminal('_81')
    new_initializer = CXXSyntax.new_initializer
    namespace_name = CXXSyntax.namespace_name
    access_specifier = CXXSyntax.access_specifier
    delete_expression = CXXSyntax.delete_expression
    namespace_definition = CXXSyntax.namespace_definition
    TYPE_KEYWORD = CXXSyntax.TYPE_KEYWORD
    block_declaration = CXXSyntax.block_declaration
    _109 = NonTerminal('_109')
    parameter_declaration_clause = CXXSyntax.parameter_declaration_clause
    named_namespace_definition = CXXSyntax.named_namespace_definition
    selection_statement = CXXSyntax.selection_statement

    TABLE = ShiftReduceTable('CXXSyntax')
    TABLE.states = [
        #STATE 0
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('named_namespace_definition -> original_namespace_definition!', 30), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ('namespace_definition -> unnamed_namespace_definition!', 24), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 33), ("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 25), ('declaration -> function_definition!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ('block_declaration -> using_declaration!', 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 32), ('type_name -> IDENTIFIER:name', 13), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('translation_unit -> declaration!*:decls', 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ("explicit_instantiation -> 'template' declaration:decl", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> template_declaration!', 15), ('declaration -> CPP_INCLUDE!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> linkage_specification!', 15), None, ('type_name -> template_id!', 13), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_definition -> function_head:head function_try_block:tryb', 23), ('declaration -> CPP_ERROR!', 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('declaration -> namespace_definition!', 15), ("raw_type_descriptor -> 'auto'", 23), ('block_declaration -> asm_definition!', 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('block_declaration -> simple_declaration!', 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('START -> translation_unit <EOF>', 9), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('translation_unit -> declaration!*:decls', 20), ("cv_qualifier -> 'const'!", 16), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('declaration -> explicit_specialization!', 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_directive!', 21), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 27), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('declaration -> explicit_instantiation!', 15), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ('translation_unit -> declaration!*:decls', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('namespace_definition -> named_namespace_definition!', 24), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('declaration -> block_declaration!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), named_type_specifier: ('g', 126), using_declaration: ('g', 127), function_definition: ('g', 128), 'virtual': ('s', 130), _73: ('g', 133), declaration: ('g', 429), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), 'struct': ('s', 58), 'extern': ('s', 139), class_name: ('g', 11), using_directive: ('g', 137), class_specifier: ('g', 138), 'typedef': ('s', 136), namespace_definition: ('g', 140), CPP_INCLUDE: ('s', 129), named_namespace_definition: ('g', 142), 'asm': ('s', 125), original_namespace_definition: ('g', 144), explicit_instantiation: ('g', 146), _81: ('g', 88), unnamed_namespace_definition: ('g', 145), _1: ('g', 124), 'export': ('s', 143), translation_unit: ('g', 835), 'auto': ('s', 90), 'volatile': ('s', 33), type_descriptor: ('g', 169), namespace_alias_definition: ('g', 161), asm_definition: ('g', 149), function_head: ('g', 150), simple_declaration: ('g', 167), explicit_specialization: ('g', 157), _75: ('g', 152), '::': ('s', 153), namespace_name: ('g', 5), 'using': ('s', 154), nested_name_specifier: ('g', 155), linkage_specification: ('g', 156), 'union': ('s', 97), type_name: ('g', 131), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), 'namespace': ('s', 148), template_name: ('g', 2), class_head: ('g', 20), cv_qualifier: ('g', 106), EOF: ('r', 273), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), cd_declarator: ('g', 163), _80: ('g', 112), cd_id: ('g', 164), template_id: ('g', 18), 'class': ('s', 115), block_declaration: ('g', 141), 'typename': ('s', 166), CPP_ERROR: ('s', 151), 'operator': ('s', 168), template_declaration: ('g', 165), 'template': ('s', 147), 'enum': ('s', 117), class_key: ('g', 78), IDENTIFIER: ('s', 29)}, 0),
        #STATE 1
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 26), ('type_name -> IDENTIFIER:name', 13), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 37), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ('id_expression -> unqualified_id!', 17), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::' IDENTIFIER!", 16), ('class_name -> template_id!', 14), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 26), ('type_name -> template_id!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 37), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 48), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 26), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 48), ('namespace_name -> IDENTIFIER:name', 18), ('unqualified_id -> IDENTIFIER:id', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 26), ("unqualified_id -> '~' class_name:name", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> operator_function_id!', 18), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 37), ('template_name -> IDENTIFIER!', 17), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 64), ("operator_function_id -> 'operator' operator:op", 24), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('unqualified_id -> conversion_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 62), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 64), ('id_expression -> qualified_id!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), pseudo_destructor_name: ('g', 14), '::': ('s', 10), namespace_name: ('g', 5), template_id: ('g', 18), operator_function_id: ('g', 6), unqualified_id: ('g', 7), type_name: ('g', 9), id_expression: ('g', 17), conversion_function_id: ('g', 12), '~': ('s', 13), IDENTIFIER: ('s', 3), 'operator': ('s', 8), 'template': ('s', 16), nested_name_specifier: ('g', 15), class_name: ('g', 11), qualified_id: ('g', 4)}, 1),
        #STATE 2
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 34), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 34)], {'<': ('s', 729)}, 2),
        #STATE 3
        State([('class_name -> IDENTIFIER:name', 24), ('namespace_name -> IDENTIFIER:name', 28), ('type_name -> IDENTIFIER:name', 23), ('template_name -> IDENTIFIER!', 27), ('unqualified_id -> IDENTIFIER:id', 28)], {',': ('c', [('r', 95), ('r', 6)]), '-': ('r', 95), '.': ('r', 95), '/': ('r', 95), '(': ('c', [('r', 95), ('r', 6)]), ')': ('c', [('r', 95), ('r', 6)]), '*': ('c', [('r', 95), ('r', 6)]), '+': ('r', 95), '%': ('r', 95), '&': ('c', [('r', 95), ('r', 6)]), '<': ('c', [('r', 95), ('r', 2)]), '=': ('c', [('r', 95), ('r', 6)]), '>': ('c', [('r', 95), ('r', 6)]), '?': ('r', 95), '<<': ('r', 95), IDENTIFIER: ('r', 6), ':': ('r', 95), ';': ('r', 95), '...': ('c', [('r', 95), ('r', 6)]), '|=': ('r', 95), '^=': ('r', 95), '||': ('r', 95), '!=': ('r', 95), '--': ('r', 95), '/=': ('r', 95), '++': ('r', 95), '^': ('r', 95), '<<=': ('r', 95), '->': ('r', 95), '-=': ('r', 95), '%=': ('r', 95), '>>': ('r', 95), '>=': ('r', 95), '<=': ('r', 95), '::': ('c', [('r', 7), ('r', 6), ('r', 5)]), '>>=': ('r', 95), '&&': ('r', 95), '|': ('r', 95), '}': ('r', 95), '~': ('r', 6), '&=': ('r', 95), 'operator': ('r', 6), '->*': ('r', 95), '+=': ('r', 95), ']': ('r', 95), '*=': ('r', 95), '==': ('r', 95), '[': ('c', [('r', 95), ('r', 6)]), '.*': ('r', 95)}, 3),
        #STATE 4
        State([('id_expression -> qualified_id!', 29)], {',': ('r', 102), '-': ('r', 102), '.': ('r', 102), '/': ('r', 102), '|=': ('r', 102), ')': ('r', 102), '*': ('r', 102), '+': ('r', 102), '%': ('r', 102), '&': ('r', 102), '<': ('r', 102), '=': ('r', 102), '>': ('r', 102), '?': ('r', 102), '<<': ('r', 102), ':': ('r', 102), ';': ('r', 102), '...': ('r', 102), '(': ('r', 102), '^=': ('r', 102), '%=': ('r', 102), '!=': ('r', 102), '--': ('r', 102), '/=': ('r', 102), '++': ('r', 102), '^': ('r', 102), '<<=': ('r', 102), '->': ('r', 102), '-=': ('r', 102), '->*': ('r', 102), '+=': ('r', 102), '>=': ('r', 102), '<=': ('r', 102), '||': ('r', 102), '>>=': ('r', 102), '&&': ('r', 102), '|': ('r', 102), '}': ('r', 102), '&=': ('r', 102), '{': ('r', 102), 'try': ('r', 102), '>>': ('r', 102), ']': ('r', 102), '*=': ('r', 102), '==': ('r', 102), '[': ('r', 102), '.*': ('r', 102)}, 4),
        #STATE 5
        State([("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63)], {'::': ('s', 275)}, 5),
        #STATE 6
        State([('unqualified_id -> operator_function_id!', 38)], {',': ('r', 299), '-': ('r', 299), '.': ('r', 299), '/': ('r', 299), '|=': ('r', 299), ')': ('r', 299), '*': ('r', 299), '+': ('r', 299), '%': ('r', 299), '&': ('r', 299), '<': ('r', 299), '=': ('r', 299), '>': ('r', 299), '?': ('r', 299), '<<': ('r', 299), ':': ('r', 299), ';': ('r', 299), '...': ('r', 299), '(': ('r', 299), '^=': ('r', 299), '%=': ('r', 299), '!=': ('r', 299), '--': ('r', 299), '/=': ('r', 299), '++': ('r', 299), '^': ('r', 299), '<<=': ('r', 299), '->': ('r', 299), '-=': ('r', 299), '->*': ('r', 299), '>>': ('r', 299), '>=': ('r', 299), '<=': ('r', 299), '||': ('r', 299), '>>=': ('r', 299), '&&': ('r', 299), '|': ('r', 299), '}': ('r', 299), '&=': ('r', 299), '{': ('r', 299), 'try': ('r', 299), '+=': ('r', 299), ']': ('r', 299), '*=': ('r', 299), '==': ('r', 299), '[': ('r', 299), '.*': ('r', 299)}, 6),
        #STATE 7
        State([('id_expression -> unqualified_id!', 31)], {',': ('r', 483), '-': ('r', 483), '.': ('r', 483), '/': ('r', 483), '|=': ('r', 483), ')': ('r', 483), '*': ('r', 483), '+': ('r', 483), '%': ('r', 483), '&': ('r', 483), '<': ('r', 483), '=': ('r', 483), '>': ('r', 483), '?': ('r', 483), '<<': ('r', 483), ':': ('r', 483), ';': ('r', 483), '...': ('r', 483), '(': ('r', 483), '^=': ('r', 483), '%=': ('r', 483), '!=': ('r', 483), '--': ('r', 483), '/=': ('r', 483), '++': ('r', 483), '^': ('r', 483), '<<=': ('r', 483), '->': ('r', 483), '-=': ('r', 483), '->*': ('r', 483), '>>': ('r', 483), '>=': ('r', 483), '<=': ('r', 483), '||': ('r', 483), '>>=': ('r', 483), '&&': ('r', 483), '|': ('r', 483), '}': ('r', 483), '&=': ('r', 483), '{': ('r', 483), 'try': ('r', 483), '+=': ('r', 483), ']': ('r', 483), '*=': ('r', 483), '==': ('r', 483), '[': ('r', 483), '.*': ('r', 483)}, 7),
        #STATE 8
        State([("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 140), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 40), ('class_name -> template_id!', 14), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 246), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 54), ("cv_qualifier -> 'volatile'!", 16), ("operator -> 'new' '[' ']'", 12), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 61), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 270), ('conversion_type_id -> type_descriptor:type conversion_declarator:dtor?', 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 148), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("conversion_function_id -> 'operator' conversion_type_id!", 37), ('class_head -> class_key:t base_clause:bases?', 14), ("operator -> '(' ')'", 12), ("operator -> 'delete' '[' ']'", 12), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 103), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 47), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 172), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 278), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 222), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 21), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 124), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t base_clause:bases?', 14), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 230), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 110), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 33), ("raw_type_descriptor -> 'auto'", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 204), ('namespace_name -> IDENTIFIER:name', 18), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 254), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ('raw_type_descriptor -> enum_specifier!', 23), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 132), ("class_key -> 'class' | 'struct' | 'union'", 23), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 96), ('type_name -> template_id!', 13), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 302), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 89), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 188), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 156), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 262), ("operator_function_id -> 'operator' operator:op", 35), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 196), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 82), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 213), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 286), ('type_descriptor -> raw_type_descriptor!', 19), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 68), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 164), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 238), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 180), ("operator -> '[' ']'", 12), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 117), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 12), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_name -> IDENTIFIER:name', 14), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 293), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 75), ('conversion_type_id -> type_descriptor:type conversion_declarator:dtor?', 22), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {',': ('s', 963), '-': ('s', 734), '/': ('s', 823), '(': ('s', 561), named_type_specifier: ('g', 126), '*': ('s', 868), raw_type_descriptor: ('g', 54), 'delete': ('s', 663), '%': ('s', 1017), '&': ('s', 458), type_name: ('g', 98), '<': ('s', 544), elaborated_type_specifier: ('g', 109), '>': ('s', 1023), IDENTIFIER: ('s', 29), '|=': ('s', 1019), _81: ('g', 88), '^=': ('s', 918), '::': ('s', 191), 'new': ('s', 394), namespace_name: ('g', 5), '!=': ('s', 22), class_head: ('g', 20), '--': ('s', 1020), class_key: ('g', 78), '++': ('s', 829), '^': ('s', 598), class_name: ('g', 11), 'typename': ('s', 166), '<<=': ('s', 875), '->': ('s', 37), '+': ('s', 52), 'struct': ('s', 58), '-=': ('s', 1021), '%=': ('s', 975), '>>': ('s', 941), '>=': ('s', 1024), 'auto': ('s', 90), 'union': ('s', 97), '<=': ('s', 809), '||': ('s', 378), '/=': ('s', 960), class_specifier: ('g', 75), nested_name_specifier: ('g', 189), '>>=': ('s', 839), '&&': ('s', 554), '!': ('s', 319), '|': ('s', 977), type_descriptor: ('g', 434), '~': ('s', 1018), conversion_type_id: ('g', 1032), '&=': ('s', 362), template_name: ('g', 2), template_id: ('g', 18), cv_qualifier: ('g', 106), '->*': ('s', 1022), TYPE_KEYWORD: ('s', 162), '=': ('s', 670), 'volatile': ('s', 33), _80: ('g', 112), operator: ('g', 853), '+=': ('s', 388), 'class': ('s', 115), '<<': ('s', 821), '==': ('s', 503), '*=': ('s', 1003), '[': ('s', 210), 'const': ('s', 35), 'enum': ('s', 117), enum_specifier: ('g', 122)}, 8),
        #STATE 9
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 76)], {'::': ('s', 431)}, 9),
        #STATE 10
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 37), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("qualified_id -> '::' (operator_function_id!|template_id!)", 22), ('type_name -> IDENTIFIER:name', 13), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 64), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_name -> template_id!', 14), ('type_name -> template_id!', 13), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 37), ('namespace_name -> IDENTIFIER:name', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("qualified_id -> '::' (operator_function_id!|template_id!)", 44), ('template_name -> IDENTIFIER!', 17), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 64), ("operator_function_id -> 'operator' operator:op", 24), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 37), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("qualified_id -> '::' IDENTIFIER!", 21)], {operator_function_id: ('g', 376), template_name: ('g', 2), '~': ('s', 845), IDENTIFIER: ('s', 707), type_name: ('g', 847), namespace_name: ('g', 5), nested_name_specifier: ('g', 846), 'operator': ('s', 619), class_name: ('g', 11), template_id: ('g', 710)}, 10),
        #STATE 11
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63)], {'::': ('s', 237)}, 11),
        #STATE 12
        State([('unqualified_id -> conversion_function_id!', 40)], {',': ('r', 382), '-': ('r', 382), '.': ('r', 382), '/': ('r', 382), '|=': ('r', 382), ')': ('r', 382), '*': ('r', 382), '+': ('r', 382), '%': ('r', 382), '&': ('r', 382), '<': ('r', 382), '=': ('r', 382), '>': ('r', 382), '?': ('r', 382), '<<': ('r', 382), ':': ('r', 382), ';': ('r', 382), '...': ('r', 382), '(': ('r', 382), '^=': ('r', 382), '%=': ('r', 382), '!=': ('r', 382), '--': ('r', 382), '/=': ('r', 382), '++': ('r', 382), '^': ('r', 382), '<<=': ('r', 382), '->': ('r', 382), '-=': ('r', 382), '->*': ('r', 382), '>>': ('r', 382), '>=': ('r', 382), '<=': ('r', 382), '||': ('r', 382), '>>=': ('r', 382), '&&': ('r', 382), '|': ('r', 382), '}': ('r', 382), '&=': ('r', 382), '{': ('r', 382), 'try': ('r', 382), '+=': ('r', 382), ']': ('r', 382), '*=': ('r', 382), '==': ('r', 382), '[': ('r', 382), '.*': ('r', 382)}, 12),
        #STATE 13
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ('type_name -> IDENTIFIER:name', 13), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ('type_name -> template_id!', 13), ("unqualified_id -> '~' class_name:name", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 68)], {type_name: ('g', 622), template_name: ('g', 2), template_id: ('g', 18), IDENTIFIER: ('s', 508), class_name: ('g', 289)}, 13),
        #STATE 14
        State([("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 70)], {',': ('r', 192), '-': ('r', 192), '.': ('r', 192), '/': ('r', 192), '(': ('r', 192), ')': ('r', 192), '*': ('r', 192), '==': ('r', 192), '%': ('r', 192), '&': ('r', 192), '<': ('r', 192), '=': ('r', 192), '>': ('r', 192), '?': ('r', 192), '<<': ('r', 192), ':': ('r', 192), ';': ('r', 192), '...': ('r', 192), '|=': ('r', 192), '^=': ('r', 192), '%=': ('r', 192), '!=': ('r', 192), '--': ('r', 192), '/=': ('r', 192), '++': ('r', 192), '^': ('r', 192), '<<=': ('r', 192), '->': ('r', 192), '-=': ('r', 192), '->*': ('r', 192), '>>': ('r', 192), '>=': ('r', 192), '<=': ('r', 192), '||': ('r', 192), '>>=': ('r', 192), '&&': ('r', 192), '|': ('r', 192), '}': ('r', 192), '&=': ('r', 192), '+=': ('r', 192), '+': ('r', 192), ']': ('r', 192), '*=': ('r', 192), '[': ('r', 192), '.*': ('r', 192)}, 14),
        #STATE 15
        State([('unqualified_id -> conversion_function_id!', 18), ('type_name -> IDENTIFIER:name', 13), ("operator_function_id -> 'operator' operator:op", 24), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 63), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 64), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('unqualified_id -> IDENTIFIER:id', 18), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 64), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 53), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("unqualified_id -> '~' class_name:name", 18), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {operator_function_id: ('g', 6), template_name: ('g', 2), '~': ('s', 507), IDENTIFIER: ('s', 423), conversion_function_id: ('g', 12), 'template': ('s', 904), unqualified_id: ('g', 326), 'operator': ('s', 8), type_name: ('g', 905), template_id: ('g', 26)}, 15),
        #STATE 16
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("operator_function_id -> 'operator' operator:op", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 62), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('class_name -> template_id!', 14), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ('namespace_name -> IDENTIFIER:name', 18), ('unqualified_id -> IDENTIFIER:id', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> operator_function_id!', 18), ('id_expression -> qualified_id!', 17), ("qualified_id -> '::' IDENTIFIER!", 16), ('unqualified_id -> conversion_function_id!', 18), ("unqualified_id -> '~' class_name:name", 18), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), qualified_id: ('g', 4), namespace_name: ('g', 5), operator_function_id: ('g', 6), unqualified_id: ('g', 7), 'operator': ('s', 8), class_name: ('g', 11), conversion_function_id: ('g', 12), '~': ('s', 45), IDENTIFIER: ('s', 46), nested_name_specifier: ('g', 47), id_expression: ('g', 1033), template_id: ('g', 44), '::': ('s', 48)}, 16),
        #STATE 17
        State([("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 75)], {',': ('r', 545), '-': ('r', 545), '.': ('r', 545), '/': ('r', 545), '(': ('r', 545), ')': ('r', 545), '*': ('r', 545), '==': ('r', 545), '%': ('r', 545), '&': ('r', 545), '<': ('r', 545), '=': ('r', 545), '>': ('r', 545), '?': ('r', 545), '<<': ('r', 545), ':': ('r', 545), ';': ('r', 545), '...': ('r', 545), '|=': ('r', 545), '^=': ('r', 545), '%=': ('r', 545), '!=': ('r', 545), '--': ('r', 545), '/=': ('r', 545), '++': ('r', 545), '*=': ('r', 545), '<<=': ('r', 545), '->': ('r', 545), '-=': ('r', 545), '->*': ('r', 545), '>>': ('r', 545), '>=': ('r', 545), '<=': ('r', 545), '||': ('r', 545), '>>=': ('r', 545), '&&': ('r', 545), '|': ('r', 545), '}': ('r', 545), '&=': ('r', 545), '+=': ('r', 545), '+': ('r', 545), ']': ('r', 545), '^': ('r', 545), '[': ('r', 545), '.*': ('r', 545)}, 17),
        #STATE 18
        State([('class_name -> template_id!', 25), ('type_name -> template_id!', 24)], {',': ('c', [('r', 105), ('r', 172)]), '-': ('c', [('r', 105), ('r', 172)]), '.': ('c', [('r', 105), ('r', 172)]), '/': ('c', [('r', 105), ('r', 172)]), '|=': ('c', [('r', 105), ('r', 172)]), ')': ('c', [('r', 105), ('r', 172)]), '*': ('c', [('r', 105), ('r', 172)]), '+': ('c', [('r', 105), ('r', 172)]), '%': ('c', [('r', 105), ('r', 172)]), '&': ('c', [('r', 105), ('r', 172)]), 'operator': ('r', 105), '<': ('c', [('r', 105), ('r', 172)]), '=': ('c', [('r', 105), ('r', 172)]), '>': ('c', [('r', 105), ('r', 172)]), '?': ('c', [('r', 105), ('r', 172)]), '<<': ('c', [('r', 105), ('r', 172)]), IDENTIFIER: ('r', 105), ':': ('c', [('r', 105), ('r', 172)]), ';': ('c', [('r', 105), ('r', 172)]), '...': ('c', [('r', 105), ('r', 172)]), '(': ('c', [('r', 105), ('r', 172)]), '^=': ('c', [('r', 105), ('r', 172)]), '||': ('c', [('r', 105), ('r', 172)]), '^': ('c', [('r', 105), ('r', 172)]), '!=': ('c', [('r', 105), ('r', 172)]), '--': ('c', [('r', 105), ('r', 172)]), '/=': ('c', [('r', 105), ('r', 172)]), '++': ('c', [('r', 105), ('r', 172)]), '*=': ('c', [('r', 105), ('r', 172)]), '<<=': ('c', [('r', 105), ('r', 172)]), '->': ('c', [('r', 105), ('r', 172)]), 'auto': ('r', 105), '-=': ('c', [('r', 105), ('r', 172)]), '%=': ('c', [('r', 105), ('r', 172)]), '+=': ('c', [('r', 105), ('r', 172)]), '>=': ('c', [('r', 105), ('r', 172)]), 'union': ('r', 105), '>>=': ('c', [('r', 105), ('r', 172)]), '<=': ('c', [('r', 105), ('r', 172)]), '::': ('c', [('r', 105), ('r', 172)]), 'volatile': ('r', 105), '&&': ('c', [('r', 105), ('r', 172)]), '|': ('c', [('r', 105), ('r', 172)]), '}': ('c', [('r', 105), ('r', 172)]), '~': ('r', 105), '&=': ('c', [('r', 105), ('r', 172)]), '{': ('r', 105), '.*': ('c', [('r', 105), ('r', 172)]), 'struct': ('r', 105), '->*': ('c', [('r', 105), ('r', 172)]), TYPE_KEYWORD: ('r', 105), 'try': ('r', 105), 'enum': ('r', 105), '>>': ('c', [('r', 105), ('r', 172)]), 'class': ('r', 105), ']': ('c', [('r', 105), ('r', 172)]), 'typename': ('r', 105), '==': ('c', [('r', 105), ('r', 172)]), '[': ('c', [('r', 105), ('r', 172)]), 'const': ('r', 105)}, 18),
        #STATE 19
        State([("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 74)], {',': ('r', 0), '-': ('r', 0), '.': ('r', 0), '/': ('r', 0), '|=': ('r', 0), ')': ('r', 0), '*': ('r', 0), '==': ('r', 0), '%': ('r', 0), '&': ('r', 0), '<': ('r', 0), '=': ('r', 0), '>': ('r', 0), '?': ('r', 0), '<<': ('r', 0), ':': ('r', 0), ';': ('r', 0), '...': ('r', 0), '(': ('r', 0), '^=': ('r', 0), '%=': ('r', 0), '!=': ('r', 0), '--': ('r', 0), '/=': ('r', 0), '++': ('r', 0), '^': ('r', 0), '<<=': ('r', 0), '->': ('r', 0), '-=': ('r', 0), '->*': ('r', 0), '>>': ('r', 0), '>=': ('r', 0), '<=': ('r', 0), '||': ('r', 0), '>>=': ('r', 0), '&&': ('r', 0), '|': ('r', 0), '}': ('r', 0), '&=': ('r', 0), '+=': ('r', 0), '+': ('r', 0), ']': ('r', 0), '*=': ('r', 0), '[': ('r', 0), '.*': ('r', 0)}, 19),
        #STATE 20
        State([("class_specifier -> class_head!! '{' member_specification!*:body '}'", 32), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 32)], {'{': ('s', 21)}, 20),
        #STATE 21
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 33), ('access_specifier -> ACCESS_KEYWORD!', 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ('member_cd_declarator -> cd_declarator:d pure_specifier', 24), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 64), ("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('member_specification -> member_declaration', 24), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 42), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("member_declaration -> function_definition! ';'?", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 36), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("member_specification -> access_specifier:access ':'", 24), ('function_definition -> function_head:head function_try_block:tryb', 23), ('namespace_name -> IDENTIFIER:name', 18), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 22), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("raw_type_descriptor -> 'auto'", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("cv_qualifier -> 'const'!", 16), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 33), ('raw_type_descriptor -> enum_specifier!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("class_key -> 'class' | 'struct' | 'union'", 23), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('type_name -> template_id!', 13), ('member_cd_declarator -> cd_declarator', 24), ("member_declaration -> elaborated_type_specifier! ';'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ('member_declaration -> template_declaration', 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ('member_declaration -> using_declaration', 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("member_declaration -> function_definition! ';'?", 22), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_name -> template_id!', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("decl_attrib -> 'typedef'!", 15), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('raw_type_descriptor -> named_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 36), ("decl_attrib -> 'extern'!", 15), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ('type_descriptor -> raw_type_descriptor!', 19), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 36), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {raw_type_descriptor: ('g', 54), _80: ('g', 112), _114: ('g', 254), function_definition: ('g', 246), 'virtual': ('s', 130), _73: ('g', 247), elaborated_type_specifier: ('g', 248), IDENTIFIER: ('s', 29), 'typedef': ('s', 136), _81: ('g', 88), named_type_specifier: ('g', 126), class_specifier: ('g', 75), 'extern': ('s', 249), class_head: ('g', 20), class_key: ('g', 78), 'export': ('s', 143), member_specification: ('g', 895), class_name: ('g', 11), type_name: ('g', 131), member_declaration: ('g', 251), member_cd_declarator: ('g', 252), 'struct': ('s', 58), 'volatile': ('s', 33), 'auto': ('s', 90), using_declaration: ('g', 245), '::': ('s', 255), namespace_name: ('g', 5), 'using': ('s', 256), nested_name_specifier: ('g', 257), ACCESS_KEYWORD: ('s', 258), access_specifier: ('g', 259), 'union': ('s', 97), function_head: ('g', 150), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), 'template': ('s', 253), template_name: ('g', 2), cv_qualifier: ('g', 106), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), '}': ('s', 761), _109: ('g', 244), 'enum': ('s', 117), cd_id: ('g', 164), type_descriptor: ('g', 263), 'class': ('s', 115), template_declaration: ('g', 262), 'typename': ('s', 166), 'operator': ('s', 168), cd_declarator: ('g', 261), decl_attrib: ('g', 28), template_id: ('g', 18), enum_specifier: ('g', 122)}, 21),
        #STATE 22
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 234)], {',': ('r', 1), '-': ('r', 1), '.': ('r', 1), '/': ('r', 1), '(': ('r', 1), ')': ('r', 1), '*': ('r', 1), '+': ('r', 1), '%': ('r', 1), '&': ('r', 1), '<': ('r', 1), '=': ('r', 1), '>': ('r', 1), '?': ('r', 1), '<<': ('r', 1), ':': ('r', 1), ';': ('r', 1), '...': ('r', 1), '|=': ('r', 1), '^=': ('r', 1), '%=': ('r', 1), '!=': ('r', 1), '--': ('r', 1), '/=': ('r', 1), '++': ('r', 1), '^': ('r', 1), '<<=': ('r', 1), '->': ('r', 1), '-=': ('r', 1), '->*': ('r', 1), '+=': ('r', 1), '>=': ('r', 1), '<=': ('r', 1), '||': ('r', 1), '>>=': ('r', 1), '&&': ('r', 1), '|': ('r', 1), '}': ('r', 1), '&=': ('r', 1), '{': ('r', 1), 'try': ('r', 1), '>>': ('r', 1), ']': ('r', 1), '*=': ('r', 1), '==': ('r', 1), '[': ('r', 1), '.*': ('r', 1)}, 22),
        #STATE 23
        State([('type_name -> IDENTIFIER:name', 13), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 85), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_id: ('g', 26), template_name: ('g', 2), IDENTIFIER: ('s', 24), type_name: ('g', 25)}, 23),
        #STATE 24
        State([('type_name -> IDENTIFIER:name', 23), ('template_name -> IDENTIFIER!', 27)], {',': ('r', 6), '-': ('r', 6), '.': ('r', 6), '/': ('r', 6), '|=': ('r', 6), ')': ('r', 6), '*': ('r', 6), '+': ('r', 6), '%': ('r', 6), '&': ('r', 6), 'operator': ('r', 6), '<': ('c', [('r', 6), ('r', 2)]), '=': ('r', 6), '>': ('r', 6), '?': ('r', 6), '<<': ('r', 6), IDENTIFIER: ('r', 6), ':': ('r', 6), ';': ('r', 6), '...': ('r', 6), '(': ('r', 6), '^=': ('r', 6), '||': ('r', 6), '^': ('r', 6), '!=': ('r', 6), '--': ('r', 6), '/=': ('r', 6), '++': ('r', 6), 'typename': ('r', 6), '<<=': ('r', 6), '%=': ('r', 6), '-=': ('r', 6), 'auto': ('r', 6), 'volatile': ('r', 6), '->': ('r', 6), '->*': ('r', 6), '+=': ('r', 6), '>=': ('r', 6), 'union': ('r', 6), '<=': ('r', 6), '::': ('r', 6), '>>=': ('r', 6), '&&': ('r', 6), 'const': ('r', 6), '|': ('r', 6), '}': ('r', 6), '~': ('r', 6), '&=': ('r', 6), '{': ('r', 6), 'struct': ('r', 6), TYPE_KEYWORD: ('r', 6), 'try': ('r', 6), 'enum': ('r', 6), '>>': ('r', 6), 'class': ('r', 6), ']': ('r', 6), '*=': ('r', 6), '==': ('r', 6), '[': ('r', 6), '.*': ('r', 6)}, 24),
        #STATE 25
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 94)], {',': ('r', 318), '-': ('r', 318), '.': ('r', 318), '/': ('r', 318), '(': ('r', 318), ')': ('r', 318), '*': ('r', 318), '+': ('r', 318), '%': ('r', 318), '&': ('r', 318), '<': ('r', 318), '=': ('r', 318), '>': ('r', 318), '?': ('r', 318), '<<': ('r', 318), ':': ('r', 318), ';': ('r', 318), '...': ('r', 318), '|=': ('r', 318), '^=': ('r', 318), '%=': ('r', 318), '!=': ('r', 318), '--': ('r', 318), '/=': ('r', 318), '==': ('r', 318), '*=': ('r', 318), '<<=': ('r', 318), '->': ('r', 318), '-=': ('r', 318), '->*': ('r', 318), '+=': ('r', 318), '>=': ('r', 318), '<=': ('r', 318), '||': ('r', 318), '>>=': ('r', 318), '&&': ('r', 318), '|': ('r', 318), '}': ('r', 318), '&=': ('r', 318), '++': ('r', 318), '>>': ('r', 318), ']': ('r', 318), '^': ('r', 318), '[': ('r', 318), '.*': ('r', 318)}, 25),
        #STATE 26
        State([('type_name -> template_id!', 24)], {',': ('r', 105), '-': ('r', 105), '.': ('r', 105), '/': ('r', 105), '|=': ('r', 105), ')': ('r', 105), '*': ('r', 105), '+': ('r', 105), '%': ('r', 105), '&': ('r', 105), 'operator': ('r', 105), '<': ('r', 105), '=': ('r', 105), '>': ('r', 105), '?': ('r', 105), '<<': ('r', 105), IDENTIFIER: ('r', 105), ':': ('r', 105), ';': ('r', 105), '...': ('r', 105), '(': ('r', 105), '^=': ('r', 105), '||': ('r', 105), '^': ('r', 105), '!=': ('r', 105), '--': ('r', 105), '/=': ('r', 105), '++': ('r', 105), 'typename': ('r', 105), '<<=': ('r', 105), '%=': ('r', 105), '-=': ('r', 105), 'auto': ('r', 105), 'volatile': ('r', 105), '->': ('r', 105), '->*': ('r', 105), '+=': ('r', 105), '>=': ('r', 105), 'union': ('r', 105), '<=': ('r', 105), '::': ('r', 105), '>>=': ('r', 105), '&&': ('r', 105), 'const': ('r', 105), '|': ('r', 105), '}': ('r', 105), '~': ('r', 105), '&=': ('r', 105), '{': ('r', 105), 'struct': ('r', 105), TYPE_KEYWORD: ('r', 105), 'try': ('r', 105), 'enum': ('r', 105), '>>': ('r', 105), 'class': ('r', 105), ']': ('r', 105), '*=': ('r', 105), '==': ('r', 105), '[': ('r', 105), '.*': ('r', 105)}, 26),
        #STATE 27
        State([('template_name -> IDENTIFIER!', 27), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 87)], {',': ('r', 3), '-': ('r', 3), '.': ('r', 3), '/': ('r', 3), '|=': ('r', 3), ')': ('r', 3), '*': ('r', 3), '+': ('r', 3), '%': ('r', 3), '&': ('r', 3), 'operator': ('r', 3), '%=': ('r', 3), '<': ('c', [('r', 2), ('r', 3)]), '=': ('r', 3), '>': ('r', 3), '?': ('r', 3), '<<': ('r', 3), IDENTIFIER: ('r', 3), ':': ('r', 3), ';': ('r', 3), '...': ('r', 3), '(': ('r', 3), '^=': ('r', 3), '||': ('r', 3), '^': ('r', 3), '!=': ('r', 3), '--': ('r', 3), '/=': ('r', 3), '++': ('r', 3), '*=': ('r', 3), '<<=': ('r', 3), '->': ('r', 3), '-=': ('r', 3), 'auto': ('r', 3), 'volatile': ('r', 3), '->*': ('r', 3), '+=': ('r', 3), '>=': ('r', 3), 'union': ('r', 3), '<=': ('r', 3), '::': ('r', 3), '>>=': ('r', 3), '&&': ('r', 3), '|': ('r', 3), '}': ('r', 3), '~': ('r', 3), '&=': ('r', 3), '{': ('r', 3), '.*': ('r', 3), 'struct': ('r', 3), TYPE_KEYWORD: ('r', 3), 'try': ('r', 3), 'enum': ('r', 3), '>>': ('r', 3), 'class': ('r', 3), ']': ('r', 3), 'typename': ('r', 3), '==': ('r', 3), '[': ('r', 3), 'const': ('r', 3)}, 27),
        #STATE 28
        State([("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 33)], {'union': ('r', 4), 'typedef': ('r', 4), '::': ('r', 4), 'typename': ('r', 4), 'struct': ('r', 4), 'volatile': ('r', 4), 'virtual': ('r', 4), 'enum': ('r', 4), DECLARE_KEYWORD: ('r', 4), 'class': ('r', 4), '~': ('r', 4), IDENTIFIER: ('r', 4), 'auto': ('r', 4), 'operator': ('r', 4), 'const': ('r', 4), 'extern': ('r', 4), TYPE_KEYWORD: ('r', 4)}, 28),
        #STATE 29
        State([('namespace_name -> IDENTIFIER:name', 28), ('type_name -> IDENTIFIER:name', 23), ('template_name -> IDENTIFIER!', 27), ('class_name -> IDENTIFIER:name', 24)], {',': ('r', 6), '-': ('r', 6), '.': ('r', 6), '/': ('r', 6), '|=': ('r', 6), ')': ('r', 6), '*': ('r', 6), '+': ('r', 6), '%': ('r', 6), '&': ('r', 6), 'operator': ('r', 6), '<': ('c', [('r', 6), ('r', 2)]), '=': ('r', 6), '>': ('r', 6), '?': ('r', 6), '<<': ('r', 6), IDENTIFIER: ('r', 6), ':': ('r', 6), ';': ('r', 6), '...': ('r', 6), '(': ('r', 6), '^=': ('r', 6), '||': ('r', 6), '^': ('r', 6), '!=': ('r', 6), '--': ('r', 6), '/=': ('r', 6), '++': ('r', 6), '*=': ('r', 6), '<<=': ('r', 6), '%=': ('r', 6), 'auto': ('r', 6), '-=': ('r', 6), '->': ('r', 6), '->*': ('r', 6), '>>': ('r', 6), '>=': ('r', 6), 'union': ('r', 6), '<=': ('r', 6), '::': ('c', [('r', 5), ('r', 6), ('r', 7)]), '>>=': ('r', 6), '&&': ('r', 6), 'const': ('r', 6), '|': ('r', 6), '}': ('r', 6), '~': ('r', 6), 'volatile': ('r', 6), '&=': ('r', 6), '{': ('r', 6), 'struct': ('r', 6), TYPE_KEYWORD: ('r', 6), 'try': ('r', 6), 'enum': ('r', 6), '+=': ('r', 6), 'class': ('r', 6), ']': ('r', 6), 'typename': ('r', 6), '==': ('r', 6), '[': ('r', 6), '.*': ('r', 6)}, 29),
        #STATE 30
        State([('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 33), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ("cv_qualifier -> 'const'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 122), ("cv_qualifier -> 'volatile'!", 16)], {',': ('r', 8), cv_qualifier: ('g', 32), 'auto': ('r', 8), '(': ('r', 8), exception_specification: ('g', 34), 'union': ('r', 8), TYPE_KEYWORD: ('r', 8), 'enum': ('r', 8), 'typename': ('r', 8), '::': ('r', 8), 'throw': ('s', 31), '=': ('r', 8), '>': ('r', 8), '[': ('r', 8), IDENTIFIER: ('r', 8), 'struct': ('r', 8), 'volatile': ('c', [('s', 33), ('r', 8)]), '...': ('r', 8), 'const': ('c', [('s', 35), ('r', 8)]), 'class': ('r', 8), ')': ('r', 8)}, 30),
        #STATE 31
        State([("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 35), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 35)], {'(': ('s', 995)}, 31),
        #STATE 32
        State([('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 31)], {',': ('r', 392), '-': ('r', 392), '.': ('r', 392), '/': ('r', 392), '|=': ('r', 392), ')': ('r', 392), '*': ('r', 392), '+': ('r', 392), '%': ('r', 392), '&': ('r', 392), 'operator': ('r', 392), '<': ('r', 392), '=': ('r', 392), '>': ('r', 392), '?': ('r', 392), '<<': ('r', 392), IDENTIFIER: ('r', 392), ':': ('r', 392), ';': ('r', 392), '...': ('r', 392), '(': ('r', 392), '^=': ('r', 392), '||': ('r', 392), 'throw': ('r', 392), '!=': ('r', 392), '--': ('r', 392), '/=': ('r', 392), '++': ('r', 392), '*=': ('r', 392), '<<=': ('r', 392), '%=': ('r', 392), 'struct': ('r', 392), '-=': ('r', 392), '->': ('r', 392), '->*': ('r', 392), '>>': ('r', 392), '>=': ('r', 392), 'union': ('r', 392), '^': ('r', 392), '<=': ('r', 392), '::': ('r', 392), 'auto': ('r', 392), '>>=': ('r', 392), '&&': ('r', 392), '|': ('r', 392), '}': ('r', 392), '~': ('r', 392), 'volatile': ('r', 392), '&=': ('r', 392), '{': ('r', 392), '.*': ('r', 392), TYPE_KEYWORD: ('r', 392), 'try': ('r', 392), 'enum': ('r', 392), '+=': ('r', 392), 'class': ('r', 392), ']': ('r', 392), 'typename': ('r', 392), '==': ('r', 392), '[': ('r', 392), 'const': ('r', 392)}, 32),
        #STATE 33
        State([("cv_qualifier -> 'volatile'!", 26)], {',': ('r', 374), '-': ('r', 374), '.': ('r', 374), '/': ('r', 374), '(': ('r', 374), ')': ('r', 374), '*': ('r', 374), '+': ('r', 374), '%': ('r', 374), '&': ('r', 374), 'operator': ('r', 374), '%=': ('r', 374), '<': ('r', 374), '=': ('r', 374), '>': ('r', 374), '?': ('r', 374), '<<': ('r', 374), IDENTIFIER: ('r', 374), ':': ('r', 374), ';': ('r', 374), '...': ('r', 374), '|=': ('r', 374), '^=': ('r', 374), '::': ('r', 374), '^': ('r', 374), 'class': ('r', 374), '!=': ('r', 374), '--': ('r', 374), '/=': ('r', 374), '++': ('r', 374), '*=': ('r', 374), '<<=': ('r', 374), '->': ('r', 374), 'struct': ('r', 374), '-=': ('r', 374), '->*': ('r', 374), '>>': ('r', 374), '>=': ('r', 374), 'union': ('r', 374), '>>=': ('r', 374), '<=': ('r', 374), '||': ('r', 374), 'auto': ('r', 374), 'volatile': ('r', 374), '&&': ('r', 374), '|': ('r', 374), '}': ('r', 374), '~': ('r', 374), '&=': ('r', 374), '{': ('r', 374), '.*': ('r', 374), TYPE_KEYWORD: ('r', 374), 'try': ('r', 374), 'enum': ('r', 374), '+=': ('r', 374), 'throw': ('r', 374), ']': ('r', 374), 'typename': ('r', 374), '==': ('r', 374), '[': ('r', 374), 'const': ('r', 374)}, 33),
        #STATE 34
        State([("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 145)], {',': ('r', 513), 'union': ('r', 513), '(': ('r', 513), ')': ('r', 513), 'struct': ('r', 513), 'volatile': ('r', 513), TYPE_KEYWORD: ('r', 513), 'enum': ('r', 513), 'typename': ('r', 513), 'class': ('r', 513), '=': ('r', 513), '>': ('r', 513), IDENTIFIER: ('r', 513), 'auto': ('r', 513), '[': ('r', 513), '...': ('r', 513), 'const': ('r', 513), '::': ('r', 513)}, 34),
        #STATE 35
        State([("cv_qualifier -> 'const'!", 23)], {',': ('r', 163), '-': ('r', 163), '.': ('r', 163), '/': ('r', 163), '(': ('r', 163), ')': ('r', 163), '*': ('r', 163), '+': ('r', 163), '%': ('r', 163), '&': ('r', 163), 'operator': ('r', 163), '%=': ('r', 163), '<': ('r', 163), '=': ('r', 163), '>': ('r', 163), '?': ('r', 163), '<<': ('r', 163), IDENTIFIER: ('r', 163), ':': ('r', 163), ';': ('r', 163), '...': ('r', 163), '|=': ('r', 163), '^=': ('r', 163), '::': ('r', 163), '^': ('r', 163), 'class': ('r', 163), '!=': ('r', 163), '--': ('r', 163), '/=': ('r', 163), '++': ('r', 163), '*=': ('r', 163), '<<=': ('r', 163), '->': ('r', 163), 'struct': ('r', 163), '-=': ('r', 163), '->*': ('r', 163), '>>': ('r', 163), '>=': ('r', 163), 'union': ('r', 163), '>>=': ('r', 163), '<=': ('r', 163), '||': ('r', 163), 'auto': ('r', 163), 'volatile': ('r', 163), '&&': ('r', 163), '|': ('r', 163), '}': ('r', 163), '~': ('r', 163), '&=': ('r', 163), '{': ('r', 163), '.*': ('r', 163), TYPE_KEYWORD: ('r', 163), 'try': ('r', 163), 'enum': ('r', 163), '+=': ('r', 163), 'throw': ('r', 163), ']': ('r', 163), 'typename': ('r', 163), '==': ('r', 163), '[': ('r', 163), 'const': ('r', 163)}, 35),
        #STATE 36
        State([("simple_declaration -> elaborated_type_specifier! ';'", 52)], {'-': ('r', 9), 'asm': ('r', 9), '(': ('r', 9), '*': ('r', 9), '+': ('r', 9), 'delete': ('r', 9), 'static_cast': ('r', 9), 'operator': ('r', 9), DECLARE_KEYWORD: ('r', 9), ACCESS_KEYWORD: ('r', 9), IDENTIFIER: ('r', 9), ';': ('r', 9), INTEGER_LITERAL: ('r', 9), 'typedef': ('r', 9), 'default': ('r', 9), 'goto': ('r', 9), 'break': ('r', 9), 'new': ('r', 9), 'throw': ('r', 9), 'extern': ('r', 9), '--': ('r', 9), '++': ('r', 9), 'struct': ('r', 9), 'dynamic_cast': ('r', 9), 'for': ('r', 9), 'export': ('r', 9), 'auto': ('r', 9), 'volatile': ('r', 9), 'template': ('r', 9), 'continue': ('r', 9), '&': ('r', 9), 'case': ('r', 9), 'if': ('r', 9), 'union': ('r', 9), 'virtual': ('r', 9), 'const_cast': ('r', 9), '::': ('r', 9), 'using': ('r', 9), 'namespace': ('r', 9), 'do': ('r', 9), '!': ('r', 9), '}': ('r', 9), '~': ('r', 9), 'return': ('r', 9), '{': ('r', 9), 'this': ('r', 9), TYPE_KEYWORD: ('r', 9), FLOATING_LITERAL: ('r', 9), 'sizeof': ('r', 9), 'else': ('r', 9), CHARACTER_LITERAL: ('r', 9), 'try': ('r', 9), 'reinterpret_cast': ('r', 9), BOOLEAN_LITERAL: ('r', 9), 'enum': ('r', 9), EOF: ('r', 9), STRING_LITERAL: ('r', 9), 'class': ('r', 9), CPP_INCLUDE: ('r', 9), 'typename': ('r', 9), 'while': ('r', 9), CPP_ERROR: ('r', 9), 'const': ('r', 9), 'switch': ('r', 9), 'typeid': ('r', 9)}, 36),
        #STATE 37
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 306)], {',': ('r', 10), '-': ('r', 10), '.': ('r', 10), '/': ('r', 10), '(': ('r', 10), ')': ('r', 10), '*': ('r', 10), '+': ('r', 10), '%': ('r', 10), '&': ('r', 10), '<': ('r', 10), '=': ('r', 10), '>': ('r', 10), '?': ('r', 10), '<<': ('r', 10), ':': ('r', 10), ';': ('r', 10), '...': ('r', 10), '|=': ('r', 10), '^=': ('r', 10), '%=': ('r', 10), '!=': ('r', 10), '--': ('r', 10), '/=': ('r', 10), '++': ('r', 10), '^': ('r', 10), '<<=': ('r', 10), '->': ('r', 10), '-=': ('r', 10), '->*': ('r', 10), '+=': ('r', 10), '>=': ('r', 10), '<=': ('r', 10), '||': ('r', 10), '>>=': ('r', 10), '&&': ('r', 10), '|': ('r', 10), '}': ('r', 10), '&=': ('r', 10), '{': ('r', 10), 'try': ('r', 10), '>>': ('r', 10), ']': ('r', 10), '*=': ('r', 10), '==': ('r', 10), '[': ('r', 10), '.*': ('r', 10)}, 37),
        #STATE 38
        State([("postfix_expression -> 'typeid' '(' expression:v ')'", 31), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 31)], {'(': ('s', 39)}, 38),
        #STATE 39
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('primary_expression -> id_expression!', 22), ("cv_qualifier -> 'volatile'!", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t base_clause:bases?', 14), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("class_key -> 'class' | 'struct' | 'union'", 23), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('raw_type_descriptor -> enum_specifier!', 23), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('raw_type_descriptor -> class_specifier!', 23), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typeid' '(' expression:v ')'", 35), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('type_descriptor -> raw_type_descriptor!', 19), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ('class_head -> class_key:t base_clause:bases?', 14), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('raw_type_descriptor -> named_type_specifier!', 23), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("class_key -> 'class' | 'struct' | 'union'", 13), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), raw_type_descriptor: ('g', 54), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), cv_qualifier: ('g', 106), additive_expression: ('g', 63), elaborated_type_specifier: ('g', 109), cast_expression: ('g', 66), IDENTIFIER: ('s', 3), equality_expression: ('g', 70), CHARACTER_LITERAL: ('s', 108), INTEGER_LITERAL: ('s', 87), delete_expression: ('g', 119), relational_expression: ('g', 67), class_name: ('g', 11), _80: ('g', 112), id_expression: ('g', 114), throw_expression: ('g', 91), shift_expression: ('g', 65), class_head: ('g', 20), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), 'struct': ('s', 58), simple_type_specifier: ('g', 86), type_descriptor: ('g', 240), primary_expression: ('g', 40), new_expression: ('g', 94), _81: ('g', 88), 'static_cast': ('s', 71), 'this': ('s', 103), 'auto': ('s', 90), unqualified_id: ('g', 7), 'const_cast': ('s', 92), '::': ('s', 64), class_specifier: ('g', 75), nested_name_specifier: ('g', 95), 'volatile': ('s', 33), 'throw': ('s', 96), 'union': ('s', 97), type_name: ('g', 98), conversion_function_id: ('g', 12), '~': ('s', 100), pm_expression: ('g', 73), 'operator': ('s', 8), unary_expression: ('g', 69), 'new': ('s', 74), '!': ('s', 104), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), postfix_expression: ('g', 99), 'reinterpret_cast': ('s', 110), BOOLEAN_LITERAL: ('s', 102), '--': ('s', 111), 'enum': ('s', 117), STRING_LITERAL: ('s', 113), expression: ('g', 859), '+': ('s', 80), type_id: ('g', 861), 'typename': ('s', 116), namespace_name: ('g', 5), operator_function_id: ('g', 6), class_key: ('g', 78), 'const': ('s', 35), exclusive_or_expression: ('g', 121), template_id: ('g', 18), 'typeid': ('s', 38), enum_specifier: ('g', 122)}, 39),
        #STATE 40
        State([('postfix_expression -> primary_expression!', 40)], {',': ('r', 11), '-': ('r', 11), '.': ('r', 11), '/': ('r', 11), '(': ('r', 11), ')': ('r', 11), '*': ('r', 11), '+': ('r', 11), '%': ('r', 11), '&': ('r', 11), '<': ('r', 11), '=': ('r', 11), '>': ('r', 11), '?': ('r', 11), '<<': ('r', 11), ':': ('r', 11), ';': ('r', 11), '...': ('r', 11), '|=': ('r', 11), '^=': ('r', 11), '%=': ('r', 11), '!=': ('r', 11), '--': ('r', 11), '/=': ('r', 11), '==': ('r', 11), '*=': ('r', 11), '<<=': ('r', 11), '->': ('r', 11), '-=': ('r', 11), '->*': ('r', 11), '>>': ('r', 11), '>=': ('r', 11), '<=': ('r', 11), '||': ('r', 11), '>>=': ('r', 11), '&&': ('r', 11), '|': ('r', 11), '}': ('r', 11), '&=': ('r', 11), '++': ('r', 11), '+=': ('r', 11), ']': ('r', 11), '^': ('r', 11), '[': ('r', 11), '.*': ('r', 11)}, 40),
        #STATE 41
        State([('type_name -> IDENTIFIER:name', 13), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_name -> template_id!', 13), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 85), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {type_name: ('g', 42), template_name: ('g', 2), IDENTIFIER: ('s', 24), template_id: ('g', 26)}, 41),
        #STATE 42
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 94)], {',': ('r', 128), '-': ('r', 128), '.': ('r', 128), '/': ('r', 128), '(': ('r', 128), ')': ('r', 128), '*': ('r', 128), '+': ('r', 128), '%': ('r', 128), '&': ('r', 128), '<': ('r', 128), '=': ('r', 128), '>': ('r', 128), '?': ('r', 128), '<<': ('r', 128), ':': ('r', 128), ';': ('r', 128), '...': ('r', 128), '|=': ('r', 128), '^=': ('r', 128), '%=': ('r', 128), '!=': ('r', 128), '--': ('r', 128), '/=': ('r', 128), '==': ('r', 128), '*=': ('r', 128), '<<=': ('r', 128), '->': ('r', 128), '-=': ('r', 128), '->*': ('r', 128), '+=': ('r', 128), '>=': ('r', 128), '<=': ('r', 128), '||': ('r', 128), '>>=': ('r', 128), '&&': ('r', 128), '|': ('r', 128), '}': ('r', 128), '&=': ('r', 128), '++': ('r', 128), '>>': ('r', 128), ']': ('r', 128), '^': ('r', 128), '[': ('r', 128), '.*': ('r', 128)}, 42),
        #STATE 43
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("operator_function_id -> 'operator' operator:op", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 61), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('class_name -> template_id!', 14), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ('namespace_name -> IDENTIFIER:name', 18), ('unqualified_id -> IDENTIFIER:id', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> operator_function_id!', 18), ('id_expression -> qualified_id!', 17), ("qualified_id -> '::' IDENTIFIER!", 16), ('unqualified_id -> conversion_function_id!', 18), ("unqualified_id -> '~' class_name:name", 18), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), qualified_id: ('g', 4), namespace_name: ('g', 5), operator_function_id: ('g', 6), unqualified_id: ('g', 7), 'operator': ('s', 8), class_name: ('g', 11), conversion_function_id: ('g', 12), '~': ('s', 45), IDENTIFIER: ('s', 46), nested_name_specifier: ('g', 47), id_expression: ('g', 19), template_id: ('g', 44), '::': ('s', 48)}, 43),
        #STATE 44
        State([('class_name -> template_id!', 25)], {',': ('r', 172), '-': ('r', 172), '.': ('r', 172), '/': ('r', 172), '|=': ('r', 172), ')': ('r', 172), '*': ('r', 172), '+': ('r', 172), '%': ('r', 172), '&': ('r', 172), '<': ('r', 172), '=': ('r', 172), '>': ('r', 172), '?': ('r', 172), '<<': ('r', 172), ':': ('r', 172), ';': ('r', 172), '...': ('r', 172), '(': ('r', 172), '^=': ('r', 172), '||': ('r', 172), '!=': ('r', 172), '--': ('r', 172), '/=': ('r', 172), '++': ('r', 172), '^': ('r', 172), '<<=': ('r', 172), '->': ('r', 172), '-=': ('r', 172), '%=': ('r', 172), '+=': ('r', 172), '>=': ('r', 172), '<=': ('r', 172), '::': ('r', 172), '>>=': ('r', 172), '&&': ('r', 172), '|': ('r', 172), '}': ('r', 172), '&=': ('r', 172), '{': ('r', 172), '->*': ('r', 172), 'try': ('r', 172), '>>': ('r', 172), ']': ('r', 172), '*=': ('r', 172), '==': ('r', 172), '[': ('r', 172), '.*': ('r', 172)}, 44),
        #STATE 45
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("unqualified_id -> '~' class_name:name", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), class_name: ('g', 289), IDENTIFIER: ('s', 173), template_id: ('g', 44)}, 45),
        #STATE 46
        State([('namespace_name -> IDENTIFIER:name', 28), ('class_name -> IDENTIFIER:name', 24), ('template_name -> IDENTIFIER!', 27), ('unqualified_id -> IDENTIFIER:id', 28)], {',': ('r', 95), '-': ('r', 95), '.': ('r', 95), '/': ('r', 95), '|=': ('r', 95), ')': ('r', 95), '*': ('r', 95), '+': ('r', 95), '%': ('r', 95), '&': ('r', 95), '<': ('c', [('r', 2), ('r', 95)]), '=': ('r', 95), '>': ('r', 95), '?': ('r', 95), '<<': ('r', 95), ':': ('r', 95), ';': ('r', 95), '...': ('r', 95), '(': ('r', 95), '^=': ('r', 95), '||': ('r', 95), '!=': ('r', 95), '--': ('r', 95), '/=': ('r', 95), '++': ('r', 95), '^': ('r', 95), '<<=': ('r', 95), '->': ('r', 95), '-=': ('r', 95), '%=': ('r', 95), '+=': ('r', 95), '>=': ('r', 95), '<=': ('r', 95), '::': ('c', [('r', 5), ('r', 7)]), '>>=': ('r', 95), '&&': ('r', 95), '|': ('r', 95), '}': ('r', 95), '&=': ('r', 95), '{': ('r', 95), '->*': ('r', 95), 'try': ('r', 95), '>>': ('r', 95), ']': ('r', 95), '*=': ('r', 95), '==': ('r', 95), '[': ('r', 95), '.*': ('r', 95)}, 46),
        #STATE 47
        State([('unqualified_id -> operator_function_id!', 18), ("operator_function_id -> 'operator' operator:op", 24), ('unqualified_id -> IDENTIFIER:id', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 53), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("unqualified_id -> '~' class_name:name", 18), ('unqualified_id -> conversion_function_id!', 18)], {unqualified_id: ('g', 326), '~': ('s', 45), IDENTIFIER: ('s', 314), conversion_function_id: ('g', 12), 'template': ('s', 327), operator_function_id: ('g', 6), 'operator': ('s', 8)}, 47),
        #STATE 48
        State([('namespace_name -> IDENTIFIER:name', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("operator_function_id -> 'operator' operator:op", 24), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("qualified_id -> '::' (operator_function_id!|template_id!)", 44), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ("qualified_id -> '::' IDENTIFIER!", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('class_name -> template_id!', 14), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), namespace_name: ('g', 5), IDENTIFIER: ('s', 617), nested_name_specifier: ('g', 618), operator_function_id: ('g', 376), 'operator': ('s', 619), class_name: ('g', 11), template_id: ('g', 620)}, 48),
        #STATE 49
        State([("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 91)], {';': ('s', 50)}, 49),
        #STATE 50
        State([("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 94)], {'union': ('r', 516), '::': ('r', 516), 'export': ('r', 516), 'using': ('r', 516), 'virtual': ('r', 516), DECLARE_KEYWORD: ('r', 516), '}': ('r', 516), '~': ('r', 516), IDENTIFIER: ('r', 516), 'operator': ('r', 516), 'typedef': ('r', 516), 'extern': ('r', 516), TYPE_KEYWORD: ('r', 516), ACCESS_KEYWORD: ('r', 516), 'enum': ('r', 516), 'class': ('r', 516), 'typename': ('r', 516), 'struct': ('r', 516), 'volatile': ('r', 516), 'template': ('r', 516), 'const': ('r', 516), 'auto': ('r', 516)}, 50),
        #STATE 51
        State([('class_head -> class_key:t base_clause:bases?', 37)], {'{': ('r', 12)}, 51),
        #STATE 52
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 36)], {',': ('r', 13), '-': ('r', 13), '.': ('r', 13), '/': ('r', 13), '(': ('r', 13), ')': ('r', 13), '*': ('r', 13), '+': ('r', 13), '%': ('r', 13), '&': ('r', 13), '<': ('r', 13), '=': ('r', 13), '>': ('r', 13), '?': ('r', 13), '<<': ('r', 13), ':': ('r', 13), ';': ('r', 13), '...': ('r', 13), '|=': ('r', 13), '^=': ('r', 13), '%=': ('r', 13), '!=': ('r', 13), '--': ('r', 13), '/=': ('r', 13), '++': ('r', 13), '^': ('r', 13), '<<=': ('r', 13), '->': ('r', 13), '-=': ('r', 13), '->*': ('r', 13), '+=': ('r', 13), '>=': ('r', 13), '<=': ('r', 13), '||': ('r', 13), '>>=': ('r', 13), '&&': ('r', 13), '|': ('r', 13), '}': ('r', 13), '&=': ('r', 13), '{': ('r', 13), 'try': ('r', 13), '>>': ('r', 13), ']': ('r', 13), '*=': ('r', 13), '==': ('r', 13), '[': ('r', 13), '.*': ('r', 13)}, 52),
        #STATE 53
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ('postfix_expression -> primary_expression!', 22), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("unary_expression -> 'sizeof' unary_expression:v", 20), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("unary_expression -> '++' cast_expression:v", 20), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ('class_head -> class_key:t base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 57), ('id_expression -> qualified_id!', 17), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('equality_expression -> relational_expression!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('namespace_name -> IDENTIFIER:name', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('assignment_expression -> conditional_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('unqualified_id -> conversion_function_id!', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("cv_qualifier -> 'const'!", 16), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('condition -> expression!', 13), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 73), ('unary_expression -> postfix_expression!', 20), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 57), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("condition -> type_descriptor:type declarator:dtor '=' assignment_expression:v", 13), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('pm_expression -> cast_expression!', 17), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 73), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), template_name: ('g', 2), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), cv_qualifier: ('g', 106), additive_expression: ('g', 63), logical_and_expression: ('g', 118), shift_expression: ('g', 65), relational_expression: ('g', 67), condition: ('g', 101), ';': ('s', 62), CHARACTER_LITERAL: ('s', 108), equality_expression: ('g', 70), 'static_cast': ('s', 71), delete_expression: ('g', 119), class_name: ('g', 11), pm_expression: ('g', 73), 'new': ('s', 74), throw_expression: ('g', 91), id_expression: ('g', 114), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), elaborated_type_specifier: ('g', 109), class_key: ('g', 78), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), 'struct': ('s', 58), simple_type_specifier: ('g', 86), type_descriptor: ('g', 120), primary_expression: ('g', 40), enum_specifier: ('g', 122), _81: ('g', 88), expression: ('g', 89), 'auto': ('s', 90), unqualified_id: ('g', 7), 'const_cast': ('s', 92), '::': ('s', 64), class_specifier: ('g', 75), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), 'union': ('s', 97), type_name: ('g', 98), conversion_function_id: ('g', 12), '~': ('s', 100), 'volatile': ('s', 33), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), class_head: ('g', 20), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), postfix_expression: ('g', 99), 'reinterpret_cast': ('s', 110), BOOLEAN_LITERAL: ('s', 102), INTEGER_LITERAL: ('s', 87), _80: ('g', 112), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 116), namespace_name: ('g', 5), 'enum': ('s', 117), operator_function_id: ('g', 6), '--': ('s', 111), 'const': ('s', 35), exclusive_or_expression: ('g', 121), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 53),
        #STATE 54
        State([('type_descriptor -> raw_type_descriptor!', 38)], {',': ('r', 441), '-': ('r', 441), '.': ('r', 441), '/': ('r', 441), '|=': ('r', 441), ')': ('r', 441), '*': ('r', 441), '+': ('r', 441), '%': ('r', 441), '&': ('r', 441), 'operator': ('r', 441), '<': ('r', 441), '=': ('r', 441), '>': ('r', 441), '?': ('r', 441), '<<': ('r', 441), IDENTIFIER: ('r', 441), ':': ('r', 441), ';': ('r', 441), '...': ('r', 441), '(': ('r', 441), '^=': ('r', 441), '||': ('r', 441), '^': ('r', 441), '!=': ('r', 441), '--': ('r', 441), '/=': ('r', 441), '++': ('r', 441), '*=': ('r', 441), '<<=': ('r', 441), '%=': ('r', 441), 'auto': ('r', 441), '-=': ('r', 441), '->': ('r', 441), '->*': ('r', 441), '>>': ('r', 441), '>=': ('r', 441), 'union': ('r', 441), '<=': ('r', 441), '::': ('r', 441), '>>=': ('r', 441), '&&': ('r', 441), 'const': ('r', 441), '|': ('r', 441), '}': ('r', 441), '~': ('r', 441), 'volatile': ('r', 441), '&=': ('r', 441), '{': ('r', 441), 'struct': ('r', 441), TYPE_KEYWORD: ('r', 441), 'try': ('r', 441), 'enum': ('r', 441), '+=': ('r', 441), 'class': ('r', 441), ']': ('r', 441), 'typename': ('r', 441), '==': ('r', 441), '[': ('r', 441), '.*': ('r', 441)}, 54),
        #STATE 55
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ("unary_expression -> '++' cast_expression:v", 25), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ('id_expression -> qualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('namespace_name -> IDENTIFIER:name', 18), ("postfix_expression -> postfix_expression:v '--'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> FLOATING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), qualified_id: ('g', 4), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), '::': ('s', 64), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), cast_expression: ('g', 1000), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), operator_function_id: ('g', 6), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38)}, 55),
        #STATE 56
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ('postfix_expression -> primary_expression!', 22), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("class_key -> 'class' | 'struct' | 'union'", 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("unary_expression -> 'sizeof' unary_expression:v", 20), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("unary_expression -> '++' cast_expression:v", 20), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ('class_head -> class_key:t base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('id_expression -> qualified_id!', 17), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('equality_expression -> relational_expression!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('namespace_name -> IDENTIFIER:name', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ('assignment_expression -> conditional_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('unqualified_id -> conversion_function_id!', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("cv_qualifier -> 'const'!", 16), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('unary_expression -> postfix_expression!', 20), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("primary_expression -> '(' expression! ')'", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 23), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ('unary_expression -> delete_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('raw_type_descriptor -> named_type_specifier!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('pm_expression -> cast_expression!', 17), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), template_name: ('g', 2), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), cv_qualifier: ('g', 106), additive_expression: ('g', 63), logical_and_expression: ('g', 118), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), CHARACTER_LITERAL: ('s', 108), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), delete_expression: ('g', 119), class_name: ('g', 11), pm_expression: ('g', 73), 'new': ('s', 74), class_specifier: ('g', 75), id_expression: ('g', 114), inclusive_or_expression: ('g', 76), literal: ('g', 84), elaborated_type_specifier: ('g', 109), class_key: ('g', 78), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), conditional_expression: ('g', 77), assignment_expression: ('g', 85), 'struct': ('s', 58), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), enum_specifier: ('g', 122), _81: ('g', 88), expression: ('g', 271), unqualified_id: ('g', 7), throw_expression: ('g', 91), 'const_cast': ('s', 92), '::': ('s', 64), 'auto': ('s', 90), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), 'union': ('s', 97), type_name: ('g', 98), conversion_function_id: ('g', 12), '~': ('s', 100), 'volatile': ('s', 33), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), class_head: ('g', 20), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), postfix_expression: ('g', 99), 'reinterpret_cast': ('s', 110), BOOLEAN_LITERAL: ('s', 102), '--': ('s', 111), _80: ('g', 112), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), type_id: ('g', 878), 'typename': ('s', 116), namespace_name: ('g', 5), 'enum': ('s', 117), operator_function_id: ('g', 6), exclusive_or_expression: ('g', 121), 'const': ('s', 35), type_descriptor: ('g', 240), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 56),
        #STATE 57
        State([('simple_type_specifier -> named_type_specifier!', 45), ('raw_type_descriptor -> named_type_specifier!', 43)], {',': ('r', 20), '~': ('r', 20), '(': ('c', [('r', 64), ('r', 20)]), '::': ('r', 20), '*': ('r', 20), 'operator': ('r', 20), '&': ('r', 20), '[': ('r', 20), ')': ('r', 20), '>': ('r', 20), IDENTIFIER: ('r', 20)}, 57),
        #STATE 58
        State([("class_key -> 'class' | 'struct' | 'union'", 31)], {'{': ('r', 138), '::': ('r', 138), ':': ('r', 138), IDENTIFIER: ('r', 138)}, 58),
        #STATE 59
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 36), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('namespace_name -> IDENTIFIER:name', 18), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("delete_expression -> '::'? 'delete' cast_expression:v", 36), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> FLOATING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), id_expression: ('g', 114), 'sizeof': ('s', 107), operator_function_id: ('g', 6), 'const_cast': ('s', 92), qualified_id: ('g', 4), new_expression: ('g', 94), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), '[': ('s', 888), delete_expression: ('g', 119), cast_expression: ('g', 999), 'typeid': ('s', 38)}, 59),
        #STATE 60
        State([("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 57), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 57), ('additive_expression -> multiplicative_expression!', 48), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 57)], {',': ('r', 402), '-': ('r', 402), '/': ('s', 986), '|=': ('r', 402), ')': ('r', 402), '*': ('s', 987), '==': ('r', 402), '%': ('s', 968), '&': ('r', 402), '>>=': ('r', 402), '&&': ('r', 402), '<': ('r', 402), '=': ('r', 402), '>': ('r', 402), '?': ('r', 402), '<<': ('r', 402), ':': ('r', 402), ';': ('r', 402), '...': ('r', 402), '<=': ('r', 402), '^=': ('r', 402), '%=': ('r', 402), '|': ('r', 402), '!=': ('r', 402), '}': ('r', 402), '/=': ('r', 402), '+': ('r', 402), '||': ('r', 402), '^': ('r', 402), '&=': ('r', 402), '>>': ('r', 402), ']': ('r', 402), '*=': ('r', 402), '<<=': ('r', 402), '-=': ('r', 402), '+=': ('r', 402), '>=': ('r', 402)}, 60),
        #STATE 61
        State([("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 28)], {'-': ('r', 216), '++': ('r', 216), '(': ('r', 216), '::': ('r', 216), '*': ('r', 216), 'sizeof': ('r', 216), 'delete': ('r', 216), 'static_cast': ('r', 216), '!': ('r', 216), 'this': ('r', 216), '~': ('r', 216), IDENTIFIER: ('r', 216), 'operator': ('r', 216), 'const_cast': ('r', 216), TYPE_KEYWORD: ('r', 216), 'new': ('r', 216), FLOATING_LITERAL: ('r', 216), CHARACTER_LITERAL: ('r', 216), '--': ('r', 216), 'reinterpret_cast': ('r', 216), BOOLEAN_LITERAL: ('r', 216), '+': ('r', 216), STRING_LITERAL: ('r', 216), 'dynamic_cast': ('r', 216), 'typename': ('r', 216), INTEGER_LITERAL: ('r', 216), '&': ('r', 216), 'typeid': ('r', 216)}, 61),
        #STATE 62
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 93), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 77), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), CHARACTER_LITERAL: ('s', 108), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), ')': ('s', 873), 'new': ('s', 74), namespace_name: ('g', 5), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), expression: ('g', 872), 'sizeof': ('s', 107), 'const_cast': ('s', 92), '::': ('s', 64), throw_expression: ('g', 91), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 62),
        #STATE 63
        State([("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 45), ('shift_expression -> additive_expression!', 39), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 45)], {',': ('r', 254), '-': ('s', 810), '|=': ('r', 254), ')': ('r', 254), '+': ('s', 680), '&': ('r', 254), '>>=': ('r', 254), '&&': ('r', 254), '<': ('r', 254), '=': ('r', 254), '>': ('r', 254), '?': ('r', 254), '<<': ('r', 254), ':': ('r', 254), ';': ('r', 254), '...': ('r', 254), '<=': ('r', 254), '^=': ('r', 254), '||': ('r', 254), '|': ('r', 254), '!=': ('r', 254), '}': ('r', 254), '/=': ('r', 254), '==': ('r', 254), '*=': ('r', 254), '&=': ('r', 254), '>>': ('r', 254), ']': ('r', 254), '^': ('r', 254), '<<=': ('r', 254), '-=': ('r', 254), '%=': ('r', 254), '+=': ('r', 254), '>=': ('r', 254)}, 63),
        #STATE 64
        State([('namespace_name -> IDENTIFIER:name', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('type_name -> IDENTIFIER:name', 13), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("operator_function_id -> 'operator' operator:op", 24), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("qualified_id -> '::' (operator_function_id!|template_id!)", 44), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('type_name -> template_id!', 13), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('template_name -> IDENTIFIER!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("qualified_id -> '::' IDENTIFIER!", 21)], {'new': ('s', 706), template_name: ('g', 2), IDENTIFIER: ('s', 707), namespace_name: ('g', 5), 'delete': ('s', 708), operator_function_id: ('g', 376), nested_name_specifier: ('g', 709), 'operator': ('s', 619), class_name: ('g', 11), template_id: ('g', 710), type_name: ('g', 405)}, 64),
        #STATE 65
        State([('relational_expression -> shift_expression!', 41), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 39), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 39)], {',': ('r', 510), '|=': ('r', 510), ')': ('r', 510), '==': ('r', 510), '&': ('r', 510), '>>=': ('r', 510), '&&': ('r', 510), '<': ('r', 510), '=': ('r', 510), '>': ('r', 510), '?': ('r', 510), '<<': ('s', 449), ':': ('r', 510), ';': ('r', 510), '...': ('r', 510), '<=': ('r', 510), '^=': ('r', 510), '%=': ('r', 510), '|': ('r', 510), '!=': ('r', 510), '}': ('r', 510), '/=': ('r', 510), '||': ('r', 510), '^': ('r', 510), '&=': ('r', 510), '+=': ('r', 510), ']': ('r', 510), '*=': ('r', 510), '<<=': ('r', 510), '-=': ('r', 510), '>>': ('s', 450), '>=': ('r', 510)}, 65),
        #STATE 66
        State([('pm_expression -> cast_expression!', 32)], {',': ('r', 349), '-': ('r', 349), '/': ('r', 349), '|=': ('r', 349), ')': ('r', 349), '*': ('r', 349), '==': ('r', 349), '%': ('r', 349), '&': ('r', 349), '>>=': ('r', 349), '&&': ('r', 349), '<': ('r', 349), '=': ('r', 349), '>': ('r', 349), '?': ('r', 349), '<<': ('r', 349), ':': ('r', 349), ';': ('r', 349), '...': ('r', 349), '<=': ('r', 349), '^=': ('r', 349), '%=': ('r', 349), '|': ('r', 349), '!=': ('r', 349), '}': ('r', 349), '/=': ('r', 349), '+': ('r', 349), '||': ('r', 349), '*=': ('r', 349), '&=': ('r', 349), '+=': ('r', 349), ']': ('r', 349), '^': ('r', 349), '<<=': ('r', 349), '-=': ('r', 349), '.*': ('r', 349), '->*': ('r', 349), '>>': ('r', 349), '>=': ('r', 349)}, 66),
        #STATE 67
        State([("relational_expression -> relational_expression:a '>' shift_expression:b", 49), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 49), ("relational_expression -> relational_expression:a '<' shift_expression:b", 49), ('equality_expression -> relational_expression!', 44), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 49)], {',': ('r', 252), '<=': ('s', 368), ')': ('r', 252), '==': ('r', 252), '&': ('r', 252), '>>=': ('r', 252), '&&': ('r', 252), '<': ('s', 366), '=': ('r', 252), '>': ('c', [('s', 367), ('r', 252)]), '?': ('r', 252), '&=': ('r', 252), ':': ('r', 252), ';': ('r', 252), '...': ('r', 252), '|=': ('r', 252), '^=': ('r', 252), '%=': ('r', 252), '|': ('r', 252), '!=': ('r', 252), '}': ('r', 252), '/=': ('r', 252), '||': ('r', 252), '^': ('r', 252), ']': ('r', 252), '*=': ('r', 252), '<<=': ('r', 252), '-=': ('r', 252), '+=': ('r', 252), '>=': ('s', 369)}, 67),
        #STATE 68
        State([('simple_type_specifier -> TYPE_KEYWORD:kw', 37), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 35)], {',': ('r', 406), '(': ('c', [('r', 195), ('r', 406)]), TYPE_KEYWORD: ('r', 406), '*': ('r', 406), '&': ('r', 406), '[': ('r', 406), ')': ('r', 406), '>': ('r', 406), '~': ('r', 406), IDENTIFIER: ('r', 406), 'operator': ('r', 406), '::': ('r', 406)}, 68),
        #STATE 69
        State([('cast_expression -> unary_expression!', 35)], {',': ('r', 480), '-': ('r', 480), '/': ('r', 480), '|=': ('r', 480), ')': ('r', 480), '*': ('r', 480), '+': ('r', 480), '%': ('r', 480), '&': ('r', 480), '>>=': ('r', 480), '&&': ('r', 480), '<': ('r', 480), '=': ('r', 480), '>': ('r', 480), '?': ('r', 480), '&=': ('r', 480), ':': ('r', 480), ';': ('r', 480), '...': ('r', 480), '<=': ('r', 480), '^=': ('r', 480), '%=': ('r', 480), '|': ('r', 480), '!=': ('r', 480), '}': ('r', 480), '/=': ('r', 480), '==': ('r', 480), '||': ('r', 480), '^': ('r', 480), '>>': ('r', 480), ']': ('r', 480), '<<': ('r', 480), '<<=': ('r', 480), '*=': ('r', 480), '-=': ('r', 480), '.*': ('r', 480), '->*': ('r', 480), '+=': ('r', 480), '>=': ('r', 480)}, 69),
        #STATE 70
        State([("equality_expression -> equality_expression:a '!=' relational_expression:b", 45), ('and_expression -> equality_expression!', 37), ("equality_expression -> equality_expression:a '==' relational_expression:b", 45)], {',': ('r', 35), '|=': ('r', 35), ')': ('r', 35), '==': ('s', 269), '&': ('r', 35), '>>=': ('r', 35), '&&': ('r', 35), '|': ('r', 35), '=': ('r', 35), '>': ('r', 35), '?': ('r', 35), '&=': ('r', 35), ':': ('r', 35), ';': ('r', 35), '...': ('r', 35), '^=': ('r', 35), '||': ('r', 35), '!=': ('s', 268), '}': ('r', 35), '/=': ('r', 35), '*=': ('r', 35), ']': ('r', 35), '^': ('r', 35), '<<=': ('r', 35), '-=': ('r', 35), '%=': ('r', 35), '+=': ('r', 35)}, 70),
        #STATE 71
        State([("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 36)], {'<': ('s', 287)}, 71),
        #STATE 72
        State([("and_expression -> and_expression:a '&' equality_expression:b", 35), ('exclusive_or_expression -> and_expression!', 41)], {',': ('r', 161), '|=': ('r', 161), ')': ('r', 161), '&': ('s', 621), '>>=': ('r', 161), '&&': ('r', 161), '|': ('r', 161), '=': ('r', 161), '>': ('r', 161), '?': ('r', 161), '&=': ('r', 161), ':': ('r', 161), ';': ('r', 161), '...': ('r', 161), '^=': ('r', 161), '||': ('r', 161), '}': ('r', 161), '/=': ('r', 161), '^': ('r', 161), ']': ('r', 161), '*=': ('r', 161), '<<=': ('r', 161), '-=': ('r', 161), '%=': ('r', 161), '+=': ('r', 161)}, 72),
        #STATE 73
        State([('multiplicative_expression -> pm_expression!', 42), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 33), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 33)], {',': ('r', 385), '-': ('r', 385), '/': ('r', 385), '|=': ('r', 385), ')': ('r', 385), '*': ('r', 385), '+': ('r', 385), '%': ('r', 385), '&': ('r', 385), '>>=': ('r', 385), '&&': ('r', 385), '<': ('r', 385), '=': ('r', 385), '>': ('r', 385), '?': ('r', 385), '<<': ('r', 385), ':': ('r', 385), ';': ('r', 385), '...': ('r', 385), '<=': ('r', 385), '^=': ('r', 385), '%=': ('r', 385), '|': ('r', 385), '!=': ('r', 385), '}': ('r', 385), '/=': ('r', 385), '==': ('r', 385), '||': ('r', 385), '*=': ('r', 385), '&=': ('r', 385), '>>': ('r', 385), ']': ('r', 385), '^': ('r', 385), '<<=': ('r', 385), '-=': ('r', 385), '.*': ('s', 740), '->*': ('s', 741), '+=': ('r', 385), '>=': ('r', 385)}, 73),
        #STATE 74
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 56), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 35), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('raw_type_descriptor -> class_specifier!', 23), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 35), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 35), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('new_type_id -> type_descriptor:type new_declarator:dtor?', 15), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 35), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 56), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> named_type_specifier!', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 56), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("raw_type_descriptor -> 'auto'", 23), ("new_placement -> '(' assignment_expression!+,','! ')'", 17), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 56), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('new_type_id -> type_descriptor:type new_declarator:dtor?', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {raw_type_descriptor: ('g', 54), '(': ('s', 910), named_type_specifier: ('g', 126), class_specifier: ('g', 75), template_id: ('g', 18), nested_name_specifier: ('g', 189), cv_qualifier: ('g', 106), type_name: ('g', 98), 'union': ('s', 97), type_descriptor: ('g', 764), elaborated_type_specifier: ('g', 109), '::': ('s', 191), enum_specifier: ('g', 122), 'struct': ('s', 58), template_name: ('g', 2), _81: ('g', 88), class_head: ('g', 20), namespace_name: ('g', 5), new_placement: ('g', 762), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), _80: ('g', 112), class_name: ('g', 11), 'class': ('s', 115), 'typename': ('s', 166), 'auto': ('s', 90), 'volatile': ('s', 33), 'const': ('s', 35), new_type_id: ('g', 911), 'enum': ('s', 117), IDENTIFIER: ('s', 29)}, 74),
        #STATE 75
        State([('raw_type_descriptor -> class_specifier!', 38)], {',': ('r', 124), '-': ('r', 124), '.': ('r', 124), '/': ('r', 124), '|=': ('r', 124), ')': ('r', 124), '*': ('r', 124), '+': ('r', 124), '%': ('r', 124), '&': ('r', 124), 'operator': ('r', 124), '<': ('r', 124), '=': ('r', 124), '>': ('r', 124), '?': ('r', 124), '<<': ('r', 124), IDENTIFIER: ('r', 124), ':': ('r', 124), ';': ('r', 124), '...': ('r', 124), '(': ('r', 124), '^=': ('r', 124), '||': ('r', 124), '^': ('r', 124), '!=': ('r', 124), '--': ('r', 124), '/=': ('r', 124), '++': ('r', 124), '*=': ('r', 124), '<<=': ('r', 124), '%=': ('r', 124), 'auto': ('r', 124), '-=': ('r', 124), '->': ('r', 124), '->*': ('r', 124), '>>': ('r', 124), '>=': ('r', 124), 'union': ('r', 124), '<=': ('r', 124), '::': ('r', 124), '>>=': ('r', 124), '&&': ('r', 124), 'const': ('r', 124), '|': ('r', 124), '}': ('r', 124), '~': ('r', 124), 'volatile': ('r', 124), '&=': ('r', 124), '{': ('r', 124), 'struct': ('r', 124), TYPE_KEYWORD: ('r', 124), 'try': ('r', 124), 'enum': ('r', 124), '+=': ('r', 124), 'class': ('r', 124), ']': ('r', 124), 'typename': ('r', 124), '==': ('r', 124), '[': ('r', 124), '.*': ('r', 124)}, 75),
        #STATE 76
        State([("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 53), ('logical_and_expression -> inclusive_or_expression!', 49)], {',': ('r', 376), '|=': ('r', 376), '||': ('r', 376), '>>=': ('r', 376), '&&': ('r', 376), '|': ('s', 278), '}': ('r', 376), '>': ('r', 376), '?': ('r', 376), '&=': ('r', 376), ':': ('r', 376), ';': ('r', 376), '...': ('r', 376), '^=': ('r', 376), ')': ('r', 376), '=': ('r', 376), '/=': ('r', 376), ']': ('r', 376), '*=': ('r', 376), '<<=': ('r', 376), '-=': ('r', 376), '%=': ('r', 376), '+=': ('r', 376)}, 76),
        #STATE 77
        State([('assignment_expression -> conditional_expression!', 47)], {',': ('r', 494), ']': ('r', 494), '>': ('r', 494), ')': ('r', 494), ':': ('r', 494), '}': ('r', 494), '...': ('r', 494), ';': ('r', 494)}, 77),
        #STATE 78
        State([('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 39), ("base_clause -> ':' base_specifier!+,','!", 15), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 26), ('class_name -> template_id!', 14), ('class_head -> class_key:t base_clause:bases?', 23), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 39), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 53), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 53), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 77), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t base_clause:bases?', 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 53), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 53), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 50), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), IDENTIFIER: ('s', 805), ':': ('s', 662), namespace_name: ('g', 5), nested_name_specifier: ('g', 638), '{': ('r', 310), class_name: ('g', 11), template_id: ('g', 660), '::': ('s', 765), base_clause: ('g', 51)}, 78),
        #STATE 79
        State([('literal -> FLOATING_LITERAL:v', 27)], {',': ('r', 79), '-': ('r', 79), '.': ('r', 79), '/': ('r', 79), '(': ('r', 79), ')': ('r', 79), '*': ('r', 79), '+': ('r', 79), '%': ('r', 79), '&': ('r', 79), '<': ('r', 79), '=': ('r', 79), '>': ('r', 79), '?': ('r', 79), '<<': ('r', 79), ':': ('r', 79), ';': ('r', 79), '...': ('r', 79), '|=': ('r', 79), '^=': ('r', 79), '%=': ('r', 79), '!=': ('r', 79), '--': ('r', 79), '/=': ('r', 79), '==': ('r', 79), '*=': ('r', 79), '<<=': ('r', 79), '->': ('r', 79), '-=': ('r', 79), '->*': ('r', 79), '+=': ('r', 79), '>=': ('r', 79), '<=': ('r', 79), '||': ('r', 79), '>>=': ('r', 79), '&&': ('r', 79), '|': ('r', 79), '}': ('r', 79), '&=': ('r', 79), '++': ('r', 79), '>>': ('r', 79), ']': ('r', 79), '^': ('r', 79), '[': ('r', 79), '.*': ('r', 79)}, 79),
        #STATE 80
        State([("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 35)], {'-': ('r', 340), '++': ('r', 340), '(': ('r', 340), '::': ('r', 340), '*': ('r', 340), 'sizeof': ('r', 340), 'delete': ('r', 340), 'static_cast': ('r', 340), '!': ('r', 340), 'this': ('r', 340), '~': ('r', 340), IDENTIFIER: ('r', 340), 'operator': ('r', 340), 'const_cast': ('r', 340), CHARACTER_LITERAL: ('r', 340), 'new': ('r', 340), FLOATING_LITERAL: ('r', 340), TYPE_KEYWORD: ('r', 340), '--': ('r', 340), 'reinterpret_cast': ('r', 340), BOOLEAN_LITERAL: ('r', 340), '+': ('r', 340), STRING_LITERAL: ('r', 340), 'dynamic_cast': ('r', 340), 'typename': ('r', 340), INTEGER_LITERAL: ('r', 340), '&': ('r', 340), 'typeid': ('r', 340)}, 80),
        #STATE 81
        State([("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 42)], {'-': ('r', 234), '++': ('r', 234), '(': ('r', 234), '::': ('r', 234), '*': ('r', 234), 'sizeof': ('r', 234), 'delete': ('r', 234), 'static_cast': ('r', 234), '!': ('r', 234), 'this': ('r', 234), '~': ('r', 234), IDENTIFIER: ('r', 234), 'operator': ('r', 234), 'const_cast': ('r', 234), CHARACTER_LITERAL: ('r', 234), 'new': ('r', 234), FLOATING_LITERAL: ('r', 234), TYPE_KEYWORD: ('r', 234), '--': ('r', 234), 'reinterpret_cast': ('r', 234), BOOLEAN_LITERAL: ('r', 234), '+': ('r', 234), STRING_LITERAL: ('r', 234), 'dynamic_cast': ('r', 234), 'typename': ('r', 234), INTEGER_LITERAL: ('r', 234), '&': ('r', 234), 'typeid': ('r', 234)}, 81),
        #STATE 82
        State([("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 50), ("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 62), ("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 104), ("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 38), ("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 46), ("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 96), ('conditional_expression -> logical_or_expression!', 47), ("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 23), ("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 30), ("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 88), ("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 70), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 51), ("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 79), ("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 54)], {',': ('r', 44), '<<=': ('s', 783), '|=': ('s', 780), ')': ('r', 44), '}': ('r', 44), ']': ('r', 44), '/=': ('s', 781), '>>=': ('s', 686), '>': ('r', 44), ';': ('r', 44), '=': ('s', 782), '*=': ('s', 665), '?': ('s', 311), '&=': ('s', 784), '-=': ('s', 785), '...': ('r', 44), assignment_operator: ('g', 786), ':': ('r', 44), '+=': ('s', 787), '^=': ('s', 788), '%=': ('s', 789)}, 82),
        #STATE 83
        State([("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 37)], {'<': ('s', 601)}, 83),
        #STATE 84
        State([('primary_expression -> literal!', 29)], {',': ('r', 437), '-': ('r', 437), '.': ('r', 437), '/': ('r', 437), '(': ('r', 437), ')': ('r', 437), '*': ('r', 437), '==': ('r', 437), '%': ('r', 437), '&': ('r', 437), '<': ('r', 437), '=': ('r', 437), '>': ('r', 437), '?': ('r', 437), '<<': ('r', 437), ':': ('r', 437), ';': ('r', 437), '...': ('r', 437), '|=': ('r', 437), '^=': ('r', 437), '%=': ('r', 437), '!=': ('r', 437), '--': ('r', 437), '/=': ('r', 437), '++': ('r', 437), '^': ('r', 437), '<<=': ('r', 437), '->': ('r', 437), '-=': ('r', 437), '->*': ('r', 437), '+=': ('r', 437), '>=': ('r', 437), '<=': ('r', 437), '||': ('r', 437), '>>=': ('r', 437), '&&': ('r', 437), '|': ('r', 437), '}': ('r', 437), '&=': ('r', 437), '>>': ('r', 437), '+': ('r', 437), ']': ('r', 437), '*=': ('r', 437), '[': ('r', 437), '.*': ('r', 437)}, 84),
        #STATE 85
        State([('expression -> assignment_expression!', 35)], {',': ('r', 237), ']': ('r', 237), ')': ('r', 237), ':': ('r', 237), ';': ('r', 237)}, 85),
        #STATE 86
        State([("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 46), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 46)], {'(': ('s', 302)}, 86),
        #STATE 87
        State([('literal -> INTEGER_LITERAL:v', 26)], {',': ('r', 301), '-': ('r', 301), '.': ('r', 301), '/': ('r', 301), '|=': ('r', 301), ')': ('r', 301), '*': ('r', 301), '==': ('r', 301), '%': ('r', 301), '&': ('r', 301), '<': ('r', 301), '=': ('r', 301), '>': ('r', 301), '?': ('r', 301), '<<': ('r', 301), ':': ('r', 301), ';': ('r', 301), '...': ('r', 301), '(': ('r', 301), '^=': ('r', 301), '%=': ('r', 301), '!=': ('r', 301), '--': ('r', 301), '/=': ('r', 301), '++': ('r', 301), '*=': ('r', 301), '<<=': ('r', 301), '->': ('r', 301), '-=': ('r', 301), '->*': ('r', 301), '>>': ('r', 301), '>=': ('r', 301), '<=': ('r', 301), '||': ('r', 301), '>>=': ('r', 301), '&&': ('r', 301), '|': ('r', 301), '}': ('r', 301), '&=': ('r', 301), '+=': ('r', 301), '+': ('r', 301), ']': ('r', 301), '^': ('r', 301), '[': ('r', 301), '.*': ('r', 301)}, 87),
        #STATE 88
        State([('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 37), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23)], {',': ('r', 293), '-': ('r', 293), '.': ('r', 293), '/': ('r', 293), '|=': ('r', 293), ')': ('r', 293), '*': ('r', 293), '+': ('r', 293), '%': ('r', 293), '&': ('r', 293), 'operator': ('r', 293), '<': ('r', 293), '=': ('r', 293), '>': ('r', 293), '?': ('r', 293), '<<': ('r', 293), IDENTIFIER: ('r', 293), ':': ('r', 293), ';': ('r', 293), '...': ('r', 293), '(': ('r', 293), '^=': ('r', 293), '||': ('r', 293), '^': ('r', 293), '!=': ('r', 293), '--': ('r', 293), '/=': ('r', 293), '++': ('r', 293), '*=': ('r', 293), '<<=': ('r', 293), '%=': ('r', 293), 'auto': ('r', 293), '-=': ('r', 293), '->': ('r', 293), '->*': ('r', 293), '>>': ('r', 293), '>=': ('r', 293), 'union': ('r', 293), '<=': ('r', 293), '::': ('r', 293), '>>=': ('r', 293), '&&': ('r', 293), 'const': ('r', 293), '|': ('r', 293), '}': ('r', 293), '~': ('r', 293), 'volatile': ('r', 293), '&=': ('r', 293), '{': ('r', 293), 'struct': ('r', 293), TYPE_KEYWORD: ('c', [('s', 874), ('r', 293)]), 'try': ('r', 293), 'enum': ('r', 293), '+=': ('r', 293), 'class': ('r', 293), ']': ('r', 293), 'typename': ('r', 293), '==': ('r', 293), '[': ('r', 293), '.*': ('r', 293)}, 88),
        #STATE 89
        State([("expression -> expression:a ',' assignment_expression:b", 27), ('condition -> expression!', 23)], {',': ('s', 272), ')': ('r', 203), ';': ('r', 203)}, 89),
        #STATE 90
        State([("raw_type_descriptor -> 'auto'", 29)], {',': ('r', 458), '-': ('r', 458), '.': ('r', 458), '/': ('r', 458), '|=': ('r', 458), ')': ('r', 458), '*': ('r', 458), '+': ('r', 458), '%': ('r', 458), '&': ('r', 458), 'operator': ('r', 458), '<': ('r', 458), '=': ('r', 458), '>': ('r', 458), '?': ('r', 458), '<<': ('r', 458), IDENTIFIER: ('r', 458), ':': ('r', 458), ';': ('r', 458), '...': ('r', 458), '(': ('r', 458), '^=': ('r', 458), '||': ('r', 458), '^': ('r', 458), '!=': ('r', 458), '--': ('r', 458), '/=': ('r', 458), '++': ('r', 458), '*=': ('r', 458), '<<=': ('r', 458), '%=': ('r', 458), 'struct': ('r', 458), '-=': ('r', 458), '->': ('r', 458), '->*': ('r', 458), '>>': ('r', 458), '>=': ('r', 458), 'union': ('r', 458), '<=': ('r', 458), '::': ('r', 458), 'auto': ('r', 458), '>>=': ('r', 458), '&&': ('r', 458), 'const': ('r', 458), '|': ('r', 458), '}': ('r', 458), '~': ('r', 458), 'volatile': ('r', 458), '&=': ('r', 458), '{': ('r', 458), TYPE_KEYWORD: ('r', 458), 'try': ('r', 458), 'enum': ('r', 458), '+=': ('r', 458), 'class': ('r', 458), ']': ('r', 458), 'typename': ('r', 458), '==': ('r', 458), '[': ('r', 458), '.*': ('r', 458)}, 90),
        #STATE 91
        State([('assignment_expression -> throw_expression!', 41)], {',': ('r', 475), ']': ('r', 475), '>': ('r', 475), ')': ('r', 475), ':': ('r', 475), '}': ('r', 475), '...': ('r', 475), ';': ('r', 475)}, 91),
        #STATE 92
        State([("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 35)], {'<': ('s', 479)}, 92),
        #STATE 93
        State([("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 21)], {'-': ('r', 533), '++': ('r', 533), '(': ('r', 533), '::': ('r', 533), '*': ('r', 533), 'sizeof': ('r', 533), 'delete': ('r', 533), '&': ('r', 533), '!': ('r', 533), 'this': ('r', 533), '~': ('r', 533), IDENTIFIER: ('r', 533), 'operator': ('r', 533), 'const_cast': ('r', 533), CHARACTER_LITERAL: ('r', 533), 'new': ('r', 533), FLOATING_LITERAL: ('r', 533), TYPE_KEYWORD: ('r', 533), '--': ('r', 533), BOOLEAN_LITERAL: ('r', 533), 'reinterpret_cast': ('r', 533), STRING_LITERAL: ('r', 533), 'dynamic_cast': ('r', 533), 'typename': ('r', 533), '+': ('r', 533), INTEGER_LITERAL: ('r', 533), 'static_cast': ('r', 533), 'typeid': ('r', 533)}, 93),
        #STATE 94
        State([('unary_expression -> new_expression!', 34)], {',': ('r', 377), '-': ('r', 377), '/': ('r', 377), '|=': ('r', 377), ')': ('r', 377), '*': ('r', 377), '+': ('r', 377), '%': ('r', 377), '&': ('r', 377), '>>=': ('r', 377), '&&': ('r', 377), '<': ('r', 377), '=': ('r', 377), '>': ('r', 377), '?': ('r', 377), '&=': ('r', 377), ':': ('r', 377), ';': ('r', 377), '...': ('r', 377), '<=': ('r', 377), '^=': ('r', 377), '%=': ('r', 377), '|': ('r', 377), '!=': ('r', 377), '}': ('r', 377), '/=': ('r', 377), '==': ('r', 377), '||': ('r', 377), '^': ('r', 377), '+=': ('r', 377), ']': ('r', 377), '<<': ('r', 377), '<<=': ('r', 377), '*=': ('r', 377), '-=': ('r', 377), '.*': ('r', 377), '->*': ('r', 377), '>>': ('r', 377), '>=': ('r', 377)}, 94),
        #STATE 95
        State([('type_name -> IDENTIFIER:name', 13), ("operator_function_id -> 'operator' operator:op", 24), ('unqualified_id -> conversion_function_id!', 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('unqualified_id -> IDENTIFIER:id', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 53), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("unqualified_id -> '~' class_name:name", 18), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {operator_function_id: ('g', 6), template_name: ('g', 2), '~': ('s', 45), IDENTIFIER: ('s', 423), conversion_function_id: ('g', 12), 'template': ('s', 629), unqualified_id: ('g', 326), 'operator': ('s', 8), type_name: ('g', 292), template_id: ('g', 26)}, 95),
        #STATE 96
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("throw_expression -> 'throw' assignment_expression:v?", 27), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("throw_expression -> 'throw' assignment_expression:v?", 28), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {',': ('r', 256), template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), ';': ('r', 256), type_name: ('g', 98), shift_expression: ('g', 65), '>': ('r', 256), relational_expression: ('g', 67), ':': ('r', 256), equality_expression: ('g', 70), '...': ('r', 256), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), '}': ('r', 256), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), ')': ('r', 256), assignment_expression: ('g', 641), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), ']': ('r', 256), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 96),
        #STATE 97
        State([("class_key -> 'class' | 'struct' | 'union'", 41)], {'{': ('r', 399), '::': ('r', 399), ':': ('r', 399), IDENTIFIER: ('r', 399)}, 97),
        #STATE 98
        State([("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 71)], {',': ('r', 193), '-': ('r', 193), '.': ('r', 193), '/': ('r', 193), '|=': ('r', 193), ')': ('r', 193), '*': ('r', 193), '+': ('r', 193), '%': ('r', 193), '&': ('r', 193), 'operator': ('r', 193), '<': ('r', 193), '=': ('r', 193), '>': ('r', 193), '?': ('r', 193), '<<': ('r', 193), IDENTIFIER: ('r', 193), ':': ('r', 193), ';': ('r', 193), '...': ('r', 193), '(': ('r', 193), '^=': ('r', 193), '::': ('r', 193), '^': ('r', 193), '!=': ('r', 193), '--': ('r', 193), '/=': ('r', 193), '++': ('r', 193), '*=': ('r', 193), '<<=': ('r', 193), '%=': ('r', 193), 'auto': ('r', 193), '-=': ('r', 193), '->': ('r', 193), '->*': ('r', 193), '>>': ('r', 193), '>=': ('r', 193), 'union': ('r', 193), '<=': ('r', 193), '||': ('r', 193), '>>=': ('r', 193), '&&': ('r', 193), 'const': ('r', 193), '|': ('r', 193), '}': ('r', 193), '~': ('r', 193), 'volatile': ('r', 193), '&=': ('r', 193), '{': ('r', 193), 'struct': ('r', 193), TYPE_KEYWORD: ('r', 193), 'try': ('r', 193), 'enum': ('r', 193), '+=': ('r', 193), 'class': ('r', 193), ']': ('r', 193), 'typename': ('r', 193), '==': ('r', 193), '[': ('r', 193), '.*': ('r', 193)}, 98),
        #STATE 99
        State([("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 43), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 43), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 43), ("postfix_expression -> postfix_expression:v '--'", 43), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 43), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 43), ('unary_expression -> postfix_expression!', 38), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 43), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 43), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 43), ("postfix_expression -> postfix_expression:v '++'", 43), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 43)], {',': ('r', 542), '-': ('r', 542), '.': ('s', 1014), '/': ('r', 542), '(': ('s', 445), ')': ('r', 542), '*': ('r', 542), '==': ('r', 542), '%': ('r', 542), '&': ('r', 542), '<': ('r', 542), '=': ('r', 542), '>': ('r', 542), '?': ('r', 542), ':': ('r', 542), ';': ('r', 542), '...': ('r', 542), '|=': ('r', 542), '^=': ('r', 542), '%=': ('r', 542), '!=': ('r', 542), '--': ('s', 915), '/=': ('r', 542), '++': ('s', 953), '^': ('r', 542), '<<=': ('r', 542), '->': ('s', 1), '-=': ('r', 542), '->*': ('r', 542), '>>': ('r', 542), '>=': ('r', 542), '<=': ('r', 542), '||': ('r', 542), '>>=': ('r', 542), '&&': ('r', 542), '|': ('r', 542), '}': ('r', 542), '&=': ('r', 542), '+=': ('r', 542), '+': ('r', 542), ']': ('r', 542), '<<': ('r', 542), '*=': ('r', 542), '[': ('s', 176), '.*': ('r', 542)}, 99),
        #STATE 100
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 56), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("unqualified_id -> '~' class_name:name", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), '++': ('r', 38), '(': ('r', 38), '::': ('r', 38), '*': ('r', 38), 'reinterpret_cast': ('r', 38), 'delete': ('r', 38), 'static_cast': ('r', 38), '!': ('r', 38), '&': ('r', 38), 'this': ('r', 38), '~': ('r', 38), IDENTIFIER: ('c', [('s', 173), ('r', 38)]), 'operator': ('r', 38), INTEGER_LITERAL: ('r', 38), class_name: ('g', 289), TYPE_KEYWORD: ('r', 38), 'new': ('r', 38), FLOATING_LITERAL: ('r', 38), 'sizeof': ('r', 38), CHARACTER_LITERAL: ('r', 38), '--': ('r', 38), 'const_cast': ('r', 38), BOOLEAN_LITERAL: ('r', 38), '+': ('r', 38), '-': ('r', 38), STRING_LITERAL: ('r', 38), 'dynamic_cast': ('r', 38), 'typename': ('r', 38), template_id: ('g', 44), 'typeid': ('r', 38)}, 100),
        #STATE 101
        State([("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 73), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 73)], {';': ('s', 588)}, 101),
        #STATE 102
        State([('literal -> BOOLEAN_LITERAL:v', 26)], {',': ('r', 21), '-': ('r', 21), '.': ('r', 21), '/': ('r', 21), '(': ('r', 21), ')': ('r', 21), '*': ('r', 21), '+': ('r', 21), '%': ('r', 21), '&': ('r', 21), '<': ('r', 21), '=': ('r', 21), '>': ('r', 21), '?': ('r', 21), '<<': ('r', 21), ':': ('r', 21), ';': ('r', 21), '...': ('r', 21), '|=': ('r', 21), '^=': ('r', 21), '%=': ('r', 21), '!=': ('r', 21), '--': ('r', 21), '/=': ('r', 21), '==': ('r', 21), '^': ('r', 21), '<<=': ('r', 21), '->': ('r', 21), '-=': ('r', 21), '->*': ('r', 21), '>>': ('r', 21), '>=': ('r', 21), '<=': ('r', 21), '||': ('r', 21), '>>=': ('r', 21), '&&': ('r', 21), '|': ('r', 21), '}': ('r', 21), '&=': ('r', 21), '++': ('r', 21), '+=': ('r', 21), ']': ('r', 21), '*=': ('r', 21), '[': ('r', 21), '.*': ('r', 21)}, 102),
        #STATE 103
        State([("primary_expression -> 'this'", 28)], {',': ('r', 553), '-': ('r', 553), '.': ('r', 553), '/': ('r', 553), '(': ('r', 553), ')': ('r', 553), '*': ('r', 553), '==': ('r', 553), '%': ('r', 553), '&': ('r', 553), '<': ('r', 553), '=': ('r', 553), '>': ('r', 553), '?': ('r', 553), '<<': ('r', 553), ':': ('r', 553), ';': ('r', 553), '...': ('r', 553), '|=': ('r', 553), '^=': ('r', 553), '%=': ('r', 553), '!=': ('r', 553), '--': ('r', 553), '/=': ('r', 553), '++': ('r', 553), '^': ('r', 553), '<<=': ('r', 553), '->': ('r', 553), '-=': ('r', 553), '->*': ('r', 553), '>>': ('r', 553), '>=': ('r', 553), '<=': ('r', 553), '||': ('r', 553), '>>=': ('r', 553), '&&': ('r', 553), '|': ('r', 553), '}': ('r', 553), '&=': ('r', 553), '+=': ('r', 553), '+': ('r', 553), ']': ('r', 553), '*=': ('r', 553), '[': ('r', 553), '.*': ('r', 553)}, 103),
        #STATE 104
        State([("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 49)], {'-': ('r', 177), '++': ('r', 177), '(': ('r', 177), '::': ('r', 177), '*': ('r', 177), 'sizeof': ('r', 177), 'delete': ('r', 177), 'static_cast': ('r', 177), '!': ('r', 177), 'this': ('r', 177), '~': ('r', 177), IDENTIFIER: ('r', 177), 'operator': ('r', 177), 'const_cast': ('r', 177), CHARACTER_LITERAL: ('r', 177), 'new': ('r', 177), FLOATING_LITERAL: ('r', 177), TYPE_KEYWORD: ('r', 177), '--': ('r', 177), 'reinterpret_cast': ('r', 177), BOOLEAN_LITERAL: ('r', 177), '+': ('r', 177), STRING_LITERAL: ('r', 177), 'dynamic_cast': ('r', 177), 'typename': ('r', 177), INTEGER_LITERAL: ('r', 177), '&': ('r', 177), 'typeid': ('r', 177)}, 104),
        #STATE 105
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('namespace_name -> IDENTIFIER:name', 18), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> FLOATING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), operator_function_id: ('g', 6), delete_expression: ('g', 119), cast_expression: ('g', 531), 'typeid': ('s', 38)}, 105),
        #STATE 106
        State([('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 31)], {',': ('r', 350), '-': ('r', 350), '.': ('r', 350), '/': ('r', 350), '(': ('r', 350), ')': ('r', 350), '*': ('r', 350), '+': ('r', 350), '%': ('r', 350), '&': ('r', 350), 'operator': ('r', 350), '%=': ('r', 350), '<': ('r', 350), '=': ('r', 350), '>': ('r', 350), '?': ('r', 350), '<<': ('r', 350), IDENTIFIER: ('r', 350), ':': ('r', 350), ';': ('r', 350), '...': ('r', 350), '|=': ('r', 350), '^=': ('r', 350), '::': ('r', 350), '^': ('r', 350), 'class': ('r', 350), '!=': ('r', 350), '--': ('r', 350), '/=': ('r', 350), '++': ('r', 350), '*=': ('r', 350), '<<=': ('r', 350), '->': ('r', 350), 'struct': ('r', 350), '-=': ('r', 350), '->*': ('r', 350), '>>': ('r', 350), '>=': ('r', 350), 'union': ('r', 350), '>>=': ('r', 350), '<=': ('r', 350), '||': ('r', 350), 'auto': ('r', 350), 'volatile': ('r', 350), '&&': ('r', 350), '|': ('r', 350), '}': ('r', 350), '~': ('r', 350), '&=': ('r', 350), '{': ('r', 350), '.*': ('r', 350), TYPE_KEYWORD: ('r', 350), 'try': ('r', 350), 'enum': ('r', 350), '+=': ('r', 350), 'throw': ('r', 350), ']': ('r', 350), 'typename': ('r', 350), '==': ('r', 350), '[': ('r', 350), 'const': ('r', 350)}, 106),
        #STATE 107
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("unary_expression -> 'sizeof' unary_expression:v", 29), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('namespace_name -> IDENTIFIER:name', 18), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 29), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> FLOATING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 890), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), id_expression: ('g', 114), unqualified_id: ('g', 7), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 876), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), '+': ('s', 80), 'typename': ('s', 180), operator_function_id: ('g', 6), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38)}, 107),
        #STATE 108
        State([('literal -> CHARACTER_LITERAL:v', 28)], {',': ('r', 563), '-': ('r', 563), '.': ('r', 563), '/': ('r', 563), '(': ('r', 563), ')': ('r', 563), '*': ('r', 563), '==': ('r', 563), '%': ('r', 563), '&': ('r', 563), '<': ('r', 563), '=': ('r', 563), '>': ('r', 563), '?': ('r', 563), '<<': ('r', 563), ':': ('r', 563), ';': ('r', 563), '...': ('r', 563), '|=': ('r', 563), '^=': ('r', 563), '%=': ('r', 563), '!=': ('r', 563), '--': ('r', 563), '/=': ('r', 563), '++': ('r', 563), '^': ('r', 563), '<<=': ('r', 563), '->': ('r', 563), '-=': ('r', 563), '->*': ('r', 563), '+=': ('r', 563), '>=': ('r', 563), '<=': ('r', 563), '||': ('r', 563), '>>=': ('r', 563), '&&': ('r', 563), '|': ('r', 563), '}': ('r', 563), '&=': ('r', 563), '>>': ('r', 563), '+': ('r', 563), ']': ('r', 563), '*=': ('r', 563), '[': ('r', 563), '.*': ('r', 563)}, 108),
        #STATE 109
        State([('raw_type_descriptor -> elaborated_type_specifier!', 48)], {',': ('r', 223), '-': ('r', 223), '.': ('r', 223), '/': ('r', 223), '|=': ('r', 223), ')': ('r', 223), '*': ('r', 223), '+': ('r', 223), '%': ('r', 223), '&': ('r', 223), 'operator': ('r', 223), '<': ('r', 223), '=': ('r', 223), '>': ('r', 223), '?': ('r', 223), '<<': ('r', 223), IDENTIFIER: ('r', 223), ':': ('r', 223), ';': ('r', 223), '...': ('r', 223), '(': ('r', 223), '^=': ('r', 223), '||': ('r', 223), '^': ('r', 223), '!=': ('r', 223), '--': ('r', 223), '/=': ('r', 223), '++': ('r', 223), '*=': ('r', 223), '<<=': ('r', 223), '%=': ('r', 223), 'struct': ('r', 223), '-=': ('r', 223), '->': ('r', 223), '->*': ('r', 223), '>>': ('r', 223), '>=': ('r', 223), 'union': ('r', 223), '<=': ('r', 223), '::': ('r', 223), 'auto': ('r', 223), '>>=': ('r', 223), '&&': ('r', 223), 'const': ('r', 223), '|': ('r', 223), '}': ('r', 223), '~': ('r', 223), 'volatile': ('r', 223), '&=': ('r', 223), '{': ('r', 223), TYPE_KEYWORD: ('r', 223), 'try': ('r', 223), 'enum': ('r', 223), '+=': ('r', 223), 'class': ('r', 223), ']': ('r', 223), 'typename': ('r', 223), '==': ('r', 223), '[': ('r', 223), '.*': ('r', 223)}, 109),
        #STATE 110
        State([("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 41)], {'<': ('s', 456)}, 110),
        #STATE 111
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('namespace_name -> IDENTIFIER:name', 18), ("unary_expression -> '--' cast_expression:v", 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> FLOATING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), operator_function_id: ('g', 6), delete_expression: ('g', 119), cast_expression: ('g', 671), 'typeid': ('s', 38)}, 111),
        #STATE 112
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 37), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {raw_type_descriptor: ('g', 604), named_type_specifier: ('g', 126), 'union': ('s', 97), nested_name_specifier: ('g', 189), type_name: ('g', 98), '::': ('s', 191), elaborated_type_specifier: ('g', 109), class_specifier: ('g', 75), 'struct': ('s', 58), template_name: ('g', 2), class_name: ('g', 11), TYPE_KEYWORD: ('s', 162), enum_specifier: ('g', 122), cv_qualifier: ('g', 32), class_head: ('g', 20), class_key: ('g', 78), 'enum': ('s', 117), _81: ('g', 88), 'class': ('s', 115), 'typename': ('s', 166), namespace_name: ('g', 5), 'auto': ('s', 90), 'volatile': ('s', 33), 'const': ('s', 35), template_id: ('g', 18), IDENTIFIER: ('s', 29)}, 112),
        #STATE 113
        State([('literal -> STRING_LITERAL:v', 25)], {',': ('r', 522), '-': ('r', 522), '.': ('r', 522), '/': ('r', 522), '(': ('r', 522), ')': ('r', 522), '*': ('r', 522), '==': ('r', 522), '%': ('r', 522), '&': ('r', 522), '<': ('r', 522), '=': ('r', 522), '>': ('r', 522), '?': ('r', 522), '<<': ('r', 522), ':': ('r', 522), ';': ('r', 522), '...': ('r', 522), '|=': ('r', 522), '^=': ('r', 522), '%=': ('r', 522), '!=': ('r', 522), '--': ('r', 522), '/=': ('r', 522), '++': ('r', 522), '^': ('r', 522), '<<=': ('r', 522), '->': ('r', 522), '-=': ('r', 522), '->*': ('r', 522), '+=': ('r', 522), '>=': ('r', 522), '<=': ('r', 522), '||': ('r', 522), '>>=': ('r', 522), '&&': ('r', 522), '|': ('r', 522), '}': ('r', 522), '&=': ('r', 522), '>>': ('r', 522), '+': ('r', 522), ']': ('r', 522), '*=': ('r', 522), '[': ('r', 522), '.*': ('r', 522)}, 113),
        #STATE 114
        State([('primary_expression -> id_expression!', 35)], {',': ('r', 140), '-': ('r', 140), '.': ('r', 140), '/': ('r', 140), '|=': ('r', 140), ')': ('r', 140), '*': ('r', 140), '+': ('r', 140), '%': ('r', 140), '&': ('r', 140), '<': ('r', 140), '=': ('r', 140), '>': ('r', 140), '?': ('r', 140), '<<': ('r', 140), ':': ('r', 140), ';': ('r', 140), '...': ('r', 140), '(': ('r', 140), '^=': ('r', 140), '%=': ('r', 140), '!=': ('r', 140), '--': ('r', 140), '/=': ('r', 140), '==': ('r', 140), '*=': ('r', 140), '<<=': ('r', 140), '->': ('r', 140), '-=': ('r', 140), '->*': ('r', 140), '+=': ('r', 140), '>=': ('r', 140), '<=': ('r', 140), '||': ('r', 140), '>>=': ('r', 140), '&&': ('r', 140), '|': ('r', 140), '}': ('r', 140), '&=': ('r', 140), '++': ('r', 140), '>>': ('r', 140), ']': ('r', 140), '^': ('r', 140), '[': ('r', 140), '.*': ('r', 140)}, 114),
        #STATE 115
        State([("class_key -> 'class' | 'struct' | 'union'", 20)], {IDENTIFIER: ('r', 24), '::': ('r', 24), ':': ('r', 24), '{': ('r', 24)}, 115),
        #STATE 116
        State([('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 33), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 40), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 44), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 33), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 33), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 33), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 33), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 51), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 33), ('class_name -> template_id!', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 51), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 40), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 44), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 51), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 40)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), template_id: ('g', 44), nested_name_specifier: ('g', 794), class_name: ('g', 11), '::': ('s', 795)}, 116),
        #STATE 117
        State([("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 47), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 74), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 25), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 25), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 36), ('class_name -> template_id!', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 36), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 42)], {template_name: ('g', 2), namespace_name: ('g', 5), IDENTIFIER: ('s', 676), '{': ('s', 980), template_id: ('g', 44), nested_name_specifier: ('g', 657), class_name: ('g', 11), '::': ('s', 612)}, 117),
        #STATE 118
        State([("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 50), ('logical_or_expression -> logical_and_expression!', 47), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 51)], {',': ('r', 108), '|=': ('r', 108), ')': ('r', 108), '||': ('s', 205), '>>=': ('r', 108), '&&': ('s', 499), '}': ('r', 108), '>': ('r', 108), '?': ('r', 108), '&=': ('r', 108), ':': ('r', 108), ';': ('r', 108), '...': ('r', 108), '^=': ('r', 108), '%=': ('r', 108), '=': ('r', 108), '/=': ('r', 108), ']': ('r', 108), '*=': ('r', 108), '<<=': ('r', 108), '-=': ('r', 108), '+=': ('r', 108)}, 118),
        #STATE 119
        State([('unary_expression -> delete_expression!', 37)], {',': ('r', 225), '-': ('r', 225), '/': ('r', 225), '|=': ('r', 225), ')': ('r', 225), '*': ('r', 225), '+': ('r', 225), '%': ('r', 225), '&': ('r', 225), '>>=': ('r', 225), '&&': ('r', 225), '<': ('r', 225), '=': ('r', 225), '>': ('r', 225), '?': ('r', 225), '&=': ('r', 225), ':': ('r', 225), ';': ('r', 225), '...': ('r', 225), '<=': ('r', 225), '^=': ('r', 225), '%=': ('r', 225), '|': ('r', 225), '!=': ('r', 225), '}': ('r', 225), '/=': ('r', 225), '==': ('r', 225), '||': ('r', 225), '^': ('r', 225), '>>': ('r', 225), ']': ('r', 225), '<<': ('r', 225), '<<=': ('r', 225), '*=': ('r', 225), '-=': ('r', 225), '.*': ('r', 225), '->*': ('r', 225), '+=': ('r', 225), '>=': ('r', 225)}, 119),
        #STATE 120
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('declarator -> direct_declarator!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('direct_declarator -> declarator_id!', 21), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('declarator_id -> id_expression!', 17), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("qualified_id -> '::' IDENTIFIER!", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('id_expression -> qualified_id!', 17), ('namespace_name -> IDENTIFIER:name', 18), ('unqualified_id -> IDENTIFIER:id', 18), ('unqualified_id -> operator_function_id!', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("condition -> type_descriptor:type declarator:dtor '=' assignment_expression:v", 34), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("operator_function_id -> 'operator' operator:op", 24), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ('unqualified_id -> conversion_function_id!', 18), ("ptr_operator -> '&'", 16), ("unqualified_id -> '~' class_name:name", 18), ("direct_declarator -> '(' declarator! ')'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {ptr_operator: ('g', 279), template_name: ('g', 2), declarator: ('g', 637), declarator_id: ('g', 286), '(': ('s', 281), qualified_id: ('g', 4), '*': ('s', 223), unqualified_id: ('g', 7), operator_function_id: ('g', 6), '&': ('s', 225), template_id: ('g', 44), conversion_function_id: ('g', 12), '~': ('s', 45), namespace_name: ('g', 5), IDENTIFIER: ('s', 46), 'operator': ('s', 8), direct_declarator: ('g', 285), nested_name_specifier: ('g', 284), class_name: ('g', 11), id_expression: ('g', 280), '::': ('s', 282)}, 120),
        #STATE 121
        State([("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 53), ('inclusive_or_expression -> exclusive_or_expression!', 50)], {',': ('r', 141), '|=': ('r', 141), ')': ('r', 141), '>>=': ('r', 141), '&&': ('r', 141), '|': ('r', 141), '}': ('r', 141), '>': ('r', 141), '?': ('r', 141), '&=': ('r', 141), ':': ('r', 141), ';': ('r', 141), '...': ('r', 141), '^=': ('r', 141), '||': ('r', 141), '=': ('r', 141), '/=': ('r', 141), '*=': ('r', 141), ']': ('r', 141), '^': ('s', 233), '<<=': ('r', 141), '-=': ('r', 141), '%=': ('r', 141), '+=': ('r', 141)}, 121),
        #STATE 122
        State([('raw_type_descriptor -> enum_specifier!', 37)], {',': ('r', 287), '-': ('r', 287), '.': ('r', 287), '/': ('r', 287), '|=': ('r', 287), ')': ('r', 287), '*': ('r', 287), '+': ('r', 287), '%': ('r', 287), '&': ('r', 287), 'operator': ('r', 287), '<': ('r', 287), '=': ('r', 287), '>': ('r', 287), '?': ('r', 287), '<<': ('r', 287), IDENTIFIER: ('r', 287), ':': ('r', 287), ';': ('r', 287), '...': ('r', 287), '(': ('r', 287), '^=': ('r', 287), '||': ('r', 287), '^': ('r', 287), '!=': ('r', 287), '--': ('r', 287), '/=': ('r', 287), '++': ('r', 287), '*=': ('r', 287), '<<=': ('r', 287), '%=': ('r', 287), 'struct': ('r', 287), '-=': ('r', 287), '->': ('r', 287), '->*': ('r', 287), '>>': ('r', 287), '>=': ('r', 287), 'union': ('r', 287), '<=': ('r', 287), '::': ('r', 287), 'auto': ('r', 287), '>>=': ('r', 287), '&&': ('r', 287), 'const': ('r', 287), '|': ('r', 287), '}': ('r', 287), '~': ('r', 287), 'volatile': ('r', 287), '&=': ('r', 287), '{': ('r', 287), TYPE_KEYWORD: ('r', 287), 'try': ('r', 287), 'enum': ('r', 287), '+=': ('r', 287), 'class': ('r', 287), ']': ('r', 287), 'typename': ('r', 287), '==': ('r', 287), '[': ('r', 287), '.*': ('r', 287)}, 122),
        #STATE 123
        State([("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 60)], {'(': ('r', 14)}, 123),
        #STATE 124
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('named_namespace_definition -> original_namespace_definition!', 30), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ('namespace_definition -> unnamed_namespace_definition!', 24), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 25), ('declaration -> function_definition!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ('block_declaration -> using_declaration!', 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 32), ('type_name -> IDENTIFIER:name', 13), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 33), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('translation_unit -> declaration!*:decls', 33), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ("explicit_instantiation -> 'template' declaration:decl", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> template_declaration!', 15), ('declaration -> CPP_INCLUDE!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> linkage_specification!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('type_name -> template_id!', 13), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_definition -> function_head:head function_try_block:tryb', 23), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 27), ('declaration -> namespace_definition!', 15), ("raw_type_descriptor -> 'auto'", 23), ('block_declaration -> asm_definition!', 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('block_declaration -> simple_declaration!', 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cv_qualifier -> 'const'!", 16), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('declaration -> CPP_ERROR!', 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_directive!', 21), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('declaration -> explicit_instantiation!', 15), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('namespace_definition -> named_namespace_definition!', 24), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('translation_unit -> declaration!*:decls', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> named_type_specifier!', 23), ('declaration -> block_declaration!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('declaration -> explicit_specialization!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), named_type_specifier: ('g', 126), 'union': ('s', 97), function_definition: ('g', 128), 'virtual': ('s', 130), explicit_specialization: ('g', 157), cd_id: ('g', 164), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), 'extern': ('s', 139), class_name: ('g', 11), using_directive: ('g', 137), class_specifier: ('g', 138), 'typedef': ('s', 136), namespace_definition: ('g', 140), CPP_INCLUDE: ('s', 129), named_namespace_definition: ('g', 142), _75: ('g', 152), 'asm': ('s', 125), original_namespace_definition: ('g', 144), explicit_instantiation: ('g', 146), _81: ('g', 88), type_name: ('g', 131), unnamed_namespace_definition: ('g', 145), 'export': ('s', 143), 'struct': ('s', 58), 'volatile': ('s', 33), 'namespace': ('s', 148), asm_definition: ('g', 149), function_head: ('g', 150), 'auto': ('s', 90), using_declaration: ('g', 127), _80: ('g', 112), '::': ('s', 153), namespace_name: ('g', 5), 'using': ('s', 154), nested_name_specifier: ('g', 155), linkage_specification: ('g', 156), _73: ('g', 133), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), namespace_alias_definition: ('g', 161), template_name: ('g', 2), class_head: ('g', 20), cv_qualifier: ('g', 106), EOF: ('r', 15), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), cd_declarator: ('g', 163), simple_declaration: ('g', 167), 'enum': ('s', 117), declaration: ('g', 132), type_descriptor: ('g', 169), 'class': ('s', 115), block_declaration: ('g', 141), 'typename': ('s', 166), CPP_ERROR: ('s', 151), 'operator': ('s', 168), template_declaration: ('g', 165), 'template': ('s', 147), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 29)}, 124),
        #STATE 125
        State([("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 24)], {'{': ('s', 935)}, 125),
        #STATE 126
        State([('raw_type_descriptor -> named_type_specifier!', 43)], {',': ('r', 20), '-': ('r', 20), '.': ('r', 20), '/': ('r', 20), '|=': ('r', 20), ')': ('r', 20), '*': ('r', 20), '+': ('r', 20), '%': ('r', 20), '&': ('r', 20), 'operator': ('r', 20), '<': ('r', 20), '=': ('r', 20), '>': ('r', 20), '?': ('r', 20), '<<': ('r', 20), IDENTIFIER: ('r', 20), ':': ('r', 20), ';': ('r', 20), '...': ('r', 20), '(': ('r', 20), '^=': ('r', 20), '||': ('r', 20), '^': ('r', 20), '!=': ('r', 20), '--': ('r', 20), '/=': ('r', 20), '++': ('r', 20), '*=': ('r', 20), '<<=': ('r', 20), '%=': ('r', 20), 'auto': ('r', 20), '-=': ('r', 20), '->': ('r', 20), '->*': ('r', 20), '>>': ('r', 20), '>=': ('r', 20), 'union': ('r', 20), '<=': ('r', 20), '::': ('r', 20), '>>=': ('r', 20), '&&': ('r', 20), 'const': ('r', 20), '|': ('r', 20), '}': ('r', 20), '~': ('r', 20), 'volatile': ('r', 20), '&=': ('r', 20), '{': ('r', 20), 'struct': ('r', 20), TYPE_KEYWORD: ('r', 20), 'try': ('r', 20), 'enum': ('r', 20), '+=': ('r', 20), 'class': ('r', 20), ']': ('r', 20), 'typename': ('r', 20), '==': ('r', 20), '[': ('r', 20), '.*': ('r', 20)}, 126),
        #STATE 127
        State([('block_declaration -> using_declaration!', 38)], {'sizeof': ('r', 48), '-': ('r', 48), 'asm': ('r', 48), '(': ('r', 48), '*': ('r', 48), 'reinterpret_cast': ('r', 48), 'delete': ('r', 48), 'static_cast': ('r', 48), 'virtual': ('r', 48), '!': ('r', 48), ACCESS_KEYWORD: ('r', 48), IDENTIFIER: ('r', 48), 'while': ('r', 48), INTEGER_LITERAL: ('r', 48), 'extern': ('r', 48), 'default': ('r', 48), 'goto': ('r', 48), 'new': ('r', 48), 'throw': ('r', 48), 'typedef': ('r', 48), '--': ('r', 48), '++': ('r', 48), 'dynamic_cast': ('r', 48), 'for': ('r', 48), 'export': ('r', 48), '+': ('r', 48), 'struct': ('r', 48), 'template': ('r', 48), 'continue': ('r', 48), '&': ('r', 48), 'this': ('r', 48), 'if': ('r', 48), 'union': ('r', 48), 'const_cast': ('r', 48), '::': ('r', 48), 'auto': ('r', 48), 'using': ('r', 48), 'volatile': ('r', 48), 'namespace': ('r', 48), 'do': ('r', 48), DECLARE_KEYWORD: ('r', 48), '}': ('r', 48), '~': ('r', 48), 'return': ('r', 48), '{': ('r', 48), 'case': ('r', 48), TYPE_KEYWORD: ('r', 48), FLOATING_LITERAL: ('r', 48), CPP_ERROR: ('r', 48), 'else': ('r', 48), CHARACTER_LITERAL: ('r', 48), 'try': ('r', 48), BOOLEAN_LITERAL: ('r', 48), 'enum': ('r', 48), EOF: ('r', 48), STRING_LITERAL: ('r', 48), 'class': ('r', 48), CPP_INCLUDE: ('r', 48), 'typename': ('r', 48), 'break': ('r', 48), 'operator': ('r', 48), 'const': ('r', 48), 'switch': ('r', 48), 'typeid': ('r', 48)}, 127),
        #STATE 128
        State([('declaration -> function_definition!', 34)], {'union': ('r', 482), '::': ('r', 482), 'export': ('r', 482), 'using': ('r', 482), 'virtual': ('r', 482), DECLARE_KEYWORD: ('r', 482), 'const': ('r', 482), ACCESS_KEYWORD: ('r', 482), '~': ('r', 482), IDENTIFIER: ('r', 482), 'template': ('r', 482), 'extern': ('r', 482), 'operator': ('r', 482), 'typedef': ('r', 482), TYPE_KEYWORD: ('r', 482), '}': ('r', 482), 'asm': ('r', 482), 'enum': ('r', 482), EOF: ('r', 482), 'class': ('r', 482), CPP_INCLUDE: ('r', 482), 'typename': ('r', 482), CPP_ERROR: ('r', 482), 'struct': ('r', 482), 'volatile': ('r', 482), 'namespace': ('r', 482), 'auto': ('r', 482)}, 128),
        #STATE 129
        State([('declaration -> CPP_INCLUDE!', 26)], {'union': ('r', 369), '::': ('r', 369), 'export': ('r', 369), 'using': ('r', 369), 'virtual': ('r', 369), DECLARE_KEYWORD: ('r', 369), 'const': ('r', 369), ACCESS_KEYWORD: ('r', 369), '~': ('r', 369), IDENTIFIER: ('r', 369), 'template': ('r', 369), 'extern': ('r', 369), 'operator': ('r', 369), 'typedef': ('r', 369), TYPE_KEYWORD: ('r', 369), '}': ('r', 369), 'asm': ('r', 369), 'enum': ('r', 369), EOF: ('r', 369), 'class': ('r', 369), CPP_INCLUDE: ('r', 369), 'typename': ('r', 369), CPP_ERROR: ('r', 369), 'struct': ('r', 369), 'volatile': ('r', 369), 'namespace': ('r', 369), 'auto': ('r', 369)}, 129),
        #STATE 130
        State([("decl_attrib -> 'virtual'!", 24)], {'union': ('r', 499), 'extern': ('r', 499), '::': ('r', 499), 'typename': ('r', 499), 'struct': ('r', 499), 'volatile': ('r', 499), 'virtual': ('r', 499), 'enum': ('r', 499), DECLARE_KEYWORD: ('r', 499), 'class': ('r', 499), '~': ('r', 499), IDENTIFIER: ('r', 499), 'auto': ('r', 499), 'operator': ('r', 499), 'const': ('r', 499), 'typedef': ('r', 499), TYPE_KEYWORD: ('r', 499)}, 130),
        #STATE 131
        State([("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 71), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 56)], {'~': ('r', 193), '(': ('c', [('r', 193), ('r', 183)]), '::': ('r', 193), '*': ('r', 193), 'operator': ('r', 193), ':': ('r', 193), '&': ('r', 193), ';': ('r', 193), IDENTIFIER: ('r', 193)}, 131),
        #STATE 132
        State([('translation_unit -> declaration!*:decls', 31)], {'union': ('r', 233), '::': ('r', 233), 'export': ('r', 233), 'using': ('r', 233), 'virtual': ('r', 233), DECLARE_KEYWORD: ('r', 233), '}': ('r', 233), '~': ('r', 233), IDENTIFIER: ('r', 233), 'namespace': ('r', 233), 'extern': ('r', 233), 'operator': ('r', 233), 'typedef': ('r', 233), TYPE_KEYWORD: ('r', 233), 'asm': ('r', 233), 'enum': ('r', 233), EOF: ('r', 233), 'class': ('r', 233), CPP_INCLUDE: ('r', 233), 'typename': ('r', 233), CPP_ERROR: ('r', 233), 'struct': ('r', 233), 'volatile': ('r', 233), 'template': ('r', 233), 'const': ('r', 233), 'auto': ('r', 233)}, 132),
        #STATE 133
        State([("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("class_key -> 'class' | 'struct' | 'union'", 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("decl_attrib -> 'extern'!", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('namespace_name -> IDENTIFIER:name', 18), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ("class_key -> 'class' | 'struct' | 'union'", 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('decl_attrib -> DECLARE_KEYWORD!', 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ("decl_attrib -> 'virtual'!", 15), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ('raw_type_descriptor -> named_type_specifier!', 23), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), decl_attrib: ('g', 266), '::': ('s', 153), 'struct': ('s', 58), _75: ('g', 723), template_id: ('g', 18), nested_name_specifier: ('g', 155), 'virtual': ('s', 130), type_name: ('g', 131), 'union': ('s', 97), DECLARE_KEYWORD: ('s', 160), elaborated_type_specifier: ('g', 109), '~': ('s', 159), IDENTIFIER: ('s', 29), 'operator': ('s', 168), template_name: ('g', 2), 'extern': ('s', 249), class_name: ('g', 11), _80: ('g', 112), class_specifier: ('g', 75), 'typedef': ('s', 136), class_head: ('g', 20), conversion_function_id: ('g', 158), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), cd_id: ('g', 164), _81: ('g', 88), 'class': ('s', 115), 'typename': ('s', 166), namespace_name: ('g', 5), 'auto': ('s', 90), 'volatile': ('s', 33), type_descriptor: ('g', 964), 'const': ('s', 35), cd_declarator: ('g', 933), cv_qualifier: ('g', 106), enum_specifier: ('g', 122)}, 133),
        #STATE 134
        State([('raw_type_descriptor -> elaborated_type_specifier!', 48), ("simple_declaration -> elaborated_type_specifier! ';'", 49)], {'~': ('r', 223), '(': ('r', 223), '::': ('r', 223), '*': ('r', 223), ';': ('s', 36), '&': ('r', 223), 'operator': ('r', 223), IDENTIFIER: ('r', 223)}, 134),
        #STATE 135
        State([("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 57), ('raw_type_descriptor -> enum_specifier!', 37)], {'~': ('r', 287), '(': ('r', 287), '::': ('r', 287), '*': ('r', 287), ';': ('s', 306), '&': ('r', 287), 'operator': ('r', 287), IDENTIFIER: ('r', 287)}, 135),
        #STATE 136
        State([("decl_attrib -> 'typedef'!", 24)], {'union': ('r', 45), 'typedef': ('r', 45), TYPE_KEYWORD: ('r', 45), 'typename': ('r', 45), 'struct': ('r', 45), 'volatile': ('r', 45), 'virtual': ('r', 45), 'enum': ('r', 45), DECLARE_KEYWORD: ('r', 45), 'class': ('r', 45), '~': ('r', 45), IDENTIFIER: ('r', 45), 'auto': ('r', 45), 'operator': ('r', 45), 'const': ('r', 45), 'extern': ('r', 45), '::': ('r', 45)}, 136),
        #STATE 137
        State([('block_declaration -> using_directive!', 36)], {'-': ('r', 507), 'asm': ('r', 507), '(': ('r', 507), '*': ('r', 507), '+': ('r', 507), 'delete': ('r', 507), 'static_cast': ('r', 507), 'virtual': ('r', 507), '!': ('r', 507), ACCESS_KEYWORD: ('r', 507), IDENTIFIER: ('r', 507), 'while': ('r', 507), INTEGER_LITERAL: ('r', 507), 'extern': ('r', 507), 'default': ('r', 507), 'goto': ('r', 507), 'break': ('r', 507), 'new': ('r', 507), 'throw': ('r', 507), 'typedef': ('r', 507), '--': ('r', 507), '++': ('r', 507), 'dynamic_cast': ('r', 507), 'for': ('r', 507), 'export': ('r', 507), 'struct': ('r', 507), 'template': ('r', 507), 'continue': ('r', 507), '&': ('r', 507), 'case': ('r', 507), 'if': ('r', 507), 'union': ('r', 507), 'const_cast': ('r', 507), '::': ('r', 507), 'auto': ('r', 507), 'using': ('r', 507), 'volatile': ('r', 507), 'namespace': ('r', 507), 'do': ('r', 507), DECLARE_KEYWORD: ('r', 507), 'try': ('r', 507), '~': ('r', 507), 'return': ('r', 507), '{': ('r', 507), 'this': ('r', 507), TYPE_KEYWORD: ('r', 507), FLOATING_LITERAL: ('r', 507), 'sizeof': ('r', 507), 'else': ('r', 507), CHARACTER_LITERAL: ('r', 507), '}': ('r', 507), 'reinterpret_cast': ('r', 507), BOOLEAN_LITERAL: ('r', 507), 'enum': ('r', 507), EOF: ('r', 507), STRING_LITERAL: ('r', 507), 'class': ('r', 507), CPP_INCLUDE: ('r', 507), 'typename': ('r', 507), CPP_ERROR: ('r', 507), 'operator': ('r', 507), 'const': ('r', 507), 'switch': ('r', 507), 'typeid': ('r', 507)}, 137),
        #STATE 138
        State([('raw_type_descriptor -> class_specifier!', 38), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 57)], {'~': ('r', 124), '(': ('r', 124), '::': ('r', 124), '*': ('r', 124), ';': ('s', 553), '&': ('r', 124), 'operator': ('r', 124), IDENTIFIER: ('r', 124)}, 138),
        #STATE 139
        State([("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 34), ("decl_attrib -> 'extern'!", 23), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 34), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 34)], {STRING_LITERAL: ('s', 512), 'auto': ('r', 52), 'typedef': ('r', 52), '::': ('r', 52), 'union': ('r', 52), 'volatile': ('r', 52), 'virtual': ('r', 52), 'enum': ('r', 52), DECLARE_KEYWORD: ('r', 52), 'class': ('r', 52), 'typename': ('r', 52), '~': ('r', 52), IDENTIFIER: ('r', 52), 'struct': ('r', 52), 'operator': ('r', 52), 'const': ('r', 52), 'extern': ('r', 52), TYPE_KEYWORD: ('r', 52)}, 139),
        #STATE 140
        State([('declaration -> namespace_definition!', 35)], {'union': ('r', 357), '::': ('r', 357), 'export': ('r', 357), 'using': ('r', 357), 'virtual': ('r', 357), DECLARE_KEYWORD: ('r', 357), 'const': ('r', 357), '}': ('r', 357), '~': ('r', 357), IDENTIFIER: ('r', 357), 'namespace': ('r', 357), 'extern': ('r', 357), 'operator': ('r', 357), 'typedef': ('r', 357), TYPE_KEYWORD: ('r', 357), ACCESS_KEYWORD: ('r', 357), 'asm': ('r', 357), 'enum': ('r', 357), EOF: ('r', 357), 'class': ('r', 357), CPP_INCLUDE: ('r', 357), 'typename': ('r', 357), CPP_ERROR: ('r', 357), 'struct': ('r', 357), 'volatile': ('r', 357), 'template': ('r', 357), 'auto': ('r', 357)}, 140),
        #STATE 141
        State([('declaration -> block_declaration!', 32)], {'union': ('r', 279), '::': ('r', 279), 'export': ('r', 279), 'using': ('r', 279), 'virtual': ('r', 279), DECLARE_KEYWORD: ('r', 279), 'const': ('r', 279), ACCESS_KEYWORD: ('r', 279), '~': ('r', 279), IDENTIFIER: ('r', 279), 'template': ('r', 279), 'extern': ('r', 279), 'operator': ('r', 279), 'typedef': ('r', 279), TYPE_KEYWORD: ('r', 279), '}': ('r', 279), 'asm': ('r', 279), 'enum': ('r', 279), EOF: ('r', 279), 'class': ('r', 279), CPP_INCLUDE: ('r', 279), 'typename': ('r', 279), CPP_ERROR: ('r', 279), 'struct': ('r', 279), 'volatile': ('r', 279), 'namespace': ('r', 279), 'auto': ('r', 279)}, 141),
        #STATE 142
        State([('namespace_definition -> named_namespace_definition!', 50)], {'union': ('r', 515), 'struct': ('r', 515), 'export': ('r', 515), 'using': ('r', 515), 'virtual': ('r', 515), DECLARE_KEYWORD: ('r', 515), 'const': ('r', 515), ACCESS_KEYWORD: ('r', 515), '~': ('r', 515), IDENTIFIER: ('r', 515), 'template': ('r', 515), 'extern': ('r', 515), 'operator': ('r', 515), '::': ('r', 515), 'typedef': ('r', 515), TYPE_KEYWORD: ('r', 515), '}': ('r', 515), 'asm': ('r', 515), 'enum': ('r', 515), EOF: ('r', 515), 'class': ('r', 515), CPP_INCLUDE: ('r', 515), 'typename': ('r', 515), CPP_ERROR: ('r', 515), 'auto': ('r', 515), 'volatile': ('r', 515), 'namespace': ('r', 515)}, 142),
        #STATE 143
        State([("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38)], {'template': ('s', 476)}, 143),
        #STATE 144
        State([('named_namespace_definition -> original_namespace_definition!', 59)], {'union': ('r', 410), 'struct': ('r', 410), 'export': ('r', 410), 'using': ('r', 410), 'virtual': ('r', 410), DECLARE_KEYWORD: ('r', 410), 'const': ('r', 410), ACCESS_KEYWORD: ('r', 410), '~': ('r', 410), IDENTIFIER: ('r', 410), 'template': ('r', 410), 'extern': ('r', 410), 'operator': ('r', 410), '::': ('r', 410), 'typedef': ('r', 410), TYPE_KEYWORD: ('r', 410), '}': ('r', 410), 'asm': ('r', 410), 'enum': ('r', 410), EOF: ('r', 410), 'class': ('r', 410), CPP_INCLUDE: ('r', 410), 'typename': ('r', 410), CPP_ERROR: ('r', 410), 'auto': ('r', 410), 'volatile': ('r', 410), 'namespace': ('r', 410)}, 144),
        #STATE 145
        State([('namespace_definition -> unnamed_namespace_definition!', 52)], {'union': ('r', 232), '::': ('r', 232), 'export': ('r', 232), 'using': ('r', 232), 'virtual': ('r', 232), DECLARE_KEYWORD: ('r', 232), 'const': ('r', 232), ACCESS_KEYWORD: ('r', 232), '~': ('r', 232), IDENTIFIER: ('r', 232), 'template': ('r', 232), 'extern': ('r', 232), 'operator': ('r', 232), 'typedef': ('r', 232), TYPE_KEYWORD: ('r', 232), '}': ('r', 232), 'asm': ('r', 232), 'enum': ('r', 232), EOF: ('r', 232), 'class': ('r', 232), CPP_INCLUDE: ('r', 232), 'typename': ('r', 232), CPP_ERROR: ('r', 232), 'struct': ('r', 232), 'volatile': ('r', 232), 'namespace': ('r', 232), 'auto': ('r', 232)}, 145),
        #STATE 146
        State([('declaration -> explicit_instantiation!', 37)], {'union': ('r', 165), 'struct': ('r', 165), 'export': ('r', 165), 'using': ('r', 165), 'virtual': ('r', 165), DECLARE_KEYWORD: ('r', 165), 'const': ('r', 165), ACCESS_KEYWORD: ('r', 165), '~': ('r', 165), IDENTIFIER: ('r', 165), 'template': ('r', 165), 'extern': ('r', 165), 'operator': ('r', 165), '::': ('r', 165), 'typedef': ('r', 165), TYPE_KEYWORD: ('r', 165), '}': ('r', 165), 'asm': ('r', 165), 'enum': ('r', 165), EOF: ('r', 165), 'class': ('r', 165), CPP_INCLUDE: ('r', 165), 'typename': ('r', 165), CPP_ERROR: ('r', 165), 'auto': ('r', 165), 'volatile': ('r', 165), 'namespace': ('r', 165)}, 146),
        #STATE 147
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('named_namespace_definition -> original_namespace_definition!', 30), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ('namespace_definition -> unnamed_namespace_definition!', 24), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 25), ('declaration -> function_definition!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ('block_declaration -> using_declaration!', 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 49), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 32), ('type_name -> IDENTIFIER:name', 13), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 33), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('namespace_definition -> named_namespace_definition!', 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ("explicit_instantiation -> 'template' declaration:decl", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> template_declaration!', 15), ('declaration -> CPP_INCLUDE!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 27), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> linkage_specification!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('type_name -> template_id!', 13), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ('function_definition -> function_head:head function_try_block:tryb', 23), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 38), ('declaration -> namespace_definition!', 15), ("raw_type_descriptor -> 'auto'", 23), ('block_declaration -> asm_definition!', 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('block_declaration -> simple_declaration!', 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cv_qualifier -> 'const'!", 16), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('declaration -> CPP_ERROR!', 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_directive!', 21), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('declaration -> explicit_instantiation!', 15), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> named_type_specifier!', 23), ('declaration -> block_declaration!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('declaration -> explicit_specialization!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("explicit_instantiation -> 'template' declaration:decl", 37), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), named_type_specifier: ('g', 126), 'union': ('s', 97), function_definition: ('g', 128), 'virtual': ('s', 130), explicit_specialization: ('g', 157), declaration: ('g', 1054), '<': ('s', 816), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), 'extern': ('s', 139), class_name: ('g', 11), using_directive: ('g', 137), class_specifier: ('g', 138), 'typedef': ('s', 136), namespace_definition: ('g', 140), CPP_INCLUDE: ('s', 129), named_namespace_definition: ('g', 142), _75: ('g', 152), 'asm': ('s', 125), original_namespace_definition: ('g', 144), explicit_instantiation: ('g', 146), _81: ('g', 88), type_name: ('g', 131), unnamed_namespace_definition: ('g', 145), 'export': ('s', 143), 'struct': ('s', 58), 'volatile': ('s', 33), namespace_alias_definition: ('g', 161), asm_definition: ('g', 149), function_head: ('g', 150), 'auto': ('s', 90), using_declaration: ('g', 127), _80: ('g', 112), '::': ('s', 153), namespace_name: ('g', 5), 'using': ('s', 154), nested_name_specifier: ('g', 155), linkage_specification: ('g', 156), _73: ('g', 133), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), 'namespace': ('s', 148), template_name: ('g', 2), class_head: ('g', 20), cv_qualifier: ('g', 106), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), cd_declarator: ('g', 163), simple_declaration: ('g', 167), 'enum': ('s', 117), cd_id: ('g', 164), type_descriptor: ('g', 169), 'class': ('s', 115), block_declaration: ('g', 141), 'typename': ('s', 166), CPP_ERROR: ('s', 151), 'operator': ('s', 168), template_declaration: ('g', 165), 'template': ('s', 147), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 29)}, 147),
        #STATE 148
        State([("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 45), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 44), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 42)], {IDENTIFIER: ('s', 462), '{': ('s', 843)}, 148),
        #STATE 149
        State([('block_declaration -> asm_definition!', 35)], {'-': ('r', 415), '++': ('r', 415), '(': ('r', 415), '*': ('r', 415), 'reinterpret_cast': ('r', 415), 'delete': ('r', 415), 'static_cast': ('r', 415), 'virtual': ('r', 415), DECLARE_KEYWORD: ('r', 415), ACCESS_KEYWORD: ('r', 415), IDENTIFIER: ('r', 415), 'while': ('r', 415), INTEGER_LITERAL: ('r', 415), 'extern': ('r', 415), 'default': ('r', 415), 'goto': ('r', 415), 'new': ('r', 415), 'throw': ('r', 415), 'typedef': ('r', 415), '--': ('r', 415), 'asm': ('r', 415), 'dynamic_cast': ('r', 415), 'for': ('r', 415), 'export': ('r', 415), '+': ('r', 415), 'struct': ('r', 415), 'template': ('r', 415), 'continue': ('r', 415), '&': ('r', 415), 'case': ('r', 415), CPP_ERROR: ('r', 415), 'if': ('r', 415), 'const_cast': ('r', 415), '::': ('r', 415), 'auto': ('r', 415), 'using': ('r', 415), 'volatile': ('r', 415), 'namespace': ('r', 415), 'union': ('r', 415), '!': ('r', 415), '}': ('r', 415), '~': ('r', 415), 'return': ('r', 415), 'do': ('r', 415), '{': ('r', 415), 'this': ('r', 415), TYPE_KEYWORD: ('r', 415), FLOATING_LITERAL: ('r', 415), 'sizeof': ('r', 415), 'else': ('r', 415), CHARACTER_LITERAL: ('r', 415), 'try': ('r', 415), BOOLEAN_LITERAL: ('r', 415), 'enum': ('r', 415), EOF: ('r', 415), STRING_LITERAL: ('r', 415), 'class': ('r', 415), CPP_INCLUDE: ('r', 415), 'typename': ('r', 415), 'break': ('r', 415), 'operator': ('r', 415), 'const': ('r', 415), 'switch': ('r', 415), 'typeid': ('r', 415)}, 149),
        #STATE 150
        State([('function_definition -> function_head:head ctor_initializer:init? function_body:body', 65), ("ctor_initializer -> ':' mem_initializer!+,','!", 20), ("compound_statement -> '{' statement!*:sts '}'", 22), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 42), ('function_definition -> function_head:head function_try_block:tryb', 42), ("function_try_block -> 'try' ctor_initializer:init? function_body:body handler!+:handlers", 22), ('function_body -> compound_statement!', 17), ("function_try_block -> 'try' ctor_initializer:init? function_body:body handler!+:handlers", 22), ("compound_statement -> '{' statement!*:sts '}'", 22)], {function_body: ('g', 1065), compound_statement: ('g', 985), function_try_block: ('g', 891), ':': ('s', 515), 'try': ('s', 1063), '{': ('s', 329), ctor_initializer: ('g', 984)}, 150),
        #STATE 151
        State([('declaration -> CPP_ERROR!', 24)], {'union': ('r', 289), 'struct': ('r', 289), 'export': ('r', 289), 'using': ('r', 289), 'virtual': ('r', 289), DECLARE_KEYWORD: ('r', 289), 'const': ('r', 289), ACCESS_KEYWORD: ('r', 289), '~': ('r', 289), IDENTIFIER: ('r', 289), 'template': ('r', 289), 'extern': ('r', 289), 'operator': ('r', 289), '::': ('r', 289), 'typedef': ('r', 289), TYPE_KEYWORD: ('r', 289), '}': ('r', 289), 'asm': ('r', 289), 'enum': ('r', 289), EOF: ('r', 289), 'class': ('r', 289), CPP_INCLUDE: ('r', 289), 'typename': ('r', 289), CPP_ERROR: ('r', 289), 'auto': ('r', 289), 'volatile': ('r', 289), 'namespace': ('r', 289)}, 151),
        #STATE 152
        State([("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 67), None], {',': ('s', 214), ';': ('s', 215)}, 152),
        #STATE 153
        State([('type_name -> IDENTIFIER:name', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_name -> template_id!', 14), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('template_name -> IDENTIFIER!', 17), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35)], {template_name: ('g', 2), '~': ('s', 218), IDENTIFIER: ('s', 29), conversion_function_id: ('g', 219), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 991), 'operator': ('s', 168), class_name: ('g', 11), type_name: ('g', 931)}, 153),
        #STATE 154
        State([('namespace_name -> IDENTIFIER:name', 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 44), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 27), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 27), ('class_name -> IDENTIFIER:name', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 27), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 29), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), 'typename': ('s', 647), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), template_id: ('g', 44), 'namespace': ('s', 648), nested_name_specifier: ('g', 397), class_name: ('g', 11), '::': ('s', 649)}, 154),
        #STATE 155
        State([('type_name -> IDENTIFIER:name', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), '~': ('s', 315), IDENTIFIER: ('s', 24), conversion_function_id: ('g', 898), 'template': ('s', 291), 'operator': ('s', 168), template_id: ('g', 26), type_name: ('g', 630)}, 155),
        #STATE 156
        State([('declaration -> linkage_specification!', 36)], {'union': ('r', 230), '::': ('r', 230), 'export': ('r', 230), 'using': ('r', 230), 'virtual': ('r', 230), DECLARE_KEYWORD: ('r', 230), 'const': ('r', 230), ACCESS_KEYWORD: ('r', 230), '~': ('r', 230), IDENTIFIER: ('r', 230), 'template': ('r', 230), 'extern': ('r', 230), 'operator': ('r', 230), 'typedef': ('r', 230), TYPE_KEYWORD: ('r', 230), '}': ('r', 230), 'asm': ('r', 230), 'enum': ('r', 230), EOF: ('r', 230), 'class': ('r', 230), CPP_INCLUDE: ('r', 230), 'typename': ('r', 230), CPP_ERROR: ('r', 230), 'struct': ('r', 230), 'volatile': ('r', 230), 'namespace': ('r', 230), 'auto': ('r', 230)}, 156),
        #STATE 157
        State([('declaration -> explicit_specialization!', 38)], {'union': ('r', 446), '::': ('r', 446), 'export': ('r', 446), 'using': ('r', 446), 'virtual': ('r', 446), DECLARE_KEYWORD: ('r', 446), 'const': ('r', 446), ACCESS_KEYWORD: ('r', 446), '~': ('r', 446), IDENTIFIER: ('r', 446), 'template': ('r', 446), 'extern': ('r', 446), 'operator': ('r', 446), 'typedef': ('r', 446), TYPE_KEYWORD: ('r', 446), '}': ('r', 446), 'asm': ('r', 446), 'enum': ('r', 446), EOF: ('r', 446), 'class': ('r', 446), CPP_INCLUDE: ('r', 446), 'typename': ('r', 446), CPP_ERROR: ('r', 446), 'struct': ('r', 446), 'volatile': ('r', 446), 'namespace': ('r', 446), 'auto': ('r', 446)}, 157),
        #STATE 158
        State([("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 69)], {'(': ('r', 277)}, 158),
        #STATE 159
        State([('type_name -> IDENTIFIER:name', 13), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_name -> template_id!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 51), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {type_name: ('g', 243), template_name: ('g', 2), IDENTIFIER: ('s', 24), template_id: ('g', 26)}, 159),
        #STATE 160
        State([('decl_attrib -> DECLARE_KEYWORD!', 30)], {'union': ('r', 214), 'extern': ('r', 214), TYPE_KEYWORD: ('r', 214), 'typename': ('r', 214), 'struct': ('r', 214), 'volatile': ('r', 214), 'virtual': ('r', 214), 'enum': ('r', 214), DECLARE_KEYWORD: ('r', 214), 'class': ('r', 214), '~': ('r', 214), IDENTIFIER: ('r', 214), 'auto': ('r', 214), 'operator': ('r', 214), 'const': ('r', 214), 'typedef': ('r', 214), '::': ('r', 214)}, 160),
        #STATE 161
        State([('block_declaration -> namespace_alias_definition!', 47)], {'-': ('r', 401), 'asm': ('r', 401), '(': ('r', 401), '*': ('r', 401), 'reinterpret_cast': ('r', 401), 'delete': ('r', 401), 'static_cast': ('r', 401), 'virtual': ('r', 401), DECLARE_KEYWORD: ('r', 401), ACCESS_KEYWORD: ('r', 401), IDENTIFIER: ('r', 401), 'while': ('r', 401), INTEGER_LITERAL: ('r', 401), 'extern': ('r', 401), 'default': ('r', 401), 'goto': ('r', 401), 'break': ('r', 401), 'new': ('r', 401), 'class': ('r', 401), 'typedef': ('r', 401), '--': ('r', 401), '++': ('r', 401), 'dynamic_cast': ('r', 401), 'for': ('r', 401), 'export': ('r', 401), '+': ('r', 401), 'struct': ('r', 401), 'template': ('r', 401), 'continue': ('r', 401), '&': ('r', 401), 'this': ('r', 401), 'if': ('r', 401), 'union': ('r', 401), 'const_cast': ('r', 401), '::': ('r', 401), 'auto': ('r', 401), 'using': ('r', 401), 'volatile': ('r', 401), 'namespace': ('r', 401), 'do': ('r', 401), '!': ('r', 401), '}': ('r', 401), '~': ('r', 401), 'return': ('r', 401), '{': ('r', 401), 'case': ('r', 401), TYPE_KEYWORD: ('r', 401), FLOATING_LITERAL: ('r', 401), 'sizeof': ('r', 401), 'else': ('r', 401), CHARACTER_LITERAL: ('r', 401), 'try': ('r', 401), BOOLEAN_LITERAL: ('r', 401), 'enum': ('r', 401), EOF: ('r', 401), STRING_LITERAL: ('r', 401), 'throw': ('r', 401), CPP_INCLUDE: ('r', 401), 'typename': ('r', 401), CPP_ERROR: ('r', 401), 'operator': ('r', 401), 'const': ('r', 401), 'switch': ('r', 401), 'typeid': ('r', 401)}, 161),
        #STATE 162
        State([('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 35)], {',': ('r', 406), '-': ('r', 406), '.': ('r', 406), '/': ('r', 406), '|=': ('r', 406), ')': ('r', 406), '*': ('r', 406), '+': ('r', 406), '%': ('r', 406), '&': ('r', 406), 'operator': ('r', 406), '<': ('r', 406), '=': ('r', 406), '>': ('r', 406), '?': ('r', 406), '<<': ('r', 406), IDENTIFIER: ('r', 406), ':': ('r', 406), ';': ('r', 406), '...': ('r', 406), '(': ('r', 406), '^=': ('r', 406), '||': ('r', 406), '^': ('r', 406), '!=': ('r', 406), '--': ('r', 406), '/=': ('r', 406), '++': ('r', 406), '*=': ('r', 406), '<<=': ('r', 406), '%=': ('r', 406), 'struct': ('r', 406), '-=': ('r', 406), '->': ('r', 406), '->*': ('r', 406), '>>': ('r', 406), '>=': ('r', 406), 'union': ('r', 406), '<=': ('r', 406), '::': ('r', 406), 'auto': ('r', 406), '>>=': ('r', 406), '&&': ('r', 406), 'const': ('r', 406), '|': ('r', 406), '}': ('r', 406), '~': ('r', 406), 'volatile': ('r', 406), '&=': ('r', 406), '{': ('r', 406), TYPE_KEYWORD: ('r', 406), 'try': ('r', 406), 'enum': ('r', 406), '+=': ('r', 406), 'class': ('r', 406), ']': ('r', 406), 'typename': ('r', 406), '==': ('r', 406), '[': ('r', 406), '.*': ('r', 406)}, 162),
        #STATE 163
        State([("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 55), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 50)], {',': ('r', 107), 'try': ('r', 31), '{': ('r', 31), ':': ('r', 31), ';': ('r', 107)}, 163),
        #STATE 164
        State([("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 25), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 25)], {'(': ('s', 187)}, 164),
        #STATE 165
        State([('declaration -> template_declaration!', 35)], {'union': ('r', 39), '::': ('r', 39), 'export': ('r', 39), 'using': ('r', 39), 'virtual': ('r', 39), DECLARE_KEYWORD: ('r', 39), 'const': ('r', 39), ACCESS_KEYWORD: ('r', 39), '~': ('r', 39), IDENTIFIER: ('r', 39), 'template': ('r', 39), 'extern': ('r', 39), 'operator': ('r', 39), 'typedef': ('r', 39), TYPE_KEYWORD: ('r', 39), '}': ('r', 39), 'asm': ('r', 39), 'enum': ('r', 39), EOF: ('r', 39), 'class': ('r', 39), CPP_INCLUDE: ('r', 39), 'typename': ('r', 39), CPP_ERROR: ('r', 39), 'struct': ('r', 39), 'volatile': ('r', 39), 'namespace': ('r', 39), 'auto': ('r', 39)}, 165),
        #STATE 166
        State([('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 40), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 40), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 51), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 51), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_name -> template_id!', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 40), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 51), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), template_id: ('g', 44), nested_name_specifier: ('g', 535), class_name: ('g', 11), '::': ('s', 536)}, 166),
        #STATE 167
        State([('block_declaration -> simple_declaration!', 39)], {'-': ('r', 464), '++': ('r', 464), '(': ('r', 464), '*': ('r', 464), '+': ('r', 464), 'delete': ('r', 464), 'static_cast': ('r', 464), 'virtual': ('r', 464), DECLARE_KEYWORD: ('r', 464), ACCESS_KEYWORD: ('r', 464), IDENTIFIER: ('r', 464), 'while': ('r', 464), INTEGER_LITERAL: ('r', 464), 'extern': ('r', 464), 'default': ('r', 464), 'goto': ('r', 464), 'break': ('r', 464), 'new': ('r', 464), 'class': ('r', 464), 'typedef': ('r', 464), '--': ('r', 464), 'asm': ('r', 464), 'dynamic_cast': ('r', 464), 'for': ('r', 464), 'export': ('r', 464), 'struct': ('r', 464), 'template': ('r', 464), 'continue': ('r', 464), '&': ('r', 464), 'case': ('r', 464), 'if': ('r', 464), 'union': ('r', 464), 'const_cast': ('r', 464), '::': ('r', 464), 'auto': ('r', 464), 'using': ('r', 464), 'volatile': ('r', 464), 'namespace': ('r', 464), 'do': ('r', 464), '!': ('r', 464), '}': ('r', 464), '~': ('r', 464), 'return': ('r', 464), '{': ('r', 464), 'this': ('r', 464), TYPE_KEYWORD: ('r', 464), FLOATING_LITERAL: ('r', 464), 'sizeof': ('r', 464), 'else': ('r', 464), CHARACTER_LITERAL: ('r', 464), 'try': ('r', 464), 'reinterpret_cast': ('r', 464), BOOLEAN_LITERAL: ('r', 464), 'enum': ('r', 464), EOF: ('r', 464), STRING_LITERAL: ('r', 464), 'throw': ('r', 464), CPP_INCLUDE: ('r', 464), 'typename': ('r', 464), CPP_ERROR: ('r', 464), 'operator': ('r', 464), 'const': ('r', 464), 'switch': ('r', 464), 'typeid': ('r', 464)}, 167),
        #STATE 168
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> named_type_specifier!', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('conversion_type_id -> type_descriptor:type conversion_declarator:dtor?', 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("conversion_function_id -> 'operator' conversion_type_id!", 37), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('conversion_type_id -> type_descriptor:type conversion_declarator:dtor?', 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), 'auto': ('s', 90), '::': ('s', 191), template_name: ('g', 2), template_id: ('g', 18), nested_name_specifier: ('g', 189), cv_qualifier: ('g', 106), type_name: ('g', 98), 'union': ('s', 97), elaborated_type_specifier: ('g', 109), enum_specifier: ('g', 122), class_name: ('g', 11), _80: ('g', 112), namespace_name: ('g', 5), class_head: ('g', 20), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), conversion_type_id: ('g', 1032), class_specifier: ('g', 75), 'class': ('s', 115), 'typename': ('s', 166), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), _81: ('g', 88), type_descriptor: ('g', 434), IDENTIFIER: ('s', 29)}, 168),
        #STATE 169
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 63), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 63), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 63), ('init_declarator -> declarator:d initializer:init?', 19), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('declarator -> direct_declarator!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('direct_declarator -> declarator_id!', 21), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 58), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('declarator_id -> id_expression!', 17), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("qualified_id -> '::' IDENTIFIER!", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('init_declarator -> declarator:d initializer:init?', 19), ('id_expression -> qualified_id!', 17), ('namespace_name -> IDENTIFIER:name', 18), ('unqualified_id -> IDENTIFIER:id', 18), ('unqualified_id -> operator_function_id!', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("operator_function_id -> 'operator' operator:op", 24), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('unqualified_id -> conversion_function_id!', 18), ("ptr_operator -> '&'", 16), ("unqualified_id -> '~' class_name:name", 18), ("direct_declarator -> '(' declarator! ')'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {unqualified_id: ('g', 7), '(': ('s', 281), qualified_id: ('g', 4), '*': ('s', 223), namespace_name: ('g', 5), nested_name_specifier: ('g', 284), '&': ('s', 225), init_declarator: ('g', 181), '~': ('s', 45), IDENTIFIER: ('s', 46), 'operator': ('s', 8), template_name: ('g', 2), direct_declarator: ('g', 285), class_name: ('g', 11), '::': ('s', 282), id_expression: ('g', 280), _74: ('g', 451), declarator_id: ('g', 286), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), ptr_operator: ('g', 279), template_id: ('g', 44), declarator: ('g', 983)}, 169),
        #STATE 170
        State([("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 42)], {IDENTIFIER: ('s', 171)}, 170),
        #STATE 171
        State([("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 58)], {'=': ('s', 463)}, 171),
        #STATE 172
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ('class_name -> template_id!', 14), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 90), ('class_name -> IDENTIFIER:name', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), class_name: ('g', 174), IDENTIFIER: ('s', 173), template_id: ('g', 44)}, 172),
        #STATE 173
        State([('template_name -> IDENTIFIER!', 27), ('class_name -> IDENTIFIER:name', 24)], {',': ('r', 7), '-': ('r', 7), '.': ('r', 7), '/': ('r', 7), '|=': ('r', 7), ')': ('r', 7), '*': ('r', 7), '+': ('r', 7), '%': ('r', 7), '&': ('r', 7), '<': ('c', [('r', 2), ('r', 7)]), '=': ('r', 7), '>': ('r', 7), '?': ('r', 7), '<<': ('r', 7), ':': ('r', 7), ';': ('r', 7), '...': ('r', 7), '(': ('r', 7), '^=': ('r', 7), '%=': ('r', 7), '!=': ('r', 7), '--': ('r', 7), '/=': ('r', 7), '++': ('r', 7), '^': ('r', 7), '<<=': ('r', 7), '->': ('r', 7), '-=': ('r', 7), '->*': ('r', 7), '+=': ('r', 7), '>=': ('r', 7), '<=': ('r', 7), '||': ('r', 7), '>>=': ('r', 7), '&&': ('r', 7), '|': ('r', 7), '}': ('r', 7), '&=': ('r', 7), '{': ('r', 7), 'try': ('r', 7), '>>': ('r', 7), ']': ('r', 7), '*=': ('r', 7), '==': ('r', 7), '[': ('r', 7), '.*': ('r', 7)}, 173),
        #STATE 174
        State([("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 100)], {',': ('r', 123), '{': ('r', 123)}, 174),
        #STATE 175
        State([("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 112)], {',': ('r', 16), '>': ('r', 16)}, 175),
        #STATE 176
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 47), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), expression: ('g', 179), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 176),
        #STATE 177
        State([('simple_type_specifier -> named_type_specifier!', 45)], {'(': ('r', 64)}, 177),
        #STATE 178
        State([('simple_type_specifier -> TYPE_KEYWORD:kw', 37)], {'(': ('r', 195)}, 178),
        #STATE 179
        State([("expression -> expression:a ',' assignment_expression:b", 27), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 60)], {',': ('s', 272), ']': ('s', 296)}, 179),
        #STATE 180
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 33), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 44), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 33), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 33), ('class_name -> template_id!', 14), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 33), ('namespace_name -> IDENTIFIER:name', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 44), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 33), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ('template_name -> IDENTIFIER!', 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 33)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), template_id: ('g', 44), nested_name_specifier: ('g', 751), class_name: ('g', 11), '::': ('s', 750)}, 180),
        #STATE 181
        State([("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 78)], {',': ('r', 17), ';': ('r', 17)}, 181),
        #STATE 182
        State([("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 95), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 76), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 76), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 75)], {',': ('r', 18), '=': ('s', 183), '>': ('r', 18), IDENTIFIER: ('s', 184)}, 182),
        #STATE 183
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("operator_function_id -> 'operator' operator:op", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('class_name -> template_id!', 14), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 99), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ('namespace_name -> IDENTIFIER:name', 18), ('unqualified_id -> IDENTIFIER:id', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> operator_function_id!', 18), ('id_expression -> qualified_id!', 17), ("qualified_id -> '::' IDENTIFIER!", 16), ('unqualified_id -> conversion_function_id!', 18), ("unqualified_id -> '~' class_name:name", 18), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), qualified_id: ('g', 4), namespace_name: ('g', 5), template_id: ('g', 44), operator_function_id: ('g', 6), unqualified_id: ('g', 7), class_name: ('g', 11), conversion_function_id: ('g', 12), '~': ('s', 45), IDENTIFIER: ('s', 46), 'operator': ('s', 8), nested_name_specifier: ('g', 47), id_expression: ('g', 401), '::': ('s', 48)}, 183),
        #STATE 184
        State([("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 86), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 95)], {',': ('r', 370), '=': ('s', 318), '>': ('r', 370)}, 184),
        #STATE 185
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 88), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), class_name: ('g', 186), IDENTIFIER: ('s', 173), template_id: ('g', 44)}, 185),
        #STATE 186
        State([("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 98)], {',': ('r', 29), '{': ('r', 29)}, 186),
        #STATE 187
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 25), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('raw_type_descriptor -> class_specifier!', 23), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 29), ('raw_type_descriptor -> enum_specifier!', 23), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('parameter_declaration -> type_descriptor:type declarator:dtor', 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ('type_name -> IDENTIFIER:name', 13), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 13), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), None, ("raw_type_descriptor -> 'auto'", 23), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_key -> 'class' | 'struct' | 'union'", 23), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("class_key -> 'class' | 'struct' | 'union'", 34), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 66), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {raw_type_descriptor: ('g', 54), IDENTIFIER: ('s', 29), named_type_specifier: ('g', 126), cv_qualifier: ('g', 106), nested_name_specifier: ('g', 189), parameter_declaration: ('g', 190), type_name: ('g', 98), 'union': ('s', 97), ')': ('r', 19), elaborated_type_specifier: ('g', 109), '::': ('s', 191), parameter_declaration_clause: ('g', 194), enum_specifier: ('g', 122), template_name: ('g', 2), class_name: ('g', 11), '...': ('s', 192), class_head: ('g', 20), class_specifier: ('g', 75), _100: ('g', 188), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), _80: ('g', 112), type_descriptor: ('g', 193), 'class': ('s', 115), 'typename': ('s', 166), namespace_name: ('g', 5), 'enum': ('s', 117), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), _81: ('g', 88), template_id: ('g', 18), 'auto': ('s', 90)}, 187),
        #STATE 188
        State([("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 66), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 59), None, ("parameter_declaration_clause -> parameter_declaration!+,',':plist ',' '...'", 66)], {'...': ('s', 389), ',': ('s', 390), ')': ('r', 68)}, 188),
        #STATE 189
        State([('type_name -> IDENTIFIER:name', 13), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {type_name: ('g', 292), 'template': ('s', 291), template_id: ('g', 26), IDENTIFIER: ('s', 24), template_name: ('g', 2)}, 189),
        #STATE 190
        State([("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 53)], {'...': ('r', 131), ',': ('r', 131), ')': ('r', 131)}, 190),
        #STATE 191
        State([('namespace_name -> IDENTIFIER:name', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ('type_name -> template_id!', 13), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('type_name -> IDENTIFIER:name', 13)], {template_name: ('g', 2), IDENTIFIER: ('s', 29), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 373), type_name: ('g', 405), class_name: ('g', 11)}, 191),
        #STATE 192
        State([("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 71)], {')': ('r', 487)}, 192),
        #STATE 193
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ('parameter_declaration -> type_descriptor:type declarator:dtor', 46), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("direct_declarator -> '(' declarator! ')'", 21), ('direct_declarator -> declarator_id!', 21), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('unqualified_id -> operator_function_id!', 18), ('abstract_declarator -> direct_abstract_declarator!', 23), ('class_name -> IDENTIFIER:name', 14), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 46), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 46), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('id_expression -> qualified_id!', 17), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("operator_function_id -> 'operator' operator:op", 24), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('id_expression -> unqualified_id!', 17), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 46), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ('declarator -> direct_declarator!', 14), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 40), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ('declarator_id -> id_expression!', 17), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ("qualified_id -> '::' IDENTIFIER!", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ('namespace_name -> IDENTIFIER:name', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unqualified_id -> '~' class_name:name", 18), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ('unqualified_id -> conversion_function_id!', 18), ("ptr_operator -> '&'", 16), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 72), ("direct_abstract_declarator -> '(' abstract_declarator! ')'", 30), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {',': ('r', 98), unqualified_id: ('g', 7), '(': ('s', 484), qualified_id: ('g', 4), '*': ('s', 223), template_name: ('g', 2), nested_name_specifier: ('g', 284), '&': ('s', 225), ')': ('r', 98), '=': ('s', 485), '~': ('s', 45), declarator: ('g', 477), 'operator': ('s', 8), '...': ('r', 98), direct_declarator: ('g', 285), ptr_operator: ('g', 486), '::': ('s', 282), id_expression: ('g', 280), namespace_name: ('g', 5), declarator_id: ('g', 286), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), '>': ('r', 98), class_name: ('g', 11), abstract_declarator: ('g', 487), '[': ('s', 226), direct_abstract_declarator: ('g', 231), template_id: ('g', 44), IDENTIFIER: ('s', 46)}, 193),
        #STATE 194
        State([("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 65), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 65)], {')': ('s', 851)}, 194),
        #STATE 195
        State([("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('raw_type_descriptor -> enum_specifier!', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('namespace_name -> IDENTIFIER:name', 18), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ('template_parameter -> type_parameter!', 22), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("cv_qualifier -> 'const'!", 16), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ('template_parameter -> parameter_declaration!', 22), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("class_key -> 'class' | 'struct' | 'union'", 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ('class_name -> IDENTIFIER:name', 14), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('parameter_declaration -> type_descriptor:type declarator:dtor', 25), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('raw_type_descriptor -> named_type_specifier!', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {raw_type_descriptor: ('g', 54), IDENTIFIER: ('s', 29), named_type_specifier: ('g', 126), class_specifier: ('g', 75), nested_name_specifier: ('g', 189), cv_qualifier: ('g', 106), parameter_declaration: ('g', 196), type_name: ('g', 98), 'union': ('s', 97), type_descriptor: ('g', 193), elaborated_type_specifier: ('g', 109), '::': ('s', 191), enum_specifier: ('g', 122), 'template': ('s', 201), template_name: ('g', 2), _123: ('g', 197), class_name: ('g', 11), _80: ('g', 112), namespace_name: ('g', 5), class_head: ('g', 20), type_parameter: ('g', 202), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), _81: ('g', 88), 'class': ('s', 198), 'typename': ('s', 199), template_parameter: ('g', 200), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), template_id: ('g', 18), 'auto': ('s', 90)}, 195),
        #STATE 196
        State([('template_parameter -> parameter_declaration!', 43)], {',': ('r', 557), '>': ('r', 557)}, 196),
        #STATE 197
        State([None, ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 84)], {',': ('s', 552), '>': ('s', 645)}, 197),
        #STATE 198
        State([("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 39), ("class_key -> 'class' | 'struct' | 'union'", 20), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 39), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 58), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 26)], {',': ('r', 25), '=': ('s', 234), '>': ('r', 25), '::': ('r', 24), ':': ('r', 24), '{': ('r', 24), IDENTIFIER: ('c', [('s', 235), ('r', 24)])}, 198),
        #STATE 199
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 39), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 40), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 51), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_name -> template_id!', 14), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 37), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 51), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 40), ('namespace_name -> IDENTIFIER:name', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 51), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 39), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 40), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 58)], {',': ('r', 118), template_name: ('g', 2), '>': ('r', 118), '=': ('s', 533), IDENTIFIER: ('s', 534), namespace_name: ('g', 5), template_id: ('g', 44), nested_name_specifier: ('g', 535), class_name: ('g', 11), '::': ('s', 536)}, 199),
        #STATE 200
        State([("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 71)], {',': ('r', 147), '>': ('r', 147)}, 200),
        #STATE 201
        State([("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 29), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 29), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 29), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 29)], {'<': ('s', 582)}, 201),
        #STATE 202
        State([('template_parameter -> type_parameter!', 36)], {',': ('r', 61), '>': ('r', 61)}, 202),
        #STATE 203
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 53), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), expression: ('g', 204), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 203),
        #STATE 204
        State([("expression -> expression:a ',' assignment_expression:b", 27), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 69)], {',': ('s', 272), ')': ('s', 475)}, 204),
        #STATE 205
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 55), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('pm_expression -> cast_expression!', 17), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), inclusive_or_expression: ('g', 76), '--': ('s', 111), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 206), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), exclusive_or_expression: ('g', 121), nested_name_specifier: ('g', 95), new_expression: ('g', 94), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 205),
        #STATE 206
        State([("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 76)], {',': ('r', 558), '<<=': ('r', 558), '-=': ('r', 558), '|=': ('r', 558), ')': ('r', 558), ':': ('r', 558), '}': ('r', 558), '/=': ('r', 558), '>>=': ('r', 558), ']': ('r', 558), '=': ('r', 558), '>': ('r', 558), '?': ('r', 558), '*=': ('r', 558), '&=': ('r', 558), ';': ('r', 558), '...': ('r', 558), '+=': ('r', 558), '^=': ('r', 558), '%=': ('r', 558)}, 206),
        #STATE 207
        State([("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 77), ('namespace_name -> IDENTIFIER:name', 18)], {namespace_name: ('g', 208), IDENTIFIER: ('s', 209)}, 207),
        #STATE 208
        State([("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 97)], {';': ('s', 1056)}, 208),
        #STATE 209
        State([('namespace_name -> IDENTIFIER:name', 28)], {';': ('r', 5)}, 209),
        #STATE 210
        State([("operator -> '[' ']'", 16)], {']': ('s', 211)}, 210),
        #STATE 211
        State([("operator -> '[' ']'", 19)], {',': ('r', 160), '-': ('r', 160), '.': ('r', 160), '/': ('r', 160), '(': ('r', 160), ')': ('r', 160), '*': ('r', 160), '+': ('r', 160), '%': ('r', 160), '&': ('r', 160), '<': ('r', 160), '=': ('r', 160), '>': ('r', 160), '?': ('r', 160), '<<': ('r', 160), ':': ('r', 160), ';': ('r', 160), '...': ('r', 160), '|=': ('r', 160), '^=': ('r', 160), '%=': ('r', 160), '!=': ('r', 160), '--': ('r', 160), '/=': ('r', 160), '++': ('r', 160), '*=': ('r', 160), '<<=': ('r', 160), '->': ('r', 160), '-=': ('r', 160), '->*': ('r', 160), '+=': ('r', 160), '>=': ('r', 160), '<=': ('r', 160), '||': ('r', 160), '>>=': ('r', 160), '&&': ('r', 160), '|': ('r', 160), '}': ('r', 160), '&=': ('r', 160), '{': ('r', 160), 'try': ('r', 160), '>>': ('r', 160), ']': ('r', 160), '^': ('r', 160), '==': ('r', 160), '[': ('r', 160), '.*': ('r', 160)}, 211),
        #STATE 212
        State([("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 68), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 68), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 68), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 68)], {'class': ('s', 182)}, 212),
        #STATE 213
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 85)], {',': ('r', 22), '-': ('r', 22), '/': ('r', 22), '|=': ('r', 22), ')': ('r', 22), '*': ('r', 22), '+': ('r', 22), '%': ('r', 22), '&': ('r', 22), '>>=': ('r', 22), '&&': ('r', 22), '<': ('r', 22), '=': ('r', 22), '>': ('r', 22), '?': ('r', 22), '<<': ('r', 22), ':': ('r', 22), ';': ('r', 22), '...': ('r', 22), '<=': ('r', 22), '^=': ('r', 22), '%=': ('r', 22), '|': ('r', 22), '!=': ('r', 22), '}': ('r', 22), '/=': ('r', 22), '==': ('r', 22), '||': ('r', 22), '^': ('r', 22), '&=': ('r', 22), '+=': ('r', 22), ']': ('r', 22), '*=': ('r', 22), '<<=': ('r', 22), '-=': ('r', 22), '.*': ('r', 22), '->*': ('r', 22), '>>': ('r', 22), '>=': ('r', 22)}, 213),
        #STATE 214
        State([('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('type_name -> IDENTIFIER:name', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_name -> template_id!', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('type_name -> template_id!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('template_name -> IDENTIFIER!', 17), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9)], {template_name: ('g', 2), '::': ('s', 217), namespace_name: ('g', 5), nested_name_specifier: ('g', 539), cd_id: ('g', 164), type_name: ('g', 540), conversion_function_id: ('g', 158), '~': ('s', 159), IDENTIFIER: ('s', 29), 'operator': ('s', 168), cd_declarator: ('g', 541), class_name: ('g', 11), template_id: ('g', 18)}, 214),
        #STATE 215
        State([("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 70)], {'sizeof': ('r', 548), '-': ('r', 548), 'asm': ('r', 548), '(': ('r', 548), '*': ('r', 548), '+': ('r', 548), 'delete': ('r', 548), 'static_cast': ('r', 548), 'operator': ('r', 548), '!': ('r', 548), ACCESS_KEYWORD: ('r', 548), IDENTIFIER: ('r', 548), ';': ('r', 548), INTEGER_LITERAL: ('r', 548), 'extern': ('r', 548), 'default': ('r', 548), 'goto': ('r', 548), 'new': ('r', 548), 'throw': ('r', 548), 'typedef': ('r', 548), '--': ('r', 548), '++': ('r', 548), 'struct': ('r', 548), 'dynamic_cast': ('r', 548), 'for': ('r', 548), 'export': ('r', 548), 'auto': ('r', 548), 'volatile': ('r', 548), 'template': ('r', 548), 'continue': ('r', 548), '&': ('r', 548), 'case': ('r', 548), 'if': ('r', 548), 'union': ('r', 548), 'virtual': ('r', 548), 'const_cast': ('r', 548), '::': ('r', 548), 'using': ('r', 548), 'namespace': ('r', 548), 'do': ('r', 548), DECLARE_KEYWORD: ('r', 548), 'try': ('r', 548), '~': ('r', 548), 'return': ('r', 548), '{': ('r', 548), 'this': ('r', 548), TYPE_KEYWORD: ('r', 548), FLOATING_LITERAL: ('r', 548), CPP_ERROR: ('r', 548), 'else': ('r', 548), CHARACTER_LITERAL: ('r', 548), '}': ('r', 548), 'reinterpret_cast': ('r', 548), BOOLEAN_LITERAL: ('r', 548), 'enum': ('r', 548), EOF: ('r', 548), STRING_LITERAL: ('r', 548), 'class': ('r', 548), CPP_INCLUDE: ('r', 548), 'typename': ('r', 548), 'while': ('r', 548), 'break': ('r', 548), 'const': ('r', 548), 'switch': ('r', 548), 'typeid': ('r', 548)}, 215),
        #STATE 216
        State([('template_name -> IDENTIFIER!', 27)], {'<': ('r', 2)}, 216),
        #STATE 217
        State([('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('type_name -> IDENTIFIER:name', 13), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('class_name -> IDENTIFIER:name', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_name -> template_id!', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('type_name -> template_id!', 13), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {type_name: ('g', 221), template_name: ('g', 2), '~': ('s', 218), IDENTIFIER: ('s', 29), conversion_function_id: ('g', 219), namespace_name: ('g', 5), nested_name_specifier: ('g', 220), 'operator': ('s', 168), class_name: ('g', 11), template_id: ('g', 18)}, 217),
        #STATE 218
        State([('type_name -> IDENTIFIER:name', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 51), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_id: ('g', 26), template_name: ('g', 2), IDENTIFIER: ('s', 24), type_name: ('g', 317)}, 218),
        #STATE 219
        State([("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 69)], {'(': ('r', 359)}, 219),
        #STATE 220
        State([('type_name -> IDENTIFIER:name', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('type_name -> template_id!', 13)], {template_name: ('g', 2), '~': ('s', 811), IDENTIFIER: ('s', 24), conversion_function_id: ('g', 885), 'operator': ('s', 168), template_id: ('g', 26), type_name: ('g', 832)}, 220),
        #STATE 221
        State([("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 56)], {'(': ('r', 454)}, 221),
        #STATE 222
        State([("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('abstract_declarator -> direct_abstract_declarator!', 23), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), None, ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 64), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('raw_type_descriptor -> enum_specifier!', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 64), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('namespace_name -> IDENTIFIER:name', 18), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 66), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("cv_qualifier -> 'const'!", 16), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("class_key -> 'class' | 'struct' | 'union'", 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("direct_abstract_declarator -> '(' abstract_declarator! ')'", 34), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 64), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('parameter_declaration -> type_descriptor:type declarator:dtor', 25), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('raw_type_descriptor -> named_type_specifier!', 23), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("direct_abstract_declarator -> '(' abstract_declarator! ')'", 30), ('type_name -> template_id!', 13), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 64), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("ptr_operator -> '&'", 16), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {raw_type_descriptor: ('g', 54), '(': ('s', 222), named_type_specifier: ('g', 126), '*': ('s', 223), template_name: ('g', 2), class_specifier: ('g', 75), nested_name_specifier: ('g', 224), '&': ('s', 225), 'volatile': ('s', 33), parameter_declaration: ('g', 190), type_name: ('g', 98), 'union': ('s', 97), type_descriptor: ('g', 193), ')': ('r', 19), elaborated_type_specifier: ('g', 109), IDENTIFIER: ('s', 29), enum_specifier: ('g', 122), 'struct': ('s', 58), '...': ('s', 192), direct_abstract_declarator: ('g', 231), ptr_operator: ('g', 229), '::': ('s', 227), class_head: ('g', 20), cv_qualifier: ('g', 106), _100: ('g', 188), class_key: ('g', 78), template_id: ('g', 18), TYPE_KEYWORD: ('s', 162), _80: ('g', 112), class_name: ('g', 11), 'class': ('s', 115), 'typename': ('s', 166), namespace_name: ('g', 5), 'enum': ('s', 117), 'auto': ('s', 90), '[': ('s', 226), 'const': ('s', 35), _81: ('g', 88), parameter_declaration_clause: ('g', 228), abstract_declarator: ('g', 230)}, 222),
        #STATE 223
        State([('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("ptr_operator -> '*' cv_qualifier!*:cv", 19), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cv_qualifier -> 'const'!", 16), ("cv_qualifier -> 'volatile'!", 16)], {',': ('r', 321), '-': ('r', 321), '.': ('r', 321), '/': ('r', 321), '|=': ('r', 321), _80: ('g', 714), '*': ('r', 321), '+': ('r', 321), '%': ('r', 321), '&': ('r', 321), 'operator': ('r', 321), '<': ('r', 321), '=': ('r', 321), '>': ('r', 321), '?': ('r', 321), '<<': ('r', 321), IDENTIFIER: ('r', 321), ':': ('r', 321), ';': ('r', 321), '...': ('r', 321), '(': ('r', 321), '^=': ('r', 321), '::': ('r', 321), '^': ('r', 321), '!=': ('r', 321), '--': ('r', 321), '/=': ('r', 321), '++': ('r', 321), '*=': ('r', 321), '<<=': ('r', 321), '%=': ('r', 321), '-=': ('r', 321), 'auto': ('r', 321), 'volatile': ('c', [('s', 33), ('r', 321)]), '->': ('r', 321), '->*': ('r', 321), '>>': ('r', 321), '>=': ('r', 321), 'union': ('r', 321), '<=': ('r', 321), '||': ('r', 321), '>>=': ('r', 321), ')': ('r', 321), '&&': ('r', 321), '|': ('r', 321), '}': ('r', 321), '~': ('r', 321), '&=': ('r', 321), '{': ('r', 321), '.*': ('r', 321), cv_qualifier: ('g', 106), TYPE_KEYWORD: ('r', 321), 'try': ('r', 321), 'struct': ('r', 321), 'enum': ('r', 321), '+=': ('r', 321), 'class': ('r', 321), ']': ('r', 321), 'typename': ('r', 321), '==': ('r', 321), '[': ('r', 321), 'const': ('c', [('s', 35), ('r', 321)])}, 223),
        #STATE 224
        State([('type_name -> IDENTIFIER:name', 13), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), IDENTIFIER: ('s', 24), '*': ('s', 290), 'template': ('s', 291), type_name: ('g', 292), template_id: ('g', 26)}, 224),
        #STATE 225
        State([("ptr_operator -> '&'", 19)], {',': ('r', 26), '-': ('r', 26), '.': ('r', 26), '/': ('r', 26), '|=': ('r', 26), ')': ('r', 26), '*': ('r', 26), '+': ('r', 26), '%': ('r', 26), '&': ('r', 26), 'operator': ('r', 26), '<': ('r', 26), '=': ('r', 26), '>': ('r', 26), '?': ('r', 26), '<<': ('r', 26), IDENTIFIER: ('r', 26), ':': ('r', 26), ';': ('r', 26), '...': ('r', 26), '(': ('r', 26), '^=': ('r', 26), '||': ('r', 26), '^': ('r', 26), '!=': ('r', 26), '--': ('r', 26), '/=': ('r', 26), '++': ('r', 26), '*=': ('r', 26), '<<=': ('r', 26), '->': ('r', 26), '-=': ('r', 26), 'auto': ('r', 26), 'volatile': ('r', 26), '%=': ('r', 26), '>>': ('r', 26), '>=': ('r', 26), 'union': ('r', 26), '<=': ('r', 26), '::': ('r', 26), '>>=': ('r', 26), '&&': ('r', 26), '|': ('r', 26), '}': ('r', 26), '~': ('r', 26), '&=': ('r', 26), '{': ('r', 26), '.*': ('r', 26), 'struct': ('r', 26), '->*': ('r', 26), TYPE_KEYWORD: ('r', 26), 'try': ('r', 26), 'enum': ('r', 26), '+=': ('r', 26), 'class': ('r', 26), ']': ('r', 26), 'typename': ('r', 26), '==': ('r', 26), '[': ('r', 26), 'const': ('r', 26)}, 225),
        #STATE 226
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 64), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 89), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('constant_expression -> conditional_expression!', 23), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), constant_expression: ('g', 791), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), '!': ('s', 104), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 774), logical_and_expression: ('g', 118), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 310), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), type_name: ('g', 98), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), unqualified_id: ('g', 7), 'const_cast': ('s', 92), qualified_id: ('g', 4), exclusive_or_expression: ('g', 121), nested_name_specifier: ('g', 95), new_expression: ('g', 94), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), ']': ('s', 792), 'typename': ('s', 180), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 226),
        #STATE 227
        State([('namespace_name -> IDENTIFIER:name', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('class_name -> IDENTIFIER:name', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ('type_name -> template_id!', 13), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('type_name -> IDENTIFIER:name', 13)], {template_name: ('g', 2), IDENTIFIER: ('s', 29), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 406), type_name: ('g', 405), class_name: ('g', 11)}, 227),
        #STATE 228
        State([("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 100), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 100), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 100), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 100)], {')': ('s', 558)}, 228),
        #STATE 229
        State([('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ('class_name -> template_id!', 14), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 35), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('abstract_declarator -> direct_abstract_declarator!', 23), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ('class_name -> IDENTIFIER:name', 14), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("ptr_operator -> '&'", 16), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 39), ("direct_abstract_declarator -> '(' abstract_declarator! ')'", 30), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60)], {',': ('r', 142), template_name: ('g', 2), '(': ('s', 222), '::': ('c', [('s', 435), ('r', 142)]), '*': ('s', 223), 'union': ('r', 142), nested_name_specifier: ('g', 437), '&': ('s', 225), 'volatile': ('r', 142), 'const': ('r', 142), '>': ('r', 142), IDENTIFIER: ('c', [('s', 414), ('r', 142)]), 'struct': ('r', 142), ptr_operator: ('g', 229), ')': ('r', 142), namespace_name: ('g', 5), TYPE_KEYWORD: ('r', 142), 'enum': ('r', 142), class_name: ('g', 11), 'class': ('r', 142), 'typename': ('r', 142), abstract_declarator: ('g', 578), 'auto': ('r', 142), '[': ('s', 226), direct_abstract_declarator: ('g', 231), template_id: ('g', 44)}, 229),
        #STATE 230
        State([("direct_abstract_declarator -> '(' abstract_declarator! ')'", 55)], {')': ('s', 593)}, 230),
        #STATE 231
        State([("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ('abstract_declarator -> direct_abstract_declarator!', 49), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60)], {',': ('r', 442), 'union': ('r', 442), '(': ('s', 1029), ')': ('r', 442), 'struct': ('r', 442), 'volatile': ('r', 442), TYPE_KEYWORD: ('r', 442), 'enum': ('r', 442), 'typename': ('r', 442), 'class': ('r', 442), '=': ('r', 442), '>': ('r', 442), IDENTIFIER: ('r', 442), 'auto': ('r', 442), '[': ('s', 1030), '...': ('r', 442), 'const': ('r', 442), '::': ('r', 442)}, 231),
        #STATE 232
        State([("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 53), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 80)], {',': ('r', 23), '|=': ('r', 23), ')': ('r', 23), '||': ('r', 23), '>>=': ('r', 23), '&&': ('r', 23), '|': ('r', 23), '}': ('r', 23), '>': ('r', 23), '?': ('r', 23), '&=': ('r', 23), ':': ('r', 23), ';': ('r', 23), '...': ('r', 23), '^=': ('r', 23), '%=': ('r', 23), '=': ('r', 23), '/=': ('r', 23), '*=': ('r', 23), ']': ('r', 23), '^': ('s', 233), '<<=': ('r', 23), '-=': ('r', 23), '+=': ('r', 23)}, 232),
        #STATE 233
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 57), ('unqualified_id -> conversion_function_id!', 18), ("postfix_expression -> postfix_expression:v '--'", 22), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('pm_expression -> cast_expression!', 17), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 579), qualified_id: ('g', 4), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), '::': ('s', 64), new_expression: ('g', 94), nested_name_specifier: ('g', 95), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 233),
        #STATE 234
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 62), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {named_type_specifier: ('g', 126), template_name: ('g', 2), IDENTIFIER: ('s', 29), '::': ('s', 191), raw_type_descriptor: ('g', 54), template_id: ('g', 18), nested_name_specifier: ('g', 189), type_name: ('g', 98), 'union': ('s', 97), type_descriptor: ('g', 240), elaborated_type_specifier: ('g', 109), enum_specifier: ('g', 122), class_name: ('g', 11), TYPE_KEYWORD: ('s', 162), cv_qualifier: ('g', 106), class_head: ('g', 20), class_key: ('g', 78), _80: ('g', 112), class_specifier: ('g', 75), 'class': ('s', 115), type_id: ('g', 746), 'typename': ('s', 166), namespace_name: ('g', 5), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), _81: ('g', 88), 'enum': ('s', 117), 'auto': ('s', 90)}, 234),
        #STATE 235
        State([("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 58), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 49)], {',': ('r', 541), '=': ('s', 409), '>': ('r', 541)}, 235),
        #STATE 236
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 98), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63)], {',': ('r', 27), '::': ('s', 237), '{': ('r', 27)}, 236),
        #STATE 237
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 67), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 60), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 68), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), '~': ('r', 381), namespace_name: ('g', 5), IDENTIFIER: ('c', [('s', 414), ('r', 381)]), '*': ('r', 381), nested_name_specifier: ('g', 803), 'template': ('c', [('s', 678), ('r', 381)]), 'operator': ('r', 381), class_name: ('g', 11), template_id: ('g', 44)}, 237),
        #STATE 238
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 100), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63)], {',': ('r', 28), '::': ('s', 237), '{': ('r', 28)}, 238),
        #STATE 239
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 62), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {template_name: ('g', 2), 'auto': ('s', 90), _80: ('g', 112), named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), template_id: ('g', 18), nested_name_specifier: ('g', 189), type_name: ('g', 98), 'union': ('s', 97), elaborated_type_specifier: ('g', 109), IDENTIFIER: ('s', 29), class_specifier: ('g', 75), class_name: ('g', 11), '::': ('s', 191), cv_qualifier: ('g', 106), class_head: ('g', 20), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), _81: ('g', 88), 'class': ('s', 115), type_id: ('g', 241), 'typename': ('s', 166), namespace_name: ('g', 5), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), type_descriptor: ('g', 240), enum_specifier: ('g', 122)}, 239),
        #STATE 240
        State([('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ('class_name -> template_id!', 14), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('type_id -> type_descriptor:type abstract_declarator:d?', 32), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('abstract_declarator -> direct_abstract_declarator!', 23), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ('type_id -> type_descriptor:type abstract_declarator:d?', 26), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ('class_name -> IDENTIFIER:name', 14), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("ptr_operator -> '&'", 16), ("direct_abstract_declarator -> '(' abstract_declarator! ')'", 30), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60)], {',': ('r', 416), template_name: ('g', 2), '(': ('s', 222), '::': ('c', [('s', 435), ('r', 416)]), '*': ('s', 223), 'union': ('r', 416), nested_name_specifier: ('g', 437), '&': ('s', 225), 'volatile': ('r', 416), '>': ('r', 416), IDENTIFIER: ('c', [('s', 414), ('r', 416)]), 'const': ('r', 416), ptr_operator: ('g', 229), ')': ('r', 416), namespace_name: ('g', 5), TYPE_KEYWORD: ('r', 416), 'enum': ('r', 416), class_name: ('g', 11), 'class': ('r', 416), 'typename': ('r', 416), abstract_declarator: ('g', 1002), 'struct': ('r', 416), '[': ('s', 226), direct_abstract_declarator: ('g', 231), template_id: ('g', 44), 'auto': ('r', 416)}, 240),
        #STATE 241
        State([("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 69)], {',': ('r', 180), '>': ('r', 180)}, 241),
        #STATE 242
        State([("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 76)], {'-': ('r', 30), '++': ('r', 30), '(': ('r', 30), '*': ('r', 30), '+': ('r', 30), 'delete': ('r', 30), 'static_cast': ('r', 30), 'virtual': ('r', 30), '!': ('r', 30), IDENTIFIER: ('r', 30), 'while': ('r', 30), INTEGER_LITERAL: ('r', 30), 'extern': ('r', 30), 'default': ('r', 30), 'goto': ('r', 30), 'new': ('r', 30), 'class': ('r', 30), 'typedef': ('r', 30), '--': ('r', 30), 'asm': ('r', 30), 'dynamic_cast': ('r', 30), 'for': ('r', 30), 'continue': ('r', 30), 'struct': ('r', 30), 'volatile': ('r', 30), 'namespace': ('r', 30), '&': ('r', 30), 'if': ('r', 30), 'union': ('r', 30), 'const_cast': ('r', 30), '::': ('r', 30), 'auto': ('r', 30), 'using': ('r', 30), 'do': ('r', 30), 'case': ('r', 30), '}': ('r', 30), '~': ('r', 30), 'return': ('r', 30), DECLARE_KEYWORD: ('r', 30), '{': ('r', 30), 'this': ('r', 30), TYPE_KEYWORD: ('r', 30), FLOATING_LITERAL: ('r', 30), 'sizeof': ('r', 30), 'else': ('r', 30), CHARACTER_LITERAL: ('r', 30), 'try': ('r', 30), 'reinterpret_cast': ('r', 30), BOOLEAN_LITERAL: ('r', 30), 'enum': ('r', 30), STRING_LITERAL: ('r', 30), 'throw': ('r', 30), 'typename': ('r', 30), 'break': ('r', 30), 'operator': ('r', 30), CPP_ERROR: ('r', 30), 'const': ('r', 30), 'switch': ('r', 30), 'typeid': ('r', 30)}, 242),
        #STATE 243
        State([("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 60)], {'(': ('r', 330)}, 243),
        #STATE 244
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 33), ('access_specifier -> ACCESS_KEYWORD!', 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ('member_cd_declarator -> cd_declarator:d pure_specifier', 24), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('member_specification -> member_declaration', 24), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 42), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("member_declaration -> function_definition! ';'?", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("member_specification -> access_specifier:access ':'", 24), ('function_definition -> function_head:head function_try_block:tryb', 23), ('namespace_name -> IDENTIFIER:name', 18), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 22), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("raw_type_descriptor -> 'auto'", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("cv_qualifier -> 'const'!", 16), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 33), ('raw_type_descriptor -> enum_specifier!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("class_key -> 'class' | 'struct' | 'union'", 23), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('type_name -> template_id!', 13), ('member_cd_declarator -> cd_declarator', 24), ("member_declaration -> elaborated_type_specifier! ';'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 36), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 64), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ('member_declaration -> template_declaration', 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ('member_declaration -> using_declaration', 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("member_declaration -> function_definition! ';'?", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_name -> template_id!', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("decl_attrib -> 'typedef'!", 15), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('raw_type_descriptor -> named_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("decl_attrib -> 'extern'!", 15), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ('type_descriptor -> raw_type_descriptor!', 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), named_type_specifier: ('g', 126), _114: ('g', 254), function_definition: ('g', 246), 'virtual': ('s', 130), _73: ('g', 247), elaborated_type_specifier: ('g', 248), IDENTIFIER: ('s', 29), 'typedef': ('s', 136), class_name: ('g', 11), _80: ('g', 112), class_specifier: ('g', 75), 'extern': ('s', 249), class_head: ('g', 20), class_key: ('g', 78), 'export': ('s', 143), member_specification: ('g', 250), _81: ('g', 88), type_name: ('g', 131), member_declaration: ('g', 251), member_cd_declarator: ('g', 252), 'struct': ('s', 58), 'volatile': ('s', 33), 'auto': ('s', 90), using_declaration: ('g', 245), '::': ('s', 255), namespace_name: ('g', 5), 'using': ('s', 256), nested_name_specifier: ('g', 257), ACCESS_KEYWORD: ('s', 258), access_specifier: ('g', 259), 'union': ('s', 97), function_head: ('g', 150), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), 'operator': ('s', 168), template_name: ('g', 2), cv_qualifier: ('g', 106), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), '}': ('s', 260), cd_declarator: ('g', 261), 'enum': ('s', 117), cd_id: ('g', 164), type_descriptor: ('g', 263), 'class': ('s', 115), template_declaration: ('g', 262), 'typename': ('s', 166), 'template': ('s', 253), template_id: ('g', 18), enum_specifier: ('g', 122)}, 244),
        #STATE 245
        State([('member_declaration -> using_declaration', 39)], {'union': ('r', 55), '::': ('r', 55), 'export': ('r', 55), 'using': ('r', 55), 'virtual': ('r', 55), DECLARE_KEYWORD: ('r', 55), 'const': ('r', 55), '}': ('r', 55), '~': ('r', 55), IDENTIFIER: ('r', 55), 'operator': ('r', 55), 'typedef': ('r', 55), 'extern': ('r', 55), TYPE_KEYWORD: ('r', 55), ACCESS_KEYWORD: ('r', 55), 'enum': ('r', 55), 'class': ('r', 55), 'typename': ('r', 55), 'struct': ('r', 55), 'volatile': ('r', 55), 'template': ('r', 55), 'auto': ('r', 55)}, 245),
        #STATE 246
        State([("member_declaration -> function_definition! ';'?", 43), ("member_declaration -> function_definition! ';'?", 41)], {'union': ('r', 426), '::': ('r', 426), 'export': ('r', 426), 'using': ('r', 426), 'virtual': ('r', 426), DECLARE_KEYWORD: ('r', 426), 'const': ('r', 426), '}': ('r', 426), '~': ('r', 426), IDENTIFIER: ('r', 426), ';': ('s', 838), 'extern': ('r', 426), 'operator': ('r', 426), 'typedef': ('r', 426), TYPE_KEYWORD: ('r', 426), ACCESS_KEYWORD: ('r', 426), 'enum': ('r', 426), 'class': ('r', 426), 'typename': ('r', 426), 'struct': ('r', 426), 'volatile': ('r', 426), 'template': ('r', 426), 'auto': ('r', 426)}, 246),
        #STATE 247
        State([('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 42), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("cv_qualifier -> 'volatile'!", 16), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ('member_cd_declarator -> cd_declarator:d pure_specifier', 24), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 42), ("decl_attrib -> 'typedef'!", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ('type_name -> IDENTIFIER:name', 13), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('member_cd_declarator -> cd_declarator', 24), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("decl_attrib -> 'virtual'!", 15), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("decl_attrib -> 'extern'!", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ('class_head -> class_key:t base_clause:bases?', 14), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 42), ('type_descriptor -> raw_type_descriptor!', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 266), _114: ('g', 703), named_type_specifier: ('g', 126), 'struct': ('s', 58), raw_type_descriptor: ('g', 54), nested_name_specifier: ('g', 155), 'virtual': ('s', 130), type_name: ('g', 131), 'union': ('s', 97), DECLARE_KEYWORD: ('s', 160), elaborated_type_specifier: ('g', 109), '~': ('s', 159), cv_qualifier: ('g', 106), IDENTIFIER: ('s', 29), 'operator': ('s', 168), template_name: ('g', 2), 'extern': ('s', 249), class_name: ('g', 11), _80: ('g', 112), class_specifier: ('g', 75), 'typedef': ('s', 136), class_head: ('g', 20), conversion_function_id: ('g', 158), cd_declarator: ('g', 634), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), cd_id: ('g', 164), _81: ('g', 88), 'class': ('s', 115), 'typename': ('s', 166), namespace_name: ('g', 5), '::': ('s', 153), member_cd_declarator: ('g', 252), 'auto': ('s', 90), 'volatile': ('s', 33), type_descriptor: ('g', 1025), 'const': ('s', 35), template_id: ('g', 18), class_key: ('g', 78), enum_specifier: ('g', 122)}, 247),
        #STATE 248
        State([('raw_type_descriptor -> elaborated_type_specifier!', 48), ("member_declaration -> elaborated_type_specifier! ';'", 49)], {'~': ('r', 223), '(': ('r', 223), '::': ('r', 223), '*': ('r', 223), ';': ('c', [('s', 1001), ('r', 223)]), ':': ('r', 223), '&': ('r', 223), 'operator': ('r', 223), IDENTIFIER: ('r', 223)}, 248),
        #STATE 249
        State([("decl_attrib -> 'extern'!", 23)], {'union': ('r', 52), 'auto': ('r', 52), 'typedef': ('r', 52), '::': ('r', 52), 'typename': ('r', 52), 'volatile': ('r', 52), 'virtual': ('r', 52), 'enum': ('r', 52), DECLARE_KEYWORD: ('r', 52), 'class': ('r', 52), '~': ('r', 52), IDENTIFIER: ('r', 52), 'struct': ('r', 52), 'operator': ('r', 52), 'const': ('r', 52), 'extern': ('r', 52), TYPE_KEYWORD: ('r', 52)}, 249),
        #STATE 250
        State([("class_specifier -> class_head!! '{' member_specification!*:body '}'", 56)], {'union': ('r', 303), '::': ('r', 303), 'export': ('r', 303), 'using': ('r', 303), 'virtual': ('r', 303), DECLARE_KEYWORD: ('r', 303), '}': ('r', 303), '~': ('r', 303), IDENTIFIER: ('r', 303), 'operator': ('r', 303), 'extern': ('r', 303), 'typedef': ('r', 303), TYPE_KEYWORD: ('r', 303), ACCESS_KEYWORD: ('r', 303), 'enum': ('r', 303), 'class': ('r', 303), 'typename': ('r', 303), 'struct': ('r', 303), 'volatile': ('r', 303), 'template': ('r', 303), 'const': ('r', 303), 'auto': ('r', 303)}, 250),
        #STATE 251
        State([('member_specification -> member_declaration', 42)], {'union': ('r', 46), '::': ('r', 46), 'export': ('r', 46), 'using': ('r', 46), 'virtual': ('r', 46), DECLARE_KEYWORD: ('r', 46), '}': ('r', 46), '~': ('r', 46), IDENTIFIER: ('r', 46), 'operator': ('r', 46), 'typedef': ('r', 46), 'extern': ('r', 46), TYPE_KEYWORD: ('r', 46), ACCESS_KEYWORD: ('r', 46), 'enum': ('r', 46), 'class': ('r', 46), 'typename': ('r', 46), 'struct': ('r', 46), 'volatile': ('r', 46), 'template': ('r', 46), 'const': ('r', 46), 'auto': ('r', 46)}, 251),
        #STATE 252
        State([("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 62)], {',': ('r', 552), ';': ('r', 552)}, 252),
        #STATE 253
        State([("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 49)], {'<': ('s', 716)}, 253),
        #STATE 254
        State([("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 74), None], {',': ('s', 704), ';': ('s', 669)}, 254),
        #STATE 255
        State([('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 33), ('class_name -> template_id!', 14), ('type_name -> template_id!', 13), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 33), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('class_name -> IDENTIFIER:name', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('template_name -> IDENTIFIER!', 17), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), '~': ('s', 218), IDENTIFIER: ('s', 29), conversion_function_id: ('g', 219), namespace_name: ('g', 5), nested_name_specifier: ('g', 1066), 'operator': ('s', 168), class_name: ('g', 11), type_name: ('g', 931), template_id: ('g', 18)}, 255),
        #STATE 256
        State([("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 44), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 29), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), 'typename': ('s', 647), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), template_id: ('g', 44), nested_name_specifier: ('g', 397), class_name: ('g', 11), '::': ('s', 649)}, 256),
        #STATE 257
        State([('type_name -> IDENTIFIER:name', 13), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 59), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('unqualified_id -> IDENTIFIER:id', 18), ('unqualified_id -> operator_function_id!', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('unqualified_id -> conversion_function_id!', 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ('template_name -> IDENTIFIER!', 17), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 73), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("unqualified_id -> '~' class_name:name", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {operator_function_id: ('g', 6), template_name: ('g', 2), '~': ('s', 627), IDENTIFIER: ('s', 423), conversion_function_id: ('g', 628), unqualified_id: ('g', 382), 'template': ('s', 594), 'operator': ('s', 8), type_name: ('g', 630), template_id: ('g', 26)}, 257),
        #STATE 258
        State([('access_specifier -> ACCESS_KEYWORD!', 34)], {'virtual': ('r', 315), IDENTIFIER: ('r', 315), ':': ('r', 315), '::': ('r', 315)}, 258),
        #STATE 259
        State([("member_specification -> access_specifier:access ':'", 48)], {':': ('s', 967)}, 259),
        #STATE 260
        State([("class_specifier -> class_head!! '{' member_specification!*:body '}'", 67)], {',': ('r', 361), '-': ('r', 361), '.': ('r', 361), '/': ('r', 361), '|=': ('r', 361), ')': ('r', 361), '*': ('r', 361), '+': ('r', 361), '%': ('r', 361), '&': ('r', 361), '{': ('r', 361), '<': ('r', 361), '=': ('r', 361), '>': ('r', 361), '?': ('r', 361), IDENTIFIER: ('r', 361), ':': ('r', 361), ';': ('r', 361), '...': ('r', 361), '(': ('r', 361), '^=': ('r', 361), '::': ('r', 361), '!=': ('r', 361), '--': ('r', 361), '/=': ('r', 361), '++': ('r', 361), '^': ('r', 361), '<<=': ('r', 361), '->': ('r', 361), 'struct': ('r', 361), '-=': ('r', 361), '%=': ('r', 361), '+=': ('r', 361), '>=': ('r', 361), 'union': ('r', 361), '<=': ('r', 361), '<<': ('r', 361), 'auto': ('r', 361), '||': ('r', 361), '>>=': ('r', 361), '&&': ('r', 361), 'const': ('r', 361), '|': ('r', 361), '}': ('r', 361), '~': ('r', 361), 'volatile': ('r', 361), '&=': ('r', 361), 'operator': ('r', 361), '->*': ('r', 361), TYPE_KEYWORD: ('r', 361), 'try': ('r', 361), 'enum': ('r', 361), '>>': ('r', 361), 'class': ('r', 361), ']': ('r', 361), 'typename': ('r', 361), '==': ('r', 361), '*=': ('r', 361), '[': ('r', 361), '.*': ('r', 361)}, 260),
        #STATE 261
        State([('member_cd_declarator -> cd_declarator:d pure_specifier', 40), ("pure_specifier -> '=' INTEGER_LITERAL:i", 18), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 50), ('member_cd_declarator -> cd_declarator', 37)], {',': ('r', 32), '=': ('s', 264), 'try': ('r', 31), ':': ('r', 31), '{': ('r', 31), ';': ('r', 32), pure_specifier: ('g', 265)}, 261),
        #STATE 262
        State([('member_declaration -> template_declaration', 42)], {'union': ('r', 334), '::': ('r', 334), 'export': ('r', 334), 'using': ('r', 334), 'virtual': ('r', 334), DECLARE_KEYWORD: ('r', 334), 'const': ('r', 334), '}': ('r', 334), '~': ('r', 334), IDENTIFIER: ('r', 334), 'operator': ('r', 334), 'typedef': ('r', 334), 'extern': ('r', 334), TYPE_KEYWORD: ('r', 334), ACCESS_KEYWORD: ('r', 334), 'enum': ('r', 334), 'class': ('r', 334), 'typename': ('r', 334), 'struct': ('r', 334), 'volatile': ('r', 334), 'template': ('r', 334), 'auto': ('r', 334)}, 262),
        #STATE 263
        State([('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('declarator_id -> id_expression!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 64), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 93), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ('unqualified_id -> operator_function_id!', 18), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('declarator -> direct_declarator!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("member_declarator -> IDENTIFIER:name? ':' constant_expression:size", 21), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 64), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ('unqualified_id -> conversion_function_id!', 18), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 58), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 64), ('id_expression -> unqualified_id!', 17), ('member_declarator -> declarator:d constant_initializer:init?', 21), ("qualified_id -> '::' IDENTIFIER!", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('id_expression -> qualified_id!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("direct_declarator -> '(' declarator! ')'", 21), ("member_declarator -> IDENTIFIER:name? ':' constant_expression:size", 38), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('member_declarator -> declarator:d constant_initializer:init?', 21), ('class_name -> IDENTIFIER:name', 14), ("operator_function_id -> 'operator' operator:op", 24), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("ptr_operator -> '&'", 16), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("unqualified_id -> '~' class_name:name", 18), ('direct_declarator -> declarator_id!', 21), ('template_name -> IDENTIFIER!', 17), ('member_declarator -> declarator:d pure_specifier', 21)], {template_name: ('g', 2), '(': ('s', 281), qualified_id: ('g', 4), '*': ('s', 223), unqualified_id: ('g', 7), nested_name_specifier: ('g', 284), '&': ('s', 225), ';': ('s', 797), conversion_function_id: ('g', 12), '~': ('s', 45), IDENTIFIER: ('s', 473), ':': ('s', 814), 'operator': ('s', 8), direct_declarator: ('g', 285), _113: ('g', 908), class_name: ('g', 11), '::': ('s', 282), id_expression: ('g', 280), namespace_name: ('g', 5), declarator_id: ('g', 286), operator_function_id: ('g', 6), ptr_operator: ('g', 279), member_declarator: ('g', 954), template_id: ('g', 44), declarator: ('g', 952)}, 263),
        #STATE 264
        State([("pure_specifier -> '=' INTEGER_LITERAL:i", 22)], {INTEGER_LITERAL: ('s', 990)}, 264),
        #STATE 265
        State([('member_cd_declarator -> cd_declarator:d pure_specifier', 54)], {',': ('r', 345), ';': ('r', 345)}, 265),
        #STATE 266
        State([("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 33)], {'union': ('r', 33), 'auto': ('r', 33), 'extern': ('r', 33), '::': ('r', 33), 'typename': ('r', 33), 'volatile': ('r', 33), 'virtual': ('r', 33), 'enum': ('r', 33), DECLARE_KEYWORD: ('r', 33), 'class': ('r', 33), '~': ('r', 33), IDENTIFIER: ('r', 33), 'struct': ('r', 33), 'operator': ('r', 33), 'const': ('r', 33), 'typedef': ('r', 33), TYPE_KEYWORD: ('r', 33)}, 266),
        #STATE 267
        State([('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 80)], {'{': ('r', 34)}, 267),
        #STATE 268
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("operator_function_id -> 'operator' operator:op", 24), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('unqualified_id -> conversion_function_id!', 18), ("postfix_expression -> postfix_expression:v '--'", 22), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 50), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 1040), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), '&': ('s', 61), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), template_id: ('g', 18), nested_name_specifier: ('g', 95), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 268),
        #STATE 269
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("operator_function_id -> 'operator' operator:op", 24), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("equality_expression -> equality_expression:a '==' relational_expression:b", 50), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('unqualified_id -> conversion_function_id!', 18), ("postfix_expression -> postfix_expression:v '--'", 22), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 365), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), '&': ('s', 61), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), template_id: ('g', 18), nested_name_specifier: ('g', 95), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 269),
        #STATE 270
        State([("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 53)], {'...': ('r', 36), ',': ('r', 36), ')': ('r', 36)}, 270),
        #STATE 271
        State([("expression -> expression:a ',' assignment_expression:b", 27), ("primary_expression -> '(' expression! ')'", 38)], {',': ('s', 272), ')': ('s', 273)}, 271),
        #STATE 272
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("expression -> expression:a ',' assignment_expression:b", 31), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 997), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 272),
        #STATE 273
        State([("primary_expression -> '(' expression! ')'", 41)], {',': ('r', 470), '-': ('r', 470), '.': ('r', 470), '/': ('r', 470), '|=': ('r', 470), ')': ('r', 470), '*': ('r', 470), '+': ('r', 470), '%': ('r', 470), '&': ('r', 470), '<': ('r', 470), '=': ('r', 470), '>': ('r', 470), '?': ('r', 470), '<<': ('r', 470), ':': ('r', 470), ';': ('r', 470), '...': ('r', 470), '(': ('r', 470), '^=': ('r', 470), '%=': ('r', 470), '!=': ('r', 470), '--': ('r', 470), '/=': ('r', 470), '==': ('r', 470), '*=': ('r', 470), '<<=': ('r', 470), '->': ('r', 470), '-=': ('r', 470), '->*': ('r', 470), '+=': ('r', 470), '>=': ('r', 470), '<=': ('r', 470), '||': ('r', 470), '>>=': ('r', 470), '&&': ('r', 470), '|': ('r', 470), '}': ('r', 470), '&=': ('r', 470), '++': ('r', 470), '>>': ('r', 470), ']': ('r', 470), '^': ('r', 470), '[': ('r', 470), '.*': ('r', 470)}, 273),
        #STATE 274
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 97)], {'::': ('s', 275), ';': ('s', 276)}, 274),
        #STATE 275
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 67), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 68), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 60), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), '~': ('r', 260), namespace_name: ('g', 5), IDENTIFIER: ('c', [('s', 414), ('r', 260)]), '*': ('r', 260), nested_name_specifier: ('g', 820), 'template': ('c', [('s', 819), ('r', 260)]), 'operator': ('r', 260), class_name: ('g', 11), template_id: ('g', 44)}, 275),
        #STATE 276
        State([("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 100)], {'sizeof': ('r', 387), '-': ('r', 387), '++': ('r', 387), '(': ('r', 387), '*': ('r', 387), 'reinterpret_cast': ('r', 387), 'delete': ('r', 387), 'static_cast': ('r', 387), '{': ('r', 387), '!': ('r', 387), ACCESS_KEYWORD: ('r', 387), IDENTIFIER: ('r', 387), 'while': ('r', 387), INTEGER_LITERAL: ('r', 387), 'extern': ('r', 387), 'default': ('r', 387), 'goto': ('r', 387), 'new': ('r', 387), 'class': ('r', 387), 'typedef': ('r', 387), '--': ('r', 387), 'asm': ('r', 387), 'dynamic_cast': ('r', 387), 'for': ('r', 387), 'export': ('r', 387), '+': ('r', 387), 'struct': ('r', 387), 'volatile': ('r', 387), 'template': ('r', 387), 'continue': ('r', 387), '&': ('r', 387), 'this': ('r', 387), 'if': ('r', 387), 'union': ('r', 387), 'virtual': ('r', 387), 'const_cast': ('r', 387), '::': ('r', 387), 'auto': ('r', 387), 'using': ('r', 387), 'namespace': ('r', 387), 'do': ('r', 387), DECLARE_KEYWORD: ('r', 387), '}': ('r', 387), '~': ('r', 387), 'return': ('r', 387), 'operator': ('r', 387), 'case': ('r', 387), TYPE_KEYWORD: ('r', 387), FLOATING_LITERAL: ('r', 387), CPP_ERROR: ('r', 387), 'else': ('r', 387), CHARACTER_LITERAL: ('r', 387), 'try': ('r', 387), BOOLEAN_LITERAL: ('r', 387), 'enum': ('r', 387), EOF: ('r', 387), STRING_LITERAL: ('r', 387), 'throw': ('r', 387), CPP_INCLUDE: ('r', 387), 'typename': ('r', 387), 'break': ('r', 387), 'const': ('r', 387), 'switch': ('r', 387), 'typeid': ('r', 387)}, 276),
        #STATE 277
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 137)], {',': ('r', 37), '-': ('r', 37), '.': ('r', 37), '/': ('r', 37), '|=': ('r', 37), ')': ('r', 37), '*': ('r', 37), '+': ('r', 37), '%': ('r', 37), '&': ('r', 37), '<': ('r', 37), '=': ('r', 37), '>': ('r', 37), '?': ('r', 37), '<<': ('r', 37), ':': ('r', 37), ';': ('r', 37), '...': ('r', 37), '(': ('r', 37), '^=': ('r', 37), '%=': ('r', 37), '!=': ('r', 37), '--': ('r', 37), '/=': ('r', 37), '==': ('r', 37), '*=': ('r', 37), '<<=': ('r', 37), '->': ('r', 37), '-=': ('r', 37), '->*': ('r', 37), '>>': ('r', 37), '>=': ('r', 37), '<=': ('r', 37), '||': ('r', 37), '>>=': ('r', 37), '&&': ('r', 37), '|': ('r', 37), '}': ('r', 37), '&=': ('r', 37), '++': ('r', 37), '+=': ('r', 37), ']': ('r', 37), '^': ('r', 37), '[': ('r', 37), '.*': ('r', 37)}, 277),
        #STATE 278
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 57), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('pm_expression -> cast_expression!', 17), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), '!': ('s', 104), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), class_name: ('g', 11), type_name: ('g', 98), literal: ('g', 84), 'dynamic_cast': ('s', 83), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), exclusive_or_expression: ('g', 232), nested_name_specifier: ('g', 95), new_expression: ('g', 94), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 278),
        #STATE 279
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('declarator -> direct_declarator!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('declarator -> ptr_operator:op declarator:d', 30), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('direct_declarator -> declarator_id!', 21), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('declarator_id -> id_expression!', 17), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("qualified_id -> '::' IDENTIFIER!", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('id_expression -> qualified_id!', 17), ('namespace_name -> IDENTIFIER:name', 18), ('unqualified_id -> IDENTIFIER:id', 18), ('unqualified_id -> operator_function_id!', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("operator_function_id -> 'operator' operator:op", 24), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('unqualified_id -> conversion_function_id!', 18), ("ptr_operator -> '&'", 16), ("unqualified_id -> '~' class_name:name", 18), ("direct_declarator -> '(' declarator! ')'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {ptr_operator: ('g', 279), template_name: ('g', 2), declarator: ('g', 283), declarator_id: ('g', 286), '(': ('s', 281), qualified_id: ('g', 4), '*': ('s', 223), namespace_name: ('g', 5), operator_function_id: ('g', 6), unqualified_id: ('g', 7), '&': ('s', 225), template_id: ('g', 44), conversion_function_id: ('g', 12), '~': ('s', 45), IDENTIFIER: ('s', 46), 'operator': ('s', 8), direct_declarator: ('g', 285), nested_name_specifier: ('g', 284), class_name: ('g', 11), id_expression: ('g', 280), '::': ('s', 282)}, 279),
        #STATE 280
        State([('declarator_id -> id_expression!', 30)], {',': ('r', 205), 'try': ('r', 205), '=': ('r', 205), '(': ('r', 205), ')': ('r', 205), ':': ('r', 205), '[': ('r', 205), '...': ('r', 205), ';': ('r', 205), '{': ('r', 205), '>': ('r', 205)}, 280),
        #STATE 281
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("direct_declarator -> '(' declarator! ')'", 25), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('declarator -> direct_declarator!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('direct_declarator -> declarator_id!', 21), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('declarator_id -> id_expression!', 17), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("qualified_id -> '::' IDENTIFIER!", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('id_expression -> qualified_id!', 17), ('namespace_name -> IDENTIFIER:name', 18), ('unqualified_id -> IDENTIFIER:id', 18), ('unqualified_id -> operator_function_id!', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("operator_function_id -> 'operator' operator:op", 24), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('unqualified_id -> conversion_function_id!', 18), ("ptr_operator -> '&'", 16), ("unqualified_id -> '~' class_name:name", 18), ("direct_declarator -> '(' declarator! ')'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {ptr_operator: ('g', 279), template_name: ('g', 2), declarator: ('g', 297), declarator_id: ('g', 286), '(': ('s', 281), qualified_id: ('g', 4), '*': ('s', 223), namespace_name: ('g', 5), operator_function_id: ('g', 6), unqualified_id: ('g', 7), '&': ('s', 225), template_id: ('g', 44), conversion_function_id: ('g', 12), '~': ('s', 45), IDENTIFIER: ('s', 46), 'operator': ('s', 8), direct_declarator: ('g', 285), nested_name_specifier: ('g', 284), class_name: ('g', 11), id_expression: ('g', 280), '::': ('s', 282)}, 281),
        #STATE 282
        State([('namespace_name -> IDENTIFIER:name', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("operator_function_id -> 'operator' operator:op", 24), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('class_name -> IDENTIFIER:name', 14), ("qualified_id -> '::' IDENTIFIER!", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('template_name -> IDENTIFIER!', 17), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 44), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), namespace_name: ('g', 5), IDENTIFIER: ('s', 617), nested_name_specifier: ('g', 957), operator_function_id: ('g', 376), 'operator': ('s', 619), class_name: ('g', 11), template_id: ('g', 620)}, 282),
        #STATE 283
        State([('declarator -> ptr_operator:op declarator:d', 40)], {',': ('r', 132), 'try': ('r', 132), '=': ('r', 132), '(': ('r', 132), ')': ('r', 132), ':': ('r', 132), ';': ('r', 132), '...': ('r', 132), '{': ('r', 132), '>': ('r', 132)}, 283),
        #STATE 284
        State([('unqualified_id -> operator_function_id!', 18), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53), ("operator_function_id -> 'operator' operator:op", 24), ('unqualified_id -> IDENTIFIER:id', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 53), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("unqualified_id -> '~' class_name:name", 18), ('unqualified_id -> conversion_function_id!', 18), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53)], {unqualified_id: ('g', 326), '~': ('s', 45), IDENTIFIER: ('s', 314), '*': ('s', 290), conversion_function_id: ('g', 12), 'template': ('s', 327), operator_function_id: ('g', 6), 'operator': ('s', 8)}, 284),
        #STATE 285
        State([("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 41), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 41), ('declarator -> direct_declarator!', 31), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 41), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 41), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 41), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 41)], {',': ('r', 388), 'try': ('r', 388), '=': ('r', 388), ';': ('r', 388), '(': ('c', [('s', 790), ('r', 388)]), ')': ('r', 388), ':': ('r', 388), '[': ('s', 773), '...': ('r', 388), '{': ('r', 388), '>': ('r', 388)}, 285),
        #STATE 286
        State([('direct_declarator -> declarator_id!', 34)], {',': ('r', 419), 'try': ('r', 419), '=': ('r', 419), '(': ('r', 419), ')': ('r', 419), ':': ('r', 419), '[': ('r', 419), '...': ('r', 419), ';': ('r', 419), '{': ('r', 419), '>': ('r', 419)}, 286),
        #STATE 287
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 40), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {template_name: ('g', 2), 'auto': ('s', 90), _80: ('g', 112), named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), template_id: ('g', 18), nested_name_specifier: ('g', 189), type_name: ('g', 98), 'union': ('s', 97), elaborated_type_specifier: ('g', 109), IDENTIFIER: ('s', 29), class_specifier: ('g', 75), class_name: ('g', 11), '::': ('s', 191), cv_qualifier: ('g', 106), class_head: ('g', 20), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), _81: ('g', 88), 'class': ('s', 115), type_id: ('g', 288), 'typename': ('s', 166), namespace_name: ('g', 5), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), type_descriptor: ('g', 240), enum_specifier: ('g', 122)}, 287),
        #STATE 288
        State([("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 50)], {'>': ('s', 726)}, 288),
        #STATE 289
        State([("unqualified_id -> '~' class_name:name", 32)], {',': ('r', 556), '-': ('r', 556), '.': ('r', 556), '/': ('r', 556), '(': ('r', 556), ')': ('r', 556), '*': ('r', 556), '+': ('r', 556), '%': ('r', 556), '&': ('r', 556), '<': ('r', 556), '=': ('r', 556), '>': ('r', 556), '?': ('r', 556), '<<': ('r', 556), ':': ('r', 556), ';': ('r', 556), '...': ('r', 556), '|=': ('r', 556), '^=': ('r', 556), '%=': ('r', 556), '!=': ('r', 556), '--': ('r', 556), '/=': ('r', 556), '++': ('r', 556), '^': ('r', 556), '<<=': ('r', 556), '->': ('r', 556), '-=': ('r', 556), '->*': ('r', 556), '>>': ('r', 556), '>=': ('r', 556), '<=': ('r', 556), '||': ('r', 556), '>>=': ('r', 556), '&&': ('r', 556), '|': ('r', 556), '}': ('r', 556), '&=': ('r', 556), '{': ('r', 556), 'try': ('r', 556), '+=': ('r', 556), ']': ('r', 556), '*=': ('r', 556), '==': ('r', 556), '[': ('r', 556), '.*': ('r', 556)}, 289),
        #STATE 290
        State([('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 56), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cv_qualifier -> 'const'!", 16), ("cv_qualifier -> 'volatile'!", 16)], {',': ('r', 120), '-': ('r', 120), '.': ('r', 120), '/': ('r', 120), '|=': ('r', 120), _80: ('g', 543), '*': ('r', 120), '+': ('r', 120), '%': ('r', 120), '&': ('r', 120), 'operator': ('r', 120), '<': ('r', 120), '=': ('r', 120), '>': ('r', 120), '?': ('r', 120), IDENTIFIER: ('r', 120), ':': ('r', 120), ';': ('r', 120), '...': ('r', 120), '(': ('r', 120), '^=': ('r', 120), '<<': ('r', 120), '^': ('r', 120), '!=': ('r', 120), '--': ('r', 120), '/=': ('r', 120), '++': ('r', 120), '*=': ('r', 120), '<<=': ('r', 120), '%=': ('r', 120), '-=': ('r', 120), 'auto': ('r', 120), 'volatile': ('c', [('s', 33), ('r', 120)]), '->': ('r', 120), '->*': ('r', 120), '>>': ('r', 120), '>=': ('r', 120), 'union': ('r', 120), '<=': ('r', 120), '::': ('r', 120), '||': ('r', 120), '>>=': ('r', 120), ')': ('r', 120), '&&': ('r', 120), '|': ('r', 120), '}': ('r', 120), '~': ('r', 120), '&=': ('r', 120), '{': ('r', 120), '.*': ('r', 120), cv_qualifier: ('g', 106), TYPE_KEYWORD: ('r', 120), 'try': ('r', 120), 'struct': ('r', 120), 'enum': ('r', 120), '+=': ('r', 120), 'class': ('r', 120), ']': ('r', 120), 'typename': ('r', 120), '==': ('r', 120), '[': ('r', 120), 'const': ('c', [('s', 35), ('r', 120)])}, 290),
        #STATE 291
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 72), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), template_id: ('g', 492), IDENTIFIER: ('s', 216)}, 291),
        #STATE 292
        State([("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 71)], {',': ('r', 82), '-': ('r', 82), '.': ('r', 82), '/': ('r', 82), '|=': ('r', 82), ')': ('r', 82), '*': ('r', 82), '+': ('r', 82), '%': ('r', 82), '&': ('r', 82), 'operator': ('r', 82), '<': ('r', 82), '=': ('r', 82), '>': ('r', 82), '?': ('r', 82), IDENTIFIER: ('r', 82), ':': ('r', 82), ';': ('r', 82), '...': ('r', 82), '(': ('r', 82), '^=': ('r', 82), '::': ('r', 82), '^': ('r', 82), '!=': ('r', 82), '--': ('r', 82), '/=': ('r', 82), '++': ('r', 82), '*=': ('r', 82), '<<=': ('r', 82), '->': ('r', 82), '-=': ('r', 82), 'auto': ('r', 82), 'volatile': ('r', 82), '%=': ('r', 82), '>>': ('r', 82), '>=': ('r', 82), 'union': ('r', 82), '<=': ('r', 82), '<<': ('r', 82), '||': ('r', 82), '>>=': ('r', 82), '&&': ('r', 82), '|': ('r', 82), '}': ('r', 82), '~': ('r', 82), '&=': ('r', 82), '{': ('r', 82), '.*': ('r', 82), 'struct': ('r', 82), '->*': ('r', 82), TYPE_KEYWORD: ('r', 82), 'try': ('r', 82), 'enum': ('r', 82), '+=': ('r', 82), 'class': ('r', 82), ']': ('r', 82), 'typename': ('r', 82), '==': ('r', 82), '[': ('r', 82), 'const': ('r', 82)}, 292),
        #STATE 293
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82)], {template_name: ('g', 2), template_id: ('g', 294), IDENTIFIER: ('s', 216)}, 293),
        #STATE 294
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97)], {'(': ('s', 500)}, 294),
        #STATE 295
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 85)], {',': ('r', 40), '-': ('r', 40), '/': ('r', 40), '|=': ('r', 40), ')': ('r', 40), '*': ('r', 40), '+': ('r', 40), '%': ('r', 40), '&': ('r', 40), '>>=': ('r', 40), '&&': ('r', 40), '<': ('r', 40), '=': ('r', 40), '>': ('r', 40), '?': ('r', 40), '<<': ('r', 40), ':': ('r', 40), ';': ('r', 40), '...': ('r', 40), '<=': ('r', 40), '^=': ('r', 40), '%=': ('r', 40), '|': ('r', 40), '!=': ('r', 40), '}': ('r', 40), '/=': ('r', 40), '==': ('r', 40), '||': ('r', 40), '*=': ('r', 40), '&=': ('r', 40), '+=': ('r', 40), ']': ('r', 40), '^': ('r', 40), '<<=': ('r', 40), '-=': ('r', 40), '.*': ('r', 40), '->*': ('r', 40), '>>': ('r', 40), '>=': ('r', 40)}, 295),
        #STATE 296
        State([("postfix_expression -> postfix_expression:v '[' expression:i ']'", 63)], {',': ('r', 184), '-': ('r', 184), '.': ('r', 184), '/': ('r', 184), '|=': ('r', 184), ')': ('r', 184), '*': ('r', 184), '+': ('r', 184), '%': ('r', 184), '&': ('r', 184), '<': ('r', 184), '=': ('r', 184), '>': ('r', 184), '?': ('r', 184), '<<': ('r', 184), ':': ('r', 184), ';': ('r', 184), '...': ('r', 184), '(': ('r', 184), '^=': ('r', 184), '%=': ('r', 184), '!=': ('r', 184), '--': ('r', 184), '/=': ('r', 184), '++': ('r', 184), '*=': ('r', 184), '<<=': ('r', 184), '->': ('r', 184), '-=': ('r', 184), '->*': ('r', 184), '>>': ('r', 184), '>=': ('r', 184), '<=': ('r', 184), '||': ('r', 184), '>>=': ('r', 184), '&&': ('r', 184), '|': ('r', 184), '}': ('r', 184), '&=': ('r', 184), '+=': ('r', 184), ']': ('r', 184), '^': ('r', 184), '==': ('r', 184), '[': ('r', 184), '.*': ('r', 184)}, 296),
        #STATE 297
        State([("direct_declarator -> '(' declarator! ')'", 37)], {')': ('s', 298)}, 297),
        #STATE 298
        State([("direct_declarator -> '(' declarator! ')'", 40)], {',': ('r', 423), 'try': ('r', 423), '=': ('r', 423), '(': ('r', 423), ')': ('r', 423), ':': ('r', 423), ';': ('r', 423), '...': ('r', 423), '[': ('r', 423), '{': ('r', 423), '>': ('r', 423)}, 298),
        #STATE 299
        State([("new_initializer -> '(' assignment_expression!*,','! ')'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 74), ("new_initializer -> '(' assignment_expression!*,','! ')'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 73)], {',': ('r', 41), '-': ('r', 41), '/': ('r', 41), '(': ('s', 300), ')': ('r', 41), '*': ('r', 41), '==': ('r', 41), '%': ('r', 41), '&': ('r', 41), '>>=': ('r', 41), '&&': ('r', 41), '>>': ('r', 41), '<': ('r', 41), '=': ('r', 41), '>': ('r', 41), '?': ('r', 41), '<=': ('r', 41), ':': ('r', 41), ';': ('r', 41), '...': ('r', 41), '|=': ('r', 41), '^=': ('r', 41), '%=': ('r', 41), '|': ('r', 41), '!=': ('r', 41), '}': ('r', 41), '/=': ('r', 41), '+': ('r', 41), '||': ('r', 41), '*=': ('r', 41), '&=': ('r', 41), '<<': ('r', 41), ']': ('r', 41), '^': ('r', 41), '<<=': ('r', 41), new_initializer: ('g', 301), '-=': ('r', 41), '.*': ('r', 41), '->*': ('r', 41), '+=': ('r', 41), '>=': ('r', 41)}, 299),
        #STATE 300
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("new_initializer -> '(' assignment_expression!*,','! ')'", 52), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), ')': ('s', 974), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), _15: ('g', 694), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 323), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), named_type_specifier: ('g', 177), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 300),
        #STATE 301
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 89)], {',': ('r', 145), '-': ('r', 145), '/': ('r', 145), '|=': ('r', 145), ')': ('r', 145), '*': ('r', 145), '+': ('r', 145), '%': ('r', 145), '&': ('r', 145), '>>=': ('r', 145), '&&': ('r', 145), '<': ('r', 145), '=': ('r', 145), '>': ('r', 145), '?': ('r', 145), '<<': ('r', 145), ':': ('r', 145), ';': ('r', 145), '...': ('r', 145), '<=': ('r', 145), '^=': ('r', 145), '%=': ('r', 145), '|': ('r', 145), '!=': ('r', 145), '}': ('r', 145), '/=': ('r', 145), '==': ('r', 145), '||': ('r', 145), '*=': ('r', 145), '&=': ('r', 145), '>>': ('r', 145), ']': ('r', 145), '^': ('r', 145), '<<=': ('r', 145), '-=': ('r', 145), '.*': ('r', 145), '->*': ('r', 145), '+=': ('r', 145), '>=': ('r', 145)}, 301),
        #STATE 302
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 83), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), _15: ('g', 636), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 323), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), ')': ('s', 635), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'throw': ('s', 96), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 302),
        #STATE 303
        State([None, ("initializer -> '(' assignment_expression!+,',':args ')'", 52)], {',': ('s', 304), ')': ('s', 305)}, 303),
        #STATE 304
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 693), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 304),
        #STATE 305
        State([("initializer -> '(' assignment_expression!+,',':args ')'", 55)], {',': ('r', 411), ';': ('r', 411)}, 305),
        #STATE 306
        State([("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 60)], {'sizeof': ('r', 42), '-': ('r', 42), '++': ('r', 42), '(': ('r', 42), '*': ('r', 42), 'reinterpret_cast': ('r', 42), 'delete': ('r', 42), 'static_cast': ('r', 42), 'operator': ('r', 42), '!': ('r', 42), ACCESS_KEYWORD: ('r', 42), IDENTIFIER: ('r', 42), ';': ('r', 42), INTEGER_LITERAL: ('r', 42), 'typedef': ('r', 42), 'default': ('r', 42), 'goto': ('r', 42), 'new': ('r', 42), 'class': ('r', 42), 'extern': ('r', 42), '--': ('r', 42), 'asm': ('r', 42), 'dynamic_cast': ('r', 42), 'for': ('r', 42), 'export': ('r', 42), '+': ('r', 42), 'struct': ('r', 42), 'volatile': ('r', 42), 'template': ('r', 42), 'continue': ('r', 42), '&': ('r', 42), 'case': ('r', 42), 'if': ('r', 42), 'union': ('r', 42), 'virtual': ('r', 42), 'const_cast': ('r', 42), '::': ('r', 42), 'auto': ('r', 42), 'using': ('r', 42), 'namespace': ('r', 42), 'do': ('r', 42), DECLARE_KEYWORD: ('r', 42), '}': ('r', 42), '~': ('r', 42), 'return': ('r', 42), '{': ('r', 42), 'this': ('r', 42), TYPE_KEYWORD: ('r', 42), FLOATING_LITERAL: ('r', 42), CPP_ERROR: ('r', 42), 'else': ('r', 42), CHARACTER_LITERAL: ('r', 42), 'try': ('r', 42), BOOLEAN_LITERAL: ('r', 42), 'enum': ('r', 42), EOF: ('r', 42), STRING_LITERAL: ('r', 42), 'throw': ('r', 42), CPP_INCLUDE: ('r', 42), 'typename': ('r', 42), 'while': ('r', 42), 'break': ('r', 42), 'const': ('r', 42), 'switch': ('r', 42), 'typeid': ('r', 42)}, 306),
        #STATE 307
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 94)], {',': ('r', 43), '-': ('r', 43), '.': ('r', 43), '/': ('r', 43), '(': ('r', 43), ')': ('r', 43), '*': ('r', 43), '+': ('r', 43), '%': ('r', 43), '&': ('r', 43), '<': ('r', 43), '=': ('r', 43), '>': ('r', 43), '?': ('r', 43), '<<': ('r', 43), ':': ('r', 43), ';': ('r', 43), '...': ('r', 43), '|=': ('r', 43), '^=': ('r', 43), '%=': ('r', 43), '!=': ('r', 43), '--': ('r', 43), '/=': ('r', 43), '==': ('r', 43), '^': ('r', 43), '<<=': ('r', 43), '->': ('r', 43), '-=': ('r', 43), '->*': ('r', 43), '+=': ('r', 43), '>=': ('r', 43), '<=': ('r', 43), '||': ('r', 43), '>>=': ('r', 43), '&&': ('r', 43), '|': ('r', 43), '}': ('r', 43), '&=': ('r', 43), '++': ('r', 43), '>>': ('r', 43), ']': ('r', 43), '*=': ('r', 43), '[': ('r', 43), '.*': ('r', 43)}, 307),
        #STATE 308
        State([("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 51)], {'>': ('s', 309)}, 308),
        #STATE 309
        State([("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 55)], {'(': ('s', 526)}, 309),
        #STATE 310
        State([("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 50), ('conditional_expression -> logical_or_expression!', 47)], {',': ('r', 44), ']': ('r', 44), '?': ('s', 311), ':': ('r', 44), '}': ('r', 44), ';': ('r', 44)}, 310),
        #STATE 311
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 54), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), expression: ('g', 772), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 311),
        #STATE 312
        State([('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("operator_function_id -> 'operator' operator:op", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("unqualified_id -> '~' class_name:name", 18), ('unqualified_id -> conversion_function_id!', 18)], {unqualified_id: ('g', 313), '~': ('s', 45), IDENTIFIER: ('s', 314), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), 'operator': ('s', 8)}, 312),
        #STATE 313
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 81)], {',': ('r', 462), '-': ('r', 462), '.': ('r', 462), '/': ('r', 462), '|=': ('r', 462), ')': ('r', 462), '*': ('r', 462), '+': ('r', 462), '%': ('r', 462), '&': ('r', 462), '<': ('r', 462), '=': ('r', 462), '>': ('r', 462), '?': ('r', 462), '<<': ('r', 462), ':': ('r', 462), ';': ('r', 462), '...': ('r', 462), '(': ('r', 462), '^=': ('r', 462), '%=': ('r', 462), '!=': ('r', 462), '--': ('r', 462), '/=': ('r', 462), '++': ('r', 462), '^': ('r', 462), '<<=': ('r', 462), '->': ('r', 462), '-=': ('r', 462), '->*': ('r', 462), '+=': ('r', 462), '>=': ('r', 462), '<=': ('r', 462), '||': ('r', 462), '>>=': ('r', 462), '&&': ('r', 462), '|': ('r', 462), '}': ('r', 462), '&=': ('r', 462), '{': ('r', 462), 'try': ('r', 462), '>>': ('r', 462), ']': ('r', 462), '*=': ('r', 462), '==': ('r', 462), '[': ('r', 462), '.*': ('r', 462)}, 313),
        #STATE 314
        State([('unqualified_id -> IDENTIFIER:id', 28)], {',': ('r', 95), '-': ('r', 95), '.': ('r', 95), '/': ('r', 95), '(': ('r', 95), ')': ('r', 95), '*': ('r', 95), '+': ('r', 95), '%': ('r', 95), '&': ('r', 95), '<': ('r', 95), '=': ('r', 95), '>': ('r', 95), '?': ('r', 95), '<<': ('r', 95), ':': ('r', 95), ';': ('r', 95), '...': ('r', 95), '|=': ('r', 95), '^=': ('r', 95), '%=': ('r', 95), '!=': ('r', 95), '--': ('r', 95), '/=': ('r', 95), '++': ('r', 95), '^': ('r', 95), '<<=': ('r', 95), '->': ('r', 95), '-=': ('r', 95), '->*': ('r', 95), '+=': ('r', 95), '>=': ('r', 95), '<=': ('r', 95), '||': ('r', 95), '>>=': ('r', 95), '&&': ('r', 95), '|': ('r', 95), '}': ('r', 95), '&=': ('r', 95), '{': ('r', 95), 'try': ('r', 95), '>>': ('r', 95), ']': ('r', 95), '*=': ('r', 95), '==': ('r', 95), '[': ('r', 95), '.*': ('r', 95)}, 314),
        #STATE 315
        State([('type_name -> IDENTIFIER:name', 13), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_name -> template_id!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 51), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {type_name: ('g', 316), template_name: ('g', 2), IDENTIFIER: ('s', 24), template_id: ('g', 26)}, 315),
        #STATE 316
        State([("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 60)], {'(': ('r', 481)}, 316),
        #STATE 317
        State([("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 60)], {'(': ('r', 47)}, 317),
        #STATE 318
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("operator_function_id -> 'operator' operator:op", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('class_name -> template_id!', 14), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ('namespace_name -> IDENTIFIER:name', 18), ('unqualified_id -> IDENTIFIER:id', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 99), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> operator_function_id!', 18), ('id_expression -> qualified_id!', 17), ("qualified_id -> '::' IDENTIFIER!", 16), ('unqualified_id -> conversion_function_id!', 18), ("unqualified_id -> '~' class_name:name", 18), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {namespace_name: ('g', 5), qualified_id: ('g', 4), unqualified_id: ('g', 7), template_id: ('g', 44), operator_function_id: ('g', 6), class_name: ('g', 11), conversion_function_id: ('g', 12), '~': ('s', 45), IDENTIFIER: ('s', 46), 'operator': ('s', 8), template_name: ('g', 2), nested_name_specifier: ('g', 47), id_expression: ('g', 175), '::': ('s', 48)}, 318),
        #STATE 319
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 99)], {',': ('r', 49), '-': ('r', 49), '.': ('r', 49), '/': ('r', 49), '(': ('r', 49), ')': ('r', 49), '*': ('r', 49), '+': ('r', 49), '%': ('r', 49), '&': ('r', 49), '<': ('r', 49), '=': ('r', 49), '>': ('r', 49), '?': ('r', 49), '<<': ('r', 49), ':': ('r', 49), ';': ('r', 49), '...': ('r', 49), '|=': ('r', 49), '^=': ('r', 49), '%=': ('r', 49), '!=': ('r', 49), '--': ('r', 49), '/=': ('r', 49), '++': ('r', 49), '^': ('r', 49), '<<=': ('r', 49), '->': ('r', 49), '-=': ('r', 49), '->*': ('r', 49), '+=': ('r', 49), '>=': ('r', 49), '<=': ('r', 49), '||': ('r', 49), '>>=': ('r', 49), '&&': ('r', 49), '|': ('r', 49), '}': ('r', 49), '&=': ('r', 49), '{': ('r', 49), 'try': ('r', 49), '>>': ('r', 49), ']': ('r', 49), '*=': ('r', 49), '==': ('r', 49), '[': ('r', 49), '.*': ('r', 49)}, 319),
        #STATE 320
        State([("jump_statement -> 'return' expression:v? ';'", 44)], {'-': ('r', 50), 'asm': ('r', 50), '(': ('r', 50), '*': ('r', 50), '+': ('r', 50), 'delete': ('r', 50), 'static_cast': ('r', 50), 'virtual': ('r', 50), '!': ('r', 50), IDENTIFIER: ('r', 50), 'while': ('r', 50), INTEGER_LITERAL: ('r', 50), 'extern': ('r', 50), 'default': ('r', 50), 'goto': ('r', 50), 'break': ('r', 50), 'new': ('r', 50), 'throw': ('r', 50), 'typedef': ('r', 50), '--': ('r', 50), '++': ('r', 50), 'dynamic_cast': ('r', 50), 'for': ('r', 50), 'continue': ('r', 50), 'struct': ('r', 50), 'volatile': ('r', 50), 'namespace': ('r', 50), '&': ('r', 50), 'if': ('r', 50), 'union': ('r', 50), 'const_cast': ('r', 50), '::': ('r', 50), 'auto': ('r', 50), 'using': ('r', 50), 'do': ('r', 50), 'case': ('r', 50), 'try': ('r', 50), '~': ('r', 50), 'return': ('r', 50), DECLARE_KEYWORD: ('r', 50), '{': ('r', 50), 'this': ('r', 50), CHARACTER_LITERAL: ('r', 50), FLOATING_LITERAL: ('r', 50), 'sizeof': ('r', 50), 'else': ('r', 50), TYPE_KEYWORD: ('r', 50), '}': ('r', 50), 'reinterpret_cast': ('r', 50), BOOLEAN_LITERAL: ('r', 50), 'enum': ('r', 50), STRING_LITERAL: ('r', 50), 'class': ('r', 50), 'typename': ('r', 50), CPP_ERROR: ('r', 50), 'operator': ('r', 50), 'const': ('r', 50), 'switch': ('r', 50), 'typeid': ('r', 50)}, 320),
        #STATE 321
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 134), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), _15: ('g', 324), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 323), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), ')': ('s', 322), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'throw': ('s', 96), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 321),
        #STATE 322
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 137)], {',': ('r', 469), '-': ('r', 469), '.': ('r', 469), '/': ('r', 469), '(': ('r', 469), ')': ('r', 469), '*': ('r', 469), '+': ('r', 469), '%': ('r', 469), '&': ('r', 469), '<': ('r', 469), '=': ('r', 469), '>': ('r', 469), '?': ('r', 469), '<<': ('r', 469), ':': ('r', 469), ';': ('r', 469), '...': ('r', 469), '|=': ('r', 469), '^=': ('r', 469), '%=': ('r', 469), '!=': ('r', 469), '--': ('r', 469), '/=': ('r', 469), '==': ('r', 469), '*=': ('r', 469), '<<=': ('r', 469), '->': ('r', 469), '-=': ('r', 469), '->*': ('r', 469), '>>': ('r', 469), '>=': ('r', 469), '<=': ('r', 469), '||': ('r', 469), '>>=': ('r', 469), '&&': ('r', 469), '|': ('r', 469), '}': ('r', 469), '&=': ('r', 469), '++': ('r', 469), '+=': ('r', 469), ']': ('r', 469), '^': ('r', 469), '[': ('r', 469), '.*': ('r', 469)}, 322),
        #STATE 323
        State([("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 68)], {',': ('r', 397), ')': ('r', 397)}, 323),
        #STATE 324
        State([None, ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 134)], {',': ('s', 304), ')': ('s', 858)}, 324),
        #STATE 325
        State([("expression_statement -> expression:expr ';'", 43)], {'-': ('r', 51), '++': ('r', 51), '(': ('r', 51), '*': ('r', 51), '+': ('r', 51), 'delete': ('r', 51), 'static_cast': ('r', 51), 'virtual': ('r', 51), '!': ('r', 51), IDENTIFIER: ('r', 51), ';': ('r', 51), INTEGER_LITERAL: ('r', 51), 'extern': ('r', 51), 'default': ('r', 51), 'goto': ('r', 51), 'new': ('r', 51), 'class': ('r', 51), 'typedef': ('r', 51), '--': ('r', 51), 'asm': ('r', 51), 'dynamic_cast': ('r', 51), 'for': ('r', 51), 'continue': ('r', 51), 'struct': ('r', 51), 'volatile': ('r', 51), 'namespace': ('r', 51), '&': ('r', 51), 'if': ('r', 51), 'union': ('r', 51), 'const_cast': ('r', 51), '::': ('r', 51), 'auto': ('r', 51), 'using': ('r', 51), 'do': ('r', 51), 'this': ('r', 51), '}': ('r', 51), '~': ('r', 51), 'return': ('r', 51), DECLARE_KEYWORD: ('r', 51), '{': ('r', 51), 'case': ('r', 51), CHARACTER_LITERAL: ('r', 51), FLOATING_LITERAL: ('r', 51), 'sizeof': ('r', 51), 'else': ('r', 51), TYPE_KEYWORD: ('r', 51), 'try': ('r', 51), 'reinterpret_cast': ('r', 51), BOOLEAN_LITERAL: ('r', 51), 'enum': ('r', 51), STRING_LITERAL: ('r', 51), 'throw': ('r', 51), 'typename': ('r', 51), 'while': ('r', 51), 'break': ('r', 51), 'operator': ('r', 51), CPP_ERROR: ('r', 51), 'const': ('r', 51), 'switch': ('r', 51), 'typeid': ('r', 51)}, 325),
        #STATE 326
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 81)], {',': ('r', 57), '-': ('r', 57), '.': ('r', 57), '/': ('r', 57), '(': ('r', 57), ')': ('r', 57), '*': ('r', 57), '+': ('r', 57), '%': ('r', 57), '&': ('r', 57), '<': ('r', 57), '=': ('r', 57), '>': ('r', 57), '?': ('r', 57), '<<': ('r', 57), ':': ('r', 57), ';': ('r', 57), '...': ('r', 57), '|=': ('r', 57), '^=': ('r', 57), '%=': ('r', 57), '!=': ('r', 57), '--': ('r', 57), '/=': ('r', 57), '++': ('r', 57), '^': ('r', 57), '<<=': ('r', 57), '->': ('r', 57), '-=': ('r', 57), '->*': ('r', 57), '>>': ('r', 57), '>=': ('r', 57), '<=': ('r', 57), '||': ('r', 57), '>>=': ('r', 57), '&&': ('r', 57), '|': ('r', 57), '}': ('r', 57), '&=': ('r', 57), '{': ('r', 57), 'try': ('r', 57), '+=': ('r', 57), ']': ('r', 57), '*=': ('r', 57), '==': ('r', 57), '[': ('r', 57), '.*': ('r', 57)}, 326),
        #STATE 327
        State([('unqualified_id -> operator_function_id!', 18), ("operator_function_id -> 'operator' operator:op", 24), ('unqualified_id -> IDENTIFIER:id', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("unqualified_id -> '~' class_name:name", 18), ('unqualified_id -> conversion_function_id!', 18)], {unqualified_id: ('g', 735), '~': ('s', 45), IDENTIFIER: ('s', 314), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), 'operator': ('s', 8)}, 327),
        #STATE 328
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ('statement -> iteration_statement!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> CPP_ERROR!', 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('statement -> labeled_statement!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 40), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('block_declaration -> asm_definition!', 21), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ('statement -> compound_statement!', 13), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ('statement -> jump_statement!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unary_expression -> postfix_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_name -> template_id!', 13), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), '++': ('s', 55), _80: ('g', 112), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), and_expression: ('g', 72), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), pm_expression: ('g', 73), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), logical_and_expression: ('g', 118), 'asm': ('s', 125), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), conversion_function_id: ('g', 357), 'namespace': ('s', 170), expression: ('g', 335), STRING_LITERAL: ('s', 113), 'auto': ('s', 90), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), compound_statement: ('g', 339), DECLARE_KEYWORD: ('s', 160), selection_statement: ('g', 340), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), operator_function_id: ('g', 6), 'enum': ('s', 117), block_declaration: ('g', 344), 'typename': ('s', 116), 'while': ('s', 349), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 336), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), 'default': ('s', 330), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), asm_definition: ('g', 149), 'union': ('s', 97), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'do': ('s', 355), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'case': ('s', 356), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), 'try': ('s', 334), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), declaration_statement: ('g', 343), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), nested_name_specifier: ('g', 352), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 328),
        #STATE 329
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ('statement -> iteration_statement!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> CPP_ERROR!', 13), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('block_declaration -> asm_definition!', 21), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("compound_statement -> '{' statement!*:sts '}'", 26), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ('statement -> compound_statement!', 13), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ("compound_statement -> '{' statement!*:sts '}'", 26), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("compound_statement -> '{' statement!*:sts '}'", 26), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ('statement -> labeled_statement!', 13), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ('statement -> jump_statement!', 13), ('unary_expression -> postfix_expression!', 20), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_name -> template_id!', 13), ("compound_statement -> '{' statement!*:sts '}'", 42), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), '++': ('s', 55), _80: ('g', 112), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), and_expression: ('g', 72), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), pm_expression: ('g', 73), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), '}': ('s', 650), logical_and_expression: ('g', 118), 'asm': ('s', 125), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), conversion_function_id: ('g', 357), 'namespace': ('s', 170), asm_definition: ('g', 149), expression: ('g', 335), STRING_LITERAL: ('s', 113), 'auto': ('s', 90), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), 'try': ('s', 334), DECLARE_KEYWORD: ('s', 160), _57: ('g', 481), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), operator_function_id: ('g', 6), 'enum': ('s', 117), block_declaration: ('g', 344), 'typename': ('s', 116), 'while': ('s', 349), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 651), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), 'default': ('s', 330), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), nested_name_specifier: ('g', 352), 'union': ('s', 97), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'do': ('s', 355), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'case': ('s', 356), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), compound_statement: ('g', 339), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), declaration_statement: ('g', 343), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), selection_statement: ('g', 340)}, 329),
        #STATE 330
        State([("labeled_statement -> 'default' ':' statement:st", 31)], {':': ('s', 537)}, 330),
        #STATE 331
        State([("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 28), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 28)], {'(': ('s', 607)}, 331),
        #STATE 332
        State([("jump_statement -> 'break' ';'", 26)], {';': ('s', 396)}, 332),
        #STATE 333
        State([("jump_statement -> 'continue' ';'", 29)], {';': ('s', 568)}, 333),
        #STATE 334
        State([("compound_statement -> '{' statement!*:sts '}'", 22), ("try_block -> 'try' compound_statement:body handler!+:handlers", 19), ("compound_statement -> '{' statement!*:sts '}'", 22)], {compound_statement: ('g', 689), '{': ('s', 329)}, 334),
        #STATE 335
        State([("expression -> expression:a ',' assignment_expression:b", 27), ("expression_statement -> expression:expr ';'", 40)], {',': ('s', 272), ';': ('s', 325)}, 335),
        #STATE 336
        State([("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 49)], {'-': ('r', 537), 'asm': ('r', 537), '(': ('r', 537), '*': ('r', 537), 'reinterpret_cast': ('r', 537), 'delete': ('r', 537), 'static_cast': ('r', 537), 'virtual': ('r', 537), DECLARE_KEYWORD: ('r', 537), IDENTIFIER: ('r', 537), 'while': ('r', 537), INTEGER_LITERAL: ('r', 537), 'extern': ('r', 537), 'default': ('r', 537), 'goto': ('r', 537), 'new': ('r', 537), 'throw': ('r', 537), 'typedef': ('r', 537), '--': ('r', 537), '++': ('r', 537), 'dynamic_cast': ('r', 537), 'for': ('r', 537), 'continue': ('r', 537), '+': ('r', 537), 'struct': ('r', 537), 'volatile': ('r', 537), 'namespace': ('r', 537), '&': ('r', 537), 'if': ('r', 537), 'union': ('r', 537), 'const_cast': ('r', 537), '::': ('r', 537), 'auto': ('r', 537), 'using': ('r', 537), 'do': ('r', 537), 'case': ('r', 537), 'try': ('r', 537), '~': ('r', 537), 'return': ('r', 537), '{': ('r', 537), 'this': ('r', 537), '!': ('r', 537), CHARACTER_LITERAL: ('r', 537), FLOATING_LITERAL: ('r', 537), 'sizeof': ('r', 537), 'else': ('r', 537), TYPE_KEYWORD: ('r', 537), '}': ('r', 537), BOOLEAN_LITERAL: ('r', 537), 'enum': ('r', 537), STRING_LITERAL: ('r', 537), 'class': ('r', 537), 'typename': ('r', 537), 'break': ('r', 537), 'operator': ('r', 537), CPP_ERROR: ('r', 537), 'const': ('r', 537), 'switch': ('r', 537), 'typeid': ('r', 537)}, 336),
        #STATE 337
        State([('statement -> labeled_statement!', 30)], {'-': ('r', 534), '++': ('r', 534), '(': ('r', 534), '*': ('r', 534), '+': ('r', 534), 'delete': ('r', 534), 'static_cast': ('r', 534), 'virtual': ('r', 534), '!': ('r', 534), IDENTIFIER: ('r', 534), 'while': ('r', 534), INTEGER_LITERAL: ('r', 534), 'typedef': ('r', 534), 'default': ('r', 534), 'goto': ('r', 534), 'break': ('r', 534), 'new': ('r', 534), 'throw': ('r', 534), 'extern': ('r', 534), '--': ('r', 534), 'asm': ('r', 534), 'dynamic_cast': ('r', 534), 'for': ('r', 534), 'continue': ('r', 534), 'struct': ('r', 534), 'volatile': ('r', 534), 'namespace': ('r', 534), '&': ('r', 534), 'this': ('r', 534), 'if': ('r', 534), 'union': ('r', 534), 'const_cast': ('r', 534), '::': ('r', 534), 'auto': ('r', 534), 'using': ('r', 534), 'do': ('r', 534), DECLARE_KEYWORD: ('r', 534), '}': ('r', 534), '~': ('r', 534), 'return': ('r', 534), '{': ('r', 534), 'case': ('r', 534), TYPE_KEYWORD: ('r', 534), FLOATING_LITERAL: ('r', 534), 'sizeof': ('r', 534), 'else': ('r', 534), CHARACTER_LITERAL: ('r', 534), 'try': ('r', 534), 'reinterpret_cast': ('r', 534), BOOLEAN_LITERAL: ('r', 534), 'enum': ('r', 534), STRING_LITERAL: ('r', 534), 'class': ('r', 534), 'typename': ('r', 534), CPP_ERROR: ('r', 534), 'operator': ('r', 534), 'const': ('r', 534), 'switch': ('r', 534), 'typeid': ('r', 534)}, 337),
        #STATE 338
        State([('statement -> expression_statement!', 33)], {'-': ('r', 169), '++': ('r', 169), '(': ('r', 169), '*': ('r', 169), '+': ('r', 169), 'delete': ('r', 169), 'static_cast': ('r', 169), 'virtual': ('r', 169), '!': ('r', 169), IDENTIFIER: ('r', 169), 'while': ('r', 169), INTEGER_LITERAL: ('r', 169), 'typedef': ('r', 169), 'default': ('r', 169), 'goto': ('r', 169), 'break': ('r', 169), 'new': ('r', 169), 'class': ('r', 169), 'extern': ('r', 169), '--': ('r', 169), 'asm': ('r', 169), 'dynamic_cast': ('r', 169), 'for': ('r', 169), 'continue': ('r', 169), 'struct': ('r', 169), 'volatile': ('r', 169), 'namespace': ('r', 169), '&': ('r', 169), 'case': ('r', 169), 'if': ('r', 169), 'union': ('r', 169), 'const_cast': ('r', 169), '::': ('r', 169), 'auto': ('r', 169), 'using': ('r', 169), 'do': ('r', 169), DECLARE_KEYWORD: ('r', 169), 'try': ('r', 169), '~': ('r', 169), 'return': ('r', 169), '{': ('r', 169), 'this': ('r', 169), TYPE_KEYWORD: ('r', 169), FLOATING_LITERAL: ('r', 169), 'sizeof': ('r', 169), 'else': ('r', 169), CHARACTER_LITERAL: ('r', 169), '}': ('r', 169), 'reinterpret_cast': ('r', 169), BOOLEAN_LITERAL: ('r', 169), 'enum': ('r', 169), STRING_LITERAL: ('r', 169), 'throw': ('r', 169), 'typename': ('r', 169), CPP_ERROR: ('r', 169), 'operator': ('r', 169), 'const': ('r', 169), 'switch': ('r', 169), 'typeid': ('r', 169)}, 338),
        #STATE 339
        State([('statement -> compound_statement!', 31)], {'-': ('r', 352), '++': ('r', 352), '(': ('r', 352), '*': ('r', 352), '+': ('r', 352), 'delete': ('r', 352), 'static_cast': ('r', 352), 'virtual': ('r', 352), '!': ('r', 352), IDENTIFIER: ('r', 352), 'while': ('r', 352), INTEGER_LITERAL: ('r', 352), 'extern': ('r', 352), 'default': ('r', 352), 'goto': ('r', 352), 'break': ('r', 352), 'new': ('r', 352), 'throw': ('r', 352), 'typedef': ('r', 352), '--': ('r', 352), 'asm': ('r', 352), 'dynamic_cast': ('r', 352), 'for': ('r', 352), 'continue': ('r', 352), 'struct': ('r', 352), 'volatile': ('r', 352), 'namespace': ('r', 352), '&': ('r', 352), 'this': ('r', 352), 'if': ('r', 352), 'union': ('r', 352), 'const_cast': ('r', 352), '::': ('r', 352), 'auto': ('r', 352), 'using': ('r', 352), 'do': ('r', 352), DECLARE_KEYWORD: ('r', 352), 'try': ('r', 352), '~': ('r', 352), 'return': ('r', 352), '{': ('r', 352), 'case': ('r', 352), TYPE_KEYWORD: ('r', 352), FLOATING_LITERAL: ('r', 352), 'sizeof': ('r', 352), 'else': ('r', 352), CHARACTER_LITERAL: ('r', 352), '}': ('r', 352), 'reinterpret_cast': ('r', 352), BOOLEAN_LITERAL: ('r', 352), 'enum': ('r', 352), STRING_LITERAL: ('r', 352), 'class': ('r', 352), 'typename': ('r', 352), CPP_ERROR: ('r', 352), 'operator': ('r', 352), 'const': ('r', 352), 'switch': ('r', 352), 'typeid': ('r', 352)}, 339),
        #STATE 340
        State([('statement -> selection_statement!', 32)], {'sizeof': ('r', 404), '-': ('r', 404), 'asm': ('r', 404), '(': ('r', 404), '*': ('r', 404), 'reinterpret_cast': ('r', 404), 'delete': ('r', 404), 'static_cast': ('r', 404), 'virtual': ('r', 404), DECLARE_KEYWORD: ('r', 404), IDENTIFIER: ('r', 404), 'while': ('r', 404), INTEGER_LITERAL: ('r', 404), 'extern': ('r', 404), 'default': ('r', 404), 'goto': ('r', 404), 'new': ('r', 404), 'class': ('r', 404), 'typedef': ('r', 404), '--': ('r', 404), '++': ('r', 404), 'dynamic_cast': ('r', 404), 'for': ('r', 404), 'continue': ('r', 404), '+': ('r', 404), 'struct': ('r', 404), 'volatile': ('r', 404), 'namespace': ('r', 404), '&': ('r', 404), 'this': ('r', 404), 'if': ('r', 404), 'union': ('r', 404), 'const_cast': ('r', 404), '::': ('r', 404), 'auto': ('r', 404), 'using': ('r', 404), 'do': ('r', 404), '!': ('r', 404), '}': ('r', 404), '~': ('r', 404), 'return': ('r', 404), '{': ('r', 404), 'case': ('r', 404), TYPE_KEYWORD: ('r', 404), FLOATING_LITERAL: ('r', 404), CPP_ERROR: ('r', 404), 'else': ('r', 404), CHARACTER_LITERAL: ('r', 404), 'try': ('r', 404), BOOLEAN_LITERAL: ('r', 404), 'enum': ('r', 404), STRING_LITERAL: ('r', 404), 'throw': ('r', 404), 'typename': ('r', 404), 'break': ('r', 404), 'operator': ('r', 404), 'const': ('r', 404), 'switch': ('r', 404), 'typeid': ('r', 404)}, 340),
        #STATE 341
        State([('statement -> iteration_statement!', 32)], {'-': ('r', 96), '++': ('r', 96), '(': ('r', 96), '*': ('r', 96), '+': ('r', 96), 'delete': ('r', 96), 'static_cast': ('r', 96), 'virtual': ('r', 96), DECLARE_KEYWORD: ('r', 96), IDENTIFIER: ('r', 96), 'while': ('r', 96), INTEGER_LITERAL: ('r', 96), 'typedef': ('r', 96), 'default': ('r', 96), 'goto': ('r', 96), 'break': ('r', 96), 'new': ('r', 96), 'class': ('r', 96), 'extern': ('r', 96), '--': ('r', 96), 'asm': ('r', 96), 'dynamic_cast': ('r', 96), 'for': ('r', 96), 'continue': ('r', 96), 'struct': ('r', 96), 'volatile': ('r', 96), 'namespace': ('r', 96), '&': ('r', 96), 'case': ('r', 96), 'if': ('r', 96), 'union': ('r', 96), 'const_cast': ('r', 96), '::': ('r', 96), 'auto': ('r', 96), 'using': ('r', 96), 'do': ('r', 96), '!': ('r', 96), 'try': ('r', 96), '~': ('r', 96), 'return': ('r', 96), '{': ('r', 96), 'this': ('r', 96), TYPE_KEYWORD: ('r', 96), FLOATING_LITERAL: ('r', 96), 'sizeof': ('r', 96), 'else': ('r', 96), CHARACTER_LITERAL: ('r', 96), '}': ('r', 96), 'reinterpret_cast': ('r', 96), BOOLEAN_LITERAL: ('r', 96), 'enum': ('r', 96), STRING_LITERAL: ('r', 96), 'throw': ('r', 96), 'typename': ('r', 96), CPP_ERROR: ('r', 96), 'operator': ('r', 96), 'const': ('r', 96), 'switch': ('r', 96), 'typeid': ('r', 96)}, 341),
        #STATE 342
        State([('statement -> jump_statement!', 27)], {'sizeof': ('r', 104), '-': ('r', 104), 'asm': ('r', 104), '(': ('r', 104), '*': ('r', 104), 'reinterpret_cast': ('r', 104), 'delete': ('r', 104), 'static_cast': ('r', 104), 'virtual': ('r', 104), '!': ('r', 104), IDENTIFIER: ('r', 104), 'while': ('r', 104), INTEGER_LITERAL: ('r', 104), 'extern': ('r', 104), 'default': ('r', 104), 'goto': ('r', 104), 'new': ('r', 104), 'class': ('r', 104), 'typedef': ('r', 104), '--': ('r', 104), '++': ('r', 104), 'dynamic_cast': ('r', 104), 'for': ('r', 104), 'continue': ('r', 104), '+': ('r', 104), 'struct': ('r', 104), 'volatile': ('r', 104), 'namespace': ('r', 104), '&': ('r', 104), 'case': ('r', 104), 'if': ('r', 104), 'union': ('r', 104), 'const_cast': ('r', 104), '::': ('r', 104), 'auto': ('r', 104), 'using': ('r', 104), 'do': ('r', 104), DECLARE_KEYWORD: ('r', 104), 'try': ('r', 104), '~': ('r', 104), 'return': ('r', 104), '{': ('r', 104), 'this': ('r', 104), TYPE_KEYWORD: ('r', 104), FLOATING_LITERAL: ('r', 104), CPP_ERROR: ('r', 104), 'else': ('r', 104), CHARACTER_LITERAL: ('r', 104), '}': ('r', 104), BOOLEAN_LITERAL: ('r', 104), 'enum': ('r', 104), STRING_LITERAL: ('r', 104), 'throw': ('r', 104), 'typename': ('r', 104), 'break': ('r', 104), 'operator': ('r', 104), 'const': ('r', 104), 'switch': ('r', 104), 'typeid': ('r', 104)}, 342),
        #STATE 343
        State([('statement -> declaration_statement!', 34)], {'sizeof': ('r', 99), '-': ('r', 99), '++': ('r', 99), '(': ('r', 99), '*': ('r', 99), '+': ('r', 99), 'delete': ('r', 99), 'static_cast': ('r', 99), 'virtual': ('r', 99), '!': ('r', 99), IDENTIFIER: ('r', 99), 'while': ('r', 99), INTEGER_LITERAL: ('r', 99), 'typedef': ('r', 99), 'default': ('r', 99), 'goto': ('r', 99), 'new': ('r', 99), 'throw': ('r', 99), 'extern': ('r', 99), '--': ('r', 99), 'asm': ('r', 99), 'dynamic_cast': ('r', 99), 'for': ('r', 99), 'continue': ('r', 99), 'struct': ('r', 99), 'volatile': ('r', 99), 'namespace': ('r', 99), '&': ('r', 99), 'case': ('r', 99), 'if': ('r', 99), 'union': ('r', 99), 'const_cast': ('r', 99), '::': ('r', 99), 'auto': ('r', 99), 'using': ('r', 99), 'do': ('r', 99), DECLARE_KEYWORD: ('r', 99), 'try': ('r', 99), '~': ('r', 99), 'return': ('r', 99), '{': ('r', 99), 'this': ('r', 99), TYPE_KEYWORD: ('r', 99), FLOATING_LITERAL: ('r', 99), CPP_ERROR: ('r', 99), 'else': ('r', 99), CHARACTER_LITERAL: ('r', 99), '}': ('r', 99), 'reinterpret_cast': ('r', 99), BOOLEAN_LITERAL: ('r', 99), 'enum': ('r', 99), STRING_LITERAL: ('r', 99), 'class': ('r', 99), 'typename': ('r', 99), 'break': ('r', 99), 'operator': ('r', 99), 'const': ('r', 99), 'switch': ('r', 99), 'typeid': ('r', 99)}, 343),
        #STATE 344
        State([('declaration_statement -> block_declaration:decl', 42)], {'sizeof': ('r', 519), '-': ('r', 519), 'asm': ('r', 519), '(': ('r', 519), '*': ('r', 519), 'reinterpret_cast': ('r', 519), 'delete': ('r', 519), 'static_cast': ('r', 519), 'virtual': ('r', 519), '!': ('r', 519), IDENTIFIER: ('r', 519), 'while': ('r', 519), INTEGER_LITERAL: ('r', 519), 'extern': ('r', 519), 'default': ('r', 519), 'goto': ('r', 519), 'new': ('r', 519), 'throw': ('r', 519), 'typedef': ('r', 519), '--': ('r', 519), '++': ('r', 519), 'dynamic_cast': ('r', 519), 'for': ('r', 519), 'continue': ('r', 519), '+': ('r', 519), 'struct': ('r', 519), 'volatile': ('r', 519), 'namespace': ('r', 519), '&': ('r', 519), 'this': ('r', 519), 'if': ('r', 519), 'union': ('r', 519), 'const_cast': ('r', 519), '::': ('r', 519), 'auto': ('r', 519), 'using': ('r', 519), 'do': ('r', 519), DECLARE_KEYWORD: ('r', 519), 'try': ('r', 519), '~': ('r', 519), 'return': ('r', 519), '{': ('r', 519), 'case': ('r', 519), TYPE_KEYWORD: ('r', 519), FLOATING_LITERAL: ('r', 519), CPP_ERROR: ('r', 519), 'else': ('r', 519), CHARACTER_LITERAL: ('r', 519), '}': ('r', 519), BOOLEAN_LITERAL: ('r', 519), 'enum': ('r', 519), STRING_LITERAL: ('r', 519), 'class': ('r', 519), 'typename': ('r', 519), 'break': ('r', 519), 'operator': ('r', 519), 'const': ('r', 519), 'switch': ('r', 519), 'typeid': ('r', 519)}, 344),
        #STATE 345
        State([('namespace_name -> IDENTIFIER:name', 28), ('type_name -> IDENTIFIER:name', 23), ('unqualified_id -> IDENTIFIER:id', 28), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 36), ('template_name -> IDENTIFIER!', 27), ('class_name -> IDENTIFIER:name', 24)], {',': ('r', 95), '-': ('r', 95), '.': ('r', 95), '/': ('r', 95), '(': ('c', [('r', 6), ('r', 95)]), '*': ('c', [('r', 6), ('r', 95)]), '==': ('r', 95), '%': ('r', 95), '&': ('c', [('r', 6), ('r', 95)]), '%=': ('r', 95), '<': ('c', [('r', 95), ('r', 2)]), '=': ('r', 95), '>': ('r', 95), '?': ('r', 95), IDENTIFIER: ('r', 6), ':': ('s', 328), ';': ('r', 95), '|=': ('r', 95), '^=': ('r', 95), '<<': ('r', 95), '!=': ('r', 95), '--': ('r', 95), '/=': ('r', 95), '++': ('r', 95), '*=': ('r', 95), '<<=': ('r', 95), '->': ('r', 95), '-=': ('r', 95), '->*': ('r', 95), '>>': ('r', 95), '>=': ('r', 95), '<=': ('r', 95), '::': ('c', [('r', 5), ('r', 6), ('r', 7)]), '||': ('r', 95), '>>=': ('r', 95), '&&': ('r', 95), '|': ('r', 95), '~': ('r', 6), '&=': ('r', 95), 'operator': ('r', 6), '+=': ('r', 95), '+': ('r', 95), '^': ('r', 95), '[': ('r', 95), '.*': ('r', 95)}, 345),
        #STATE 346
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("class_key -> 'class' | 'struct' | 'union'", 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("raw_type_descriptor -> 'auto'", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("cv_qualifier -> 'const'!", 16), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ("class_key -> 'class' | 'struct' | 'union'", 23), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('raw_type_descriptor -> named_type_specifier!', 23), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("decl_attrib -> 'extern'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 266), raw_type_descriptor: ('g', 54), _80: ('g', 112), class_specifier: ('g', 75), nested_name_specifier: ('g', 155), 'virtual': ('s', 130), type_name: ('g', 131), 'union': ('s', 97), DECLARE_KEYWORD: ('s', 160), elaborated_type_specifier: ('g', 109), '~': ('s', 159), IDENTIFIER: ('s', 29), 'operator': ('s', 168), template_name: ('g', 2), 'extern': ('s', 249), class_name: ('g', 11), named_type_specifier: ('g', 126), enum_specifier: ('g', 122), cv_qualifier: ('g', 106), 'typedef': ('s', 136), class_head: ('g', 20), conversion_function_id: ('g', 158), cd_declarator: ('g', 358), _75: ('g', 723), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), cd_id: ('g', 164), _81: ('g', 88), 'class': ('s', 115), 'typename': ('s', 166), namespace_name: ('g', 5), '::': ('s', 153), 'struct': ('s', 58), 'volatile': ('s', 33), type_descriptor: ('g', 724), 'const': ('s', 35), template_id: ('g', 18), class_key: ('g', 78), 'auto': ('s', 90)}, 346),
        #STATE 347
        State([('namespace_name -> IDENTIFIER:name', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('type_name -> IDENTIFIER:name', 13), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('class_name -> template_id!', 14), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("operator_function_id -> 'operator' operator:op", 24), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("qualified_id -> '::' (operator_function_id!|template_id!)", 44), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('type_name -> template_id!', 13), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('template_name -> IDENTIFIER!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("qualified_id -> '::' IDENTIFIER!", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47)], {'new': ('s', 706), template_name: ('g', 2), namespace_name: ('g', 5), 'delete': ('s', 708), operator_function_id: ('g', 376), type_name: ('g', 931), template_id: ('g', 710), conversion_function_id: ('g', 219), '~': ('s', 218), IDENTIFIER: ('s', 707), 'operator': ('s', 8), nested_name_specifier: ('g', 421), class_name: ('g', 11)}, 347),
        #STATE 348
        State([('statement -> try_block!', 22)], {'sizeof': ('r', 431), '-': ('r', 431), 'asm': ('r', 431), '(': ('r', 431), '*': ('r', 431), 'reinterpret_cast': ('r', 431), 'delete': ('r', 431), 'static_cast': ('r', 431), 'virtual': ('r', 431), DECLARE_KEYWORD: ('r', 431), IDENTIFIER: ('r', 431), 'while': ('r', 431), INTEGER_LITERAL: ('r', 431), 'extern': ('r', 431), 'default': ('r', 431), 'goto': ('r', 431), 'new': ('r', 431), 'throw': ('r', 431), 'typedef': ('r', 431), '--': ('r', 431), '++': ('r', 431), 'dynamic_cast': ('r', 431), 'for': ('r', 431), 'continue': ('r', 431), '+': ('r', 431), 'struct': ('r', 431), 'volatile': ('r', 431), 'namespace': ('r', 431), '&': ('r', 431), 'case': ('r', 431), 'if': ('r', 431), 'union': ('r', 431), 'const_cast': ('r', 431), '::': ('r', 431), 'auto': ('r', 431), 'using': ('r', 431), 'do': ('r', 431), '!': ('r', 431), 'try': ('r', 431), '~': ('r', 431), 'return': ('r', 431), '{': ('r', 431), 'this': ('r', 431), TYPE_KEYWORD: ('r', 431), FLOATING_LITERAL: ('r', 431), CPP_ERROR: ('r', 431), 'else': ('r', 431), CHARACTER_LITERAL: ('r', 431), '}': ('r', 431), BOOLEAN_LITERAL: ('r', 431), 'enum': ('r', 431), STRING_LITERAL: ('r', 431), 'class': ('r', 431), 'typename': ('r', 431), 'break': ('r', 431), 'operator': ('r', 431), 'const': ('r', 431), 'switch': ('r', 431), 'typeid': ('r', 431)}, 348),
        #STATE 349
        State([("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 31)], {'(': ('s', 917)}, 349),
        #STATE 350
        State([("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 25)], {IDENTIFIER: ('s', 892)}, 350),
        #STATE 351
        State([("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 29)], {'(': ('s', 682)}, 351),
        #STATE 352
        State([("operator_function_id -> 'operator' operator:op", 24), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('unqualified_id -> IDENTIFIER:id', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 53), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('unqualified_id -> operator_function_id!', 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("unqualified_id -> '~' class_name:name", 18), ('unqualified_id -> conversion_function_id!', 18), ('type_name -> IDENTIFIER:name', 13)], {operator_function_id: ('g', 6), template_name: ('g', 2), '~': ('s', 627), IDENTIFIER: ('s', 423), conversion_function_id: ('g', 628), unqualified_id: ('g', 326), 'template': ('s', 629), 'operator': ('s', 8), type_name: ('g', 630), template_id: ('g', 26)}, 352),
        #STATE 353
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 56), ('class_name -> template_id!', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 51), ('class_name -> IDENTIFIER:name', 14), ('type_name -> template_id!', 13), ("unqualified_id -> '~' class_name:name", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_name -> IDENTIFIER:name', 13)], {template_name: ('g', 2), '++': ('r', 38), '(': ('r', 38), '::': ('r', 38), '*': ('r', 38), 'reinterpret_cast': ('r', 38), 'delete': ('r', 38), 'static_cast': ('r', 38), type_name: ('g', 243), '&': ('r', 38), 'this': ('r', 38), '~': ('r', 38), IDENTIFIER: ('c', [('s', 508), ('r', 38)]), 'operator': ('r', 38), INTEGER_LITERAL: ('r', 38), '!': ('r', 38), class_name: ('g', 289), TYPE_KEYWORD: ('r', 38), 'new': ('r', 38), FLOATING_LITERAL: ('r', 38), 'sizeof': ('r', 38), CHARACTER_LITERAL: ('r', 38), '--': ('r', 38), 'const_cast': ('r', 38), BOOLEAN_LITERAL: ('r', 38), '+': ('r', 38), '-': ('r', 38), STRING_LITERAL: ('r', 38), 'dynamic_cast': ('r', 38), 'typename': ('r', 38), template_id: ('g', 18), 'typeid': ('r', 38)}, 353),
        #STATE 354
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("jump_statement -> 'return' expression:v? ';'", 27), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("jump_statement -> 'return' expression:v? ';'", 41), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), ';': ('s', 320), equality_expression: ('g', 70), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), expression: ('g', 848), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), '--': ('s', 111), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), INTEGER_LITERAL: ('s', 87), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 354),
        #STATE 355
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ('statement -> iteration_statement!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> CPP_ERROR!', 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('statement -> labeled_statement!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('block_declaration -> asm_definition!', 21), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 28), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ('statement -> compound_statement!', 13), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ('statement -> jump_statement!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unary_expression -> postfix_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_name -> template_id!', 13), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), '++': ('s', 55), _80: ('g', 112), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), and_expression: ('g', 72), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), pm_expression: ('g', 73), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), logical_and_expression: ('g', 118), 'asm': ('s', 125), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), conversion_function_id: ('g', 357), 'namespace': ('s', 170), expression: ('g', 335), STRING_LITERAL: ('s', 113), 'auto': ('s', 90), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), compound_statement: ('g', 339), DECLARE_KEYWORD: ('s', 160), selection_statement: ('g', 340), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), operator_function_id: ('g', 6), 'enum': ('s', 117), block_declaration: ('g', 344), 'typename': ('s', 116), 'while': ('s', 349), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 1034), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), 'default': ('s', 330), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), asm_definition: ('g', 149), 'union': ('s', 97), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'do': ('s', 355), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'case': ('s', 356), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), 'try': ('s', 334), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), declaration_statement: ('g', 343), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), nested_name_specifier: ('g', 352), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 355),
        #STATE 356
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 28), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('constant_expression -> conditional_expression!', 23), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), constant_expression: ('g', 576), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), '!': ('s', 104), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 774), logical_and_expression: ('g', 118), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 310), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), type_name: ('g', 98), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), unqualified_id: ('g', 7), 'const_cast': ('s', 92), qualified_id: ('g', 4), exclusive_or_expression: ('g', 121), nested_name_specifier: ('g', 95), new_expression: ('g', 94), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 356),
        #STATE 357
        State([('unqualified_id -> conversion_function_id!', 40), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 69)], {',': ('r', 382), '-': ('r', 382), '.': ('r', 382), '/': ('r', 382), '(': ('c', [('r', 382), ('r', 277)]), '<<': ('r', 382), '*': ('r', 382), '==': ('r', 382), '%': ('r', 382), '&': ('r', 382), '>>=': ('r', 382), '&&': ('r', 382), '<': ('r', 382), '=': ('r', 382), '>': ('r', 382), '?': ('r', 382), '<=': ('r', 382), '&=': ('r', 382), ';': ('r', 382), '|=': ('r', 382), '^=': ('r', 382), '%=': ('r', 382), '|': ('r', 382), '!=': ('r', 382), '++': ('r', 382), '--': ('r', 382), '/=': ('r', 382), '[': ('r', 382), '+': ('r', 382), '||': ('r', 382), '^': ('r', 382), '>>': ('r', 382), '*=': ('r', 382), '<<=': ('r', 382), '->': ('r', 382), '-=': ('r', 382), '.*': ('r', 382), '->*': ('r', 382), '+=': ('r', 382), '>=': ('r', 382)}, 357),
        #STATE 358
        State([("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 55)], {',': ('r', 107), ';': ('r', 107)}, 358),
        #STATE 359
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 63), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 63), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 63), ('init_declarator -> declarator:d initializer:init?', 19), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ('unqualified_id -> operator_function_id!', 18), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("operator_function_id -> 'operator' operator:op", 24), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('declarator -> direct_declarator!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('direct_declarator -> declarator_id!', 21), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('declarator_id -> id_expression!', 17), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("qualified_id -> '::' IDENTIFIER!", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('id_expression -> qualified_id!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('init_declarator -> declarator:d initializer:init?', 19), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('unqualified_id -> conversion_function_id!', 18), ("ptr_operator -> '&'", 16), ("unqualified_id -> '~' class_name:name", 18), ("direct_declarator -> '(' declarator! ')'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {unqualified_id: ('g', 7), '(': ('s', 281), qualified_id: ('g', 4), '*': ('s', 223), namespace_name: ('g', 5), nested_name_specifier: ('g', 284), '&': ('s', 225), init_declarator: ('g', 181), '~': ('s', 45), IDENTIFIER: ('s', 46), 'operator': ('s', 8), template_name: ('g', 2), direct_declarator: ('g', 285), ptr_operator: ('g', 279), '::': ('s', 282), id_expression: ('g', 280), _74: ('g', 451), declarator_id: ('g', 286), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), class_name: ('g', 11), template_id: ('g', 44), declarator: ('g', 603)}, 359),
        #STATE 360
        State([("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 32)], {'(': ('s', 831)}, 360),
        #STATE 361
        State([('statement -> CPP_ERROR!', 22)], {'-': ('r', 92), 'asm': ('r', 92), '(': ('r', 92), '*': ('r', 92), 'reinterpret_cast': ('r', 92), 'delete': ('r', 92), 'static_cast': ('r', 92), 'virtual': ('r', 92), '!': ('r', 92), IDENTIFIER: ('r', 92), 'while': ('r', 92), INTEGER_LITERAL: ('r', 92), 'extern': ('r', 92), 'default': ('r', 92), 'goto': ('r', 92), 'break': ('r', 92), 'new': ('r', 92), 'throw': ('r', 92), 'typedef': ('r', 92), '--': ('r', 92), '++': ('r', 92), 'dynamic_cast': ('r', 92), 'for': ('r', 92), 'continue': ('r', 92), '+': ('r', 92), 'struct': ('r', 92), 'volatile': ('r', 92), 'namespace': ('r', 92), '&': ('r', 92), 'case': ('r', 92), 'if': ('r', 92), 'union': ('r', 92), 'const_cast': ('r', 92), '::': ('r', 92), 'auto': ('r', 92), 'using': ('r', 92), 'do': ('r', 92), DECLARE_KEYWORD: ('r', 92), '}': ('r', 92), '~': ('r', 92), 'return': ('r', 92), '{': ('r', 92), 'this': ('r', 92), TYPE_KEYWORD: ('r', 92), FLOATING_LITERAL: ('r', 92), 'sizeof': ('r', 92), 'else': ('r', 92), CHARACTER_LITERAL: ('r', 92), 'try': ('r', 92), BOOLEAN_LITERAL: ('r', 92), 'enum': ('r', 92), STRING_LITERAL: ('r', 92), 'class': ('r', 92), 'typename': ('r', 92), CPP_ERROR: ('r', 92), 'operator': ('r', 92), 'const': ('r', 92), 'switch': ('r', 92), 'typeid': ('r', 92)}, 361),
        #STATE 362
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 176)], {',': ('r', 53), '-': ('r', 53), '.': ('r', 53), '/': ('r', 53), '(': ('r', 53), ')': ('r', 53), '*': ('r', 53), '+': ('r', 53), '%': ('r', 53), '&': ('r', 53), '<': ('r', 53), '=': ('r', 53), '>': ('r', 53), '?': ('r', 53), '<<': ('r', 53), ':': ('r', 53), ';': ('r', 53), '...': ('r', 53), '|=': ('r', 53), '^=': ('r', 53), '%=': ('r', 53), '!=': ('r', 53), '--': ('r', 53), '/=': ('r', 53), '++': ('r', 53), '^': ('r', 53), '<<=': ('r', 53), '->': ('r', 53), '-=': ('r', 53), '->*': ('r', 53), '+=': ('r', 53), '>=': ('r', 53), '<=': ('r', 53), '||': ('r', 53), '>>=': ('r', 53), '&&': ('r', 53), '|': ('r', 53), '}': ('r', 53), '&=': ('r', 53), '{': ('r', 53), 'try': ('r', 53), '>>': ('r', 53), ']': ('r', 53), '*=': ('r', 53), '==': ('r', 53), '[': ('r', 53), '.*': ('r', 53)}, 362),
        #STATE 363
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 60), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 60)], {template_name: ('g', 2), 'auto': ('s', 90), _80: ('g', 112), named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), template_id: ('g', 18), nested_name_specifier: ('g', 189), type_name: ('g', 98), 'union': ('s', 97), elaborated_type_specifier: ('g', 109), IDENTIFIER: ('s', 29), class_specifier: ('g', 75), class_name: ('g', 11), '::': ('s', 191), cv_qualifier: ('g', 106), class_head: ('g', 20), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), _81: ('g', 88), 'class': ('s', 115), type_id: ('g', 364), 'typename': ('s', 166), namespace_name: ('g', 5), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), type_descriptor: ('g', 240), enum_specifier: ('g', 122)}, 363),
        #STATE 364
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 70), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 70)], {')': ('s', 573)}, 364),
        #STATE 365
        State([("relational_expression -> relational_expression:a '>' shift_expression:b", 49), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 49), ("relational_expression -> relational_expression:a '<' shift_expression:b", 49), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 49), ("equality_expression -> equality_expression:a '==' relational_expression:b", 71)], {',': ('r', 54), '<=': ('s', 368), ')': ('r', 54), '==': ('r', 54), '&': ('r', 54), '>>=': ('r', 54), '&&': ('r', 54), '|': ('r', 54), '=': ('r', 54), '>': ('c', [('s', 367), ('r', 54)]), '?': ('r', 54), '&=': ('r', 54), ':': ('r', 54), ';': ('r', 54), '...': ('r', 54), '|=': ('r', 54), '^=': ('r', 54), '%=': ('r', 54), '<': ('s', 366), '!=': ('r', 54), '}': ('r', 54), '/=': ('r', 54), '||': ('r', 54), '*=': ('r', 54), ']': ('r', 54), '^': ('r', 54), '<<=': ('r', 54), '-=': ('r', 54), '+=': ('r', 54), '>=': ('s', 369)}, 365),
        #STATE 366
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('simple_type_specifier -> named_type_specifier!', 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("relational_expression -> relational_expression:a '<' shift_expression:b", 53), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), additive_expression: ('g', 63), shift_expression: ('g', 448), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), TYPE_KEYWORD: ('s', 178), new_expression: ('g', 94), CHARACTER_LITERAL: ('s', 108), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 366),
        #STATE 367
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('simple_type_specifier -> named_type_specifier!', 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("relational_expression -> relational_expression:a '>' shift_expression:b", 53), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), additive_expression: ('g', 63), shift_expression: ('g', 430), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), TYPE_KEYWORD: ('s', 178), new_expression: ('g', 94), CHARACTER_LITERAL: ('s', 108), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 367),
        #STATE 368
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('simple_type_specifier -> named_type_specifier!', 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 54), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), additive_expression: ('g', 63), shift_expression: ('g', 666), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), TYPE_KEYWORD: ('s', 178), new_expression: ('g', 94), CHARACTER_LITERAL: ('s', 108), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 368),
        #STATE 369
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('simple_type_specifier -> named_type_specifier!', 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 54), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), additive_expression: ('g', 63), shift_expression: ('g', 468), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), TYPE_KEYWORD: ('s', 178), new_expression: ('g', 94), CHARACTER_LITERAL: ('s', 108), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 369),
        #STATE 370
        State([("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 92)], {',': ('r', 56), 'union': ('r', 56), '(': ('r', 56), ')': ('r', 56), 'struct': ('r', 56), TYPE_KEYWORD: ('r', 56), 'enum': ('r', 56), 'typename': ('r', 56), 'class': ('r', 56), '=': ('r', 56), '>': ('r', 56), '[': ('r', 56), IDENTIFIER: ('r', 56), 'auto': ('r', 56), 'volatile': ('r', 56), '...': ('r', 56), 'const': ('r', 56), '::': ('r', 56)}, 370),
        #STATE 371
        State([("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 80)], {'union': ('r', 58), '::': ('r', 58), 'export': ('r', 58), 'using': ('r', 58), 'virtual': ('r', 58), DECLARE_KEYWORD: ('r', 58), 'const': ('r', 58), '}': ('r', 58), '~': ('r', 58), IDENTIFIER: ('r', 58), 'operator': ('r', 58), 'typedef': ('r', 58), 'extern': ('r', 58), TYPE_KEYWORD: ('r', 58), ACCESS_KEYWORD: ('r', 58), 'asm': ('r', 58), 'enum': ('r', 58), EOF: ('r', 58), 'class': ('r', 58), CPP_INCLUDE: ('r', 58), 'typename': ('r', 58), CPP_ERROR: ('r', 58), 'struct': ('r', 58), 'volatile': ('r', 58), 'template': ('r', 58), 'namespace': ('r', 58), 'auto': ('r', 58)}, 371),
        #STATE 372
        State([("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 71)], {',': ('r', 59), '>': ('r', 59)}, 372),
        #STATE 373
        State([('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ('type_name -> template_id!', 13)], {type_name: ('g', 375), 'template': ('s', 374), template_id: ('g', 26), IDENTIFIER: ('s', 24), template_name: ('g', 2)}, 373),
        #STATE 374
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 72), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), template_id: ('g', 597), IDENTIFIER: ('s', 216)}, 374),
        #STATE 375
        State([("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 71)], {',': ('r', 178), '-': ('r', 178), '.': ('r', 178), '/': ('r', 178), '|=': ('r', 178), ')': ('r', 178), '*': ('r', 178), '+': ('r', 178), '%': ('r', 178), '&': ('r', 178), 'operator': ('r', 178), '<': ('r', 178), '=': ('r', 178), '>': ('r', 178), '?': ('r', 178), '<<': ('r', 178), IDENTIFIER: ('r', 178), ':': ('r', 178), ';': ('r', 178), '...': ('r', 178), '(': ('r', 178), '^=': ('r', 178), '||': ('r', 178), '^': ('r', 178), '!=': ('r', 178), '--': ('r', 178), '/=': ('r', 178), '++': ('r', 178), 'typename': ('r', 178), '<<=': ('r', 178), '%=': ('r', 178), '-=': ('r', 178), 'auto': ('r', 178), 'volatile': ('r', 178), '->': ('r', 178), '->*': ('r', 178), '>>': ('r', 178), '>=': ('r', 178), 'union': ('r', 178), '<=': ('r', 178), '::': ('r', 178), '>>=': ('r', 178), '&&': ('r', 178), 'const': ('r', 178), '|': ('r', 178), '}': ('r', 178), '~': ('r', 178), '&=': ('r', 178), '{': ('r', 178), 'struct': ('r', 178), TYPE_KEYWORD: ('r', 178), 'try': ('r', 178), 'enum': ('r', 178), '+=': ('r', 178), 'class': ('r', 178), ']': ('r', 178), '*=': ('r', 178), '==': ('r', 178), '[': ('r', 178), '.*': ('r', 178)}, 375),
        #STATE 376
        State([("qualified_id -> '::' (operator_function_id!|template_id!)", 42)], {',': ('r', 60), '-': ('r', 60), '.': ('r', 60), '/': ('r', 60), '|=': ('r', 60), ')': ('r', 60), '*': ('r', 60), '+': ('r', 60), '%': ('r', 60), '&': ('r', 60), '<': ('r', 60), '=': ('r', 60), '>': ('r', 60), '?': ('r', 60), '<<': ('r', 60), ':': ('r', 60), ';': ('r', 60), '...': ('r', 60), '(': ('r', 60), '^=': ('r', 60), '%=': ('r', 60), '!=': ('r', 60), '--': ('r', 60), '/=': ('r', 60), '++': ('r', 60), '^': ('r', 60), '<<=': ('r', 60), '->': ('r', 60), '-=': ('r', 60), '->*': ('r', 60), '>>': ('r', 60), '>=': ('r', 60), '<=': ('r', 60), '||': ('r', 60), '>>=': ('r', 60), '&&': ('r', 60), '|': ('r', 60), 'try': ('r', 60), '&=': ('r', 60), '{': ('r', 60), '}': ('r', 60), '+=': ('r', 60), ']': ('r', 60), '*=': ('r', 60), '==': ('r', 60), '[': ('r', 60), '.*': ('r', 60)}, 376),
        #STATE 377
        State([("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 74)], {',': ('r', 62), '-': ('r', 62), '.': ('r', 62), '/': ('r', 62), '(': ('r', 62), ')': ('r', 62), '*': ('r', 62), '+': ('r', 62), '%': ('r', 62), '&': ('r', 62), '<': ('r', 62), '=': ('r', 62), '>': ('r', 62), '?': ('r', 62), '<<': ('r', 62), ':': ('r', 62), ';': ('r', 62), '...': ('r', 62), '|=': ('r', 62), '^=': ('r', 62), '%=': ('r', 62), '!=': ('r', 62), '--': ('r', 62), '/=': ('r', 62), '==': ('r', 62), '^': ('r', 62), '<<=': ('r', 62), '->': ('r', 62), '-=': ('r', 62), '->*': ('r', 62), '>>': ('r', 62), '>=': ('r', 62), '<=': ('r', 62), '||': ('r', 62), '>>=': ('r', 62), '&&': ('r', 62), '|': ('r', 62), '}': ('r', 62), '&=': ('r', 62), '++': ('r', 62), '+=': ('r', 62), ']': ('r', 62), '*=': ('r', 62), '[': ('r', 62), '.*': ('r', 62)}, 377),
        #STATE 378
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 266)], {',': ('r', 63), '-': ('r', 63), '.': ('r', 63), '/': ('r', 63), '(': ('r', 63), ')': ('r', 63), '*': ('r', 63), '+': ('r', 63), '%': ('r', 63), '&': ('r', 63), '<': ('r', 63), '=': ('r', 63), '>': ('r', 63), '?': ('r', 63), '<<': ('r', 63), ':': ('r', 63), ';': ('r', 63), '...': ('r', 63), '|=': ('r', 63), '^=': ('r', 63), '%=': ('r', 63), '!=': ('r', 63), '--': ('r', 63), '/=': ('r', 63), '++': ('r', 63), '^': ('r', 63), '<<=': ('r', 63), '->': ('r', 63), '-=': ('r', 63), '->*': ('r', 63), '+=': ('r', 63), '>=': ('r', 63), '<=': ('r', 63), '||': ('r', 63), '>>=': ('r', 63), '&&': ('r', 63), '|': ('r', 63), '}': ('r', 63), '&=': ('r', 63), '{': ('r', 63), 'try': ('r', 63), '>>': ('r', 63), ']': ('r', 63), '*=': ('r', 63), '==': ('r', 63), '[': ('r', 63), '.*': ('r', 63)}, 378),
        #STATE 379
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 60), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_id: ('g', 44), template_name: ('g', 2), IDENTIFIER: ('s', 173), class_name: ('g', 380)}, 379),
        #STATE 380
        State([("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 70)], {'(': ('r', 465)}, 380),
        #STATE 381
        State([("member_declarator -> IDENTIFIER:name? ':' constant_expression:size", 61)], {',': ('r', 65), ';': ('r', 65)}, 381),
        #STATE 382
        State([("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 91)], {';': ('s', 383)}, 382),
        #STATE 383
        State([("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 94)], {'union': ('r', 135), '::': ('r', 135), 'export': ('r', 135), 'using': ('r', 135), 'virtual': ('r', 135), DECLARE_KEYWORD: ('r', 135), 'const': ('r', 135), '}': ('r', 135), '~': ('r', 135), IDENTIFIER: ('r', 135), 'struct': ('r', 135), 'extern': ('r', 135), 'operator': ('r', 135), 'typedef': ('r', 135), TYPE_KEYWORD: ('r', 135), ACCESS_KEYWORD: ('r', 135), 'enum': ('r', 135), 'class': ('r', 135), 'typename': ('r', 135), 'auto': ('r', 135), 'volatile': ('r', 135), 'template': ('r', 135)}, 383),
        #STATE 384
        State([("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 100), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97)], {',': ('r', 66), '(': ('c', [('s', 385), ('r', 66)]), '::': ('r', 66), '*': ('r', 66), '&': ('r', 66), '[': ('r', 66), '~': ('r', 66), '>': ('r', 66), IDENTIFIER: ('r', 66), 'operator': ('r', 66), ';': ('r', 66), ')': ('r', 66)}, 384),
        #STATE 385
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 134), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), ')': ('s', 493), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), _15: ('g', 899), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 323), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), named_type_specifier: ('g', 177), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 385),
        #STATE 386
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 70), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 70)], {')': ('s', 387)}, 386),
        #STATE 387
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 74), ("new_initializer -> '(' assignment_expression!*,','! ')'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 73), ("new_initializer -> '(' assignment_expression!*,','! ')'", 19)], {',': ('r', 113), '-': ('r', 113), '/': ('r', 113), '(': ('s', 300), ')': ('r', 113), '*': ('r', 113), '+': ('r', 113), '%': ('r', 113), '&': ('r', 113), '>>=': ('r', 113), '+=': ('r', 113), '&&': ('r', 113), '<': ('r', 113), '=': ('r', 113), '>': ('r', 113), '?': ('r', 113), '<=': ('r', 113), ':': ('r', 113), ';': ('r', 113), '...': ('r', 113), '|=': ('r', 113), '^=': ('r', 113), '%=': ('r', 113), '|': ('r', 113), '!=': ('r', 113), '}': ('r', 113), '/=': ('r', 113), '==': ('r', 113), '||': ('r', 113), '*=': ('r', 113), '&=': ('r', 113), '<<': ('r', 113), ']': ('r', 113), '^': ('r', 113), '<<=': ('r', 113), new_initializer: ('g', 511), '-=': ('r', 113), '.*': ('r', 113), '->*': ('r', 113), '>>': ('r', 113), '>=': ('r', 113)}, 387),
        #STATE 388
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 128)], {',': ('r', 67), '-': ('r', 67), '.': ('r', 67), '/': ('r', 67), '(': ('r', 67), ')': ('r', 67), '*': ('r', 67), '+': ('r', 67), '%': ('r', 67), '&': ('r', 67), '<': ('r', 67), '=': ('r', 67), '>': ('r', 67), '?': ('r', 67), '<<': ('r', 67), ':': ('r', 67), ';': ('r', 67), '...': ('r', 67), '|=': ('r', 67), '^=': ('r', 67), '%=': ('r', 67), '!=': ('r', 67), '--': ('r', 67), '/=': ('r', 67), '++': ('r', 67), '^': ('r', 67), '<<=': ('r', 67), '->': ('r', 67), '-=': ('r', 67), '->*': ('r', 67), '+=': ('r', 67), '>=': ('r', 67), '<=': ('r', 67), '||': ('r', 67), '>>=': ('r', 67), '&&': ('r', 67), '|': ('r', 67), '}': ('r', 67), '&=': ('r', 67), '{': ('r', 67), 'try': ('r', 67), '>>': ('r', 67), ']': ('r', 67), '*=': ('r', 67), '==': ('r', 67), '[': ('r', 67), '.*': ('r', 67)}, 388),
        #STATE 389
        State([("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 71)], {')': ('r', 168)}, 389),
        #STATE 390
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("parameter_declaration_clause -> parameter_declaration!+,',':plist ',' '...'", 70), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 25), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('parameter_declaration -> type_descriptor:type declarator:dtor', 25), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), _80: ('g', 112), template_name: ('g', 2), template_id: ('g', 18), nested_name_specifier: ('g', 189), type_name: ('g', 98), 'union': ('s', 97), elaborated_type_specifier: ('g', 109), '::': ('s', 191), enum_specifier: ('g', 122), 'struct': ('s', 58), '...': ('s', 779), class_name: ('g', 11), parameter_declaration: ('g', 270), cv_qualifier: ('g', 106), class_head: ('g', 20), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), class_specifier: ('g', 75), 'class': ('s', 115), 'typename': ('s', 166), namespace_name: ('g', 5), 'auto': ('s', 90), 'volatile': ('s', 33), 'const': ('s', 35), _81: ('g', 88), type_descriptor: ('g', 193), IDENTIFIER: ('s', 29)}, 390),
        #STATE 391
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 100), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63)], {',': ('r', 69), '::': ('s', 237), '{': ('r', 69)}, 391),
        #STATE 392
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('translation_unit -> declaration!*:decls', 33), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ('namespace_definition -> unnamed_namespace_definition!', 24), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 25), ('declaration -> function_definition!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ('block_declaration -> using_declaration!', 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 32), ('type_name -> IDENTIFIER:name', 13), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 33), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ("explicit_instantiation -> 'template' declaration:decl", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> template_declaration!', 15), ('declaration -> CPP_INCLUDE!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> linkage_specification!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('type_name -> template_id!', 13), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_definition -> function_head:head function_try_block:tryb', 23), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 27), ('declaration -> namespace_definition!', 15), ("raw_type_descriptor -> 'auto'", 23), ('block_declaration -> asm_definition!', 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('block_declaration -> simple_declaration!', 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('named_namespace_definition -> original_namespace_definition!', 30), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cv_qualifier -> 'const'!", 16), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ('declaration -> CPP_ERROR!', 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_directive!', 21), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('declaration -> explicit_instantiation!', 15), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('namespace_definition -> named_namespace_definition!', 24), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('translation_unit -> declaration!*:decls', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> named_type_specifier!', 23), ('declaration -> block_declaration!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('declaration -> explicit_specialization!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), named_type_specifier: ('g', 126), 'union': ('s', 97), function_definition: ('g', 128), 'virtual': ('s', 130), explicit_specialization: ('g', 157), declaration: ('g', 132), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), 'extern': ('s', 139), class_name: ('g', 11), using_directive: ('g', 137), class_specifier: ('g', 138), 'typedef': ('s', 136), namespace_definition: ('g', 140), CPP_INCLUDE: ('s', 129), named_namespace_definition: ('g', 142), _75: ('g', 152), 'asm': ('s', 125), original_namespace_definition: ('g', 144), explicit_instantiation: ('g', 146), _81: ('g', 88), type_name: ('g', 131), unnamed_namespace_definition: ('g', 145), 'export': ('s', 143), 'struct': ('s', 58), 'volatile': ('s', 33), 'namespace': ('s', 148), asm_definition: ('g', 149), function_head: ('g', 150), 'auto': ('s', 90), using_declaration: ('g', 127), _80: ('g', 112), '::': ('s', 153), namespace_name: ('g', 5), 'using': ('s', 154), nested_name_specifier: ('g', 155), linkage_specification: ('g', 156), _73: ('g', 133), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), namespace_alias_definition: ('g', 161), template_name: ('g', 2), class_head: ('g', 20), cv_qualifier: ('g', 106), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), '}': ('r', 70), cd_declarator: ('g', 163), simple_declaration: ('g', 167), 'enum': ('s', 117), cd_id: ('g', 164), type_descriptor: ('g', 169), 'class': ('s', 115), block_declaration: ('g', 141), 'typename': ('s', 166), CPP_ERROR: ('s', 151), 'operator': ('s', 168), template_declaration: ('g', 165), 'template': ('s', 147), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 29)}, 392),
        #STATE 393
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 55)], {',': ('r', 71), '>': ('r', 71)}, 393),
        #STATE 394
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 17), ("operator -> 'new' '[' ']'", 18)], {',': ('r', 72), '-': ('r', 72), '.': ('r', 72), '/': ('r', 72), '(': ('r', 72), ')': ('r', 72), '*': ('r', 72), '+': ('r', 72), '%': ('r', 72), '&': ('r', 72), '<': ('r', 72), '=': ('r', 72), '>': ('r', 72), '?': ('r', 72), '<<': ('r', 72), ':': ('r', 72), ';': ('r', 72), '...': ('r', 72), '|=': ('r', 72), '^=': ('r', 72), '%=': ('r', 72), '!=': ('r', 72), '--': ('r', 72), '/=': ('r', 72), '++': ('r', 72), '^': ('r', 72), '<<=': ('r', 72), '->': ('r', 72), '-=': ('r', 72), '->*': ('r', 72), '+=': ('r', 72), '>=': ('r', 72), '<=': ('r', 72), '||': ('r', 72), '>>=': ('r', 72), '&&': ('r', 72), '|': ('r', 72), '}': ('r', 72), '&=': ('r', 72), '{': ('r', 72), 'try': ('r', 72), '>>': ('r', 72), ']': ('r', 72), '*=': ('r', 72), '==': ('r', 72), '[': ('c', [('s', 395), ('r', 72)]), '.*': ('r', 72)}, 394),
        #STATE 395
        State([("operator -> 'new' '[' ']'", 22)], {']': ('s', 461)}, 395),
        #STATE 396
        State([("jump_statement -> 'break' ';'", 29)], {'-': ('r', 73), '++': ('r', 73), '(': ('r', 73), '*': ('r', 73), 'reinterpret_cast': ('r', 73), 'delete': ('r', 73), 'static_cast': ('r', 73), 'virtual': ('r', 73), DECLARE_KEYWORD: ('r', 73), IDENTIFIER: ('r', 73), 'while': ('r', 73), INTEGER_LITERAL: ('r', 73), 'extern': ('r', 73), 'default': ('r', 73), 'goto': ('r', 73), 'break': ('r', 73), 'new': ('r', 73), 'throw': ('r', 73), 'typedef': ('r', 73), '--': ('r', 73), 'asm': ('r', 73), 'dynamic_cast': ('r', 73), 'for': ('r', 73), 'continue': ('r', 73), '+': ('r', 73), 'struct': ('r', 73), 'volatile': ('r', 73), 'namespace': ('r', 73), '&': ('r', 73), 'if': ('r', 73), 'union': ('r', 73), 'const_cast': ('r', 73), '::': ('r', 73), 'auto': ('r', 73), 'using': ('r', 73), 'do': ('r', 73), 'case': ('r', 73), '}': ('r', 73), '~': ('r', 73), 'return': ('r', 73), '{': ('r', 73), 'this': ('r', 73), '!': ('r', 73), CHARACTER_LITERAL: ('r', 73), FLOATING_LITERAL: ('r', 73), 'sizeof': ('r', 73), 'else': ('r', 73), TYPE_KEYWORD: ('r', 73), 'try': ('r', 73), BOOLEAN_LITERAL: ('r', 73), 'enum': ('r', 73), STRING_LITERAL: ('r', 73), 'class': ('r', 73), 'typename': ('r', 73), CPP_ERROR: ('r', 73), 'operator': ('r', 73), 'const': ('r', 73), 'switch': ('r', 73), 'typeid': ('r', 73)}, 396),
        #STATE 397
        State([('unqualified_id -> operator_function_id!', 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 81), ("operator_function_id -> 'operator' operator:op", 24), ('unqualified_id -> IDENTIFIER:id', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unqualified_id -> '~' class_name:name", 18), ('unqualified_id -> conversion_function_id!', 18)], {unqualified_id: ('g', 398), '~': ('s', 45), IDENTIFIER: ('s', 314), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), 'operator': ('s', 8)}, 397),
        #STATE 398
        State([("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 99)], {';': ('s', 869)}, 398),
        #STATE 399
        State([("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 71), ("expression -> expression:a ',' assignment_expression:b", 27)], {',': ('s', 272), ')': ('s', 377)}, 399),
        #STATE 400
        State([("enumerator_definition -> enumerator:name ('=' constant_expression:v)?", 65)], {',': ('r', 74), '}': ('r', 74)}, 400),
        #STATE 401
        State([("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 112)], {',': ('r', 75), '>': ('r', 75)}, 401),
        #STATE 402
        State([("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 83)], {',': ('r', 76), '-': ('r', 76), '.': ('r', 76), '/': ('r', 76), '|=': ('r', 76), ')': ('r', 76), '*': ('r', 76), '+': ('r', 76), '%': ('r', 76), '&': ('r', 76), '{': ('r', 76), '<': ('r', 76), '=': ('r', 76), '>': ('r', 76), '?': ('r', 76), IDENTIFIER: ('r', 76), ':': ('r', 76), ';': ('r', 76), '...': ('r', 76), '(': ('r', 76), '^=': ('r', 76), '::': ('r', 76), '!=': ('r', 76), '--': ('r', 76), '/=': ('r', 76), '++': ('r', 76), '^': ('r', 76), '<<=': ('r', 76), '->': ('r', 76), 'auto': ('r', 76), '-=': ('r', 76), '%=': ('r', 76), '+=': ('r', 76), '>=': ('r', 76), 'union': ('r', 76), '<=': ('r', 76), '<<': ('r', 76), '||': ('r', 76), '>>=': ('r', 76), '&&': ('r', 76), 'const': ('r', 76), '|': ('r', 76), '}': ('r', 76), '~': ('r', 76), 'volatile': ('r', 76), '&=': ('r', 76), 'operator': ('r', 76), 'struct': ('r', 76), '->*': ('r', 76), TYPE_KEYWORD: ('r', 76), 'try': ('r', 76), 'enum': ('r', 76), '>>': ('r', 76), 'class': ('r', 76), ']': ('r', 76), 'typename': ('r', 76), '==': ('r', 76), '*=': ('r', 76), '[': ('r', 76), '.*': ('r', 76)}, 402),
        #STATE 403
        State([("base_clause -> ':' base_specifier!+,','!", 39), None], {',': ('s', 404), '{': ('r', 77)}, 403),
        #STATE 404
        State([('namespace_name -> IDENTIFIER:name', 18), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_clause -> ':' base_specifier!+,','!", 19), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 56), ('class_name -> template_id!', 14), ('access_specifier -> ACCESS_KEYWORD!', 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 29), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ('template_name -> IDENTIFIER!', 17), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18)], {template_name: ('g', 2), access_specifier: ('g', 550), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), base_specifier: ('g', 547), nested_name_specifier: ('g', 523), 'virtual': ('s', 546), ACCESS_KEYWORD: ('s', 258), class_name: ('g', 548), '::': ('s', 549), template_id: ('g', 44)}, 404),
        #STATE 405
        State([("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 71)], {',': ('r', 231), '-': ('r', 231), '.': ('r', 231), '/': ('r', 231), '|=': ('r', 231), ')': ('r', 231), '*': ('r', 231), '+': ('r', 231), '%': ('r', 231), '&': ('r', 231), '{': ('r', 231), '%=': ('r', 231), '<': ('r', 231), '=': ('r', 231), '>': ('r', 231), '?': ('r', 231), IDENTIFIER: ('r', 231), ':': ('r', 231), ';': ('r', 231), '...': ('r', 231), '(': ('r', 231), '^=': ('r', 231), '<<': ('r', 231), '!=': ('r', 231), '--': ('r', 231), '/=': ('r', 231), '++': ('r', 231), '^': ('r', 231), 'typename': ('r', 231), '<<=': ('r', 231), '->': ('r', 231), 'auto': ('r', 231), '-=': ('r', 231), '->*': ('r', 231), '+=': ('r', 231), '>=': ('r', 231), 'union': ('r', 231), '<=': ('r', 231), '::': ('r', 231), '||': ('r', 231), '>>=': ('r', 231), '&&': ('r', 231), 'const': ('r', 231), '|': ('r', 231), '}': ('r', 231), '~': ('r', 231), 'volatile': ('r', 231), '&=': ('r', 231), 'operator': ('r', 231), 'struct': ('r', 231), TYPE_KEYWORD: ('r', 231), 'try': ('r', 231), 'enum': ('r', 231), '>>': ('r', 231), 'class': ('r', 231), ']': ('r', 231), '*=': ('r', 231), '==': ('r', 231), '[': ('r', 231), '.*': ('r', 231)}, 405),
        #STATE 406
        State([("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ('type_name -> template_id!', 13)], {template_name: ('g', 2), IDENTIFIER: ('s', 24), '*': ('s', 732), 'template': ('s', 374), type_name: ('g', 375), template_id: ('g', 26)}, 406),
        #STATE 407
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 71), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 408), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 407),
        #STATE 408
        State([("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 92)], {',': ('r', 191), ']': ('r', 191), '>': ('r', 191), ')': ('r', 191), ':': ('r', 191), '}': ('r', 191), '...': ('r', 191), ';': ('r', 191)}, 408),
        #STATE 409
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 62), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {template_name: ('g', 2), 'auto': ('s', 90), _80: ('g', 112), named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), template_id: ('g', 18), nested_name_specifier: ('g', 189), type_name: ('g', 98), 'union': ('s', 97), elaborated_type_specifier: ('g', 109), IDENTIFIER: ('s', 29), class_specifier: ('g', 75), class_name: ('g', 11), '::': ('s', 191), cv_qualifier: ('g', 106), class_head: ('g', 20), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), _81: ('g', 88), 'class': ('s', 115), type_id: ('g', 410), 'typename': ('s', 166), namespace_name: ('g', 5), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), type_descriptor: ('g', 240), enum_specifier: ('g', 122)}, 409),
        #STATE 410
        State([("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 69)], {',': ('r', 488), '>': ('r', 488)}, 410),
        #STATE 411
        State([('START -> translation_unit <EOF>', 31)], {}, 411),
        #STATE 412
        State([("new_initializer -> '(' assignment_expression!*,','! ')'", 55)], {',': ('r', 78), '-': ('r', 78), '/': ('r', 78), '|=': ('r', 78), ')': ('r', 78), '*': ('r', 78), '+': ('r', 78), '%': ('r', 78), '&': ('r', 78), '>>=': ('r', 78), '&&': ('r', 78), '<': ('r', 78), '=': ('r', 78), '>': ('r', 78), '?': ('r', 78), '<<': ('r', 78), ':': ('r', 78), ';': ('r', 78), '...': ('r', 78), '<=': ('r', 78), '^=': ('r', 78), '%=': ('r', 78), '|': ('r', 78), '!=': ('r', 78), '}': ('r', 78), '/=': ('r', 78), '==': ('r', 78), '||': ('r', 78), '*=': ('r', 78), '&=': ('r', 78), '+=': ('r', 78), ']': ('r', 78), '^': ('r', 78), '<<=': ('r', 78), '-=': ('r', 78), '.*': ('r', 78), '->*': ('r', 78), '>>': ('r', 78), '>=': ('r', 78)}, 412),
        #STATE 413
        State([('namespace_name -> IDENTIFIER:name', 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 52), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 63), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 52), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 90), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), template_id: ('g', 44), nested_name_specifier: ('g', 415), class_name: ('g', 416), '::': ('s', 417)}, 413),
        #STATE 414
        State([('namespace_name -> IDENTIFIER:name', 28), ('template_name -> IDENTIFIER!', 27), ('class_name -> IDENTIFIER:name', 24)], {'<': ('r', 2), ',': ('r', 7), '(': ('r', 7), '::': ('c', [('r', 5), ('r', 7)]), ';': ('r', 5), '{': ('r', 7)}, 414),
        #STATE 415
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 90), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), class_name: ('g', 498), IDENTIFIER: ('s', 173), template_id: ('g', 44)}, 415),
        #STATE 416
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 100), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63)], {',': ('r', 206), '::': ('s', 237), '{': ('r', 206)}, 416),
        #STATE 417
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 63), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 90), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), nested_name_specifier: ('g', 459), class_name: ('g', 238), template_id: ('g', 44)}, 417),
        #STATE 418
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 58), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), expression: ('g', 399), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 418),
        #STATE 419
        State([("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 46)], {',': ('r', 80), 'union': ('r', 80), TYPE_KEYWORD: ('r', 80), 'struct': ('r', 80), 'enum': ('r', 80), 'class': ('r', 80), 'typename': ('r', 80), IDENTIFIER: ('r', 80), 'auto': ('r', 80), 'volatile': ('r', 80), 'const': ('r', 80), '::': ('r', 80)}, 419),
        #STATE 420
        State([('for_init_statement -> simple_declaration:decl', 40)], {'-': ('r', 81), '(': ('r', 81), '::': ('r', 81), '*': ('r', 81), 'reinterpret_cast': ('r', 81), 'delete': ('r', 81), 'static_cast': ('r', 81), 'operator': ('r', 81), '!': ('r', 81), 'union': ('r', 81), 'this': ('r', 81), '~': ('r', 81), IDENTIFIER: ('r', 81), ';': ('r', 81), 'const_cast': ('r', 81), BOOLEAN_LITERAL: ('r', 81), CHARACTER_LITERAL: ('r', 81), 'new': ('r', 81), 'dynamic_cast': ('r', 81), 'sizeof': ('r', 81), TYPE_KEYWORD: ('r', 81), 'class': ('r', 81), '--': ('r', 81), 'struct': ('r', 81), '++': ('r', 81), 'enum': ('r', 81), STRING_LITERAL: ('r', 81), FLOATING_LITERAL: ('r', 81), 'throw': ('r', 81), 'typename': ('r', 81), '+': ('r', 81), 'auto': ('r', 81), 'volatile': ('r', 81), 'const': ('r', 81), INTEGER_LITERAL: ('r', 81), '&': ('r', 81), 'typeid': ('r', 81)}, 420),
        #STATE 421
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 53), ('type_name -> IDENTIFIER:name', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ('unqualified_id -> operator_function_id!', 18), ('unqualified_id -> IDENTIFIER:id', 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('template_name -> IDENTIFIER!', 17), ("operator_function_id -> 'operator' operator:op", 24), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unqualified_id -> conversion_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ("unqualified_id -> '~' class_name:name", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {operator_function_id: ('g', 6), template_name: ('g', 2), '~': ('s', 422), IDENTIFIER: ('s', 423), conversion_function_id: ('g', 424), unqualified_id: ('g', 425), 'template': ('s', 426), 'operator': ('s', 8), template_id: ('g', 26), type_name: ('g', 427)}, 421),
        #STATE 422
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 51), ('template_name -> IDENTIFIER!', 17), ('type_name -> IDENTIFIER:name', 13), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ('type_name -> template_id!', 13), ("unqualified_id -> '~' class_name:name", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {type_name: ('g', 123), template_name: ('g', 2), class_name: ('g', 289), template_id: ('g', 18), IDENTIFIER: ('s', 508)}, 422),
        #STATE 423
        State([('unqualified_id -> IDENTIFIER:id', 28), ('type_name -> IDENTIFIER:name', 23), ('template_name -> IDENTIFIER!', 27)], {',': ('c', [('r', 95), ('r', 6)]), '-': ('r', 95), '.': ('r', 95), '/': ('r', 95), '(': ('c', [('r', 95), ('r', 6)]), ')': ('c', [('r', 95), ('r', 6)]), '*': ('c', [('r', 95), ('r', 6)]), '+': ('r', 95), '%': ('r', 95), '&': ('c', [('r', 95), ('r', 6)]), '::': ('r', 6), '<': ('c', [('r', 95), ('r', 2)]), '=': ('c', [('r', 95), ('r', 6)]), '>': ('c', [('r', 95), ('r', 6)]), '?': ('r', 95), '<<': ('r', 95), IDENTIFIER: ('r', 6), ':': ('c', [('r', 95), ('r', 6)]), ';': ('c', [('r', 95), ('r', 6)]), '...': ('c', [('r', 95), ('r', 6)]), '|=': ('r', 95), '^=': ('r', 95), '%=': ('r', 95), '!=': ('r', 95), '--': ('r', 95), '/=': ('r', 95), '++': ('r', 95), '^': ('r', 95), '<<=': ('r', 95), '->': ('r', 95), '-=': ('r', 95), '->*': ('r', 95), '>>': ('r', 95), '>=': ('r', 95), '<=': ('r', 95), '||': ('r', 95), '>>=': ('r', 95), '&&': ('r', 95), '|': ('r', 95), '}': ('r', 95), '~': ('r', 6), '&=': ('r', 95), 'operator': ('r', 6), '+=': ('r', 95), ']': ('r', 95), '*=': ('r', 95), '==': ('r', 95), '[': ('c', [('r', 95), ('r', 6)]), '.*': ('r', 95)}, 423),
        #STATE 424
        State([('unqualified_id -> conversion_function_id!', 40), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 69)], {',': ('r', 382), '-': ('r', 382), '.': ('r', 382), '/': ('r', 382), '(': ('c', [('r', 382), ('r', 363)]), '<<': ('r', 382), '*': ('r', 382), '+': ('r', 382), '%': ('r', 382), '&': ('r', 382), '>>=': ('r', 382), '&&': ('r', 382), '<': ('r', 382), '=': ('r', 382), '>': ('r', 382), '?': ('r', 382), '<=': ('r', 382), '&=': ('r', 382), ';': ('r', 382), '|=': ('r', 382), '^=': ('r', 382), '%=': ('r', 382), '|': ('r', 382), '==': ('r', 382), '!=': ('r', 382), '--': ('r', 382), '/=': ('r', 382), '[': ('r', 382), '++': ('r', 382), '||': ('r', 382), '*=': ('r', 382), '>>': ('r', 382), '^': ('r', 382), '<<=': ('r', 382), '->': ('r', 382), '-=': ('r', 382), '.*': ('r', 382), '->*': ('r', 382), '+=': ('r', 382), '>=': ('r', 382)}, 424),
        #STATE 425
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 81)], {',': ('r', 477), '-': ('r', 477), '.': ('r', 477), '/': ('r', 477), '|=': ('r', 477), ')': ('r', 477), '*': ('r', 477), '+': ('r', 477), '%': ('r', 477), '&': ('r', 477), '<': ('r', 477), '=': ('r', 477), '>': ('r', 477), '?': ('r', 477), '<<': ('r', 477), ':': ('r', 477), ';': ('r', 477), '...': ('r', 477), '(': ('r', 477), '^=': ('r', 477), '%=': ('r', 477), '!=': ('r', 477), '--': ('r', 477), '/=': ('r', 477), '++': ('r', 477), '^': ('r', 477), '<<=': ('r', 477), '->': ('r', 477), '-=': ('r', 477), '->*': ('r', 477), '>>': ('r', 477), '>=': ('r', 477), '<=': ('r', 477), '||': ('r', 477), '>>=': ('r', 477), '&&': ('r', 477), '|': ('r', 477), '}': ('r', 477), '&=': ('r', 477), '{': ('r', 477), 'try': ('r', 477), '+=': ('r', 477), ']': ('r', 477), '*=': ('r', 477), '==': ('r', 477), '[': ('r', 477), '.*': ('r', 477)}, 425),
        #STATE 426
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("operator_function_id -> 'operator' operator:op", 24), ('template_name -> IDENTIFIER!', 17), ('unqualified_id -> operator_function_id!', 18), ('unqualified_id -> IDENTIFIER:id', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('unqualified_id -> conversion_function_id!', 18), ("unqualified_id -> '~' class_name:name", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 72), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), '~': ('s', 45), IDENTIFIER: ('s', 596), conversion_function_id: ('g', 12), unqualified_id: ('g', 313), operator_function_id: ('g', 6), 'operator': ('s', 8), template_id: ('g', 597)}, 426),
        #STATE 427
        State([("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 71), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 56)], {'~': ('r', 178), '(': ('c', [('r', 178), ('r', 179)]), '::': ('r', 178), '*': ('r', 178), ';': ('r', 178), ':': ('r', 178), '&': ('r', 178), 'operator': ('r', 178), IDENTIFIER: ('r', 178)}, 427),
        #STATE 428
        State([("base_clause -> ':' base_specifier!+,','!", 33)], {',': ('r', 83), '{': ('r', 83)}, 428),
        #STATE 429
        State([('translation_unit -> declaration!*:decls', 31)], {'union': ('r', 84), '::': ('r', 84), 'namespace': ('r', 84), 'export': ('r', 84), 'using': ('r', 84), 'virtual': ('r', 84), DECLARE_KEYWORD: ('r', 84), 'const': ('r', 84), '}': ('r', 84), '~': ('r', 84), IDENTIFIER: ('r', 84), 'operator': ('r', 84), 'extern': ('r', 84), 'typedef': ('r', 84), TYPE_KEYWORD: ('r', 84), 'asm': ('r', 84), 'enum': ('r', 84), EOF: ('r', 84), 'class': ('r', 84), CPP_INCLUDE: ('r', 84), 'typename': ('r', 84), CPP_ERROR: ('r', 84), 'struct': ('r', 84), 'volatile': ('r', 84), 'template': ('r', 84), 'auto': ('r', 84)}, 429),
        #STATE 430
        State([("shift_expression -> shift_expression:a '<<' additive_expression:b", 39), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 39), ("relational_expression -> relational_expression:a '>' shift_expression:b", 69)], {',': ('r', 291), '^': ('r', 291), '|=': ('r', 291), ')': ('r', 291), '==': ('r', 291), '&': ('r', 291), '>>=': ('r', 291), '&&': ('r', 291), '|': ('r', 291), '=': ('r', 291), '>': ('r', 291), '?': ('r', 291), '&=': ('r', 291), ':': ('r', 291), ';': ('r', 291), '...': ('r', 291), '<=': ('r', 291), '^=': ('r', 291), '%=': ('r', 291), '<': ('r', 291), '!=': ('r', 291), '}': ('r', 291), '/=': ('r', 291), '||': ('r', 291), '*=': ('r', 291), '+=': ('r', 291), ']': ('r', 291), '<<': ('s', 449), '<<=': ('r', 291), '-=': ('r', 291), '>>': ('s', 450), '>=': ('r', 291)}, 430),
        #STATE 431
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 81)], {'~': ('s', 1062)}, 431),
        #STATE 432
        State([("direct_new_declarator -> direct_new_declarator:dtor? '[' expression:size ']'", 53), ('new_declarator -> direct_new_declarator!', 39)], {',': ('r', 85), '-': ('r', 85), '/': ('r', 85), '(': ('r', 85), ')': ('r', 85), '*': ('r', 85), '+': ('r', 85), '%': ('r', 85), '&': ('r', 85), '-=': ('r', 85), '&&': ('r', 85), '<': ('r', 85), '=': ('r', 85), '>': ('r', 85), '?': ('r', 85), '<=': ('r', 85), ':': ('r', 85), ';': ('r', 85), '...': ('r', 85), '|=': ('r', 85), '^=': ('r', 85), '%=': ('r', 85), '|': ('r', 85), '>>=': ('r', 85), '!=': ('r', 85), '}': ('r', 85), '/=': ('r', 85), '==': ('r', 85), '||': ('r', 85), '*=': ('r', 85), '&=': ('r', 85), '<<': ('r', 85), ']': ('r', 85), '^': ('r', 85), '<<=': ('r', 85), '>>': ('r', 85), '[': ('s', 433), '.*': ('r', 85), '->*': ('r', 85), '+=': ('r', 85), '>=': ('r', 85)}, 432),
        #STATE 433
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("direct_new_declarator -> direct_new_declarator:dtor? '[' expression:size ']'", 57), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), expression: ('g', 748), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 433),
        #STATE 434
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_name -> template_id!', 14), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('conversion_declarator -> ptr_operator:op conversion_declarator:d?', 25), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('conversion_type_id -> type_descriptor:type conversion_declarator:dtor?', 37), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('conversion_declarator -> ptr_operator:op conversion_declarator:d?', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('conversion_type_id -> type_descriptor:type conversion_declarator:dtor?', 43), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("ptr_operator -> '&'", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {',': ('r', 86), template_name: ('g', 2), '.': ('r', 86), '/': ('r', 86), '(': ('r', 86), ')': ('r', 86), '*': ('c', [('s', 223), ('r', 86)]), '-': ('r', 86), '%': ('r', 86), '&': ('c', [('s', 225), ('r', 86)]), '%=': ('r', 86), '<': ('r', 86), '=': ('r', 86), '>': ('r', 86), '?': ('r', 86), '<<': ('r', 86), IDENTIFIER: ('s', 414), ':': ('r', 86), ';': ('r', 86), '...': ('r', 86), '|=': ('r', 86), class_name: ('g', 11), '^=': ('r', 86), '||': ('r', 86), namespace_name: ('g', 5), '!=': ('r', 86), '--': ('r', 86), '/=': ('r', 86), '++': ('r', 86), '*=': ('r', 86), '<<=': ('r', 86), '->': ('r', 86), '-=': ('r', 86), '->*': ('r', 86), '+=': ('r', 86), '>=': ('r', 86), '<=': ('r', 86), '::': ('s', 435), nested_name_specifier: ('g', 437), '>>=': ('r', 86), '&&': ('r', 86), '|': ('r', 86), '}': ('r', 86), '&=': ('r', 86), '{': ('r', 86), conversion_declarator: ('g', 436), ptr_operator: ('g', 438), 'try': ('r', 86), '>>': ('r', 86), '+': ('r', 86), ']': ('r', 86), '^': ('r', 86), '==': ('r', 86), '[': ('r', 86), '.*': ('r', 86), template_id: ('g', 44)}, 434),
        #STATE 435
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), nested_name_specifier: ('g', 837), class_name: ('g', 11), template_id: ('g', 44)}, 435),
        #STATE 436
        State([('conversion_type_id -> type_descriptor:type conversion_declarator:dtor?', 64)], {',': ('r', 154), '-': ('r', 154), '.': ('r', 154), '/': ('r', 154), '(': ('r', 154), ')': ('r', 154), '*': ('r', 154), '+': ('r', 154), '%': ('r', 154), '&': ('r', 154), '<': ('r', 154), '=': ('r', 154), '>': ('r', 154), '?': ('r', 154), ':': ('r', 154), ';': ('r', 154), '...': ('r', 154), '|=': ('r', 154), '^=': ('r', 154), '%=': ('r', 154), '^': ('r', 154), '!=': ('r', 154), '--': ('r', 154), '/=': ('r', 154), '++': ('r', 154), '*=': ('r', 154), '<<=': ('r', 154), '->': ('r', 154), '-=': ('r', 154), '->*': ('r', 154), '>>': ('r', 154), '>=': ('r', 154), '<=': ('r', 154), '||': ('r', 154), '>>=': ('r', 154), '&&': ('r', 154), '|': ('r', 154), '}': ('r', 154), '&=': ('r', 154), '{': ('r', 154), 'try': ('r', 154), '+=': ('r', 154), ']': ('r', 154), '<<': ('r', 154), '==': ('r', 154), '[': ('r', 154), '.*': ('r', 154)}, 436),
        #STATE 437
        State([("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53)], {'*': ('s', 290)}, 437),
        #STATE 438
        State([('conversion_declarator -> ptr_operator:op conversion_declarator:d?', 37), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_name -> template_id!', 14), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('conversion_declarator -> ptr_operator:op conversion_declarator:d?', 25), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('conversion_declarator -> ptr_operator:op conversion_declarator:d?', 41), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('conversion_declarator -> ptr_operator:op conversion_declarator:d?', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("ptr_operator -> '&'", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {',': ('r', 200), template_name: ('g', 2), '.': ('r', 200), '/': ('r', 200), '(': ('r', 200), ')': ('r', 200), '*': ('c', [('s', 223), ('r', 200)]), '-': ('r', 200), '%': ('r', 200), '&': ('c', [('s', 225), ('r', 200)]), '%=': ('r', 200), '<': ('r', 200), '=': ('r', 200), '>': ('r', 200), '?': ('r', 200), '<<': ('r', 200), IDENTIFIER: ('s', 414), ':': ('r', 200), ';': ('r', 200), '...': ('r', 200), '|=': ('r', 200), class_name: ('g', 11), '^=': ('r', 200), '||': ('r', 200), namespace_name: ('g', 5), '!=': ('r', 200), '--': ('r', 200), '/=': ('r', 200), '++': ('r', 200), '^': ('r', 200), '<<=': ('r', 200), '->': ('r', 200), '-=': ('r', 200), '->*': ('r', 200), '+=': ('r', 200), '>=': ('r', 200), '<=': ('r', 200), '::': ('s', 435), nested_name_specifier: ('g', 437), '>>=': ('r', 200), '&&': ('r', 200), '|': ('r', 200), '}': ('r', 200), '&=': ('r', 200), '{': ('r', 200), conversion_declarator: ('g', 691), ptr_operator: ('g', 438), 'try': ('r', 200), '>>': ('r', 200), '+': ('r', 200), ']': ('r', 200), '*=': ('r', 200), '==': ('r', 200), '[': ('r', 200), '.*': ('r', 200), template_id: ('g', 44)}, 438),
        #STATE 439
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 123), None], {',': ('s', 304), ')': ('s', 440)}, 439),
        #STATE 440
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 126)], {',': ('r', 319), '-': ('r', 319), '.': ('r', 319), '/': ('r', 319), '(': ('r', 319), ')': ('r', 319), '*': ('r', 319), '+': ('r', 319), '%': ('r', 319), '&': ('r', 319), '<': ('r', 319), '=': ('r', 319), '>': ('r', 319), '?': ('r', 319), '<<': ('r', 319), ':': ('r', 319), ';': ('r', 319), '...': ('r', 319), '|=': ('r', 319), '^=': ('r', 319), '%=': ('r', 319), '!=': ('r', 319), '--': ('r', 319), '/=': ('r', 319), '==': ('r', 319), '*=': ('r', 319), '<<=': ('r', 319), '->': ('r', 319), '-=': ('r', 319), '->*': ('r', 319), '+=': ('r', 319), '>=': ('r', 319), '<=': ('r', 319), '||': ('r', 319), '>>=': ('r', 319), '&&': ('r', 319), '|': ('r', 319), '}': ('r', 319), '&=': ('r', 319), '++': ('r', 319), '>>': ('r', 319), ']': ('r', 319), '^': ('r', 319), '[': ('r', 319), '.*': ('r', 319)}, 440),
        #STATE 441
        State([('for_init_statement -> expression_statement!', 42)], {'-': ('r', 87), '(': ('r', 87), '::': ('r', 87), '*': ('r', 87), 'sizeof': ('r', 87), 'delete': ('r', 87), '&': ('r', 87), 'operator': ('r', 87), '!': ('r', 87), 'union': ('r', 87), 'this': ('r', 87), '~': ('r', 87), IDENTIFIER: ('r', 87), ';': ('r', 87), 'const_cast': ('r', 87), TYPE_KEYWORD: ('r', 87), 'new': ('r', 87), 'dynamic_cast': ('r', 87), CHARACTER_LITERAL: ('r', 87), 'class': ('r', 87), '--': ('r', 87), 'reinterpret_cast': ('r', 87), BOOLEAN_LITERAL: ('r', 87), '++': ('r', 87), 'enum': ('r', 87), STRING_LITERAL: ('r', 87), FLOATING_LITERAL: ('r', 87), 'throw': ('r', 87), 'typename': ('r', 87), '+': ('r', 87), 'struct': ('r', 87), 'volatile': ('r', 87), 'const': ('r', 87), INTEGER_LITERAL: ('r', 87), 'static_cast': ('r', 87), 'typeid': ('r', 87), 'auto': ('r', 87)}, 441),
        #STATE 442
        State([("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 81), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 81), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 81), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 81)], {')': ('s', 443)}, 442),
        #STATE 443
        State([('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 103), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 84), ("cv_qualifier -> 'const'!", 16), ("cv_qualifier -> 'volatile'!", 16)], {',': ('r', 341), cv_qualifier: ('g', 106), '(': ('r', 341), _80: ('g', 504), 'try': ('r', 341), '[': ('r', 341), 'throw': ('s', 31), '=': ('r', 341), '>': ('r', 341), ';': ('r', 341), '{': ('r', 341), ':': ('r', 341), 'volatile': ('s', 33), '...': ('r', 341), 'const': ('s', 35), exception_specification: ('g', 923), ')': ('r', 341)}, 443),
        #STATE 444
        State([("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 106)], {'-': ('r', 88), 'asm': ('r', 88), '(': ('r', 88), '*': ('r', 88), '+': ('r', 88), 'delete': ('r', 88), 'static_cast': ('r', 88), 'virtual': ('r', 88), DECLARE_KEYWORD: ('r', 88), IDENTIFIER: ('r', 88), 'while': ('r', 88), INTEGER_LITERAL: ('r', 88), 'extern': ('r', 88), 'default': ('r', 88), 'goto': ('r', 88), 'new': ('r', 88), 'throw': ('r', 88), 'typedef': ('r', 88), '--': ('r', 88), '++': ('r', 88), 'dynamic_cast': ('r', 88), 'for': ('r', 88), 'continue': ('r', 88), 'struct': ('r', 88), 'volatile': ('r', 88), 'namespace': ('r', 88), '&': ('r', 88), 'if': ('r', 88), 'union': ('r', 88), 'const_cast': ('r', 88), '::': ('r', 88), 'auto': ('r', 88), 'using': ('r', 88), 'do': ('r', 88), 'case': ('r', 88), '}': ('r', 88), '~': ('r', 88), 'return': ('r', 88), '{': ('r', 88), 'this': ('r', 88), '!': ('r', 88), CHARACTER_LITERAL: ('r', 88), FLOATING_LITERAL: ('r', 88), 'sizeof': ('r', 88), 'else': ('r', 88), TYPE_KEYWORD: ('r', 88), 'try': ('r', 88), 'reinterpret_cast': ('r', 88), BOOLEAN_LITERAL: ('r', 88), 'enum': ('r', 88), STRING_LITERAL: ('r', 88), 'class': ('r', 88), 'typename': ('r', 88), 'break': ('r', 88), 'operator': ('r', 88), CPP_ERROR: ('r', 88), 'const': ('r', 88), 'switch': ('r', 88), 'typeid': ('r', 88)}, 444),
        #STATE 445
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 80), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), ')': ('s', 446), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), _15: ('g', 447), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 323), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), named_type_specifier: ('g', 177), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 445),
        #STATE 446
        State([("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 83)], {',': ('r', 176), '-': ('r', 176), '.': ('r', 176), '/': ('r', 176), '|=': ('r', 176), ')': ('r', 176), '*': ('r', 176), '+': ('r', 176), '%': ('r', 176), '&': ('r', 176), '<': ('r', 176), '=': ('r', 176), '>': ('r', 176), '?': ('r', 176), '<<': ('r', 176), ':': ('r', 176), ';': ('r', 176), '...': ('r', 176), '(': ('r', 176), '^=': ('r', 176), '%=': ('r', 176), '!=': ('r', 176), '--': ('r', 176), '/=': ('r', 176), '==': ('r', 176), '*=': ('r', 176), '<<=': ('r', 176), '->': ('r', 176), '-=': ('r', 176), '->*': ('r', 176), '+=': ('r', 176), '>=': ('r', 176), '<=': ('r', 176), '||': ('r', 176), '>>=': ('r', 176), '&&': ('r', 176), '|': ('r', 176), '}': ('r', 176), '&=': ('r', 176), '++': ('r', 176), '>>': ('r', 176), ']': ('r', 176), '^': ('r', 176), '[': ('r', 176), '.*': ('r', 176)}, 446),
        #STATE 447
        State([None, ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 80)], {',': ('s', 304), ')': ('s', 490)}, 447),
        #STATE 448
        State([("shift_expression -> shift_expression:a '<<' additive_expression:b", 39), ("relational_expression -> relational_expression:a '<' shift_expression:b", 69), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 39)], {',': ('r', 89), '|=': ('r', 89), ')': ('r', 89), '==': ('r', 89), '&': ('r', 89), '>>=': ('r', 89), '&&': ('r', 89), '|': ('r', 89), '=': ('r', 89), '>': ('r', 89), '?': ('r', 89), '&=': ('r', 89), ':': ('r', 89), ';': ('r', 89), '...': ('r', 89), '<=': ('r', 89), '^=': ('r', 89), '%=': ('r', 89), '<': ('r', 89), '!=': ('r', 89), '}': ('r', 89), '/=': ('r', 89), '||': ('r', 89), '^': ('r', 89), '+=': ('r', 89), ']': ('r', 89), '<<': ('s', 449), '<<=': ('r', 89), '*=': ('r', 89), '-=': ('r', 89), '>>': ('s', 450), '>=': ('r', 89)}, 448),
        #STATE 449
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 44), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), additive_expression: ('g', 973), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 449),
        #STATE 450
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 44), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), additive_expression: ('g', 759), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 450),
        #STATE 451
        State([("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 90), None], {',': ('s', 452), ';': ('s', 453)}, 451),
        #STATE 452
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('init_declarator -> declarator:d initializer:init?', 19), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("operator_function_id -> 'operator' operator:op", 24), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('declarator -> direct_declarator!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('direct_declarator -> declarator_id!', 21), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('declarator_id -> id_expression!', 17), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("qualified_id -> '::' IDENTIFIER!", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('id_expression -> qualified_id!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 63), ('unqualified_id -> operator_function_id!', 18), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('unqualified_id -> IDENTIFIER:id', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('init_declarator -> declarator:d initializer:init?', 19), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('unqualified_id -> conversion_function_id!', 18), ("ptr_operator -> '&'", 16), ("unqualified_id -> '~' class_name:name", 18), ("direct_declarator -> '(' declarator! ')'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), '(': ('s', 281), qualified_id: ('g', 4), '*': ('s', 223), unqualified_id: ('g', 7), nested_name_specifier: ('g', 284), '&': ('s', 225), init_declarator: ('g', 602), '~': ('s', 45), IDENTIFIER: ('s', 46), 'operator': ('s', 8), direct_declarator: ('g', 285), class_name: ('g', 11), ptr_operator: ('g', 279), '::': ('s', 282), namespace_name: ('g', 5), declarator_id: ('g', 286), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), template_id: ('g', 44), id_expression: ('g', 280), declarator: ('g', 603)}, 452),
        #STATE 453
        State([("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 93)], {'-': ('r', 346), '++': ('r', 346), '(': ('r', 346), '*': ('r', 346), '+': ('r', 346), 'delete': ('r', 346), 'static_cast': ('r', 346), 'virtual': ('r', 346), DECLARE_KEYWORD: ('r', 346), ACCESS_KEYWORD: ('r', 346), IDENTIFIER: ('r', 346), ';': ('r', 346), INTEGER_LITERAL: ('r', 346), 'extern': ('r', 346), 'default': ('r', 346), 'goto': ('r', 346), 'break': ('r', 346), 'new': ('r', 346), 'throw': ('r', 346), 'typedef': ('r', 346), '--': ('r', 346), 'asm': ('r', 346), 'dynamic_cast': ('r', 346), 'for': ('r', 346), 'export': ('r', 346), 'struct': ('r', 346), 'template': ('r', 346), 'continue': ('r', 346), '&': ('r', 346), 'this': ('r', 346), 'if': ('r', 346), 'union': ('r', 346), 'const_cast': ('r', 346), '::': ('r', 346), 'auto': ('r', 346), 'using': ('r', 346), 'volatile': ('r', 346), 'namespace': ('r', 346), 'do': ('r', 346), '!': ('r', 346), '}': ('r', 346), '~': ('r', 346), 'return': ('r', 346), '{': ('r', 346), 'case': ('r', 346), TYPE_KEYWORD: ('r', 346), FLOATING_LITERAL: ('r', 346), 'sizeof': ('r', 346), 'else': ('r', 346), CHARACTER_LITERAL: ('r', 346), 'try': ('r', 346), 'reinterpret_cast': ('r', 346), BOOLEAN_LITERAL: ('r', 346), 'enum': ('r', 346), EOF: ('r', 346), STRING_LITERAL: ('r', 346), 'class': ('r', 346), CPP_INCLUDE: ('r', 346), 'typename': ('r', 346), 'while': ('r', 346), CPP_ERROR: ('r', 346), 'operator': ('r', 346), 'const': ('r', 346), 'switch': ('r', 346), 'typeid': ('r', 346)}, 453),
        #STATE 454
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 76)], {'::': ('s', 455)}, 454),
        #STATE 455
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 81)], {'~': ('s', 652)}, 455),
        #STATE 456
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 45), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {named_type_specifier: ('g', 126), template_name: ('g', 2), IDENTIFIER: ('s', 29), '::': ('s', 191), raw_type_descriptor: ('g', 54), template_id: ('g', 18), namespace_name: ('g', 5), cv_qualifier: ('g', 106), type_name: ('g', 98), 'union': ('s', 97), type_descriptor: ('g', 240), elaborated_type_specifier: ('g', 109), enum_specifier: ('g', 122), class_name: ('g', 11), TYPE_KEYWORD: ('s', 162), class_specifier: ('g', 75), class_head: ('g', 20), class_key: ('g', 78), _80: ('g', 112), _81: ('g', 88), 'class': ('s', 115), type_id: ('g', 457), 'typename': ('s', 166), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), nested_name_specifier: ('g', 189), 'enum': ('s', 117), 'auto': ('s', 90)}, 456),
        #STATE 457
        State([("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 55)], {'>': ('s', 808)}, 457),
        #STATE 458
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 78)], {',': ('r', 90), '-': ('r', 90), '.': ('r', 90), '/': ('r', 90), '(': ('r', 90), ')': ('r', 90), '*': ('r', 90), '+': ('r', 90), '%': ('r', 90), '&': ('r', 90), '<': ('r', 90), '=': ('r', 90), '>': ('r', 90), '?': ('r', 90), '<<': ('r', 90), ':': ('r', 90), ';': ('r', 90), '...': ('r', 90), '|=': ('r', 90), '^=': ('r', 90), '%=': ('r', 90), '!=': ('r', 90), '--': ('r', 90), '/=': ('r', 90), '++': ('r', 90), '^': ('r', 90), '<<=': ('r', 90), '->': ('r', 90), '-=': ('r', 90), '->*': ('r', 90), '+=': ('r', 90), '>=': ('r', 90), '<=': ('r', 90), '||': ('r', 90), '>>=': ('r', 90), '&&': ('r', 90), '|': ('r', 90), '}': ('r', 90), '&=': ('r', 90), '{': ('r', 90), 'try': ('r', 90), '>>': ('r', 90), ']': ('r', 90), '*=': ('r', 90), '==': ('r', 90), '[': ('r', 90), '.*': ('r', 90)}, 458),
        #STATE 459
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ('class_name -> IDENTIFIER:name', 14), ('class_name -> template_id!', 14), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 90), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), class_name: ('g', 460), IDENTIFIER: ('s', 173), template_id: ('g', 44)}, 459),
        #STATE 460
        State([("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 100)], {',': ('r', 284), '{': ('r', 284)}, 460),
        #STATE 461
        State([("operator -> 'new' '[' ']'", 25)], {',': ('r', 91), '-': ('r', 91), '.': ('r', 91), '/': ('r', 91), '(': ('r', 91), ')': ('r', 91), '*': ('r', 91), '+': ('r', 91), '%': ('r', 91), '&': ('r', 91), '<': ('r', 91), '=': ('r', 91), '>': ('r', 91), '?': ('r', 91), ':': ('r', 91), ';': ('r', 91), '...': ('r', 91), '|=': ('r', 91), '^=': ('r', 91), '%=': ('r', 91), '^': ('r', 91), '!=': ('r', 91), '--': ('r', 91), '/=': ('r', 91), '++': ('r', 91), '*=': ('r', 91), '<<=': ('r', 91), '->': ('r', 91), '-=': ('r', 91), '->*': ('r', 91), '+=': ('r', 91), '>=': ('r', 91), '<=': ('r', 91), '||': ('r', 91), '>>=': ('r', 91), '&&': ('r', 91), '|': ('r', 91), '}': ('r', 91), '&=': ('r', 91), '{': ('r', 91), 'try': ('r', 91), '>>': ('r', 91), ']': ('r', 91), '<<': ('r', 91), '==': ('r', 91), '[': ('r', 91), '.*': ('r', 91)}, 461),
        #STATE 462
        State([("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 58), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 61)], {'=': ('s', 463), '{': ('s', 464)}, 462),
        #STATE 463
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("qualified_namespace_specifier -> '::'?:glbl nested_name_specifier:nns? namespace_name:name", 71), ("qualified_namespace_specifier -> '::'?:glbl nested_name_specifier:nns? namespace_name:name", 44), ("qualified_namespace_specifier -> '::'?:glbl nested_name_specifier:nns? namespace_name:name", 33), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 62), ("qualified_namespace_specifier -> '::'?:glbl nested_name_specifier:nns? namespace_name:name", 33), ('class_name -> template_id!', 14), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {namespace_name: ('g', 611), IDENTIFIER: ('s', 414), template_name: ('g', 2), template_id: ('g', 44), nested_name_specifier: ('g', 907), class_name: ('g', 11), '::': ('s', 698), qualified_namespace_specifier: ('g', 768)}, 463),
        #STATE 464
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('named_namespace_definition -> original_namespace_definition!', 30), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ('namespace_definition -> unnamed_namespace_definition!', 24), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 25), ('declaration -> function_definition!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ('block_declaration -> using_declaration!', 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 32), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('type_name -> IDENTIFIER:name', 13), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 33), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('translation_unit -> declaration!*:decls', 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ("explicit_instantiation -> 'template' declaration:decl", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> template_declaration!', 15), ('declaration -> CPP_INCLUDE!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('translation_unit -> declaration!*:decls', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("decl_attrib -> 'virtual'!", 15), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('function_definition -> function_head:head function_try_block:tryb', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('type_name -> template_id!', 13), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('declaration -> linkage_specification!', 15), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 27), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("raw_type_descriptor -> 'auto'", 23), ('block_declaration -> asm_definition!', 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('block_declaration -> simple_declaration!', 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ("decl_attrib -> 'extern'!", 15), ('declaration -> CPP_ERROR!', 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ('declaration -> namespace_definition!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_directive!', 21), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('declaration -> explicit_instantiation!', 15), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 65), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), None, ('type_descriptor -> raw_type_descriptor!', 19), ('translation_unit -> declaration!*:decls', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('namespace_definition -> named_namespace_definition!', 24), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> named_type_specifier!', 23), ('declaration -> block_declaration!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('declaration -> explicit_specialization!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), named_type_specifier: ('g', 126), 'union': ('s', 97), function_definition: ('g', 128), 'virtual': ('s', 130), explicit_specialization: ('g', 157), cd_id: ('g', 164), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), 'struct': ('s', 58), 'extern': ('s', 139), class_name: ('g', 11), using_directive: ('g', 137), class_specifier: ('g', 138), 'typedef': ('s', 136), namespace_definition: ('g', 140), CPP_INCLUDE: ('s', 129), named_namespace_definition: ('g', 142), _75: ('g', 152), 'asm': ('s', 125), original_namespace_definition: ('g', 144), explicit_instantiation: ('g', 146), _81: ('g', 88), type_name: ('g', 131), unnamed_namespace_definition: ('g', 145), _1: ('g', 392), 'export': ('s', 143), namespace_body: ('g', 841), 'auto': ('s', 90), 'volatile': ('s', 33), type_descriptor: ('g', 169), namespace_alias_definition: ('g', 161), function_head: ('g', 150), simple_declaration: ('g', 167), using_declaration: ('g', 127), '::': ('s', 153), namespace_name: ('g', 5), 'using': ('s', 154), asm_definition: ('g', 149), linkage_specification: ('g', 156), _73: ('g', 133), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), 'namespace': ('s', 148), template_name: ('g', 2), class_head: ('g', 20), cv_qualifier: ('g', 106), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), '}': ('r', 278), cd_declarator: ('g', 163), _80: ('g', 112), declaration: ('g', 429), template_id: ('g', 18), 'class': ('s', 115), block_declaration: ('g', 141), 'typename': ('s', 166), CPP_ERROR: ('s', 151), 'operator': ('s', 168), template_declaration: ('g', 165), 'template': ('s', 147), nested_name_specifier: ('g', 155), 'enum': ('s', 117), class_key: ('g', 78), IDENTIFIER: ('s', 29)}, 464),
        #STATE 465
        State([("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 61), None, ("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 56)], {',': ('s', 466), '}': ('s', 467)}, 465),
        #STATE 466
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("initializer_clause -> '{' '}'", 22), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 26), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 22), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 61), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('initializer_clause -> assignment_expression!', 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), '{': ('s', 656), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), initializer_clause: ('g', 653), equality_expression: ('g', 70), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), literal: ('g', 84), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), conditional_expression: ('g', 77), assignment_expression: ('g', 655), conversion_function_id: ('g', 12), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), '}': ('s', 654), '~': ('s', 100), '--': ('s', 111), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), postfix_expression: ('g', 99), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), INTEGER_LITERAL: ('s', 87), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 466),
        #STATE 467
        State([("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 64)], {',': ('r', 213), '}': ('r', 213), ';': ('r', 213)}, 467),
        #STATE 468
        State([("shift_expression -> shift_expression:a '<<' additive_expression:b", 39), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 39), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 70)], {',': ('r', 245), '^': ('r', 245), '|=': ('r', 245), ')': ('r', 245), '==': ('r', 245), '&': ('r', 245), '>>=': ('r', 245), '&&': ('r', 245), '|': ('r', 245), '=': ('r', 245), '>': ('r', 245), '?': ('r', 245), '&=': ('r', 245), ':': ('r', 245), ';': ('r', 245), '...': ('r', 245), '<=': ('r', 245), '^=': ('r', 245), '%=': ('r', 245), '<': ('r', 245), '!=': ('r', 245), '}': ('r', 245), '/=': ('r', 245), '||': ('r', 245), '*=': ('r', 245), '+=': ('r', 245), ']': ('r', 245), '<<': ('s', 449), '<<=': ('r', 245), '-=': ('r', 245), '>>': ('s', 450), '>=': ('r', 245)}, 468),
        #STATE 469
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 70)], {',': ('r', 93), '-': ('r', 93), '.': ('r', 93), '/': ('r', 93), '|=': ('r', 93), ')': ('r', 93), '*': ('r', 93), '+': ('r', 93), '%': ('r', 93), '&': ('r', 93), '{': ('r', 93), '<': ('r', 93), '=': ('r', 93), '>': ('r', 93), '?': ('r', 93), IDENTIFIER: ('r', 93), ':': ('r', 93), ';': ('r', 93), '...': ('r', 93), '(': ('r', 93), '^=': ('r', 93), '::': ('r', 93), '!=': ('r', 93), '--': ('r', 93), '/=': ('r', 93), '++': ('r', 93), '^': ('r', 93), '<<=': ('r', 93), '->': ('r', 93), 'auto': ('r', 93), '-=': ('r', 93), '%=': ('r', 93), '+=': ('r', 93), '>=': ('r', 93), 'union': ('r', 93), '<=': ('r', 93), '<<': ('r', 93), '||': ('r', 93), '>>=': ('r', 93), '&&': ('r', 93), 'const': ('r', 93), '|': ('r', 93), '}': ('r', 93), '~': ('r', 93), 'volatile': ('r', 93), '&=': ('r', 93), 'operator': ('r', 93), 'struct': ('r', 93), '->*': ('r', 93), TYPE_KEYWORD: ('r', 93), 'try': ('r', 93), 'enum': ('r', 93), '>>': ('r', 93), 'class': ('r', 93), ']': ('r', 93), 'typename': ('r', 93), '==': ('r', 93), '*=': ('r', 93), '[': ('r', 93), '.*': ('r', 93)}, 469),
        #STATE 470
        State([("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 40)], {']': ('s', 471)}, 470),
        #STATE 471
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('namespace_name -> IDENTIFIER:name', 18), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> FLOATING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 44), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), operator_function_id: ('g', 6), delete_expression: ('g', 119), cast_expression: ('g', 1008), 'typeid': ('s', 38)}, 471),
        #STATE 472
        State([("initializer_clause -> '{' '}'", 29)], {',': ('r', 94), '}': ('r', 94), ';': ('r', 94)}, 472),
        #STATE 473
        State([('class_name -> IDENTIFIER:name', 24), ('namespace_name -> IDENTIFIER:name', 28), ("member_declarator -> IDENTIFIER:name? ':' constant_expression:size", 38), ('template_name -> IDENTIFIER!', 27), ('unqualified_id -> IDENTIFIER:id', 28)], {'<': ('r', 2), ',': ('r', 95), '=': ('r', 95), '[': ('r', 95), '(': ('r', 95), '::': ('c', [('r', 7), ('r', 5)]), ':': ('c', [('s', 474), ('r', 95)]), 'try': ('r', 95), ';': ('r', 95), '{': ('r', 95)}, 473),
        #STATE 474
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('constant_expression -> conditional_expression!', 23), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("member_declarator -> IDENTIFIER:name? ':' constant_expression:size", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), '!': ('s', 104), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 774), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 310), class_name: ('g', 11), type_name: ('g', 98), literal: ('g', 84), 'dynamic_cast': ('s', 83), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), constant_expression: ('g', 381), 'const_cast': ('s', 92), qualified_id: ('g', 4), exclusive_or_expression: ('g', 121), nested_name_specifier: ('g', 95), new_expression: ('g', 94), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 474),
        #STATE 475
        State([("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 73)], {';': ('s', 242)}, 475),
        #STATE 476
        State([("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 49)], {'<': ('s', 195)}, 476),
        #STATE 477
        State([('parameter_declaration -> type_descriptor:type declarator:dtor', 56), ("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 62)], {',': ('r', 97), '=': ('s', 478), '>': ('r', 97), ')': ('r', 97), '...': ('r', 97)}, 477),
        #STATE 478
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 66), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 608), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 478),
        #STATE 479
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 39), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {template_name: ('g', 2), 'auto': ('s', 90), _80: ('g', 112), named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), template_id: ('g', 18), nested_name_specifier: ('g', 189), type_name: ('g', 98), 'union': ('s', 97), elaborated_type_specifier: ('g', 109), IDENTIFIER: ('s', 29), class_specifier: ('g', 75), class_name: ('g', 11), '::': ('s', 191), cv_qualifier: ('g', 106), class_head: ('g', 20), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), _81: ('g', 88), 'class': ('s', 115), type_id: ('g', 970), 'typename': ('s', 166), namespace_name: ('g', 5), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), type_descriptor: ('g', 240), enum_specifier: ('g', 122)}, 479),
        #STATE 480
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 70), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 70)], {')': ('s', 299)}, 480),
        #STATE 481
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ('statement -> iteration_statement!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> CPP_ERROR!', 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('block_declaration -> asm_definition!', 21), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ('statement -> compound_statement!', 13), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ('statement -> jump_statement!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("compound_statement -> '{' statement!*:sts '}'", 26), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ('statement -> labeled_statement!', 13), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unary_expression -> postfix_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_name -> template_id!', 13), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), 'asm': ('s', 125), compound_statement: ('g', 339), pm_expression: ('g', 73), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), class_name: ('g', 11), 'default': ('s', 330), _80: ('g', 112), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), '}': ('s', 482), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), 'namespace': ('s', 170), asm_definition: ('g', 149), expression: ('g', 335), STRING_LITERAL: ('s', 113), 'auto': ('s', 90), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), 'try': ('s', 334), DECLARE_KEYWORD: ('s', 160), selection_statement: ('g', 340), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), operator_function_id: ('g', 6), INTEGER_LITERAL: ('s', 87), 'enum': ('s', 117), block_declaration: ('g', 344), 'typename': ('s', 116), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), 'while': ('s', 349), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 483), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), nested_name_specifier: ('g', 352), 'union': ('s', 97), 'case': ('s', 356), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'do': ('s', 355), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), conversion_function_id: ('g', 357), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), declaration_statement: ('g', 343), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 481),
        #STATE 482
        State([("compound_statement -> '{' statement!*:sts '}'", 45)], {'-': ('r', 451), '++': ('r', 451), '(': ('r', 451), '*': ('r', 451), '+': ('r', 451), 'delete': ('r', 451), 'static_cast': ('r', 451), 'virtual': ('r', 451), '!': ('r', 451), ACCESS_KEYWORD: ('r', 451), IDENTIFIER: ('r', 451), ';': ('r', 451), INTEGER_LITERAL: ('r', 451), 'extern': ('r', 451), 'default': ('r', 451), 'goto': ('r', 451), 'break': ('r', 451), 'new': ('r', 451), 'class': ('r', 451), 'typedef': ('r', 451), '--': ('r', 451), 'catch': ('r', 451), 'asm': ('r', 451), 'dynamic_cast': ('r', 451), 'for': ('r', 451), 'export': ('r', 451), 'struct': ('r', 451), 'template': ('r', 451), 'continue': ('r', 451), '&': ('r', 451), 'this': ('r', 451), 'if': ('r', 451), 'union': ('r', 451), 'const_cast': ('r', 451), '::': ('r', 451), 'auto': ('r', 451), 'using': ('r', 451), 'volatile': ('r', 451), 'namespace': ('r', 451), 'do': ('r', 451), DECLARE_KEYWORD: ('r', 451), '}': ('r', 451), '~': ('r', 451), 'return': ('r', 451), '{': ('r', 451), 'case': ('r', 451), TYPE_KEYWORD: ('r', 451), FLOATING_LITERAL: ('r', 451), 'sizeof': ('r', 451), 'else': ('r', 451), CHARACTER_LITERAL: ('r', 451), 'try': ('r', 451), 'reinterpret_cast': ('r', 451), BOOLEAN_LITERAL: ('r', 451), 'enum': ('r', 451), EOF: ('r', 451), STRING_LITERAL: ('r', 451), 'throw': ('r', 451), CPP_INCLUDE: ('r', 451), 'typename': ('r', 451), 'while': ('r', 451), CPP_ERROR: ('r', 451), 'operator': ('r', 451), 'const': ('r', 451), 'switch': ('r', 451), 'typeid': ('r', 451)}, 482),
        #STATE 483
        State([("compound_statement -> '{' statement!*:sts '}'", 35)], {'-': ('r', 339), 'asm': ('r', 339), '(': ('r', 339), '*': ('r', 339), '+': ('r', 339), 'delete': ('r', 339), '&': ('r', 339), 'virtual': ('r', 339), DECLARE_KEYWORD: ('r', 339), IDENTIFIER: ('r', 339), 'while': ('r', 339), INTEGER_LITERAL: ('r', 339), 'extern': ('r', 339), 'default': ('r', 339), 'goto': ('r', 339), 'break': ('r', 339), 'new': ('r', 339), 'class': ('r', 339), 'typedef': ('r', 339), '--': ('r', 339), '++': ('r', 339), 'dynamic_cast': ('r', 339), 'for': ('r', 339), 'continue': ('r', 339), 'auto': ('r', 339), 'volatile': ('r', 339), 'namespace': ('r', 339), 'static_cast': ('r', 339), 'if': ('r', 339), 'union': ('r', 339), 'const_cast': ('r', 339), '::': ('r', 339), 'using': ('r', 339), 'do': ('r', 339), 'this': ('r', 339), '}': ('r', 339), '~': ('r', 339), 'return': ('r', 339), '{': ('r', 339), 'case': ('r', 339), '!': ('r', 339), TYPE_KEYWORD: ('r', 339), FLOATING_LITERAL: ('r', 339), 'sizeof': ('r', 339), CHARACTER_LITERAL: ('r', 339), 'try': ('r', 339), 'reinterpret_cast': ('r', 339), 'struct': ('r', 339), 'enum': ('r', 339), STRING_LITERAL: ('r', 339), 'throw': ('r', 339), 'typename': ('r', 339), 'switch': ('r', 339), 'operator': ('r', 339), BOOLEAN_LITERAL: ('r', 339), CPP_ERROR: ('r', 339), 'const': ('r', 339), 'typeid': ('r', 339)}, 483),
        #STATE 484
        State([("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), None, ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("cv_qualifier -> 'const'!", 16), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("cv_qualifier -> 'volatile'!", 16), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("direct_declarator -> '(' declarator! ')'", 21), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('direct_declarator -> declarator_id!', 21), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('type_name -> IDENTIFIER:name', 13), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('declarator -> ptr_operator:op declarator:d', 14), ('unqualified_id -> operator_function_id!', 18), ('abstract_declarator -> direct_abstract_declarator!', 23), ("direct_declarator -> '(' declarator! ')'", 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("direct_abstract_declarator -> '(' abstract_declarator! ')'", 34), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t base_clause:bases?', 14), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("raw_type_descriptor -> 'auto'", 23), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 66), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ('unqualified_id -> conversion_function_id!', 18), ("operator_function_id -> 'operator' operator:op", 24), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 64), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 64), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('raw_type_descriptor -> enum_specifier!', 23), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ('declarator -> direct_declarator!', 14), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('parameter_declaration -> type_descriptor:type declarator:dtor', 25), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('declarator_id -> id_expression!', 17), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 64), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('raw_type_descriptor -> named_type_specifier!', 23), ('namespace_name -> IDENTIFIER:name', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("class_key -> 'class' | 'struct' | 'union'", 13), ("direct_abstract_declarator -> '(' abstract_declarator! ')'", 30), ('type_name -> template_id!', 13), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 64), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('class_name -> IDENTIFIER:name', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("qualified_id -> '::' IDENTIFIER!", 16), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("ptr_operator -> '&'", 16), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("unqualified_id -> '~' class_name:name", 18), ('raw_type_descriptor -> class_specifier!', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {raw_type_descriptor: ('g', 54), declarator_id: ('g', 286), '(': ('s', 484), named_type_specifier: ('g', 126), '*': ('s', 223), template_name: ('g', 2), 'enum': ('s', 117), '&': ('s', 225), type_name: ('g', 98), '::': ('s', 737), elaborated_type_specifier: ('g', 109), enum_specifier: ('g', 122), '...': ('s', 192), _81: ('g', 88), parameter_declaration: ('g', 190), namespace_name: ('g', 5), class_head: ('g', 20), class_key: ('g', 78), class_name: ('g', 11), 'struct': ('s', 58), 'volatile': ('s', 33), id_expression: ('g', 280), 'auto': ('s', 90), 'union': ('s', 97), qualified_id: ('g', 4), class_specifier: ('g', 75), template_id: ('g', 18), nested_name_specifier: ('g', 738), ')': ('r', 19), conversion_function_id: ('g', 12), '~': ('s', 45), declarator: ('g', 297), 'operator': ('s', 8), direct_declarator: ('g', 285), direct_abstract_declarator: ('g', 231), ptr_operator: ('g', 486), _100: ('g', 188), cv_qualifier: ('g', 106), TYPE_KEYWORD: ('s', 162), operator_function_id: ('g', 6), _80: ('g', 112), parameter_declaration_clause: ('g', 228), 'class': ('s', 115), 'typename': ('s', 166), abstract_declarator: ('g', 230), unqualified_id: ('g', 7), '[': ('s', 226), 'const': ('s', 35), type_descriptor: ('g', 193), IDENTIFIER: ('s', 3)}, 484),
        #STATE 485
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 76), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 962), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 485),
        #STATE 486
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 35), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('declarator -> direct_declarator!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('declarator -> ptr_operator:op declarator:d', 30), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("direct_abstract_declarator -> '(' abstract_declarator! ')'", 30), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ('direct_declarator -> declarator_id!', 21), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ('declarator_id -> id_expression!', 17), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("qualified_id -> '::' IDENTIFIER!", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ('abstract_declarator -> direct_abstract_declarator!', 23), ('id_expression -> qualified_id!', 17), ('namespace_name -> IDENTIFIER:name', 18), ('unqualified_id -> IDENTIFIER:id', 18), ('unqualified_id -> operator_function_id!', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("operator_function_id -> 'operator' operator:op", 24), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ('unqualified_id -> conversion_function_id!', 18), ("ptr_operator -> '&'", 16), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 39), ("unqualified_id -> '~' class_name:name", 18), ("direct_declarator -> '(' declarator! ')'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {',': ('r', 142), template_name: ('g', 2), '(': ('s', 484), qualified_id: ('g', 4), '*': ('s', 223), unqualified_id: ('g', 7), nested_name_specifier: ('g', 284), '&': ('s', 225), ')': ('r', 142), conversion_function_id: ('g', 12), '~': ('s', 45), declarator: ('g', 283), 'operator': ('s', 8), '...': ('r', 142), direct_declarator: ('g', 285), ptr_operator: ('g', 486), '::': ('s', 282), id_expression: ('g', 280), namespace_name: ('g', 5), declarator_id: ('g', 286), '=': ('r', 142), operator_function_id: ('g', 6), '>': ('r', 142), class_name: ('g', 11), abstract_declarator: ('g', 578), '[': ('s', 226), direct_abstract_declarator: ('g', 231), template_id: ('g', 44), IDENTIFIER: ('s', 46)}, 486),
        #STATE 487
        State([('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 65), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 72)], {',': ('r', 269), '=': ('s', 696), '>': ('r', 269), ')': ('r', 269), '...': ('r', 269)}, 487),
        #STATE 488
        State([("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 69)], {',': ('r', 100), '-': ('r', 100), '.': ('r', 100), '/': ('r', 100), '|=': ('r', 100), ')': ('r', 100), '*': ('r', 100), '+': ('r', 100), '%': ('r', 100), '&': ('r', 100), '<': ('r', 100), '=': ('r', 100), '>': ('r', 100), '?': ('r', 100), '<<': ('r', 100), ':': ('r', 100), ';': ('r', 100), '...': ('r', 100), '(': ('r', 100), '^=': ('r', 100), '%=': ('r', 100), '!=': ('r', 100), '--': ('r', 100), '/=': ('r', 100), '==': ('r', 100), '*=': ('r', 100), '<<=': ('r', 100), '->': ('r', 100), '-=': ('r', 100), '->*': ('r', 100), '+=': ('r', 100), '>=': ('r', 100), '<=': ('r', 100), '||': ('r', 100), '>>=': ('r', 100), '&&': ('r', 100), '|': ('r', 100), '}': ('r', 100), '&=': ('r', 100), '++': ('r', 100), '>>': ('r', 100), ']': ('r', 100), '^': ('r', 100), '[': ('r', 100), '.*': ('r', 100)}, 488),
        #STATE 489
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 98), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63)], {',': ('r', 101), '::': ('s', 237), '{': ('r', 101)}, 489),
        #STATE 490
        State([("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 83)], {',': ('r', 199), '-': ('r', 199), '.': ('r', 199), '/': ('r', 199), '(': ('r', 199), ')': ('r', 199), '*': ('r', 199), '+': ('r', 199), '%': ('r', 199), '&': ('r', 199), '<': ('r', 199), '=': ('r', 199), '>': ('r', 199), '?': ('r', 199), '<<': ('r', 199), ':': ('r', 199), ';': ('r', 199), '...': ('r', 199), '|=': ('r', 199), '^=': ('r', 199), '%=': ('r', 199), '!=': ('r', 199), '--': ('r', 199), '/=': ('r', 199), '==': ('r', 199), '*=': ('r', 199), '<<=': ('r', 199), '->': ('r', 199), '-=': ('r', 199), '->*': ('r', 199), '>>': ('r', 199), '>=': ('r', 199), '<=': ('r', 199), '||': ('r', 199), '>>=': ('r', 199), '&&': ('r', 199), '|': ('r', 199), '}': ('r', 199), '&=': ('r', 199), '++': ('r', 199), '+=': ('r', 199), ']': ('r', 199), '^': ('r', 199), '[': ('r', 199), '.*': ('r', 199)}, 490),
        #STATE 491
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 81)], {'~': ('s', 23)}, 491),
        #STATE 492
        State([("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 83)], {',': ('r', 354), '-': ('r', 354), '.': ('r', 354), '/': ('r', 354), '|=': ('r', 354), ')': ('r', 354), '*': ('r', 354), '+': ('r', 354), '%': ('r', 354), '&': ('r', 354), 'operator': ('r', 354), '<': ('r', 354), '=': ('r', 354), '>': ('r', 354), '?': ('r', 354), '<<': ('r', 354), IDENTIFIER: ('r', 354), ':': ('r', 354), ';': ('r', 354), '...': ('r', 354), '(': ('r', 354), '^=': ('r', 354), '||': ('r', 354), '^': ('r', 354), '!=': ('r', 354), '--': ('r', 354), '/=': ('r', 354), '++': ('r', 354), '*=': ('r', 354), '<<=': ('r', 354), '->': ('r', 354), 'auto': ('r', 354), '-=': ('r', 354), '%=': ('r', 354), '>>': ('r', 354), '>=': ('r', 354), 'union': ('r', 354), '<=': ('r', 354), '::': ('r', 354), '>>=': ('r', 354), '&&': ('r', 354), '|': ('r', 354), '}': ('r', 354), '~': ('r', 354), 'volatile': ('r', 354), '&=': ('r', 354), '{': ('r', 354), '.*': ('r', 354), 'struct': ('r', 354), '->*': ('r', 354), TYPE_KEYWORD: ('r', 354), 'try': ('r', 354), 'enum': ('r', 354), '+=': ('r', 354), 'class': ('r', 354), ']': ('r', 354), 'typename': ('r', 354), '==': ('r', 354), '[': ('r', 354), 'const': ('r', 354)}, 492),
        #STATE 493
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 137)], {',': ('r', 103), '-': ('r', 103), '.': ('r', 103), '/': ('r', 103), '(': ('r', 103), ')': ('r', 103), '*': ('r', 103), '+': ('r', 103), '%': ('r', 103), '&': ('r', 103), '<': ('r', 103), '=': ('r', 103), '>': ('r', 103), '?': ('r', 103), '<<': ('r', 103), ':': ('r', 103), ';': ('r', 103), '...': ('r', 103), '|=': ('r', 103), '^=': ('r', 103), '%=': ('r', 103), '!=': ('r', 103), '--': ('r', 103), '/=': ('r', 103), '==': ('r', 103), '*=': ('r', 103), '<<=': ('r', 103), '->': ('r', 103), '-=': ('r', 103), '->*': ('r', 103), '>>': ('r', 103), '>=': ('r', 103), '<=': ('r', 103), '||': ('r', 103), '>>=': ('r', 103), '&&': ('r', 103), '|': ('r', 103), '}': ('r', 103), '&=': ('r', 103), '++': ('r', 103), '+=': ('r', 103), ']': ('r', 103), '^': ('r', 103), '[': ('r', 103), '.*': ('r', 103)}, 493),
        #STATE 494
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ('postfix_expression -> primary_expression!', 22), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("class_key -> 'class' | 'struct' | 'union'", 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("unary_expression -> 'sizeof' unary_expression:v", 20), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("unary_expression -> '++' cast_expression:v", 20), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ('class_head -> class_key:t base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('id_expression -> qualified_id!', 17), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('equality_expression -> relational_expression!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('namespace_name -> IDENTIFIER:name', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ('assignment_expression -> conditional_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('unqualified_id -> conversion_function_id!', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("cv_qualifier -> 'const'!", 16), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('unary_expression -> postfix_expression!', 20), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 38), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_argument -> type_id:t', 21), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ('template_argument -> assignment_expression:v', 21), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> CHARACTER_LITERAL:v', 11), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('pm_expression -> cast_expression!', 17), ('additive_expression -> multiplicative_expression!', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), template_name: ('g', 2), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), cv_qualifier: ('g', 106), additive_expression: ('g', 63), logical_and_expression: ('g', 118), shift_expression: ('g', 65), IDENTIFIER: ('s', 3), equality_expression: ('g', 70), CHARACTER_LITERAL: ('s', 108), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), delete_expression: ('g', 119), class_name: ('g', 11), template_argument: ('g', 393), 'new': ('s', 74), class_specifier: ('g', 75), inclusive_or_expression: ('g', 76), literal: ('g', 84), elaborated_type_specifier: ('g', 109), class_key: ('g', 78), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), conditional_expression: ('g', 77), assignment_expression: ('g', 495), 'auto': ('s', 90), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), enum_specifier: ('g', 122), _81: ('g', 88), id_expression: ('g', 114), unqualified_id: ('g', 7), operator_function_id: ('g', 6), 'const_cast': ('s', 92), '::': ('s', 64), throw_expression: ('g', 91), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), 'typename': ('s', 116), 'union': ('s', 97), type_name: ('g', 98), conversion_function_id: ('g', 12), '~': ('s', 100), 'volatile': ('s', 33), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), class_head: ('g', 20), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), postfix_expression: ('g', 99), 'reinterpret_cast': ('s', 110), 'struct': ('s', 58), '--': ('s', 111), _80: ('g', 112), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), type_id: ('g', 496), pm_expression: ('g', 73), namespace_name: ('g', 5), 'enum': ('s', 117), BOOLEAN_LITERAL: ('s', 102), exclusive_or_expression: ('g', 121), 'const': ('s', 35), type_descriptor: ('g', 240), 'typeid': ('s', 38), relational_expression: ('g', 67)}, 494),
        #STATE 495
        State([('template_argument -> assignment_expression:v', 42)], {',': ('r', 360), '>': ('r', 360)}, 495),
        #STATE 496
        State([('template_argument -> type_id:t', 28)], {',': ('r', 527), '>': ('r', 527)}, 496),
        #STATE 497
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 106)], {',': ('r', 106), '-': ('r', 106), '.': ('r', 106), '/': ('r', 106), '(': ('r', 106), ')': ('r', 106), '*': ('r', 106), '+': ('r', 106), '%': ('r', 106), '&': ('r', 106), '<': ('r', 106), '=': ('r', 106), '>': ('r', 106), '?': ('r', 106), '<<': ('r', 106), ':': ('r', 106), ';': ('r', 106), '...': ('r', 106), '|=': ('r', 106), '^=': ('r', 106), '%=': ('r', 106), '!=': ('r', 106), '--': ('r', 106), '/=': ('r', 106), '==': ('r', 106), '*=': ('r', 106), '<<=': ('r', 106), '->': ('r', 106), '-=': ('r', 106), '->*': ('r', 106), '+=': ('r', 106), '>=': ('r', 106), '<=': ('r', 106), '||': ('r', 106), '>>=': ('r', 106), '&&': ('r', 106), '|': ('r', 106), '}': ('r', 106), '&=': ('r', 106), '++': ('r', 106), '>>': ('r', 106), ']': ('r', 106), '^': ('r', 106), '[': ('r', 106), '.*': ('r', 106)}, 497),
        #STATE 498
        State([("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 100)], {',': ('r', 307), '{': ('r', 307)}, 498),
        #STATE 499
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 56), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('pm_expression -> cast_expression!', 17), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), inclusive_or_expression: ('g', 510), '--': ('s', 111), '++': ('s', 55), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), exclusive_or_expression: ('g', 121), nested_name_specifier: ('g', 95), new_expression: ('g', 94), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 499),
        #STATE 500
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 134), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), ')': ('s', 501), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), _15: ('g', 502), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 323), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), named_type_specifier: ('g', 177), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 500),
        #STATE 501
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 137)], {',': ('r', 322), '-': ('r', 322), '.': ('r', 322), '/': ('r', 322), '(': ('r', 322), ')': ('r', 322), '*': ('r', 322), '+': ('r', 322), '%': ('r', 322), '&': ('r', 322), '<': ('r', 322), '=': ('r', 322), '>': ('r', 322), '?': ('r', 322), '<<': ('r', 322), ':': ('r', 322), ';': ('r', 322), '...': ('r', 322), '|=': ('r', 322), '^=': ('r', 322), '%=': ('r', 322), '!=': ('r', 322), '--': ('r', 322), '/=': ('r', 322), '==': ('r', 322), '*=': ('r', 322), '<<=': ('r', 322), '->': ('r', 322), '-=': ('r', 322), '->*': ('r', 322), '+=': ('r', 322), '>=': ('r', 322), '<=': ('r', 322), '||': ('r', 322), '>>=': ('r', 322), '&&': ('r', 322), '|': ('r', 322), '}': ('r', 322), '&=': ('r', 322), '++': ('r', 322), '>>': ('r', 322), ']': ('r', 322), '^': ('r', 322), '[': ('r', 322), '.*': ('r', 322)}, 501),
        #STATE 502
        State([None, ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 134)], {',': ('s', 304), ')': ('s', 277)}, 502),
        #STATE 503
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 226)], {',': ('r', 109), '-': ('r', 109), '.': ('r', 109), '/': ('r', 109), '(': ('r', 109), ')': ('r', 109), '*': ('r', 109), '+': ('r', 109), '%': ('r', 109), '&': ('r', 109), '<': ('r', 109), '=': ('r', 109), '>': ('r', 109), '?': ('r', 109), '<<': ('r', 109), ':': ('r', 109), ';': ('r', 109), '...': ('r', 109), '|=': ('r', 109), '^=': ('r', 109), '%=': ('r', 109), '!=': ('r', 109), '--': ('r', 109), '/=': ('r', 109), '++': ('r', 109), '^': ('r', 109), '<<=': ('r', 109), '->': ('r', 109), '-=': ('r', 109), '->*': ('r', 109), '+=': ('r', 109), '>=': ('r', 109), '<=': ('r', 109), '||': ('r', 109), '>>=': ('r', 109), '&&': ('r', 109), '|': ('r', 109), '}': ('r', 109), '&=': ('r', 109), '{': ('r', 109), 'try': ('r', 109), '>>': ('r', 109), ']': ('r', 109), '*=': ('r', 109), '==': ('r', 109), '[': ('r', 109), '.*': ('r', 109)}, 503),
        #STATE 504
        State([('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 33), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ("cv_qualifier -> 'const'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 103), ("cv_qualifier -> 'volatile'!", 16)], {',': ('r', 110), cv_qualifier: ('g', 32), '(': ('r', 110), exception_specification: ('g', 505), 'try': ('r', 110), ';': ('r', 110), 'throw': ('s', 31), '=': ('r', 110), '>': ('r', 110), '[': ('r', 110), '{': ('r', 110), ':': ('r', 110), 'volatile': ('s', 33), '...': ('r', 110), 'const': ('s', 35), ')': ('r', 110)}, 504),
        #STATE 505
        State([("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 126)], {',': ('r', 294), '=': ('r', 294), '>': ('r', 294), ';': ('r', 294), '(': ('r', 294), ')': ('r', 294), 'try': ('r', 294), '{': ('r', 294), '...': ('r', 294), ':': ('r', 294), '[': ('r', 294)}, 505),
        #STATE 506
        State([("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 100)], {',': ('r', 111), '-': ('r', 111), '.': ('r', 111), '/': ('r', 111), '|=': ('r', 111), ')': ('r', 111), '*': ('r', 111), '+': ('r', 111), '%': ('r', 111), '&': ('r', 111), 'operator': ('r', 111), '<': ('r', 111), '=': ('r', 111), '>': ('r', 111), '?': ('r', 111), '<<': ('r', 111), IDENTIFIER: ('r', 111), ':': ('r', 111), ';': ('r', 111), '...': ('r', 111), '(': ('r', 111), '^=': ('r', 111), '||': ('r', 111), '^': ('r', 111), '!=': ('r', 111), '--': ('r', 111), '/=': ('r', 111), '++': ('r', 111), '*=': ('r', 111), '<<=': ('r', 111), '->': ('r', 111), 'struct': ('r', 111), '-=': ('r', 111), '%=': ('r', 111), '+=': ('r', 111), '>=': ('r', 111), 'union': ('r', 111), '<=': ('r', 111), '::': ('r', 111), 'auto': ('r', 111), '>>=': ('r', 111), '&&': ('r', 111), '|': ('r', 111), '}': ('r', 111), '~': ('r', 111), 'volatile': ('r', 111), '&=': ('r', 111), '{': ('r', 111), '.*': ('r', 111), '->*': ('r', 111), TYPE_KEYWORD: ('r', 111), 'try': ('r', 111), 'enum': ('r', 111), '>>': ('r', 111), 'class': ('r', 111), ']': ('r', 111), 'typename': ('r', 111), '==': ('r', 111), '[': ('r', 111), 'const': ('r', 111)}, 506),
        #STATE 507
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 68), ('type_name -> IDENTIFIER:name', 13), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ('type_name -> template_id!', 13), ("unqualified_id -> '~' class_name:name", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {type_name: ('g', 509), template_name: ('g', 2), class_name: ('g', 289), template_id: ('g', 18), IDENTIFIER: ('s', 508)}, 507),
        #STATE 508
        State([('class_name -> IDENTIFIER:name', 24), ('template_name -> IDENTIFIER!', 27), ('type_name -> IDENTIFIER:name', 23)], {',': ('c', [('r', 7), ('r', 6)]), '-': ('c', [('r', 7), ('r', 6)]), '.': ('c', [('r', 7), ('r', 6)]), '/': ('c', [('r', 7), ('r', 6)]), '(': ('c', [('r', 7), ('r', 6)]), ')': ('c', [('r', 7), ('r', 6)]), '*': ('c', [('r', 7), ('r', 6)]), '+': ('c', [('r', 7), ('r', 6)]), '%': ('c', [('r', 7), ('r', 6)]), '&': ('c', [('r', 7), ('r', 6)]), '<': ('c', [('r', 7), ('r', 2), ('r', 6)]), '=': ('c', [('r', 7), ('r', 6)]), '>': ('c', [('r', 7), ('r', 6)]), '?': ('c', [('r', 7), ('r', 6)]), '<<': ('c', [('r', 7), ('r', 6)]), ':': ('c', [('r', 7), ('r', 6)]), ';': ('c', [('r', 7), ('r', 6)]), '...': ('c', [('r', 7), ('r', 6)]), '|=': ('c', [('r', 7), ('r', 6)]), '^=': ('c', [('r', 7), ('r', 6)]), '%=': ('c', [('r', 7), ('r', 6)]), '!=': ('c', [('r', 7), ('r', 6)]), '--': ('c', [('r', 7), ('r', 6)]), '/=': ('c', [('r', 7), ('r', 6)]), '++': ('c', [('r', 7), ('r', 6)]), '^': ('c', [('r', 7), ('r', 6)]), '<<=': ('c', [('r', 7), ('r', 6)]), '->': ('c', [('r', 7), ('r', 6)]), '-=': ('c', [('r', 7), ('r', 6)]), '->*': ('c', [('r', 7), ('r', 6)]), '>>': ('c', [('r', 7), ('r', 6)]), '>=': ('c', [('r', 7), ('r', 6)]), '<=': ('c', [('r', 7), ('r', 6)]), '||': ('c', [('r', 7), ('r', 6)]), '>>=': ('c', [('r', 7), ('r', 6)]), '&&': ('c', [('r', 7), ('r', 6)]), '|': ('c', [('r', 7), ('r', 6)]), '}': ('c', [('r', 7), ('r', 6)]), '&=': ('c', [('r', 7), ('r', 6)]), '+=': ('c', [('r', 7), ('r', 6)]), ']': ('c', [('r', 7), ('r', 6)]), '*=': ('c', [('r', 7), ('r', 6)]), '==': ('c', [('r', 7), ('r', 6)]), '[': ('c', [('r', 7), ('r', 6)]), '.*': ('c', [('r', 7), ('r', 6)])}, 508),
        #STATE 509
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 77)], {',': ('r', 457), '-': ('r', 457), '.': ('r', 457), '/': ('r', 457), '(': ('r', 457), ')': ('r', 457), '*': ('r', 457), '+': ('r', 457), '%': ('r', 457), '&': ('r', 457), '<': ('r', 457), '=': ('r', 457), '>': ('r', 457), '?': ('r', 457), '<<': ('r', 457), ':': ('r', 457), ';': ('r', 457), '...': ('r', 457), '|=': ('r', 457), '^=': ('r', 457), '%=': ('r', 457), '!=': ('r', 457), '--': ('r', 457), '/=': ('r', 457), '==': ('r', 457), '*=': ('r', 457), '<<=': ('r', 457), '->': ('r', 457), '-=': ('r', 457), '->*': ('r', 457), '+=': ('r', 457), '>=': ('r', 457), '<=': ('r', 457), '||': ('r', 457), '>>=': ('r', 457), '&&': ('r', 457), '|': ('r', 457), '}': ('r', 457), '&=': ('r', 457), '++': ('r', 457), '>>': ('r', 457), ']': ('r', 457), '^': ('r', 457), '[': ('r', 457), '.*': ('r', 457)}, 509),
        #STATE 510
        State([("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 53), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 79)], {',': ('r', 112), '|=': ('r', 112), '||': ('r', 112), '>>=': ('r', 112), '&&': ('r', 112), '|': ('s', 278), '}': ('r', 112), '>': ('r', 112), '?': ('r', 112), '&=': ('r', 112), ':': ('r', 112), ';': ('r', 112), '...': ('r', 112), '^=': ('r', 112), ')': ('r', 112), '=': ('r', 112), '/=': ('r', 112), ']': ('r', 112), '*=': ('r', 112), '<<=': ('r', 112), '-=': ('r', 112), '%=': ('r', 112), '+=': ('r', 112)}, 510),
        #STATE 511
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 89)], {',': ('r', 150), '-': ('r', 150), '/': ('r', 150), '|=': ('r', 150), ')': ('r', 150), '*': ('r', 150), '==': ('r', 150), '%': ('r', 150), '&': ('r', 150), '>>=': ('r', 150), '&&': ('r', 150), '<': ('r', 150), '=': ('r', 150), '>': ('r', 150), '?': ('r', 150), '<<': ('r', 150), ':': ('r', 150), ';': ('r', 150), '...': ('r', 150), '<=': ('r', 150), '^=': ('r', 150), '%=': ('r', 150), '|': ('r', 150), '!=': ('r', 150), '}': ('r', 150), '/=': ('r', 150), '+': ('r', 150), '||': ('r', 150), '^': ('r', 150), '&=': ('r', 150), '+=': ('r', 150), ']': ('r', 150), '*=': ('r', 150), '<<=': ('r', 150), '-=': ('r', 150), '.*': ('r', 150), '->*': ('r', 150), '>>': ('r', 150), '>=': ('r', 150)}, 511),
        #STATE 512
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('named_namespace_definition -> original_namespace_definition!', 30), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ('namespace_definition -> unnamed_namespace_definition!', 24), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 25), ('declaration -> function_definition!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 54), ('block_declaration -> using_declaration!', 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 32), ('type_name -> IDENTIFIER:name', 13), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 33), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ("explicit_instantiation -> 'template' declaration:decl", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> template_declaration!', 15), ('declaration -> CPP_INCLUDE!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> linkage_specification!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('type_name -> template_id!', 13), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_definition -> function_head:head function_try_block:tryb', 23), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 27), ('declaration -> namespace_definition!', 15), ("raw_type_descriptor -> 'auto'", 23), ('block_declaration -> asm_definition!', 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('block_declaration -> simple_declaration!', 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 54), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cv_qualifier -> 'const'!", 16), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('declaration -> CPP_ERROR!', 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_directive!', 21), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('declaration -> explicit_instantiation!', 15), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('namespace_definition -> named_namespace_definition!', 24), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> named_type_specifier!', 23), ('declaration -> block_declaration!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('declaration -> explicit_specialization!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 54), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), named_type_specifier: ('g', 126), 'namespace': ('s', 148), 'union': ('s', 97), function_definition: ('g', 128), 'virtual': ('s', 130), explicit_specialization: ('g', 157), cd_id: ('g', 164), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), 'extern': ('s', 139), class_name: ('g', 11), using_directive: ('g', 137), class_specifier: ('g', 138), 'typedef': ('s', 136), namespace_definition: ('g', 140), CPP_INCLUDE: ('s', 129), named_namespace_definition: ('g', 142), _75: ('g', 152), 'asm': ('s', 125), original_namespace_definition: ('g', 144), explicit_instantiation: ('g', 146), _81: ('g', 88), type_name: ('g', 131), unnamed_namespace_definition: ('g', 145), 'export': ('s', 143), 'struct': ('s', 58), 'volatile': ('s', 33), namespace_alias_definition: ('g', 161), asm_definition: ('g', 149), function_head: ('g', 150), 'auto': ('s', 90), using_declaration: ('g', 127), _80: ('g', 112), '::': ('s', 153), namespace_name: ('g', 5), 'using': ('s', 154), nested_name_specifier: ('g', 155), linkage_specification: ('g', 156), _73: ('g', 133), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), '{': ('s', 514), template_name: ('g', 2), class_head: ('g', 20), cv_qualifier: ('g', 106), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), cd_declarator: ('g', 163), simple_declaration: ('g', 167), 'enum': ('s', 117), declaration: ('g', 513), type_descriptor: ('g', 169), 'class': ('s', 115), block_declaration: ('g', 141), 'typename': ('s', 166), CPP_ERROR: ('s', 151), 'operator': ('s', 168), template_declaration: ('g', 165), 'template': ('s', 147), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 29)}, 512),
        #STATE 513
        State([("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 65)], {'union': ('r', 447), '::': ('r', 447), 'export': ('r', 447), 'using': ('r', 447), 'virtual': ('r', 447), DECLARE_KEYWORD: ('r', 447), '}': ('r', 447), '~': ('r', 447), IDENTIFIER: ('r', 447), 'const': ('r', 447), 'typedef': ('r', 447), 'operator': ('r', 447), 'struct': ('r', 447), 'extern': ('r', 447), TYPE_KEYWORD: ('r', 447), ACCESS_KEYWORD: ('r', 447), 'asm': ('r', 447), 'enum': ('r', 447), EOF: ('r', 447), 'class': ('r', 447), CPP_INCLUDE: ('r', 447), 'typename': ('r', 447), CPP_ERROR: ('r', 447), 'auto': ('r', 447), 'volatile': ('r', 447), 'template': ('r', 447), 'namespace': ('r', 447)}, 513),
        #STATE 514
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('named_namespace_definition -> original_namespace_definition!', 30), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ('namespace_definition -> unnamed_namespace_definition!', 24), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 25), ('declaration -> function_definition!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ('block_declaration -> using_declaration!', 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 32), ('type_name -> IDENTIFIER:name', 13), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 33), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('translation_unit -> declaration!*:decls', 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ("explicit_instantiation -> 'template' declaration:decl", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> template_declaration!', 15), ('declaration -> CPP_INCLUDE!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> linkage_specification!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('type_name -> template_id!', 13), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_definition -> function_head:head function_try_block:tryb', 23), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 27), ('declaration -> namespace_definition!', 15), ("raw_type_descriptor -> 'auto'", 23), ('block_declaration -> asm_definition!', 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('block_declaration -> simple_declaration!', 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cv_qualifier -> 'const'!", 16), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('declaration -> CPP_ERROR!', 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 77), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_directive!', 21), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('declaration -> explicit_instantiation!', 15), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ('translation_unit -> declaration!*:decls', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('translation_unit -> declaration!*:decls', 20), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('namespace_definition -> named_namespace_definition!', 24), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> named_type_specifier!', 23), ('declaration -> block_declaration!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('declaration -> explicit_specialization!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), named_type_specifier: ('g', 126), 'union': ('s', 97), function_definition: ('g', 128), 'virtual': ('s', 130), explicit_specialization: ('g', 157), cd_id: ('g', 164), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), 'extern': ('s', 139), class_name: ('g', 11), '::': ('s', 153), class_specifier: ('g', 138), 'typedef': ('s', 136), namespace_definition: ('g', 140), block_declaration: ('g', 141), named_namespace_definition: ('g', 142), _75: ('g', 152), 'asm': ('s', 125), original_namespace_definition: ('g', 144), explicit_instantiation: ('g', 146), _81: ('g', 88), type_name: ('g', 131), unnamed_namespace_definition: ('g', 145), _1: ('g', 1057), 'export': ('s', 143), 'struct': ('s', 58), 'volatile': ('s', 33), type_descriptor: ('g', 169), namespace_alias_definition: ('g', 161), asm_definition: ('g', 149), function_head: ('g', 150), 'auto': ('s', 90), using_declaration: ('g', 127), using_directive: ('g', 137), namespace_name: ('g', 5), 'using': ('s', 154), nested_name_specifier: ('g', 155), linkage_specification: ('g', 156), _73: ('g', 133), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), 'namespace': ('s', 148), template_name: ('g', 2), class_head: ('g', 20), cv_qualifier: ('g', 106), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), '}': ('s', 862), cd_declarator: ('g', 163), simple_declaration: ('g', 167), _80: ('g', 112), declaration: ('g', 429), template_id: ('g', 18), 'class': ('s', 115), CPP_INCLUDE: ('s', 129), 'typename': ('s', 166), CPP_ERROR: ('s', 151), 'operator': ('s', 168), template_declaration: ('g', 165), 'template': ('s', 147), 'enum': ('s', 117), class_key: ('g', 78), IDENTIFIER: ('s', 29)}, 514),
        #STATE 515
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 22), ('mem_initializer_id -> IDENTIFIER:name', 22), ("ctor_initializer -> ':' mem_initializer!+,','!", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("mem_initializer -> mem_initializer_id:id '(' assignment_expression!*,',':args ')'", 19), ('class_name -> template_id!', 14), ("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 60), ("mem_initializer -> mem_initializer_id:id '(' assignment_expression!*,',':args ')'", 19), ("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 33), ("ctor_initializer -> ':' mem_initializer!+,','!", 24), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ctor_initializer -> ':' mem_initializer!+,','!", 24), ('template_name -> IDENTIFIER!', 17), ("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), IDENTIFIER: ('s', 517), _120: ('g', 519), mem_initializer: ('g', 516), namespace_name: ('g', 5), nested_name_specifier: ('g', 520), class_name: ('g', 522), template_id: ('g', 44), '::': ('s', 521), mem_initializer_id: ('g', 518)}, 515),
        #STATE 516
        State([("ctor_initializer -> ':' mem_initializer!+,','!", 39)], {',': ('r', 190), '{': ('r', 190)}, 516),
        #STATE 517
        State([('mem_initializer_id -> IDENTIFIER:name', 32), ('class_name -> IDENTIFIER:name', 24), ('template_name -> IDENTIFIER!', 27), ('namespace_name -> IDENTIFIER:name', 28)], {'<': ('r', 2), '(': ('c', [('r', 409), ('r', 7)]), '::': ('c', [('r', 7), ('r', 5)])}, 517),
        #STATE 518
        State([("mem_initializer -> mem_initializer_id:id '(' assignment_expression!*,',':args ')'", 41), ("mem_initializer -> mem_initializer_id:id '(' assignment_expression!*,',':args ')'", 41)], {'(': ('s', 719)}, 518),
        #STATE 519
        State([("ctor_initializer -> ':' mem_initializer!+,','!", 45), None], {',': ('s', 555), '{': ('r', 380)}, 519),
        #STATE 520
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ('class_name -> template_id!', 14), ("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 60), ('class_name -> IDENTIFIER:name', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), class_name: ('g', 557), IDENTIFIER: ('s', 173), template_id: ('g', 44)}, 520),
        #STATE 521
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('namespace_name -> IDENTIFIER:name', 18), ("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 33), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 60), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), nested_name_specifier: ('g', 379), class_name: ('g', 563), template_id: ('g', 44)}, 521),
        #STATE 522
        State([("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 70), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63)], {'(': ('r', 452), '::': ('s', 237)}, 522),
        #STATE 523
        State([("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 56), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_id: ('g', 44), template_name: ('g', 2), IDENTIFIER: ('s', 173), class_name: ('g', 524)}, 523),
        #STATE 524
        State([("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 66)], {',': ('r', 302), '{': ('r', 302)}, 524),
        #STATE 525
        State([("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 98), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63)], {',': ('r', 114), '::': ('s', 237), '{': ('r', 114)}, 525),
        #STATE 526
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 59), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), expression: ('g', 527), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 526),
        #STATE 527
        State([("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 72), ("expression -> expression:a ',' assignment_expression:b", 27)], {',': ('s', 272), ')': ('s', 564)}, 527),
        #STATE 528
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ('class_name -> IDENTIFIER:name', 14), ('class_name -> template_id!', 14), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 88), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), class_name: ('g', 529), IDENTIFIER: ('s', 173), template_id: ('g', 44)}, 528),
        #STATE 529
        State([("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 98)], {',': ('r', 196), '{': ('r', 196)}, 529),
        #STATE 530
        State([("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 99)], {'union': ('r', 115), '::': ('r', 115), 'namespace': ('r', 115), 'export': ('r', 115), 'using': ('r', 115), 'virtual': ('r', 115), DECLARE_KEYWORD: ('r', 115), '}': ('r', 115), '~': ('r', 115), IDENTIFIER: ('r', 115), 'operator': ('r', 115), 'extern': ('r', 115), 'typedef': ('r', 115), TYPE_KEYWORD: ('r', 115), ACCESS_KEYWORD: ('r', 115), 'asm': ('r', 115), 'enum': ('r', 115), EOF: ('r', 115), 'class': ('r', 115), CPP_INCLUDE: ('r', 115), 'typename': ('r', 115), CPP_ERROR: ('r', 115), 'struct': ('r', 115), 'volatile': ('r', 115), 'template': ('r', 115), 'const': ('r', 115), 'auto': ('r', 115)}, 530),
        #STATE 531
        State([('unary_expression -> unary_operator:op cast_expression:v', 53)], {',': ('r', 116), '-': ('r', 116), '/': ('r', 116), '|=': ('r', 116), ')': ('r', 116), '*': ('r', 116), '==': ('r', 116), '%': ('r', 116), '&': ('r', 116), '>>=': ('r', 116), '&&': ('r', 116), '<': ('r', 116), '=': ('r', 116), '>': ('r', 116), '?': ('r', 116), '<<': ('r', 116), ':': ('r', 116), ';': ('r', 116), '...': ('r', 116), '<=': ('r', 116), '^=': ('r', 116), '%=': ('r', 116), '|': ('r', 116), '!=': ('r', 116), '}': ('r', 116), '/=': ('r', 116), '+': ('r', 116), '||': ('r', 116), '*=': ('r', 116), '&=': ('r', 116), '>>': ('r', 116), ']': ('r', 116), '^': ('r', 116), '<<=': ('r', 116), '-=': ('r', 116), '.*': ('r', 116), '->*': ('r', 116), '+=': ('r', 116), '>=': ('r', 116)}, 531),
        #STATE 532
        State([("labeled_statement -> 'case' constant_expression:c ':' statement:st", 63)], {'-': ('r', 117), 'asm': ('r', 117), '(': ('r', 117), '*': ('r', 117), '+': ('r', 117), 'delete': ('r', 117), 'static_cast': ('r', 117), 'virtual': ('r', 117), DECLARE_KEYWORD: ('r', 117), IDENTIFIER: ('r', 117), 'while': ('r', 117), INTEGER_LITERAL: ('r', 117), 'extern': ('r', 117), 'default': ('r', 117), 'goto': ('r', 117), 'break': ('r', 117), 'new': ('r', 117), 'class': ('r', 117), 'typedef': ('r', 117), '--': ('r', 117), '++': ('r', 117), 'dynamic_cast': ('r', 117), 'for': ('r', 117), 'continue': ('r', 117), 'struct': ('r', 117), 'volatile': ('r', 117), 'namespace': ('r', 117), '&': ('r', 117), 'if': ('r', 117), 'union': ('r', 117), 'const_cast': ('r', 117), '::': ('r', 117), 'auto': ('r', 117), 'using': ('r', 117), 'do': ('r', 117), 'this': ('r', 117), '}': ('r', 117), '~': ('r', 117), 'return': ('r', 117), '{': ('r', 117), 'case': ('r', 117), '!': ('r', 117), CHARACTER_LITERAL: ('r', 117), FLOATING_LITERAL: ('r', 117), 'sizeof': ('r', 117), 'else': ('r', 117), TYPE_KEYWORD: ('r', 117), 'try': ('r', 117), 'reinterpret_cast': ('r', 117), BOOLEAN_LITERAL: ('r', 117), 'enum': ('r', 117), STRING_LITERAL: ('r', 117), 'throw': ('r', 117), 'typename': ('r', 117), CPP_ERROR: ('r', 117), 'operator': ('r', 117), 'const': ('r', 117), 'switch': ('r', 117), 'typeid': ('r', 117)}, 532),
        #STATE 533
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 62), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {template_name: ('g', 2), 'auto': ('s', 90), _80: ('g', 112), named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), template_id: ('g', 18), nested_name_specifier: ('g', 189), type_name: ('g', 98), 'union': ('s', 97), elaborated_type_specifier: ('g', 109), IDENTIFIER: ('s', 29), class_specifier: ('g', 75), class_name: ('g', 11), '::': ('s', 191), cv_qualifier: ('g', 106), class_head: ('g', 20), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), _81: ('g', 88), 'class': ('s', 115), type_id: ('g', 610), 'typename': ('s', 166), namespace_name: ('g', 5), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), type_descriptor: ('g', 240), enum_specifier: ('g', 122)}, 533),
        #STATE 534
        State([("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 58), ('namespace_name -> IDENTIFIER:name', 28), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 49), ('class_name -> IDENTIFIER:name', 24), ('template_name -> IDENTIFIER!', 27)], {',': ('r', 155), '=': ('s', 239), '>': ('r', 155), '<': ('r', 2), '::': ('c', [('r', 5), ('r', 7)])}, 534),
        #STATE 535
        State([("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 77), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 77), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 89), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {'template': ('s', 570), template_name: ('g', 2), IDENTIFIER: ('s', 916), template_id: ('g', 506)}, 535),
        #STATE 536
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 51), ('class_name -> IDENTIFIER:name', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 51), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 51), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), nested_name_specifier: ('g', 924), class_name: ('g', 11), template_id: ('g', 44)}, 536),
        #STATE 537
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ('statement -> iteration_statement!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> CPP_ERROR!', 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('statement -> labeled_statement!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('block_declaration -> asm_definition!', 21), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ('statement -> compound_statement!', 13), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ('statement -> jump_statement!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("labeled_statement -> 'default' ':' statement:st", 35), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unary_expression -> postfix_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_name -> template_id!', 13), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), '++': ('s', 55), pm_expression: ('g', 73), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), and_expression: ('g', 72), _80: ('g', 112), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), logical_and_expression: ('g', 118), 'asm': ('s', 125), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), conversion_function_id: ('g', 357), 'namespace': ('s', 170), expression: ('g', 335), STRING_LITERAL: ('s', 113), 'auto': ('s', 90), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), compound_statement: ('g', 339), DECLARE_KEYWORD: ('s', 160), selection_statement: ('g', 340), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), operator_function_id: ('g', 6), 'enum': ('s', 117), block_declaration: ('g', 344), 'typename': ('s', 116), 'while': ('s', 349), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 538), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), 'default': ('s', 330), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), asm_definition: ('g', 149), 'union': ('s', 97), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'do': ('s', 355), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'case': ('s', 356), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), 'try': ('s', 334), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), declaration_statement: ('g', 343), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), nested_name_specifier: ('g', 352), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 537),
        #STATE 538
        State([("labeled_statement -> 'default' ':' statement:st", 44)], {'-': ('r', 143), 'asm': ('r', 143), '(': ('r', 143), '*': ('r', 143), '+': ('r', 143), 'delete': ('r', 143), 'static_cast': ('r', 143), 'virtual': ('r', 143), '!': ('r', 143), IDENTIFIER: ('r', 143), 'while': ('r', 143), INTEGER_LITERAL: ('r', 143), 'extern': ('r', 143), 'default': ('r', 143), 'goto': ('r', 143), 'new': ('r', 143), 'throw': ('r', 143), 'typedef': ('r', 143), '--': ('r', 143), '++': ('r', 143), 'dynamic_cast': ('r', 143), 'for': ('r', 143), 'continue': ('r', 143), 'struct': ('r', 143), 'volatile': ('r', 143), 'namespace': ('r', 143), '&': ('r', 143), 'if': ('r', 143), 'union': ('r', 143), 'const_cast': ('r', 143), '::': ('r', 143), 'auto': ('r', 143), 'using': ('r', 143), 'do': ('r', 143), 'case': ('r', 143), 'try': ('r', 143), '~': ('r', 143), 'return': ('r', 143), DECLARE_KEYWORD: ('r', 143), '{': ('r', 143), 'this': ('r', 143), CHARACTER_LITERAL: ('r', 143), FLOATING_LITERAL: ('r', 143), 'sizeof': ('r', 143), 'else': ('r', 143), TYPE_KEYWORD: ('r', 143), '}': ('r', 143), 'reinterpret_cast': ('r', 143), BOOLEAN_LITERAL: ('r', 143), 'enum': ('r', 143), STRING_LITERAL: ('r', 143), 'class': ('r', 143), 'typename': ('r', 143), 'break': ('r', 143), 'operator': ('r', 143), CPP_ERROR: ('r', 143), 'const': ('r', 143), 'switch': ('r', 143), 'typeid': ('r', 143)}, 538),
        #STATE 539
        State([('type_name -> IDENTIFIER:name', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('type_name -> template_id!', 13)], {template_name: ('g', 2), '~': ('s', 315), IDENTIFIER: ('s', 24), conversion_function_id: ('g', 898), 'operator': ('s', 168), template_id: ('g', 26), type_name: ('g', 1051)}, 539),
        #STATE 540
        State([("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 56)], {'(': ('r', 183)}, 540),
        #STATE 541
        State([("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 55)], {',': ('r', 491), ';': ('r', 491)}, 541),
        #STATE 542
        State([("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 66)], {',': ('r', 119), '{': ('r', 119)}, 542),
        #STATE 543
        State([("cv_qualifier -> 'const'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 33), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cv_qualifier -> 'volatile'!", 16)], {',': ('r', 314), '-': ('r', 314), '.': ('r', 314), '/': ('r', 314), '|=': ('r', 314), ')': ('r', 314), '*': ('r', 314), '+': ('r', 314), '%': ('r', 314), '&': ('r', 314), '{': ('r', 314), '%=': ('r', 314), '<': ('r', 314), '=': ('r', 314), '>': ('r', 314), '?': ('r', 314), IDENTIFIER: ('r', 314), ':': ('r', 314), ';': ('r', 314), '...': ('r', 314), '(': ('r', 314), '^=': ('r', 314), '::': ('r', 314), '!=': ('r', 314), '--': ('r', 314), '/=': ('r', 314), '++': ('r', 314), '^': ('r', 314), 'typename': ('r', 314), '<<=': ('r', 314), '->': ('r', 314), 'auto': ('r', 314), '-=': ('r', 314), '->*': ('r', 314), '+=': ('r', 314), '>=': ('r', 314), 'union': ('r', 314), '>>=': ('r', 314), '<=': ('r', 314), '<<': ('r', 314), '||': ('r', 314), 'volatile': ('c', [('s', 33), ('r', 314)]), '&&': ('r', 314), '|': ('r', 314), '}': ('r', 314), '~': ('r', 314), '&=': ('r', 314), 'operator': ('r', 314), '.*': ('r', 314), cv_qualifier: ('g', 32), TYPE_KEYWORD: ('r', 314), 'try': ('r', 314), 'struct': ('r', 314), 'enum': ('r', 314), '>>': ('r', 314), 'class': ('r', 314), ']': ('r', 314), '*=': ('r', 314), '==': ('r', 314), '[': ('r', 314), 'const': ('c', [('s', 35), ('r', 314)])}, 543),
        #STATE 544
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 113)], {',': ('r', 121), '-': ('r', 121), '.': ('r', 121), '/': ('r', 121), '(': ('r', 121), ')': ('r', 121), '*': ('r', 121), '+': ('r', 121), '%': ('r', 121), '&': ('r', 121), '<': ('r', 121), '=': ('r', 121), '>': ('r', 121), '?': ('r', 121), '<<': ('r', 121), ':': ('r', 121), ';': ('r', 121), '...': ('r', 121), '|=': ('r', 121), '^=': ('r', 121), '%=': ('r', 121), '!=': ('r', 121), '--': ('r', 121), '/=': ('r', 121), '++': ('r', 121), '^': ('r', 121), '<<=': ('r', 121), '->': ('r', 121), '-=': ('r', 121), '->*': ('r', 121), '+=': ('r', 121), '>=': ('r', 121), '<=': ('r', 121), '||': ('r', 121), '>>=': ('r', 121), '&&': ('r', 121), '|': ('r', 121), '}': ('r', 121), '&=': ('r', 121), '{': ('r', 121), 'try': ('r', 121), '>>': ('r', 121), ']': ('r', 121), '*=': ('r', 121), '==': ('r', 121), '[': ('r', 121), '.*': ('r', 121)}, 544),
        #STATE 545
        State([("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 106)], {'-': ('r', 122), '++': ('r', 122), '(': ('r', 122), '*': ('r', 122), 'reinterpret_cast': ('r', 122), 'delete': ('r', 122), 'static_cast': ('r', 122), 'virtual': ('r', 122), '!': ('r', 122), IDENTIFIER: ('r', 122), 'while': ('r', 122), INTEGER_LITERAL: ('r', 122), 'extern': ('r', 122), 'default': ('r', 122), 'goto': ('r', 122), 'new': ('r', 122), 'throw': ('r', 122), 'typedef': ('r', 122), '--': ('r', 122), 'asm': ('r', 122), 'dynamic_cast': ('r', 122), 'for': ('r', 122), 'continue': ('r', 122), '+': ('r', 122), 'auto': ('r', 122), 'volatile': ('r', 122), 'namespace': ('r', 122), '&': ('r', 122), 'if': ('r', 122), 'union': ('r', 122), 'const_cast': ('r', 122), '::': ('r', 122), FLOATING_LITERAL: ('r', 122), 'using': ('r', 122), 'do': ('r', 122), 'this': ('r', 122), '}': ('r', 122), '~': ('r', 122), 'return': ('r', 122), DECLARE_KEYWORD: ('r', 122), '{': ('r', 122), 'case': ('r', 122), TYPE_KEYWORD: ('r', 122), 'struct': ('r', 122), 'sizeof': ('r', 122), 'else': ('r', 122), CHARACTER_LITERAL: ('r', 122), 'try': ('r', 122), BOOLEAN_LITERAL: ('r', 122), 'enum': ('r', 122), STRING_LITERAL: ('r', 122), 'class': ('r', 122), 'typename': ('r', 122), 'break': ('r', 122), 'operator': ('r', 122), CPP_ERROR: ('r', 122), 'const': ('r', 122), 'switch': ('r', 122), 'typeid': ('r', 122)}, 545),
        #STATE 546
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 61), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 50), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('namespace_name -> IDENTIFIER:name', 18), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 28), ('template_name -> IDENTIFIER!', 17), ('class_name -> IDENTIFIER:name', 14), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 88), ('class_name -> template_id!', 14), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 28), ('access_specifier -> ACCESS_KEYWORD!', 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 28), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 50), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 28), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), template_id: ('g', 44), nested_name_specifier: ('g', 586), ACCESS_KEYWORD: ('s', 258), class_name: ('g', 525), access_specifier: ('g', 587), '::': ('s', 585)}, 546),
        #STATE 547
        State([("base_clause -> ':' base_specifier!+,','!", 33)], {',': ('r', 335), '{': ('r', 335)}, 547),
        #STATE 548
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 66)], {',': ('r', 312), '::': ('s', 237), '{': ('r', 312)}, 548),
        #STATE 549
        State([('namespace_name -> IDENTIFIER:name', 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 56), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), nested_name_specifier: ('g', 672), class_name: ('g', 1061), template_id: ('g', 44)}, 549),
        #STATE 550
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 52), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 52), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('namespace_name -> IDENTIFIER:name', 18), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 39), ('template_name -> IDENTIFIER!', 17), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 63), ('class_name -> template_id!', 14), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 39), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 39), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 90), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 39), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), template_id: ('g', 44), nested_name_specifier: ('g', 172), 'virtual': ('s', 413), class_name: ('g', 391), '::': ('s', 722)}, 550),
        #STATE 551
        State([None, ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 64), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 64), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 64), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 64)], {',': ('s', 552), '>': ('s', 212)}, 551),
        #STATE 552
        State([("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 25), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('raw_type_descriptor -> enum_specifier!', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('namespace_name -> IDENTIFIER:name', 18), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ('template_parameter -> type_parameter!', 22), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("cv_qualifier -> 'const'!", 16), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ('template_parameter -> parameter_declaration!', 22), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("class_key -> 'class' | 'struct' | 'union'", 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ('class_name -> IDENTIFIER:name', 14), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('parameter_declaration -> type_descriptor:type declarator:dtor', 25), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('raw_type_descriptor -> named_type_specifier!', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), IDENTIFIER: ('s', 29), _80: ('g', 112), 'union': ('s', 97), nested_name_specifier: ('g', 189), parameter_declaration: ('g', 196), type_name: ('g', 98), class_specifier: ('g', 75), type_descriptor: ('g', 193), elaborated_type_specifier: ('g', 109), enum_specifier: ('g', 122), 'template': ('s', 201), template_name: ('g', 2), class_name: ('g', 11), '::': ('s', 191), cv_qualifier: ('g', 106), class_head: ('g', 20), type_parameter: ('g', 202), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), _81: ('g', 88), 'class': ('s', 198), 'typename': ('s', 199), namespace_name: ('g', 5), template_parameter: ('g', 372), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), template_id: ('g', 18), 'auto': ('s', 90)}, 552),
        #STATE 553
        State([("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 60)], {'-': ('r', 243), 'asm': ('r', 243), '(': ('r', 243), '*': ('r', 243), '+': ('r', 243), 'delete': ('r', 243), 'static_cast': ('r', 243), 'operator': ('r', 243), '!': ('r', 243), ACCESS_KEYWORD: ('r', 243), IDENTIFIER: ('r', 243), ';': ('r', 243), INTEGER_LITERAL: ('r', 243), 'extern': ('r', 243), 'default': ('r', 243), 'goto': ('r', 243), 'break': ('r', 243), 'new': ('r', 243), 'throw': ('r', 243), 'typedef': ('r', 243), '--': ('r', 243), '++': ('r', 243), 'struct': ('r', 243), 'dynamic_cast': ('r', 243), 'for': ('r', 243), 'export': ('r', 243), 'auto': ('r', 243), 'volatile': ('r', 243), 'template': ('r', 243), 'continue': ('r', 243), '&': ('r', 243), 'case': ('r', 243), 'if': ('r', 243), 'union': ('r', 243), 'virtual': ('r', 243), 'const_cast': ('r', 243), '::': ('r', 243), 'using': ('r', 243), 'namespace': ('r', 243), 'do': ('r', 243), DECLARE_KEYWORD: ('r', 243), '}': ('r', 243), '~': ('r', 243), 'return': ('r', 243), '{': ('r', 243), 'this': ('r', 243), TYPE_KEYWORD: ('r', 243), FLOATING_LITERAL: ('r', 243), 'sizeof': ('r', 243), 'else': ('r', 243), CHARACTER_LITERAL: ('r', 243), 'try': ('r', 243), 'reinterpret_cast': ('r', 243), BOOLEAN_LITERAL: ('r', 243), 'enum': ('r', 243), EOF: ('r', 243), STRING_LITERAL: ('r', 243), 'class': ('r', 243), CPP_INCLUDE: ('r', 243), 'typename': ('r', 243), 'while': ('r', 243), CPP_ERROR: ('r', 243), 'const': ('r', 243), 'switch': ('r', 243), 'typeid': ('r', 243)}, 553),
        #STATE 554
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 258)], {',': ('r', 125), '-': ('r', 125), '.': ('r', 125), '/': ('r', 125), '(': ('r', 125), ')': ('r', 125), '*': ('r', 125), '+': ('r', 125), '%': ('r', 125), '&': ('r', 125), '<': ('r', 125), '=': ('r', 125), '>': ('r', 125), '?': ('r', 125), '<<': ('r', 125), ':': ('r', 125), ';': ('r', 125), '...': ('r', 125), '|=': ('r', 125), '^=': ('r', 125), '%=': ('r', 125), '!=': ('r', 125), '--': ('r', 125), '/=': ('r', 125), '++': ('r', 125), '^': ('r', 125), '<<=': ('r', 125), '->': ('r', 125), '-=': ('r', 125), '->*': ('r', 125), '+=': ('r', 125), '>=': ('r', 125), '<=': ('r', 125), '||': ('r', 125), '>>=': ('r', 125), '&&': ('r', 125), '|': ('r', 125), '}': ('r', 125), '&=': ('r', 125), '{': ('r', 125), 'try': ('r', 125), '>>': ('r', 125), ']': ('r', 125), '*=': ('r', 125), '==': ('r', 125), '[': ('r', 125), '.*': ('r', 125)}, 554),
        #STATE 555
        State([("ctor_initializer -> ':' mem_initializer!+,','!", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 22), ('namespace_name -> IDENTIFIER:name', 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("mem_initializer -> mem_initializer_id:id '(' assignment_expression!*,',':args ')'", 19), ('class_name -> IDENTIFIER:name', 14), ("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 33), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> template_id!', 14), ('mem_initializer_id -> IDENTIFIER:name', 22), ("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 60), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('template_name -> IDENTIFIER!', 17), ("mem_initializer -> mem_initializer_id:id '(' assignment_expression!*,',':args ')'", 19)], {template_name: ('g', 2), mem_initializer_id: ('g', 518), mem_initializer: ('g', 556), template_id: ('g', 44), namespace_name: ('g', 5), nested_name_specifier: ('g', 520), class_name: ('g', 522), '::': ('s', 521), IDENTIFIER: ('s', 517)}, 555),
        #STATE 556
        State([("ctor_initializer -> ':' mem_initializer!+,','!", 39)], {',': ('r', 495), '{': ('r', 495)}, 556),
        #STATE 557
        State([("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 70)], {'(': ('r', 396)}, 557),
        #STATE 558
        State([('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 103), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 122), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ("cv_qualifier -> 'const'!", 16), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19)], {',': ('r', 126), 'union': ('r', 126), '(': ('r', 126), _80: ('g', 30), 'volatile': ('c', [('s', 33), ('r', 126)]), ')': ('r', 126), '=': ('r', 126), '>': ('r', 126), IDENTIFIER: ('r', 126), 'struct': ('r', 126), '...': ('r', 126), '::': ('r', 126), cv_qualifier: ('g', 106), exception_specification: ('g', 559), TYPE_KEYWORD: ('r', 126), 'enum': ('r', 126), 'throw': ('s', 31), 'typename': ('r', 126), 'auto': ('r', 126), '[': ('r', 126), 'const': ('c', [('s', 35), ('r', 126)]), 'class': ('r', 126)}, 558),
        #STATE 559
        State([("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 145)], {',': ('r', 471), 'union': ('r', 471), '(': ('r', 471), ')': ('r', 471), 'auto': ('r', 471), TYPE_KEYWORD: ('r', 471), 'enum': ('r', 471), 'typename': ('r', 471), 'class': ('r', 471), '=': ('r', 471), '>': ('r', 471), '[': ('r', 471), IDENTIFIER: ('r', 471), 'struct': ('r', 471), 'volatile': ('r', 471), '...': ('r', 471), 'const': ('r', 471), '::': ('r', 471)}, 559),
        #STATE 560
        State([('namespace_name -> IDENTIFIER:name', 28), ('class_name -> IDENTIFIER:name', 24), ('template_name -> IDENTIFIER!', 27), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 84)], {',': ('r', 127), '-': ('r', 127), '.': ('r', 127), '/': ('r', 127), '|=': ('r', 127), ')': ('r', 127), '*': ('r', 127), '+': ('r', 127), '%': ('r', 127), '&': ('r', 127), 'operator': ('r', 127), '<': ('c', [('r', 2), ('r', 127)]), '=': ('r', 127), '>': ('r', 127), '?': ('r', 127), '<<': ('r', 127), IDENTIFIER: ('r', 127), ':': ('r', 127), ';': ('r', 127), '...': ('r', 127), '(': ('r', 127), '^=': ('r', 127), '||': ('r', 127), '^': ('r', 127), '!=': ('r', 127), '--': ('r', 127), '/=': ('r', 127), '++': ('r', 127), '*=': ('r', 127), '<<=': ('r', 127), '->': ('r', 127), 'auto': ('r', 127), '-=': ('r', 127), '%=': ('r', 127), '+=': ('r', 127), '>=': ('r', 127), 'union': ('r', 127), '<=': ('r', 127), '::': ('c', [('r', 5), ('r', 7), ('r', 127)]), '>>=': ('r', 127), '&&': ('r', 127), '|': ('r', 127), '}': ('r', 127), '~': ('r', 127), 'volatile': ('r', 127), '&=': ('r', 127), '{': ('r', 127), '.*': ('r', 127), 'struct': ('r', 127), '->*': ('r', 127), TYPE_KEYWORD: ('r', 127), 'try': ('r', 127), 'enum': ('r', 127), '>>': ('r', 127), 'class': ('r', 127), ']': ('r', 127), 'typename': ('r', 127), '==': ('r', 127), '[': ('r', 127), 'const': ('r', 127)}, 560),
        #STATE 561
        State([("operator -> '(' ')'", 16)], {')': ('s', 562)}, 561),
        #STATE 562
        State([("operator -> '(' ')'", 19)], {',': ('r', 251), '-': ('r', 251), '.': ('r', 251), '/': ('r', 251), '(': ('r', 251), ')': ('r', 251), '*': ('r', 251), '+': ('r', 251), '%': ('r', 251), '&': ('r', 251), '<': ('r', 251), '=': ('r', 251), '>': ('r', 251), '?': ('r', 251), '<<': ('r', 251), ':': ('r', 251), ';': ('r', 251), '...': ('r', 251), '|=': ('r', 251), '^=': ('r', 251), '%=': ('r', 251), '!=': ('r', 251), '--': ('r', 251), '/=': ('r', 251), '++': ('r', 251), '*=': ('r', 251), '<<=': ('r', 251), '->': ('r', 251), '-=': ('r', 251), '->*': ('r', 251), '+=': ('r', 251), '>=': ('r', 251), '<=': ('r', 251), '||': ('r', 251), '>>=': ('r', 251), '&&': ('r', 251), '|': ('r', 251), '}': ('r', 251), '&=': ('r', 251), '{': ('r', 251), 'try': ('r', 251), '>>': ('r', 251), ']': ('r', 251), '^': ('r', 251), '==': ('r', 251), '[': ('r', 251), '.*': ('r', 251)}, 562),
        #STATE 563
        State([("mem_initializer_id -> '::'?:glbl nested_name_specifier:nns? class_name:name", 70), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63)], {'(': ('r', 325), '::': ('s', 237)}, 563),
        #STATE 564
        State([("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 75)], {',': ('r', 220), '-': ('r', 220), '.': ('r', 220), '/': ('r', 220), '(': ('r', 220), ')': ('r', 220), '*': ('r', 220), '+': ('r', 220), '%': ('r', 220), '&': ('r', 220), '<': ('r', 220), '=': ('r', 220), '>': ('r', 220), '?': ('r', 220), '<<': ('r', 220), ':': ('r', 220), ';': ('r', 220), '...': ('r', 220), '|=': ('r', 220), '^=': ('r', 220), '%=': ('r', 220), '!=': ('r', 220), '--': ('r', 220), '/=': ('r', 220), '==': ('r', 220), '^': ('r', 220), '<<=': ('r', 220), '->': ('r', 220), '-=': ('r', 220), '->*': ('r', 220), '+=': ('r', 220), '>=': ('r', 220), '<=': ('r', 220), '||': ('r', 220), '>>=': ('r', 220), '&&': ('r', 220), '|': ('r', 220), '}': ('r', 220), '&=': ('r', 220), '++': ('r', 220), '>>': ('r', 220), ']': ('r', 220), '*=': ('r', 220), '[': ('r', 220), '.*': ('r', 220)}, 564),
        #STATE 565
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 126)], {',': ('r', 129), '-': ('r', 129), '.': ('r', 129), '/': ('r', 129), '|=': ('r', 129), ')': ('r', 129), '*': ('r', 129), '+': ('r', 129), '%': ('r', 129), '&': ('r', 129), '<': ('r', 129), '=': ('r', 129), '>': ('r', 129), '?': ('r', 129), '<<': ('r', 129), ':': ('r', 129), ';': ('r', 129), '...': ('r', 129), '(': ('r', 129), '^=': ('r', 129), '%=': ('r', 129), '!=': ('r', 129), '--': ('r', 129), '/=': ('r', 129), '==': ('r', 129), '*=': ('r', 129), '<<=': ('r', 129), '->': ('r', 129), '-=': ('r', 129), '->*': ('r', 129), '+=': ('r', 129), '>=': ('r', 129), '<=': ('r', 129), '||': ('r', 129), '>>=': ('r', 129), '&&': ('r', 129), '|': ('r', 129), '}': ('r', 129), '&=': ('r', 129), '++': ('r', 129), '>>': ('r', 129), ']': ('r', 129), '^': ('r', 129), '[': ('r', 129), '.*': ('r', 129)}, 565),
        #STATE 566
        State([('member_declarator -> declarator:d pure_specifier', 48)], {',': ('r', 130), ';': ('r', 130)}, 566),
        #STATE 567
        State([("condition -> type_descriptor:type declarator:dtor '=' assignment_expression:v", 75)], {')': ('r', 133), ';': ('r', 133)}, 567),
        #STATE 568
        State([("jump_statement -> 'continue' ';'", 32)], {'-': ('r', 386), 'asm': ('r', 386), '(': ('r', 386), '*': ('r', 386), 'reinterpret_cast': ('r', 386), 'delete': ('r', 386), 'static_cast': ('r', 386), 'virtual': ('r', 386), '!': ('r', 386), IDENTIFIER: ('r', 386), 'while': ('r', 386), INTEGER_LITERAL: ('r', 386), 'extern': ('r', 386), 'default': ('r', 386), 'goto': ('r', 386), 'break': ('r', 386), 'new': ('r', 386), 'class': ('r', 386), 'typedef': ('r', 386), '--': ('r', 386), '++': ('r', 386), 'dynamic_cast': ('r', 386), 'for': ('r', 386), 'continue': ('r', 386), '+': ('r', 386), 'struct': ('r', 386), 'volatile': ('r', 386), 'namespace': ('r', 386), '&': ('r', 386), 'if': ('r', 386), 'union': ('r', 386), 'const_cast': ('r', 386), '::': ('r', 386), 'auto': ('r', 386), 'using': ('r', 386), 'do': ('r', 386), 'case': ('r', 386), '}': ('r', 386), '~': ('r', 386), 'return': ('r', 386), DECLARE_KEYWORD: ('r', 386), '{': ('r', 386), 'this': ('r', 386), CHARACTER_LITERAL: ('r', 386), FLOATING_LITERAL: ('r', 386), 'sizeof': ('r', 386), 'else': ('r', 386), TYPE_KEYWORD: ('r', 386), 'try': ('r', 386), BOOLEAN_LITERAL: ('r', 386), 'enum': ('r', 386), STRING_LITERAL: ('r', 386), 'throw': ('r', 386), 'typename': ('r', 386), CPP_ERROR: ('r', 386), 'operator': ('r', 386), 'const': ('r', 386), 'switch': ('r', 386), 'typeid': ('r', 386)}, 568),
        #STATE 569
        State([("using_declaration -> 'using' '::' unqualified_id:id ';'", 55)], {'-': ('r', 134), 'asm': ('r', 134), '(': ('r', 134), '*': ('r', 134), '+': ('r', 134), 'delete': ('r', 134), 'static_cast': ('r', 134), 'virtual': ('r', 134), DECLARE_KEYWORD: ('r', 134), ACCESS_KEYWORD: ('r', 134), IDENTIFIER: ('r', 134), 'while': ('r', 134), INTEGER_LITERAL: ('r', 134), 'extern': ('r', 134), 'default': ('r', 134), 'goto': ('r', 134), 'break': ('r', 134), 'new': ('r', 134), 'class': ('r', 134), 'typedef': ('r', 134), '--': ('r', 134), '++': ('r', 134), 'dynamic_cast': ('r', 134), 'for': ('r', 134), 'export': ('r', 134), 'struct': ('r', 134), 'template': ('r', 134), 'continue': ('r', 134), '&': ('r', 134), 'this': ('r', 134), 'if': ('r', 134), 'union': ('r', 134), 'const_cast': ('r', 134), '::': ('r', 134), 'auto': ('r', 134), 'using': ('r', 134), 'volatile': ('r', 134), 'namespace': ('r', 134), 'do': ('r', 134), '!': ('r', 134), '}': ('r', 134), '~': ('r', 134), 'return': ('r', 134), '{': ('r', 134), 'case': ('r', 134), TYPE_KEYWORD: ('r', 134), FLOATING_LITERAL: ('r', 134), 'sizeof': ('r', 134), 'else': ('r', 134), CHARACTER_LITERAL: ('r', 134), 'try': ('r', 134), 'reinterpret_cast': ('r', 134), BOOLEAN_LITERAL: ('r', 134), 'enum': ('r', 134), EOF: ('r', 134), STRING_LITERAL: ('r', 134), 'throw': ('r', 134), CPP_INCLUDE: ('r', 134), 'typename': ('r', 134), CPP_ERROR: ('r', 134), 'operator': ('r', 134), 'const': ('r', 134), 'switch': ('r', 134), 'typeid': ('r', 134)}, 569),
        #STATE 570
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 89), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), template_id: ('g', 571), IDENTIFIER: ('s', 216)}, 570),
        #STATE 571
        State([("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 100)], {',': ('r', 323), '-': ('r', 323), '.': ('r', 323), '/': ('r', 323), '|=': ('r', 323), ')': ('r', 323), '*': ('r', 323), '+': ('r', 323), '%': ('r', 323), '&': ('r', 323), 'operator': ('r', 323), '%=': ('r', 323), '<': ('r', 323), '=': ('r', 323), '>': ('r', 323), '?': ('r', 323), '<<': ('r', 323), IDENTIFIER: ('r', 323), ':': ('r', 323), ';': ('r', 323), '...': ('r', 323), '(': ('r', 323), '^=': ('r', 323), '||': ('r', 323), '^': ('r', 323), '!=': ('r', 323), '--': ('r', 323), '/=': ('r', 323), '++': ('r', 323), '*=': ('r', 323), '<<=': ('r', 323), '->': ('r', 323), '-=': ('r', 323), 'auto': ('r', 323), 'volatile': ('r', 323), '->*': ('r', 323), '+=': ('r', 323), '>=': ('r', 323), 'union': ('r', 323), '<=': ('r', 323), '::': ('r', 323), '>>=': ('r', 323), '&&': ('r', 323), '|': ('r', 323), '}': ('r', 323), '~': ('r', 323), '&=': ('r', 323), '{': ('r', 323), '.*': ('r', 323), 'struct': ('r', 323), TYPE_KEYWORD: ('r', 323), 'try': ('r', 323), 'enum': ('r', 323), '>>': ('r', 323), 'class': ('r', 323), ']': ('r', 323), 'typename': ('r', 323), '==': ('r', 323), '[': ('r', 323), 'const': ('r', 323)}, 571),
        #STATE 572
        State([("handler -> 'catch' '(' exception_declaration:exc ')' compound_statement:body", 71)], {'-': ('r', 136), '++': ('r', 136), '(': ('r', 136), '*': ('r', 136), 'reinterpret_cast': ('r', 136), 'delete': ('r', 136), 'static_cast': ('r', 136), 'virtual': ('r', 136), '!': ('r', 136), ACCESS_KEYWORD: ('r', 136), IDENTIFIER: ('r', 136), ';': ('r', 136), INTEGER_LITERAL: ('r', 136), 'typedef': ('r', 136), 'default': ('r', 136), 'goto': ('r', 136), 'new': ('r', 136), 'throw': ('r', 136), 'extern': ('r', 136), '--': ('r', 136), 'catch': ('r', 136), 'asm': ('r', 136), 'dynamic_cast': ('r', 136), 'for': ('r', 136), 'export': ('r', 136), 'struct': ('r', 136), 'template': ('r', 136), 'continue': ('r', 136), '&': ('r', 136), 'case': ('r', 136), 'if': ('r', 136), 'union': ('r', 136), 'const_cast': ('r', 136), '::': ('r', 136), 'auto': ('r', 136), 'using': ('r', 136), 'volatile': ('r', 136), 'namespace': ('r', 136), 'do': ('r', 136), DECLARE_KEYWORD: ('r', 136), '}': ('r', 136), '~': ('r', 136), 'return': ('r', 136), '{': ('r', 136), 'this': ('r', 136), TYPE_KEYWORD: ('r', 136), FLOATING_LITERAL: ('r', 136), 'sizeof': ('r', 136), 'else': ('r', 136), CHARACTER_LITERAL: ('r', 136), 'class': ('r', 136), 'try': ('r', 136), BOOLEAN_LITERAL: ('r', 136), 'enum': ('r', 136), EOF: ('r', 136), STRING_LITERAL: ('r', 136), '+': ('r', 136), CPP_INCLUDE: ('r', 136), 'typename': ('r', 136), 'while': ('r', 136), 'break': ('r', 136), 'operator': ('r', 136), CPP_ERROR: ('r', 136), 'const': ('r', 136), 'switch': ('r', 136), 'typeid': ('r', 136)}, 572),
        #STATE 573
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 73), ("new_initializer -> '(' assignment_expression!*,','! ')'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 74), ("new_initializer -> '(' assignment_expression!*,','! ')'", 19)], {',': ('r', 137), '-': ('r', 137), '/': ('r', 137), '(': ('s', 300), ')': ('r', 137), '*': ('r', 137), '+': ('r', 137), '%': ('r', 137), '&': ('r', 137), '>>=': ('r', 137), '+=': ('r', 137), '&&': ('r', 137), '<': ('r', 137), '=': ('r', 137), '>': ('r', 137), '?': ('r', 137), '<=': ('r', 137), ':': ('r', 137), ';': ('r', 137), '...': ('r', 137), '|=': ('r', 137), '^=': ('r', 137), '%=': ('r', 137), '|': ('r', 137), '!=': ('r', 137), '}': ('r', 137), '/=': ('r', 137), '==': ('r', 137), '||': ('r', 137), '^': ('r', 137), '&=': ('r', 137), '<<': ('r', 137), ']': ('r', 137), '*=': ('r', 137), '<<=': ('r', 137), new_initializer: ('g', 574), '-=': ('r', 137), '.*': ('r', 137), '->*': ('r', 137), '>>': ('r', 137), '>=': ('r', 137)}, 573),
        #STATE 574
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 89)], {',': ('r', 194), '-': ('r', 194), '/': ('r', 194), '|=': ('r', 194), ')': ('r', 194), '*': ('r', 194), '==': ('r', 194), '%': ('r', 194), '&': ('r', 194), '>>=': ('r', 194), '&&': ('r', 194), '<': ('r', 194), '=': ('r', 194), '>': ('r', 194), '?': ('r', 194), '<<': ('r', 194), ':': ('r', 194), ';': ('r', 194), '...': ('r', 194), '<=': ('r', 194), '^=': ('r', 194), '%=': ('r', 194), '|': ('r', 194), '!=': ('r', 194), '}': ('r', 194), '/=': ('r', 194), '+': ('r', 194), '||': ('r', 194), '*=': ('r', 194), '&=': ('r', 194), '+=': ('r', 194), ']': ('r', 194), '^': ('r', 194), '<<=': ('r', 194), '-=': ('r', 194), '.*': ('r', 194), '->*': ('r', 194), '>>': ('r', 194), '>=': ('r', 194)}, 574),
        #STATE 575
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 137)], {',': ('r', 139), '-': ('r', 139), '.': ('r', 139), '/': ('r', 139), '|=': ('r', 139), ')': ('r', 139), '*': ('r', 139), '+': ('r', 139), '%': ('r', 139), '&': ('r', 139), '<': ('r', 139), '=': ('r', 139), '>': ('r', 139), '?': ('r', 139), '<<': ('r', 139), ':': ('r', 139), ';': ('r', 139), '...': ('r', 139), '(': ('r', 139), '^=': ('r', 139), '%=': ('r', 139), '!=': ('r', 139), '--': ('r', 139), '/=': ('r', 139), '==': ('r', 139), '*=': ('r', 139), '<<=': ('r', 139), '->': ('r', 139), '-=': ('r', 139), '->*': ('r', 139), '>>': ('r', 139), '>=': ('r', 139), '<=': ('r', 139), '||': ('r', 139), '>>=': ('r', 139), '&&': ('r', 139), '|': ('r', 139), '}': ('r', 139), '&=': ('r', 139), '++': ('r', 139), '+=': ('r', 139), ']': ('r', 139), '^': ('r', 139), '[': ('r', 139), '.*': ('r', 139)}, 575),
        #STATE 576
        State([("labeled_statement -> 'case' constant_expression:c ':' statement:st", 50)], {':': ('s', 577)}, 576),
        #STATE 577
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ('statement -> iteration_statement!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> CPP_ERROR!', 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('statement -> labeled_statement!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('block_declaration -> asm_definition!', 21), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ('statement -> compound_statement!', 13), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ('statement -> jump_statement!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 54), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unary_expression -> postfix_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_name -> template_id!', 13), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), '++': ('s', 55), pm_expression: ('g', 73), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), and_expression: ('g', 72), _80: ('g', 112), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), logical_and_expression: ('g', 118), 'asm': ('s', 125), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), conversion_function_id: ('g', 357), 'namespace': ('s', 170), expression: ('g', 335), STRING_LITERAL: ('s', 113), 'auto': ('s', 90), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), compound_statement: ('g', 339), DECLARE_KEYWORD: ('s', 160), selection_statement: ('g', 340), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), operator_function_id: ('g', 6), 'enum': ('s', 117), block_declaration: ('g', 344), 'typename': ('s', 116), 'while': ('s', 349), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 532), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), 'default': ('s', 330), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), asm_definition: ('g', 149), 'union': ('s', 97), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'do': ('s', 355), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'case': ('s', 356), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), 'try': ('s', 334), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), declaration_statement: ('g', 343), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), nested_name_specifier: ('g', 352), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 577),
        #STATE 578
        State([('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 58)], {',': ('r', 427), 'union': ('r', 427), ')': ('r', 427), 'auto': ('r', 427), 'enum': ('r', 427), 'typename': ('r', 427), '::': ('r', 427), 'class': ('r', 427), '=': ('r', 427), '>': ('r', 427), IDENTIFIER: ('r', 427), 'struct': ('r', 427), 'volatile': ('r', 427), '...': ('r', 427), 'const': ('r', 427), TYPE_KEYWORD: ('r', 427)}, 578),
        #STATE 579
        State([("and_expression -> and_expression:a '&' equality_expression:b", 35), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 71)], {',': ('r', 564), '|=': ('r', 564), ')': ('r', 564), '&': ('s', 621), '>>=': ('r', 564), '&&': ('r', 564), '|': ('r', 564), '}': ('r', 564), '>': ('r', 564), '?': ('r', 564), '&=': ('r', 564), ':': ('r', 564), ';': ('r', 564), '...': ('r', 564), '^=': ('r', 564), '%=': ('r', 564), '=': ('r', 564), '/=': ('r', 564), '||': ('r', 564), '*=': ('r', 564), ']': ('r', 564), '^': ('r', 564), '<<=': ('r', 564), '-=': ('r', 564), '+=': ('r', 564)}, 579),
        #STATE 580
        State([("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 93), ("expression -> expression:a ',' assignment_expression:b", 27)], {',': ('s', 272), ')': ('s', 581)}, 580),
        #STATE 581
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ('statement -> iteration_statement!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> CPP_ERROR!', 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('statement -> labeled_statement!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('block_declaration -> asm_definition!', 21), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ('statement -> compound_statement!', 13), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ('statement -> jump_statement!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 97), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unary_expression -> postfix_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_name -> template_id!', 13), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), '++': ('s', 55), pm_expression: ('g', 73), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), and_expression: ('g', 72), _80: ('g', 112), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), logical_and_expression: ('g', 118), 'asm': ('s', 125), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), conversion_function_id: ('g', 357), 'namespace': ('s', 170), expression: ('g', 335), STRING_LITERAL: ('s', 113), 'auto': ('s', 90), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), compound_statement: ('g', 339), DECLARE_KEYWORD: ('s', 160), selection_statement: ('g', 340), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), operator_function_id: ('g', 6), 'enum': ('s', 117), block_declaration: ('g', 344), 'typename': ('s', 116), 'while': ('s', 349), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 812), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), 'default': ('s', 330), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), asm_definition: ('g', 149), 'union': ('s', 97), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'do': ('s', 355), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'case': ('s', 356), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), 'try': ('s', 334), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), declaration_statement: ('g', 343), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), nested_name_specifier: ('g', 352), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 581),
        #STATE 582
        State([("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('raw_type_descriptor -> enum_specifier!', 23), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ('raw_type_descriptor -> named_type_specifier!', 23), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ('template_parameter -> parameter_declaration!', 22), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("class_key -> 'class' | 'struct' | 'union'", 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('parameter_declaration -> type_descriptor:type declarator:dtor', 25), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('template_parameter -> type_parameter!', 22), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {raw_type_descriptor: ('g', 54), 'auto': ('s', 90), IDENTIFIER: ('s', 29), named_type_specifier: ('g', 126), 'union': ('s', 97), nested_name_specifier: ('g', 189), parameter_declaration: ('g', 196), type_name: ('g', 98), type_descriptor: ('g', 193), elaborated_type_specifier: ('g', 109), enum_specifier: ('g', 122), 'template': ('s', 201), template_name: ('g', 2), _123: ('g', 551), class_name: ('g', 11), '::': ('s', 191), cv_qualifier: ('g', 106), class_head: ('g', 20), type_parameter: ('g', 202), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), _80: ('g', 112), class_specifier: ('g', 75), 'class': ('s', 198), 'typename': ('s', 199), namespace_name: ('g', 5), 'enum': ('s', 117), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), _81: ('g', 88), template_id: ('g', 18), template_parameter: ('g', 200)}, 582),
        #STATE 583
        State([("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 87), ('template_name -> IDENTIFIER!', 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 86), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 86)], {',': ('r', 3), '(': ('c', [('s', 584), ('r', 3)]), '::': ('r', 3), '*': ('r', 3), '&': ('r', 3), '[': ('r', 3), '~': ('r', 3), '<': ('r', 2), '>': ('r', 3), IDENTIFIER: ('r', 3), 'operator': ('r', 3), ';': ('r', 3), ')': ('r', 3)}, 583),
        #STATE 584
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 123), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), ')': ('s', 758), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), _15: ('g', 757), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), relational_expression: ('g', 67), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 323), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), named_type_specifier: ('g', 177), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 584),
        #STATE 585
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 88), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 61), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), nested_name_specifier: ('g', 893), class_name: ('g', 236), template_id: ('g', 44)}, 585),
        #STATE 586
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 88), ('template_name -> IDENTIFIER!', 17), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_id: ('g', 44), template_name: ('g', 2), IDENTIFIER: ('s', 173), class_name: ('g', 1047)}, 586),
        #STATE 587
        State([("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 88), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 50), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 61), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 50), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), template_id: ('g', 44), nested_name_specifier: ('g', 185), class_name: ('g', 489), '::': ('s', 591)}, 587),
        #STATE 588
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('id_expression -> unqualified_id!', 17), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 93), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 77), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), ')': ('s', 798), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), expression: ('g', 580), named_type_specifier: ('g', 177), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 588),
        #STATE 589
        State([("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 122), ("cv_qualifier -> 'const'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 33), ("cv_qualifier -> 'volatile'!", 16)], {',': ('r', 144), cv_qualifier: ('g', 32), '(': ('r', 144), exception_specification: ('g', 590), 'union': ('r', 144), 'struct': ('r', 144), TYPE_KEYWORD: ('r', 144), 'enum': ('r', 144), 'typename': ('r', 144), '::': ('r', 144), 'throw': ('s', 31), '=': ('r', 144), '>': ('r', 144), '[': ('r', 144), IDENTIFIER: ('r', 144), 'auto': ('r', 144), 'volatile': ('c', [('s', 33), ('r', 144)]), '...': ('r', 144), 'const': ('c', [('s', 35), ('r', 144)]), 'class': ('r', 144), ')': ('r', 144)}, 589),
        #STATE 590
        State([("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 145)], {',': ('r', 473), 'union': ('r', 473), '(': ('r', 473), ')': ('r', 473), 'auto': ('r', 473), 'volatile': ('r', 473), TYPE_KEYWORD: ('r', 473), 'enum': ('r', 473), 'typename': ('r', 473), 'class': ('r', 473), '=': ('r', 473), '>': ('r', 473), IDENTIFIER: ('r', 473), 'struct': ('r', 473), '[': ('r', 473), '...': ('r', 473), 'const': ('r', 473), '::': ('r', 473)}, 590),
        #STATE 591
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 61), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 88), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), nested_name_specifier: ('g', 528), class_name: ('g', 592), template_id: ('g', 44)}, 591),
        #STATE 592
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 98), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63)], {',': ('r', 536), '::': ('s', 237), '{': ('r', 536)}, 592),
        #STATE 593
        State([("direct_abstract_declarator -> '(' abstract_declarator! ')'", 58)], {',': ('r', 146), 'union': ('r', 146), '(': ('r', 146), ')': ('r', 146), 'struct': ('r', 146), 'volatile': ('r', 146), TYPE_KEYWORD: ('r', 146), 'enum': ('r', 146), 'typename': ('r', 146), 'class': ('r', 146), '=': ('r', 146), '>': ('r', 146), IDENTIFIER: ('r', 146), 'auto': ('r', 146), '[': ('r', 146), '...': ('r', 146), 'const': ('r', 146), '::': ('r', 146)}, 593),
        #STATE 594
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("operator_function_id -> 'operator' operator:op", 24), ('template_name -> IDENTIFIER!', 17), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 73), ('unqualified_id -> operator_function_id!', 18), ('unqualified_id -> IDENTIFIER:id', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 72), ('unqualified_id -> conversion_function_id!', 18), ("unqualified_id -> '~' class_name:name", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), '~': ('s', 45), IDENTIFIER: ('s', 596), conversion_function_id: ('g', 12), unqualified_id: ('g', 595), operator_function_id: ('g', 6), 'operator': ('s', 8), template_id: ('g', 492)}, 594),
        #STATE 595
        State([("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 91)], {';': ('s', 850)}, 595),
        #STATE 596
        State([('unqualified_id -> IDENTIFIER:id', 28), ('template_name -> IDENTIFIER!', 27)], {',': ('r', 95), '-': ('r', 95), '.': ('r', 95), '/': ('r', 95), '|=': ('r', 95), ')': ('r', 95), '*': ('r', 95), '+': ('r', 95), '%': ('r', 95), '&': ('r', 95), '<': ('c', [('r', 95), ('r', 2)]), '=': ('r', 95), '>': ('r', 95), '?': ('r', 95), '<<': ('r', 95), ':': ('r', 95), ';': ('r', 95), '...': ('r', 95), '(': ('r', 95), '^=': ('r', 95), '%=': ('r', 95), '!=': ('r', 95), '--': ('r', 95), '/=': ('r', 95), '++': ('r', 95), '^': ('r', 95), '<<=': ('r', 95), '->': ('r', 95), '-=': ('r', 95), '->*': ('r', 95), '+=': ('r', 95), '>=': ('r', 95), '<=': ('r', 95), '||': ('r', 95), '>>=': ('r', 95), '&&': ('r', 95), '|': ('r', 95), '}': ('r', 95), '&=': ('r', 95), '>>': ('r', 95), ']': ('r', 95), '*=': ('r', 95), '==': ('r', 95), '[': ('r', 95), '.*': ('r', 95)}, 596),
        #STATE 597
        State([("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 83)], {',': ('r', 148), '-': ('r', 148), '.': ('r', 148), '/': ('r', 148), '|=': ('r', 148), ')': ('r', 148), '*': ('r', 148), '+': ('r', 148), '%': ('r', 148), '&': ('r', 148), 'operator': ('r', 148), '<': ('r', 148), '=': ('r', 148), '>': ('r', 148), '?': ('r', 148), IDENTIFIER: ('r', 148), ':': ('r', 148), ';': ('r', 148), '...': ('r', 148), '(': ('r', 148), '^=': ('r', 148), '::': ('r', 148), '^': ('r', 148), '!=': ('r', 148), '--': ('r', 148), '/=': ('r', 148), '++': ('r', 148), 'typename': ('r', 148), '<<=': ('r', 148), '->': ('r', 148), 'struct': ('r', 148), '-=': ('r', 148), '%=': ('r', 148), '>>': ('r', 148), '>=': ('r', 148), 'union': ('r', 148), '<=': ('r', 148), '<<': ('r', 148), 'auto': ('r', 148), '||': ('r', 148), '>>=': ('r', 148), '&&': ('r', 148), '|': ('r', 148), '}': ('r', 148), '~': ('r', 148), 'volatile': ('r', 148), '&=': ('r', 148), '{': ('r', 148), '.*': ('r', 148), '->*': ('r', 148), TYPE_KEYWORD: ('r', 148), 'try': ('r', 148), 'enum': ('r', 148), '+=': ('r', 148), 'class': ('r', 148), ']': ('r', 148), '*=': ('r', 148), '==': ('r', 148), '[': ('r', 148), 'const': ('r', 148)}, 597),
        #STATE 598
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 71)], {',': ('r', 149), '-': ('r', 149), '.': ('r', 149), '/': ('r', 149), '(': ('r', 149), ')': ('r', 149), '*': ('r', 149), '+': ('r', 149), '%': ('r', 149), '&': ('r', 149), '<': ('r', 149), '=': ('r', 149), '>': ('r', 149), '?': ('r', 149), '<<': ('r', 149), ':': ('r', 149), ';': ('r', 149), '...': ('r', 149), '|=': ('r', 149), '^=': ('r', 149), '%=': ('r', 149), '!=': ('r', 149), '--': ('r', 149), '/=': ('r', 149), '++': ('r', 149), '^': ('r', 149), '<<=': ('r', 149), '->': ('r', 149), '-=': ('r', 149), '->*': ('r', 149), '+=': ('r', 149), '>=': ('r', 149), '<=': ('r', 149), '||': ('r', 149), '>>=': ('r', 149), '&&': ('r', 149), '|': ('r', 149), '}': ('r', 149), '&=': ('r', 149), '{': ('r', 149), 'try': ('r', 149), '>>': ('r', 149), ']': ('r', 149), '*=': ('r', 149), '==': ('r', 149), '[': ('r', 149), '.*': ('r', 149)}, 598),
        #STATE 599
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('id_expression -> unqualified_id!', 17), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("direct_new_declarator -> direct_new_declarator:dtor? '[' expression:size ']'", 57), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), expression: ('g', 600), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 599),
        #STATE 600
        State([("direct_new_declarator -> direct_new_declarator:dtor? '[' expression:size ']'", 73), ("expression -> expression:a ',' assignment_expression:b", 27)], {',': ('s', 272), ']': ('s', 749)}, 600),
        #STATE 601
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 41), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {named_type_specifier: ('g', 126), template_name: ('g', 2), IDENTIFIER: ('s', 29), '::': ('s', 191), raw_type_descriptor: ('g', 54), template_id: ('g', 18), nested_name_specifier: ('g', 189), type_name: ('g', 98), 'union': ('s', 97), type_descriptor: ('g', 240), elaborated_type_specifier: ('g', 109), enum_specifier: ('g', 122), class_name: ('g', 11), TYPE_KEYWORD: ('s', 162), cv_qualifier: ('g', 106), class_head: ('g', 20), class_key: ('g', 78), _80: ('g', 112), class_specifier: ('g', 75), 'class': ('s', 115), type_id: ('g', 308), 'typename': ('s', 166), namespace_name: ('g', 5), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), _81: ('g', 88), 'enum': ('s', 117), 'auto': ('s', 90)}, 601),
        #STATE 602
        State([("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 78)], {',': ('r', 355), ';': ('r', 355)}, 602),
        #STATE 603
        State([('init_declarator -> declarator:d initializer:init?', 32), ("initializer -> '=' initializer_clause!", 15), ('init_declarator -> declarator:d initializer:init?', 29), ("initializer -> '(' assignment_expression!+,',':args ')'", 15)], {',': ('r', 440), '=': ('s', 971), '(': ('s', 1026), initializer: ('g', 1027), ';': ('r', 440)}, 603),
        #STATE 604
        State([('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 56)], {',': ('r', 151), '-': ('r', 151), '.': ('r', 151), '/': ('r', 151), '|=': ('r', 151), ')': ('r', 151), '*': ('r', 151), '+': ('r', 151), '%': ('r', 151), '&': ('r', 151), '{': ('r', 151), '%=': ('r', 151), '<': ('r', 151), '=': ('r', 151), '>': ('r', 151), '?': ('r', 151), IDENTIFIER: ('r', 151), ':': ('r', 151), ';': ('r', 151), '...': ('r', 151), '(': ('r', 151), '^=': ('r', 151), '::': ('r', 151), '!=': ('r', 151), '--': ('r', 151), '/=': ('r', 151), '++': ('r', 151), '^': ('r', 151), 'typename': ('r', 151), '<<=': ('r', 151), '->': ('r', 151), 'auto': ('r', 151), '-=': ('r', 151), '->*': ('r', 151), '+=': ('r', 151), '>=': ('r', 151), 'union': ('r', 151), '<=': ('r', 151), '<<': ('r', 151), '||': ('r', 151), '>>=': ('r', 151), '&&': ('r', 151), 'const': ('r', 151), '|': ('r', 151), '}': ('r', 151), '~': ('r', 151), 'volatile': ('r', 151), '&=': ('r', 151), 'operator': ('r', 151), 'struct': ('r', 151), TYPE_KEYWORD: ('r', 151), 'try': ('r', 151), 'enum': ('r', 151), '>>': ('r', 151), 'class': ('r', 151), ']': ('r', 151), '*=': ('r', 151), '==': ('r', 151), '[': ('r', 151), '.*': ('r', 151)}, 604),
        #STATE 605
        State([("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 63)], {'-': ('r', 152), 'asm': ('r', 152), '(': ('r', 152), '*': ('r', 152), '+': ('r', 152), 'delete': ('r', 152), 'static_cast': ('r', 152), 'virtual': ('r', 152), '!': ('r', 152), IDENTIFIER: ('r', 152), 'while': ('r', 152), INTEGER_LITERAL: ('r', 152), 'extern': ('r', 152), 'default': ('r', 152), 'goto': ('r', 152), 'new': ('r', 152), 'throw': ('r', 152), 'typedef': ('r', 152), '--': ('r', 152), '++': ('r', 152), 'dynamic_cast': ('r', 152), 'for': ('r', 152), 'continue': ('r', 152), 'struct': ('r', 152), 'volatile': ('r', 152), 'namespace': ('r', 152), '&': ('r', 152), 'if': ('r', 152), 'union': ('r', 152), 'const_cast': ('r', 152), '::': ('r', 152), 'auto': ('r', 152), 'using': ('r', 152), 'do': ('r', 152), 'case': ('r', 152), 'try': ('r', 152), '~': ('r', 152), 'return': ('r', 152), DECLARE_KEYWORD: ('r', 152), '{': ('r', 152), 'this': ('r', 152), CHARACTER_LITERAL: ('r', 152), FLOATING_LITERAL: ('r', 152), 'sizeof': ('r', 152), 'else': ('r', 152), TYPE_KEYWORD: ('r', 152), '}': ('r', 152), 'reinterpret_cast': ('r', 152), BOOLEAN_LITERAL: ('r', 152), 'enum': ('r', 152), STRING_LITERAL: ('r', 152), 'class': ('r', 152), 'typename': ('r', 152), 'break': ('r', 152), 'operator': ('r', 152), CPP_ERROR: ('r', 152), 'const': ('r', 152), 'switch': ('r', 152), 'typeid': ('r', 152)}, 605),
        #STATE 606
        State([("direct_new_declarator -> direct_new_declarator:dtor? '[' expression:size ']'", 76)], {',': ('r', 153), '-': ('r', 153), '/': ('r', 153), '(': ('r', 153), ')': ('r', 153), '*': ('r', 153), '+': ('r', 153), '%': ('r', 153), '&': ('r', 153), '>>=': ('r', 153), '&&': ('r', 153), '<': ('r', 153), '=': ('r', 153), '>': ('r', 153), '?': ('r', 153), '<=': ('r', 153), ':': ('r', 153), ';': ('r', 153), '...': ('r', 153), '|=': ('r', 153), '^=': ('r', 153), '%=': ('r', 153), '|': ('r', 153), '!=': ('r', 153), '}': ('r', 153), '/=': ('r', 153), '[': ('r', 153), '==': ('r', 153), '||': ('r', 153), '^': ('r', 153), '&=': ('r', 153), '<<': ('r', 153), ']': ('r', 153), '*=': ('r', 153), '<<=': ('r', 153), '>>': ('r', 153), '-=': ('r', 153), '.*': ('r', 153), '->*': ('r', 153), '+=': ('r', 153), '>=': ('r', 153)}, 606),
        #STATE 607
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ('postfix_expression -> primary_expression!', 22), ('raw_type_descriptor -> class_specifier!', 23), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 32), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("unary_expression -> 'sizeof' unary_expression:v", 20), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 32), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("unary_expression -> '++' cast_expression:v", 20), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ('class_head -> class_key:t base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('id_expression -> qualified_id!', 17), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('equality_expression -> relational_expression!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('namespace_name -> IDENTIFIER:name', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('assignment_expression -> conditional_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('unqualified_id -> conversion_function_id!', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("cv_qualifier -> 'const'!", 16), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('condition -> expression!', 13), ('unary_expression -> postfix_expression!', 20), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("condition -> type_descriptor:type declarator:dtor '=' assignment_expression:v", 13), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('pm_expression -> cast_expression!', 17), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), template_name: ('g', 2), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), cv_qualifier: ('g', 106), additive_expression: ('g', 63), logical_and_expression: ('g', 118), shift_expression: ('g', 65), relational_expression: ('g', 67), condition: ('g', 616), INTEGER_LITERAL: ('s', 87), CHARACTER_LITERAL: ('s', 108), equality_expression: ('g', 70), 'static_cast': ('s', 71), delete_expression: ('g', 119), class_name: ('g', 11), pm_expression: ('g', 73), 'new': ('s', 74), throw_expression: ('g', 91), id_expression: ('g', 114), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), elaborated_type_specifier: ('g', 109), class_key: ('g', 78), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), 'struct': ('s', 58), simple_type_specifier: ('g', 86), type_descriptor: ('g', 120), primary_expression: ('g', 40), enum_specifier: ('g', 122), _81: ('g', 88), expression: ('g', 89), 'auto': ('s', 90), unqualified_id: ('g', 7), 'const_cast': ('s', 92), '::': ('s', 64), class_specifier: ('g', 75), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), 'union': ('s', 97), type_name: ('g', 98), conversion_function_id: ('g', 12), '~': ('s', 100), 'volatile': ('s', 33), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), class_head: ('g', 20), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), postfix_expression: ('g', 99), 'reinterpret_cast': ('s', 110), BOOLEAN_LITERAL: ('s', 102), '--': ('s', 111), _80: ('g', 112), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 116), namespace_name: ('g', 5), 'enum': ('s', 117), operator_function_id: ('g', 6), exclusive_or_expression: ('g', 121), 'const': ('s', 35), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 607),
        #STATE 608
        State([("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 87)], {',': ('r', 156), '...': ('r', 156), '>': ('r', 156), ')': ('r', 156)}, 608),
        #STATE 609
        State([('exception_declaration -> type_descriptor:type ( declarator:dtor | abstract_declarator:dtor )?', 85)], {')': ('r', 157)}, 609),
        #STATE 610
        State([("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 69)], {',': ('r', 158), '>': ('r', 158)}, 610),
        #STATE 611
        State([("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("qualified_namespace_specifier -> '::'?:glbl nested_name_specifier:nns? namespace_name:name", 85), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63)], {'::': ('s', 275), ';': ('r', 159)}, 611),
        #STATE 612
        State([("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 47), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 74), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 560), namespace_name: ('g', 5), nested_name_specifier: ('g', 613), class_name: ('g', 11), template_id: ('g', 44)}, 612),
        #STATE 613
        State([("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 74)], {IDENTIFIER: ('s', 855)}, 613),
        #STATE 614
        State([("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 99)], {';': ('s', 615)}, 614),
        #STATE 615
        State([("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 102)], {'sizeof': ('r', 240), '-': ('r', 240), 'asm': ('r', 240), '(': ('r', 240), '*': ('r', 240), 'reinterpret_cast': ('r', 240), 'delete': ('r', 240), 'static_cast': ('r', 240), 'virtual': ('r', 240), DECLARE_KEYWORD: ('r', 240), ACCESS_KEYWORD: ('r', 240), IDENTIFIER: ('r', 240), 'while': ('r', 240), INTEGER_LITERAL: ('r', 240), 'extern': ('r', 240), 'default': ('r', 240), 'goto': ('r', 240), 'new': ('r', 240), 'class': ('r', 240), 'typedef': ('r', 240), '--': ('r', 240), '++': ('r', 240), 'dynamic_cast': ('r', 240), 'for': ('r', 240), 'export': ('r', 240), '+': ('r', 240), 'struct': ('r', 240), 'template': ('r', 240), 'continue': ('r', 240), '&': ('r', 240), 'case': ('r', 240), 'if': ('r', 240), 'union': ('r', 240), 'const_cast': ('r', 240), '::': ('r', 240), 'auto': ('r', 240), 'using': ('r', 240), 'volatile': ('r', 240), 'namespace': ('r', 240), 'do': ('r', 240), '!': ('r', 240), '}': ('r', 240), '~': ('r', 240), 'return': ('r', 240), '{': ('r', 240), 'this': ('r', 240), TYPE_KEYWORD: ('r', 240), FLOATING_LITERAL: ('r', 240), CPP_ERROR: ('r', 240), 'else': ('r', 240), CHARACTER_LITERAL: ('r', 240), 'try': ('r', 240), BOOLEAN_LITERAL: ('r', 240), 'enum': ('r', 240), EOF: ('r', 240), STRING_LITERAL: ('r', 240), 'throw': ('r', 240), CPP_INCLUDE: ('r', 240), 'typename': ('r', 240), 'break': ('r', 240), 'operator': ('r', 240), 'const': ('r', 240), 'switch': ('r', 240), 'typeid': ('r', 240)}, 615),
        #STATE 616
        State([("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 47), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 47)], {')': ('s', 828)}, 616),
        #STATE 617
        State([("qualified_id -> '::' IDENTIFIER!", 31), ('namespace_name -> IDENTIFIER:name', 28), ('template_name -> IDENTIFIER!', 27), ('class_name -> IDENTIFIER:name', 24)], {',': ('r', 476), '-': ('r', 476), '.': ('r', 476), '/': ('r', 476), '(': ('r', 476), ')': ('r', 476), '*': ('r', 476), '+': ('r', 476), '%': ('r', 476), '&': ('r', 476), '::': ('c', [('r', 5), ('r', 7)]), '<': ('c', [('r', 476), ('r', 2)]), '=': ('r', 476), '>': ('r', 476), '?': ('r', 476), '<<': ('r', 476), ':': ('r', 476), ';': ('r', 476), '...': ('r', 476), '|=': ('r', 476), '^=': ('r', 476), '%=': ('r', 476), '!=': ('r', 476), '--': ('r', 476), '/=': ('r', 476), '++': ('r', 476), '*=': ('r', 476), '<<=': ('r', 476), '->': ('r', 476), '-=': ('r', 476), '->*': ('r', 476), '+=': ('r', 476), '>=': ('r', 476), '<=': ('r', 476), '||': ('r', 476), '>>=': ('r', 476), '&&': ('r', 476), '|': ('r', 476), '}': ('r', 476), '&=': ('r', 476), '{': ('r', 476), 'try': ('r', 476), '>>': ('r', 476), ']': ('r', 476), '^': ('r', 476), '==': ('r', 476), '[': ('r', 476), '.*': ('r', 476)}, 617),
        #STATE 618
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 53), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("operator_function_id -> 'operator' operator:op", 24), ('unqualified_id -> IDENTIFIER:id', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unqualified_id -> '~' class_name:name", 18), ('unqualified_id -> conversion_function_id!', 18)], {unqualified_id: ('g', 425), '~': ('s', 45), IDENTIFIER: ('s', 314), conversion_function_id: ('g', 12), 'template': ('s', 312), operator_function_id: ('g', 6), 'operator': ('s', 8)}, 618),
        #STATE 619
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 254), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 213), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 140), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 103), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 40), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 293), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 246), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 172), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 132), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 278), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 68), ("operator -> '[' ']'", 12), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 33), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 204), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 164), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 96), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 262), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 61), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 238), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 270), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 196), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 124), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 302), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 89), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 21), ("operator -> 'new' '[' ']'", 12), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 230), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 156), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 117), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 54), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 12), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 188), ("operator_function_id -> 'operator' operator:op", 35), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 148), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 82), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 286), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 47), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 222), ("operator -> 'delete' '[' ']'", 12), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 180), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 110), ("operator -> '(' ')'", 12), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 75)], {',': ('s', 963), '-': ('s', 734), '/': ('s', 823), '<=': ('s', 809), '||': ('s', 378), '*': ('s', 868), '+': ('s', 52), 'delete': ('s', 663), '%': ('s', 1017), '&': ('s', 458), '>>=': ('s', 839), '&&': ('s', 554), '!': ('s', 319), '|': ('s', 977), '=': ('s', 670), '~': ('s', 1018), '&=': ('s', 362), '-=': ('s', 1021), '|=': ('s', 1019), '^=': ('s', 918), '<<': ('s', 821), 'new': ('s', 394), '<': ('s', 544), '(': ('s', 561), '!=': ('s', 22), '--': ('s', 1020), '/=': ('s', 960), '++': ('s', 829), operator: ('g', 853), '%=': ('s', 975), '+=': ('s', 388), '^': ('s', 598), '<<=': ('s', 875), '==': ('s', 503), '*=': ('s', 1003), '[': ('s', 210), '->': ('s', 37), '->*': ('s', 1022), '>': ('s', 1023), '>>': ('s', 941), '>=': ('s', 1024)}, 619),
        #STATE 620
        State([('class_name -> template_id!', 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 55)], {',': ('r', 242), '-': ('r', 242), '.': ('r', 242), '/': ('r', 242), '(': ('r', 242), ')': ('r', 242), '*': ('r', 242), '+': ('r', 242), '%': ('r', 242), '&': ('r', 242), '%=': ('r', 242), '<': ('r', 242), '=': ('r', 242), '>': ('r', 242), '?': ('r', 242), ':': ('r', 242), ';': ('r', 242), '...': ('r', 242), '|=': ('r', 242), '^=': ('r', 242), '<<': ('r', 242), '!=': ('r', 242), '--': ('r', 242), '/=': ('r', 242), '++': ('r', 242), '*=': ('r', 242), '<<=': ('r', 242), '->': ('r', 242), '-=': ('r', 242), '->*': ('r', 242), '+=': ('r', 242), '>=': ('r', 242), '<=': ('r', 242), '::': ('r', 172), '||': ('r', 242), '>>=': ('r', 242), '&&': ('r', 242), '|': ('r', 242), '}': ('r', 242), '&=': ('r', 242), '{': ('r', 242), 'try': ('r', 242), '>>': ('r', 242), ']': ('r', 242), '^': ('r', 242), '==': ('r', 242), '[': ('r', 242), '.*': ('r', 242)}, 620),
        #STATE 621
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("and_expression -> and_expression:a '&' equality_expression:b", 39), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("postfix_expression -> postfix_expression:v '--'", 22), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 877), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), '&': ('s', 61), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), new_expression: ('g', 94), template_id: ('g', 18), nested_name_specifier: ('g', 95), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 621),
        #STATE 622
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 77)], {',': ('r', 162), '-': ('r', 162), '.': ('r', 162), '/': ('r', 162), '(': ('r', 162), ')': ('r', 162), '*': ('r', 162), '+': ('r', 162), '%': ('r', 162), '&': ('r', 162), '<': ('r', 162), '=': ('r', 162), '>': ('r', 162), '?': ('r', 162), '<<': ('r', 162), ':': ('r', 162), ';': ('r', 162), '...': ('r', 162), '|=': ('r', 162), '^=': ('r', 162), '%=': ('r', 162), '!=': ('r', 162), '--': ('r', 162), '/=': ('r', 162), '==': ('r', 162), '*=': ('r', 162), '<<=': ('r', 162), '->': ('r', 162), '-=': ('r', 162), '->*': ('r', 162), '+=': ('r', 162), '>=': ('r', 162), '<=': ('r', 162), '||': ('r', 162), '>>=': ('r', 162), '&&': ('r', 162), '|': ('r', 162), '}': ('r', 162), '&=': ('r', 162), '++': ('r', 162), '>>': ('r', 162), ']': ('r', 162), '^': ('r', 162), '[': ('r', 162), '.*': ('r', 162)}, 622),
        #STATE 623
        State([("try_block -> 'try' compound_statement:body handler!+:handlers", 43), ("try_block -> 'try' compound_statement:body handler!+:handlers", 43), ("try_block -> 'try' compound_statement:body handler!+:handlers", 43), ("handler -> 'catch' '(' exception_declaration:exc ')' compound_statement:body", 11)], {handler: ('g', 624), _128: ('g', 625), 'catch': ('s', 626)}, 623),
        #STATE 624
        State([("try_block -> 'try' compound_statement:body handler!+:handlers", 50)], {'-': ('r', 221), 'asm': ('r', 221), '(': ('r', 221), '*': ('r', 221), 'reinterpret_cast': ('r', 221), 'delete': ('r', 221), 'static_cast': ('r', 221), 'virtual': ('r', 221), DECLARE_KEYWORD: ('r', 221), ACCESS_KEYWORD: ('r', 221), IDENTIFIER: ('r', 221), ';': ('r', 221), INTEGER_LITERAL: ('r', 221), 'extern': ('r', 221), 'default': ('r', 221), 'goto': ('r', 221), 'break': ('r', 221), 'new': ('r', 221), 'throw': ('r', 221), 'typedef': ('r', 221), '--': ('r', 221), 'catch': ('r', 221), '++': ('r', 221), 'dynamic_cast': ('r', 221), 'for': ('r', 221), 'export': ('r', 221), 'struct': ('r', 221), 'template': ('r', 221), 'continue': ('r', 221), '&': ('r', 221), 'this': ('r', 221), 'if': ('r', 221), 'union': ('r', 221), 'const_cast': ('r', 221), '::': ('r', 221), 'auto': ('r', 221), 'using': ('r', 221), 'volatile': ('r', 221), 'namespace': ('r', 221), 'do': ('r', 221), '!': ('r', 221), '}': ('r', 221), '~': ('r', 221), 'return': ('r', 221), '{': ('r', 221), 'case': ('r', 221), TYPE_KEYWORD: ('r', 221), FLOATING_LITERAL: ('r', 221), 'sizeof': ('r', 221), 'else': ('r', 221), CHARACTER_LITERAL: ('r', 221), 'class': ('r', 221), 'try': ('r', 221), BOOLEAN_LITERAL: ('r', 221), 'enum': ('r', 221), EOF: ('r', 221), STRING_LITERAL: ('r', 221), '+': ('r', 221), CPP_INCLUDE: ('r', 221), 'typename': ('r', 221), 'while': ('r', 221), CPP_ERROR: ('r', 221), 'operator': ('r', 221), 'const': ('r', 221), 'switch': ('r', 221), 'typeid': ('r', 221)}, 624),
        #STATE 625
        State([("try_block -> 'try' compound_statement:body handler!+:handlers", 52), ("try_block -> 'try' compound_statement:body handler!+:handlers", 43), ("handler -> 'catch' '(' exception_declaration:exc ')' compound_statement:body", 11)], {'union': ('r', 525), '::': ('r', 525), 'catch': ('s', 626), 'using': ('r', 525), 'virtual': ('r', 525), DECLARE_KEYWORD: ('r', 525), 'const': ('r', 525), '}': ('r', 525), '~': ('r', 525), IDENTIFIER: ('r', 525), ';': ('r', 525), handler: ('g', 778), 'typedef': ('r', 525), 'struct': ('r', 525), 'extern': ('r', 525), TYPE_KEYWORD: ('r', 525), ACCESS_KEYWORD: ('r', 525), 'asm': ('r', 525), 'enum': ('r', 525), EOF: ('r', 525), 'class': ('r', 525), CPP_INCLUDE: ('r', 525), 'typename': ('r', 525), 'export': ('r', 525), CPP_ERROR: ('r', 525), 'operator': ('r', 525), 'volatile': ('r', 525), 'template': ('r', 525), 'namespace': ('r', 525), 'auto': ('r', 525)}, 625),
        #STATE 626
        State([("handler -> 'catch' '(' exception_declaration:exc ')' compound_statement:body", 19)], {'(': ('s', 1060)}, 626),
        #STATE 627
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ('type_name -> IDENTIFIER:name', 13), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ('type_name -> template_id!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 51), ("unqualified_id -> '~' class_name:name", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_id: ('g', 18), template_name: ('g', 2), class_name: ('g', 289), type_name: ('g', 316), IDENTIFIER: ('s', 508)}, 627),
        #STATE 628
        State([('unqualified_id -> conversion_function_id!', 40), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 69)], {',': ('r', 382), '-': ('r', 382), '.': ('r', 382), '/': ('r', 382), '(': ('c', [('r', 382), ('r', 383)]), '<<': ('r', 382), '*': ('r', 382), '==': ('r', 382), '%': ('r', 382), '&': ('r', 382), '>>=': ('r', 382), '&&': ('r', 382), '<': ('r', 382), '=': ('r', 382), '>': ('r', 382), '?': ('r', 382), '<=': ('r', 382), '&=': ('r', 382), ';': ('r', 382), '|=': ('r', 382), '^=': ('r', 382), '%=': ('r', 382), '|': ('r', 382), '!=': ('r', 382), '--': ('r', 382), '/=': ('r', 382), '[': ('r', 382), '++': ('r', 382), '||': ('r', 382), '^': ('r', 382), '>>': ('r', 382), '+': ('r', 382), '*=': ('r', 382), '<<=': ('r', 382), '->': ('r', 382), '-=': ('r', 382), '.*': ('r', 382), '->*': ('r', 382), '+=': ('r', 382), '>=': ('r', 382)}, 628),
        #STATE 629
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("operator_function_id -> 'operator' operator:op", 24), ('template_name -> IDENTIFIER!', 17), ('unqualified_id -> operator_function_id!', 18), ('unqualified_id -> IDENTIFIER:id', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 72), ('unqualified_id -> conversion_function_id!', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("unqualified_id -> '~' class_name:name", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), '~': ('s', 45), IDENTIFIER: ('s', 596), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), unqualified_id: ('g', 735), 'operator': ('s', 8), template_id: ('g', 492)}, 629),
        #STATE 630
        State([("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 71), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 56)], {'~': ('r', 82), '(': ('c', [('r', 82), ('r', 306)]), '::': ('r', 82), '*': ('r', 82), ';': ('r', 82), ':': ('r', 82), '&': ('r', 82), 'operator': ('r', 82), IDENTIFIER: ('r', 82)}, 630),
        #STATE 631
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 134), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), _15: ('g', 633), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 323), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), ')': ('s', 632), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'throw': ('s', 96), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 631),
        #STATE 632
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 137)], {',': ('r', 258), '-': ('r', 258), '.': ('r', 258), '/': ('r', 258), '(': ('r', 258), ')': ('r', 258), '*': ('r', 258), '+': ('r', 258), '%': ('r', 258), '&': ('r', 258), '<': ('r', 258), '=': ('r', 258), '>': ('r', 258), '?': ('r', 258), '<<': ('r', 258), ':': ('r', 258), ';': ('r', 258), '...': ('r', 258), '|=': ('r', 258), '^=': ('r', 258), '%=': ('r', 258), '!=': ('r', 258), '--': ('r', 258), '/=': ('r', 258), '==': ('r', 258), '*=': ('r', 258), '<<=': ('r', 258), '->': ('r', 258), '-=': ('r', 258), '->*': ('r', 258), '>>': ('r', 258), '>=': ('r', 258), '<=': ('r', 258), '||': ('r', 258), '>>=': ('r', 258), '&&': ('r', 258), '|': ('r', 258), '}': ('r', 258), '&=': ('r', 258), '++': ('r', 258), '+=': ('r', 258), ']': ('r', 258), '^': ('r', 258), '[': ('r', 258), '.*': ('r', 258)}, 632),
        #STATE 633
        State([None, ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 134)], {',': ('s', 304), ')': ('s', 575)}, 633),
        #STATE 634
        State([('member_cd_declarator -> cd_declarator:d pure_specifier', 40), ("pure_specifier -> '=' INTEGER_LITERAL:i", 18), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 50), ('member_cd_declarator -> cd_declarator', 37)], {',': ('r', 32), '=': ('s', 264), 'try': ('r', 164), ':': ('r', 164), '{': ('r', 164), ';': ('r', 32), pure_specifier: ('g', 265)}, 634),
        #STATE 635
        State([("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 86)], {',': ('r', 210), '-': ('r', 210), '.': ('r', 210), '/': ('r', 210), '|=': ('r', 210), ')': ('r', 210), '*': ('r', 210), '+': ('r', 210), '%': ('r', 210), '&': ('r', 210), '<': ('r', 210), '=': ('r', 210), '>': ('r', 210), '?': ('r', 210), '<<': ('r', 210), ':': ('r', 210), ';': ('r', 210), '...': ('r', 210), '(': ('r', 210), '^=': ('r', 210), '%=': ('r', 210), '!=': ('r', 210), '--': ('r', 210), '/=': ('r', 210), '==': ('r', 210), '^': ('r', 210), '<<=': ('r', 210), '->': ('r', 210), '-=': ('r', 210), '->*': ('r', 210), '>>': ('r', 210), '>=': ('r', 210), '<=': ('r', 210), '||': ('r', 210), '>>=': ('r', 210), '&&': ('r', 210), '|': ('r', 210), '}': ('r', 210), '&=': ('r', 210), '++': ('r', 210), '+=': ('r', 210), ']': ('r', 210), '*=': ('r', 210), '[': ('r', 210), '.*': ('r', 210)}, 635),
        #STATE 636
        State([None, ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 83)], {',': ('s', 304), ')': ('s', 754)}, 636),
        #STATE 637
        State([("condition -> type_descriptor:type declarator:dtor '=' assignment_expression:v", 50)], {'=': ('s', 685)}, 637),
        #STATE 638
        State([('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 53), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 53), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 53), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 77), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 53), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), template_id: ('g', 639), IDENTIFIER: ('s', 640)}, 638),
        #STATE 639
        State([("base_clause -> ':' base_specifier!+,','!", 15), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 69), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 64)], {base_clause: ('g', 267), ':': ('s', 662), '{': ('r', 217)}, 639),
        #STATE 640
        State([("base_clause -> ':' base_specifier!+,','!", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 87), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 69), ('template_name -> IDENTIFIER!', 27), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 63)], {',': ('r', 366), '-': ('r', 366), '.': ('r', 366), '/': ('r', 366), '|=': ('r', 366), ')': ('r', 366), '*': ('r', 366), '+': ('r', 366), '%': ('r', 366), '&': ('r', 366), 'operator': ('r', 366), '<': ('c', [('r', 366), ('r', 2)]), '=': ('r', 366), '>': ('r', 366), '?': ('r', 366), '<<': ('r', 366), IDENTIFIER: ('r', 366), ':': ('c', [('s', 662), ('r', 366)]), ';': ('r', 366), '...': ('r', 366), '(': ('r', 366), '^=': ('r', 366), '::': ('r', 366), '^': ('r', 366), '!=': ('r', 366), '--': ('r', 366), '/=': ('r', 366), '++': ('r', 366), '*=': ('r', 366), '<<=': ('r', 366), '->': ('r', 366), 'auto': ('r', 366), '-=': ('r', 366), '%=': ('r', 366), '+=': ('r', 366), '>=': ('r', 366), 'union': ('r', 366), '<=': ('r', 366), base_clause: ('g', 961), '||': ('r', 366), '>>=': ('r', 366), '&&': ('r', 366), '|': ('r', 366), '}': ('r', 366), '~': ('r', 366), 'volatile': ('r', 366), '&=': ('r', 366), '{': ('c', [('r', 366), ('r', 367)]), '.*': ('r', 366), 'struct': ('r', 366), '->*': ('r', 366), TYPE_KEYWORD: ('r', 366), 'try': ('r', 366), 'enum': ('r', 366), '>>': ('r', 366), 'class': ('r', 366), ']': ('r', 366), 'typename': ('r', 366), '==': ('r', 366), '[': ('r', 366), 'const': ('r', 366)}, 640),
        #STATE 641
        State([("throw_expression -> 'throw' assignment_expression:v?", 49)], {',': ('r', 166), '}': ('r', 166), '>': ('r', 166), ')': ('r', 166), ':': ('r', 166), ']': ('r', 166), '...': ('r', 166), ';': ('r', 166)}, 641),
        #STATE 642
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 55)], {',': ('r', 167), '>': ('r', 167)}, 642),
        #STATE 643
        State([("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 99)], {';': ('s', 644)}, 643),
        #STATE 644
        State([("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 102)], {'sizeof': ('r', 526), '-': ('r', 526), 'asm': ('r', 526), '(': ('r', 526), '*': ('r', 526), '+': ('r', 526), 'delete': ('r', 526), 'static_cast': ('r', 526), 'virtual': ('r', 526), '!': ('r', 526), ACCESS_KEYWORD: ('r', 526), IDENTIFIER: ('r', 526), 'while': ('r', 526), INTEGER_LITERAL: ('r', 526), 'extern': ('r', 526), 'default': ('r', 526), 'goto': ('r', 526), 'new': ('r', 526), 'class': ('r', 526), 'typedef': ('r', 526), '--': ('r', 526), '++': ('r', 526), 'dynamic_cast': ('r', 526), 'for': ('r', 526), 'export': ('r', 526), 'struct': ('r', 526), 'template': ('r', 526), 'continue': ('r', 526), '&': ('r', 526), 'this': ('r', 526), 'if': ('r', 526), 'union': ('r', 526), 'const_cast': ('r', 526), '::': ('r', 526), 'auto': ('r', 526), 'using': ('r', 526), 'volatile': ('r', 526), 'namespace': ('r', 526), 'do': ('r', 526), DECLARE_KEYWORD: ('r', 526), '}': ('r', 526), '~': ('r', 526), 'return': ('r', 526), '{': ('r', 526), 'case': ('r', 526), TYPE_KEYWORD: ('r', 526), FLOATING_LITERAL: ('r', 526), CPP_ERROR: ('r', 526), 'else': ('r', 526), CHARACTER_LITERAL: ('r', 526), 'try': ('r', 526), 'reinterpret_cast': ('r', 526), BOOLEAN_LITERAL: ('r', 526), 'enum': ('r', 526), EOF: ('r', 526), STRING_LITERAL: ('r', 526), 'throw': ('r', 526), CPP_INCLUDE: ('r', 526), 'typename': ('r', 526), 'break': ('r', 526), 'operator': ('r', 526), 'const': ('r', 526), 'switch': ('r', 526), 'typeid': ('r', 526)}, 644),
        #STATE 645
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('named_namespace_definition -> original_namespace_definition!', 30), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ('namespace_definition -> unnamed_namespace_definition!', 24), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 25), ('declaration -> function_definition!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ('block_declaration -> using_declaration!', 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 32), ('type_name -> IDENTIFIER:name', 13), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 33), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 88), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ("explicit_instantiation -> 'template' declaration:decl", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> template_declaration!', 15), ('declaration -> CPP_INCLUDE!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> linkage_specification!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('type_name -> template_id!', 13), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_definition -> function_head:head function_try_block:tryb', 23), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 27), ('declaration -> namespace_definition!', 15), ("raw_type_descriptor -> 'auto'", 23), ('block_declaration -> asm_definition!', 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('block_declaration -> simple_declaration!', 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cv_qualifier -> 'const'!", 16), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('declaration -> CPP_ERROR!', 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_directive!', 21), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('declaration -> explicit_instantiation!', 15), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('namespace_definition -> named_namespace_definition!', 24), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> named_type_specifier!', 23), ('declaration -> block_declaration!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('declaration -> explicit_specialization!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), named_type_specifier: ('g', 126), 'union': ('s', 97), function_definition: ('g', 128), 'virtual': ('s', 130), explicit_specialization: ('g', 157), cd_id: ('g', 164), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), 'extern': ('s', 139), class_name: ('g', 11), '::': ('s', 153), class_specifier: ('g', 138), 'typedef': ('s', 136), namespace_definition: ('g', 140), CPP_INCLUDE: ('s', 129), named_namespace_definition: ('g', 142), _75: ('g', 152), 'asm': ('s', 125), original_namespace_definition: ('g', 144), explicit_instantiation: ('g', 146), _81: ('g', 88), type_name: ('g', 131), unnamed_namespace_definition: ('g', 145), 'export': ('s', 143), 'struct': ('s', 58), 'volatile': ('s', 33), 'namespace': ('s', 148), asm_definition: ('g', 149), function_head: ('g', 150), 'auto': ('s', 90), using_declaration: ('g', 127), _80: ('g', 112), using_directive: ('g', 137), namespace_name: ('g', 5), 'using': ('s', 154), nested_name_specifier: ('g', 155), linkage_specification: ('g', 156), _73: ('g', 133), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), namespace_alias_definition: ('g', 161), template_name: ('g', 2), class_head: ('g', 20), cv_qualifier: ('g', 106), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), cd_declarator: ('g', 163), simple_declaration: ('g', 167), 'enum': ('s', 117), declaration: ('g', 530), type_descriptor: ('g', 169), 'class': ('s', 115), block_declaration: ('g', 141), 'typename': ('s', 166), CPP_ERROR: ('s', 151), 'operator': ('s', 168), template_declaration: ('g', 165), 'template': ('s', 147), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 29)}, 645),
        #STATE 646
        State([("qualified_namespace_specifier -> '::'?:glbl nested_name_specifier:nns? namespace_name:name", 85)], {';': ('r', 170)}, 646),
        #STATE 647
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 44), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 55), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), template_id: ('g', 44), nested_name_specifier: ('g', 1059), class_name: ('g', 11), '::': ('s', 1048)}, 647),
        #STATE 648
        State([("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 39), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 77), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 39), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 50), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 274), template_id: ('g', 44), nested_name_specifier: ('g', 207), class_name: ('g', 11), '::': ('s', 833)}, 648),
        #STATE 649
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> operator_function_id!', 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('namespace_name -> IDENTIFIER:name', 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('template_name -> IDENTIFIER!', 17), ("operator_function_id -> 'operator' operator:op", 24), ('unqualified_id -> IDENTIFIER:id', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ("unqualified_id -> '~' class_name:name", 18), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 34), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('unqualified_id -> conversion_function_id!', 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {operator_function_id: ('g', 6), template_name: ('g', 2), '~': ('s', 45), IDENTIFIER: ('s', 46), nested_name_specifier: ('g', 755), conversion_function_id: ('g', 12), namespace_name: ('g', 5), unqualified_id: ('g', 793), 'operator': ('s', 8), class_name: ('g', 11), template_id: ('g', 44)}, 649),
        #STATE 650
        State([("compound_statement -> '{' statement!*:sts '}'", 45)], {'sizeof': ('r', 521), '-': ('r', 521), '++': ('r', 521), '(': ('r', 521), '*': ('r', 521), '+': ('r', 521), 'delete': ('r', 521), 'static_cast': ('r', 521), 'operator': ('r', 521), DECLARE_KEYWORD: ('r', 521), ACCESS_KEYWORD: ('r', 521), IDENTIFIER: ('r', 521), ';': ('r', 521), INTEGER_LITERAL: ('r', 521), 'extern': ('r', 521), 'default': ('r', 521), 'goto': ('r', 521), 'new': ('r', 521), 'class': ('r', 521), 'typedef': ('r', 521), '--': ('r', 521), 'catch': ('r', 521), 'asm': ('r', 521), 'dynamic_cast': ('r', 521), 'for': ('r', 521), 'export': ('r', 521), 'struct': ('r', 521), 'volatile': ('r', 521), 'continue': ('r', 521), '&': ('r', 521), 'case': ('r', 521), 'if': ('r', 521), 'union': ('r', 521), 'virtual': ('r', 521), 'const_cast': ('r', 521), '::': ('r', 521), 'auto': ('r', 521), 'using': ('r', 521), 'namespace': ('r', 521), 'do': ('r', 521), '!': ('r', 521), 'try': ('r', 521), '~': ('r', 521), 'return': ('r', 521), '{': ('r', 521), 'else': ('r', 521), 'this': ('r', 521), TYPE_KEYWORD: ('r', 521), FLOATING_LITERAL: ('r', 521), CPP_ERROR: ('r', 521), 'const': ('r', 521), CHARACTER_LITERAL: ('r', 521), '}': ('r', 521), 'reinterpret_cast': ('r', 521), BOOLEAN_LITERAL: ('r', 521), 'enum': ('r', 521), EOF: ('r', 521), STRING_LITERAL: ('r', 521), 'throw': ('r', 521), CPP_INCLUDE: ('r', 521), 'typename': ('r', 521), 'while': ('r', 521), 'break': ('r', 521), 'template': ('r', 521), 'switch': ('r', 521), 'typeid': ('r', 521)}, 650),
        #STATE 651
        State([("compound_statement -> '{' statement!*:sts '}'", 35)], {'-': ('r', 187), 'asm': ('r', 187), '(': ('r', 187), '*': ('r', 187), '+': ('r', 187), 'delete': ('r', 187), 'static_cast': ('r', 187), 'virtual': ('r', 187), '!': ('r', 187), IDENTIFIER: ('r', 187), 'while': ('r', 187), INTEGER_LITERAL: ('r', 187), 'extern': ('r', 187), 'default': ('r', 187), 'goto': ('r', 187), 'new': ('r', 187), 'throw': ('r', 187), 'typedef': ('r', 187), '--': ('r', 187), '++': ('r', 187), 'dynamic_cast': ('r', 187), 'for': ('r', 187), 'continue': ('r', 187), 'auto': ('r', 187), 'volatile': ('r', 187), 'namespace': ('r', 187), '&': ('r', 187), CPP_ERROR: ('r', 187), STRING_LITERAL: ('r', 187), 'const_cast': ('r', 187), '::': ('r', 187), FLOATING_LITERAL: ('r', 187), 'using': ('r', 187), 'do': ('r', 187), 'this': ('r', 187), '}': ('r', 187), '~': ('r', 187), 'return': ('r', 187), DECLARE_KEYWORD: ('r', 187), '{': ('r', 187), 'case': ('r', 187), CHARACTER_LITERAL: ('r', 187), 'union': ('r', 187), 'struct': ('r', 187), 'sizeof': ('r', 187), 'if': ('r', 187), TYPE_KEYWORD: ('r', 187), 'try': ('r', 187), 'reinterpret_cast': ('r', 187), BOOLEAN_LITERAL: ('r', 187), 'enum': ('r', 187), 'class': ('r', 187), 'typename': ('r', 187), 'break': ('r', 187), 'operator': ('r', 187), 'const': ('r', 187), 'switch': ('r', 187), 'typeid': ('r', 187)}, 651),
        #STATE 652
        State([('type_name -> IDENTIFIER:name', 13), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 85), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_id: ('g', 26), template_name: ('g', 2), IDENTIFIER: ('s', 24), type_name: ('g', 307)}, 652),
        #STATE 653
        State([("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 44)], {',': ('r', 400), '}': ('r', 400)}, 653),
        #STATE 654
        State([("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 64)], {',': ('r', 484), '}': ('r', 484), ';': ('r', 484)}, 654),
        #STATE 655
        State([('initializer_clause -> assignment_expression!', 43)], {',': ('r', 433), '}': ('r', 433), ';': ('r', 433)}, 655),
        #STATE 656
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 26), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("initializer_clause -> '{' '}'", 22), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 26), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 26), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 26), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('initializer_clause -> assignment_expression!', 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("initializer_clause -> '{' '}'", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), '{': ('s', 656), type_name: ('g', 98), shift_expression: ('g', 65), _107: ('g', 465), initializer_clause: ('g', 834), equality_expression: ('g', 70), 'static_cast': ('s', 71), relational_expression: ('g', 67), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), literal: ('g', 84), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), class_name: ('g', 11), 'dynamic_cast': ('s', 83), conditional_expression: ('g', 77), assignment_expression: ('g', 655), conversion_function_id: ('g', 12), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), '}': ('s', 472), '~': ('s', 100), '--': ('s', 111), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), postfix_expression: ('g', 99), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), INTEGER_LITERAL: ('s', 87), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 656),
        #STATE 657
        State([("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 74)], {IDENTIFIER: ('s', 658)}, 657),
        #STATE 658
        State([("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 84)], {',': ('r', 281), '-': ('r', 281), '.': ('r', 281), '/': ('r', 281), '|=': ('r', 281), ')': ('r', 281), '*': ('r', 281), '+': ('r', 281), '%': ('r', 281), '&': ('r', 281), 'operator': ('r', 281), '<': ('r', 281), '=': ('r', 281), '>': ('r', 281), '?': ('r', 281), '<<': ('r', 281), IDENTIFIER: ('r', 281), ':': ('r', 281), ';': ('r', 281), '...': ('r', 281), '(': ('r', 281), '^=': ('r', 281), '||': ('r', 281), '^': ('r', 281), '!=': ('r', 281), '--': ('r', 281), '/=': ('r', 281), '++': ('r', 281), '*=': ('r', 281), '<<=': ('r', 281), '->': ('r', 281), 'auto': ('r', 281), '-=': ('r', 281), '%=': ('r', 281), '+=': ('r', 281), '>=': ('r', 281), 'union': ('r', 281), '<=': ('r', 281), '::': ('r', 281), '>>=': ('r', 281), '&&': ('r', 281), '|': ('r', 281), '}': ('r', 281), '~': ('r', 281), 'volatile': ('r', 281), '&=': ('r', 281), '{': ('r', 281), '.*': ('r', 281), 'struct': ('r', 281), '->*': ('r', 281), TYPE_KEYWORD: ('r', 281), 'try': ('r', 281), 'enum': ('r', 281), '>>': ('r', 281), 'class': ('r', 281), ']': ('r', 281), 'typename': ('r', 281), '==': ('r', 281), '[': ('r', 281), 'const': ('r', 281)}, 658),
        #STATE 659
        State([("explicit_specialization -> 'template' '<' '>' declaration:decl", 57)], {'union': ('r', 171), '::': ('r', 171), 'namespace': ('r', 171), 'export': ('r', 171), 'using': ('r', 171), 'virtual': ('r', 171), DECLARE_KEYWORD: ('r', 171), '}': ('r', 171), '~': ('r', 171), IDENTIFIER: ('r', 171), 'operator': ('r', 171), 'typedef': ('r', 171), 'extern': ('r', 171), TYPE_KEYWORD: ('r', 171), ACCESS_KEYWORD: ('r', 171), 'asm': ('r', 171), 'enum': ('r', 171), EOF: ('r', 171), 'class': ('r', 171), CPP_INCLUDE: ('r', 171), 'typename': ('r', 171), CPP_ERROR: ('r', 171), 'struct': ('r', 171), 'volatile': ('r', 171), 'template': ('r', 171), 'const': ('r', 171), 'auto': ('r', 171)}, 659),
        #STATE 660
        State([('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 69), ('class_name -> template_id!', 25), ("base_clause -> ':' base_specifier!+,','!", 15), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 64)], {'{': ('r', 173), base_clause: ('g', 661), ':': ('s', 662), '::': ('r', 172)}, 660),
        #STATE 661
        State([('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 80)], {'{': ('r', 384)}, 661),
        #STATE 662
        State([('namespace_name -> IDENTIFIER:name', 18), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_clause -> ':' base_specifier!+,','!", 19), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 56), ('class_name -> template_id!', 14), ('access_specifier -> ACCESS_KEYWORD!', 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 29), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ('template_name -> IDENTIFIER!', 17), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("base_clause -> ':' base_specifier!+,','!", 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ('class_name -> IDENTIFIER:name', 14), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 18), ("base_clause -> ':' base_specifier!+,','!", 19), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 18)], {template_name: ('g', 2), '::': ('s', 549), namespace_name: ('g', 5), base_specifier: ('g', 428), 'virtual': ('s', 546), _117: ('g', 403), access_specifier: ('g', 550), class_name: ('g', 548), ACCESS_KEYWORD: ('s', 258), IDENTIFIER: ('s', 414), nested_name_specifier: ('g', 523), template_id: ('g', 44)}, 662),
        #STATE 663
        State([("operator -> 'delete' '[' ']'", 21), ("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 29)], {',': ('r', 174), '-': ('r', 174), '.': ('r', 174), '/': ('r', 174), '(': ('r', 174), ')': ('r', 174), '*': ('r', 174), '+': ('r', 174), '%': ('r', 174), '&': ('r', 174), '<': ('r', 174), '=': ('r', 174), '>': ('r', 174), '?': ('r', 174), '<<': ('r', 174), ':': ('r', 174), ';': ('r', 174), '...': ('r', 174), '|=': ('r', 174), '^=': ('r', 174), '%=': ('r', 174), '!=': ('r', 174), '--': ('r', 174), '/=': ('r', 174), '++': ('r', 174), '^': ('r', 174), '<<=': ('r', 174), '->': ('r', 174), '-=': ('r', 174), '->*': ('r', 174), '+=': ('r', 174), '>=': ('r', 174), '<=': ('r', 174), '||': ('r', 174), '>>=': ('r', 174), '&&': ('r', 174), '|': ('r', 174), '}': ('r', 174), '&=': ('r', 174), '{': ('r', 174), 'try': ('r', 174), '>>': ('r', 174), ']': ('r', 174), '*=': ('r', 174), '==': ('r', 174), '[': ('c', [('s', 664), ('r', 174)]), '.*': ('r', 174)}, 663),
        #STATE 664
        State([("operator -> 'delete' '[' ']'", 25)], {']': ('s', 922)}, 664),
        #STATE 665
        State([("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 34)], {'-': ('r', 175), '++': ('r', 175), '(': ('r', 175), '::': ('r', 175), '*': ('r', 175), 'sizeof': ('r', 175), 'delete': ('r', 175), '&': ('r', 175), '!': ('r', 175), 'this': ('r', 175), '~': ('r', 175), IDENTIFIER: ('r', 175), 'operator': ('r', 175), 'const_cast': ('r', 175), CHARACTER_LITERAL: ('r', 175), 'new': ('r', 175), FLOATING_LITERAL: ('r', 175), TYPE_KEYWORD: ('r', 175), '--': ('r', 175), BOOLEAN_LITERAL: ('r', 175), 'reinterpret_cast': ('r', 175), STRING_LITERAL: ('r', 175), 'throw': ('r', 175), 'typename': ('r', 175), 'dynamic_cast': ('r', 175), '+': ('r', 175), INTEGER_LITERAL: ('r', 175), 'static_cast': ('r', 175), 'typeid': ('r', 175)}, 665),
        #STATE 666
        State([("shift_expression -> shift_expression:a '<<' additive_expression:b", 39), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 70), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 39)], {',': ('r', 418), '|=': ('r', 418), ')': ('r', 418), '==': ('r', 418), '&': ('r', 418), '>>=': ('r', 418), '&&': ('r', 418), '|': ('r', 418), '=': ('r', 418), '>': ('r', 418), '?': ('r', 418), '&=': ('r', 418), ':': ('r', 418), ';': ('r', 418), '...': ('r', 418), '<=': ('r', 418), '^=': ('r', 418), '%=': ('r', 418), '<': ('r', 418), '!=': ('r', 418), '}': ('r', 418), '/=': ('r', 418), '||': ('r', 418), '^': ('r', 418), '+=': ('r', 418), ']': ('r', 418), '<<': ('s', 449), '<<=': ('r', 418), '*=': ('r', 418), '-=': ('r', 418), '>>': ('s', 450), '>=': ('r', 418)}, 666),
        #STATE 667
        State([("handler -> 'catch' '(' exception_declaration:exc ')' compound_statement:body", 53), ("compound_statement -> '{' statement!*:sts '}'", 22), ("compound_statement -> '{' statement!*:sts '}'", 22)], {compound_statement: ('g', 572), '{': ('s', 329)}, 667),
        #STATE 668
        State([("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 71)], {'union': ('r', 181), '::': ('r', 181), 'namespace': ('r', 181), 'export': ('r', 181), 'using': ('r', 181), 'virtual': ('r', 181), DECLARE_KEYWORD: ('r', 181), '}': ('r', 181), '~': ('r', 181), IDENTIFIER: ('r', 181), 'operator': ('r', 181), 'typedef': ('r', 181), 'extern': ('r', 181), TYPE_KEYWORD: ('r', 181), ACCESS_KEYWORD: ('r', 181), 'asm': ('r', 181), 'enum': ('r', 181), EOF: ('r', 181), 'class': ('r', 181), CPP_INCLUDE: ('r', 181), 'typename': ('r', 181), CPP_ERROR: ('r', 181), 'struct': ('r', 181), 'volatile': ('r', 181), 'template': ('r', 181), 'const': ('r', 181), 'auto': ('r', 181)}, 668),
        #STATE 669
        State([("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 77)], {'union': ('r', 182), '::': ('r', 182), 'export': ('r', 182), 'using': ('r', 182), 'virtual': ('r', 182), DECLARE_KEYWORD: ('r', 182), 'const': ('r', 182), '}': ('r', 182), '~': ('r', 182), IDENTIFIER: ('r', 182), 'operator': ('r', 182), 'typedef': ('r', 182), 'extern': ('r', 182), TYPE_KEYWORD: ('r', 182), ACCESS_KEYWORD: ('r', 182), 'enum': ('r', 182), 'class': ('r', 182), 'typename': ('r', 182), 'struct': ('r', 182), 'volatile': ('r', 182), 'template': ('r', 182), 'auto': ('r', 182)}, 669),
        #STATE 670
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 106)], {',': ('r', 185), '-': ('r', 185), '.': ('r', 185), '/': ('r', 185), '(': ('r', 185), ')': ('r', 185), '*': ('r', 185), '+': ('r', 185), '%': ('r', 185), '&': ('r', 185), '<': ('r', 185), '=': ('r', 185), '>': ('r', 185), '?': ('r', 185), '<<': ('r', 185), ':': ('r', 185), ';': ('r', 185), '...': ('r', 185), '|=': ('r', 185), '^=': ('r', 185), '%=': ('r', 185), '!=': ('r', 185), '--': ('r', 185), '/=': ('r', 185), '++': ('r', 185), '^': ('r', 185), '<<=': ('r', 185), '->': ('r', 185), '-=': ('r', 185), '->*': ('r', 185), '+=': ('r', 185), '>=': ('r', 185), '<=': ('r', 185), '||': ('r', 185), '>>=': ('r', 185), '&&': ('r', 185), '|': ('r', 185), '}': ('r', 185), '&=': ('r', 185), '{': ('r', 185), 'try': ('r', 185), '>>': ('r', 185), ']': ('r', 185), '*=': ('r', 185), '==': ('r', 185), '[': ('r', 185), '.*': ('r', 185)}, 670),
        #STATE 671
        State([("unary_expression -> '--' cast_expression:v", 40)], {',': ('r', 186), '-': ('r', 186), '/': ('r', 186), '|=': ('r', 186), ')': ('r', 186), '*': ('r', 186), '==': ('r', 186), '%': ('r', 186), '&': ('r', 186), '>>=': ('r', 186), '&&': ('r', 186), '<': ('r', 186), '=': ('r', 186), '>': ('r', 186), '?': ('r', 186), '<<': ('r', 186), ':': ('r', 186), ';': ('r', 186), '...': ('r', 186), '<=': ('r', 186), '^=': ('r', 186), '%=': ('r', 186), '|': ('r', 186), '!=': ('r', 186), '}': ('r', 186), '/=': ('r', 186), '+': ('r', 186), '||': ('r', 186), '*=': ('r', 186), '&=': ('r', 186), '+=': ('r', 186), ']': ('r', 186), '^': ('r', 186), '<<=': ('r', 186), '-=': ('r', 186), '.*': ('r', 186), '->*': ('r', 186), '>>': ('r', 186), '>=': ('r', 186)}, 671),
        #STATE 672
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 56), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), class_name: ('g', 542), IDENTIFIER: ('s', 173), template_id: ('g', 44)}, 672),
        #STATE 673
        State([("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 106)], {'-': ('r', 188), '++': ('r', 188), '(': ('r', 188), '*': ('r', 188), 'reinterpret_cast': ('r', 188), 'delete': ('r', 188), 'static_cast': ('r', 188), 'virtual': ('r', 188), '!': ('r', 188), IDENTIFIER: ('r', 188), 'while': ('r', 188), INTEGER_LITERAL: ('r', 188), 'extern': ('r', 188), 'default': ('r', 188), 'goto': ('r', 188), 'break': ('r', 188), 'new': ('r', 188), 'throw': ('r', 188), 'typedef': ('r', 188), '--': ('r', 188), 'asm': ('r', 188), 'dynamic_cast': ('r', 188), 'for': ('r', 188), 'continue': ('r', 188), '+': ('r', 188), 'struct': ('r', 188), 'volatile': ('r', 188), 'namespace': ('r', 188), '&': ('r', 188), 'if': ('r', 188), 'union': ('r', 188), 'const_cast': ('r', 188), '::': ('r', 188), 'auto': ('r', 188), 'using': ('r', 188), 'do': ('r', 188), 'case': ('r', 188), 'try': ('r', 188), '~': ('r', 188), 'return': ('r', 188), DECLARE_KEYWORD: ('r', 188), '{': ('r', 188), 'this': ('r', 188), CHARACTER_LITERAL: ('r', 188), FLOATING_LITERAL: ('r', 188), 'sizeof': ('r', 188), 'else': ('r', 188), TYPE_KEYWORD: ('r', 188), '}': ('r', 188), BOOLEAN_LITERAL: ('r', 188), 'enum': ('r', 188), STRING_LITERAL: ('r', 188), 'class': ('r', 188), 'typename': ('r', 188), CPP_ERROR: ('r', 188), 'operator': ('r', 188), 'const': ('r', 188), 'switch': ('r', 188), 'typeid': ('r', 188)}, 673),
        #STATE 674
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 93)], {'~': ('s', 675)}, 674),
        #STATE 675
        State([('type_name -> IDENTIFIER:name', 13), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 97), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_id: ('g', 26), template_name: ('g', 2), IDENTIFIER: ('s', 24), type_name: ('g', 497)}, 675),
        #STATE 676
        State([("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 42), ('namespace_name -> IDENTIFIER:name', 28), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 84), ('class_name -> IDENTIFIER:name', 24), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 42), ('template_name -> IDENTIFIER!', 27)], {',': ('r', 189), '-': ('r', 189), '.': ('r', 189), '/': ('r', 189), '|=': ('r', 189), ')': ('r', 189), '*': ('r', 189), '+': ('r', 189), '%': ('r', 189), '&': ('r', 189), '{': ('c', [('s', 677), ('r', 189)]), '%=': ('r', 189), '<': ('c', [('r', 189), ('r', 2)]), '=': ('r', 189), '>': ('r', 189), '?': ('r', 189), IDENTIFIER: ('r', 189), ':': ('r', 189), ';': ('r', 189), '...': ('r', 189), '(': ('r', 189), '^=': ('r', 189), '<<': ('r', 189), '!=': ('r', 189), '--': ('r', 189), '/=': ('r', 189), '++': ('r', 189), '^': ('r', 189), 'typename': ('r', 189), '<<=': ('r', 189), '->': ('r', 189), 'struct': ('r', 189), '-=': ('r', 189), '->*': ('r', 189), '+=': ('r', 189), '>=': ('r', 189), 'union': ('r', 189), '<=': ('r', 189), '::': ('c', [('r', 5), ('r', 189), ('r', 7)]), 'auto': ('r', 189), '||': ('r', 189), '>>=': ('r', 189), '&&': ('r', 189), 'const': ('r', 189), '|': ('r', 189), '}': ('r', 189), '~': ('r', 189), 'volatile': ('r', 189), '&=': ('r', 189), 'operator': ('r', 189), TYPE_KEYWORD: ('r', 189), 'try': ('r', 189), 'enum': ('r', 189), '>>': ('r', 189), 'class': ('r', 189), ']': ('r', 189), '*=': ('r', 189), '==': ('r', 189), '[': ('r', 189), '.*': ('r', 189)}, 676),
        #STATE 677
        State([("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 46), ("enumerator_definition -> enumerator:name ('=' constant_expression:v)?", 25), ("enumerator_definition -> enumerator:name ('=' constant_expression:v)?", 25), ('enumerator -> IDENTIFIER!', 14), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 46), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 46), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 80)], {enumerator_definition: ('g', 882), _84: ('g', 942), IDENTIFIER: ('s', 930), '}': ('s', 902), enumerator: ('g', 929)}, 677),
        #STATE 678
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 71), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), nested_name_specifier: ('g', 679), class_name: ('g', 11), template_id: ('g', 44)}, 678),
        #STATE 679
        State([("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 92)], {'template': ('r', 327), '~': ('r', 327), IDENTIFIER: ('r', 327), '*': ('r', 327), 'operator': ('r', 327)}, 679),
        #STATE 680
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 49), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), multiplicative_expression: ('g', 681), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), qualified_id: ('g', 4), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), '::': ('s', 64), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), operator_function_id: ('g', 6), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38)}, 680),
        #STATE 681
        State([("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 57), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 74), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 57), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 57)], {',': ('r', 566), '-': ('r', 566), '/': ('s', 986), '|=': ('r', 566), ')': ('r', 566), '*': ('s', 987), '+': ('r', 566), '%': ('s', 968), '&': ('r', 566), '>>=': ('r', 566), '&&': ('r', 566), '<': ('r', 566), '=': ('r', 566), '>': ('r', 566), '?': ('r', 566), '<<': ('r', 566), ':': ('r', 566), ';': ('r', 566), '...': ('r', 566), '<=': ('r', 566), '^=': ('r', 566), '%=': ('r', 566), '|': ('r', 566), '!=': ('r', 566), '}': ('r', 566), '/=': ('r', 566), '==': ('r', 566), '||': ('r', 566), '^': ('r', 566), '&=': ('r', 566), '+=': ('r', 566), ']': ('r', 566), '*=': ('r', 566), '<<=': ('r', 566), '-=': ('r', 566), '>>': ('r', 566), '>=': ('r', 566)}, 681),
        #STATE 682
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('for_init_statement -> expression_statement!', 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('relational_expression -> shift_expression!', 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('postfix_expression -> primary_expression!', 22), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("class_key -> 'class' | 'struct' | 'union'", 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unary_expression -> new_expression!', 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 33), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("unary_expression -> 'sizeof' unary_expression:v", 20), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 33), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("unary_expression -> '++' cast_expression:v", 20), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("decl_attrib -> 'extern'!", 15), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('id_expression -> qualified_id!', 17), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('logical_and_expression -> inclusive_or_expression!', 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('equality_expression -> relational_expression!', 23), ('namespace_name -> IDENTIFIER:name', 18), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('assignment_expression -> conditional_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("raw_type_descriptor -> 'auto'", 23), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('for_init_statement -> simple_declaration:decl', 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('literal -> BOOLEAN_LITERAL:v', 11), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('unqualified_id -> conversion_function_id!', 18), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("cv_qualifier -> 'const'!", 16), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('unary_expression -> postfix_expression!', 20), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 33), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('decl_attrib -> DECLARE_KEYWORD!', 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ("decl_attrib -> 'virtual'!", 15), ('type_descriptor -> raw_type_descriptor!', 19), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 33), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ('unary_expression -> delete_expression!', 20), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('additive_expression -> multiplicative_expression!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {'-': ('s', 81), pm_expression: ('g', 73), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), INTEGER_LITERAL: ('s', 87), and_expression: ('g', 72), _80: ('g', 112), class_specifier: ('g', 138), inclusive_or_expression: ('g', 76), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), assignment_expression: ('g', 85), expression: ('g', 335), 'union': ('s', 97), 'const_cast': ('s', 92), 'auto': ('s', 90), FLOATING_LITERAL: ('s', 79), 'throw': ('s', 96), expression_statement: ('g', 441), _73: ('g', 346), conversion_function_id: ('g', 357), DECLARE_KEYWORD: ('s', 160), '!': ('s', 104), for_init_statement: ('g', 53), CHARACTER_LITERAL: ('s', 108), operator_function_id: ('g', 6), 'enum': ('s', 117), STRING_LITERAL: ('s', 113), 'typename': ('s', 116), simple_declaration: ('g', 420), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), 'const': ('s', 35), type_descriptor: ('g', 359), IDENTIFIER: ('s', 3), decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), 'sizeof': ('s', 107), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), type_name: ('g', 131), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'extern': ('s', 249), '::': ('s', 347), 'new': ('s', 74), throw_expression: ('g', 91), 'typedef': ('s', 136), '--': ('s', 111), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), _75: ('g', 152), qualified_id: ('g', 4), exclusive_or_expression: ('g', 121), nested_name_specifier: ('g', 352), new_expression: ('g', 94), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'operator': ('s', 8), template_name: ('g', 2), unary_expression: ('g', 69), unary_operator: ('g', 105), class_head: ('g', 20), cv_qualifier: ('g', 106), TYPE_KEYWORD: ('s', 68), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), template_id: ('g', 18), 'class': ('s', 115), namespace_name: ('g', 5), class_key: ('g', 78), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 682),
        #STATE 683
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97)], {'(': ('s', 385)}, 683),
        #STATE 684
        State([("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 59)], {',': ('r', 197), '-': ('r', 197), '/': ('r', 197), '|=': ('r', 197), ')': ('r', 197), '*': ('r', 197), '+': ('r', 197), '%': ('r', 197), '&': ('r', 197), '>>=': ('r', 197), '&&': ('r', 197), '<': ('r', 197), '=': ('r', 197), '>': ('r', 197), '?': ('r', 197), '<<': ('r', 197), ':': ('r', 197), ';': ('r', 197), '...': ('r', 197), '<=': ('r', 197), '^=': ('r', 197), '%=': ('r', 197), '|': ('r', 197), '!=': ('r', 197), '}': ('r', 197), '/=': ('r', 197), '==': ('r', 197), '||': ('r', 197), '^': ('r', 197), '&=': ('r', 197), '>>': ('r', 197), ']': ('r', 197), '*=': ('r', 197), '<<=': ('r', 197), '-=': ('r', 197), '.*': ('r', 197), '->*': ('r', 197), '+=': ('r', 197), '>=': ('r', 197)}, 684),
        #STATE 685
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("condition -> type_descriptor:type declarator:dtor '=' assignment_expression:v", 54), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 567), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 685),
        #STATE 686
        State([("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 84)], {'-': ('r', 198), '++': ('r', 198), '(': ('r', 198), '::': ('r', 198), '*': ('r', 198), 'sizeof': ('r', 198), 'delete': ('r', 198), 'static_cast': ('r', 198), '!': ('r', 198), 'this': ('r', 198), '~': ('r', 198), IDENTIFIER: ('r', 198), 'operator': ('r', 198), INTEGER_LITERAL: ('r', 198), TYPE_KEYWORD: ('r', 198), 'new': ('r', 198), FLOATING_LITERAL: ('r', 198), CHARACTER_LITERAL: ('r', 198), '--': ('r', 198), 'reinterpret_cast': ('r', 198), BOOLEAN_LITERAL: ('r', 198), '+': ('r', 198), STRING_LITERAL: ('r', 198), 'throw': ('r', 198), 'const_cast': ('r', 198), 'typename': ('r', 198), 'dynamic_cast': ('r', 198), '&': ('r', 198), 'typeid': ('r', 198)}, 686),
        #STATE 687
        State([("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 70)], {']': ('s', 688)}, 687),
        #STATE 688
        State([("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 73)], {',': ('r', 255), '=': ('r', 255), '>': ('r', 255), '(': ('r', 255), ')': ('r', 255), 'try': ('r', 255), '[': ('r', 255), '...': ('r', 255), ':': ('r', 255), ';': ('r', 255), '{': ('r', 255)}, 688),
        #STATE 689
        State([("try_block -> 'try' compound_statement:body handler!+:handlers", 43), ("try_block -> 'try' compound_statement:body handler!+:handlers", 43), ("try_block -> 'try' compound_statement:body handler!+:handlers", 43), ("handler -> 'catch' '(' exception_declaration:exc ')' compound_statement:body", 11)], {handler: ('g', 624), _128: ('g', 690), 'catch': ('s', 626)}, 689),
        #STATE 690
        State([("try_block -> 'try' compound_statement:body handler!+:handlers", 52), ("try_block -> 'try' compound_statement:body handler!+:handlers", 43), ("handler -> 'catch' '(' exception_declaration:exc ')' compound_statement:body", 11)], {'-': ('r', 379), 'asm': ('r', 379), '(': ('r', 379), '*': ('r', 379), 'union': ('r', 379), 'delete': ('r', 379), 'static_cast': ('r', 379), 'virtual': ('r', 379), '!': ('r', 379), IDENTIFIER: ('r', 379), 'while': ('r', 379), handler: ('g', 778), 'extern': ('r', 379), 'default': ('r', 379), 'goto': ('r', 379), 'break': ('r', 379), 'new': ('r', 379), 'class': ('r', 379), 'typedef': ('r', 379), '--': ('r', 379), '++': ('r', 379), 'dynamic_cast': ('r', 379), 'for': ('r', 379), 'continue': ('r', 379), '+': ('r', 379), 'auto': ('r', 379), 'volatile': ('r', 379), 'namespace': ('r', 379), INTEGER_LITERAL: ('r', 379), '&': ('r', 379), 'if': ('r', 379), 'catch': ('s', 626), 'const_cast': ('r', 379), '::': ('r', 379), FLOATING_LITERAL: ('r', 379), 'using': ('r', 379), 'do': ('r', 379), 'case': ('r', 379), '}': ('r', 379), '~': ('r', 379), 'return': ('r', 379), DECLARE_KEYWORD: ('r', 379), '{': ('r', 379), 'this': ('r', 379), TYPE_KEYWORD: ('r', 379), 'struct': ('r', 379), 'sizeof': ('r', 379), 'else': ('r', 379), CHARACTER_LITERAL: ('r', 379), 'try': ('r', 379), 'reinterpret_cast': ('r', 379), BOOLEAN_LITERAL: ('r', 379), 'enum': ('r', 379), STRING_LITERAL: ('r', 379), 'throw': ('r', 379), 'typename': ('r', 379), CPP_ERROR: ('r', 379), 'operator': ('r', 379), 'const': ('r', 379), 'switch': ('r', 379), 'typeid': ('r', 379)}, 690),
        #STATE 691
        State([('conversion_declarator -> ptr_operator:op conversion_declarator:d?', 62)], {',': ('r', 296), '-': ('r', 296), '.': ('r', 296), '/': ('r', 296), '(': ('r', 296), ')': ('r', 296), '*': ('r', 296), '+': ('r', 296), '%': ('r', 296), '&': ('r', 296), '<': ('r', 296), '=': ('r', 296), '>': ('r', 296), '?': ('r', 296), ':': ('r', 296), ';': ('r', 296), '...': ('r', 296), '|=': ('r', 296), '^=': ('r', 296), '%=': ('r', 296), '!=': ('r', 296), '--': ('r', 296), '/=': ('r', 296), '++': ('r', 296), '^': ('r', 296), '<<=': ('r', 296), '->': ('r', 296), '-=': ('r', 296), '->*': ('r', 296), '>>': ('r', 296), '>=': ('r', 296), '<=': ('r', 296), '||': ('r', 296), '>>=': ('r', 296), '&&': ('r', 296), '|': ('r', 296), '}': ('r', 296), '&=': ('r', 296), '{': ('r', 296), 'try': ('r', 296), '+=': ('r', 296), ']': ('r', 296), '<<': ('r', 296), '==': ('r', 296), '*=': ('r', 296), '[': ('r', 296), '.*': ('r', 296)}, 691),
        #STATE 692
        State([("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 50)], {'-': ('r', 201), 'asm': ('r', 201), '(': ('r', 201), '*': ('r', 201), '+': ('r', 201), 'delete': ('r', 201), 'static_cast': ('r', 201), '{': ('r', 201), DECLARE_KEYWORD: ('r', 201), ACCESS_KEYWORD: ('r', 201), IDENTIFIER: ('r', 201), 'while': ('r', 201), INTEGER_LITERAL: ('r', 201), 'typedef': ('r', 201), 'default': ('r', 201), 'goto': ('r', 201), 'break': ('r', 201), 'new': ('r', 201), 'class': ('r', 201), 'extern': ('r', 201), '--': ('r', 201), '++': ('r', 201), 'dynamic_cast': ('r', 201), 'for': ('r', 201), 'export': ('r', 201), 'struct': ('r', 201), 'volatile': ('r', 201), 'template': ('r', 201), 'continue': ('r', 201), '&': ('r', 201), 'this': ('r', 201), 'if': ('r', 201), 'union': ('r', 201), 'virtual': ('r', 201), 'const_cast': ('r', 201), '::': ('r', 201), 'auto': ('r', 201), 'using': ('r', 201), 'namespace': ('r', 201), 'do': ('r', 201), '!': ('r', 201), 'try': ('r', 201), '~': ('r', 201), 'return': ('r', 201), 'operator': ('r', 201), 'case': ('r', 201), TYPE_KEYWORD: ('r', 201), FLOATING_LITERAL: ('r', 201), 'sizeof': ('r', 201), 'else': ('r', 201), CHARACTER_LITERAL: ('r', 201), '}': ('r', 201), 'reinterpret_cast': ('r', 201), BOOLEAN_LITERAL: ('r', 201), 'enum': ('r', 201), EOF: ('r', 201), STRING_LITERAL: ('r', 201), 'throw': ('r', 201), CPP_INCLUDE: ('r', 201), 'typename': ('r', 201), CPP_ERROR: ('r', 201), 'const': ('r', 201), 'switch': ('r', 201), 'typeid': ('r', 201)}, 692),
        #STATE 693
        State([("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 68)], {',': ('r', 305), ')': ('r', 305)}, 693),
        #STATE 694
        State([None, ("new_initializer -> '(' assignment_expression!*,','! ')'", 52)], {',': ('s', 304), ')': ('s', 412)}, 694),
        #STATE 695
        State([("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 46)], {',': ('r', 202), 'union': ('r', 202), '::': ('r', 202), 'struct': ('r', 202), 'enum': ('r', 202), 'class': ('r', 202), 'typename': ('r', 202), IDENTIFIER: ('r', 202), 'auto': ('r', 202), 'volatile': ('r', 202), 'const': ('r', 202), TYPE_KEYWORD: ('r', 202)}, 695),
        #STATE 696
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 76), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 697), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 696),
        #STATE 697
        State([("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 97)], {',': ('r', 492), '...': ('r', 492), '>': ('r', 492), ')': ('r', 492)}, 697),
        #STATE 698
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ("qualified_namespace_specifier -> '::'?:glbl nested_name_specifier:nns? namespace_name:name", 44), ('template_name -> IDENTIFIER!', 17), ("qualified_namespace_specifier -> '::'?:glbl nested_name_specifier:nns? namespace_name:name", 71), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 699), nested_name_specifier: ('g', 700), class_name: ('g', 11), template_id: ('g', 44)}, 698),
        #STATE 699
        State([("qualified_namespace_specifier -> '::'?:glbl nested_name_specifier:nns? namespace_name:name", 85), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55)], {'::': ('s', 275), ';': ('r', 353)}, 699),
        #STATE 700
        State([("qualified_namespace_specifier -> '::'?:glbl nested_name_specifier:nns? namespace_name:name", 71), ('namespace_name -> IDENTIFIER:name', 18)], {namespace_name: ('g', 866), IDENTIFIER: ('s', 209)}, 700),
        #STATE 701
        State([('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 89)], {template_name: ('g', 2), template_id: ('g', 702), IDENTIFIER: ('s', 216)}, 701),
        #STATE 702
        State([("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 100)], {',': ('r', 259), '-': ('r', 259), '.': ('r', 259), '/': ('r', 259), '|=': ('r', 259), ')': ('r', 259), '*': ('r', 259), '+': ('r', 259), '%': ('r', 259), '&': ('r', 259), '{': ('r', 259), '%=': ('r', 259), '<': ('r', 259), '=': ('r', 259), '>': ('r', 259), '?': ('r', 259), IDENTIFIER: ('r', 259), ':': ('r', 259), ';': ('r', 259), '...': ('r', 259), '(': ('r', 259), '^=': ('r', 259), '::': ('r', 259), '!=': ('r', 259), '--': ('r', 259), '/=': ('r', 259), '++': ('r', 259), '^': ('r', 259), '<<=': ('r', 259), '->': ('r', 259), 'struct': ('r', 259), '-=': ('r', 259), '->*': ('r', 259), '+=': ('r', 259), '>=': ('r', 259), 'union': ('r', 259), '<=': ('r', 259), '<<': ('r', 259), 'auto': ('r', 259), '||': ('r', 259), '>>=': ('r', 259), '&&': ('r', 259), 'const': ('r', 259), '|': ('r', 259), '}': ('r', 259), '~': ('r', 259), 'volatile': ('r', 259), '&=': ('r', 259), 'operator': ('r', 259), TYPE_KEYWORD: ('r', 259), 'try': ('r', 259), 'enum': ('r', 259), '>>': ('r', 259), 'class': ('r', 259), ']': ('r', 259), 'typename': ('r', 259), '==': ('r', 259), '*=': ('r', 259), '[': ('r', 259), '.*': ('r', 259)}, 702),
        #STATE 703
        State([("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 74), None], {',': ('s', 704), ';': ('s', 705)}, 703),
        #STATE 704
        State([('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('type_name -> IDENTIFIER:name', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('member_cd_declarator -> cd_declarator', 24), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_name -> template_id!', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('type_name -> template_id!', 13), ('member_cd_declarator -> cd_declarator:d pure_specifier', 24), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('template_name -> IDENTIFIER!', 17), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9)], {namespace_name: ('g', 5), IDENTIFIER: ('s', 29), '::': ('s', 217), template_name: ('g', 2), cd_declarator: ('g', 880), cd_id: ('g', 164), type_name: ('g', 540), conversion_function_id: ('g', 158), '~': ('s', 159), member_cd_declarator: ('g', 822), 'operator': ('s', 168), nested_name_specifier: ('g', 539), class_name: ('g', 11), template_id: ('g', 18)}, 704),
        #STATE 705
        State([("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 77)], {'union': ('r', 304), '::': ('r', 304), 'export': ('r', 304), 'using': ('r', 304), 'virtual': ('r', 304), DECLARE_KEYWORD: ('r', 304), 'const': ('r', 304), '}': ('r', 304), '~': ('r', 304), IDENTIFIER: ('r', 304), 'operator': ('r', 304), 'extern': ('r', 304), 'typedef': ('r', 304), TYPE_KEYWORD: ('r', 304), ACCESS_KEYWORD: ('r', 304), 'enum': ('r', 304), 'class': ('r', 304), 'typename': ('r', 304), 'struct': ('r', 304), 'volatile': ('r', 304), 'template': ('r', 304), 'auto': ('r', 304)}, 705),
        #STATE 706
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 35), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('raw_type_descriptor -> class_specifier!', 23), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 56), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('new_type_id -> type_descriptor:type new_declarator:dtor?', 15), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 56), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 56), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('class_name -> IDENTIFIER:name', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 56), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 35), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('type_name -> template_id!', 13), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("new_placement -> '(' assignment_expression!+,','! ')'", 17), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 35), ('new_type_id -> type_descriptor:type new_declarator:dtor?', 15), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 35), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {raw_type_descriptor: ('g', 54), '(': ('s', 1011), named_type_specifier: ('g', 126), 'union': ('s', 97), class_specifier: ('g', 75), nested_name_specifier: ('g', 189), type_name: ('g', 98), '::': ('s', 191), elaborated_type_specifier: ('g', 109), enum_specifier: ('g', 122), 'struct': ('s', 58), template_name: ('g', 2), class_name: ('g', 11), class_head: ('g', 20), cv_qualifier: ('g', 106), new_placement: ('g', 948), class_key: ('g', 78), template_id: ('g', 18), TYPE_KEYWORD: ('s', 162), _80: ('g', 112), _81: ('g', 88), 'class': ('s', 115), 'typename': ('s', 166), namespace_name: ('g', 5), 'enum': ('s', 117), 'auto': ('s', 90), 'volatile': ('s', 33), 'const': ('s', 35), new_type_id: ('g', 804), type_descriptor: ('g', 764), IDENTIFIER: ('s', 29)}, 706),
        #STATE 707
        State([("qualified_id -> '::' IDENTIFIER!", 31), ('namespace_name -> IDENTIFIER:name', 28), ('type_name -> IDENTIFIER:name', 23), ('template_name -> IDENTIFIER!', 27), ('class_name -> IDENTIFIER:name', 24)], {',': ('c', [('r', 476), ('r', 6)]), '-': ('r', 476), '.': ('r', 476), '/': ('r', 476), '|=': ('r', 476), ')': ('c', [('r', 476), ('r', 6)]), '*': ('c', [('r', 476), ('r', 6)]), '+': ('r', 476), '%': ('r', 476), '&': ('c', [('r', 476), ('r', 6)]), '::': ('c', [('r', 5), ('r', 6), ('r', 7)]), '<': ('c', [('r', 476), ('r', 2)]), '=': ('c', [('r', 476), ('r', 6)]), '>': ('c', [('r', 476), ('r', 6)]), '?': ('r', 476), '<<': ('r', 476), IDENTIFIER: ('r', 6), ':': ('r', 476), ';': ('r', 476), '...': ('c', [('r', 476), ('r', 6)]), '(': ('c', [('r', 476), ('r', 6)]), '^=': ('r', 476), '%=': ('r', 476), '!=': ('r', 476), '--': ('r', 476), '/=': ('r', 476), '++': ('r', 476), '^': ('r', 476), '<<=': ('r', 476), '->': ('r', 476), '-=': ('r', 476), '->*': ('r', 476), '+=': ('r', 476), '>=': ('r', 476), '<=': ('r', 476), '||': ('r', 476), '>>=': ('r', 476), '&&': ('r', 476), '|': ('r', 476), '}': ('r', 476), '~': ('r', 6), '&=': ('r', 476), 'operator': ('r', 6), '>>': ('r', 476), ']': ('r', 476), '*=': ('r', 476), '==': ('r', 476), '[': ('c', [('r', 476), ('r', 6)]), '.*': ('r', 476)}, 707),
        #STATE 708
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 36), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 36), ('literal -> FLOATING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), id_expression: ('g', 114), 'sizeof': ('s', 107), operator_function_id: ('g', 6), 'const_cast': ('s', 92), qualified_id: ('g', 4), new_expression: ('g', 94), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), '[': ('s', 470), delete_expression: ('g', 119), cast_expression: ('g', 951), 'typeid': ('s', 38)}, 708),
        #STATE 709
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 53), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("operator_function_id -> 'operator' operator:op", 24), ('unqualified_id -> IDENTIFIER:id', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ("unqualified_id -> '~' class_name:name", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_name -> template_id!', 13), ('unqualified_id -> conversion_function_id!', 18), ('type_name -> IDENTIFIER:name', 13)], {operator_function_id: ('g', 6), template_name: ('g', 2), '~': ('s', 45), IDENTIFIER: ('s', 423), conversion_function_id: ('g', 12), unqualified_id: ('g', 425), 'template': ('s', 426), 'operator': ('s', 8), template_id: ('g', 26), type_name: ('g', 375)}, 709),
        #STATE 710
        State([('class_name -> template_id!', 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 55), ('type_name -> template_id!', 24)], {',': ('c', [('r', 242), ('r', 105)]), '-': ('r', 242), '.': ('r', 242), '/': ('r', 242), '|=': ('r', 242), ')': ('c', [('r', 242), ('r', 105)]), '*': ('c', [('r', 242), ('r', 105)]), '+': ('r', 242), '%': ('r', 242), '&': ('c', [('r', 242), ('r', 105)]), '<': ('r', 242), '=': ('c', [('r', 242), ('r', 105)]), '>': ('c', [('r', 242), ('r', 105)]), '?': ('r', 242), '<<': ('r', 242), IDENTIFIER: ('r', 105), ':': ('r', 242), ';': ('r', 242), '...': ('c', [('r', 242), ('r', 105)]), '(': ('c', [('r', 242), ('r', 105)]), '^=': ('r', 242), '||': ('r', 242), '!=': ('r', 242), '--': ('r', 242), '/=': ('r', 242), '++': ('r', 242), '^': ('r', 242), '<<=': ('r', 242), '->': ('r', 242), '-=': ('r', 242), '%=': ('r', 242), '>>': ('r', 242), '>=': ('r', 242), '<=': ('r', 242), '::': ('c', [('r', 172), ('r', 105)]), '>>=': ('r', 242), '&&': ('r', 242), '|': ('r', 242), '}': ('r', 242), '~': ('r', 105), '&=': ('r', 242), 'operator': ('r', 105), '->*': ('r', 242), '+=': ('r', 242), ']': ('r', 242), '*=': ('r', 242), '==': ('r', 242), '[': ('c', [('r', 242), ('r', 105)]), '.*': ('r', 242)}, 710),
        #STATE 711
        State([('function_definition -> function_head:head ctor_initializer:init? function_body:body', 78)], {'union': ('r', 204), '::': ('r', 204), 'namespace': ('r', 204), 'export': ('r', 204), 'using': ('r', 204), 'virtual': ('r', 204), DECLARE_KEYWORD: ('r', 204), '}': ('r', 204), '~': ('r', 204), IDENTIFIER: ('r', 204), ';': ('r', 204), 'typedef': ('r', 204), 'operator': ('r', 204), 'extern': ('r', 204), TYPE_KEYWORD: ('r', 204), ACCESS_KEYWORD: ('r', 204), 'asm': ('r', 204), 'enum': ('r', 204), EOF: ('r', 204), 'class': ('r', 204), CPP_INCLUDE: ('r', 204), 'typename': ('r', 204), CPP_ERROR: ('r', 204), 'struct': ('r', 204), 'volatile': ('r', 204), 'template': ('r', 204), 'const': ('r', 204), 'auto': ('r', 204)}, 711),
        #STATE 712
        State([("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 100)], {',': ('r', 66), '-': ('r', 66), '.': ('r', 66), '/': ('r', 66), '|=': ('r', 66), ')': ('r', 66), '*': ('r', 66), '+': ('r', 66), '%': ('r', 66), '&': ('r', 66), '{': ('r', 66), '<': ('r', 66), '=': ('r', 66), '>': ('r', 66), '?': ('r', 66), IDENTIFIER: ('r', 66), ':': ('r', 66), ';': ('r', 66), '...': ('r', 66), '(': ('r', 66), '^=': ('r', 66), '::': ('r', 66), '!=': ('r', 66), '--': ('r', 66), '/=': ('r', 66), '++': ('r', 66), '^': ('r', 66), '<<=': ('r', 66), '->': ('r', 66), 'auto': ('r', 66), '-=': ('r', 66), '%=': ('r', 66), '+=': ('r', 66), '>=': ('r', 66), 'union': ('r', 66), '<=': ('r', 66), '<<': ('r', 66), '||': ('r', 66), '>>=': ('r', 66), '&&': ('r', 66), 'const': ('r', 66), '|': ('r', 66), '}': ('r', 66), '~': ('r', 66), 'volatile': ('r', 66), '&=': ('r', 66), 'operator': ('r', 66), 'struct': ('r', 66), '->*': ('r', 66), TYPE_KEYWORD: ('r', 66), 'try': ('r', 66), 'enum': ('r', 66), '>>': ('r', 66), 'class': ('r', 66), ']': ('r', 66), 'typename': ('r', 66), '==': ('r', 66), '*=': ('r', 66), '[': ('r', 66), '.*': ('r', 66)}, 712),
        #STATE 713
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97)], {'(': ('s', 321)}, 713),
        #STATE 714
        State([("cv_qualifier -> 'const'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 33), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cv_qualifier -> 'volatile'!", 16)], {',': ('r', 207), '-': ('r', 207), '.': ('r', 207), '/': ('r', 207), '|=': ('r', 207), ')': ('r', 207), '*': ('r', 207), '+': ('r', 207), '%': ('r', 207), '&': ('r', 207), '{': ('r', 207), '%=': ('r', 207), '<': ('r', 207), '=': ('r', 207), '>': ('r', 207), '?': ('r', 207), IDENTIFIER: ('r', 207), ':': ('r', 207), ';': ('r', 207), '...': ('r', 207), '(': ('r', 207), '^=': ('r', 207), '::': ('r', 207), '!=': ('r', 207), '--': ('r', 207), '/=': ('r', 207), '++': ('r', 207), '^': ('r', 207), 'typename': ('r', 207), '<<=': ('r', 207), '->': ('r', 207), 'auto': ('r', 207), '-=': ('r', 207), '->*': ('r', 207), '+=': ('r', 207), '>=': ('r', 207), 'union': ('r', 207), '>>=': ('r', 207), '<=': ('r', 207), '<<': ('r', 207), '||': ('r', 207), 'volatile': ('c', [('s', 33), ('r', 207)]), '&&': ('r', 207), '|': ('r', 207), '}': ('r', 207), '~': ('r', 207), '&=': ('r', 207), 'operator': ('r', 207), '.*': ('r', 207), cv_qualifier: ('g', 32), TYPE_KEYWORD: ('r', 207), 'try': ('r', 207), 'struct': ('r', 207), 'enum': ('r', 207), '>>': ('r', 207), 'class': ('r', 207), ']': ('r', 207), '*=': ('r', 207), '==': ('r', 207), '[': ('r', 207), 'const': ('c', [('s', 35), ('r', 207)])}, 714),
        #STATE 715
        State([("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 73)], {',': ('r', 208), '-': ('r', 208), '.': ('r', 208), '/': ('r', 208), '(': ('r', 208), ')': ('r', 208), '*': ('r', 208), '==': ('r', 208), '%': ('r', 208), '&': ('r', 208), '<': ('r', 208), '=': ('r', 208), '>': ('r', 208), '?': ('r', 208), '<<': ('r', 208), ':': ('r', 208), ';': ('r', 208), '...': ('r', 208), '|=': ('r', 208), '^=': ('r', 208), '%=': ('r', 208), '!=': ('r', 208), '--': ('r', 208), '/=': ('r', 208), '++': ('r', 208), '*=': ('r', 208), '<<=': ('r', 208), '->': ('r', 208), '-=': ('r', 208), '->*': ('r', 208), '+=': ('r', 208), '>=': ('r', 208), '<=': ('r', 208), '||': ('r', 208), '>>=': ('r', 208), '&&': ('r', 208), '|': ('r', 208), '}': ('r', 208), '&=': ('r', 208), '>>': ('r', 208), '+': ('r', 208), ']': ('r', 208), '^': ('r', 208), '[': ('r', 208), '.*': ('r', 208)}, 715),
        #STATE 716
        State([("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('raw_type_descriptor -> enum_specifier!', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('namespace_name -> IDENTIFIER:name', 18), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ('template_parameter -> type_parameter!', 22), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("cv_qualifier -> 'const'!", 16), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ('template_parameter -> parameter_declaration!', 22), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("class_key -> 'class' | 'struct' | 'union'", 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ('class_name -> IDENTIFIER:name', 14), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('parameter_declaration -> type_descriptor:type declarator:dtor', 25), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('raw_type_descriptor -> named_type_specifier!', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {raw_type_descriptor: ('g', 54), IDENTIFIER: ('s', 29), named_type_specifier: ('g', 126), class_specifier: ('g', 75), nested_name_specifier: ('g', 189), cv_qualifier: ('g', 106), parameter_declaration: ('g', 196), type_name: ('g', 98), 'union': ('s', 97), type_descriptor: ('g', 193), elaborated_type_specifier: ('g', 109), '::': ('s', 191), enum_specifier: ('g', 122), 'template': ('s', 201), template_name: ('g', 2), _123: ('g', 717), class_name: ('g', 11), _80: ('g', 112), namespace_name: ('g', 5), class_head: ('g', 20), type_parameter: ('g', 202), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), _81: ('g', 88), 'class': ('s', 198), 'typename': ('s', 199), template_parameter: ('g', 200), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), template_id: ('g', 18), 'auto': ('s', 90)}, 716),
        #STATE 717
        State([None, ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 84)], {',': ('s', 552), '>': ('s', 955)}, 717),
        #STATE 718
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ('unqualified_id -> operator_function_id!', 18), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ('statement -> iteration_statement!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> CPP_ERROR!', 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('statement -> labeled_statement!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('block_declaration -> asm_definition!', 21), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ('statement -> compound_statement!', 13), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ('statement -> jump_statement!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 54), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unary_expression -> postfix_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_name -> template_id!', 13), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), '++': ('s', 55), pm_expression: ('g', 73), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), and_expression: ('g', 72), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), _80: ('g', 112), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), logical_and_expression: ('g', 118), 'asm': ('s', 125), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), conversion_function_id: ('g', 357), 'namespace': ('s', 170), asm_definition: ('g', 149), expression: ('g', 335), STRING_LITERAL: ('s', 113), 'auto': ('s', 90), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), compound_statement: ('g', 339), DECLARE_KEYWORD: ('s', 160), selection_statement: ('g', 340), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), operator_function_id: ('g', 6), 'enum': ('s', 117), block_declaration: ('g', 344), 'typename': ('s', 116), 'while': ('s', 349), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 605), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), 'default': ('s', 330), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), nested_name_specifier: ('g', 352), 'union': ('s', 97), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'do': ('s', 355), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'case': ('s', 356), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), 'try': ('s', 334), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), declaration_statement: ('g', 343), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 718),
        #STATE 719
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("mem_initializer -> mem_initializer_id:id '(' assignment_expression!*,',':args ')'", 78), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), ')': ('s', 720), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), _15: ('g', 721), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 323), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), named_type_specifier: ('g', 177), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 719),
        #STATE 720
        State([("mem_initializer -> mem_initializer_id:id '(' assignment_expression!*,',':args ')'", 81)], {',': ('r', 455), '{': ('r', 455)}, 720),
        #STATE 721
        State([None, ("mem_initializer -> mem_initializer_id:id '(' assignment_expression!*,',':args ')'", 78)], {',': ('s', 304), ')': ('s', 914)}, 721),
        #STATE 722
        State([('namespace_name -> IDENTIFIER:name', 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 90), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 63), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), nested_name_specifier: ('g', 920), class_name: ('g', 921), template_id: ('g', 44)}, 722),
        #STATE 723
        State([("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 67), None], {',': ('s', 214), ';': ('s', 996)}, 723),
        #STATE 724
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 63), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 63), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('init_declarator -> declarator:d initializer:init?', 19), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 63), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("operator_function_id -> 'operator' operator:op", 24), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('declarator -> direct_declarator!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('direct_declarator -> declarator_id!', 21), ('unqualified_id -> operator_function_id!', 18), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('declarator_id -> id_expression!', 17), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("qualified_id -> '::' IDENTIFIER!", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('id_expression -> qualified_id!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('init_declarator -> declarator:d initializer:init?', 19), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('unqualified_id -> conversion_function_id!', 18), ("ptr_operator -> '&'", 16), ("unqualified_id -> '~' class_name:name", 18), ("direct_declarator -> '(' declarator! ')'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {unqualified_id: ('g', 7), '(': ('s', 281), qualified_id: ('g', 4), '*': ('s', 223), namespace_name: ('g', 5), nested_name_specifier: ('g', 284), '&': ('s', 225), init_declarator: ('g', 181), '~': ('s', 45), IDENTIFIER: ('s', 46), 'operator': ('s', 8), template_name: ('g', 2), direct_declarator: ('g', 285), ptr_operator: ('g', 279), '::': ('s', 282), id_expression: ('g', 280), _74: ('g', 965), declarator_id: ('g', 286), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), class_name: ('g', 11), template_id: ('g', 44), declarator: ('g', 603)}, 724),
        #STATE 725
        State([("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 100)], {'-': ('r', 209), 'asm': ('r', 209), '(': ('r', 209), '*': ('r', 209), 'reinterpret_cast': ('r', 209), 'delete': ('r', 209), 'static_cast': ('r', 209), 'virtual': ('r', 209), DECLARE_KEYWORD: ('r', 209), ACCESS_KEYWORD: ('r', 209), IDENTIFIER: ('r', 209), 'while': ('r', 209), INTEGER_LITERAL: ('r', 209), 'typedef': ('r', 209), 'default': ('r', 209), 'goto': ('r', 209), 'break': ('r', 209), 'new': ('r', 209), 'throw': ('r', 209), 'extern': ('r', 209), '--': ('r', 209), '++': ('r', 209), 'dynamic_cast': ('r', 209), 'for': ('r', 209), 'export': ('r', 209), '+': ('r', 209), 'struct': ('r', 209), 'template': ('r', 209), 'continue': ('r', 209), '&': ('r', 209), 'case': ('r', 209), 'if': ('r', 209), 'union': ('r', 209), 'const_cast': ('r', 209), '::': ('r', 209), 'auto': ('r', 209), 'using': ('r', 209), 'volatile': ('r', 209), 'namespace': ('r', 209), 'do': ('r', 209), '!': ('r', 209), 'try': ('r', 209), '~': ('r', 209), 'return': ('r', 209), '{': ('r', 209), 'this': ('r', 209), TYPE_KEYWORD: ('r', 209), FLOATING_LITERAL: ('r', 209), 'sizeof': ('r', 209), 'else': ('r', 209), CHARACTER_LITERAL: ('r', 209), '}': ('r', 209), BOOLEAN_LITERAL: ('r', 209), 'enum': ('r', 209), EOF: ('r', 209), STRING_LITERAL: ('r', 209), 'class': ('r', 209), CPP_INCLUDE: ('r', 209), 'typename': ('r', 209), CPP_ERROR: ('r', 209), 'operator': ('r', 209), 'const': ('r', 209), 'switch': ('r', 209), 'typeid': ('r', 209)}, 725),
        #STATE 726
        State([("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 54)], {'(': ('s', 418)}, 726),
        #STATE 727
        State([("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 97)], {';': ('s', 728)}, 727),
        #STATE 728
        State([("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 100)], {'-': ('r', 489), '++': ('r', 489), '(': ('r', 489), '*': ('r', 489), 'reinterpret_cast': ('r', 489), 'delete': ('r', 489), 'static_cast': ('r', 489), '{': ('r', 489), DECLARE_KEYWORD: ('r', 489), ACCESS_KEYWORD: ('r', 489), IDENTIFIER: ('r', 489), 'while': ('r', 489), INTEGER_LITERAL: ('r', 489), 'typedef': ('r', 489), 'default': ('r', 489), 'goto': ('r', 489), 'break': ('r', 489), 'new': ('r', 489), 'throw': ('r', 489), 'extern': ('r', 489), '--': ('r', 489), 'asm': ('r', 489), 'dynamic_cast': ('r', 489), 'for': ('r', 489), 'export': ('r', 489), '+': ('r', 489), 'struct': ('r', 489), 'volatile': ('r', 489), 'continue': ('r', 489), '&': ('r', 489), 'case': ('r', 489), 'if': ('r', 489), 'union': ('r', 489), 'virtual': ('r', 489), 'const_cast': ('r', 489), '::': ('r', 489), 'auto': ('r', 489), 'using': ('r', 489), 'namespace': ('r', 489), 'do': ('r', 489), '!': ('r', 489), '}': ('r', 489), '~': ('r', 489), 'return': ('r', 489), 'operator': ('r', 489), 'else': ('r', 489), 'this': ('r', 489), TYPE_KEYWORD: ('r', 489), FLOATING_LITERAL: ('r', 489), 'sizeof': ('r', 489), 'const': ('r', 489), CHARACTER_LITERAL: ('r', 489), 'try': ('r', 489), BOOLEAN_LITERAL: ('r', 489), 'enum': ('r', 489), EOF: ('r', 489), STRING_LITERAL: ('r', 489), 'class': ('r', 489), CPP_INCLUDE: ('r', 489), 'typename': ('r', 489), CPP_ERROR: ('r', 489), 'template': ('r', 489), 'switch': ('r', 489), 'typeid': ('r', 489)}, 728),
        #STATE 729
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 38), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ('postfix_expression -> primary_expression!', 22), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("class_key -> 'class' | 'struct' | 'union'", 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 38), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_expression -> 'sizeof' unary_expression:v", 20), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("unary_expression -> '++' cast_expression:v", 20), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ('class_head -> class_key:t base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('id_expression -> qualified_id!', 17), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 67), ("unary_expression -> '--' cast_expression:v", 20), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('equality_expression -> relational_expression!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('namespace_name -> IDENTIFIER:name', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ('assignment_expression -> conditional_expression!', 25), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 38), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('unqualified_id -> conversion_function_id!', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("cv_qualifier -> 'const'!", 16), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('unary_expression -> postfix_expression!', 20), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_argument -> type_id:t', 21), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ('template_argument -> assignment_expression:v', 21), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> CHARACTER_LITERAL:v', 11), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('pm_expression -> cast_expression!', 17), ('additive_expression -> multiplicative_expression!', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), template_name: ('g', 2), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), cv_qualifier: ('g', 106), additive_expression: ('g', 63), logical_and_expression: ('g', 118), shift_expression: ('g', 65), '>': ('s', 903), IDENTIFIER: ('s', 3), equality_expression: ('g', 70), CHARACTER_LITERAL: ('s', 108), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), delete_expression: ('g', 119), class_name: ('g', 11), pm_expression: ('g', 73), 'new': ('s', 74), class_specifier: ('g', 75), inclusive_or_expression: ('g', 76), literal: ('g', 84), elaborated_type_specifier: ('g', 109), class_key: ('g', 78), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), conditional_expression: ('g', 77), assignment_expression: ('g', 495), 'struct': ('s', 58), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), enum_specifier: ('g', 122), _81: ('g', 88), id_expression: ('g', 114), unqualified_id: ('g', 7), throw_expression: ('g', 91), 'const_cast': ('s', 92), '::': ('s', 64), 'auto': ('s', 90), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), 'union': ('s', 97), type_name: ('g', 98), template_argument: ('g', 642), conversion_function_id: ('g', 12), '~': ('s', 100), 'volatile': ('s', 33), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), class_head: ('g', 20), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), postfix_expression: ('g', 99), 'reinterpret_cast': ('s', 110), BOOLEAN_LITERAL: ('s', 102), '--': ('s', 111), _80: ('g', 112), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), _127: ('g', 730), 'typename': ('s', 116), namespace_name: ('g', 5), type_id: ('g', 496), 'enum': ('s', 117), operator_function_id: ('g', 6), exclusive_or_expression: ('g', 121), 'const': ('s', 35), type_descriptor: ('g', 240), 'typeid': ('s', 38), relational_expression: ('g', 67)}, 729),
        #STATE 730
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 67), None], {',': ('s', 494), '>': ('s', 469)}, 730),
        #STATE 731
        State([('namespace_name -> IDENTIFIER:name', 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 77)], {namespace_name: ('g', 727), IDENTIFIER: ('s', 209)}, 731),
        #STATE 732
        State([('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 56), ("cv_qualifier -> 'const'!", 16), ("cv_qualifier -> 'volatile'!", 16)], {',': ('r', 211), '-': ('r', 211), '.': ('r', 211), '/': ('r', 211), '|=': ('r', 211), _80: ('g', 733), '*': ('r', 211), '+': ('r', 211), '%': ('r', 211), '&': ('r', 211), 'operator': ('r', 211), '%=': ('r', 211), '<': ('r', 211), '=': ('r', 211), '>': ('r', 211), '?': ('r', 211), '<<': ('r', 211), IDENTIFIER: ('r', 211), ':': ('r', 211), ';': ('r', 211), '...': ('r', 211), '(': ('r', 211), '^=': ('r', 211), ')': ('r', 211), '^': ('r', 211), '!=': ('r', 211), '--': ('r', 211), '/=': ('r', 211), '++': ('r', 211), 'typename': ('r', 211), '<<=': ('r', 211), '->': ('r', 211), 'auto': ('r', 211), 'volatile': ('c', [('s', 33), ('r', 211)]), '->*': ('r', 211), '>>': ('r', 211), '>=': ('r', 211), 'union': ('r', 211), '>>=': ('r', 211), '<=': ('r', 211), '::': ('r', 211), '||': ('r', 211), '-=': ('r', 211), '&&': ('r', 211), 'const': ('c', [('s', 35), ('r', 211)]), '|': ('r', 211), '}': ('r', 211), '~': ('r', 211), '&=': ('r', 211), '{': ('r', 211), cv_qualifier: ('g', 106), TYPE_KEYWORD: ('r', 211), 'try': ('r', 211), 'struct': ('r', 211), 'enum': ('r', 211), '+=': ('r', 211), 'class': ('r', 211), ']': ('r', 211), '*=': ('r', 211), '==': ('r', 211), '[': ('r', 211), '.*': ('r', 211)}, 732),
        #STATE 733
        State([("cv_qualifier -> 'volatile'!", 16), ("cv_qualifier -> 'const'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 33)], {',': ('r', 286), '-': ('r', 286), '.': ('r', 286), '/': ('r', 286), '|=': ('r', 286), ')': ('r', 286), '*': ('r', 286), '+': ('r', 286), '%': ('r', 286), '&': ('r', 286), 'operator': ('r', 286), '<': ('r', 286), '=': ('r', 286), '>': ('r', 286), '?': ('r', 286), IDENTIFIER: ('r', 286), ':': ('r', 286), ';': ('r', 286), '...': ('r', 286), '(': ('r', 286), '^=': ('r', 286), '::': ('r', 286), '!=': ('r', 286), '--': ('r', 286), '/=': ('r', 286), '++': ('r', 286), '^': ('r', 286), '<<=': ('r', 286), '->': ('r', 286), 'auto': ('r', 286), '-=': ('r', 286), '%=': ('r', 286), '+=': ('r', 286), '>=': ('r', 286), 'union': ('r', 286), '<=': ('r', 286), '<<': ('r', 286), '||': ('r', 286), '>>=': ('r', 286), '&&': ('r', 286), '|': ('r', 286), '}': ('r', 286), '~': ('r', 286), 'volatile': ('c', [('s', 33), ('r', 286)]), '&=': ('r', 286), '{': ('r', 286), '.*': ('r', 286), cv_qualifier: ('g', 32), '->*': ('r', 286), TYPE_KEYWORD: ('r', 286), 'try': ('r', 286), 'struct': ('r', 286), 'enum': ('r', 286), '>>': ('r', 286), 'class': ('r', 286), ']': ('r', 286), 'typename': ('r', 286), '==': ('r', 286), '*=': ('r', 286), '[': ('r', 286), 'const': ('c', [('s', 35), ('r', 286)])}, 733),
        #STATE 734
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 43)], {',': ('r', 212), '-': ('r', 212), '.': ('r', 212), '/': ('r', 212), '(': ('r', 212), ')': ('r', 212), '*': ('r', 212), '+': ('r', 212), '%': ('r', 212), '&': ('r', 212), '<': ('r', 212), '=': ('r', 212), '>': ('r', 212), '?': ('r', 212), '<<': ('r', 212), ':': ('r', 212), ';': ('r', 212), '...': ('r', 212), '|=': ('r', 212), '^=': ('r', 212), '%=': ('r', 212), '!=': ('r', 212), '--': ('r', 212), '/=': ('r', 212), '++': ('r', 212), '^': ('r', 212), '<<=': ('r', 212), '->': ('r', 212), '-=': ('r', 212), '->*': ('r', 212), '+=': ('r', 212), '>=': ('r', 212), '<=': ('r', 212), '||': ('r', 212), '>>=': ('r', 212), '&&': ('r', 212), '|': ('r', 212), '}': ('r', 212), '&=': ('r', 212), '{': ('r', 212), 'try': ('r', 212), '>>': ('r', 212), ']': ('r', 212), '*=': ('r', 212), '==': ('r', 212), '[': ('r', 212), '.*': ('r', 212)}, 734),
        #STATE 735
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 81)], {',': ('r', 371), '-': ('r', 371), '.': ('r', 371), '/': ('r', 371), '(': ('r', 371), ')': ('r', 371), '*': ('r', 371), '+': ('r', 371), '%': ('r', 371), '&': ('r', 371), '<': ('r', 371), '=': ('r', 371), '>': ('r', 371), '?': ('r', 371), '<<': ('r', 371), ':': ('r', 371), ';': ('r', 371), '...': ('r', 371), '|=': ('r', 371), '^=': ('r', 371), '%=': ('r', 371), '!=': ('r', 371), '--': ('r', 371), '/=': ('r', 371), '++': ('r', 371), '^': ('r', 371), '<<=': ('r', 371), '->': ('r', 371), '-=': ('r', 371), '->*': ('r', 371), '>>': ('r', 371), '>=': ('r', 371), '<=': ('r', 371), '||': ('r', 371), '>>=': ('r', 371), '&&': ('r', 371), '|': ('r', 371), '}': ('r', 371), '&=': ('r', 371), '{': ('r', 371), 'try': ('r', 371), '+=': ('r', 371), ']': ('r', 371), '*=': ('r', 371), '==': ('r', 371), '[': ('r', 371), '.*': ('r', 371)}, 735),
        #STATE 736
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 85)], {',': ('r', 215), '-': ('r', 215), '/': ('r', 215), '|=': ('r', 215), ')': ('r', 215), '*': ('r', 215), '+': ('r', 215), '%': ('r', 215), '&': ('r', 215), '>>=': ('r', 215), '&&': ('r', 215), '<': ('r', 215), '=': ('r', 215), '>': ('r', 215), '?': ('r', 215), '<<': ('r', 215), ':': ('r', 215), ';': ('r', 215), '...': ('r', 215), '<=': ('r', 215), '^=': ('r', 215), '%=': ('r', 215), '|': ('r', 215), '!=': ('r', 215), '}': ('r', 215), '/=': ('r', 215), '==': ('r', 215), '||': ('r', 215), '*=': ('r', 215), '&=': ('r', 215), '+=': ('r', 215), ']': ('r', 215), '^': ('r', 215), '<<=': ('r', 215), '-=': ('r', 215), '.*': ('r', 215), '->*': ('r', 215), '>>': ('r', 215), '>=': ('r', 215)}, 736),
        #STATE 737
        State([("qualified_id -> '::' (operator_function_id!|template_id!)", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('type_name -> IDENTIFIER:name', 13), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("operator_function_id -> 'operator' operator:op", 24), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_name -> template_id!', 14), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('namespace_name -> IDENTIFIER:name', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("qualified_id -> '::' (operator_function_id!|template_id!)", 44), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("qualified_id -> '::' IDENTIFIER!", 21)], {type_name: ('g', 405), template_name: ('g', 2), namespace_name: ('g', 5), IDENTIFIER: ('s', 707), nested_name_specifier: ('g', 897), operator_function_id: ('g', 376), 'operator': ('s', 619), class_name: ('g', 11), template_id: ('g', 710)}, 737),
        #STATE 738
        State([('type_name -> IDENTIFIER:name', 13), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('unqualified_id -> IDENTIFIER:id', 18), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 53), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('unqualified_id -> conversion_function_id!', 18), ('template_name -> IDENTIFIER!', 17), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("unqualified_id -> '~' class_name:name", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {operator_function_id: ('g', 6), template_name: ('g', 2), '~': ('s', 45), IDENTIFIER: ('s', 423), conversion_function_id: ('g', 12), unqualified_id: ('g', 326), 'template': ('s', 629), '*': ('s', 290), 'operator': ('s', 8), type_name: ('g', 292), template_id: ('g', 26)}, 738),
        #STATE 739
        State([("pm_expression -> pm_expression:a '->*' cast_expression:b", 33), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 33), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 74)], {',': ('r', 218), '-': ('r', 218), '/': ('r', 218), '|=': ('r', 218), ')': ('r', 218), '*': ('r', 218), '==': ('r', 218), '%': ('r', 218), '&': ('r', 218), '>>=': ('r', 218), '&&': ('r', 218), '<': ('r', 218), '=': ('r', 218), '>': ('r', 218), '?': ('r', 218), '<<': ('r', 218), ':': ('r', 218), ';': ('r', 218), '...': ('r', 218), '<=': ('r', 218), '^=': ('r', 218), '%=': ('r', 218), '|': ('r', 218), '!=': ('r', 218), '}': ('r', 218), '/=': ('r', 218), '+': ('r', 218), '||': ('r', 218), '^': ('r', 218), '&=': ('r', 218), '>>': ('r', 218), ']': ('r', 218), '*=': ('r', 218), '<<=': ('r', 218), '-=': ('r', 218), '.*': ('s', 740), '->*': ('s', 741), '+=': ('r', 218), '>=': ('r', 218)}, 739),
        #STATE 740
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("primary_expression -> '(' expression! ')'", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('namespace_name -> IDENTIFIER:name', 18), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> FLOATING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), qualified_id: ('g', 4), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), '::': ('s', 64), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), TYPE_KEYWORD: ('s', 178), new_expression: ('g', 94), CHARACTER_LITERAL: ('s', 108), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), cast_expression: ('g', 796), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), operator_function_id: ('g', 6), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38)}, 740),
        #STATE 741
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 39), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('namespace_name -> IDENTIFIER:name', 18), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> FLOATING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), operator_function_id: ('g', 6), delete_expression: ('g', 119), cast_expression: ('g', 1038), 'typeid': ('s', 38)}, 741),
        #STATE 742
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ('exception_declaration -> type_descriptor:type ( declarator:dtor | abstract_declarator:dtor )?', 40), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 30), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('exception_declaration -> type_descriptor:type ( declarator:dtor | abstract_declarator:dtor )?', 66), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('declarator -> direct_declarator!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("direct_abstract_declarator -> '(' abstract_declarator! ')'", 30), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ('direct_declarator -> declarator_id!', 21), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 60), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ('declarator_id -> id_expression!', 17), ('id_expression -> unqualified_id!', 17), ('exception_declaration -> type_descriptor:type ( declarator:dtor | abstract_declarator:dtor )?', 48), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("qualified_id -> '::' IDENTIFIER!", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ('abstract_declarator -> direct_abstract_declarator!', 23), ('id_expression -> qualified_id!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('unqualified_id -> operator_function_id!', 18), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('abstract_declarator -> ptr_operator:op abstract_declarator:d?', 23), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("operator_function_id -> 'operator' operator:op", 24), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 60), ('unqualified_id -> conversion_function_id!', 18), ("ptr_operator -> '&'", 16), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 30), ("unqualified_id -> '~' class_name:name", 18), ("direct_declarator -> '(' declarator! ')'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {unqualified_id: ('g', 7), '(': ('s', 484), qualified_id: ('g', 4), '*': ('s', 223), template_name: ('g', 2), nested_name_specifier: ('g', 284), '&': ('s', 225), ')': ('r', 219), conversion_function_id: ('g', 12), '~': ('s', 45), declarator: ('g', 743), 'operator': ('s', 8), direct_declarator: ('g', 285), ptr_operator: ('g', 486), '::': ('s', 282), id_expression: ('g', 280), namespace_name: ('g', 5), declarator_id: ('g', 286), operator_function_id: ('g', 6), class_name: ('g', 11), abstract_declarator: ('g', 609), '[': ('s', 226), direct_abstract_declarator: ('g', 231), template_id: ('g', 44), IDENTIFIER: ('s', 46)}, 742),
        #STATE 743
        State([('exception_declaration -> type_descriptor:type ( declarator:dtor | abstract_declarator:dtor )?', 58)], {')': ('r', 429)}, 743),
        #STATE 744
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82), ('template_name -> IDENTIFIER!', 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 70), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 70), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 77), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 89), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 70), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 77), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 70)], {'template': ('s', 745), template_name: ('g', 2), IDENTIFIER: ('s', 583), template_id: ('g', 384)}, 744),
        #STATE 745
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 89), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82), ('template_name -> IDENTIFIER!', 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), template_id: ('g', 818), IDENTIFIER: ('s', 216)}, 745),
        #STATE 746
        State([("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 69)], {',': ('r', 222), '>': ('r', 222)}, 746),
        #STATE 747
        State([("member_declarator -> IDENTIFIER:name? ':' constant_expression:size", 61)], {',': ('r', 224), ';': ('r', 224)}, 747),
        #STATE 748
        State([("expression -> expression:a ',' assignment_expression:b", 27), ("direct_new_declarator -> direct_new_declarator:dtor? '[' expression:size ']'", 73)], {',': ('s', 272), ']': ('s', 606)}, 748),
        #STATE 749
        State([("direct_new_declarator -> direct_new_declarator:dtor? '[' expression:size ']'", 76)], {',': ('r', 226), '-': ('r', 226), '/': ('r', 226), '(': ('r', 226), ')': ('r', 226), '*': ('r', 226), '+': ('r', 226), '%': ('r', 226), '&': ('r', 226), '>>=': ('r', 226), '&&': ('r', 226), '<': ('r', 226), '=': ('r', 226), '>': ('r', 226), '?': ('r', 226), '<=': ('r', 226), ':': ('r', 226), ';': ('r', 226), '...': ('r', 226), '|=': ('r', 226), '^=': ('r', 226), '%=': ('r', 226), '|': ('r', 226), '!=': ('r', 226), '}': ('r', 226), '/=': ('r', 226), '[': ('r', 226), '==': ('r', 226), '||': ('r', 226), '*=': ('r', 226), '&=': ('r', 226), '<<': ('r', 226), ']': ('r', 226), '^': ('r', 226), '<<=': ('r', 226), '>>': ('r', 226), '-=': ('r', 226), '.*': ('r', 226), '->*': ('r', 226), '+=': ('r', 226), '>=': ('r', 226)}, 749),
        #STATE 750
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 44), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 44), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('class_name -> template_id!', 14), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), nested_name_specifier: ('g', 1005), class_name: ('g', 11), template_id: ('g', 44)}, 750),
        #STATE 751
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 70), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 70), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 70), ('template_name -> IDENTIFIER!', 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 70), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {'template': ('s', 293), template_name: ('g', 2), IDENTIFIER: ('s', 776), template_id: ('g', 713)}, 751),
        #STATE 752
        State([("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 50)], {')': ('s', 718)}, 752),
        #STATE 753
        State([('unqualified_id -> operator_function_id!', 18), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 73), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("operator_function_id -> 'operator' operator:op", 24), ('unqualified_id -> IDENTIFIER:id', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unqualified_id -> '~' class_name:name", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 72), ('unqualified_id -> conversion_function_id!', 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), '~': ('s', 45), IDENTIFIER: ('s', 596), conversion_function_id: ('g', 12), unqualified_id: ('g', 49), operator_function_id: ('g', 6), 'operator': ('s', 8), template_id: ('g', 597)}, 753),
        #STATE 754
        State([("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 86)], {',': ('r', 227), '-': ('r', 227), '.': ('r', 227), '/': ('r', 227), '(': ('r', 227), ')': ('r', 227), '*': ('r', 227), '==': ('r', 227), '%': ('r', 227), '&': ('r', 227), '<': ('r', 227), '=': ('r', 227), '>': ('r', 227), '?': ('r', 227), '<<': ('r', 227), ':': ('r', 227), ';': ('r', 227), '...': ('r', 227), '|=': ('r', 227), '^=': ('r', 227), '%=': ('r', 227), '!=': ('r', 227), '--': ('r', 227), '/=': ('r', 227), '++': ('r', 227), '^': ('r', 227), '<<=': ('r', 227), '->': ('r', 227), '-=': ('r', 227), '->*': ('r', 227), '+=': ('r', 227), '>=': ('r', 227), '<=': ('r', 227), '||': ('r', 227), '>>=': ('r', 227), '&&': ('r', 227), '|': ('r', 227), '}': ('r', 227), '&=': ('r', 227), '>>': ('r', 227), '+': ('r', 227), ']': ('r', 227), '*=': ('r', 227), '[': ('r', 227), '.*': ('r', 227)}, 754),
        #STATE 755
        State([('unqualified_id -> operator_function_id!', 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 81), ("operator_function_id -> 'operator' operator:op", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("unqualified_id -> '~' class_name:name", 18), ('unqualified_id -> conversion_function_id!', 18)], {unqualified_id: ('g', 756), '~': ('s', 45), IDENTIFIER: ('s', 314), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), 'operator': ('s', 8)}, 755),
        #STATE 756
        State([("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 99)], {';': ('s', 1049)}, 756),
        #STATE 757
        State([None, ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 123)], {',': ('s', 304), ')': ('s', 565)}, 757),
        #STATE 758
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 126)], {',': ('r', 267), '-': ('r', 267), '.': ('r', 267), '/': ('r', 267), '|=': ('r', 267), ')': ('r', 267), '*': ('r', 267), '+': ('r', 267), '%': ('r', 267), '&': ('r', 267), '<': ('r', 267), '=': ('r', 267), '>': ('r', 267), '?': ('r', 267), '<<': ('r', 267), ':': ('r', 267), ';': ('r', 267), '...': ('r', 267), '(': ('r', 267), '^=': ('r', 267), '%=': ('r', 267), '!=': ('r', 267), '--': ('r', 267), '/=': ('r', 267), '==': ('r', 267), '*=': ('r', 267), '<<=': ('r', 267), '->': ('r', 267), '-=': ('r', 267), '->*': ('r', 267), '>>': ('r', 267), '>=': ('r', 267), '<=': ('r', 267), '||': ('r', 267), '>>=': ('r', 267), '&&': ('r', 267), '|': ('r', 267), '}': ('r', 267), '&=': ('r', 267), '++': ('r', 267), '+=': ('r', 267), ']': ('r', 267), '^': ('r', 267), '[': ('r', 267), '.*': ('r', 267)}, 758),
        #STATE 759
        State([("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 45), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 63), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 45)], {',': ('r', 264), '-': ('s', 810), '|=': ('r', 264), ')': ('r', 264), '+': ('s', 680), '&': ('r', 264), '>>=': ('r', 264), '&&': ('r', 264), '<': ('r', 264), '=': ('r', 264), '>': ('r', 264), '?': ('r', 264), '<<': ('r', 264), ':': ('r', 264), ';': ('r', 264), '...': ('r', 264), '<=': ('r', 264), '^=': ('r', 264), '%=': ('r', 264), '|': ('r', 264), '!=': ('r', 264), '}': ('r', 264), '/=': ('r', 264), '==': ('r', 264), '||': ('r', 264), '*=': ('r', 264), '&=': ('r', 264), '>>': ('r', 264), ']': ('r', 264), '^': ('r', 264), '<<=': ('r', 264), '-=': ('r', 264), '+=': ('r', 264), '>=': ('r', 264)}, 759),
        #STATE 760
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 137)], {',': ('r', 228), '-': ('r', 228), '.': ('r', 228), '/': ('r', 228), '|=': ('r', 228), ')': ('r', 228), '*': ('r', 228), '+': ('r', 228), '%': ('r', 228), '&': ('r', 228), '<': ('r', 228), '=': ('r', 228), '>': ('r', 228), '?': ('r', 228), '<<': ('r', 228), ':': ('r', 228), ';': ('r', 228), '...': ('r', 228), '(': ('r', 228), '^=': ('r', 228), '%=': ('r', 228), '!=': ('r', 228), '--': ('r', 228), '/=': ('r', 228), '==': ('r', 228), '*=': ('r', 228), '<<=': ('r', 228), '->': ('r', 228), '-=': ('r', 228), '->*': ('r', 228), '+=': ('r', 228), '>=': ('r', 228), '<=': ('r', 228), '||': ('r', 228), '>>=': ('r', 228), '&&': ('r', 228), '|': ('r', 228), '}': ('r', 228), '&=': ('r', 228), '++': ('r', 228), '>>': ('r', 228), ']': ('r', 228), '^': ('r', 228), '[': ('r', 228), '.*': ('r', 228)}, 760),
        #STATE 761
        State([("class_specifier -> class_head!! '{' member_specification!*:body '}'", 67)], {',': ('r', 229), '-': ('r', 229), '.': ('r', 229), '/': ('r', 229), '|=': ('r', 229), ')': ('r', 229), '*': ('r', 229), '+': ('r', 229), '%': ('r', 229), '&': ('r', 229), 'operator': ('r', 229), '<': ('r', 229), '=': ('r', 229), '>': ('r', 229), '?': ('r', 229), '<<': ('r', 229), IDENTIFIER: ('r', 229), ':': ('r', 229), ';': ('r', 229), '...': ('r', 229), '(': ('r', 229), '^=': ('r', 229), '||': ('r', 229), '^': ('r', 229), '!=': ('r', 229), '--': ('r', 229), '/=': ('r', 229), '++': ('r', 229), '*=': ('r', 229), '<<=': ('r', 229), '->': ('r', 229), 'struct': ('r', 229), '-=': ('r', 229), '%=': ('r', 229), '+=': ('r', 229), '>=': ('r', 229), 'union': ('r', 229), '<=': ('r', 229), '::': ('r', 229), 'auto': ('r', 229), '>>=': ('r', 229), '&&': ('r', 229), '|': ('r', 229), '}': ('r', 229), '~': ('r', 229), 'volatile': ('r', 229), '&=': ('r', 229), '{': ('r', 229), '.*': ('r', 229), '->*': ('r', 229), TYPE_KEYWORD: ('r', 229), 'try': ('r', 229), 'enum': ('r', 229), '>>': ('r', 229), 'class': ('r', 229), ']': ('r', 229), 'typename': ('r', 229), '==': ('r', 229), '[': ('r', 229), 'const': ('r', 229)}, 761),
        #STATE 762
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 56), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 56), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('new_type_id -> type_descriptor:type new_declarator:dtor?', 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 56), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('new_type_id -> type_descriptor:type new_declarator:dtor?', 15), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 56), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {template_name: ('g', 2), '(': ('s', 363), named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), nested_name_specifier: ('g', 189), type_name: ('g', 98), 'union': ('s', 97), type_descriptor: ('g', 764), elaborated_type_specifier: ('g', 109), '::': ('s', 191), enum_specifier: ('g', 122), 'struct': ('s', 58), class_name: ('g', 11), _80: ('g', 112), cv_qualifier: ('g', 106), class_head: ('g', 20), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), class_specifier: ('g', 75), 'class': ('s', 115), 'typename': ('s', 166), namespace_name: ('g', 5), 'auto': ('s', 90), 'volatile': ('s', 33), 'const': ('s', 35), new_type_id: ('g', 763), _81: ('g', 88), template_id: ('g', 18), IDENTIFIER: ('s', 29)}, 762),
        #STATE 763
        State([("new_initializer -> '(' assignment_expression!*,','! ')'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 67), ("new_initializer -> '(' assignment_expression!*,','! ')'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 70)], {',': ('r', 434), '-': ('r', 434), '/': ('r', 434), '(': ('s', 300), ')': ('r', 434), '*': ('r', 434), '==': ('r', 434), '%': ('r', 434), '&': ('r', 434), '>>=': ('r', 434), '+=': ('r', 434), '&&': ('r', 434), '<': ('r', 434), '=': ('r', 434), '>': ('r', 434), '?': ('r', 434), '<=': ('r', 434), ':': ('r', 434), ';': ('r', 434), '...': ('r', 434), '|=': ('r', 434), '^=': ('r', 434), '%=': ('r', 434), '|': ('r', 434), '!=': ('r', 434), '}': ('r', 434), '/=': ('r', 434), '+': ('r', 434), '||': ('r', 434), '^': ('r', 434), '&=': ('r', 434), '<<': ('r', 434), ']': ('r', 434), '*=': ('r', 434), '<<=': ('r', 434), new_initializer: ('g', 926), '-=': ('r', 434), '.*': ('r', 434), '->*': ('r', 434), '>>': ('r', 434), '>=': ('r', 434)}, 763),
        #STATE 764
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('new_type_id -> type_descriptor:type new_declarator:dtor?', 30), ('class_name -> template_id!', 14), ('new_declarator -> ptr_operator:op new_declarator:dtor?', 18), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_new_declarator -> direct_new_declarator:dtor? '[' expression:size ']'", 53), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('new_type_id -> type_descriptor:type new_declarator:dtor?', 36), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('new_declarator -> ptr_operator:op new_declarator:dtor?', 18), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('new_declarator -> direct_new_declarator!', 18), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("direct_new_declarator -> direct_new_declarator:dtor? '[' expression:size ']'", 25), ("ptr_operator -> '&'", 16), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {',': ('r', 311), template_name: ('g', 2), '/': ('r', 311), '(': ('r', 311), ')': ('r', 311), '*': ('c', [('s', 223), ('r', 311)]), '-': ('r', 311), '%': ('r', 311), '&': ('c', [('s', 225), ('r', 311)]), '<': ('r', 311), '=': ('r', 311), '>': ('r', 311), '?': ('r', 311), '<<': ('r', 311), IDENTIFIER: ('s', 414), ':': ('r', 311), ';': ('r', 311), '...': ('r', 311), '|=': ('r', 311), class_name: ('g', 11), '^=': ('r', 311), '||': ('r', 311), namespace_name: ('g', 5), '!=': ('r', 311), ']': ('r', 311), '/=': ('r', 311), '+': ('r', 311), '^': ('r', 311), '<<=': ('r', 311), '%=': ('r', 311), '-=': ('r', 311), '->*': ('r', 311), '+=': ('r', 311), '>=': ('r', 311), '<=': ('r', 311), '::': ('s', 435), nested_name_specifier: ('g', 437), '>>=': ('r', 311), '&&': ('r', 311), '|': ('r', 311), '}': ('r', 311), '&=': ('r', 311), ptr_operator: ('g', 884), new_declarator: ('g', 883), '>>': ('r', 311), direct_new_declarator: ('g', 432), '*=': ('r', 311), '==': ('r', 311), '[': ('s', 599), '.*': ('r', 311), template_id: ('g', 44)}, 764),
        #STATE 765
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 77), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 50), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 766), namespace_name: ('g', 5), nested_name_specifier: ('g', 767), class_name: ('g', 11), template_id: ('g', 44)}, 765),
        #STATE 766
        State([('namespace_name -> IDENTIFIER:name', 28), ('class_name -> IDENTIFIER:name', 24), ('template_name -> IDENTIFIER!', 27), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 87)], {',': ('r', 456), '-': ('r', 456), '.': ('r', 456), '/': ('r', 456), '|=': ('r', 456), ')': ('r', 456), '*': ('r', 456), '+': ('r', 456), '%': ('r', 456), '&': ('r', 456), 'operator': ('r', 456), '<': ('c', [('r', 2), ('r', 456)]), '=': ('r', 456), '>': ('r', 456), '?': ('r', 456), '<<': ('r', 456), IDENTIFIER: ('r', 456), ':': ('r', 456), ';': ('r', 456), '...': ('r', 456), '(': ('r', 456), '^=': ('r', 456), '||': ('r', 456), '^': ('r', 456), '!=': ('r', 456), '--': ('r', 456), '/=': ('r', 456), '++': ('r', 456), '*=': ('r', 456), '<<=': ('r', 456), '->': ('r', 456), 'auto': ('r', 456), '-=': ('r', 456), '%=': ('r', 456), '+=': ('r', 456), '>=': ('r', 456), 'union': ('r', 456), '<=': ('r', 456), '::': ('c', [('r', 5), ('r', 7), ('r', 456)]), '>>=': ('r', 456), '&&': ('r', 456), '|': ('r', 456), '}': ('r', 456), '~': ('r', 456), 'volatile': ('r', 456), '&=': ('r', 456), '{': ('r', 456), '.*': ('r', 456), 'struct': ('r', 456), '->*': ('r', 456), TYPE_KEYWORD: ('r', 456), 'try': ('r', 456), 'enum': ('r', 456), '>>': ('r', 456), 'class': ('r', 456), ']': ('r', 456), 'typename': ('r', 456), '==': ('r', 456), '[': ('r', 456), 'const': ('r', 456)}, 766),
        #STATE 767
        State([("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 77)], {IDENTIFIER: ('s', 879)}, 767),
        #STATE 768
        State([("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 95)], {';': ('s', 769)}, 768),
        #STATE 769
        State([("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 98)], {'-': ('r', 530), '++': ('r', 530), '(': ('r', 530), '*': ('r', 530), 'reinterpret_cast': ('r', 530), 'delete': ('r', 530), 'static_cast': ('r', 530), 'virtual': ('r', 530), DECLARE_KEYWORD: ('r', 530), ACCESS_KEYWORD: ('r', 530), IDENTIFIER: ('r', 530), 'while': ('r', 530), INTEGER_LITERAL: ('r', 530), 'extern': ('r', 530), 'default': ('r', 530), 'goto': ('r', 530), 'break': ('r', 530), 'new': ('r', 530), 'class': ('r', 530), 'typedef': ('r', 530), '--': ('r', 530), 'asm': ('r', 530), 'dynamic_cast': ('r', 530), 'for': ('r', 530), 'export': ('r', 530), '+': ('r', 530), 'struct': ('r', 530), 'template': ('r', 530), 'continue': ('r', 530), '&': ('r', 530), 'case': ('r', 530), 'if': ('r', 530), 'union': ('r', 530), 'const_cast': ('r', 530), '::': ('r', 530), 'auto': ('r', 530), 'using': ('r', 530), 'volatile': ('r', 530), 'namespace': ('r', 530), 'do': ('r', 530), '!': ('r', 530), '}': ('r', 530), '~': ('r', 530), 'return': ('r', 530), '{': ('r', 530), 'this': ('r', 530), TYPE_KEYWORD: ('r', 530), FLOATING_LITERAL: ('r', 530), 'sizeof': ('r', 530), 'else': ('r', 530), CHARACTER_LITERAL: ('r', 530), 'try': ('r', 530), BOOLEAN_LITERAL: ('r', 530), 'enum': ('r', 530), EOF: ('r', 530), STRING_LITERAL: ('r', 530), 'throw': ('r', 530), CPP_INCLUDE: ('r', 530), 'typename': ('r', 530), CPP_ERROR: ('r', 530), 'operator': ('r', 530), 'const': ('r', 530), 'switch': ('r', 530), 'typeid': ('r', 530)}, 769),
        #STATE 770
        State([("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 91)], {';': ('s', 771)}, 770),
        #STATE 771
        State([("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 94)], {'union': ('r', 395), '::': ('r', 395), 'export': ('r', 395), 'using': ('r', 395), 'virtual': ('r', 395), DECLARE_KEYWORD: ('r', 395), '}': ('r', 395), '~': ('r', 395), IDENTIFIER: ('r', 395), 'operator': ('r', 395), 'typedef': ('r', 395), 'extern': ('r', 395), TYPE_KEYWORD: ('r', 395), ACCESS_KEYWORD: ('r', 395), 'enum': ('r', 395), 'class': ('r', 395), 'typename': ('r', 395), 'struct': ('r', 395), 'volatile': ('r', 395), 'template': ('r', 395), 'const': ('r', 395), 'auto': ('r', 395)}, 771),
        #STATE 772
        State([("expression -> expression:a ',' assignment_expression:b", 27), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 67)], {',': ('s', 272), ':': ('s', 407)}, 772),
        #STATE 773
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 45), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('constant_expression -> conditional_expression!', 23), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 70), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), constant_expression: ('g', 687), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), '!': ('s', 104), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 774), logical_and_expression: ('g', 118), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 310), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), type_name: ('g', 98), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), unqualified_id: ('g', 7), 'const_cast': ('s', 92), qualified_id: ('g', 4), exclusive_or_expression: ('g', 121), nested_name_specifier: ('g', 95), new_expression: ('g', 94), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), ']': ('s', 775), 'typename': ('s', 180), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 773),
        #STATE 774
        State([('constant_expression -> conditional_expression!', 45)], {',': ('r', 439), ']': ('r', 439), ';': ('r', 439), ':': ('r', 439), '}': ('r', 439)}, 774),
        #STATE 775
        State([("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 73)], {',': ('r', 528), 'try': ('r', 528), '=': ('r', 528), ';': ('r', 528), '(': ('r', 528), ')': ('r', 528), ':': ('r', 528), '{': ('r', 528), '...': ('r', 528), '[': ('r', 528), '>': ('r', 528)}, 775),
        #STATE 776
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 86), ('template_name -> IDENTIFIER!', 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 86)], {'<': ('r', 2), '(': ('s', 777)}, 776),
        #STATE 777
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("unqualified_id -> '~' class_name:name", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ('unary_expression -> postfix_expression!', 20), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 123), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), ')': ('s', 1009), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), _15: ('g', 439), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), relational_expression: ('g', 67), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 323), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), named_type_specifier: ('g', 177), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 777),
        #STATE 778
        State([("try_block -> 'try' compound_statement:body handler!+:handlers", 50)], {'-': ('r', 235), '++': ('r', 235), '(': ('r', 235), '*': ('r', 235), 'reinterpret_cast': ('r', 235), 'delete': ('r', 235), 'static_cast': ('r', 235), 'virtual': ('r', 235), '!': ('r', 235), ACCESS_KEYWORD: ('r', 235), IDENTIFIER: ('r', 235), ';': ('r', 235), INTEGER_LITERAL: ('r', 235), 'typedef': ('r', 235), 'default': ('r', 235), 'goto': ('r', 235), 'new': ('r', 235), 'throw': ('r', 235), 'extern': ('r', 235), '--': ('r', 235), 'catch': ('r', 235), 'asm': ('r', 235), 'dynamic_cast': ('r', 235), 'for': ('r', 235), 'export': ('r', 235), 'struct': ('r', 235), 'template': ('r', 235), 'continue': ('r', 235), '&': ('r', 235), 'case': ('r', 235), 'if': ('r', 235), 'sizeof': ('r', 235), 'const_cast': ('r', 235), '::': ('r', 235), 'auto': ('r', 235), 'using': ('r', 235), 'volatile': ('r', 235), 'namespace': ('r', 235), 'union': ('r', 235), DECLARE_KEYWORD: ('r', 235), '}': ('r', 235), '~': ('r', 235), 'return': ('r', 235), 'do': ('r', 235), '{': ('r', 235), 'this': ('r', 235), TYPE_KEYWORD: ('r', 235), FLOATING_LITERAL: ('r', 235), CPP_ERROR: ('r', 235), 'else': ('r', 235), CHARACTER_LITERAL: ('r', 235), 'class': ('r', 235), 'try': ('r', 235), BOOLEAN_LITERAL: ('r', 235), 'enum': ('r', 235), EOF: ('r', 235), STRING_LITERAL: ('r', 235), '+': ('r', 235), CPP_INCLUDE: ('r', 235), 'typename': ('r', 235), 'while': ('r', 235), 'break': ('r', 235), 'operator': ('r', 235), 'const': ('r', 235), 'switch': ('r', 235), 'typeid': ('r', 235)}, 778),
        #STATE 779
        State([("parameter_declaration_clause -> parameter_declaration!+,',':plist ',' '...'", 75)], {')': ('r', 236)}, 779),
        #STATE 780
        State([("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 108)], {'-': ('r', 547), '++': ('r', 547), '(': ('r', 547), '::': ('r', 547), '*': ('r', 547), 'sizeof': ('r', 547), 'delete': ('r', 547), '&': ('r', 547), '!': ('r', 547), 'this': ('r', 547), '~': ('r', 547), IDENTIFIER: ('r', 547), 'operator': ('r', 547), 'const_cast': ('r', 547), CHARACTER_LITERAL: ('r', 547), 'new': ('r', 547), FLOATING_LITERAL: ('r', 547), TYPE_KEYWORD: ('r', 547), '--': ('r', 547), 'reinterpret_cast': ('r', 547), BOOLEAN_LITERAL: ('r', 547), '+': ('r', 547), STRING_LITERAL: ('r', 547), 'throw': ('r', 547), 'typename': ('r', 547), 'dynamic_cast': ('r', 547), INTEGER_LITERAL: ('r', 547), 'static_cast': ('r', 547), 'typeid': ('r', 547)}, 780),
        #STATE 781
        State([("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 42)], {'-': ('r', 425), '++': ('r', 425), '(': ('r', 425), '::': ('r', 425), '*': ('r', 425), 'sizeof': ('r', 425), 'delete': ('r', 425), '&': ('r', 425), '!': ('r', 425), 'this': ('r', 425), '~': ('r', 425), IDENTIFIER: ('r', 425), 'operator': ('r', 425), 'const_cast': ('r', 425), TYPE_KEYWORD: ('r', 425), 'new': ('r', 425), FLOATING_LITERAL: ('r', 425), CHARACTER_LITERAL: ('r', 425), '--': ('r', 425), BOOLEAN_LITERAL: ('r', 425), 'reinterpret_cast': ('r', 425), STRING_LITERAL: ('r', 425), 'throw': ('r', 425), 'typename': ('r', 425), 'dynamic_cast': ('r', 425), '+': ('r', 425), INTEGER_LITERAL: ('r', 425), 'static_cast': ('r', 425), 'typeid': ('r', 425)}, 781),
        #STATE 782
        State([("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 26)], {'-': ('r', 403), '++': ('r', 403), '(': ('r', 403), '::': ('r', 403), '*': ('r', 403), 'sizeof': ('r', 403), 'delete': ('r', 403), '&': ('r', 403), '!': ('r', 403), 'this': ('r', 403), '~': ('r', 403), IDENTIFIER: ('r', 403), 'operator': ('r', 403), 'const_cast': ('r', 403), 'static_cast': ('r', 403), CHARACTER_LITERAL: ('r', 403), 'new': ('r', 403), FLOATING_LITERAL: ('r', 403), TYPE_KEYWORD: ('r', 403), '--': ('r', 403), BOOLEAN_LITERAL: ('r', 403), 'reinterpret_cast': ('r', 403), STRING_LITERAL: ('r', 403), 'dynamic_cast': ('r', 403), 'typename': ('r', 403), '+': ('r', 403), INTEGER_LITERAL: ('r', 403), 'throw': ('r', 403), 'typeid': ('r', 403)}, 782),
        #STATE 783
        State([("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 75)], {'-': ('r', 238), '++': ('r', 238), '(': ('r', 238), '::': ('r', 238), '*': ('r', 238), 'sizeof': ('r', 238), 'delete': ('r', 238), 'static_cast': ('r', 238), '!': ('r', 238), '&': ('r', 238), 'this': ('r', 238), '~': ('r', 238), IDENTIFIER: ('r', 238), 'operator': ('r', 238), 'const_cast': ('r', 238), CHARACTER_LITERAL: ('r', 238), 'new': ('r', 238), FLOATING_LITERAL: ('r', 238), TYPE_KEYWORD: ('r', 238), '--': ('r', 238), BOOLEAN_LITERAL: ('r', 238), 'reinterpret_cast': ('r', 238), STRING_LITERAL: ('r', 238), 'dynamic_cast': ('r', 238), 'typename': ('r', 238), '+': ('r', 238), INTEGER_LITERAL: ('r', 238), 'throw': ('r', 238), 'typeid': ('r', 238)}, 783),
        #STATE 784
        State([("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 92)], {'-': ('r', 517), '++': ('r', 517), '(': ('r', 517), '::': ('r', 517), '*': ('r', 517), 'sizeof': ('r', 517), 'delete': ('r', 517), '&': ('r', 517), '!': ('r', 517), 'this': ('r', 517), '~': ('r', 517), IDENTIFIER: ('r', 517), 'operator': ('r', 517), INTEGER_LITERAL: ('r', 517), TYPE_KEYWORD: ('r', 517), 'new': ('r', 517), FLOATING_LITERAL: ('r', 517), CHARACTER_LITERAL: ('r', 517), '--': ('r', 517), 'const_cast': ('r', 517), BOOLEAN_LITERAL: ('r', 517), 'reinterpret_cast': ('r', 517), STRING_LITERAL: ('r', 517), 'throw': ('r', 517), 'typename': ('r', 517), 'dynamic_cast': ('r', 517), '+': ('r', 517), 'static_cast': ('r', 517), 'typeid': ('r', 517)}, 784),
        #STATE 785
        State([("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 66)], {'-': ('r', 421), '++': ('r', 421), '(': ('r', 421), '::': ('r', 421), '*': ('r', 421), 'sizeof': ('r', 421), 'delete': ('r', 421), '&': ('r', 421), '!': ('r', 421), 'this': ('r', 421), '~': ('r', 421), IDENTIFIER: ('r', 421), 'operator': ('r', 421), 'const_cast': ('r', 421), CHARACTER_LITERAL: ('r', 421), 'new': ('r', 421), FLOATING_LITERAL: ('r', 421), TYPE_KEYWORD: ('r', 421), '--': ('r', 421), 'reinterpret_cast': ('r', 421), BOOLEAN_LITERAL: ('r', 421), '+': ('r', 421), STRING_LITERAL: ('r', 421), 'throw': ('r', 421), 'typename': ('r', 421), 'dynamic_cast': ('r', 421), INTEGER_LITERAL: ('r', 421), 'static_cast': ('r', 421), 'typeid': ('r', 421)}, 785),
        #STATE 786
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 74), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 992), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 786),
        #STATE 787
        State([("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 58)], {'-': ('r', 422), '++': ('r', 422), '(': ('r', 422), '::': ('r', 422), '*': ('r', 422), 'sizeof': ('r', 422), 'delete': ('r', 422), 'static_cast': ('r', 422), '!': ('r', 422), '&': ('r', 422), 'this': ('r', 422), '~': ('r', 422), IDENTIFIER: ('r', 422), 'operator': ('r', 422), 'const_cast': ('r', 422), TYPE_KEYWORD: ('r', 422), 'new': ('r', 422), FLOATING_LITERAL: ('r', 422), CHARACTER_LITERAL: ('r', 422), '--': ('r', 422), BOOLEAN_LITERAL: ('r', 422), 'reinterpret_cast': ('r', 422), STRING_LITERAL: ('r', 422), 'dynamic_cast': ('r', 422), 'typename': ('r', 422), '+': ('r', 422), INTEGER_LITERAL: ('r', 422), 'throw': ('r', 422), 'typeid': ('r', 422)}, 787),
        #STATE 788
        State([("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 100)], {'-': ('r', 413), '++': ('r', 413), '(': ('r', 413), '::': ('r', 413), '*': ('r', 413), 'sizeof': ('r', 413), 'delete': ('r', 413), '&': ('r', 413), '!': ('r', 413), 'this': ('r', 413), '~': ('r', 413), IDENTIFIER: ('r', 413), 'operator': ('r', 413), 'const_cast': ('r', 413), 'static_cast': ('r', 413), CHARACTER_LITERAL: ('r', 413), 'new': ('r', 413), FLOATING_LITERAL: ('r', 413), TYPE_KEYWORD: ('r', 413), '--': ('r', 413), BOOLEAN_LITERAL: ('r', 413), 'reinterpret_cast': ('r', 413), STRING_LITERAL: ('r', 413), 'dynamic_cast': ('r', 413), 'typename': ('r', 413), '+': ('r', 413), INTEGER_LITERAL: ('r', 413), 'throw': ('r', 413), 'typeid': ('r', 413)}, 788),
        #STATE 789
        State([("assignment_operator -> '='! | '*='! | '/='! | '%='! | '+='! | '-='! | '<<='! | '>>='! | '&='! | '^='! | '|='!", 50)], {'-': ('r', 478), '++': ('r', 478), '(': ('r', 478), '::': ('r', 478), '*': ('r', 478), 'sizeof': ('r', 478), 'delete': ('r', 478), '&': ('r', 478), '!': ('r', 478), 'this': ('r', 478), '~': ('r', 478), IDENTIFIER: ('r', 478), 'operator': ('r', 478), INTEGER_LITERAL: ('r', 478), CHARACTER_LITERAL: ('r', 478), 'new': ('r', 478), 'dynamic_cast': ('r', 478), TYPE_KEYWORD: ('r', 478), '--': ('r', 478), 'const_cast': ('r', 478), BOOLEAN_LITERAL: ('r', 478), 'reinterpret_cast': ('r', 478), STRING_LITERAL: ('r', 478), FLOATING_LITERAL: ('r', 478), 'throw': ('r', 478), 'typename': ('r', 478), '+': ('r', 478), 'static_cast': ('r', 478), 'typeid': ('r', 478)}, 789),
        #STATE 790
        State([("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 45), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 25), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 45), ('raw_type_descriptor -> class_specifier!', 23), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ('raw_type_descriptor -> enum_specifier!', 23), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('parameter_declaration -> type_descriptor:type declarator:dtor', 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 45), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 13), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 45), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), None, ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("raw_type_descriptor -> 'auto'", 23), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_key -> 'class' | 'struct' | 'union'", 23), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("class_key -> 'class' | 'struct' | 'union'", 34), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 66), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {raw_type_descriptor: ('g', 54), IDENTIFIER: ('s', 29), named_type_specifier: ('g', 126), cv_qualifier: ('g', 106), nested_name_specifier: ('g', 189), parameter_declaration: ('g', 190), type_name: ('g', 98), 'union': ('s', 97), type_descriptor: ('g', 193), ')': ('r', 19), elaborated_type_specifier: ('g', 109), '::': ('s', 191), parameter_declaration_clause: ('g', 442), enum_specifier: ('g', 122), template_name: ('g', 2), class_name: ('g', 11), '...': ('s', 192), class_head: ('g', 20), class_specifier: ('g', 75), _100: ('g', 188), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), _80: ('g', 112), _81: ('g', 88), 'class': ('s', 115), 'typename': ('s', 166), namespace_name: ('g', 5), 'enum': ('s', 117), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), template_id: ('g', 18), 'auto': ('s', 90)}, 790),
        #STATE 791
        State([("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 89)], {']': ('s', 830)}, 791),
        #STATE 792
        State([("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 92)], {',': ('r', 505), 'union': ('r', 505), '(': ('r', 505), ')': ('r', 505), 'auto': ('r', 505), 'volatile': ('r', 505), TYPE_KEYWORD: ('r', 505), 'enum': ('r', 505), 'typename': ('r', 505), 'class': ('r', 505), '=': ('r', 505), '>': ('r', 505), IDENTIFIER: ('r', 505), 'struct': ('r', 505), '[': ('r', 505), '...': ('r', 505), 'const': ('r', 505), '::': ('r', 505)}, 792),
        #STATE 793
        State([("using_declaration -> 'using' '::' unqualified_id:id ';'", 52)], {';': ('s', 569)}, 793),
        #STATE 794
        State([("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 77), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 70), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 89), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 77), ('template_name -> IDENTIFIER!', 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 70), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 70), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 70), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {'template': ('s', 940), template_name: ('g', 2), IDENTIFIER: ('s', 938), template_id: ('g', 939)}, 794),
        #STATE 795
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 44), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('namespace_name -> IDENTIFIER:name', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 44), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 51), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 51), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ('class_name -> IDENTIFIER:name', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 51), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ('template_name -> IDENTIFIER!', 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 44), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), nested_name_specifier: ('g', 744), class_name: ('g', 11), template_id: ('g', 44)}, 795),
        #STATE 796
        State([("pm_expression -> pm_expression:a '.*' cast_expression:b", 53)], {',': ('r', 239), '-': ('r', 239), '/': ('r', 239), '|=': ('r', 239), ')': ('r', 239), '*': ('r', 239), '==': ('r', 239), '%': ('r', 239), '&': ('r', 239), '>>=': ('r', 239), '&&': ('r', 239), '<': ('r', 239), '=': ('r', 239), '>': ('r', 239), '?': ('r', 239), '<<': ('r', 239), ':': ('r', 239), ';': ('r', 239), '...': ('r', 239), '<=': ('r', 239), '^=': ('r', 239), '%=': ('r', 239), '|': ('r', 239), '!=': ('r', 239), '}': ('r', 239), '/=': ('r', 239), '+': ('r', 239), '||': ('r', 239), '^': ('r', 239), '&=': ('r', 239), '+=': ('r', 239), ']': ('r', 239), '*=': ('r', 239), '<<=': ('r', 239), '-=': ('r', 239), '.*': ('r', 239), '->*': ('r', 239), '>>': ('r', 239), '>=': ('r', 239)}, 796),
        #STATE 797
        State([("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 96)], {'union': ('r', 241), '::': ('r', 241), 'export': ('r', 241), 'using': ('r', 241), 'virtual': ('r', 241), DECLARE_KEYWORD: ('r', 241), '}': ('r', 241), '~': ('r', 241), IDENTIFIER: ('r', 241), 'operator': ('r', 241), 'extern': ('r', 241), 'typedef': ('r', 241), TYPE_KEYWORD: ('r', 241), ACCESS_KEYWORD: ('r', 241), 'enum': ('r', 241), 'class': ('r', 241), 'typename': ('r', 241), 'struct': ('r', 241), 'volatile': ('r', 241), 'template': ('r', 241), 'const': ('r', 241), 'auto': ('r', 241)}, 797),
        #STATE 798
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ('statement -> iteration_statement!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> CPP_ERROR!', 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('statement -> labeled_statement!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('block_declaration -> asm_definition!', 21), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ('statement -> compound_statement!', 13), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ('statement -> jump_statement!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 97), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unary_expression -> postfix_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_name -> template_id!', 13), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), '++': ('s', 55), pm_expression: ('g', 73), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), and_expression: ('g', 72), _80: ('g', 112), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), logical_and_expression: ('g', 118), 'asm': ('s', 125), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), conversion_function_id: ('g', 357), 'namespace': ('s', 170), expression: ('g', 335), STRING_LITERAL: ('s', 113), 'auto': ('s', 90), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), compound_statement: ('g', 339), DECLARE_KEYWORD: ('s', 160), selection_statement: ('g', 340), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), operator_function_id: ('g', 6), 'enum': ('s', 117), block_declaration: ('g', 344), 'typename': ('s', 116), 'while': ('s', 349), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 444), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), 'default': ('s', 330), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), asm_definition: ('g', 149), 'union': ('s', 97), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'do': ('s', 355), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'case': ('s', 356), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), 'try': ('s', 334), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), declaration_statement: ('g', 343), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), nested_name_specifier: ('g', 352), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 798),
        #STATE 799
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("unqualified_id -> '~' class_name:name", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("constant_initializer -> '=' constant_expression!", 28), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('constant_expression -> conditional_expression!', 23), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("pure_specifier -> '=' INTEGER_LITERAL:i", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), constant_expression: ('g', 801), 'delete': ('s', 59), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), '!': ('s', 104), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 800), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 774), logical_and_expression: ('g', 118), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 310), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), type_name: ('g', 98), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), '&': ('s', 61), unqualified_id: ('g', 7), 'const_cast': ('s', 92), qualified_id: ('g', 4), exclusive_or_expression: ('g', 121), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 799),
        #STATE 800
        State([("pure_specifier -> '=' INTEGER_LITERAL:i", 37), ('literal -> INTEGER_LITERAL:v', 26)], {',': ('c', [('r', 300), ('r', 301)]), '-': ('r', 301), '.': ('r', 301), '/': ('r', 301), '(': ('r', 301), '<<': ('r', 301), '*': ('r', 301), '==': ('r', 301), '%': ('r', 301), '&': ('r', 301), '&&': ('r', 301), '<': ('r', 301), '>': ('r', 301), '?': ('r', 301), ';': ('c', [('r', 300), ('r', 301)]), '<=': ('r', 301), '||': ('r', 301), '|': ('r', 301), '!=': ('r', 301), '--': ('r', 301), '++': ('r', 301), '+': ('r', 301), '^': ('r', 301), '->': ('r', 301), '[': ('r', 301), '.*': ('r', 301), '->*': ('r', 301), '>>': ('r', 301), '>=': ('r', 301)}, 800),
        #STATE 801
        State([("constant_initializer -> '=' constant_expression!", 47)], {',': ('r', 430), ';': ('r', 430)}, 801),
        #STATE 802
        State([("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 79)], {',': ('r', 244), '-': ('r', 244), '.': ('r', 244), '/': ('r', 244), '|=': ('r', 244), ')': ('r', 244), '*': ('r', 244), '+': ('r', 244), '%': ('r', 244), '&': ('r', 244), '<': ('r', 244), '=': ('r', 244), '>': ('r', 244), '?': ('r', 244), '<<': ('r', 244), ':': ('r', 244), ';': ('r', 244), '...': ('r', 244), '(': ('r', 244), '^=': ('r', 244), '%=': ('r', 244), '!=': ('r', 244), '--': ('r', 244), '/=': ('r', 244), '==': ('r', 244), '^': ('r', 244), '<<=': ('r', 244), '->': ('r', 244), '-=': ('r', 244), '->*': ('r', 244), '>>': ('r', 244), '>=': ('r', 244), '<=': ('r', 244), '||': ('r', 244), '>>=': ('r', 244), '&&': ('r', 244), '|': ('r', 244), '}': ('r', 244), '&=': ('r', 244), '++': ('r', 244), '+=': ('r', 244), ']': ('r', 244), '*=': ('r', 244), '[': ('r', 244), '.*': ('r', 244)}, 802),
        #STATE 803
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 89)], {'template': ('r', 246), '~': ('r', 246), IDENTIFIER: ('r', 246), '*': ('r', 246), 'operator': ('r', 246)}, 803),
        #STATE 804
        State([("new_initializer -> '(' assignment_expression!*,','! ')'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 67), ("new_initializer -> '(' assignment_expression!*,','! ')'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 70)], {',': ('r', 247), '-': ('r', 247), '/': ('r', 247), '(': ('s', 300), ')': ('r', 247), '*': ('r', 247), '==': ('r', 247), '%': ('r', 247), '&': ('r', 247), '>>=': ('r', 247), '+=': ('r', 247), '&&': ('r', 247), '<': ('r', 247), '=': ('r', 247), '>': ('r', 247), '?': ('r', 247), '<=': ('r', 247), ':': ('r', 247), ';': ('r', 247), '...': ('r', 247), '|=': ('r', 247), '^=': ('r', 247), '%=': ('r', 247), '|': ('r', 247), '!=': ('r', 247), '}': ('r', 247), '/=': ('r', 247), '+': ('r', 247), '||': ('r', 247), '^': ('r', 247), '&=': ('r', 247), '<<': ('r', 247), ']': ('r', 247), '*=': ('r', 247), '<<=': ('r', 247), new_initializer: ('g', 736), '-=': ('r', 247), '.*': ('r', 247), '->*': ('r', 247), '>>': ('r', 247), '>=': ('r', 247)}, 804),
        #STATE 805
        State([('namespace_name -> IDENTIFIER:name', 28), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 63), ('class_name -> IDENTIFIER:name', 24), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 69), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 87), ("base_clause -> ':' base_specifier!+,','!", 15), ('template_name -> IDENTIFIER!', 27)], {',': ('r', 249), '-': ('r', 249), '.': ('r', 249), '/': ('r', 249), '|=': ('r', 249), ')': ('r', 249), '*': ('r', 249), '+': ('r', 249), '%': ('r', 249), '&': ('r', 249), 'operator': ('r', 249), '%=': ('r', 249), '<': ('c', [('r', 249), ('r', 2)]), '=': ('r', 249), '>': ('r', 249), '?': ('r', 249), '<<': ('r', 249), IDENTIFIER: ('r', 249), ':': ('c', [('s', 662), ('r', 249)]), ';': ('r', 249), '...': ('r', 249), '(': ('r', 249), '^=': ('r', 249), '::': ('c', [('r', 5), ('r', 7), ('r', 249)]), '!=': ('r', 249), '--': ('r', 249), '/=': ('r', 249), '++': ('r', 249), '*=': ('r', 249), 'typename': ('r', 249), '<<=': ('r', 249), '->': ('r', 249), 'auto': ('r', 249), '-=': ('r', 249), '->*': ('r', 249), '+=': ('r', 249), '>=': ('r', 249), 'union': ('r', 249), '<=': ('r', 249), base_clause: ('g', 806), '||': ('r', 249), '>>=': ('r', 249), '&&': ('r', 249), 'const': ('r', 249), '|': ('r', 249), '}': ('r', 249), '~': ('r', 249), 'volatile': ('r', 249), '&=': ('r', 249), '{': ('c', [('r', 248), ('r', 249)]), 'struct': ('r', 249), TYPE_KEYWORD: ('r', 249), 'try': ('r', 249), 'enum': ('r', 249), '>>': ('r', 249), 'class': ('r', 249), ']': ('r', 249), '^': ('r', 249), '==': ('r', 249), '[': ('r', 249), '.*': ('r', 249)}, 805),
        #STATE 806
        State([('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 80)], {'{': ('r', 412)}, 806),
        #STATE 807
        State([("try_block -> 'try' compound_statement:body handler!+:handlers", 52), ("try_block -> 'try' compound_statement:body handler!+:handlers", 43), ("handler -> 'catch' '(' exception_declaration:exc ')' compound_statement:body", 11)], {'union': ('r', 250), '::': ('r', 250), 'namespace': ('r', 250), 'export': ('r', 250), 'using': ('r', 250), 'virtual': ('r', 250), DECLARE_KEYWORD: ('r', 250), '}': ('r', 250), '~': ('r', 250), IDENTIFIER: ('r', 250), ';': ('r', 250), handler: ('g', 778), 'typedef': ('r', 250), 'operator': ('r', 250), 'extern': ('r', 250), TYPE_KEYWORD: ('r', 250), ACCESS_KEYWORD: ('r', 250), 'catch': ('s', 626), 'asm': ('r', 250), 'enum': ('r', 250), EOF: ('r', 250), 'class': ('r', 250), CPP_INCLUDE: ('r', 250), 'typename': ('r', 250), CPP_ERROR: ('r', 250), 'struct': ('r', 250), 'volatile': ('r', 250), 'template': ('r', 250), 'const': ('r', 250), 'auto': ('r', 250)}, 807),
        #STATE 808
        State([("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 59)], {'(': ('s', 936)}, 808),
        #STATE 809
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 242)], {',': ('r', 253), '-': ('r', 253), '.': ('r', 253), '/': ('r', 253), '(': ('r', 253), ')': ('r', 253), '*': ('r', 253), '+': ('r', 253), '%': ('r', 253), '&': ('r', 253), '<': ('r', 253), '=': ('r', 253), '>': ('r', 253), '?': ('r', 253), '<<': ('r', 253), ':': ('r', 253), ';': ('r', 253), '...': ('r', 253), '|=': ('r', 253), '^=': ('r', 253), '%=': ('r', 253), '!=': ('r', 253), '--': ('r', 253), '/=': ('r', 253), '++': ('r', 253), '^': ('r', 253), '<<=': ('r', 253), '->': ('r', 253), '-=': ('r', 253), '->*': ('r', 253), '+=': ('r', 253), '>=': ('r', 253), '<=': ('r', 253), '||': ('r', 253), '>>=': ('r', 253), '&&': ('r', 253), '|': ('r', 253), '}': ('r', 253), '&=': ('r', 253), '{': ('r', 253), 'try': ('r', 253), '>>': ('r', 253), ']': ('r', 253), '*=': ('r', 253), '==': ('r', 253), '[': ('r', 253), '.*': ('r', 253)}, 809),
        #STATE 810
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 49), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), multiplicative_expression: ('g', 871), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), qualified_id: ('g', 4), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), '::': ('s', 64), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), operator_function_id: ('g', 6), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38)}, 810),
        #STATE 811
        State([('type_name -> IDENTIFIER:name', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 51), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_id: ('g', 26), template_name: ('g', 2), IDENTIFIER: ('s', 24), type_name: ('g', 123)}, 811),
        #STATE 812
        State([("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 106)], {'-': ('r', 393), 'asm': ('r', 393), '(': ('r', 393), '*': ('r', 393), 'reinterpret_cast': ('r', 393), 'delete': ('r', 393), 'static_cast': ('r', 393), 'virtual': ('r', 393), DECLARE_KEYWORD: ('r', 393), IDENTIFIER: ('r', 393), 'while': ('r', 393), INTEGER_LITERAL: ('r', 393), 'extern': ('r', 393), 'default': ('r', 393), 'goto': ('r', 393), 'new': ('r', 393), 'class': ('r', 393), 'typedef': ('r', 393), '--': ('r', 393), '++': ('r', 393), 'dynamic_cast': ('r', 393), 'for': ('r', 393), 'continue': ('r', 393), '+': ('r', 393), 'struct': ('r', 393), 'volatile': ('r', 393), 'namespace': ('r', 393), '&': ('r', 393), 'if': ('r', 393), 'union': ('r', 393), 'const_cast': ('r', 393), '::': ('r', 393), 'auto': ('r', 393), 'using': ('r', 393), 'do': ('r', 393), 'this': ('r', 393), '}': ('r', 393), '~': ('r', 393), 'return': ('r', 393), '{': ('r', 393), 'case': ('r', 393), '!': ('r', 393), CHARACTER_LITERAL: ('r', 393), FLOATING_LITERAL: ('r', 393), 'sizeof': ('r', 393), 'else': ('r', 393), TYPE_KEYWORD: ('r', 393), 'try': ('r', 393), BOOLEAN_LITERAL: ('r', 393), 'enum': ('r', 393), STRING_LITERAL: ('r', 393), 'throw': ('r', 393), 'typename': ('r', 393), 'break': ('r', 393), 'operator': ('r', 393), CPP_ERROR: ('r', 393), 'const': ('r', 393), 'switch': ('r', 393), 'typeid': ('r', 393)}, 812),
        #STATE 813
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 106)], {',': ('r', 257), '-': ('r', 257), '.': ('r', 257), '/': ('r', 257), '(': ('r', 257), ')': ('r', 257), '*': ('r', 257), '+': ('r', 257), '%': ('r', 257), '&': ('r', 257), '<': ('r', 257), '=': ('r', 257), '>': ('r', 257), '?': ('r', 257), '<<': ('r', 257), ':': ('r', 257), ';': ('r', 257), '...': ('r', 257), '|=': ('r', 257), '^=': ('r', 257), '%=': ('r', 257), '!=': ('r', 257), '--': ('r', 257), '/=': ('r', 257), '==': ('r', 257), '^': ('r', 257), '<<=': ('r', 257), '->': ('r', 257), '-=': ('r', 257), '->*': ('r', 257), '+=': ('r', 257), '>=': ('r', 257), '<=': ('r', 257), '||': ('r', 257), '>>=': ('r', 257), '&&': ('r', 257), '|': ('r', 257), '}': ('r', 257), '&=': ('r', 257), '++': ('r', 257), '>>': ('r', 257), ']': ('r', 257), '*=': ('r', 257), '[': ('r', 257), '.*': ('r', 257)}, 813),
        #STATE 814
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('constant_expression -> conditional_expression!', 23), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ("member_declarator -> IDENTIFIER:name? ':' constant_expression:size", 42), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), '!': ('s', 104), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 774), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 310), class_name: ('g', 11), type_name: ('g', 98), literal: ('g', 84), 'dynamic_cast': ('s', 83), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), constant_expression: ('g', 747), 'const_cast': ('s', 92), qualified_id: ('g', 4), exclusive_or_expression: ('g', 121), nested_name_specifier: ('g', 95), new_expression: ('g', 94), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 814),
        #STATE 815
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 97), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55)], {'::': ('s', 275), ';': ('s', 725)}, 815),
        #STATE 816
        State([("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 42), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('raw_type_descriptor -> enum_specifier!', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('namespace_name -> IDENTIFIER:name', 18), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ('raw_type_descriptor -> named_type_specifier!', 23), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ('template_parameter -> parameter_declaration!', 22), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("class_key -> 'class' | 'struct' | 'union'", 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 27), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("type_parameter -> ('class'|'typename') IDENTIFIER:name? ( '=' type_id:default )?", 19), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("type_parameter -> 'template' '<' template_parameter!+,',':plist '>' 'class' IDENTIFIER:name? ( '=' id_expression:default )?", 18), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('parameter_declaration -> type_descriptor:type declarator:dtor', 25), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 53), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('template_parameter -> type_parameter!', 22), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), IDENTIFIER: ('s', 29), _80: ('g', 112), 'union': ('s', 97), nested_name_specifier: ('g', 189), parameter_declaration: ('g', 196), type_name: ('g', 98), type_descriptor: ('g', 193), elaborated_type_specifier: ('g', 109), '>': ('s', 817), enum_specifier: ('g', 122), 'template': ('s', 201), template_name: ('g', 2), _123: ('g', 717), class_name: ('g', 11), '::': ('s', 191), cv_qualifier: ('g', 106), class_head: ('g', 20), type_parameter: ('g', 202), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), class_specifier: ('g', 75), 'class': ('s', 198), 'typename': ('s', 199), namespace_name: ('g', 5), template_parameter: ('g', 200), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), _81: ('g', 88), template_id: ('g', 18), 'auto': ('s', 90)}, 816),
        #STATE 817
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('named_namespace_definition -> original_namespace_definition!', 30), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ('namespace_definition -> unnamed_namespace_definition!', 24), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 25), ('declaration -> function_definition!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ('block_declaration -> using_declaration!', 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 32), ('type_name -> IDENTIFIER:name', 13), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 33), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ("explicit_instantiation -> 'template' declaration:decl", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> template_declaration!', 15), ('declaration -> CPP_INCLUDE!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> linkage_specification!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('type_name -> template_id!', 13), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_definition -> function_head:head function_try_block:tryb', 23), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 27), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("raw_type_descriptor -> 'auto'", 23), ('block_declaration -> asm_definition!', 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('block_declaration -> simple_declaration!', 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cv_qualifier -> 'const'!", 16), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('declaration -> CPP_ERROR!', 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('declaration -> namespace_definition!', 15), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_directive!', 21), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('declaration -> explicit_instantiation!', 15), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 46), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('namespace_definition -> named_namespace_definition!', 24), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> named_type_specifier!', 23), ('declaration -> block_declaration!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('declaration -> explicit_specialization!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), named_type_specifier: ('g', 126), 'union': ('s', 97), function_definition: ('g', 128), 'virtual': ('s', 130), explicit_specialization: ('g', 157), cd_id: ('g', 164), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), 'extern': ('s', 139), class_name: ('g', 11), using_directive: ('g', 137), class_specifier: ('g', 138), 'typedef': ('s', 136), namespace_definition: ('g', 140), CPP_INCLUDE: ('s', 129), named_namespace_definition: ('g', 142), _75: ('g', 152), 'asm': ('s', 125), original_namespace_definition: ('g', 144), explicit_instantiation: ('g', 146), _81: ('g', 88), type_name: ('g', 131), unnamed_namespace_definition: ('g', 145), 'export': ('s', 143), 'struct': ('s', 58), 'volatile': ('s', 33), 'namespace': ('s', 148), asm_definition: ('g', 149), function_head: ('g', 150), 'auto': ('s', 90), using_declaration: ('g', 127), _80: ('g', 112), '::': ('s', 153), namespace_name: ('g', 5), 'using': ('s', 154), nested_name_specifier: ('g', 155), linkage_specification: ('g', 156), _73: ('g', 133), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), namespace_alias_definition: ('g', 161), template_name: ('g', 2), class_head: ('g', 20), cv_qualifier: ('g', 106), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), cd_declarator: ('g', 163), simple_declaration: ('g', 167), 'enum': ('s', 117), declaration: ('g', 659), type_descriptor: ('g', 169), 'class': ('s', 115), block_declaration: ('g', 141), 'typename': ('s', 166), CPP_ERROR: ('s', 151), 'operator': ('s', 168), template_declaration: ('g', 165), 'template': ('s', 147), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 29)}, 817),
        #STATE 818
        State([("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 100), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97)], {',': ('r', 259), '(': ('c', [('s', 631), ('r', 259)]), '::': ('r', 259), '*': ('r', 259), '&': ('r', 259), 'operator': ('r', 259), '>': ('r', 259), ';': ('r', 259), '~': ('r', 259), IDENTIFIER: ('r', 259), '[': ('r', 259), ')': ('r', 259)}, 818),
        #STATE 819
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 71)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), nested_name_specifier: ('g', 944), class_name: ('g', 11), template_id: ('g', 44)}, 819),
        #STATE 820
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 89)], {'template': ('r', 496), '~': ('r', 496), IDENTIFIER: ('r', 496), '*': ('r', 496), 'operator': ('r', 496)}, 820),
        #STATE 821
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 192)], {',': ('r', 261), '-': ('r', 261), '.': ('r', 261), '/': ('r', 261), '(': ('r', 261), ')': ('r', 261), '*': ('r', 261), '+': ('r', 261), '%': ('r', 261), '&': ('r', 261), '<': ('r', 261), '=': ('r', 261), '>': ('r', 261), '?': ('r', 261), '<<': ('r', 261), ':': ('r', 261), ';': ('r', 261), '...': ('r', 261), '|=': ('r', 261), '^=': ('r', 261), '%=': ('r', 261), '!=': ('r', 261), '--': ('r', 261), '/=': ('r', 261), '++': ('r', 261), '^': ('r', 261), '<<=': ('r', 261), '->': ('r', 261), '-=': ('r', 261), '->*': ('r', 261), '+=': ('r', 261), '>=': ('r', 261), '<=': ('r', 261), '||': ('r', 261), '>>=': ('r', 261), '&&': ('r', 261), '|': ('r', 261), '}': ('r', 261), '&=': ('r', 261), '{': ('r', 261), 'try': ('r', 261), '>>': ('r', 261), ']': ('r', 261), '*=': ('r', 261), '==': ('r', 261), '[': ('r', 261), '.*': ('r', 261)}, 821),
        #STATE 822
        State([("member_declaration -> decl_attrib!*:attrs member_cd_declarator!+,',':dtor ';'", 62)], {',': ('r', 262), ';': ('r', 262)}, 822),
        #STATE 823
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 57)], {',': ('r', 263), '-': ('r', 263), '.': ('r', 263), '/': ('r', 263), '(': ('r', 263), ')': ('r', 263), '*': ('r', 263), '+': ('r', 263), '%': ('r', 263), '&': ('r', 263), '<': ('r', 263), '=': ('r', 263), '>': ('r', 263), '?': ('r', 263), '<<': ('r', 263), ':': ('r', 263), ';': ('r', 263), '...': ('r', 263), '|=': ('r', 263), '^=': ('r', 263), '%=': ('r', 263), '!=': ('r', 263), '--': ('r', 263), '/=': ('r', 263), '++': ('r', 263), '^': ('r', 263), '<<=': ('r', 263), '->': ('r', 263), '-=': ('r', 263), '->*': ('r', 263), '+=': ('r', 263), '>=': ('r', 263), '<=': ('r', 263), '||': ('r', 263), '>>=': ('r', 263), '&&': ('r', 263), '|': ('r', 263), '}': ('r', 263), '&=': ('r', 263), '{': ('r', 263), 'try': ('r', 263), '>>': ('r', 263), ']': ('r', 263), '*=': ('r', 263), '==': ('r', 263), '[': ('r', 263), '.*': ('r', 263)}, 823),
        #STATE 824
        State([('member_declarator -> declarator:d pure_specifier', 34), ('member_declarator -> declarator:d constant_initializer:init?', 31), ('member_declarator -> declarator:d constant_initializer:init?', 34), ("constant_initializer -> '=' constant_expression!", 24), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 68), ("pure_specifier -> '=' INTEGER_LITERAL:i", 18)], {',': ('r', 265), constant_initializer: ('g', 825), '=': ('s', 799), ':': ('r', 266), 'try': ('r', 266), ';': ('r', 265), '{': ('r', 266), pure_specifier: ('g', 566)}, 824),
        #STATE 825
        State([('member_declarator -> declarator:d constant_initializer:init?', 54)], {',': ('r', 479), ';': ('r', 479)}, 825),
        #STATE 826
        State([("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 92)], {',': ('r', 268), '=': ('r', 268), 'try': ('r', 268), ':': ('r', 268), '{': ('r', 268), ';': ('r', 268)}, 826),
        #STATE 827
        State([("try_block -> 'try' compound_statement:body handler!+:handlers", 43), ("try_block -> 'try' compound_statement:body handler!+:handlers", 43), ("handler -> 'catch' '(' exception_declaration:exc ')' compound_statement:body", 11), ("try_block -> 'try' compound_statement:body handler!+:handlers", 43)], {handler: ('g', 624), _128: ('g', 807), 'catch': ('s', 626)}, 827),
        #STATE 828
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ('statement -> iteration_statement!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> CPP_ERROR!', 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('statement -> labeled_statement!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('pm_expression -> cast_expression!', 17), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ('statement -> jump_statement!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("raw_type_descriptor -> 'auto'", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ('type_name -> template_id!', 13), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ('statement -> compound_statement!', 13), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unary_expression -> postfix_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 51), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 51), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('block_declaration -> asm_definition!', 21), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), '++': ('s', 55), pm_expression: ('g', 73), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), and_expression: ('g', 72), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), _80: ('g', 112), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), compound_statement: ('g', 339), logical_and_expression: ('g', 118), 'asm': ('s', 125), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), 'namespace': ('s', 170), expression: ('g', 335), 'union': ('s', 97), 'auto': ('s', 90), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), 'try': ('s', 334), DECLARE_KEYWORD: ('s', 160), selection_statement: ('g', 340), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), operator_function_id: ('g', 6), 'enum': ('s', 117), STRING_LITERAL: ('s', 113), block_declaration: ('g', 344), 'typename': ('s', 116), 'while': ('s', 349), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 1004), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), 'default': ('s', 330), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), asm_definition: ('g', 149), 'do': ('s', 355), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'case': ('s', 356), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), conversion_function_id: ('g', 357), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), declaration_statement: ('g', 343), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), nested_name_specifier: ('g', 352), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 828),
        #STATE 829
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 274)], {',': ('r', 270), '-': ('r', 270), '.': ('r', 270), '/': ('r', 270), '(': ('r', 270), ')': ('r', 270), '*': ('r', 270), '+': ('r', 270), '%': ('r', 270), '&': ('r', 270), '<': ('r', 270), '=': ('r', 270), '>': ('r', 270), '?': ('r', 270), '<<': ('r', 270), ':': ('r', 270), ';': ('r', 270), '...': ('r', 270), '|=': ('r', 270), '^=': ('r', 270), '%=': ('r', 270), '!=': ('r', 270), '--': ('r', 270), '/=': ('r', 270), '++': ('r', 270), '^': ('r', 270), '<<=': ('r', 270), '->': ('r', 270), '-=': ('r', 270), '->*': ('r', 270), '+=': ('r', 270), '>=': ('r', 270), '<=': ('r', 270), '||': ('r', 270), '>>=': ('r', 270), '&&': ('r', 270), '|': ('r', 270), '}': ('r', 270), '&=': ('r', 270), '{': ('r', 270), 'try': ('r', 270), '>>': ('r', 270), ']': ('r', 270), '*=': ('r', 270), '==': ('r', 270), '[': ('r', 270), '.*': ('r', 270)}, 829),
        #STATE 830
        State([("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 92)], {',': ('r', 271), 'union': ('r', 271), '(': ('r', 271), ')': ('r', 271), 'struct': ('r', 271), TYPE_KEYWORD: ('r', 271), 'enum': ('r', 271), 'typename': ('r', 271), 'class': ('r', 271), '=': ('r', 271), '>': ('r', 271), '[': ('r', 271), IDENTIFIER: ('r', 271), 'auto': ('r', 271), 'volatile': ('r', 271), '...': ('r', 271), 'const': ('r', 271), '::': ('r', 271)}, 830),
        #STATE 831
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ('postfix_expression -> primary_expression!', 22), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("unary_expression -> 'sizeof' unary_expression:v", 20), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("unary_expression -> '++' cast_expression:v", 20), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ('class_head -> class_key:t base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('id_expression -> qualified_id!', 17), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('equality_expression -> relational_expression!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('namespace_name -> IDENTIFIER:name', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('assignment_expression -> conditional_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('unqualified_id -> conversion_function_id!', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("cv_qualifier -> 'const'!", 16), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('condition -> expression!', 13), ('unary_expression -> postfix_expression!', 20), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 36), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("condition -> type_descriptor:type declarator:dtor '=' assignment_expression:v", 13), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('pm_expression -> cast_expression!', 17), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), template_name: ('g', 2), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), cv_qualifier: ('g', 106), additive_expression: ('g', 63), logical_and_expression: ('g', 118), shift_expression: ('g', 65), relational_expression: ('g', 67), condition: ('g', 976), INTEGER_LITERAL: ('s', 87), CHARACTER_LITERAL: ('s', 108), equality_expression: ('g', 70), 'static_cast': ('s', 71), delete_expression: ('g', 119), class_name: ('g', 11), pm_expression: ('g', 73), 'new': ('s', 74), throw_expression: ('g', 91), id_expression: ('g', 114), inclusive_or_expression: ('g', 76), literal: ('g', 84), elaborated_type_specifier: ('g', 109), class_key: ('g', 78), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), conditional_expression: ('g', 77), assignment_expression: ('g', 85), 'struct': ('s', 58), simple_type_specifier: ('g', 86), type_descriptor: ('g', 120), primary_expression: ('g', 40), enum_specifier: ('g', 122), _81: ('g', 88), expression: ('g', 89), 'auto': ('s', 90), unqualified_id: ('g', 7), 'const_cast': ('s', 92), '::': ('s', 64), class_specifier: ('g', 75), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), 'union': ('s', 97), type_name: ('g', 98), conversion_function_id: ('g', 12), '~': ('s', 100), 'volatile': ('s', 33), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), class_head: ('g', 20), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), postfix_expression: ('g', 99), 'reinterpret_cast': ('s', 110), BOOLEAN_LITERAL: ('s', 102), '--': ('s', 111), _80: ('g', 112), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 116), namespace_name: ('g', 5), 'enum': ('s', 117), operator_function_id: ('g', 6), exclusive_or_expression: ('g', 121), 'const': ('s', 35), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 831),
        #STATE 832
        State([("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 56)], {'(': ('r', 179)}, 832),
        #STATE 833
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 50), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 77), ('class_name -> template_id!', 14), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 815), nested_name_specifier: ('g', 731), class_name: ('g', 11), template_id: ('g', 44)}, 833),
        #STATE 834
        State([("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 44)], {',': ('r', 272), '}': ('r', 272)}, 834),
        #STATE 835
        State([('START -> translation_unit <EOF>', 26)], {EOF: ('a', None)}, 835),
        #STATE 836
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('constant_expression -> conditional_expression!', 23), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("enumerator_definition -> enumerator:name ('=' constant_expression:v)?", 46), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), '!': ('s', 104), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 774), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 310), class_name: ('g', 11), type_name: ('g', 98), literal: ('g', 84), 'dynamic_cast': ('s', 83), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), constant_expression: ('g', 400), 'const_cast': ('s', 92), qualified_id: ('g', 4), exclusive_or_expression: ('g', 121), nested_name_specifier: ('g', 95), new_expression: ('g', 94), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 836),
        #STATE 837
        State([("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53)], {'*': ('s', 732)}, 837),
        #STATE 838
        State([("member_declaration -> function_definition! ';'?", 46)], {'union': ('r', 274), '::': ('r', 274), 'export': ('r', 274), 'using': ('r', 274), 'virtual': ('r', 274), DECLARE_KEYWORD: ('r', 274), 'const': ('r', 274), '}': ('r', 274), '~': ('r', 274), IDENTIFIER: ('r', 274), 'operator': ('r', 274), 'typedef': ('r', 274), 'extern': ('r', 274), TYPE_KEYWORD: ('r', 274), ACCESS_KEYWORD: ('r', 274), 'enum': ('r', 274), 'class': ('r', 274), 'typename': ('r', 274), 'struct': ('r', 274), 'volatile': ('r', 274), 'template': ('r', 274), 'auto': ('r', 274)}, 838),
        #STATE 839
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 218)], {',': ('r', 275), '-': ('r', 275), '.': ('r', 275), '/': ('r', 275), '(': ('r', 275), ')': ('r', 275), '*': ('r', 275), '+': ('r', 275), '%': ('r', 275), '&': ('r', 275), '<': ('r', 275), '=': ('r', 275), '>': ('r', 275), '?': ('r', 275), '<<': ('r', 275), ':': ('r', 275), ';': ('r', 275), '...': ('r', 275), '|=': ('r', 275), '^=': ('r', 275), '%=': ('r', 275), '!=': ('r', 275), '--': ('r', 275), '/=': ('r', 275), '++': ('r', 275), '^': ('r', 275), '<<=': ('r', 275), '->': ('r', 275), '-=': ('r', 275), '->*': ('r', 275), '+=': ('r', 275), '>=': ('r', 275), '<=': ('r', 275), '||': ('r', 275), '>>=': ('r', 275), '&&': ('r', 275), '|': ('r', 275), '}': ('r', 275), '&=': ('r', 275), '{': ('r', 275), 'try': ('r', 275), '>>': ('r', 275), ']': ('r', 275), '*=': ('r', 275), '==': ('r', 275), '[': ('r', 275), '.*': ('r', 275)}, 839),
        #STATE 840
        State([("postfix_expression -> 'typeid' '(' type_id:t ')'", 48)], {',': ('r', 276), '-': ('r', 276), '.': ('r', 276), '/': ('r', 276), '|=': ('r', 276), ')': ('r', 276), '*': ('r', 276), '==': ('r', 276), '%': ('r', 276), '&': ('r', 276), '<': ('r', 276), '=': ('r', 276), '>': ('r', 276), '?': ('r', 276), '<<': ('r', 276), ':': ('r', 276), ';': ('r', 276), '...': ('r', 276), '(': ('r', 276), '^=': ('r', 276), '%=': ('r', 276), '!=': ('r', 276), '--': ('r', 276), '/=': ('r', 276), '++': ('r', 276), '*=': ('r', 276), '<<=': ('r', 276), '->': ('r', 276), '-=': ('r', 276), '->*': ('r', 276), '+=': ('r', 276), '>=': ('r', 276), '<=': ('r', 276), '||': ('r', 276), '>>=': ('r', 276), '&&': ('r', 276), '|': ('r', 276), '}': ('r', 276), '&=': ('r', 276), '>>': ('r', 276), '+': ('r', 276), ']': ('r', 276), '^': ('r', 276), '[': ('r', 276), '.*': ('r', 276)}, 840),
        #STATE 841
        State([("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 85)], {'}': ('s', 842)}, 841),
        #STATE 842
        State([("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 88)], {'union': ('r', 313), '::': ('r', 313), 'export': ('r', 313), 'using': ('r', 313), 'virtual': ('r', 313), DECLARE_KEYWORD: ('r', 313), 'const': ('r', 313), '}': ('r', 313), '~': ('r', 313), IDENTIFIER: ('r', 313), 'operator': ('r', 313), 'typedef': ('r', 313), 'extern': ('r', 313), TYPE_KEYWORD: ('r', 313), ACCESS_KEYWORD: ('r', 313), 'asm': ('r', 313), 'enum': ('r', 313), EOF: ('r', 313), 'class': ('r', 313), CPP_INCLUDE: ('r', 313), 'typename': ('r', 313), CPP_ERROR: ('r', 313), 'struct': ('r', 313), 'volatile': ('r', 313), 'template': ('r', 313), 'namespace': ('r', 313), 'auto': ('r', 313)}, 842),
        #STATE 843
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('named_namespace_definition -> original_namespace_definition!', 30), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ('namespace_definition -> unnamed_namespace_definition!', 24), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 25), ('declaration -> function_definition!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ('block_declaration -> using_declaration!', 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 32), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('type_name -> IDENTIFIER:name', 13), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 33), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('translation_unit -> declaration!*:decls', 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ("explicit_instantiation -> 'template' declaration:decl", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> template_declaration!', 15), ('declaration -> CPP_INCLUDE!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('translation_unit -> declaration!*:decls', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("decl_attrib -> 'virtual'!", 15), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> linkage_specification!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('type_name -> template_id!', 13), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_definition -> function_head:head function_try_block:tryb', 23), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 27), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("raw_type_descriptor -> 'auto'", 23), ('block_declaration -> asm_definition!', 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('block_declaration -> simple_declaration!', 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 48), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ("decl_attrib -> 'extern'!", 15), ('declaration -> CPP_ERROR!', 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ('declaration -> namespace_definition!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_directive!', 21), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('declaration -> explicit_instantiation!', 15), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), None, ('type_descriptor -> raw_type_descriptor!', 19), ('translation_unit -> declaration!*:decls', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('namespace_definition -> named_namespace_definition!', 24), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> named_type_specifier!', 23), ('declaration -> block_declaration!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('declaration -> explicit_specialization!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), named_type_specifier: ('g', 126), 'union': ('s', 97), function_definition: ('g', 128), 'virtual': ('s', 130), explicit_specialization: ('g', 157), cd_id: ('g', 164), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), 'struct': ('s', 58), 'extern': ('s', 139), class_name: ('g', 11), using_directive: ('g', 137), class_specifier: ('g', 138), 'typedef': ('s', 136), namespace_definition: ('g', 140), CPP_INCLUDE: ('s', 129), named_namespace_definition: ('g', 142), _75: ('g', 152), 'asm': ('s', 125), original_namespace_definition: ('g', 144), explicit_instantiation: ('g', 146), _81: ('g', 88), type_name: ('g', 131), unnamed_namespace_definition: ('g', 145), _1: ('g', 392), 'export': ('s', 143), namespace_body: ('g', 844), 'auto': ('s', 90), 'volatile': ('s', 33), type_descriptor: ('g', 169), namespace_alias_definition: ('g', 161), function_head: ('g', 150), simple_declaration: ('g', 167), using_declaration: ('g', 127), '::': ('s', 153), namespace_name: ('g', 5), 'using': ('s', 154), asm_definition: ('g', 149), linkage_specification: ('g', 156), _73: ('g', 133), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), 'namespace': ('s', 148), template_name: ('g', 2), class_head: ('g', 20), cv_qualifier: ('g', 106), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), '}': ('r', 278), cd_declarator: ('g', 163), _80: ('g', 112), declaration: ('g', 429), template_id: ('g', 18), 'class': ('s', 115), block_declaration: ('g', 141), 'typename': ('s', 166), CPP_ERROR: ('s', 151), 'operator': ('s', 168), template_declaration: ('g', 165), 'template': ('s', 147), nested_name_specifier: ('g', 155), 'enum': ('s', 117), class_key: ('g', 78), IDENTIFIER: ('s', 29)}, 843),
        #STATE 844
        State([("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 68)], {'}': ('s', 668)}, 844),
        #STATE 845
        State([('type_name -> IDENTIFIER:name', 13), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 68), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_id: ('g', 26), template_name: ('g', 2), IDENTIFIER: ('s', 24), type_name: ('g', 900)}, 845),
        #STATE 846
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 53), ('unqualified_id -> operator_function_id!', 18), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 64), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 64), ('template_name -> IDENTIFIER!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("operator_function_id -> 'operator' operator:op", 24), ('unqualified_id -> IDENTIFIER:id', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_name -> template_id!', 13), ("unqualified_id -> '~' class_name:name", 18), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 63), ('unqualified_id -> conversion_function_id!', 18), ('type_name -> IDENTIFIER:name', 13)], {operator_function_id: ('g', 6), template_name: ('g', 2), '~': ('s', 958), IDENTIFIER: ('s', 423), conversion_function_id: ('g', 12), unqualified_id: ('g', 425), 'template': ('s', 959), 'operator': ('s', 8), template_id: ('g', 26), type_name: ('g', 454)}, 846),
        #STATE 847
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 76)], {'::': ('s', 491)}, 847),
        #STATE 848
        State([("expression -> expression:a ',' assignment_expression:b", 27), ("jump_statement -> 'return' expression:v? ';'", 41)], {',': ('s', 272), ';': ('s', 849)}, 848),
        #STATE 849
        State([("jump_statement -> 'return' expression:v? ';'", 44)], {'-': ('r', 562), '++': ('r', 562), '(': ('r', 562), '*': ('r', 562), 'reinterpret_cast': ('r', 562), 'delete': ('r', 562), 'static_cast': ('r', 562), 'virtual': ('r', 562), DECLARE_KEYWORD: ('r', 562), IDENTIFIER: ('r', 562), 'while': ('r', 562), INTEGER_LITERAL: ('r', 562), 'extern': ('r', 562), 'default': ('r', 562), 'goto': ('r', 562), 'new': ('r', 562), 'class': ('r', 562), 'typedef': ('r', 562), '--': ('r', 562), 'asm': ('r', 562), 'dynamic_cast': ('r', 562), 'for': ('r', 562), 'continue': ('r', 562), '+': ('r', 562), 'auto': ('r', 562), 'volatile': ('r', 562), 'namespace': ('r', 562), '&': ('r', 562), 'if': ('r', 562), 'union': ('r', 562), 'const_cast': ('r', 562), '::': ('r', 562), FLOATING_LITERAL: ('r', 562), 'using': ('r', 562), 'do': ('r', 562), 'this': ('r', 562), 'try': ('r', 562), '~': ('r', 562), 'return': ('r', 562), '{': ('r', 562), 'case': ('r', 562), '!': ('r', 562), TYPE_KEYWORD: ('r', 562), 'struct': ('r', 562), 'sizeof': ('r', 562), 'else': ('r', 562), CHARACTER_LITERAL: ('r', 562), '}': ('r', 562), BOOLEAN_LITERAL: ('r', 562), 'enum': ('r', 562), STRING_LITERAL: ('r', 562), 'throw': ('r', 562), 'typename': ('r', 562), 'break': ('r', 562), 'operator': ('r', 562), CPP_ERROR: ('r', 562), 'const': ('r', 562), 'switch': ('r', 562), 'typeid': ('r', 562)}, 849),
        #STATE 850
        State([("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 94)], {'union': ('r', 518), '::': ('r', 518), 'export': ('r', 518), 'using': ('r', 518), 'virtual': ('r', 518), DECLARE_KEYWORD: ('r', 518), '}': ('r', 518), '~': ('r', 518), IDENTIFIER: ('r', 518), 'operator': ('r', 518), 'typedef': ('r', 518), 'extern': ('r', 518), TYPE_KEYWORD: ('r', 518), ACCESS_KEYWORD: ('r', 518), 'enum': ('r', 518), 'class': ('r', 518), 'typename': ('r', 518), 'struct': ('r', 518), 'volatile': ('r', 518), 'template': ('r', 518), 'const': ('r', 518), 'auto': ('r', 518)}, 850),
        #STATE 851
        State([("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 69), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 68)], {'throw': ('s', 31), ',': ('r', 331), 'try': ('r', 331), '=': ('r', 331), exception_specification: ('g', 826), ':': ('r', 331), '{': ('r', 331), ';': ('r', 331)}, 851),
        #STATE 852
        State([("pm_expression -> pm_expression:a '->*' cast_expression:b", 33), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 74), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 33)], {',': ('r', 280), '-': ('r', 280), '/': ('r', 280), '|=': ('r', 280), ')': ('r', 280), '*': ('r', 280), '==': ('r', 280), '%': ('r', 280), '&': ('r', 280), '>>=': ('r', 280), '&&': ('r', 280), '<': ('r', 280), '=': ('r', 280), '>': ('r', 280), '?': ('r', 280), '<<': ('r', 280), ':': ('r', 280), ';': ('r', 280), '...': ('r', 280), '<=': ('r', 280), '^=': ('r', 280), '%=': ('r', 280), '|': ('r', 280), '!=': ('r', 280), '}': ('r', 280), '/=': ('r', 280), '+': ('r', 280), '||': ('r', 280), '*=': ('r', 280), '&=': ('r', 280), '+=': ('r', 280), ']': ('r', 280), '^': ('r', 280), '<<=': ('r', 280), '-=': ('r', 280), '.*': ('s', 740), '->*': ('s', 741), '>>': ('r', 280), '>=': ('r', 280)}, 852),
        #STATE 853
        State([("operator_function_id -> 'operator' operator:op", 43)], {',': ('r', 282), '-': ('r', 282), '.': ('r', 282), '/': ('r', 282), '(': ('r', 282), ')': ('r', 282), '*': ('r', 282), '+': ('r', 282), '%': ('r', 282), '&': ('r', 282), '<': ('r', 282), '=': ('r', 282), '>': ('r', 282), '?': ('r', 282), '<<': ('r', 282), ':': ('r', 282), ';': ('r', 282), '...': ('r', 282), '|=': ('r', 282), '^=': ('r', 282), '%=': ('r', 282), '!=': ('r', 282), '--': ('r', 282), '/=': ('r', 282), '++': ('r', 282), '^': ('r', 282), '<<=': ('r', 282), '->': ('r', 282), '-=': ('r', 282), '->*': ('r', 282), '+=': ('r', 282), '>=': ('r', 282), '<=': ('r', 282), '||': ('r', 282), '>>=': ('r', 282), '&&': ('r', 282), '|': ('r', 282), '}': ('r', 282), '&=': ('r', 282), '{': ('r', 282), 'try': ('r', 282), '>>': ('r', 282), ']': ('r', 282), '*=': ('r', 282), '==': ('r', 282), '[': ('r', 282), '.*': ('r', 282)}, 853),
        #STATE 854
        State([('type_name -> IDENTIFIER:name', 13), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 97), ('type_name -> template_id!', 13)], {template_id: ('g', 26), template_name: ('g', 2), IDENTIFIER: ('s', 24), type_name: ('g', 813)}, 854),
        #STATE 855
        State([("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 84)], {',': ('r', 283), '-': ('r', 283), '.': ('r', 283), '/': ('r', 283), '|=': ('r', 283), ')': ('r', 283), '*': ('r', 283), '+': ('r', 283), '%': ('r', 283), '&': ('r', 283), '{': ('r', 283), '<': ('r', 283), '=': ('r', 283), '>': ('r', 283), '?': ('r', 283), IDENTIFIER: ('r', 283), ':': ('r', 283), ';': ('r', 283), '...': ('r', 283), '(': ('r', 283), '^=': ('r', 283), '::': ('r', 283), '!=': ('r', 283), '--': ('r', 283), '/=': ('r', 283), '++': ('r', 283), '^': ('r', 283), '<<=': ('r', 283), '->': ('r', 283), 'auto': ('r', 283), '-=': ('r', 283), '%=': ('r', 283), '+=': ('r', 283), '>=': ('r', 283), 'union': ('r', 283), '<=': ('r', 283), '<<': ('r', 283), '||': ('r', 283), '>>=': ('r', 283), '&&': ('r', 283), 'const': ('r', 283), '|': ('r', 283), '}': ('r', 283), '~': ('r', 283), 'volatile': ('r', 283), '&=': ('r', 283), 'operator': ('r', 283), 'struct': ('r', 283), '->*': ('r', 283), TYPE_KEYWORD: ('r', 283), 'try': ('r', 283), 'enum': ('r', 283), '>>': ('r', 283), 'class': ('r', 283), ']': ('r', 283), 'typename': ('r', 283), '==': ('r', 283), '*=': ('r', 283), '[': ('r', 283), '.*': ('r', 283)}, 855),
        #STATE 856
        State([("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 53)], {'(': ('s', 857)}, 856),
        #STATE 857
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 57), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), expression: ('g', 1045), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), type_name: ('g', 98), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 857),
        #STATE 858
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 137)], {',': ('r', 460), '-': ('r', 460), '.': ('r', 460), '/': ('r', 460), '(': ('r', 460), ')': ('r', 460), '*': ('r', 460), '+': ('r', 460), '%': ('r', 460), '&': ('r', 460), '<': ('r', 460), '=': ('r', 460), '>': ('r', 460), '?': ('r', 460), '<<': ('r', 460), ':': ('r', 460), ';': ('r', 460), '...': ('r', 460), '|=': ('r', 460), '^=': ('r', 460), '%=': ('r', 460), '!=': ('r', 460), '--': ('r', 460), '/=': ('r', 460), '==': ('r', 460), '*=': ('r', 460), '<<=': ('r', 460), '->': ('r', 460), '-=': ('r', 460), '->*': ('r', 460), '>>': ('r', 460), '>=': ('r', 460), '<=': ('r', 460), '||': ('r', 460), '>>=': ('r', 460), '&&': ('r', 460), '|': ('r', 460), '}': ('r', 460), '&=': ('r', 460), '++': ('r', 460), '+=': ('r', 460), ']': ('r', 460), '^': ('r', 460), '[': ('r', 460), '.*': ('r', 460)}, 858),
        #STATE 859
        State([("expression -> expression:a ',' assignment_expression:b", 27), ("postfix_expression -> 'typeid' '(' expression:v ')'", 48)], {',': ('s', 272), ')': ('s', 860)}, 859),
        #STATE 860
        State([("postfix_expression -> 'typeid' '(' expression:v ')'", 51)], {',': ('r', 351), '-': ('r', 351), '.': ('r', 351), '/': ('r', 351), '(': ('r', 351), ')': ('r', 351), '*': ('r', 351), '==': ('r', 351), '%': ('r', 351), '&': ('r', 351), '<': ('r', 351), '=': ('r', 351), '>': ('r', 351), '?': ('r', 351), '<<': ('r', 351), ':': ('r', 351), ';': ('r', 351), '...': ('r', 351), '|=': ('r', 351), '^=': ('r', 351), '%=': ('r', 351), '!=': ('r', 351), '--': ('r', 351), '/=': ('r', 351), '++': ('r', 351), '*=': ('r', 351), '<<=': ('r', 351), '->': ('r', 351), '-=': ('r', 351), '->*': ('r', 351), '>>': ('r', 351), '>=': ('r', 351), '<=': ('r', 351), '||': ('r', 351), '>>=': ('r', 351), '&&': ('r', 351), '|': ('r', 351), '}': ('r', 351), '&=': ('r', 351), '+=': ('r', 351), '+': ('r', 351), ']': ('r', 351), '^': ('r', 351), '[': ('r', 351), '.*': ('r', 351)}, 860),
        #STATE 861
        State([("postfix_expression -> 'typeid' '(' type_id:t ')'", 45)], {')': ('s', 840)}, 861),
        #STATE 862
        State([("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 80)], {'union': ('r', 285), '::': ('r', 285), 'namespace': ('r', 285), 'export': ('r', 285), 'using': ('r', 285), 'virtual': ('r', 285), DECLARE_KEYWORD: ('r', 285), '}': ('r', 285), '~': ('r', 285), IDENTIFIER: ('r', 285), 'operator': ('r', 285), 'typedef': ('r', 285), 'extern': ('r', 285), TYPE_KEYWORD: ('r', 285), ACCESS_KEYWORD: ('r', 285), 'asm': ('r', 285), 'enum': ('r', 285), EOF: ('r', 285), 'class': ('r', 285), CPP_INCLUDE: ('r', 285), 'typename': ('r', 285), CPP_ERROR: ('r', 285), 'struct': ('r', 285), 'volatile': ('r', 285), 'template': ('r', 285), 'const': ('r', 285), 'auto': ('r', 285)}, 862),
        #STATE 863
        State([("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 93), None], {',': ('s', 864), ';': ('s', 865)}, 863),
        #STATE 864
        State([('unqualified_id -> conversion_function_id!', 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 64), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("member_declarator -> IDENTIFIER:name? ':' constant_expression:size", 38), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('declarator -> direct_declarator!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("member_declarator -> IDENTIFIER:name? ':' constant_expression:size", 21), ('direct_declarator -> declarator_id!', 21), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('declarator_id -> id_expression!', 17), ('id_expression -> unqualified_id!', 17), ('member_declarator -> declarator:d constant_initializer:init?', 21), ("qualified_id -> '::' IDENTIFIER!", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('id_expression -> qualified_id!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('unqualified_id -> operator_function_id!', 18), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("direct_declarator -> '(' declarator! ')'", 21), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('member_declarator -> declarator:d constant_initializer:init?', 21), ('class_name -> IDENTIFIER:name', 14), ("operator_function_id -> 'operator' operator:op", 24), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("ptr_operator -> '&'", 16), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("unqualified_id -> '~' class_name:name", 18), ('template_name -> IDENTIFIER!', 17), ('member_declarator -> declarator:d pure_specifier', 21)], {unqualified_id: ('g', 7), '(': ('s', 281), qualified_id: ('g', 4), '*': ('s', 223), template_name: ('g', 2), nested_name_specifier: ('g', 284), '&': ('s', 225), conversion_function_id: ('g', 12), '~': ('s', 45), IDENTIFIER: ('s', 473), ':': ('s', 814), 'operator': ('s', 8), direct_declarator: ('g', 285), class_name: ('g', 11), '::': ('s', 282), id_expression: ('g', 280), namespace_name: ('g', 5), declarator_id: ('g', 286), operator_function_id: ('g', 6), ptr_operator: ('g', 279), member_declarator: ('g', 956), template_id: ('g', 44), declarator: ('g', 925)}, 864),
        #STATE 865
        State([("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 96)], {'union': ('r', 438), '::': ('r', 438), 'export': ('r', 438), 'using': ('r', 438), 'virtual': ('r', 438), DECLARE_KEYWORD: ('r', 438), 'const': ('r', 438), '}': ('r', 438), '~': ('r', 438), IDENTIFIER: ('r', 438), 'operator': ('r', 438), 'extern': ('r', 438), 'typedef': ('r', 438), TYPE_KEYWORD: ('r', 438), ACCESS_KEYWORD: ('r', 438), 'enum': ('r', 438), 'class': ('r', 438), 'typename': ('r', 438), 'struct': ('r', 438), 'volatile': ('r', 438), 'template': ('r', 438), 'auto': ('r', 438)}, 865),
        #STATE 866
        State([("qualified_namespace_specifier -> '::'?:glbl nested_name_specifier:nns? namespace_name:name", 85)], {';': ('r', 501)}, 866),
        #STATE 867
        State([("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 86)], {'-': ('r', 288), '++': ('r', 288), '(': ('r', 288), '*': ('r', 288), '+': ('r', 288), 'delete': ('r', 288), 'static_cast': ('r', 288), 'virtual': ('r', 288), DECLARE_KEYWORD: ('r', 288), IDENTIFIER: ('r', 288), 'while': ('r', 288), INTEGER_LITERAL: ('r', 288), 'extern': ('r', 288), 'default': ('r', 288), 'goto': ('r', 288), 'new': ('r', 288), 'throw': ('r', 288), 'typedef': ('r', 288), '--': ('r', 288), 'asm': ('r', 288), 'dynamic_cast': ('r', 288), 'for': ('r', 288), 'continue': ('r', 288), 'struct': ('r', 288), 'volatile': ('r', 288), 'namespace': ('r', 288), '&': ('r', 288), 'if': ('r', 288), 'union': ('r', 288), 'const_cast': ('r', 288), '::': ('r', 288), 'auto': ('r', 288), 'using': ('r', 288), 'do': ('r', 288), 'this': ('r', 288), '}': ('r', 288), '~': ('r', 288), 'return': ('r', 288), '{': ('r', 288), 'case': ('r', 288), '!': ('r', 288), CHARACTER_LITERAL: ('r', 288), FLOATING_LITERAL: ('r', 288), 'sizeof': ('r', 288), 'else': ('r', 288), TYPE_KEYWORD: ('r', 288), 'try': ('r', 288), 'reinterpret_cast': ('r', 288), BOOLEAN_LITERAL: ('r', 288), 'enum': ('r', 288), STRING_LITERAL: ('r', 288), 'class': ('r', 288), 'typename': ('r', 288), 'break': ('r', 288), 'operator': ('r', 288), CPP_ERROR: ('r', 288), 'const': ('r', 288), 'switch': ('r', 288), 'typeid': ('r', 288)}, 867),
        #STATE 868
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 50)], {',': ('r', 290), '-': ('r', 290), '.': ('r', 290), '/': ('r', 290), '(': ('r', 290), ')': ('r', 290), '*': ('r', 290), '+': ('r', 290), '%': ('r', 290), '&': ('r', 290), '<': ('r', 290), '=': ('r', 290), '>': ('r', 290), '?': ('r', 290), '<<': ('r', 290), ':': ('r', 290), ';': ('r', 290), '...': ('r', 290), '|=': ('r', 290), '^=': ('r', 290), '%=': ('r', 290), '!=': ('r', 290), '--': ('r', 290), '/=': ('r', 290), '++': ('r', 290), '^': ('r', 290), '<<=': ('r', 290), '->': ('r', 290), '-=': ('r', 290), '->*': ('r', 290), '+=': ('r', 290), '>=': ('r', 290), '<=': ('r', 290), '||': ('r', 290), '>>=': ('r', 290), '&&': ('r', 290), '|': ('r', 290), '}': ('r', 290), '&=': ('r', 290), '{': ('r', 290), 'try': ('r', 290), '>>': ('r', 290), ']': ('r', 290), '*=': ('r', 290), '==': ('r', 290), '[': ('r', 290), '.*': ('r', 290)}, 868),
        #STATE 869
        State([("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 102)], {'-': ('r', 512), '++': ('r', 512), '(': ('r', 512), '*': ('r', 512), '+': ('r', 512), 'delete': ('r', 512), 'static_cast': ('r', 512), '{': ('r', 512), '!': ('r', 512), ACCESS_KEYWORD: ('r', 512), IDENTIFIER: ('r', 512), 'while': ('r', 512), INTEGER_LITERAL: ('r', 512), 'typedef': ('r', 512), 'default': ('r', 512), 'goto': ('r', 512), 'break': ('r', 512), 'new': ('r', 512), 'class': ('r', 512), 'extern': ('r', 512), '--': ('r', 512), 'asm': ('r', 512), 'dynamic_cast': ('r', 512), 'for': ('r', 512), 'export': ('r', 512), 'struct': ('r', 512), 'volatile': ('r', 512), 'template': ('r', 512), 'continue': ('r', 512), '&': ('r', 512), 'case': ('r', 512), 'if': ('r', 512), 'union': ('r', 512), 'virtual': ('r', 512), 'const_cast': ('r', 512), '::': ('r', 512), 'auto': ('r', 512), 'using': ('r', 512), 'namespace': ('r', 512), 'do': ('r', 512), DECLARE_KEYWORD: ('r', 512), '}': ('r', 512), '~': ('r', 512), 'return': ('r', 512), 'operator': ('r', 512), 'this': ('r', 512), TYPE_KEYWORD: ('r', 512), FLOATING_LITERAL: ('r', 512), 'sizeof': ('r', 512), 'else': ('r', 512), CHARACTER_LITERAL: ('r', 512), 'try': ('r', 512), 'reinterpret_cast': ('r', 512), BOOLEAN_LITERAL: ('r', 512), 'enum': ('r', 512), EOF: ('r', 512), STRING_LITERAL: ('r', 512), 'throw': ('r', 512), CPP_INCLUDE: ('r', 512), 'typename': ('r', 512), CPP_ERROR: ('r', 512), 'const': ('r', 512), 'switch': ('r', 512), 'typeid': ('r', 512)}, 869),
        #STATE 870
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 94)], {',': ('r', 292), '-': ('r', 292), '.': ('r', 292), '/': ('r', 292), '(': ('r', 292), ')': ('r', 292), '*': ('r', 292), '+': ('r', 292), '%': ('r', 292), '&': ('r', 292), '<': ('r', 292), '=': ('r', 292), '>': ('r', 292), '?': ('r', 292), '<<': ('r', 292), ':': ('r', 292), ';': ('r', 292), '...': ('r', 292), '|=': ('r', 292), '^=': ('r', 292), '%=': ('r', 292), '!=': ('r', 292), '--': ('r', 292), '/=': ('r', 292), '==': ('r', 292), '^': ('r', 292), '<<=': ('r', 292), '->': ('r', 292), '-=': ('r', 292), '->*': ('r', 292), '+=': ('r', 292), '>=': ('r', 292), '<=': ('r', 292), '||': ('r', 292), '>>=': ('r', 292), '&&': ('r', 292), '|': ('r', 292), '}': ('r', 292), '&=': ('r', 292), '++': ('r', 292), '>>': ('r', 292), ']': ('r', 292), '*=': ('r', 292), '[': ('r', 292), '.*': ('r', 292)}, 870),
        #STATE 871
        State([("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 57), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 74), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 57), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 57)], {',': ('r', 436), '-': ('r', 436), '/': ('s', 986), '|=': ('r', 436), ')': ('r', 436), '*': ('s', 987), '==': ('r', 436), '%': ('s', 968), '&': ('r', 436), '>>=': ('r', 436), '&&': ('r', 436), '<': ('r', 436), '=': ('r', 436), '>': ('r', 436), '?': ('r', 436), '<<': ('r', 436), ':': ('r', 436), ';': ('r', 436), '...': ('r', 436), '<=': ('r', 436), '^=': ('r', 436), '%=': ('r', 436), '|': ('r', 436), '!=': ('r', 436), '}': ('r', 436), '/=': ('r', 436), '+': ('r', 436), '||': ('r', 436), '*=': ('r', 436), '&=': ('r', 436), '+=': ('r', 436), ']': ('r', 436), '^': ('r', 436), '<<=': ('r', 436), '-=': ('r', 436), '>>': ('r', 436), '>=': ('r', 436)}, 871),
        #STATE 872
        State([("expression -> expression:a ',' assignment_expression:b", 27), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 93)], {',': ('s', 272), ')': ('s', 896)}, 872),
        #STATE 873
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ('statement -> iteration_statement!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("class_key -> 'class' | 'struct' | 'union'", 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('statement -> labeled_statement!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('block_declaration -> asm_definition!', 21), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ('statement -> compound_statement!', 13), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ('statement -> jump_statement!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('statement -> CPP_ERROR!', 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 97), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unary_expression -> postfix_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_name -> template_id!', 13), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), '++': ('s', 55), pm_expression: ('g', 73), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), 'struct': ('s', 58), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), and_expression: ('g', 72), _80: ('g', 112), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), logical_and_expression: ('g', 118), 'asm': ('s', 125), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), conversion_function_id: ('g', 357), 'namespace': ('s', 170), expression: ('g', 335), 'union': ('s', 97), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), compound_statement: ('g', 339), DECLARE_KEYWORD: ('s', 160), selection_statement: ('g', 340), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), operator_function_id: ('g', 6), 'enum': ('s', 117), STRING_LITERAL: ('s', 113), block_declaration: ('g', 344), 'typename': ('s', 116), 'while': ('s', 349), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 673), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), 'default': ('s', 330), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'auto': ('s', 90), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), asm_definition: ('g', 149), 'do': ('s', 355), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'case': ('s', 356), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), 'try': ('s', 334), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), declaration_statement: ('g', 343), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), nested_name_specifier: ('g', 352), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 873),
        #STATE 874
        State([('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 35)], {',': ('r', 551), '-': ('r', 551), '.': ('r', 551), '/': ('r', 551), '|=': ('r', 551), ')': ('r', 551), '*': ('r', 551), '+': ('r', 551), '%': ('r', 551), '&': ('r', 551), '{': ('r', 551), '%=': ('r', 551), '<': ('r', 551), '=': ('r', 551), '>': ('r', 551), '?': ('r', 551), IDENTIFIER: ('r', 551), ':': ('r', 551), ';': ('r', 551), '...': ('r', 551), '(': ('r', 551), '^=': ('r', 551), '::': ('r', 551), '!=': ('r', 551), '--': ('r', 551), '/=': ('r', 551), '++': ('r', 551), '^': ('r', 551), 'typename': ('r', 551), '<<=': ('r', 551), '->': ('r', 551), 'auto': ('r', 551), '-=': ('r', 551), '->*': ('r', 551), '+=': ('r', 551), '>=': ('r', 551), 'union': ('r', 551), '<=': ('r', 551), '<<': ('r', 551), '||': ('r', 551), '>>=': ('r', 551), '&&': ('r', 551), 'const': ('r', 551), '|': ('r', 551), '}': ('r', 551), '~': ('r', 551), 'volatile': ('r', 551), '&=': ('r', 551), 'operator': ('r', 551), 'struct': ('r', 551), TYPE_KEYWORD: ('r', 551), 'try': ('r', 551), 'enum': ('r', 551), '>>': ('r', 551), 'class': ('r', 551), ']': ('r', 551), '*=': ('r', 551), '==': ('r', 551), '[': ('r', 551), '.*': ('r', 551)}, 874),
        #STATE 875
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 209)], {',': ('r', 295), '-': ('r', 295), '.': ('r', 295), '/': ('r', 295), '(': ('r', 295), ')': ('r', 295), '*': ('r', 295), '+': ('r', 295), '%': ('r', 295), '&': ('r', 295), '<': ('r', 295), '=': ('r', 295), '>': ('r', 295), '?': ('r', 295), '<<': ('r', 295), ':': ('r', 295), ';': ('r', 295), '...': ('r', 295), '|=': ('r', 295), '^=': ('r', 295), '%=': ('r', 295), '!=': ('r', 295), '--': ('r', 295), '/=': ('r', 295), '++': ('r', 295), '^': ('r', 295), '<<=': ('r', 295), '->': ('r', 295), '-=': ('r', 295), '->*': ('r', 295), '+=': ('r', 295), '>=': ('r', 295), '<=': ('r', 295), '||': ('r', 295), '>>=': ('r', 295), '&&': ('r', 295), '|': ('r', 295), '}': ('r', 295), '&=': ('r', 295), '{': ('r', 295), 'try': ('r', 295), '>>': ('r', 295), ']': ('r', 295), '*=': ('r', 295), '==': ('r', 295), '[': ('r', 295), '.*': ('r', 295)}, 875),
        #STATE 876
        State([("unary_expression -> 'sizeof' unary_expression:v", 45)], {',': ('r', 297), '-': ('r', 297), '/': ('r', 297), '|=': ('r', 297), ')': ('r', 297), '*': ('r', 297), '==': ('r', 297), '%': ('r', 297), '&': ('r', 297), '>>=': ('r', 297), '&&': ('r', 297), '<': ('r', 297), '=': ('r', 297), '>': ('r', 297), '?': ('r', 297), '<<': ('r', 297), ':': ('r', 297), ';': ('r', 297), '...': ('r', 297), '<=': ('r', 297), '^=': ('r', 297), '%=': ('r', 297), '|': ('r', 297), '!=': ('r', 297), '}': ('r', 297), '/=': ('r', 297), '+': ('r', 297), '||': ('r', 297), '^': ('r', 297), '&=': ('r', 297), '+=': ('r', 297), ']': ('r', 297), '*=': ('r', 297), '<<=': ('r', 297), '-=': ('r', 297), '.*': ('r', 297), '->*': ('r', 297), '>>': ('r', 297), '>=': ('r', 297)}, 876),
        #STATE 877
        State([("equality_expression -> equality_expression:a '==' relational_expression:b", 45), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 45), ("and_expression -> and_expression:a '&' equality_expression:b", 58)], {',': ('r', 539), '|=': ('r', 539), ')': ('r', 539), '==': ('s', 269), '&': ('r', 539), '>>=': ('r', 539), '&&': ('r', 539), '|': ('r', 539), '=': ('r', 539), '>': ('r', 539), '?': ('r', 539), '&=': ('r', 539), ':': ('r', 539), ';': ('r', 539), '...': ('r', 539), '^=': ('r', 539), '||': ('r', 539), '!=': ('s', 268), '}': ('r', 539), '/=': ('r', 539), '^': ('r', 539), ']': ('r', 539), '*=': ('r', 539), '<<=': ('r', 539), '-=': ('r', 539), '%=': ('r', 539), '+=': ('r', 539)}, 877),
        #STATE 878
        State([("cast_expression -> '(' type_id:t ')' cast_expression:v", 33)], {')': ('s', 1041)}, 878),
        #STATE 879
        State([("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 87)], {',': ('r', 298), '-': ('r', 298), '.': ('r', 298), '/': ('r', 298), '|=': ('r', 298), ')': ('r', 298), '*': ('r', 298), '+': ('r', 298), '%': ('r', 298), '&': ('r', 298), '{': ('r', 298), '<': ('r', 298), '=': ('r', 298), '>': ('r', 298), '?': ('r', 298), IDENTIFIER: ('r', 298), ':': ('r', 298), ';': ('r', 298), '...': ('r', 298), '(': ('r', 298), '^=': ('r', 298), '::': ('r', 298), '!=': ('r', 298), '--': ('r', 298), '/=': ('r', 298), '++': ('r', 298), '^': ('r', 298), '<<=': ('r', 298), '->': ('r', 298), 'auto': ('r', 298), '-=': ('r', 298), '%=': ('r', 298), '+=': ('r', 298), '>=': ('r', 298), 'union': ('r', 298), '<=': ('r', 298), '<<': ('r', 298), '||': ('r', 298), '>>=': ('r', 298), '&&': ('r', 298), 'const': ('r', 298), '|': ('r', 298), '}': ('r', 298), '~': ('r', 298), 'volatile': ('r', 298), '&=': ('r', 298), 'operator': ('r', 298), 'struct': ('r', 298), '->*': ('r', 298), TYPE_KEYWORD: ('r', 298), 'try': ('r', 298), 'enum': ('r', 298), '>>': ('r', 298), 'class': ('r', 298), ']': ('r', 298), 'typename': ('r', 298), '==': ('r', 298), '*=': ('r', 298), '[': ('r', 298), '.*': ('r', 298)}, 879),
        #STATE 880
        State([('member_cd_declarator -> cd_declarator:d pure_specifier', 40), ("pure_specifier -> '=' INTEGER_LITERAL:i", 18), ('member_cd_declarator -> cd_declarator', 37)], {',': ('r', 32), '=': ('s', 264), pure_specifier: ('g', 265), ';': ('r', 32)}, 880),
        #STATE 881
        State([("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 61)], {',': ('r', 308), 'union': ('r', 308), '(': ('r', 308), ')': ('r', 308), '[': ('r', 308), ';': ('r', 308), 'try': ('r', 308), '>': ('r', 308), IDENTIFIER: ('r', 308), ':': ('r', 308), '{': ('r', 308), '...': ('r', 308), '::': ('r', 308), 'struct': ('r', 308), TYPE_KEYWORD: ('r', 308), '=': ('r', 308), 'enum': ('r', 308), 'class': ('r', 308), 'typename': ('r', 308), 'auto': ('r', 308), 'volatile': ('r', 308), 'const': ('r', 308)}, 881),
        #STATE 882
        State([("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 67)], {',': ('r', 309), '}': ('r', 309)}, 882),
        #STATE 883
        State([('new_type_id -> type_descriptor:type new_declarator:dtor?', 50)], {',': ('r', 466), '-': ('r', 466), '/': ('r', 466), '(': ('r', 466), ')': ('r', 466), '*': ('r', 466), '+': ('r', 466), '%': ('r', 466), '&': ('r', 466), '>>=': ('r', 466), '&&': ('r', 466), '<': ('r', 466), '=': ('r', 466), '>': ('r', 466), '?': ('r', 466), '<=': ('r', 466), ':': ('r', 466), ';': ('r', 466), '...': ('r', 466), '|=': ('r', 466), '^=': ('r', 466), '%=': ('r', 466), '|': ('r', 466), '!=': ('r', 466), '}': ('r', 466), '/=': ('r', 466), '==': ('r', 466), '||': ('r', 466), '*=': ('r', 466), '&=': ('r', 466), '<<': ('r', 466), ']': ('r', 466), '^': ('r', 466), '<<=': ('r', 466), '>>': ('r', 466), '-=': ('r', 466), '.*': ('r', 466), '->*': ('r', 466), '+=': ('r', 466), '>=': ('r', 466)}, 883),
        #STATE 884
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_name -> template_id!', 14), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('new_declarator -> ptr_operator:op new_declarator:dtor?', 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_new_declarator -> direct_new_declarator:dtor? '[' expression:size ']'", 53), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('new_declarator -> ptr_operator:op new_declarator:dtor?', 18), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('new_declarator -> ptr_operator:op new_declarator:dtor?', 30), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('new_declarator -> direct_new_declarator!', 18), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('new_declarator -> ptr_operator:op new_declarator:dtor?', 34), ("direct_new_declarator -> direct_new_declarator:dtor? '[' expression:size ']'", 25), ("ptr_operator -> '&'", 16), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {',': ('r', 493), template_name: ('g', 2), '/': ('r', 493), '(': ('r', 493), ')': ('r', 493), '*': ('c', [('s', 223), ('r', 493)]), '-': ('r', 493), '%': ('r', 493), '&': ('c', [('s', 225), ('r', 493)]), '<': ('r', 493), '=': ('r', 493), '>': ('r', 493), '?': ('r', 493), '<<': ('r', 493), IDENTIFIER: ('s', 414), ':': ('r', 493), ';': ('r', 493), '...': ('r', 493), '|=': ('r', 493), class_name: ('g', 11), '^=': ('r', 493), '||': ('r', 493), namespace_name: ('g', 5), '!=': ('r', 493), ']': ('r', 493), '/=': ('r', 493), '+': ('r', 493), '*=': ('r', 493), '<<=': ('r', 493), '%=': ('r', 493), '-=': ('r', 493), '->*': ('r', 493), '+=': ('r', 493), '>=': ('r', 493), '<=': ('r', 493), '::': ('s', 435), nested_name_specifier: ('g', 437), '>>=': ('r', 493), '&&': ('r', 493), '|': ('r', 493), '}': ('r', 493), '&=': ('r', 493), ptr_operator: ('g', 884), new_declarator: ('g', 1013), '>>': ('r', 493), direct_new_declarator: ('g', 432), '^': ('r', 493), '==': ('r', 493), '[': ('s', 599), '.*': ('r', 493), template_id: ('g', 44)}, 884),
        #STATE 885
        State([("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 69)], {'(': ('r', 363)}, 885),
        #STATE 886
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('statement -> iteration_statement!', 13), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> CPP_ERROR!', 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('statement -> labeled_statement!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('block_declaration -> asm_definition!', 21), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ('statement -> compound_statement!', 13), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ('statement -> jump_statement!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 55), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unary_expression -> postfix_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_name -> template_id!', 13), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), '++': ('s', 55), _80: ('g', 112), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), and_expression: ('g', 72), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), pm_expression: ('g', 73), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), logical_and_expression: ('g', 118), 'asm': ('s', 125), logical_or_expression: ('g', 82), operator_function_id: ('g', 6), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), conversion_function_id: ('g', 357), 'namespace': ('s', 170), asm_definition: ('g', 149), expression: ('g', 335), STRING_LITERAL: ('s', 113), 'auto': ('s', 90), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), compound_statement: ('g', 339), DECLARE_KEYWORD: ('s', 160), selection_statement: ('g', 340), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), declaration_statement: ('g', 343), 'enum': ('s', 117), block_declaration: ('g', 344), 'typename': ('s', 116), 'while': ('s', 349), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 887), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), 'default': ('s', 330), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), nested_name_specifier: ('g', 352), 'union': ('s', 97), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'do': ('s', 355), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'case': ('s', 356), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), 'try': ('s', 334), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), class_key: ('g', 78), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 886),
        #STATE 887
        State([("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 64)], {'-': ('r', 320), '++': ('r', 320), '(': ('r', 320), '*': ('r', 320), '+': ('r', 320), 'delete': ('r', 320), 'static_cast': ('r', 320), 'virtual': ('r', 320), DECLARE_KEYWORD: ('r', 320), IDENTIFIER: ('r', 320), 'while': ('r', 320), INTEGER_LITERAL: ('r', 320), 'extern': ('r', 320), 'default': ('r', 320), 'goto': ('r', 320), 'break': ('r', 320), 'new': ('r', 320), 'class': ('r', 320), 'typedef': ('r', 320), '--': ('r', 320), 'asm': ('r', 320), 'dynamic_cast': ('r', 320), 'for': ('r', 320), 'continue': ('r', 320), 'struct': ('r', 320), 'volatile': ('r', 320), 'namespace': ('r', 320), '&': ('r', 320), 'if': ('r', 320), 'union': ('r', 320), 'const_cast': ('r', 320), '::': ('r', 320), 'auto': ('r', 320), 'using': ('r', 320), 'do': ('r', 320), 'case': ('r', 320), '}': ('r', 320), '~': ('r', 320), 'return': ('r', 320), '{': ('r', 320), 'this': ('r', 320), '!': ('r', 320), CHARACTER_LITERAL: ('r', 320), FLOATING_LITERAL: ('r', 320), 'sizeof': ('r', 320), 'else': ('r', 320), TYPE_KEYWORD: ('r', 320), 'try': ('r', 320), 'reinterpret_cast': ('r', 320), BOOLEAN_LITERAL: ('r', 320), 'enum': ('r', 320), STRING_LITERAL: ('r', 320), 'throw': ('r', 320), 'typename': ('r', 320), CPP_ERROR: ('r', 320), 'operator': ('r', 320), 'const': ('r', 320), 'switch': ('r', 320), 'typeid': ('r', 320)}, 887),
        #STATE 888
        State([("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 40)], {']': ('s', 889)}, 888),
        #STATE 889
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('namespace_name -> IDENTIFIER:name', 18), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 44), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> FLOATING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), operator_function_id: ('g', 6), delete_expression: ('g', 119), cast_expression: ('g', 684), 'typeid': ('s', 38)}, 889),
        #STATE 890
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('primary_expression -> id_expression!', 22), ("cv_qualifier -> 'volatile'!", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t base_clause:bases?', 14), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 33), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('raw_type_descriptor -> enum_specifier!', 23), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('raw_type_descriptor -> class_specifier!', 23), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('type_descriptor -> raw_type_descriptor!', 19), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("primary_expression -> '(' expression! ')'", 26), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ('class_head -> class_key:t base_clause:bases?', 14), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('raw_type_descriptor -> named_type_specifier!', 23), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("class_key -> 'class' | 'struct' | 'union'", 13), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), raw_type_descriptor: ('g', 54), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), cv_qualifier: ('g', 106), additive_expression: ('g', 63), elaborated_type_specifier: ('g', 109), cast_expression: ('g', 66), enum_specifier: ('g', 122), equality_expression: ('g', 70), CHARACTER_LITERAL: ('s', 108), INTEGER_LITERAL: ('s', 87), delete_expression: ('g', 119), relational_expression: ('g', 67), class_name: ('g', 11), pm_expression: ('g', 73), id_expression: ('g', 114), throw_expression: ('g', 91), shift_expression: ('g', 65), class_head: ('g', 20), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), 'struct': ('s', 58), simple_type_specifier: ('g', 86), type_descriptor: ('g', 240), primary_expression: ('g', 40), new_expression: ('g', 94), _81: ('g', 88), 'static_cast': ('s', 71), 'this': ('s', 103), 'auto': ('s', 90), unqualified_id: ('g', 7), 'const_cast': ('s', 92), '::': ('s', 64), class_specifier: ('g', 75), nested_name_specifier: ('g', 95), 'volatile': ('s', 33), 'throw': ('s', 96), 'union': ('s', 97), type_name: ('g', 98), conversion_function_id: ('g', 12), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'new': ('s', 74), '!': ('s', 104), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), postfix_expression: ('g', 99), 'reinterpret_cast': ('s', 110), BOOLEAN_LITERAL: ('s', 102), '--': ('s', 111), _80: ('g', 112), STRING_LITERAL: ('s', 113), expression: ('g', 271), '+': ('s', 80), type_id: ('g', 912), 'typename': ('s', 116), namespace_name: ('g', 5), 'enum': ('s', 117), operator_function_id: ('g', 6), class_key: ('g', 78), 'const': ('s', 35), exclusive_or_expression: ('g', 121), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 890),
        #STATE 891
        State([('function_definition -> function_head:head function_try_block:tryb', 60)], {'union': ('r', 316), '::': ('r', 316), 'namespace': ('r', 316), 'export': ('r', 316), 'using': ('r', 316), 'virtual': ('r', 316), DECLARE_KEYWORD: ('r', 316), '}': ('r', 316), '~': ('r', 316), IDENTIFIER: ('r', 316), ';': ('r', 316), 'typedef': ('r', 316), 'struct': ('r', 316), 'extern': ('r', 316), TYPE_KEYWORD: ('r', 316), ACCESS_KEYWORD: ('r', 316), 'asm': ('r', 316), 'enum': ('r', 316), EOF: ('r', 316), 'class': ('r', 316), CPP_INCLUDE: ('r', 316), 'typename': ('r', 316), CPP_ERROR: ('r', 316), 'operator': ('r', 316), 'volatile': ('r', 316), 'template': ('r', 316), 'const': ('r', 316), 'auto': ('r', 316)}, 891),
        #STATE 892
        State([("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 40)], {';': ('s', 1055)}, 892),
        #STATE 893
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 88)], {template_name: ('g', 2), class_name: ('g', 894), IDENTIFIER: ('s', 173), template_id: ('g', 44)}, 893),
        #STATE 894
        State([("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 98)], {',': ('r', 364), '{': ('r', 364)}, 894),
        #STATE 895
        State([("class_specifier -> class_head!! '{' member_specification!*:body '}'", 56)], {'union': ('r', 317), '::': ('r', 317), 'export': ('r', 317), 'using': ('r', 317), 'virtual': ('r', 317), DECLARE_KEYWORD: ('r', 317), 'const': ('r', 317), '}': ('r', 317), '~': ('r', 317), IDENTIFIER: ('r', 317), 'operator': ('r', 317), 'extern': ('r', 317), 'typedef': ('r', 317), TYPE_KEYWORD: ('r', 317), ACCESS_KEYWORD: ('r', 317), 'enum': ('r', 317), 'class': ('r', 317), 'typename': ('r', 317), 'struct': ('r', 317), 'volatile': ('r', 317), 'template': ('r', 317), 'auto': ('r', 317)}, 895),
        #STATE 896
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ('statement -> iteration_statement!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> CPP_ERROR!', 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('statement -> labeled_statement!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('block_declaration -> asm_definition!', 21), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ('statement -> compound_statement!', 13), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ('statement -> jump_statement!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 97), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unary_expression -> postfix_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_name -> template_id!', 13), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), '++': ('s', 55), pm_expression: ('g', 73), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), and_expression: ('g', 72), _80: ('g', 112), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), logical_and_expression: ('g', 118), 'asm': ('s', 125), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), conversion_function_id: ('g', 357), 'namespace': ('s', 170), expression: ('g', 335), STRING_LITERAL: ('s', 113), 'auto': ('s', 90), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), compound_statement: ('g', 339), DECLARE_KEYWORD: ('s', 160), selection_statement: ('g', 340), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), operator_function_id: ('g', 6), 'enum': ('s', 117), block_declaration: ('g', 344), 'typename': ('s', 116), 'while': ('s', 349), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 545), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), 'default': ('s', 330), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), asm_definition: ('g', 149), 'union': ('s', 97), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'do': ('s', 355), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'case': ('s', 356), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), 'try': ('s', 334), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), declaration_statement: ('g', 343), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), nested_name_specifier: ('g', 352), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 896),
        #STATE 897
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 53), ("operator_function_id -> 'operator' operator:op", 24), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ("unqualified_id -> '~' class_name:name", 18), ('unqualified_id -> conversion_function_id!', 18)], {operator_function_id: ('g', 6), template_name: ('g', 2), '~': ('s', 45), IDENTIFIER: ('s', 423), conversion_function_id: ('g', 12), unqualified_id: ('g', 425), 'template': ('s', 426), '*': ('s', 732), 'operator': ('s', 8), template_id: ('g', 26), type_name: ('g', 375)}, 897),
        #STATE 898
        State([("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 69)], {'(': ('r', 383)}, 898),
        #STATE 899
        State([None, ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 134)], {',': ('s', 304), ')': ('s', 760)}, 899),
        #STATE 900
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 77)], {',': ('r', 324), '-': ('r', 324), '.': ('r', 324), '/': ('r', 324), '(': ('r', 324), ')': ('r', 324), '*': ('r', 324), '+': ('r', 324), '%': ('r', 324), '&': ('r', 324), '<': ('r', 324), '=': ('r', 324), '>': ('r', 324), '?': ('r', 324), '<<': ('r', 324), ':': ('r', 324), ';': ('r', 324), '...': ('r', 324), '|=': ('r', 324), '^=': ('r', 324), '%=': ('r', 324), '!=': ('r', 324), '--': ('r', 324), '/=': ('r', 324), '==': ('r', 324), '*=': ('r', 324), '<<=': ('r', 324), '->': ('r', 324), '-=': ('r', 324), '->*': ('r', 324), '+=': ('r', 324), '>=': ('r', 324), '<=': ('r', 324), '||': ('r', 324), '>>=': ('r', 324), '&&': ('r', 324), '|': ('r', 324), '}': ('r', 324), '&=': ('r', 324), '++': ('r', 324), '>>': ('r', 324), ']': ('r', 324), '^': ('r', 324), '[': ('r', 324), '.*': ('r', 324)}, 900),
        #STATE 901
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 93)], {'~': ('s', 854)}, 901),
        #STATE 902
        State([("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 83)], {',': ('r', 326), '-': ('r', 326), '.': ('r', 326), '/': ('r', 326), '|=': ('r', 326), ')': ('r', 326), '*': ('r', 326), '+': ('r', 326), '%': ('r', 326), '&': ('r', 326), '{': ('r', 326), '<': ('r', 326), '=': ('r', 326), '>': ('r', 326), '?': ('r', 326), IDENTIFIER: ('r', 326), ':': ('r', 326), ';': ('r', 326), '...': ('r', 326), '(': ('r', 326), '^=': ('r', 326), '::': ('r', 326), '!=': ('r', 326), '--': ('r', 326), '/=': ('r', 326), '++': ('r', 326), '^': ('r', 326), '<<=': ('r', 326), '->': ('r', 326), 'auto': ('r', 326), '-=': ('r', 326), '%=': ('r', 326), '+=': ('r', 326), '>=': ('r', 326), 'union': ('r', 326), '<=': ('r', 326), '<<': ('r', 326), '||': ('r', 326), '>>=': ('r', 326), '&&': ('r', 326), 'const': ('r', 326), '|': ('r', 326), '}': ('r', 326), '~': ('r', 326), 'volatile': ('r', 326), '&=': ('r', 326), 'operator': ('r', 326), 'struct': ('r', 326), '->*': ('r', 326), TYPE_KEYWORD: ('r', 326), 'try': ('r', 326), 'enum': ('r', 326), '>>': ('r', 326), 'class': ('r', 326), ']': ('r', 326), 'typename': ('r', 326), '==': ('r', 326), '*=': ('r', 326), '[': ('r', 326), '.*': ('r', 326)}, 902),
        #STATE 903
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 70)], {',': ('r', 328), '-': ('r', 328), '.': ('r', 328), '/': ('r', 328), '|=': ('r', 328), ')': ('r', 328), '*': ('r', 328), '+': ('r', 328), '%': ('r', 328), '&': ('r', 328), 'operator': ('r', 328), '<': ('r', 328), '=': ('r', 328), '>': ('r', 328), '?': ('r', 328), '<<': ('r', 328), IDENTIFIER: ('r', 328), ':': ('r', 328), ';': ('r', 328), '...': ('r', 328), '(': ('r', 328), '^=': ('r', 328), '||': ('r', 328), '^': ('r', 328), '!=': ('r', 328), '--': ('r', 328), '/=': ('r', 328), '++': ('r', 328), '*=': ('r', 328), '<<=': ('r', 328), '->': ('r', 328), 'auto': ('r', 328), '-=': ('r', 328), '%=': ('r', 328), '+=': ('r', 328), '>=': ('r', 328), 'union': ('r', 328), '<=': ('r', 328), '::': ('r', 328), '>>=': ('r', 328), '&&': ('r', 328), '|': ('r', 328), '}': ('r', 328), '~': ('r', 328), 'volatile': ('r', 328), '&=': ('r', 328), '{': ('r', 328), '.*': ('r', 328), 'struct': ('r', 328), '->*': ('r', 328), TYPE_KEYWORD: ('r', 328), 'try': ('r', 328), 'enum': ('r', 328), '>>': ('r', 328), 'class': ('r', 328), ']': ('r', 328), 'typename': ('r', 328), '==': ('r', 328), '[': ('r', 328), 'const': ('r', 328)}, 903),
        #STATE 904
        State([('unqualified_id -> operator_function_id!', 18), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 74), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("operator_function_id -> 'operator' operator:op", 24), ('unqualified_id -> IDENTIFIER:id', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("unqualified_id -> '~' class_name:name", 18), ('unqualified_id -> conversion_function_id!', 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), '~': ('s', 45), IDENTIFIER: ('s', 596), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), unqualified_id: ('g', 735), 'operator': ('s', 8), template_id: ('g', 947)}, 904),
        #STATE 905
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 76)], {'::': ('s', 932)}, 905),
        #STATE 906
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 77)], {',': ('r', 329), '-': ('r', 329), '.': ('r', 329), '/': ('r', 329), '(': ('r', 329), ')': ('r', 329), '*': ('r', 329), '+': ('r', 329), '%': ('r', 329), '&': ('r', 329), '<': ('r', 329), '=': ('r', 329), '>': ('r', 329), '?': ('r', 329), '<<': ('r', 329), ':': ('r', 329), ';': ('r', 329), '...': ('r', 329), '|=': ('r', 329), '^=': ('r', 329), '%=': ('r', 329), '!=': ('r', 329), '--': ('r', 329), '/=': ('r', 329), '==': ('r', 329), '^': ('r', 329), '<<=': ('r', 329), '->': ('r', 329), '-=': ('r', 329), '->*': ('r', 329), '+=': ('r', 329), '>=': ('r', 329), '<=': ('r', 329), '||': ('r', 329), '>>=': ('r', 329), '&&': ('r', 329), '|': ('r', 329), '}': ('r', 329), '&=': ('r', 329), '++': ('r', 329), '>>': ('r', 329), ']': ('r', 329), '*=': ('r', 329), '[': ('r', 329), '.*': ('r', 329)}, 906),
        #STATE 907
        State([("qualified_namespace_specifier -> '::'?:glbl nested_name_specifier:nns? namespace_name:name", 71), ('namespace_name -> IDENTIFIER:name', 18)], {namespace_name: ('g', 646), IDENTIFIER: ('s', 209)}, 907),
        #STATE 908
        State([("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 93), None], {',': ('s', 864), ';': ('s', 909)}, 908),
        #STATE 909
        State([("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 96)], {'union': ('r', 554), '::': ('r', 554), 'export': ('r', 554), 'using': ('r', 554), 'virtual': ('r', 554), DECLARE_KEYWORD: ('r', 554), '}': ('r', 554), '~': ('r', 554), IDENTIFIER: ('r', 554), 'operator': ('r', 554), 'typedef': ('r', 554), 'extern': ('r', 554), TYPE_KEYWORD: ('r', 554), ACCESS_KEYWORD: ('r', 554), 'enum': ('r', 554), 'class': ('r', 554), 'typename': ('r', 554), 'struct': ('r', 554), 'volatile': ('r', 554), 'template': ('r', 554), 'const': ('r', 554), 'auto': ('r', 554)}, 909),
        #STATE 910
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ('postfix_expression -> primary_expression!', 22), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("class_key -> 'class' | 'struct' | 'union'", 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('unqualified_id -> IDENTIFIER:id', 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("unary_expression -> 'sizeof' unary_expression:v", 20), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("unary_expression -> '++' cast_expression:v", 20), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ('class_head -> class_key:t base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('id_expression -> qualified_id!', 17), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('equality_expression -> relational_expression!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 60), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('namespace_name -> IDENTIFIER:name', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ('assignment_expression -> conditional_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('unqualified_id -> conversion_function_id!', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("cv_qualifier -> 'const'!", 16), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ('unary_expression -> postfix_expression!', 20), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('raw_type_descriptor -> named_type_specifier!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 60), ('pm_expression -> cast_expression!', 17), ('additive_expression -> multiplicative_expression!', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), template_name: ('g', 2), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), cv_qualifier: ('g', 106), additive_expression: ('g', 63), shift_expression: ('g', 65), IDENTIFIER: ('s', 3), equality_expression: ('g', 70), CHARACTER_LITERAL: ('s', 108), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), delete_expression: ('g', 119), relational_expression: ('g', 67), class_name: ('g', 11), _80: ('g', 112), 'new': ('s', 74), class_specifier: ('g', 75), inclusive_or_expression: ('g', 76), literal: ('g', 84), elaborated_type_specifier: ('g', 109), class_key: ('g', 78), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), conditional_expression: ('g', 77), assignment_expression: ('g', 323), 'auto': ('s', 90), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), unqualified_id: ('g', 7), operator_function_id: ('g', 6), 'const_cast': ('s', 92), '::': ('s', 64), throw_expression: ('g', 91), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), 'typename': ('s', 116), 'union': ('s', 97), type_name: ('g', 98), conversion_function_id: ('g', 12), '~': ('s', 100), 'volatile': ('s', 33), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), class_head: ('g', 20), _15: ('g', 988), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), postfix_expression: ('g', 99), 'reinterpret_cast': ('s', 110), 'struct': ('s', 58), '--': ('s', 111), 'enum': ('s', 117), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), type_id: ('g', 480), pm_expression: ('g', 73), namespace_name: ('g', 5), logical_and_expression: ('g', 118), BOOLEAN_LITERAL: ('s', 102), exclusive_or_expression: ('g', 121), 'const': ('s', 35), type_descriptor: ('g', 240), 'typeid': ('s', 38), enum_specifier: ('g', 122)}, 910),
        #STATE 911
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 67), ("new_initializer -> '(' assignment_expression!*,','! ')'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 70), ("new_initializer -> '(' assignment_expression!*,','! ')'", 19)], {',': ('r', 538), '-': ('r', 538), '/': ('r', 538), '(': ('s', 300), ')': ('r', 538), '*': ('r', 538), '+': ('r', 538), '%': ('r', 538), '&': ('r', 538), '>>=': ('r', 538), '&&': ('r', 538), '>>': ('r', 538), '<': ('r', 538), '=': ('r', 538), '>': ('r', 538), '?': ('r', 538), '<=': ('r', 538), ':': ('r', 538), ';': ('r', 538), '...': ('r', 538), '|=': ('r', 538), '^=': ('r', 538), '%=': ('r', 538), '|': ('r', 538), '!=': ('r', 538), '}': ('r', 538), '/=': ('r', 538), '==': ('r', 538), '||': ('r', 538), '^': ('r', 538), '&=': ('r', 538), '<<': ('r', 538), ']': ('r', 538), '*=': ('r', 538), '<<=': ('r', 538), new_initializer: ('g', 213), '-=': ('r', 538), '.*': ('r', 538), '->*': ('r', 538), '+=': ('r', 538), '>=': ('r', 538)}, 911),
        #STATE 912
        State([("unary_expression -> 'sizeof' '(' type_id:t ')'", 43)], {')': ('s', 913)}, 912),
        #STATE 913
        State([("unary_expression -> 'sizeof' '(' type_id:t ')'", 46)], {',': ('r', 448), '-': ('r', 448), '/': ('r', 448), '|=': ('r', 448), ')': ('r', 448), '*': ('r', 448), '+': ('r', 448), '%': ('r', 448), '&': ('r', 448), '>>=': ('r', 448), '&&': ('r', 448), '<': ('r', 448), '=': ('r', 448), '>': ('r', 448), '?': ('r', 448), '<<': ('r', 448), ':': ('r', 448), ';': ('r', 448), '...': ('r', 448), '<=': ('r', 448), '^=': ('r', 448), '%=': ('r', 448), '|': ('r', 448), '!=': ('r', 448), '}': ('r', 448), '/=': ('r', 448), '==': ('r', 448), '||': ('r', 448), '*=': ('r', 448), '&=': ('r', 448), '+=': ('r', 448), ']': ('r', 448), '^': ('r', 448), '<<=': ('r', 448), '-=': ('r', 448), '.*': ('r', 448), '->*': ('r', 448), '>>': ('r', 448), '>=': ('r', 448)}, 913),
        #STATE 914
        State([("mem_initializer -> mem_initializer_id:id '(' assignment_expression!*,',':args ')'", 81)], {',': ('r', 332), '{': ('r', 332)}, 914),
        #STATE 915
        State([("postfix_expression -> postfix_expression:v '--'", 47)], {',': ('r', 333), '-': ('r', 333), '.': ('r', 333), '/': ('r', 333), '(': ('r', 333), ')': ('r', 333), '*': ('r', 333), '+': ('r', 333), '%': ('r', 333), '&': ('r', 333), '<': ('r', 333), '=': ('r', 333), '>': ('r', 333), '?': ('r', 333), '<<': ('r', 333), ':': ('r', 333), ';': ('r', 333), '...': ('r', 333), '|=': ('r', 333), '^=': ('r', 333), '%=': ('r', 333), '!=': ('r', 333), '--': ('r', 333), '/=': ('r', 333), '==': ('r', 333), '^': ('r', 333), '<<=': ('r', 333), '->': ('r', 333), '-=': ('r', 333), '->*': ('r', 333), '+=': ('r', 333), '>=': ('r', 333), '<=': ('r', 333), '||': ('r', 333), '>>=': ('r', 333), '&&': ('r', 333), '|': ('r', 333), '}': ('r', 333), '&=': ('r', 333), '++': ('r', 333), '>>': ('r', 333), ']': ('r', 333), '*=': ('r', 333), '[': ('r', 333), '.*': ('r', 333)}, 915),
        #STATE 916
        State([('template_name -> IDENTIFIER!', 27), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 87)], {',': ('r', 336), '-': ('r', 336), '.': ('r', 336), '/': ('r', 336), '|=': ('r', 336), ')': ('r', 336), '*': ('r', 336), '+': ('r', 336), '%': ('r', 336), '&': ('r', 336), 'operator': ('r', 336), '<': ('c', [('r', 2), ('r', 336)]), '=': ('r', 336), '>': ('r', 336), '?': ('r', 336), '<<': ('r', 336), IDENTIFIER: ('r', 336), ':': ('r', 336), ';': ('r', 336), '...': ('r', 336), '(': ('r', 336), '^=': ('r', 336), '||': ('r', 336), '^': ('r', 336), '!=': ('r', 336), '--': ('r', 336), '/=': ('r', 336), '++': ('r', 336), '*=': ('r', 336), '<<=': ('r', 336), '->': ('r', 336), 'auto': ('r', 336), '-=': ('r', 336), '%=': ('r', 336), '+=': ('r', 336), '>=': ('r', 336), 'union': ('r', 336), '<=': ('r', 336), '::': ('r', 336), '>>=': ('r', 336), '&&': ('r', 336), '|': ('r', 336), '}': ('r', 336), '~': ('r', 336), 'volatile': ('r', 336), '&=': ('r', 336), '{': ('r', 336), '.*': ('r', 336), 'struct': ('r', 336), '->*': ('r', 336), TYPE_KEYWORD: ('r', 336), 'try': ('r', 336), 'enum': ('r', 336), '>>': ('r', 336), 'class': ('r', 336), ']': ('r', 336), 'typename': ('r', 336), '==': ('r', 336), '[': ('r', 336), 'const': ('r', 336)}, 916),
        #STATE 917
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ('postfix_expression -> primary_expression!', 22), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("unary_expression -> 'sizeof' unary_expression:v", 20), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("unary_expression -> '++' cast_expression:v", 20), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ('class_head -> class_key:t base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('id_expression -> qualified_id!', 17), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('equality_expression -> relational_expression!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('namespace_name -> IDENTIFIER:name', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('assignment_expression -> conditional_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('unqualified_id -> conversion_function_id!', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("cv_qualifier -> 'const'!", 16), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('condition -> expression!', 13), ('unary_expression -> postfix_expression!', 20), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("condition -> type_descriptor:type declarator:dtor '=' assignment_expression:v", 13), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('pm_expression -> cast_expression!', 17), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), template_name: ('g', 2), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), cv_qualifier: ('g', 106), additive_expression: ('g', 63), logical_and_expression: ('g', 118), shift_expression: ('g', 65), relational_expression: ('g', 67), condition: ('g', 752), INTEGER_LITERAL: ('s', 87), CHARACTER_LITERAL: ('s', 108), equality_expression: ('g', 70), 'static_cast': ('s', 71), delete_expression: ('g', 119), class_name: ('g', 11), pm_expression: ('g', 73), 'new': ('s', 74), throw_expression: ('g', 91), id_expression: ('g', 114), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), elaborated_type_specifier: ('g', 109), class_key: ('g', 78), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), 'struct': ('s', 58), simple_type_specifier: ('g', 86), type_descriptor: ('g', 120), primary_expression: ('g', 40), enum_specifier: ('g', 122), _81: ('g', 88), expression: ('g', 89), 'auto': ('s', 90), unqualified_id: ('g', 7), 'const_cast': ('s', 92), '::': ('s', 64), class_specifier: ('g', 75), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), 'union': ('s', 97), type_name: ('g', 98), conversion_function_id: ('g', 12), '~': ('s', 100), 'volatile': ('s', 33), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), class_head: ('g', 20), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), postfix_expression: ('g', 99), 'reinterpret_cast': ('s', 110), BOOLEAN_LITERAL: ('s', 102), '--': ('s', 111), _80: ('g', 112), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 116), namespace_name: ('g', 5), 'enum': ('s', 117), operator_function_id: ('g', 6), exclusive_or_expression: ('g', 121), 'const': ('s', 35), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 917),
        #STATE 918
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 168)], {',': ('r', 337), '-': ('r', 337), '.': ('r', 337), '/': ('r', 337), '(': ('r', 337), ')': ('r', 337), '*': ('r', 337), '+': ('r', 337), '%': ('r', 337), '&': ('r', 337), '<': ('r', 337), '=': ('r', 337), '>': ('r', 337), '?': ('r', 337), '<<': ('r', 337), ':': ('r', 337), ';': ('r', 337), '...': ('r', 337), '|=': ('r', 337), '^=': ('r', 337), '%=': ('r', 337), '!=': ('r', 337), '--': ('r', 337), '/=': ('r', 337), '++': ('r', 337), '^': ('r', 337), '<<=': ('r', 337), '->': ('r', 337), '-=': ('r', 337), '->*': ('r', 337), '+=': ('r', 337), '>=': ('r', 337), '<=': ('r', 337), '||': ('r', 337), '>>=': ('r', 337), '&&': ('r', 337), '|': ('r', 337), '}': ('r', 337), '&=': ('r', 337), '{': ('r', 337), 'try': ('r', 337), '>>': ('r', 337), ']': ('r', 337), '*=': ('r', 337), '==': ('r', 337), '[': ('r', 337), '.*': ('r', 337)}, 918),
        #STATE 919
        State([("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 61)], {',': ('r', 338), 'union': ('r', 338), '(': ('r', 338), ')': ('r', 338), '{': ('r', 338), ';': ('r', 338), 'try': ('r', 338), '>': ('r', 338), 'volatile': ('r', 338), ':': ('r', 338), 'struct': ('r', 338), '...': ('r', 338), '::': ('r', 338), TYPE_KEYWORD: ('r', 338), '=': ('r', 338), 'enum': ('r', 338), 'class': ('r', 338), 'typename': ('r', 338), 'auto': ('r', 338), '[': ('r', 338), 'const': ('r', 338), IDENTIFIER: ('r', 338)}, 919),
        #STATE 920
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 90), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_id: ('g', 44), template_name: ('g', 2), IDENTIFIER: ('s', 173), class_name: ('g', 1031)}, 920),
        #STATE 921
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 100)], {',': ('r', 342), '::': ('s', 237), '{': ('r', 342)}, 921),
        #STATE 922
        State([("operator -> 'delete' '[' ']'", 28)], {',': ('r', 420), '-': ('r', 420), '.': ('r', 420), '/': ('r', 420), '(': ('r', 420), ')': ('r', 420), '*': ('r', 420), '+': ('r', 420), '%': ('r', 420), '&': ('r', 420), '<': ('r', 420), '=': ('r', 420), '>': ('r', 420), '?': ('r', 420), ':': ('r', 420), ';': ('r', 420), '...': ('r', 420), '|=': ('r', 420), '^=': ('r', 420), '%=': ('r', 420), '^': ('r', 420), '!=': ('r', 420), '--': ('r', 420), '/=': ('r', 420), '++': ('r', 420), '*=': ('r', 420), '<<=': ('r', 420), '->': ('r', 420), '-=': ('r', 420), '->*': ('r', 420), '+=': ('r', 420), '>=': ('r', 420), '<=': ('r', 420), '||': ('r', 420), '>>=': ('r', 420), '&&': ('r', 420), '|': ('r', 420), '}': ('r', 420), '&=': ('r', 420), '{': ('r', 420), 'try': ('r', 420), '>>': ('r', 420), ']': ('r', 420), '<<': ('r', 420), '==': ('r', 420), '[': ('r', 420), '.*': ('r', 420)}, 922),
        #STATE 923
        State([("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 126)], {',': ('r', 368), 'try': ('r', 368), '=': ('r', 368), '[': ('r', 368), '(': ('r', 368), ')': ('r', 368), ':': ('r', 368), ';': ('r', 368), '...': ('r', 368), '{': ('r', 368), '>': ('r', 368)}, 923),
        #STATE 924
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 77), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 89), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 77), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {'template': ('s', 701), template_name: ('g', 2), IDENTIFIER: ('s', 27), template_id: ('g', 712)}, 924),
        #STATE 925
        State([('member_declarator -> declarator:d constant_initializer:init?', 31), ("pure_specifier -> '=' INTEGER_LITERAL:i", 18), ('member_declarator -> declarator:d constant_initializer:init?', 34), ("constant_initializer -> '=' constant_expression!", 24), ('member_declarator -> declarator:d pure_specifier', 34)], {',': ('r', 265), constant_initializer: ('g', 825), ';': ('r', 265), pure_specifier: ('g', 566), '=': ('s', 799)}, 925),
        #STATE 926
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 85)], {',': ('r', 343), '-': ('r', 343), '/': ('r', 343), '|=': ('r', 343), ')': ('r', 343), '*': ('r', 343), '+': ('r', 343), '%': ('r', 343), '&': ('r', 343), '>>=': ('r', 343), '&&': ('r', 343), '<': ('r', 343), '=': ('r', 343), '>': ('r', 343), '?': ('r', 343), '<<': ('r', 343), ':': ('r', 343), ';': ('r', 343), '...': ('r', 343), '<=': ('r', 343), '^=': ('r', 343), '%=': ('r', 343), '|': ('r', 343), '!=': ('r', 343), '}': ('r', 343), '/=': ('r', 343), '==': ('r', 343), '||': ('r', 343), '^': ('r', 343), '&=': ('r', 343), '>>': ('r', 343), ']': ('r', 343), '*=': ('r', 343), '<<=': ('r', 343), '-=': ('r', 343), '.*': ('r', 343), '->*': ('r', 343), '+=': ('r', 343), '>=': ('r', 343)}, 926),
        #STATE 927
        State([("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 46), ("enumerator_definition -> enumerator:name ('=' constant_expression:v)?", 25), ('enumerator -> IDENTIFIER!', 14), ("enumerator_definition -> enumerator:name ('=' constant_expression:v)?", 25)], {enumerator_definition: ('g', 928), enumerator: ('g', 929), IDENTIFIER: ('s', 930)}, 927),
        #STATE 928
        State([("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 67)], {',': ('r', 524), '}': ('r', 524)}, 928),
        #STATE 929
        State([("enumerator_definition -> enumerator:name ('=' constant_expression:v)?", 35), ("enumerator_definition -> enumerator:name ('=' constant_expression:v)?", 42)], {',': ('r', 549), '=': ('s', 836), '}': ('r', 549)}, 929),
        #STATE 930
        State([('enumerator -> IDENTIFIER!', 24)], {',': ('r', 398), '=': ('r', 398), '}': ('r', 398)}, 930),
        #STATE 931
        State([("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 56), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 71)], {'~': ('r', 231), '(': ('c', [('r', 454), ('r', 231)]), '::': ('r', 231), '*': ('r', 231), ';': ('r', 231), ':': ('r', 231), '&': ('r', 231), 'operator': ('r', 231), IDENTIFIER: ('r', 231)}, 931),
        #STATE 932
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 81)], {'~': ('s', 41)}, 932),
        #STATE 933
        State([("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 55), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 50)], {',': ('r', 107), 'try': ('r', 164), '{': ('r', 164), ':': ('r', 164), ';': ('r', 107)}, 933),
        #STATE 934
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 89)], {',': ('r', 344), '-': ('r', 344), '/': ('r', 344), '|=': ('r', 344), ')': ('r', 344), '*': ('r', 344), '==': ('r', 344), '%': ('r', 344), '&': ('r', 344), '>>=': ('r', 344), '&&': ('r', 344), '<': ('r', 344), '=': ('r', 344), '>': ('r', 344), '?': ('r', 344), '<<': ('r', 344), ':': ('r', 344), ';': ('r', 344), '...': ('r', 344), '<=': ('r', 344), '^=': ('r', 344), '%=': ('r', 344), '|': ('r', 344), '!=': ('r', 344), '}': ('r', 344), '/=': ('r', 344), '+': ('r', 344), '||': ('r', 344), '*=': ('r', 344), '&=': ('r', 344), '+=': ('r', 344), ']': ('r', 344), '^': ('r', 344), '<<=': ('r', 344), '-=': ('r', 344), '.*': ('r', 344), '->*': ('r', 344), '>>': ('r', 344), '>=': ('r', 344)}, 934),
        #STATE 935
        State([("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 28)], {STRING_LITERAL: ('s', 978)}, 935),
        #STATE 936
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 63), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ("expression -> expression:a ',' assignment_expression:b", 14), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ('expression -> assignment_expression!', 14), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 85), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), expression: ('g', 937), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), id_expression: ('g', 114), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 936),
        #STATE 937
        State([("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 76), ("expression -> expression:a ',' assignment_expression:b", 27)], {',': ('s', 272), ')': ('s', 802)}, 937),
        #STATE 938
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 86), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 86), ('template_name -> IDENTIFIER!', 27), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 87)], {',': ('r', 336), '(': ('c', [('s', 777), ('r', 336)]), '::': ('r', 336), '*': ('r', 336), '&': ('r', 336), '[': ('r', 336), '>': ('r', 336), '<': ('r', 2), '~': ('r', 336), IDENTIFIER: ('r', 336), 'operator': ('r', 336), ';': ('r', 336), ')': ('r', 336)}, 938),
        #STATE 939
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 100)], {',': ('r', 111), '(': ('c', [('s', 321), ('r', 111)]), '::': ('r', 111), '*': ('r', 111), '&': ('r', 111), '[': ('r', 111), '>': ('r', 111), '~': ('r', 111), IDENTIFIER: ('r', 111), 'operator': ('r', 111), ';': ('r', 111), ')': ('r', 111)}, 939),
        #STATE 940
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 89), ('template_name -> IDENTIFIER!', 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82)], {template_name: ('g', 2), template_id: ('g', 1044), IDENTIFIER: ('s', 216)}, 940),
        #STATE 941
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 200)], {',': ('r', 347), '-': ('r', 347), '.': ('r', 347), '/': ('r', 347), '(': ('r', 347), ')': ('r', 347), '*': ('r', 347), '+': ('r', 347), '%': ('r', 347), '&': ('r', 347), '<': ('r', 347), '=': ('r', 347), '>': ('r', 347), '?': ('r', 347), '<<': ('r', 347), ':': ('r', 347), ';': ('r', 347), '...': ('r', 347), '|=': ('r', 347), '^=': ('r', 347), '%=': ('r', 347), '!=': ('r', 347), '--': ('r', 347), '/=': ('r', 347), '++': ('r', 347), '^': ('r', 347), '<<=': ('r', 347), '->': ('r', 347), '-=': ('r', 347), '->*': ('r', 347), '+=': ('r', 347), '>=': ('r', 347), '<=': ('r', 347), '||': ('r', 347), '>>=': ('r', 347), '&&': ('r', 347), '|': ('r', 347), '}': ('r', 347), '&=': ('r', 347), '{': ('r', 347), 'try': ('r', 347), '>>': ('r', 347), ']': ('r', 347), '*=': ('r', 347), '==': ('r', 347), '[': ('r', 347), '.*': ('r', 347)}, 941),
        #STATE 942
        State([None, ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 80)], {',': ('s', 927), '}': ('s', 943)}, 942),
        #STATE 943
        State([("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 83)], {',': ('r', 467), '-': ('r', 467), '.': ('r', 467), '/': ('r', 467), '|=': ('r', 467), ')': ('r', 467), '*': ('r', 467), '+': ('r', 467), '%': ('r', 467), '&': ('r', 467), 'operator': ('r', 467), '<': ('r', 467), '=': ('r', 467), '>': ('r', 467), '?': ('r', 467), IDENTIFIER: ('r', 467), ':': ('r', 467), ';': ('r', 467), '...': ('r', 467), '(': ('r', 467), '^=': ('r', 467), '||': ('r', 467), '^': ('r', 467), '!=': ('r', 467), '--': ('r', 467), '/=': ('r', 467), '++': ('r', 467), 'typename': ('r', 467), '<<=': ('r', 467), '->': ('r', 467), 'auto': ('r', 467), '-=': ('r', 467), '%=': ('r', 467), '+=': ('r', 467), '>=': ('r', 467), 'union': ('r', 467), '<=': ('r', 467), '::': ('r', 467), '>>=': ('r', 467), '&&': ('r', 467), '|': ('r', 467), '}': ('r', 467), '~': ('r', 467), 'volatile': ('r', 467), '&=': ('r', 467), '{': ('r', 467), '.*': ('r', 467), 'struct': ('r', 467), '->*': ('r', 467), TYPE_KEYWORD: ('r', 467), 'try': ('r', 467), 'enum': ('r', 467), '>>': ('r', 467), 'class': ('r', 467), ']': ('r', 467), '<<': ('r', 467), '==': ('r', 467), '*=': ('r', 467), '[': ('r', 467), 'const': ('r', 467)}, 943),
        #STATE 944
        State([("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 92)], {'template': ('r', 348), '~': ('r', 348), IDENTIFIER: ('r', 348), '*': ('r', 348), 'operator': ('r', 348)}, 944),
        #STATE 945
        State([("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 100), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 100), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 100), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 100)], {')': ('s', 946)}, 945),
        #STATE 946
        State([('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cv_qualifier -> 'const'!", 16), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 103), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 27), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 122)], {',': ('r', 511), 'union': ('r', 511), '(': ('r', 511), _80: ('g', 589), 'auto': ('r', 511), 'volatile': ('c', [('s', 33), ('r', 511)]), ')': ('r', 511), '=': ('r', 511), '>': ('r', 511), IDENTIFIER: ('r', 511), '...': ('r', 511), '::': ('r', 511), cv_qualifier: ('g', 106), exception_specification: ('g', 1058), TYPE_KEYWORD: ('r', 511), 'enum': ('r', 511), 'throw': ('s', 31), 'typename': ('r', 511), 'struct': ('r', 511), '[': ('r', 511), 'const': ('c', [('s', 35), ('r', 511)]), 'class': ('r', 511)}, 946),
        #STATE 947
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 88)], {'::': ('s', 901)}, 947),
        #STATE 948
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('new_type_id -> type_descriptor:type new_declarator:dtor?', 15), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 56), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('class_name -> IDENTIFIER:name', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 56), ('raw_type_descriptor -> named_type_specifier!', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 56), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('new_type_id -> type_descriptor:type new_declarator:dtor?', 15), ('type_descriptor -> raw_type_descriptor!', 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 56), ("class_key -> 'class' | 'struct' | 'union'", 23), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {template_name: ('g', 2), '(': ('s', 949), named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), template_id: ('g', 18), nested_name_specifier: ('g', 189), type_name: ('g', 98), 'union': ('s', 97), elaborated_type_specifier: ('g', 109), '::': ('s', 191), IDENTIFIER: ('s', 29), enum_specifier: ('g', 122), class_name: ('g', 11), _80: ('g', 112), cv_qualifier: ('g', 106), class_head: ('g', 20), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), class_specifier: ('g', 75), 'class': ('s', 115), 'typename': ('s', 166), namespace_name: ('g', 5), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), new_type_id: ('g', 950), _81: ('g', 88), type_descriptor: ('g', 764), 'auto': ('s', 90)}, 948),
        #STATE 949
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 60), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 60), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {template_name: ('g', 2), 'auto': ('s', 90), _80: ('g', 112), named_type_specifier: ('g', 126), raw_type_descriptor: ('g', 54), template_id: ('g', 18), nested_name_specifier: ('g', 189), type_name: ('g', 98), 'union': ('s', 97), elaborated_type_specifier: ('g', 109), IDENTIFIER: ('s', 29), class_specifier: ('g', 75), class_name: ('g', 11), '::': ('s', 191), cv_qualifier: ('g', 106), class_head: ('g', 20), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), _81: ('g', 88), 'class': ('s', 115), type_id: ('g', 386), 'typename': ('s', 166), namespace_name: ('g', 5), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), type_descriptor: ('g', 240), enum_specifier: ('g', 122)}, 949),
        #STATE 950
        State([("new_initializer -> '(' assignment_expression!*,','! ')'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 70), ("new_initializer -> '(' assignment_expression!*,','! ')'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 67)], {',': ('r', 514), '-': ('r', 514), '/': ('r', 514), '(': ('s', 300), ')': ('r', 514), '*': ('r', 514), '==': ('r', 514), '%': ('r', 514), '&': ('r', 514), '>>=': ('r', 514), '&&': ('r', 514), '>>': ('r', 514), '<': ('r', 514), '=': ('r', 514), '>': ('r', 514), '?': ('r', 514), '<=': ('r', 514), ':': ('r', 514), ';': ('r', 514), '...': ('r', 514), '|=': ('r', 514), '^=': ('r', 514), '%=': ('r', 514), '|': ('r', 514), '!=': ('r', 514), '}': ('r', 514), '/=': ('r', 514), '+': ('r', 514), '||': ('r', 514), '^': ('r', 514), '&=': ('r', 514), '<<': ('r', 514), ']': ('r', 514), '*=': ('r', 514), '<<=': ('r', 514), new_initializer: ('g', 295), '-=': ('r', 514), '.*': ('r', 514), '->*': ('r', 514), '+=': ('r', 514), '>=': ('r', 514)}, 950),
        #STATE 951
        State([("delete_expression -> '::'? 'delete' cast_expression:v", 51)], {',': ('r', 389), '-': ('r', 389), '/': ('r', 389), '|=': ('r', 389), ')': ('r', 389), '*': ('r', 389), '==': ('r', 389), '%': ('r', 389), '&': ('r', 389), '>>=': ('r', 389), '&&': ('r', 389), '<': ('r', 389), '=': ('r', 389), '>': ('r', 389), '?': ('r', 389), '<<': ('r', 389), ':': ('r', 389), ';': ('r', 389), '...': ('r', 389), '<=': ('r', 389), '^=': ('r', 389), '%=': ('r', 389), '|': ('r', 389), '!=': ('r', 389), '}': ('r', 389), '/=': ('r', 389), '+': ('r', 389), '||': ('r', 389), '*=': ('r', 389), '&=': ('r', 389), '>>': ('r', 389), ']': ('r', 389), '^': ('r', 389), '<<=': ('r', 389), '-=': ('r', 389), '.*': ('r', 389), '->*': ('r', 389), '+=': ('r', 389), '>=': ('r', 389)}, 951),
        #STATE 952
        State([('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 68), ('member_declarator -> declarator:d pure_specifier', 34), ('member_declarator -> declarator:d constant_initializer:init?', 31), ('member_declarator -> declarator:d constant_initializer:init?', 34), ("constant_initializer -> '=' constant_expression!", 24), ("pure_specifier -> '=' INTEGER_LITERAL:i", 18)], {',': ('r', 265), constant_initializer: ('g', 825), ';': ('r', 265), '=': ('s', 799), ':': ('r', 356), 'try': ('r', 356), '{': ('r', 356), pure_specifier: ('g', 566)}, 952),
        #STATE 953
        State([("postfix_expression -> postfix_expression:v '++'", 47)], {',': ('r', 358), '-': ('r', 358), '.': ('r', 358), '/': ('r', 358), '(': ('r', 358), ')': ('r', 358), '*': ('r', 358), '==': ('r', 358), '%': ('r', 358), '&': ('r', 358), '<': ('r', 358), '=': ('r', 358), '>': ('r', 358), '?': ('r', 358), '<<': ('r', 358), ':': ('r', 358), ';': ('r', 358), '...': ('r', 358), '|=': ('r', 358), '^=': ('r', 358), '%=': ('r', 358), '!=': ('r', 358), '--': ('r', 358), '/=': ('r', 358), '++': ('r', 358), '*=': ('r', 358), '<<=': ('r', 358), '->': ('r', 358), '-=': ('r', 358), '->*': ('r', 358), '>>': ('r', 358), '>=': ('r', 358), '<=': ('r', 358), '||': ('r', 358), '>>=': ('r', 358), '&&': ('r', 358), '|': ('r', 358), '}': ('r', 358), '&=': ('r', 358), '+=': ('r', 358), '+': ('r', 358), ']': ('r', 358), '^': ('r', 358), '[': ('r', 358), '.*': ('r', 358)}, 953),
        #STATE 954
        State([("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 81)], {',': ('r', 362), ';': ('r', 362)}, 954),
        #STATE 955
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('named_namespace_definition -> original_namespace_definition!', 30), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ('namespace_definition -> unnamed_namespace_definition!', 24), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 25), ('declaration -> function_definition!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ('block_declaration -> using_declaration!', 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 32), ('type_name -> IDENTIFIER:name', 13), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 33), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ("explicit_instantiation -> 'template' declaration:decl", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> template_declaration!', 15), ('declaration -> CPP_INCLUDE!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 88), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> linkage_specification!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('type_name -> template_id!', 13), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_definition -> function_head:head function_try_block:tryb', 23), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 27), ('declaration -> namespace_definition!', 15), ("raw_type_descriptor -> 'auto'", 23), ('block_declaration -> asm_definition!', 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('block_declaration -> simple_declaration!', 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cv_qualifier -> 'const'!", 16), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('declaration -> CPP_ERROR!', 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_directive!', 21), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('declaration -> explicit_instantiation!', 15), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('namespace_definition -> named_namespace_definition!', 24), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> named_type_specifier!', 23), ('declaration -> block_declaration!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('declaration -> explicit_specialization!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), named_type_specifier: ('g', 126), 'union': ('s', 97), function_definition: ('g', 128), 'virtual': ('s', 130), explicit_specialization: ('g', 157), declaration: ('g', 1050), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), 'extern': ('s', 139), class_name: ('g', 11), '::': ('s', 153), class_specifier: ('g', 138), 'typedef': ('s', 136), namespace_definition: ('g', 140), CPP_INCLUDE: ('s', 129), named_namespace_definition: ('g', 142), _75: ('g', 152), 'asm': ('s', 125), original_namespace_definition: ('g', 144), explicit_instantiation: ('g', 146), _81: ('g', 88), type_name: ('g', 131), unnamed_namespace_definition: ('g', 145), 'export': ('s', 143), 'struct': ('s', 58), 'volatile': ('s', 33), 'namespace': ('s', 148), asm_definition: ('g', 149), function_head: ('g', 150), 'auto': ('s', 90), using_declaration: ('g', 127), _80: ('g', 112), using_directive: ('g', 137), namespace_name: ('g', 5), 'using': ('s', 154), nested_name_specifier: ('g', 155), linkage_specification: ('g', 156), _73: ('g', 133), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), namespace_alias_definition: ('g', 161), template_name: ('g', 2), class_head: ('g', 20), cv_qualifier: ('g', 106), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), cd_declarator: ('g', 163), simple_declaration: ('g', 167), 'enum': ('s', 117), cd_id: ('g', 164), type_descriptor: ('g', 169), 'class': ('s', 115), block_declaration: ('g', 141), 'typename': ('s', 166), CPP_ERROR: ('s', 151), 'operator': ('s', 168), template_declaration: ('g', 165), 'template': ('s', 147), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 29)}, 955),
        #STATE 956
        State([("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 81)], {',': ('r', 435), ';': ('r', 435)}, 956),
        #STATE 957
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 53), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("operator_function_id -> 'operator' operator:op", 24), ('unqualified_id -> IDENTIFIER:id', 18), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 53), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unqualified_id -> '~' class_name:name", 18), ('unqualified_id -> conversion_function_id!', 18)], {unqualified_id: ('g', 425), '~': ('s', 45), IDENTIFIER: ('s', 314), '*': ('s', 732), conversion_function_id: ('g', 12), 'template': ('s', 312), operator_function_id: ('g', 6), 'operator': ('s', 8)}, 957),
        #STATE 958
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 68), ('template_name -> IDENTIFIER!', 17), ('type_name -> IDENTIFIER:name', 13), ('class_name -> template_id!', 14), ('class_name -> IDENTIFIER:name', 14), ('type_name -> template_id!', 13), ("unqualified_id -> '~' class_name:name", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {type_name: ('g', 906), template_name: ('g', 2), class_name: ('g', 289), template_id: ('g', 18), IDENTIFIER: ('s', 508)}, 958),
        #STATE 959
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 67), ("operator_function_id -> 'operator' operator:op", 24), ('template_name -> IDENTIFIER!', 17), ('unqualified_id -> operator_function_id!', 18), ('unqualified_id -> IDENTIFIER:id', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('unqualified_id -> conversion_function_id!', 18), ("unqualified_id -> '~' class_name:name", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 74)], {template_name: ('g', 2), '~': ('s', 45), IDENTIFIER: ('s', 596), conversion_function_id: ('g', 12), unqualified_id: ('g', 313), operator_function_id: ('g', 6), 'operator': ('s', 8), template_id: ('g', 979)}, 959),
        #STATE 960
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 152)], {',': ('r', 365), '-': ('r', 365), '.': ('r', 365), '/': ('r', 365), '(': ('r', 365), ')': ('r', 365), '*': ('r', 365), '+': ('r', 365), '%': ('r', 365), '&': ('r', 365), '<': ('r', 365), '=': ('r', 365), '>': ('r', 365), '?': ('r', 365), '<<': ('r', 365), ':': ('r', 365), ';': ('r', 365), '...': ('r', 365), '|=': ('r', 365), '^=': ('r', 365), '%=': ('r', 365), '!=': ('r', 365), '--': ('r', 365), '/=': ('r', 365), '++': ('r', 365), '^': ('r', 365), '<<=': ('r', 365), '->': ('r', 365), '-=': ('r', 365), '->*': ('r', 365), '+=': ('r', 365), '>=': ('r', 365), '<=': ('r', 365), '||': ('r', 365), '>>=': ('r', 365), '&&': ('r', 365), '|': ('r', 365), '}': ('r', 365), '&=': ('r', 365), '{': ('r', 365), 'try': ('r', 365), '>>': ('r', 365), ']': ('r', 365), '*=': ('r', 365), '==': ('r', 365), '[': ('r', 365), '.*': ('r', 365)}, 960),
        #STATE 961
        State([('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 80)], {'{': ('r', 372)}, 961),
        #STATE 962
        State([("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 97)], {',': ('r', 472), '...': ('r', 472), '>': ('r', 472), ')': ('r', 472)}, 962),
        #STATE 963
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 289)], {',': ('r', 373), '-': ('r', 373), '.': ('r', 373), '/': ('r', 373), '(': ('r', 373), ')': ('r', 373), '*': ('r', 373), '+': ('r', 373), '%': ('r', 373), '&': ('r', 373), '<': ('r', 373), '=': ('r', 373), '>': ('r', 373), '?': ('r', 373), '<<': ('r', 373), ':': ('r', 373), ';': ('r', 373), '...': ('r', 373), '|=': ('r', 373), '^=': ('r', 373), '%=': ('r', 373), '!=': ('r', 373), '--': ('r', 373), '/=': ('r', 373), '++': ('r', 373), '^': ('r', 373), '<<=': ('r', 373), '->': ('r', 373), '-=': ('r', 373), '->*': ('r', 373), '+=': ('r', 373), '>=': ('r', 373), '<=': ('r', 373), '||': ('r', 373), '>>=': ('r', 373), '&&': ('r', 373), '|': ('r', 373), '}': ('r', 373), '&=': ('r', 373), '{': ('r', 373), 'try': ('r', 373), '>>': ('r', 373), ']': ('r', 373), '*=': ('r', 373), '==': ('r', 373), '[': ('r', 373), '.*': ('r', 373)}, 963),
        #STATE 964
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 63), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 63), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('init_declarator -> declarator:d initializer:init?', 19), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 63), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('declarator -> direct_declarator!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 58), ('direct_declarator -> declarator_id!', 21), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('declarator_id -> id_expression!', 17), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("qualified_id -> '::' IDENTIFIER!", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('init_declarator -> declarator:d initializer:init?', 19), ('id_expression -> qualified_id!', 17), ('namespace_name -> IDENTIFIER:name', 18), ('unqualified_id -> IDENTIFIER:id', 18), ('unqualified_id -> operator_function_id!', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("operator_function_id -> 'operator' operator:op", 24), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('unqualified_id -> conversion_function_id!', 18), ("ptr_operator -> '&'", 16), ("unqualified_id -> '~' class_name:name", 18), ("direct_declarator -> '(' declarator! ')'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {unqualified_id: ('g', 7), '(': ('s', 281), qualified_id: ('g', 4), '*': ('s', 223), namespace_name: ('g', 5), nested_name_specifier: ('g', 284), '&': ('s', 225), init_declarator: ('g', 181), '~': ('s', 45), IDENTIFIER: ('s', 46), 'operator': ('s', 8), template_name: ('g', 2), direct_declarator: ('g', 285), class_name: ('g', 11), '::': ('s', 282), id_expression: ('g', 280), _74: ('g', 965), declarator_id: ('g', 286), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), ptr_operator: ('g', 279), template_id: ('g', 44), declarator: ('g', 966)}, 964),
        #STATE 965
        State([("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 90), None], {',': ('s', 452), ';': ('s', 1028)}, 965),
        #STATE 966
        State([('init_declarator -> declarator:d initializer:init?', 32), ("initializer -> '=' initializer_clause!", 15), ('init_declarator -> declarator:d initializer:init?', 29), ("initializer -> '(' assignment_expression!+,',':args ')'", 15), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 68)], {',': ('r', 440), '=': ('s', 971), '(': ('s', 1026), initializer: ('g', 1027), 'try': ('r', 266), ';': ('r', 440), ':': ('r', 266), '{': ('r', 266)}, 966),
        #STATE 967
        State([("member_specification -> access_specifier:access ':'", 51)], {'union': ('r', 375), '::': ('r', 375), 'export': ('r', 375), 'using': ('r', 375), 'virtual': ('r', 375), DECLARE_KEYWORD: ('r', 375), 'const': ('r', 375), '}': ('r', 375), '~': ('r', 375), IDENTIFIER: ('r', 375), 'operator': ('r', 375), 'typedef': ('r', 375), 'struct': ('r', 375), 'extern': ('r', 375), TYPE_KEYWORD: ('r', 375), ACCESS_KEYWORD: ('r', 375), 'enum': ('r', 375), 'class': ('r', 375), 'typename': ('r', 375), 'auto': ('r', 375), 'volatile': ('r', 375), 'template': ('r', 375)}, 967),
        #STATE 968
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 61), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), pm_expression: ('g', 852), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), operator_function_id: ('g', 6), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 968),
        #STATE 969
        State([("pm_expression -> pm_expression:a '->*' cast_expression:b", 33), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 74), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 33)], {',': ('r', 378), '-': ('r', 378), '/': ('r', 378), '|=': ('r', 378), ')': ('r', 378), '*': ('r', 378), '==': ('r', 378), '%': ('r', 378), '&': ('r', 378), '>>=': ('r', 378), '&&': ('r', 378), '<': ('r', 378), '=': ('r', 378), '>': ('r', 378), '?': ('r', 378), '<<': ('r', 378), ':': ('r', 378), ';': ('r', 378), '...': ('r', 378), '<=': ('r', 378), '^=': ('r', 378), '%=': ('r', 378), '|': ('r', 378), '!=': ('r', 378), '}': ('r', 378), '/=': ('r', 378), '+': ('r', 378), '||': ('r', 378), '*=': ('r', 378), '&=': ('r', 378), '+=': ('r', 378), ']': ('r', 378), '^': ('r', 378), '<<=': ('r', 378), '-=': ('r', 378), '.*': ('s', 740), '->*': ('s', 741), '>>': ('r', 378), '>=': ('r', 378)}, 969),
        #STATE 970
        State([("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 49)], {'>': ('s', 856)}, 970),
        #STATE 971
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("initializer_clause -> '{' '}'", 22), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("initializer_clause -> '{' initializer_clause!+,',':data ','? '}'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("initializer -> '=' initializer_clause!", 19), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('initializer_clause -> assignment_expression!', 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), '{': ('s', 656), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), initializer_clause: ('g', 972), equality_expression: ('g', 70), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 655), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), '--': ('s', 111), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), INTEGER_LITERAL: ('s', 87), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 971),
        #STATE 972
        State([("initializer -> '=' initializer_clause!", 37)], {',': ('r', 443), ';': ('r', 443)}, 972),
        #STATE 973
        State([("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 45), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 45), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 63)], {',': ('r', 555), '-': ('s', 810), '|=': ('r', 555), ')': ('r', 555), '+': ('s', 680), '&': ('r', 555), '>>=': ('r', 555), '&&': ('r', 555), '<': ('r', 555), '=': ('r', 555), '>': ('r', 555), '?': ('r', 555), '<<': ('r', 555), ':': ('r', 555), ';': ('r', 555), '...': ('r', 555), '<=': ('r', 555), '^=': ('r', 555), '%=': ('r', 555), '|': ('r', 555), '!=': ('r', 555), '}': ('r', 555), '/=': ('r', 555), '==': ('r', 555), '||': ('r', 555), '^': ('r', 555), '&=': ('r', 555), '+=': ('r', 555), ']': ('r', 555), '*=': ('r', 555), '<<=': ('r', 555), '-=': ('r', 555), '>>': ('r', 555), '>=': ('r', 555)}, 973),
        #STATE 974
        State([("new_initializer -> '(' assignment_expression!*,','! ')'", 55)], {',': ('r', 390), '-': ('r', 390), '/': ('r', 390), '|=': ('r', 390), ')': ('r', 390), '*': ('r', 390), '+': ('r', 390), '%': ('r', 390), '&': ('r', 390), '>>=': ('r', 390), '&&': ('r', 390), '<': ('r', 390), '=': ('r', 390), '>': ('r', 390), '?': ('r', 390), '<<': ('r', 390), ':': ('r', 390), ';': ('r', 390), '...': ('r', 390), '<=': ('r', 390), '^=': ('r', 390), '%=': ('r', 390), '|': ('r', 390), '!=': ('r', 390), '}': ('r', 390), '/=': ('r', 390), '==': ('r', 390), '||': ('r', 390), '^': ('r', 390), '&=': ('r', 390), '+=': ('r', 390), ']': ('r', 390), '*=': ('r', 390), '<<=': ('r', 390), '-=': ('r', 390), '.*': ('r', 390), '->*': ('r', 390), '>>': ('r', 390), '>=': ('r', 390)}, 974),
        #STATE 975
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 160)], {',': ('r', 391), '-': ('r', 391), '.': ('r', 391), '/': ('r', 391), '(': ('r', 391), ')': ('r', 391), '*': ('r', 391), '+': ('r', 391), '%': ('r', 391), '&': ('r', 391), '<': ('r', 391), '=': ('r', 391), '>': ('r', 391), '?': ('r', 391), '<<': ('r', 391), ':': ('r', 391), ';': ('r', 391), '...': ('r', 391), '|=': ('r', 391), '^=': ('r', 391), '%=': ('r', 391), '!=': ('r', 391), '--': ('r', 391), '/=': ('r', 391), '++': ('r', 391), '^': ('r', 391), '<<=': ('r', 391), '->': ('r', 391), '-=': ('r', 391), '->*': ('r', 391), '+=': ('r', 391), '>=': ('r', 391), '<=': ('r', 391), '||': ('r', 391), '>>=': ('r', 391), '&&': ('r', 391), '|': ('r', 391), '}': ('r', 391), '&=': ('r', 391), '{': ('r', 391), 'try': ('r', 391), '>>': ('r', 391), ']': ('r', 391), '*=': ('r', 391), '==': ('r', 391), '[': ('r', 391), '.*': ('r', 391)}, 975),
        #STATE 976
        State([("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 51)], {')': ('s', 886)}, 976),
        #STATE 977
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 85)], {',': ('r', 394), '-': ('r', 394), '.': ('r', 394), '/': ('r', 394), '(': ('r', 394), ')': ('r', 394), '*': ('r', 394), '+': ('r', 394), '%': ('r', 394), '&': ('r', 394), '<': ('r', 394), '=': ('r', 394), '>': ('r', 394), '?': ('r', 394), '<<': ('r', 394), ':': ('r', 394), ';': ('r', 394), '...': ('r', 394), '|=': ('r', 394), '^=': ('r', 394), '%=': ('r', 394), '!=': ('r', 394), '--': ('r', 394), '/=': ('r', 394), '++': ('r', 394), '^': ('r', 394), '<<=': ('r', 394), '->': ('r', 394), '-=': ('r', 394), '->*': ('r', 394), '+=': ('r', 394), '>=': ('r', 394), '<=': ('r', 394), '||': ('r', 394), '>>=': ('r', 394), '&&': ('r', 394), '|': ('r', 394), '}': ('r', 394), '&=': ('r', 394), '{': ('r', 394), 'try': ('r', 394), '>>': ('r', 394), ']': ('r', 394), '*=': ('r', 394), '==': ('r', 394), '[': ('r', 394), '.*': ('r', 394)}, 977),
        #STATE 978
        State([("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 47)], {'}': ('s', 692)}, 978),
        #STATE 979
        State([("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 88)], {'::': ('s', 674)}, 979),
        #STATE 980
        State([("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 80), ("enumerator_definition -> enumerator:name ('=' constant_expression:v)?", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 46), ("enumerator_definition -> enumerator:name ('=' constant_expression:v)?", 25), ('enumerator -> IDENTIFIER!', 14), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 46), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 46)], {enumerator_definition: ('g', 882), _84: ('g', 981), IDENTIFIER: ('s', 930), '}': ('s', 982), enumerator: ('g', 929)}, 980),
        #STATE 981
        State([("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 80), None], {',': ('s', 927), '}': ('s', 402)}, 981),
        #STATE 982
        State([("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 83)], {',': ('r', 502), '-': ('r', 502), '.': ('r', 502), '/': ('r', 502), '|=': ('r', 502), ')': ('r', 502), '*': ('r', 502), '+': ('r', 502), '%': ('r', 502), '&': ('r', 502), 'operator': ('r', 502), '<': ('r', 502), '=': ('r', 502), '>': ('r', 502), '?': ('r', 502), '<<': ('r', 502), IDENTIFIER: ('r', 502), ':': ('r', 502), ';': ('r', 502), '...': ('r', 502), '(': ('r', 502), '^=': ('r', 502), '||': ('r', 502), '^': ('r', 502), '!=': ('r', 502), '--': ('r', 502), '/=': ('r', 502), '++': ('r', 502), '*=': ('r', 502), '<<=': ('r', 502), '->': ('r', 502), 'auto': ('r', 502), '-=': ('r', 502), '%=': ('r', 502), '+=': ('r', 502), '>=': ('r', 502), 'union': ('r', 502), '<=': ('r', 502), '::': ('r', 502), '>>=': ('r', 502), '&&': ('r', 502), '|': ('r', 502), '}': ('r', 502), '~': ('r', 502), 'volatile': ('r', 502), '&=': ('r', 502), '{': ('r', 502), '.*': ('r', 502), 'struct': ('r', 502), '->*': ('r', 502), TYPE_KEYWORD: ('r', 502), 'try': ('r', 502), 'enum': ('r', 502), '>>': ('r', 502), 'class': ('r', 502), ']': ('r', 502), 'typename': ('r', 502), '==': ('r', 502), '[': ('r', 502), 'const': ('r', 502)}, 982),
        #STATE 983
        State([('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 68), ('init_declarator -> declarator:d initializer:init?', 32), ("initializer -> '=' initializer_clause!", 15), ('init_declarator -> declarator:d initializer:init?', 29), ("initializer -> '(' assignment_expression!+,',':args ')'", 15)], {',': ('r', 440), '=': ('s', 971), ';': ('r', 440), '(': ('s', 1026), initializer: ('g', 1027), ':': ('r', 356), 'try': ('r', 356), '{': ('r', 356)}, 983),
        #STATE 984
        State([('function_definition -> function_head:head ctor_initializer:init? function_body:body', 65), ("compound_statement -> '{' statement!*:sts '}'", 22), ("compound_statement -> '{' statement!*:sts '}'", 22), ('function_body -> compound_statement!', 17)], {function_body: ('g', 711), compound_statement: ('g', 985), '{': ('s', 329)}, 984),
        #STATE 985
        State([('function_body -> compound_statement!', 35)], {'catch': ('r', 523), '::': ('r', 523), 'export': ('r', 523), 'using': ('r', 523), 'virtual': ('r', 523), DECLARE_KEYWORD: ('r', 523), 'union': ('r', 523), 'const': ('r', 523), ACCESS_KEYWORD: ('r', 523), '~': ('r', 523), IDENTIFIER: ('r', 523), ';': ('r', 523), 'extern': ('r', 523), 'operator': ('r', 523), 'typedef': ('r', 523), TYPE_KEYWORD: ('r', 523), '}': ('r', 523), 'asm': ('r', 523), 'enum': ('r', 523), EOF: ('r', 523), 'class': ('r', 523), CPP_INCLUDE: ('r', 523), 'typename': ('r', 523), CPP_ERROR: ('r', 523), 'struct': ('r', 523), 'volatile': ('r', 523), 'template': ('r', 523), 'namespace': ('r', 523), 'auto': ('r', 523)}, 985),
        #STATE 986
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 61), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), pm_expression: ('g', 739), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), operator_function_id: ('g', 6), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 986),
        #STATE 987
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 61), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), pm_expression: ('g', 969), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), operator_function_id: ('g', 6), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 987),
        #STATE 988
        State([None, ("new_placement -> '(' assignment_expression!+,','! ')'", 50)], {',': ('s', 304), ')': ('s', 989)}, 988),
        #STATE 989
        State([("new_placement -> '(' assignment_expression!+,','! ')'", 53)], {'union': ('r', 449), '(': ('r', 449), '::': ('r', 449), 'struct': ('r', 449), 'enum': ('r', 449), 'class': ('r', 449), 'typename': ('r', 449), IDENTIFIER: ('r', 449), 'auto': ('r', 449), 'volatile': ('r', 449), 'const': ('r', 449), TYPE_KEYWORD: ('r', 449)}, 989),
        #STATE 990
        State([("pure_specifier -> '=' INTEGER_LITERAL:i", 37)], {',': ('r', 300), ';': ('r', 300)}, 990),
        #STATE 991
        State([('type_name -> IDENTIFIER:name', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('type_name -> template_id!', 13)], {template_name: ('g', 2), '~': ('s', 811), IDENTIFIER: ('s', 24), conversion_function_id: ('g', 885), 'template': ('s', 374), 'operator': ('s', 168), template_id: ('g', 26), type_name: ('g', 427)}, 991),
        #STATE 992
        State([('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 95)], {',': ('r', 405), ']': ('r', 405), '>': ('r', 405), ')': ('r', 405), ':': ('r', 405), '}': ('r', 405), '...': ('r', 405), ';': ('r', 405)}, 992),
        #STATE 993
        State([("exception_declaration -> '...'", 30)], {')': ('r', 407)}, 993),
        #STATE 994
        State([("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 92)], {',': ('r', 408), 'union': ('r', 408), '(': ('r', 408), ')': ('r', 408), 'auto': ('r', 408), 'volatile': ('r', 408), TYPE_KEYWORD: ('r', 408), 'enum': ('r', 408), 'typename': ('r', 408), 'class': ('r', 408), '=': ('r', 408), '>': ('r', 408), IDENTIFIER: ('r', 408), 'struct': ('r', 408), '[': ('r', 408), '...': ('r', 408), 'const': ('r', 408), '::': ('r', 408)}, 994),
        #STATE 995
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 39), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 48), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 39), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 39), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {',': ('s', 1052), template_name: ('g', 2), IDENTIFIER: ('s', 29), '::': ('s', 191), named_type_specifier: ('g', 126), namespace_name: ('g', 5), raw_type_descriptor: ('g', 54), 'enum': ('s', 117), cv_qualifier: ('g', 106), type_name: ('g', 98), 'union': ('s', 97), elaborated_type_specifier: ('g', 109), enum_specifier: ('g', 122), class_name: ('g', 11), TYPE_KEYWORD: ('s', 162), _130: ('g', 1053), class_head: ('g', 20), class_key: ('g', 78), template_id: ('g', 18), _80: ('g', 112), class_specifier: ('g', 75), 'class': ('s', 115), type_id: ('g', 419), 'typename': ('s', 166), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), nested_name_specifier: ('g', 189), _81: ('g', 88), type_descriptor: ('g', 240), 'auto': ('s', 90)}, 995),
        #STATE 996
        State([("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 70)], {'-': ('r', 531), 'asm': ('r', 531), '(': ('r', 531), '*': ('r', 531), '+': ('r', 531), 'delete': ('r', 531), 'static_cast': ('r', 531), 'operator': ('r', 531), DECLARE_KEYWORD: ('r', 531), ACCESS_KEYWORD: ('r', 531), IDENTIFIER: ('r', 531), ';': ('r', 531), INTEGER_LITERAL: ('r', 531), 'extern': ('r', 531), 'default': ('r', 531), 'goto': ('r', 531), 'break': ('r', 531), 'new': ('r', 531), 'throw': ('r', 531), 'typedef': ('r', 531), '--': ('r', 531), '++': ('r', 531), 'dynamic_cast': ('r', 531), 'for': ('r', 531), 'export': ('r', 531), 'struct': ('r', 531), 'volatile': ('r', 531), 'continue': ('r', 531), '&': ('r', 531), 'this': ('r', 531), 'if': ('r', 531), 'union': ('r', 531), 'virtual': ('r', 531), 'const_cast': ('r', 531), '::': ('r', 531), 'auto': ('r', 531), 'using': ('r', 531), 'namespace': ('r', 531), 'do': ('r', 531), '!': ('r', 531), '}': ('r', 531), '~': ('r', 531), 'return': ('r', 531), '{': ('r', 531), 'else': ('r', 531), 'case': ('r', 531), TYPE_KEYWORD: ('r', 531), FLOATING_LITERAL: ('r', 531), 'sizeof': ('r', 531), 'const': ('r', 531), CHARACTER_LITERAL: ('r', 531), 'try': ('r', 531), 'reinterpret_cast': ('r', 531), BOOLEAN_LITERAL: ('r', 531), 'enum': ('r', 531), EOF: ('r', 531), STRING_LITERAL: ('r', 531), 'class': ('r', 531), CPP_INCLUDE: ('r', 531), 'typename': ('r', 531), 'while': ('r', 531), CPP_ERROR: ('r', 531), 'template': ('r', 531), 'switch': ('r', 531), 'typeid': ('r', 531)}, 996),
        #STATE 997
        State([("expression -> expression:a ',' assignment_expression:b", 52)], {',': ('r', 546), ']': ('r', 546), ')': ('r', 546), ':': ('r', 546), ';': ('r', 546)}, 997),
        #STATE 998
        State([("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 89)], {']': ('s', 994)}, 998),
        #STATE 999
        State([("delete_expression -> '::'? 'delete' cast_expression:v", 51)], {',': ('r', 509), '-': ('r', 509), '/': ('r', 509), '|=': ('r', 509), ')': ('r', 509), '*': ('r', 509), '==': ('r', 509), '%': ('r', 509), '&': ('r', 509), '>>=': ('r', 509), '&&': ('r', 509), '<': ('r', 509), '=': ('r', 509), '>': ('r', 509), '?': ('r', 509), '<<': ('r', 509), ':': ('r', 509), ';': ('r', 509), '...': ('r', 509), '<=': ('r', 509), '^=': ('r', 509), '%=': ('r', 509), '|': ('r', 509), '!=': ('r', 509), '}': ('r', 509), '/=': ('r', 509), '+': ('r', 509), '||': ('r', 509), '^': ('r', 509), '&=': ('r', 509), '>>': ('r', 509), ']': ('r', 509), '*=': ('r', 509), '<<=': ('r', 509), '-=': ('r', 509), '.*': ('r', 509), '->*': ('r', 509), '+=': ('r', 509), '>=': ('r', 509)}, 999),
        #STATE 1000
        State([("unary_expression -> '++' cast_expression:v", 40)], {',': ('r', 532), '-': ('r', 532), '/': ('r', 532), '|=': ('r', 532), ')': ('r', 532), '*': ('r', 532), '==': ('r', 532), '%': ('r', 532), '&': ('r', 532), '>>=': ('r', 532), '&&': ('r', 532), '<': ('r', 532), '=': ('r', 532), '>': ('r', 532), '?': ('r', 532), '<<': ('r', 532), ':': ('r', 532), ';': ('r', 532), '...': ('r', 532), '<=': ('r', 532), '^=': ('r', 532), '%=': ('r', 532), '|': ('r', 532), '!=': ('r', 532), '}': ('r', 532), '/=': ('r', 532), '+': ('r', 532), '||': ('r', 532), '*=': ('r', 532), '&=': ('r', 532), '+=': ('r', 532), ']': ('r', 532), '^': ('r', 532), '<<=': ('r', 532), '-=': ('r', 532), '.*': ('r', 532), '->*': ('r', 532), '>>': ('r', 532), '>=': ('r', 532)}, 1000),
        #STATE 1001
        State([("member_declaration -> elaborated_type_specifier! ';'", 52)], {'union': ('r', 414), '::': ('r', 414), 'export': ('r', 414), 'using': ('r', 414), 'virtual': ('r', 414), DECLARE_KEYWORD: ('r', 414), 'const': ('r', 414), '}': ('r', 414), '~': ('r', 414), IDENTIFIER: ('r', 414), 'operator': ('r', 414), 'typedef': ('r', 414), 'extern': ('r', 414), TYPE_KEYWORD: ('r', 414), ACCESS_KEYWORD: ('r', 414), 'enum': ('r', 414), 'class': ('r', 414), 'typename': ('r', 414), 'struct': ('r', 414), 'volatile': ('r', 414), 'template': ('r', 414), 'auto': ('r', 414)}, 1001),
        #STATE 1002
        State([('type_id -> type_descriptor:type abstract_declarator:d?', 51)], {',': ('r', 463), 'union': ('r', 463), ')': ('r', 463), 'volatile': ('r', 463), 'enum': ('r', 463), '>': ('r', 463), '::': ('r', 463), 'class': ('r', 463), 'typename': ('r', 463), IDENTIFIER: ('r', 463), 'auto': ('r', 463), 'struct': ('r', 463), 'const': ('r', 463), TYPE_KEYWORD: ('r', 463)}, 1002),
        #STATE 1003
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 144)], {',': ('r', 417), '-': ('r', 417), '.': ('r', 417), '/': ('r', 417), '(': ('r', 417), ')': ('r', 417), '*': ('r', 417), '+': ('r', 417), '%': ('r', 417), '&': ('r', 417), '<': ('r', 417), '=': ('r', 417), '>': ('r', 417), '?': ('r', 417), '<<': ('r', 417), ':': ('r', 417), ';': ('r', 417), '...': ('r', 417), '|=': ('r', 417), '^=': ('r', 417), '%=': ('r', 417), '!=': ('r', 417), '--': ('r', 417), '/=': ('r', 417), '++': ('r', 417), '^': ('r', 417), '<<=': ('r', 417), '->': ('r', 417), '-=': ('r', 417), '->*': ('r', 417), '+=': ('r', 417), '>=': ('r', 417), '<=': ('r', 417), '||': ('r', 417), '>>=': ('r', 417), '&&': ('r', 417), '|': ('r', 417), '}': ('r', 417), '&=': ('r', 417), '{': ('r', 417), 'try': ('r', 417), '>>': ('r', 417), ']': ('r', 417), '*=': ('r', 417), '==': ('r', 417), '[': ('r', 417), '.*': ('r', 417)}, 1003),
        #STATE 1004
        State([("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 70), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 60)], {'-': ('r', 424), 'asm': ('r', 424), '(': ('r', 424), '*': ('r', 424), '+': ('r', 424), 'delete': ('r', 424), 'static_cast': ('r', 424), 'virtual': ('r', 424), DECLARE_KEYWORD: ('r', 424), IDENTIFIER: ('r', 424), 'while': ('r', 424), INTEGER_LITERAL: ('r', 424), 'extern': ('r', 424), 'default': ('r', 424), 'goto': ('r', 424), 'break': ('r', 424), 'new': ('r', 424), 'throw': ('r', 424), 'typedef': ('r', 424), '--': ('r', 424), '++': ('r', 424), 'dynamic_cast': ('r', 424), 'for': ('r', 424), 'continue': ('r', 424), 'struct': ('r', 424), 'volatile': ('r', 424), 'namespace': ('r', 424), '&': ('r', 424), 'if': ('r', 424), 'union': ('r', 424), 'const_cast': ('r', 424), '::': ('r', 424), 'auto': ('r', 424), 'using': ('r', 424), 'do': ('r', 424), 'this': ('r', 424), 'try': ('r', 424), '~': ('r', 424), 'return': ('r', 424), '{': ('r', 424), 'case': ('r', 424), '!': ('r', 424), CHARACTER_LITERAL: ('r', 424), FLOATING_LITERAL: ('r', 424), 'sizeof': ('r', 424), 'else': ('s', 1007), TYPE_KEYWORD: ('r', 424), '}': ('r', 424), 'reinterpret_cast': ('r', 424), BOOLEAN_LITERAL: ('r', 424), 'enum': ('r', 424), STRING_LITERAL: ('r', 424), 'class': ('r', 424), 'typename': ('r', 424), CPP_ERROR: ('r', 424), 'operator': ('r', 424), 'const': ('r', 424), 'switch': ('r', 424), 'typeid': ('r', 424)}, 1004),
        #STATE 1005
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 70), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 70), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 70), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 70)], {'template': ('s', 1036), template_name: ('g', 2), IDENTIFIER: ('s', 1046), template_id: ('g', 683)}, 1005),
        #STATE 1006
        State([('unqualified_id -> operator_function_id!', 18), ("operator_function_id -> 'operator' operator:op", 24), ('unqualified_id -> IDENTIFIER:id', 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 81), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unqualified_id -> '~' class_name:name", 18), ('unqualified_id -> conversion_function_id!', 18)], {unqualified_id: ('g', 614), '~': ('s', 45), IDENTIFIER: ('s', 314), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), 'operator': ('s', 8)}, 1006),
        #STATE 1007
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ('decl_attrib -> DECLARE_KEYWORD!', 15), ("iteration_statement -> 'while' '(' condition:cond ')' statement:st", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("labeled_statement -> 'default' ':' statement:st", 21), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('statement -> expression_statement!', 13), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ('statement -> iteration_statement!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("selection_statement -> 'switch' '(' condition:cond ')' statement:st", 23), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> CPP_ERROR!', 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('unqualified_id -> conversion_function_id!', 18), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('statement -> labeled_statement!', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("jump_statement -> 'return' expression:v? ';'", 18), ("unary_expression -> '--' cast_expression:v", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('relational_expression -> shift_expression!', 25), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('block_declaration -> asm_definition!', 21), ('class_head -> class_key:t base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 18), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("compound_statement -> '{' statement!*:sts '}'", 22), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('statement -> try_block!', 13), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("jump_statement -> 'continue' ';'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 77), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ('statement -> compound_statement!', 13), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('additive_expression -> multiplicative_expression!', 23), ('logical_and_expression -> inclusive_or_expression!', 26), ('equality_expression -> relational_expression!', 23), ('statement -> jump_statement!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('expression -> assignment_expression!', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("jump_statement -> 'return' expression:v? ';'", 18), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> '++' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("compound_statement -> '{' statement!*:sts '}'", 22), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('statement -> declaration_statement!', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> conditional_expression!', 25), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ("raw_type_descriptor -> 'auto'", 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('id_expression -> qualified_id!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ('block_declaration -> simple_declaration!', 21), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cv_qualifier -> 'const'!", 16), ('class_name -> IDENTIFIER:name', 14), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('statement -> selection_statement!', 13), ("jump_statement -> 'break' ';'", 18), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("expression -> expression:a ',' assignment_expression:b", 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('postfix_expression -> primary_expression!', 22), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("labeled_statement -> 'case' constant_expression:c ':' statement:st", 21), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("try_block -> 'try' compound_statement:body handler!+:handlers", 13), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('type_descriptor -> raw_type_descriptor!', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_declaration!', 21), ('shift_expression -> additive_expression!', 20), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('literal -> CHARACTER_LITERAL:v', 11), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("labeled_statement -> IDENTIFIER:lbl ':' statement:st", 21), ('assignment_expression -> throw_expression!', 25), ("iteration_statement -> 'for' '(' for_init_statement:init condition:cond? ';' expression:inc? ')' statement:st", 23), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('block_declaration -> using_directive!', 21), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ('declaration_statement -> block_declaration:decl', 25), ('unary_expression -> delete_expression!', 20), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("decl_attrib -> 'typedef'!", 15), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("selection_statement -> 'if' '(' condition:cond ')' statement:thenst ( 'else' statement:elsest )?", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unary_expression -> postfix_expression!', 20), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ('pm_expression -> cast_expression!', 17), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> named_type_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('type_name -> template_id!', 13), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("expression_statement -> expression:expr ';'", 24), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {'-': ('s', 81), '++': ('s', 55), _80: ('g', 112), '+': ('s', 80), multiplicative_expression: ('g', 60), 'static_cast': ('s', 71), 'operator': ('s', 8), and_expression: ('g', 72), additive_expression: ('g', 63), shift_expression: ('g', 65), relational_expression: ('g', 67), INTEGER_LITERAL: ('s', 87), class_name: ('g', 11), pm_expression: ('g', 73), 'if': ('s', 331), class_specifier: ('g', 138), class_head: ('g', 20), logical_and_expression: ('g', 118), 'asm': ('s', 125), logical_or_expression: ('g', 82), conditional_expression: ('g', 77), 'continue': ('s', 333), assignment_expression: ('g', 85), conversion_function_id: ('g', 357), 'namespace': ('s', 170), expression: ('g', 335), STRING_LITERAL: ('s', 113), 'auto': ('s', 90), 'const_cast': ('s', 92), '::': ('s', 347), cv_qualifier: ('g', 106), labeled_statement: ('g', 337), expression_statement: ('g', 338), type_name: ('g', 131), compound_statement: ('g', 339), DECLARE_KEYWORD: ('s', 160), selection_statement: ('g', 340), '{': ('s', 329), namespace_alias_definition: ('g', 161), '!': ('s', 104), iteration_statement: ('g', 341), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), jump_statement: ('g', 342), try_block: ('g', 348), operator_function_id: ('g', 6), 'enum': ('s', 117), block_declaration: ('g', 344), 'typename': ('s', 116), 'while': ('s', 349), simple_declaration: ('g', 167), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), decl_attrib: ('g', 28), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 345), raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), using_declaration: ('g', 127), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), 'virtual': ('s', 130), _73: ('g', 346), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), equality_expression: ('g', 70), 'typedef': ('s', 136), 'goto': ('s', 350), statement: ('g', 867), 'new': ('s', 74), throw_expression: ('g', 91), 'extern': ('s', 249), '--': ('s', 111), 'default': ('s', 330), 'dynamic_cast': ('s', 83), literal: ('g', 84), 'for': ('s', 351), 'struct': ('s', 58), 'volatile': ('s', 33), primary_expression: ('g', 40), _81: ('g', 88), id_expression: ('g', 114), 'break': ('s', 332), _75: ('g', 152), using_directive: ('g', 137), exclusive_or_expression: ('g', 121), 'using': ('s', 154), asm_definition: ('g', 149), 'union': ('s', 97), 'this': ('s', 103), postfix_expression: ('g', 99), '~': ('s', 353), 'return': ('s', 354), 'do': ('s', 355), 'const': ('s', 35), template_name: ('g', 2), unary_expression: ('g', 69), 'case': ('s', 356), unary_operator: ('g', 105), inclusive_or_expression: ('g', 76), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), 'try': ('s', 334), 'reinterpret_cast': ('s', 110), cd_declarator: ('g', 358), cd_id: ('g', 164), type_descriptor: ('g', 359), 'throw': ('s', 96), namespace_name: ('g', 5), 'switch': ('s', 360), declaration_statement: ('g', 343), CPP_ERROR: ('s', 361), delete_expression: ('g', 119), nested_name_specifier: ('g', 352), cast_expression: ('g', 66), 'typeid': ('s', 38)}, 1007),
        #STATE 1008
        State([("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 59)], {',': ('r', 490), '-': ('r', 490), '/': ('r', 490), '|=': ('r', 490), ')': ('r', 490), '*': ('r', 490), '==': ('r', 490), '%': ('r', 490), '&': ('r', 490), '>>=': ('r', 490), '&&': ('r', 490), '<': ('r', 490), '=': ('r', 490), '>': ('r', 490), '?': ('r', 490), '<<': ('r', 490), ':': ('r', 490), ';': ('r', 490), '...': ('r', 490), '<=': ('r', 490), '^=': ('r', 490), '%=': ('r', 490), '|': ('r', 490), '!=': ('r', 490), '}': ('r', 490), '/=': ('r', 490), '+': ('r', 490), '||': ('r', 490), '^': ('r', 490), '&=': ('r', 490), '>>': ('r', 490), ']': ('r', 490), '*=': ('r', 490), '<<=': ('r', 490), '-=': ('r', 490), '.*': ('r', 490), '->*': ('r', 490), '+=': ('r', 490), '>=': ('r', 490)}, 1008),
        #STATE 1009
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 126)], {',': ('r', 500), '-': ('r', 500), '.': ('r', 500), '/': ('r', 500), '|=': ('r', 500), ')': ('r', 500), '*': ('r', 500), '+': ('r', 500), '%': ('r', 500), '&': ('r', 500), '<': ('r', 500), '=': ('r', 500), '>': ('r', 500), '?': ('r', 500), '<<': ('r', 500), ':': ('r', 500), ';': ('r', 500), '...': ('r', 500), '(': ('r', 500), '^=': ('r', 500), '%=': ('r', 500), '!=': ('r', 500), '--': ('r', 500), '/=': ('r', 500), '==': ('r', 500), '*=': ('r', 500), '<<=': ('r', 500), '->': ('r', 500), '-=': ('r', 500), '->*': ('r', 500), '+=': ('r', 500), '>=': ('r', 500), '<=': ('r', 500), '||': ('r', 500), '>>=': ('r', 500), '&&': ('r', 500), '|': ('r', 500), '}': ('r', 500), '&=': ('r', 500), '++': ('r', 500), '>>': ('r', 500), ']': ('r', 500), '^': ('r', 500), '[': ('r', 500), '.*': ('r', 500)}, 1009),
        #STATE 1010
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 73), ("new_initializer -> '(' assignment_expression!*,','! ')'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 74), ("new_initializer -> '(' assignment_expression!*,','! ')'", 19)], {',': ('r', 428), '-': ('r', 428), '/': ('r', 428), '(': ('s', 300), ')': ('r', 428), '*': ('r', 428), '==': ('r', 428), '%': ('r', 428), '&': ('r', 428), '>>=': ('r', 428), '+=': ('r', 428), '&&': ('r', 428), '<': ('r', 428), '=': ('r', 428), '>': ('r', 428), '?': ('r', 428), '<=': ('r', 428), ':': ('r', 428), ';': ('r', 428), '...': ('r', 428), '|=': ('r', 428), '^=': ('r', 428), '%=': ('r', 428), '|': ('r', 428), '!=': ('r', 428), '}': ('r', 428), '/=': ('r', 428), '+': ('r', 428), '||': ('r', 428), '^': ('r', 428), '&=': ('r', 428), '<<': ('r', 428), ']': ('r', 428), '*=': ('r', 428), '<<=': ('r', 428), new_initializer: ('g', 934), '-=': ('r', 428), '.*': ('r', 428), '->*': ('r', 428), '>>': ('r', 428), '>=': ('r', 428)}, 1010),
        #STATE 1011
        State([("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('inclusive_or_expression -> exclusive_or_expression!', 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("cv_qualifier -> 'volatile'!", 16), ("unqualified_id -> '~' class_name:name", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("primary_expression -> 'this'", 22), ('unary_expression -> new_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('conditional_expression -> logical_or_expression!', 26), ("primary_expression -> '(' expression! ')'", 22), ('postfix_expression -> primary_expression!', 22), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("class_key -> 'class' | 'struct' | 'union'", 13), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('simple_type_specifier -> named_type_specifier!', 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("unary_expression -> 'sizeof' unary_expression:v", 20), ('multiplicative_expression -> pm_expression!', 29), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('id_expression -> unqualified_id!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('and_expression -> equality_expression!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("unary_expression -> '++' cast_expression:v", 20), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('primary_expression -> id_expression!', 22), ('class_head -> class_key:t base_clause:bases?', 14), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('id_expression -> qualified_id!', 17), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 60), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('equality_expression -> relational_expression!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ('namespace_name -> IDENTIFIER:name', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ('assignment_expression -> conditional_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("raw_type_descriptor -> 'auto'", 23), ('template_name -> IDENTIFIER!', 17), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('literal -> BOOLEAN_LITERAL:v', 11), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('unqualified_id -> conversion_function_id!', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("cv_qualifier -> 'const'!", 16), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ('unary_expression -> postfix_expression!', 20), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ('raw_type_descriptor -> enum_specifier!', 23), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("class_key -> 'class' | 'struct' | 'union'", 23), ("postfix_expression -> postfix_expression:v '--'", 22), ('cast_expression -> unary_expression!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> STRING_LITERAL:v', 11), ('literal -> FLOATING_LITERAL:v', 11), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ('exclusive_or_expression -> and_expression!', 27), ('unqualified_id -> operator_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 34), ('type_name -> IDENTIFIER:name', 13), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 60), ("operator_function_id -> 'operator' operator:op", 24), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('raw_type_descriptor -> named_type_specifier!', 23), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('type_name -> template_id!', 13), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('pm_expression -> cast_expression!', 17), ('additive_expression -> multiplicative_expression!', 23), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {raw_type_descriptor: ('g', 54), qualified_id: ('g', 4), '(': ('s', 56), named_type_specifier: ('g', 57), '*': ('s', 93), template_name: ('g', 2), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), cv_qualifier: ('g', 106), additive_expression: ('g', 63), elaborated_type_specifier: ('g', 109), shift_expression: ('g', 65), enum_specifier: ('g', 122), equality_expression: ('g', 70), CHARACTER_LITERAL: ('s', 108), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), delete_expression: ('g', 119), class_name: ('g', 11), and_expression: ('g', 72), _80: ('g', 112), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), 'const_cast': ('s', 92), class_key: ('g', 78), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 82), _81: ('g', 88), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 323), 'struct': ('s', 58), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'auto': ('s', 90), unqualified_id: ('g', 7), IDENTIFIER: ('s', 3), '::': ('s', 64), class_specifier: ('g', 75), template_id: ('g', 18), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), 'union': ('s', 97), type_name: ('g', 98), conversion_function_id: ('g', 12), '~': ('s', 100), 'volatile': ('s', 33), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), class_head: ('g', 20), _15: ('g', 988), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 68), 'class': ('s', 115), postfix_expression: ('g', 99), 'reinterpret_cast': ('s', 110), BOOLEAN_LITERAL: ('s', 102), '--': ('s', 111), 'enum': ('s', 117), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), type_id: ('g', 1012), 'typename': ('s', 116), namespace_name: ('g', 5), logical_and_expression: ('g', 118), operator_function_id: ('g', 6), exclusive_or_expression: ('g', 121), 'const': ('s', 35), type_descriptor: ('g', 240), 'typeid': ('s', 38), relational_expression: ('g', 67)}, 1011),
        #STATE 1012
        State([("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 70), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 70)], {')': ('s', 1010)}, 1012),
        #STATE 1013
        State([('new_declarator -> ptr_operator:op new_declarator:dtor?', 48)], {',': ('r', 432), '-': ('r', 432), '/': ('r', 432), '(': ('r', 432), ')': ('r', 432), '*': ('r', 432), '+': ('r', 432), '%': ('r', 432), '&': ('r', 432), '>>=': ('r', 432), '&&': ('r', 432), '<': ('r', 432), '=': ('r', 432), '>': ('r', 432), '?': ('r', 432), '<=': ('r', 432), ':': ('r', 432), ';': ('r', 432), '...': ('r', 432), '|=': ('r', 432), '^=': ('r', 432), '%=': ('r', 432), '|': ('r', 432), '!=': ('r', 432), '}': ('r', 432), '/=': ('r', 432), '==': ('r', 432), '||': ('r', 432), '^': ('r', 432), '&=': ('r', 432), '<<': ('r', 432), ']': ('r', 432), '*=': ('r', 432), '<<=': ('r', 432), '>>': ('r', 432), '-=': ('r', 432), '.*': ('r', 432), '->*': ('r', 432), '+=': ('r', 432), '>=': ('r', 432)}, 1013),
        #STATE 1014
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 26), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 26), ('type_name -> IDENTIFIER:name', 13), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 37), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 61), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ('id_expression -> unqualified_id!', 17), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("qualified_id -> '::' IDENTIFIER!", 16), ('class_name -> template_id!', 14), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 47), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 26), ('type_name -> template_id!', 13), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns 'template' template_id:t '::' '~' type_name:tn", 37), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 26), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('namespace_name -> IDENTIFIER:name', 18), ('unqualified_id -> IDENTIFIER:id', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("unqualified_id -> '~' class_name:name", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> operator_function_id!', 18), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 37), ('template_name -> IDENTIFIER!', 17), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? '~' type_name:t", 64), ("operator_function_id -> 'operator' operator:op", 24), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('unqualified_id -> conversion_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 64), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 47), ('id_expression -> qualified_id!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_name: ('g', 2), pseudo_destructor_name: ('g', 488), '::': ('s', 10), namespace_name: ('g', 5), template_id: ('g', 18), operator_function_id: ('g', 6), unqualified_id: ('g', 7), type_name: ('g', 9), class_name: ('g', 11), conversion_function_id: ('g', 12), '~': ('s', 13), IDENTIFIER: ('s', 3), 'operator': ('s', 8), 'template': ('s', 43), nested_name_specifier: ('g', 15), id_expression: ('g', 1015), qualified_id: ('g', 4)}, 1014),
        #STATE 1015
        State([("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 74)], {',': ('r', 540), '-': ('r', 540), '.': ('r', 540), '/': ('r', 540), '(': ('r', 540), ')': ('r', 540), '*': ('r', 540), '+': ('r', 540), '%': ('r', 540), '&': ('r', 540), '<': ('r', 540), '=': ('r', 540), '>': ('r', 540), '?': ('r', 540), '<<': ('r', 540), ':': ('r', 540), ';': ('r', 540), '...': ('r', 540), '|=': ('r', 540), '^=': ('r', 540), '%=': ('r', 540), '!=': ('r', 540), '--': ('r', 540), '/=': ('r', 540), '++': ('r', 540), '*=': ('r', 540), '<<=': ('r', 540), '->': ('r', 540), '-=': ('r', 540), '->*': ('r', 540), '+=': ('r', 540), '>=': ('r', 540), '<=': ('r', 540), '||': ('r', 540), '>>=': ('r', 540), '&&': ('r', 540), '|': ('r', 540), '}': ('r', 540), '&=': ('r', 540), '>>': ('r', 540), ']': ('r', 540), '^': ('r', 540), '==': ('r', 540), '[': ('r', 540), '.*': ('r', 540)}, 1015),
        #STATE 1016
        State([("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 58)], {')': ('s', 881)}, 1016),
        #STATE 1017
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 64)], {',': ('r', 468), '-': ('r', 468), '.': ('r', 468), '/': ('r', 468), '(': ('r', 468), ')': ('r', 468), '*': ('r', 468), '+': ('r', 468), '%': ('r', 468), '&': ('r', 468), '<': ('r', 468), '=': ('r', 468), '>': ('r', 468), '?': ('r', 468), '<<': ('r', 468), ':': ('r', 468), ';': ('r', 468), '...': ('r', 468), '|=': ('r', 468), '^=': ('r', 468), '%=': ('r', 468), '!=': ('r', 468), '--': ('r', 468), '/=': ('r', 468), '++': ('r', 468), '^': ('r', 468), '<<=': ('r', 468), '->': ('r', 468), '-=': ('r', 468), '->*': ('r', 468), '+=': ('r', 468), '>=': ('r', 468), '<=': ('r', 468), '||': ('r', 468), '>>=': ('r', 468), '&&': ('r', 468), '|': ('r', 468), '}': ('r', 468), '&=': ('r', 468), '{': ('r', 468), 'try': ('r', 468), '>>': ('r', 468), ']': ('r', 468), '*=': ('r', 468), '==': ('r', 468), '[': ('r', 468), '.*': ('r', 468)}, 1017),
        #STATE 1018
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 92)], {',': ('r', 565), '-': ('r', 565), '.': ('r', 565), '/': ('r', 565), '(': ('r', 565), ')': ('r', 565), '*': ('r', 565), '+': ('r', 565), '%': ('r', 565), '&': ('r', 565), '<': ('r', 565), '=': ('r', 565), '>': ('r', 565), '?': ('r', 565), '<<': ('r', 565), ':': ('r', 565), ';': ('r', 565), '...': ('r', 565), '|=': ('r', 565), '^=': ('r', 565), '%=': ('r', 565), '!=': ('r', 565), '--': ('r', 565), '/=': ('r', 565), '++': ('r', 565), '^': ('r', 565), '<<=': ('r', 565), '->': ('r', 565), '-=': ('r', 565), '->*': ('r', 565), '+=': ('r', 565), '>=': ('r', 565), '<=': ('r', 565), '||': ('r', 565), '>>=': ('r', 565), '&&': ('r', 565), '|': ('r', 565), '}': ('r', 565), '&=': ('r', 565), '{': ('r', 565), 'try': ('r', 565), '>>': ('r', 565), ']': ('r', 565), '*=': ('r', 565), '==': ('r', 565), '[': ('r', 565), '.*': ('r', 565)}, 1018),
        #STATE 1019
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 184)], {',': ('r', 520), '-': ('r', 520), '.': ('r', 520), '/': ('r', 520), '(': ('r', 520), ')': ('r', 520), '*': ('r', 520), '+': ('r', 520), '%': ('r', 520), '&': ('r', 520), '<': ('r', 520), '=': ('r', 520), '>': ('r', 520), '?': ('r', 520), '<<': ('r', 520), ':': ('r', 520), ';': ('r', 520), '...': ('r', 520), '|=': ('r', 520), '^=': ('r', 520), '%=': ('r', 520), '!=': ('r', 520), '--': ('r', 520), '/=': ('r', 520), '++': ('r', 520), '^': ('r', 520), '<<=': ('r', 520), '->': ('r', 520), '-=': ('r', 520), '->*': ('r', 520), '+=': ('r', 520), '>=': ('r', 520), '<=': ('r', 520), '||': ('r', 520), '>>=': ('r', 520), '&&': ('r', 520), '|': ('r', 520), '}': ('r', 520), '&=': ('r', 520), '{': ('r', 520), 'try': ('r', 520), '>>': ('r', 520), ']': ('r', 520), '*=': ('r', 520), '==': ('r', 520), '[': ('r', 520), '.*': ('r', 520)}, 1019),
        #STATE 1020
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 282)], {',': ('r', 474), '-': ('r', 474), '.': ('r', 474), '/': ('r', 474), '(': ('r', 474), ')': ('r', 474), '*': ('r', 474), '+': ('r', 474), '%': ('r', 474), '&': ('r', 474), '<': ('r', 474), '=': ('r', 474), '>': ('r', 474), '?': ('r', 474), '<<': ('r', 474), ':': ('r', 474), ';': ('r', 474), '...': ('r', 474), '|=': ('r', 474), '^=': ('r', 474), '%=': ('r', 474), '!=': ('r', 474), '--': ('r', 474), '/=': ('r', 474), '++': ('r', 474), '^': ('r', 474), '<<=': ('r', 474), '->': ('r', 474), '-=': ('r', 474), '->*': ('r', 474), '+=': ('r', 474), '>=': ('r', 474), '<=': ('r', 474), '||': ('r', 474), '>>=': ('r', 474), '&&': ('r', 474), '|': ('r', 474), '}': ('r', 474), '&=': ('r', 474), '{': ('r', 474), 'try': ('r', 474), '>>': ('r', 474), ']': ('r', 474), '*=': ('r', 474), '==': ('r', 474), '[': ('r', 474), '.*': ('r', 474)}, 1020),
        #STATE 1021
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 136)], {',': ('r', 561), '-': ('r', 561), '.': ('r', 561), '/': ('r', 561), '(': ('r', 561), ')': ('r', 561), '*': ('r', 561), '+': ('r', 561), '%': ('r', 561), '&': ('r', 561), '<': ('r', 561), '=': ('r', 561), '>': ('r', 561), '?': ('r', 561), '<<': ('r', 561), ':': ('r', 561), ';': ('r', 561), '...': ('r', 561), '|=': ('r', 561), '^=': ('r', 561), '%=': ('r', 561), '!=': ('r', 561), '--': ('r', 561), '/=': ('r', 561), '++': ('r', 561), '^': ('r', 561), '<<=': ('r', 561), '->': ('r', 561), '-=': ('r', 561), '->*': ('r', 561), '+=': ('r', 561), '>=': ('r', 561), '<=': ('r', 561), '||': ('r', 561), '>>=': ('r', 561), '&&': ('r', 561), '|': ('r', 561), '}': ('r', 561), '&=': ('r', 561), '{': ('r', 561), 'try': ('r', 561), '>>': ('r', 561), ']': ('r', 561), '*=': ('r', 561), '==': ('r', 561), '[': ('r', 561), '.*': ('r', 561)}, 1021),
        #STATE 1022
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 298)], {',': ('r', 529), '-': ('r', 529), '.': ('r', 529), '/': ('r', 529), '(': ('r', 529), ')': ('r', 529), '*': ('r', 529), '+': ('r', 529), '%': ('r', 529), '&': ('r', 529), '<': ('r', 529), '=': ('r', 529), '>': ('r', 529), '?': ('r', 529), '<<': ('r', 529), ':': ('r', 529), ';': ('r', 529), '...': ('r', 529), '|=': ('r', 529), '^=': ('r', 529), '%=': ('r', 529), '!=': ('r', 529), '--': ('r', 529), '/=': ('r', 529), '++': ('r', 529), '^': ('r', 529), '<<=': ('r', 529), '->': ('r', 529), '-=': ('r', 529), '->*': ('r', 529), '+=': ('r', 529), '>=': ('r', 529), '<=': ('r', 529), '||': ('r', 529), '>>=': ('r', 529), '&&': ('r', 529), '|': ('r', 529), '}': ('r', 529), '&=': ('r', 529), '{': ('r', 529), 'try': ('r', 529), '>>': ('r', 529), ']': ('r', 529), '*=': ('r', 529), '==': ('r', 529), '[': ('r', 529), '.*': ('r', 529)}, 1022),
        #STATE 1023
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 120)], {',': ('r', 444), '-': ('r', 444), '.': ('r', 444), '/': ('r', 444), '(': ('r', 444), ')': ('r', 444), '*': ('r', 444), '+': ('r', 444), '%': ('r', 444), '&': ('r', 444), '<': ('r', 444), '=': ('r', 444), '>': ('r', 444), '?': ('r', 444), '<<': ('r', 444), ':': ('r', 444), ';': ('r', 444), '...': ('r', 444), '|=': ('r', 444), '^=': ('r', 444), '%=': ('r', 444), '!=': ('r', 444), '--': ('r', 444), '/=': ('r', 444), '++': ('r', 444), '^': ('r', 444), '<<=': ('r', 444), '->': ('r', 444), '-=': ('r', 444), '->*': ('r', 444), '+=': ('r', 444), '>=': ('r', 444), '<=': ('r', 444), '||': ('r', 444), '>>=': ('r', 444), '&&': ('r', 444), '|': ('r', 444), '}': ('r', 444), '&=': ('r', 444), '{': ('r', 444), 'try': ('r', 444), '>>': ('r', 444), ']': ('r', 444), '*=': ('r', 444), '==': ('r', 444), '[': ('r', 444), '.*': ('r', 444)}, 1023),
        #STATE 1024
        State([("operator -> 'new'! | 'delete'! | '+'! | '-'! | '*'! | '/'! | '%'! | '^'! | '&'! | '|'! | '~'! | '!'! | '='! | '<'! | '>'! | '+='! | '-='! | '*='! | '/='! | '%='! | '^='! | '&='! | '|='! | '<<'! | '>>'! | '<<='! | '>>='! | '=='! | '!='! | '<='! | '>='! | '&&'! | '||'! | '++'! | '--'! | ','! | '->*'! | '->'!", 250)], {',': ('r', 498), '-': ('r', 498), '.': ('r', 498), '/': ('r', 498), '(': ('r', 498), ')': ('r', 498), '*': ('r', 498), '+': ('r', 498), '%': ('r', 498), '&': ('r', 498), '<': ('r', 498), '=': ('r', 498), '>': ('r', 498), '?': ('r', 498), '<<': ('r', 498), ':': ('r', 498), ';': ('r', 498), '...': ('r', 498), '|=': ('r', 498), '^=': ('r', 498), '%=': ('r', 498), '!=': ('r', 498), '--': ('r', 498), '/=': ('r', 498), '++': ('r', 498), '^': ('r', 498), '<<=': ('r', 498), '->': ('r', 498), '-=': ('r', 498), '->*': ('r', 498), '+=': ('r', 498), '>=': ('r', 498), '<=': ('r', 498), '||': ('r', 498), '>>=': ('r', 498), '&&': ('r', 498), '|': ('r', 498), '}': ('r', 498), '&=': ('r', 498), '{': ('r', 498), 'try': ('r', 498), '>>': ('r', 498), ']': ('r', 498), '*=': ('r', 498), '==': ('r', 498), '[': ('r', 498), '.*': ('r', 498)}, 1024),
        #STATE 1025
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 64), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('member_declarator -> declarator:d constant_initializer:init?', 21), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ('class_name -> template_id!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ('member_declarator -> declarator:d constant_initializer:init?', 21), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('declarator -> direct_declarator!', 14), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 93), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 16), ("member_declarator -> IDENTIFIER:name? ':' constant_expression:size", 21), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 58), ('direct_declarator -> declarator_id!', 21), ("member_declarator -> IDENTIFIER:name? ':' constant_expression:size", 38), ("direct_declarator -> direct_declarator:d '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 21), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ('declarator_id -> id_expression!', 17), ('id_expression -> unqualified_id!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("qualified_id -> '::' IDENTIFIER!", 16), ('declarator -> ptr_operator:op declarator:d', 14), ('id_expression -> qualified_id!', 17), ('namespace_name -> IDENTIFIER:name', 18), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 64), ('unqualified_id -> operator_function_id!', 18), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 64), ('unqualified_id -> IDENTIFIER:id', 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('member_declarator -> declarator:d pure_specifier', 21), ("ptr_operator -> '*' cv_qualifier!*:cv", 16), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ('template_name -> IDENTIFIER!', 17), ("ptr_operator -> '::'?:glbl nested_name_specifier:nns '*' cv_qualifier!*:cv", 27), ("operator_function_id -> 'operator' operator:op", 24), ("direct_declarator -> direct_declarator:d '[' constant_expression:dim? ']'", 21), ('unqualified_id -> conversion_function_id!', 18), ("ptr_operator -> '&'", 16), ("unqualified_id -> '~' class_name:name", 18), ("direct_declarator -> '(' declarator! ')'", 21), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {unqualified_id: ('g', 7), '(': ('s', 281), qualified_id: ('g', 4), '*': ('s', 223), template_name: ('g', 2), nested_name_specifier: ('g', 284), '&': ('s', 225), 'operator': ('s', 8), conversion_function_id: ('g', 12), '~': ('s', 45), IDENTIFIER: ('s', 473), ':': ('s', 814), ';': ('s', 1035), _113: ('g', 863), direct_declarator: ('g', 285), ptr_operator: ('g', 279), '::': ('s', 282), id_expression: ('g', 280), namespace_name: ('g', 5), declarator_id: ('g', 286), operator_function_id: ('g', 6), class_name: ('g', 11), member_declarator: ('g', 954), template_id: ('g', 44), declarator: ('g', 824)}, 1025),
        #STATE 1026
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("throw_expression -> 'throw' assignment_expression:v?", 20), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('pm_expression -> cast_expression!', 17), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("throw_expression -> 'throw' assignment_expression:v?", 20), ('assignment_expression -> conditional_expression!', 25), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 47), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('assignment_expression -> throw_expression!', 25), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('assignment_expression -> logical_or_expression:lhs assignment_operator:op assignment_expression:rhs', 25), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), CHARACTER_LITERAL: ('s', 108), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), '-': ('s', 81), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), _15: ('g', 303), type_name: ('g', 98), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), throw_expression: ('g', 91), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 77), logical_and_expression: ('g', 118), '++': ('s', 55), logical_or_expression: ('g', 82), and_expression: ('g', 72), 'dynamic_cast': ('s', 83), literal: ('g', 84), assignment_expression: ('g', 323), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), namespace_name: ('g', 5), nested_name_specifier: ('g', 95), new_expression: ('g', 94), 'throw': ('s', 96), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), '!': ('s', 104), unary_operator: ('g', 105), exclusive_or_expression: ('g', 121), FLOATING_LITERAL: ('s', 79), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), cast_expression: ('g', 66), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), template_id: ('g', 18), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 1026),
        #STATE 1027
        State([('init_declarator -> declarator:d initializer:init?', 43)], {',': ('r', 450), ';': ('r', 450)}, 1027),
        #STATE 1028
        State([("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 93)], {'-': ('r', 559), 'asm': ('r', 559), '(': ('r', 559), '*': ('r', 559), '+': ('r', 559), 'delete': ('r', 559), 'static_cast': ('r', 559), 'operator': ('r', 559), DECLARE_KEYWORD: ('r', 559), ACCESS_KEYWORD: ('r', 559), IDENTIFIER: ('r', 559), ';': ('r', 559), INTEGER_LITERAL: ('r', 559), 'extern': ('r', 559), 'default': ('r', 559), 'goto': ('r', 559), 'break': ('r', 559), 'new': ('r', 559), 'throw': ('r', 559), 'typedef': ('r', 559), '--': ('r', 559), '++': ('r', 559), 'dynamic_cast': ('r', 559), 'for': ('r', 559), 'export': ('r', 559), 'struct': ('r', 559), 'volatile': ('r', 559), 'template': ('r', 559), 'continue': ('r', 559), '&': ('r', 559), 'this': ('r', 559), 'if': ('r', 559), 'union': ('r', 559), 'virtual': ('r', 559), 'const_cast': ('r', 559), '::': ('r', 559), 'auto': ('r', 559), 'using': ('r', 559), 'namespace': ('r', 559), 'do': ('r', 559), '!': ('r', 559), '}': ('r', 559), '~': ('r', 559), 'return': ('r', 559), '{': ('r', 559), 'case': ('r', 559), TYPE_KEYWORD: ('r', 559), FLOATING_LITERAL: ('r', 559), 'sizeof': ('r', 559), 'else': ('r', 559), CHARACTER_LITERAL: ('r', 559), 'try': ('r', 559), 'reinterpret_cast': ('r', 559), BOOLEAN_LITERAL: ('r', 559), 'enum': ('r', 559), EOF: ('r', 559), STRING_LITERAL: ('r', 559), 'class': ('r', 559), CPP_INCLUDE: ('r', 559), 'typename': ('r', 559), 'while': ('r', 559), CPP_ERROR: ('r', 559), 'const': ('r', 559), 'switch': ('r', 559), 'typeid': ('r', 559)}, 1028),
        #STATE 1029
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("class_key -> 'class' | 'struct' | 'union'", 23), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 64), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("parameter_declaration -> type_descriptor:type declarator:dtor '=' assignment_expression:default", 25), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('raw_type_descriptor -> class_specifier!', 23), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ('raw_type_descriptor -> enum_specifier!', 23), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('parameter_declaration -> type_descriptor:type declarator:dtor', 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 64), ("parameter_declaration -> type_descriptor:type abstract_declarator:dtor? '=' assignment_expression:default", 25), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 64), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 13), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), None, ("raw_type_descriptor -> 'auto'", 23), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 32), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 64), ('parameter_declaration -> type_descriptor:type abstract_declarator:dtor?', 25), ("class_key -> 'class' | 'struct' | 'union'", 34), ("parameter_declaration_clause -> parameter_declaration!*,',':plist '...'?:etc", 66), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {template_name: ('g', 2), IDENTIFIER: ('s', 29), named_type_specifier: ('g', 126), 'union': ('s', 97), raw_type_descriptor: ('g', 54), 'enum': ('s', 117), cv_qualifier: ('g', 106), parameter_declaration: ('g', 190), type_name: ('g', 98), '::': ('s', 191), ')': ('r', 19), elaborated_type_specifier: ('g', 109), parameter_declaration_clause: ('g', 945), class_specifier: ('g', 75), 'struct': ('s', 58), '...': ('s', 192), class_name: ('g', 11), class_head: ('g', 20), namespace_name: ('g', 5), _100: ('g', 188), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), _80: ('g', 112), type_descriptor: ('g', 193), 'class': ('s', 115), 'typename': ('s', 166), 'auto': ('s', 90), 'volatile': ('s', 33), 'const': ('s', 35), nested_name_specifier: ('g', 189), _81: ('g', 88), template_id: ('g', 18), enum_specifier: ('g', 122)}, 1029),
        #STATE 1030
        State([('inclusive_or_expression -> exclusive_or_expression!', 27), ('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('relational_expression -> shift_expression!', 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ("multiplicative_expression -> multiplicative_expression:a '*' pm_expression:b", 29), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('conditional_expression -> logical_or_expression!', 26), ('unary_expression -> postfix_expression!', 20), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 64), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("equality_expression -> equality_expression:a '==' relational_expression:b", 23), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ('shift_expression -> additive_expression!', 20), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("exclusive_or_expression -> exclusive_or_expression:a '^' and_expression:b", 27), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 25), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ('multiplicative_expression -> pm_expression!', 29), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("logical_or_expression -> logical_and_expression:a '||' logical_or_expression:b", 25), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("direct_abstract_declarator -> direct_abstract_declarator:d? '[' constant_expression:dim? ']'", 89), ('id_expression -> unqualified_id!', 17), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ('and_expression -> equality_expression!', 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("additive_expression -> additive_expression:a '-' multiplicative_expression:b", 23), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('constant_expression -> conditional_expression!', 23), ('pm_expression -> cast_expression!', 17), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('logical_and_expression -> inclusive_or_expression!', 26), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("postfix_expression -> postfix_expression:v '++'", 22), ("relational_expression -> relational_expression:a '>' shift_expression:b", 25), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ('unqualified_id -> IDENTIFIER:id', 18), ("multiplicative_expression -> multiplicative_expression:a '%' pm_expression:b", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 23), ('unary_expression -> delete_expression!', 20), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("shift_expression -> shift_expression:a '>>' additive_expression:b", 20), ('namespace_name -> IDENTIFIER:name', 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("inclusive_or_expression -> inclusive_or_expression:a '|' exclusive_or_expression:b", 27), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('equality_expression -> relational_expression!', 23), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("multiplicative_expression -> multiplicative_expression:a '/' pm_expression:b", 29), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("conditional_expression -> logical_or_expression:c '?' expression:a ':' assignment_expression:b", 26), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('exclusive_or_expression -> and_expression!', 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ('class_name -> IDENTIFIER:name', 14), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("shift_expression -> shift_expression:a '<<' additive_expression:b", 20), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('cast_expression -> unary_expression!', 19), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('logical_or_expression -> logical_and_expression!', 25), ('primary_expression -> literal!', 22), ("unary_expression -> '--' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 25), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("additive_expression -> additive_expression:a '+' multiplicative_expression:b", 23), ("pm_expression -> pm_expression:a '.*' cast_expression:b", 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('simple_type_specifier -> named_type_specifier!', 25), ("operator_function_id -> 'operator' operator:op", 24), ("and_expression -> and_expression:a '&' equality_expression:b", 18), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('class_name -> template_id!', 14), ("relational_expression -> relational_expression:a '<' shift_expression:b", 25), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("logical_and_expression -> logical_and_expression:a '&&' inclusive_or_expression:b", 26), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ('literal -> FLOATING_LITERAL:v', 11), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('additive_expression -> multiplicative_expression!', 23), ("pm_expression -> pm_expression:a '->*' cast_expression:b", 17), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), constant_expression: ('g', 998), 'delete': ('s', 59), multiplicative_expression: ('g', 60), '&': ('s', 61), '!': ('s', 104), shift_expression: ('g', 65), relational_expression: ('g', 67), equality_expression: ('g', 70), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), and_expression: ('g', 72), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), inclusive_or_expression: ('g', 76), conditional_expression: ('g', 774), logical_and_expression: ('g', 118), '++': ('s', 55), '-': ('s', 81), logical_or_expression: ('g', 310), class_name: ('g', 11), 'dynamic_cast': ('s', 83), literal: ('g', 84), type_name: ('g', 98), simple_type_specifier: ('g', 86), primary_expression: ('g', 40), pm_expression: ('g', 73), id_expression: ('g', 114), unqualified_id: ('g', 7), 'const_cast': ('s', 92), qualified_id: ('g', 4), exclusive_or_expression: ('g', 121), nested_name_specifier: ('g', 95), new_expression: ('g', 94), additive_expression: ('g', 63), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), FLOATING_LITERAL: ('s', 79), 'sizeof': ('s', 107), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), 'reinterpret_cast': ('s', 110), operator_function_id: ('g', 6), '--': ('s', 111), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), ']': ('s', 370), 'typename': ('s', 180), BOOLEAN_LITERAL: ('s', 102), delete_expression: ('g', 119), cast_expression: ('g', 66), 'typeid': ('s', 38), IDENTIFIER: ('s', 3)}, 1030),
        #STATE 1031
        State([("base_specifier -> access_specifier:acc 'virtual'?:v '::'?:glbl nested_name_specifier:nns? class_name:name", 100)], {',': ('r', 535), '{': ('r', 535)}, 1031),
        #STATE 1032
        State([("conversion_function_id -> 'operator' conversion_type_id!", 55)], {',': ('r', 445), '-': ('r', 445), '.': ('r', 445), '/': ('r', 445), '(': ('r', 445), ')': ('r', 445), '*': ('r', 445), '+': ('r', 445), '%': ('r', 445), '&': ('r', 445), '<': ('r', 445), '=': ('r', 445), '>': ('r', 445), '?': ('r', 445), '<<': ('r', 445), ':': ('r', 445), ';': ('r', 445), '...': ('r', 445), '|=': ('r', 445), '^=': ('r', 445), '%=': ('r', 445), '!=': ('r', 445), '--': ('r', 445), '/=': ('r', 445), '++': ('r', 445), '*=': ('r', 445), '<<=': ('r', 445), '->': ('r', 445), '-=': ('r', 445), '->*': ('r', 445), '>>': ('r', 445), '>=': ('r', 445), '<=': ('r', 445), '||': ('r', 445), '>>=': ('r', 445), '&&': ('r', 445), '|': ('r', 445), '}': ('r', 445), '&=': ('r', 445), '{': ('r', 445), 'try': ('r', 445), '+=': ('r', 445), ']': ('r', 445), '^': ('r', 445), '==': ('r', 445), '[': ('r', 445), '.*': ('r', 445)}, 1032),
        #STATE 1033
        State([("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 75)], {',': ('r', 508), '-': ('r', 508), '.': ('r', 508), '/': ('r', 508), '(': ('r', 508), ')': ('r', 508), '*': ('r', 508), '==': ('r', 508), '%': ('r', 508), '&': ('r', 508), '<': ('r', 508), '=': ('r', 508), '>': ('r', 508), '?': ('r', 508), '<<': ('r', 508), ':': ('r', 508), ';': ('r', 508), '...': ('r', 508), '|=': ('r', 508), '^=': ('r', 508), '%=': ('r', 508), '!=': ('r', 508), '--': ('r', 508), '/=': ('r', 508), '++': ('r', 508), '^': ('r', 508), '<<=': ('r', 508), '->': ('r', 508), '-=': ('r', 508), '->*': ('r', 508), '+=': ('r', 508), '>=': ('r', 508), '<=': ('r', 508), '||': ('r', 508), '>>=': ('r', 508), '&&': ('r', 508), '|': ('r', 508), '}': ('r', 508), '&=': ('r', 508), '>>': ('r', 508), '+': ('r', 508), ']': ('r', 508), '*=': ('r', 508), '[': ('r', 508), '.*': ('r', 508)}, 1033),
        #STATE 1034
        State([("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 41)], {'while': ('s', 1043)}, 1034),
        #STATE 1035
        State([("member_declaration -> decl_attrib!*:attrs type_descriptor:type  member_declarator!*,',':dtor ';'", 96)], {'union': ('r', 497), '::': ('r', 497), 'export': ('r', 497), 'using': ('r', 497), 'virtual': ('r', 497), DECLARE_KEYWORD: ('r', 497), '}': ('r', 497), '~': ('r', 497), IDENTIFIER: ('r', 497), 'operator': ('r', 497), 'extern': ('r', 497), 'typedef': ('r', 497), TYPE_KEYWORD: ('r', 497), ACCESS_KEYWORD: ('r', 497), 'enum': ('r', 497), 'class': ('r', 497), 'typename': ('r', 497), 'struct': ('r', 497), 'volatile': ('r', 497), 'template': ('r', 497), 'const': ('r', 497), 'auto': ('r', 497)}, 1035),
        #STATE 1036
        State([("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('template_name -> IDENTIFIER!', 17), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 82)], {template_name: ('g', 2), template_id: ('g', 1037), IDENTIFIER: ('s', 216)}, 1036),
        #STATE 1037
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97)], {'(': ('s', 631)}, 1037),
        #STATE 1038
        State([("pm_expression -> pm_expression:a '->*' cast_expression:b", 54)], {',': ('r', 453), '-': ('r', 453), '/': ('r', 453), '|=': ('r', 453), ')': ('r', 453), '*': ('r', 453), '==': ('r', 453), '%': ('r', 453), '&': ('r', 453), '>>=': ('r', 453), '&&': ('r', 453), '<': ('r', 453), '=': ('r', 453), '>': ('r', 453), '?': ('r', 453), '<<': ('r', 453), ':': ('r', 453), ';': ('r', 453), '...': ('r', 453), '<=': ('r', 453), '^=': ('r', 453), '%=': ('r', 453), '|': ('r', 453), '!=': ('r', 453), '}': ('r', 453), '/=': ('r', 453), '+': ('r', 453), '||': ('r', 453), '*=': ('r', 453), '&=': ('r', 453), '+=': ('r', 453), ']': ('r', 453), '^': ('r', 453), '<<=': ('r', 453), '-=': ('r', 453), '.*': ('r', 453), '->*': ('r', 453), '>>': ('r', 453), '>=': ('r', 453)}, 1038),
        #STATE 1039
        State([("cast_expression -> '(' type_id:t ')' cast_expression:v", 52)], {',': ('r', 459), '-': ('r', 459), '/': ('r', 459), '|=': ('r', 459), ')': ('r', 459), '*': ('r', 459), '==': ('r', 459), '%': ('r', 459), '&': ('r', 459), '>>=': ('r', 459), '&&': ('r', 459), '<': ('r', 459), '=': ('r', 459), '>': ('r', 459), '?': ('r', 459), '<<': ('r', 459), ':': ('r', 459), ';': ('r', 459), '...': ('r', 459), '<=': ('r', 459), '^=': ('r', 459), '%=': ('r', 459), '|': ('r', 459), '!=': ('r', 459), '}': ('r', 459), '/=': ('r', 459), '+': ('r', 459), '||': ('r', 459), '^': ('r', 459), '&=': ('r', 459), '>>': ('r', 459), ']': ('r', 459), '*=': ('r', 459), '<<=': ('r', 459), '-=': ('r', 459), '.*': ('r', 459), '->*': ('r', 459), '+=': ('r', 459), '>=': ('r', 459)}, 1039),
        #STATE 1040
        State([("relational_expression -> relational_expression:a '>' shift_expression:b", 49), ("equality_expression -> equality_expression:a '!=' relational_expression:b", 71), ("relational_expression -> relational_expression:a '<' shift_expression:b", 49), ("relational_expression -> relational_expression:a '<=' shift_expression:b", 49), ("relational_expression -> relational_expression:a '>=' shift_expression:b", 49)], {',': ('r', 461), '<=': ('s', 368), ')': ('r', 461), '==': ('r', 461), '&': ('r', 461), '>>=': ('r', 461), '&&': ('r', 461), '|': ('r', 461), '=': ('r', 461), '>': ('c', [('s', 367), ('r', 461)]), '?': ('r', 461), '&=': ('r', 461), ':': ('r', 461), ';': ('r', 461), '...': ('r', 461), '|=': ('r', 461), '^=': ('r', 461), '%=': ('r', 461), '<': ('s', 366), '!=': ('r', 461), '}': ('r', 461), '/=': ('r', 461), '||': ('r', 461), '*=': ('r', 461), ']': ('r', 461), '^': ('r', 461), '<<=': ('r', 461), '-=': ('r', 461), '+=': ('r', 461), '>=': ('s', 369)}, 1040),
        #STATE 1041
        State([('unary_expression -> new_expression!', 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 21), ('primary_expression -> id_expression!', 22), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("primary_expression -> 'this'", 22), ("postfix_expression -> postfix_expression:v '->' pseudo_destructor_name:name", 22), ('unary_expression -> postfix_expression!', 20), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22), ('cast_expression -> unary_expression!', 19), ('simple_type_specifier -> named_type_specifier!', 25), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ('unary_expression -> unary_operator:op cast_expression:v', 20), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 25), ("postfix_expression -> 'dynamic_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("primary_expression -> '(' expression! ')'", 22), ('id_expression -> qualified_id!', 17), ("postfix_expression -> 'static_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> postfix_expression:v '(' assignment_expression!*,',':args ')'", 22), ('id_expression -> unqualified_id!', 17), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 32), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> BOOLEAN_LITERAL:v', 11), ('postfix_expression -> primary_expression!', 22), ("cast_expression -> '(' type_id:t ')' cast_expression:v", 37), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' unary_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unary_expression -> '--' cast_expression:v", 20), ("qualified_id -> '::' IDENTIFIER!", 16), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 53), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('unqualified_id -> IDENTIFIER:id', 18), ('namespace_name -> IDENTIFIER:name', 18), ("postfix_expression -> postfix_expression:v '--'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("operator_function_id -> 'operator' operator:op", 24), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("postfix_expression -> 'typeid' '(' expression:v ')'", 22), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("delete_expression -> '::'? 'delete' '[' ']' cast_expression:v", 27), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 27), ('type_name -> IDENTIFIER:name', 13), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("unary_expression -> '++' cast_expression:v", 20), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ('unqualified_id -> conversion_function_id!', 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 18), ('literal -> INTEGER_LITERAL:v', 11), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ('literal -> STRING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("postfix_expression -> postfix_expression:v '.' pseudo_destructor_name:name", 22), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'reinterpret_cast' '<' type_id:t '>' '(' expression:v ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("postfix_expression -> simple_type_specifier:t '(' assignment_expression!*,',':args ')'", 22), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("postfix_expression -> 'typeid' '(' type_id:t ')'", 22), ('primary_expression -> literal!', 22), ("postfix_expression -> postfix_expression:v '++'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 18), ("postfix_expression -> postfix_expression:v '.' 'template'?:t id_expression:id", 22), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 39), ('simple_type_specifier -> TYPE_KEYWORD:kw', 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('literal -> FLOATING_LITERAL:v', 11), ("postfix_expression -> postfix_expression:v '[' expression:i ']'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("unary_expression -> 'sizeof' '(' type_id:t ')'", 20), ('unary_expression -> delete_expression!', 20), ('class_name -> template_id!', 14), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ('literal -> CHARACTER_LITERAL:v', 11), ("delete_expression -> '::'? 'delete' cast_expression:v", 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("qualified_id -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 22), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("delete_expression -> '::'? 'delete' cast_expression:v", 21), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 18), ("new_expression -> '::'?:glbl 'new' new_placement:place? '(' type_id:t ')' new_initializer:init?", 29), ("unqualified_id -> '~' class_name:name", 18), ("unary_operator -> '*'! | '&'! | '+'! | '-'! | '!'! | '~'!", 46), ('unqualified_id -> operator_function_id!', 18), ("qualified_id -> '::' (operator_function_id!|template_id!)", 16), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ("new_expression -> '::'?:glbl 'new' new_placement:place? new_type_id:t new_initializer:init?", 29), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 22), ('template_name -> IDENTIFIER!', 17), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("postfix_expression -> postfix_expression:v '->' 'template'?:t id_expression:id", 22)], {template_name: ('g', 2), '(': ('s', 56), named_type_specifier: ('g', 177), '*': ('s', 93), 'reinterpret_cast': ('s', 110), 'delete': ('s', 59), simple_type_specifier: ('g', 86), '&': ('s', 61), type_name: ('g', 98), IDENTIFIER: ('s', 3), INTEGER_LITERAL: ('s', 87), 'static_cast': ('s', 71), class_name: ('g', 11), '::': ('s', 64), 'new': ('s', 74), namespace_name: ('g', 5), '--': ('s', 111), '++': ('s', 55), '-': ('s', 81), 'dynamic_cast': ('s', 83), literal: ('g', 84), primary_expression: ('g', 40), id_expression: ('g', 114), 'sizeof': ('s', 107), 'const_cast': ('s', 92), qualified_id: ('g', 4), FLOATING_LITERAL: ('s', 79), nested_name_specifier: ('g', 95), '!': ('s', 104), postfix_expression: ('g', 99), '~': ('s', 100), 'operator': ('s', 8), unary_expression: ('g', 69), 'this': ('s', 103), unary_operator: ('g', 105), CHARACTER_LITERAL: ('s', 108), new_expression: ('g', 94), TYPE_KEYWORD: ('s', 178), conversion_function_id: ('g', 12), BOOLEAN_LITERAL: ('s', 102), STRING_LITERAL: ('s', 113), template_id: ('g', 18), '+': ('s', 80), 'typename': ('s', 180), unqualified_id: ('g', 7), operator_function_id: ('g', 6), delete_expression: ('g', 119), cast_expression: ('g', 1039), 'typeid': ('s', 38)}, 1041),
        #STATE 1042
        State([("handler -> 'catch' '(' exception_declaration:exc ')' compound_statement:body", 49)], {')': ('s', 667)}, 1042),
        #STATE 1043
        State([("iteration_statement -> 'do' statement:st 'while' '(' expression:cond ')' ';'", 49)], {'(': ('s', 203)}, 1043),
        #STATE 1044
        State([("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id '(' assignment_expression!*,',':args ')'", 97), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 100)], {',': ('r', 323), '(': ('c', [('s', 500), ('r', 323)]), '::': ('r', 323), '*': ('r', 323), '&': ('r', 323), '[': ('r', 323), '~': ('r', 323), '>': ('r', 323), IDENTIFIER: ('r', 323), 'operator': ('r', 323), ';': ('r', 323), ')': ('r', 323)}, 1044),
        #STATE 1045
        State([("expression -> expression:a ',' assignment_expression:b", 27), ("postfix_expression -> 'const_cast' '<' type_id:t '>' '(' expression:v ')'", 70)], {',': ('s', 272), ')': ('s', 715)}, 1045),
        #STATE 1046
        State([('template_name -> IDENTIFIER!', 27), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 86), ("postfix_expression -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name '(' assignment_expression!*,',':args ')'", 86)], {'<': ('r', 2), '(': ('s', 584)}, 1046),
        #STATE 1047
        State([("base_specifier -> 'virtual' access_specifier:acc? '::'?:glbl nested_name_specifier:nns? class_name:name", 98)], {',': ('r', 485), '{': ('r', 485)}, 1047),
        #STATE 1048
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 55), ('class_name -> IDENTIFIER:name', 14), ('namespace_name -> IDENTIFIER:name', 18), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ('class_name -> template_id!', 14), ('template_name -> IDENTIFIER!', 17), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26)], {template_name: ('g', 2), IDENTIFIER: ('s', 414), namespace_name: ('g', 5), nested_name_specifier: ('g', 1006), class_name: ('g', 11), template_id: ('g', 44)}, 1048),
        #STATE 1049
        State([("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 102)], {'sizeof': ('r', 486), '-': ('r', 486), '++': ('r', 486), '(': ('r', 486), '*': ('r', 486), '+': ('r', 486), 'delete': ('r', 486), 'static_cast': ('r', 486), '{': ('r', 486), DECLARE_KEYWORD: ('r', 486), ACCESS_KEYWORD: ('r', 486), IDENTIFIER: ('r', 486), 'while': ('r', 486), INTEGER_LITERAL: ('r', 486), 'extern': ('r', 486), 'default': ('r', 486), 'goto': ('r', 486), 'new': ('r', 486), 'throw': ('r', 486), 'typedef': ('r', 486), '--': ('r', 486), 'asm': ('r', 486), 'dynamic_cast': ('r', 486), 'for': ('r', 486), 'export': ('r', 486), 'struct': ('r', 486), 'volatile': ('r', 486), 'continue': ('r', 486), '&': ('r', 486), 'case': ('r', 486), 'if': ('r', 486), 'union': ('r', 486), 'virtual': ('r', 486), 'const_cast': ('r', 486), '::': ('r', 486), 'auto': ('r', 486), 'using': ('r', 486), 'namespace': ('r', 486), 'do': ('r', 486), '!': ('r', 486), '}': ('r', 486), '~': ('r', 486), 'return': ('r', 486), 'operator': ('r', 486), 'else': ('r', 486), 'this': ('r', 486), TYPE_KEYWORD: ('r', 486), FLOATING_LITERAL: ('r', 486), CPP_ERROR: ('r', 486), 'const': ('r', 486), CHARACTER_LITERAL: ('r', 486), 'try': ('r', 486), 'reinterpret_cast': ('r', 486), BOOLEAN_LITERAL: ('r', 486), 'enum': ('r', 486), EOF: ('r', 486), STRING_LITERAL: ('r', 486), 'class': ('r', 486), CPP_INCLUDE: ('r', 486), 'typename': ('r', 486), 'break': ('r', 486), 'template': ('r', 486), 'switch': ('r', 486), 'typeid': ('r', 486)}, 1049),
        #STATE 1050
        State([("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 99)], {'union': ('r', 560), '::': ('r', 560), 'namespace': ('r', 560), 'export': ('r', 560), 'using': ('r', 560), 'virtual': ('r', 560), DECLARE_KEYWORD: ('r', 560), '}': ('r', 560), '~': ('r', 560), IDENTIFIER: ('r', 560), 'operator': ('r', 560), 'extern': ('r', 560), 'typedef': ('r', 560), TYPE_KEYWORD: ('r', 560), ACCESS_KEYWORD: ('r', 560), 'asm': ('r', 560), 'enum': ('r', 560), EOF: ('r', 560), 'class': ('r', 560), CPP_INCLUDE: ('r', 560), 'typename': ('r', 560), CPP_ERROR: ('r', 560), 'struct': ('r', 560), 'volatile': ('r', 560), 'template': ('r', 560), 'const': ('r', 560), 'auto': ('r', 560)}, 1050),
        #STATE 1051
        State([("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 56)], {'(': ('r', 306)}, 1051),
        #STATE 1052
        State([("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 58)], {')': ('s', 919)}, 1052),
        #STATE 1053
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_name -> IDENTIFIER:name', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> enum_specifier!', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('type_name -> IDENTIFIER:name', 13), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 39), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("exception_specification -> 'throw' '(' type_id!*',':xlist ')'", 48), ('raw_type_descriptor -> named_type_specifier!', 23), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('type_id -> type_descriptor:type abstract_declarator:d?', 11), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {',': ('s', 1016), template_name: ('g', 2), IDENTIFIER: ('s', 29), named_type_specifier: ('g', 126), class_head: ('g', 20), raw_type_descriptor: ('g', 54), class_specifier: ('g', 75), nested_name_specifier: ('g', 189), type_name: ('g', 98), 'union': ('s', 97), elaborated_type_specifier: ('g', 109), '::': ('s', 191), enum_specifier: ('g', 122), class_name: ('g', 11), _80: ('g', 112), cv_qualifier: ('g', 106), TYPE_KEYWORD: ('s', 162), class_key: ('g', 78), template_id: ('g', 18), 'enum': ('s', 117), _81: ('g', 88), 'class': ('s', 115), type_id: ('g', 695), 'typename': ('s', 166), namespace_name: ('g', 5), 'struct': ('s', 58), 'volatile': ('s', 33), 'const': ('s', 35), type_descriptor: ('g', 240), 'auto': ('s', 90)}, 1053),
        #STATE 1054
        State([("explicit_instantiation -> 'template' declaration:decl", 48)], {'union': ('r', 503), '::': ('r', 503), 'namespace': ('r', 503), 'export': ('r', 503), 'using': ('r', 503), 'virtual': ('r', 503), DECLARE_KEYWORD: ('r', 503), '}': ('r', 503), '~': ('r', 503), IDENTIFIER: ('r', 503), 'operator': ('r', 503), 'extern': ('r', 503), 'typedef': ('r', 503), TYPE_KEYWORD: ('r', 503), ACCESS_KEYWORD: ('r', 503), 'asm': ('r', 503), 'enum': ('r', 503), EOF: ('r', 503), 'class': ('r', 503), CPP_INCLUDE: ('r', 503), 'typename': ('r', 503), CPP_ERROR: ('r', 503), 'struct': ('r', 503), 'volatile': ('r', 503), 'template': ('r', 503), 'const': ('r', 503), 'auto': ('r', 503)}, 1054),
        #STATE 1055
        State([("jump_statement -> 'goto' IDENTIFIER:lbl ';'", 43)], {'-': ('r', 504), 'asm': ('r', 504), '(': ('r', 504), '*': ('r', 504), '+': ('r', 504), 'delete': ('r', 504), 'static_cast': ('r', 504), 'virtual': ('r', 504), DECLARE_KEYWORD: ('r', 504), IDENTIFIER: ('r', 504), 'while': ('r', 504), INTEGER_LITERAL: ('r', 504), 'extern': ('r', 504), 'default': ('r', 504), 'goto': ('r', 504), 'new': ('r', 504), 'class': ('r', 504), 'typedef': ('r', 504), '--': ('r', 504), '++': ('r', 504), 'dynamic_cast': ('r', 504), 'for': ('r', 504), 'continue': ('r', 504), 'struct': ('r', 504), 'volatile': ('r', 504), 'namespace': ('r', 504), '&': ('r', 504), 'if': ('r', 504), 'union': ('r', 504), 'const_cast': ('r', 504), '::': ('r', 504), 'auto': ('r', 504), 'using': ('r', 504), 'do': ('r', 504), 'this': ('r', 504), 'try': ('r', 504), '~': ('r', 504), 'return': ('r', 504), '{': ('r', 504), 'case': ('r', 504), '!': ('r', 504), TYPE_KEYWORD: ('r', 504), FLOATING_LITERAL: ('r', 504), 'sizeof': ('r', 504), 'else': ('r', 504), CHARACTER_LITERAL: ('r', 504), '}': ('r', 504), 'reinterpret_cast': ('r', 504), BOOLEAN_LITERAL: ('r', 504), 'enum': ('r', 504), STRING_LITERAL: ('r', 504), 'throw': ('r', 504), 'typename': ('r', 504), 'break': ('r', 504), 'operator': ('r', 504), CPP_ERROR: ('r', 504), 'const': ('r', 504), 'switch': ('r', 504), 'typeid': ('r', 504)}, 1055),
        #STATE 1056
        State([("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 100)], {'-': ('r', 506), 'asm': ('r', 506), '(': ('r', 506), '*': ('r', 506), '+': ('r', 506), 'delete': ('r', 506), 'static_cast': ('r', 506), 'virtual': ('r', 506), '!': ('r', 506), ACCESS_KEYWORD: ('r', 506), IDENTIFIER: ('r', 506), 'while': ('r', 506), INTEGER_LITERAL: ('r', 506), 'typedef': ('r', 506), 'default': ('r', 506), 'goto': ('r', 506), 'new': ('r', 506), 'throw': ('r', 506), 'extern': ('r', 506), '--': ('r', 506), '++': ('r', 506), 'dynamic_cast': ('r', 506), 'for': ('r', 506), 'export': ('r', 506), 'struct': ('r', 506), 'template': ('r', 506), 'continue': ('r', 506), '&': ('r', 506), 'this': ('r', 506), CPP_ERROR: ('r', 506), 'if': ('r', 506), 'const_cast': ('r', 506), '::': ('r', 506), 'auto': ('r', 506), 'using': ('r', 506), 'volatile': ('r', 506), 'namespace': ('r', 506), 'union': ('r', 506), DECLARE_KEYWORD: ('r', 506), '}': ('r', 506), '~': ('r', 506), 'return': ('r', 506), 'do': ('r', 506), '{': ('r', 506), 'case': ('r', 506), TYPE_KEYWORD: ('r', 506), FLOATING_LITERAL: ('r', 506), 'sizeof': ('r', 506), 'else': ('r', 506), CHARACTER_LITERAL: ('r', 506), 'try': ('r', 506), 'reinterpret_cast': ('r', 506), BOOLEAN_LITERAL: ('r', 506), 'enum': ('r', 506), EOF: ('r', 506), STRING_LITERAL: ('r', 506), 'class': ('r', 506), CPP_INCLUDE: ('r', 506), 'typename': ('r', 506), 'break': ('r', 506), 'operator': ('r', 506), 'const': ('r', 506), 'switch': ('r', 506), 'typeid': ('r', 506)}, 1056),
        #STATE 1057
        State([('decl_attrib -> DECLARE_KEYWORD!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('named_namespace_definition -> original_namespace_definition!', 30), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_head -> decl_attrib!*:attrs cd_declarator:dtor', 37), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 42), ('namespace_definition -> unnamed_namespace_definition!', 24), ('function_head -> decl_attrib!*:attrs type_descriptor:type declarator:dtor', 37), ("cv_qualifier -> 'volatile'!", 16), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 20), ('raw_type_descriptor -> class_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("linkage_specification -> 'extern' STRING_LITERAL:link declaration:decl", 25), ('declaration -> function_definition!', 15), ("cv_qualifier -> 'const'!", 16), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ('block_declaration -> using_declaration!', 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 20), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 40), ("unnamed_namespace_definition -> 'namespace' '{' namespace_body:body '}'", 32), ('type_name -> IDENTIFIER:name', 13), ("original_namespace_definition -> 'namespace' IDENTIFIER:name '{' namespace_body:body '}'", 33), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ("asm_definition -> 'asm' '{' STRING_LITERAL:asm '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("explicit_instantiation -> 'template' declaration:decl", 26), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> template_declaration!', 15), ('declaration -> CPP_INCLUDE!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("decl_attrib -> 'typedef'!", 15), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('block_declaration -> namespace_alias_definition!', 21), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('declaration -> linkage_specification!', 15), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('type_name -> template_id!', 13), ("simple_declaration -> (class_specifier!|enum_specifier!) ';'", 23), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ('function_definition -> function_head:head function_try_block:tryb', 23), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ('class_head -> class_key:t base_clause:bases?', 14), ("cd_declarator -> cd_id:d '(' parameter_declaration_clause:params ')' exception_specification:excspec?", 17), ("explicit_specialization -> 'template' '<' '>' declaration:decl", 27), ('declaration -> namespace_definition!', 15), ("raw_type_descriptor -> 'auto'", 23), ('block_declaration -> asm_definition!', 21), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ('block_declaration -> simple_declaration!', 21), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 9), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("linkage_specification -> 'extern' STRING_LITERAL:link '{' declaration!*:body '}'", 77), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> enum_specifier!', 23), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('declaration -> CPP_ERROR!', 15), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('function_definition -> function_head:head ctor_initializer:init? function_body:body', 23), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 24), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ('class_name -> IDENTIFIER:name', 14), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("using_declaration -> 'using' '::' unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('block_declaration -> using_directive!', 21), ("template_declaration -> 'export'?:exp 'template' '<' template_parameter!+,',':plist '>' declaration:decl", 38), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("decl_attrib -> 'virtual'!", 15), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 9), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('template_name -> IDENTIFIER!', 17), ("class_key -> 'class' | 'struct' | 'union'", 34), ('declaration -> explicit_instantiation!', 15), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 9), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("namespace_alias_definition -> 'namespace' IDENTIFIER:name '=' qualified_namespace_specifier:ns ';'", 30), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('class_name -> template_id!', 14), ("using_directive -> 'using' 'namespace' '::'?:glbl nested_name_specifier:nns? namespace_name:name ';'", 19), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 20), ('namespace_definition -> named_namespace_definition!', 24), ("simple_declaration -> elaborated_type_specifier! ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('translation_unit -> declaration!*:decls', 20), ("simple_declaration -> decl_attrib!*:attrs cd_declarator!+,',':dtor ';'", 42), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> named_type_specifier!', 23), ('declaration -> block_declaration!', 15), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('declaration -> explicit_specialization!', 15), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("decl_attrib -> 'extern'!", 15), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 21), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ("simple_declaration -> decl_attrib!*:attrs type_descriptor:type init_declarator!+,',':dtor ';'", 22), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {decl_attrib: ('g', 28), raw_type_descriptor: ('g', 54), named_type_specifier: ('g', 126), 'union': ('s', 97), function_definition: ('g', 128), 'virtual': ('s', 130), explicit_specialization: ('g', 157), cd_id: ('g', 164), elaborated_type_specifier: ('g', 134), enum_specifier: ('g', 135), 'extern': ('s', 139), class_name: ('g', 11), using_directive: ('g', 137), class_specifier: ('g', 138), 'typedef': ('s', 136), namespace_definition: ('g', 140), CPP_INCLUDE: ('s', 129), named_namespace_definition: ('g', 142), _75: ('g', 152), 'asm': ('s', 125), original_namespace_definition: ('g', 144), explicit_instantiation: ('g', 146), _81: ('g', 88), type_name: ('g', 131), unnamed_namespace_definition: ('g', 145), 'export': ('s', 143), 'struct': ('s', 58), 'volatile': ('s', 33), namespace_alias_definition: ('g', 161), asm_definition: ('g', 149), function_head: ('g', 150), 'auto': ('s', 90), using_declaration: ('g', 127), _80: ('g', 112), '::': ('s', 153), namespace_name: ('g', 5), 'using': ('s', 154), nested_name_specifier: ('g', 155), linkage_specification: ('g', 156), _73: ('g', 133), conversion_function_id: ('g', 158), '~': ('s', 159), DECLARE_KEYWORD: ('s', 160), 'namespace': ('s', 148), template_name: ('g', 2), class_head: ('g', 20), cv_qualifier: ('g', 106), 'const': ('s', 35), TYPE_KEYWORD: ('s', 162), '}': ('s', 371), cd_declarator: ('g', 163), simple_declaration: ('g', 167), 'enum': ('s', 117), declaration: ('g', 132), type_descriptor: ('g', 169), 'class': ('s', 115), block_declaration: ('g', 141), 'typename': ('s', 166), CPP_ERROR: ('s', 151), 'operator': ('s', 168), template_declaration: ('g', 165), 'template': ('s', 147), template_id: ('g', 18), class_key: ('g', 78), IDENTIFIER: ('s', 29)}, 1057),
        #STATE 1058
        State([("direct_abstract_declarator -> direct_abstract_declarator:d? '(' parameter_declaration_clause:params ')' cv_qualifier!*:cv exception_specification:excspec?", 145)], {',': ('r', 550), 'union': ('r', 550), '(': ('r', 550), ')': ('r', 550), 'struct': ('r', 550), TYPE_KEYWORD: ('r', 550), 'enum': ('r', 550), 'typename': ('r', 550), 'class': ('r', 550), '=': ('r', 550), '>': ('r', 550), '[': ('r', 550), IDENTIFIER: ('r', 550), 'auto': ('r', 550), 'volatile': ('r', 550), '...': ('r', 550), 'const': ('r', 550), '::': ('r', 550)}, 1058),
        #STATE 1059
        State([('unqualified_id -> operator_function_id!', 18), ("operator_function_id -> 'operator' operator:op", 24), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("using_declaration -> 'using' 'typename'?:tn '::'?:glbl nested_name_specifier:nns unqualified_id:id ';'", 81), ('unqualified_id -> IDENTIFIER:id', 18), ("unqualified_id -> '~' class_name:name", 18), ('unqualified_id -> conversion_function_id!', 18)], {unqualified_id: ('g', 643), '~': ('s', 45), IDENTIFIER: ('s', 314), conversion_function_id: ('g', 12), operator_function_id: ('g', 6), 'operator': ('s', 8)}, 1059),
        #STATE 1060
        State([("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 38), ("exception_declaration -> '...'", 25), ('namespace_name -> IDENTIFIER:name', 18), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("cv_qualifier -> 'const'!", 16), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ('class_name -> IDENTIFIER:name', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('raw_type_descriptor -> enum_specifier!', 23), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ("cv_qualifier -> 'volatile'!", 16), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("class_specifier -> class_head!! '{' member_specification!*:body '}'", 19), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('exception_declaration -> type_descriptor:type ( declarator:dtor | abstract_declarator:dtor )?', 25), ("enum_specifier -> 'enum' IDENTIFIER:name? '{' enumerator_definition!*,',':elist '}'", 18), ('template_name -> IDENTIFIER!', 17), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ('raw_type_descriptor -> class_specifier!', 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 26), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_name -> template_id!', 14), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ("handler -> 'catch' '(' exception_declaration:exc ')' compound_statement:body", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('exception_declaration -> type_descriptor:type ( declarator:dtor | abstract_declarator:dtor )?', 25), ('type_name -> IDENTIFIER:name', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 35), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ("class_key -> 'class' | 'struct' | 'union'", 13), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("elaborated_type_specifier -> class_key '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ('class_head -> class_key:t base_clause:bases?', 14), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('raw_type_descriptor -> named_type_specifier!', 23), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 35), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29), ("class_key -> 'class' | 'struct' | 'union'", 23), ('raw_type_descriptor -> TYPE_KEYWORD!+:kws', 23), ('class_head -> class_key:t nested_name_specifier:nns? IDENTIFIER:name base_clause:bases?', 14), ('exception_declaration -> type_descriptor:type ( declarator:dtor | abstract_declarator:dtor )?', 25), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ("raw_type_descriptor -> 'auto'", 23), ('type_descriptor -> cv_qualifier!+:cv raw_type_descriptor:t', 19), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 24), ('class_head -> class_key:t nested_name_specifier:nns? template_id:tid base_clause:bases?', 14), ('type_descriptor -> raw_type_descriptor!', 19), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 42), ('class_head -> class_key:t base_clause:bases?', 14), ("class_key -> 'class' | 'struct' | 'union'", 34), ('raw_type_descriptor -> elaborated_type_specifier!', 23), ('type_name -> template_id!', 13), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 24), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns 'template'? template_id:id", 29), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 26), ("elaborated_type_specifier -> 'typename' '::'?:glbl nested_name_specifier:nns IDENTIFIER:name", 29), ("elaborated_type_specifier -> 'enum' '::'?:glbl nested_name_specifier:nns? IDENTIFIER:name", 29)], {named_type_specifier: ('g', 126), 'union': ('s', 97), _80: ('g', 112), raw_type_descriptor: ('g', 54), nested_name_specifier: ('g', 189), type_name: ('g', 98), type_descriptor: ('g', 742), elaborated_type_specifier: ('g', 109), enum_specifier: ('g', 122), 'struct': ('s', 58), template_name: ('g', 2), class_name: ('g', 11), exception_declaration: ('g', 1042), '...': ('s', 993), '::': ('s', 191), cv_qualifier: ('g', 106), class_head: ('g', 20), class_key: ('g', 78), TYPE_KEYWORD: ('s', 162), 'enum': ('s', 117), class_specifier: ('g', 75), 'class': ('s', 115), 'typename': ('s', 166), namespace_name: ('g', 5), 'auto': ('s', 90), 'volatile': ('s', 33), 'const': ('s', 35), _81: ('g', 88), template_id: ('g', 18), IDENTIFIER: ('s', 29)}, 1060),
        #STATE 1061
        State([("base_specifier -> '::'?:glbl nested_name_specifier:nns? class_name:name", 66), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63), ("nested_name_specifier -> (class_name!|namespace_name!) '::' 'template' nested_name_specifier!", 55), ("nested_name_specifier -> (class_name:name|namespace_name:name) '::' nested_name_specifier:nns?", 63)], {',': ('r', 544), '::': ('s', 237), '{': ('r', 544)}, 1061),
        #STATE 1062
        State([('type_name -> IDENTIFIER:name', 13), ("pseudo_destructor_name -> '::'?:glbl nested_name_specifier:nns? type_name:t '::' '~' type_name:tn", 85), ('template_name -> IDENTIFIER!', 17), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {template_id: ('g', 26), template_name: ('g', 2), IDENTIFIER: ('s', 24), type_name: ('g', 870)}, 1062),
        #STATE 1063
        State([("ctor_initializer -> ':' mem_initializer!+,','!", 20), ("compound_statement -> '{' statement!*:sts '}'", 22), ("function_try_block -> 'try' ctor_initializer:init? function_body:body handler!+:handlers", 28), ('function_body -> compound_statement!', 17), ("function_try_block -> 'try' ctor_initializer:init? function_body:body handler!+:handlers", 51), ("compound_statement -> '{' statement!*:sts '}'", 22)], {compound_statement: ('g', 985), function_body: ('g', 623), ctor_initializer: ('g', 1064), ':': ('s', 515), '{': ('s', 329)}, 1063),
        #STATE 1064
        State([("compound_statement -> '{' statement!*:sts '}'", 22), ("function_try_block -> 'try' ctor_initializer:init? function_body:body handler!+:handlers", 51), ("compound_statement -> '{' statement!*:sts '}'", 22), ('function_body -> compound_statement!', 17)], {function_body: ('g', 827), compound_statement: ('g', 985), '{': ('s', 329)}, 1064),
        #STATE 1065
        State([('function_definition -> function_head:head ctor_initializer:init? function_body:body', 78)], {'union': ('r', 543), '::': ('r', 543), 'namespace': ('r', 543), 'export': ('r', 543), 'using': ('r', 543), 'virtual': ('r', 543), DECLARE_KEYWORD: ('r', 543), '}': ('r', 543), '~': ('r', 543), IDENTIFIER: ('r', 543), ';': ('r', 543), 'typedef': ('r', 543), 'operator': ('r', 543), 'extern': ('r', 543), TYPE_KEYWORD: ('r', 543), ACCESS_KEYWORD: ('r', 543), 'asm': ('r', 543), 'enum': ('r', 543), EOF: ('r', 543), 'class': ('r', 543), CPP_INCLUDE: ('r', 543), 'typename': ('r', 543), CPP_ERROR: ('r', 543), 'struct': ('r', 543), 'volatile': ('r', 543), 'template': ('r', 543), 'const': ('r', 543), 'auto': ('r', 543)}, 1065),
        #STATE 1066
        State([('type_name -> IDENTIFIER:name', 13), ("cd_id -> '::'?:glbl nested_name_specifier:nns? '~' type_name:name", 47), ('unqualified_id -> operator_function_id!', 18), ("conversion_function_id -> 'operator' conversion_type_id!", 26), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 73), ("cd_id -> '::'?:glbl nested_name_specifier:nns? type_name:name", 47), ('unqualified_id -> IDENTIFIER:id', 18), ('type_name -> template_id!', 13), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15), ("member_declaration -> '::'?:glbl nested_name_specifier:nns 'template'?:t unqualified_id:id ';'", 59), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns? type_name:name", 62), ('template_name -> IDENTIFIER!', 17), ("operator_function_id -> 'operator' operator:op", 24), ("cd_id -> '::'?:glbl nested_name_specifier:nns? conversion_function_id:name", 47), ('unqualified_id -> conversion_function_id!', 18), ("named_type_specifier -> '::'?:glbl nested_name_specifier:nns 'template' template_id:id", 61), ("unqualified_id -> '~' class_name:name", 18), ("template_id -> template_name:name '<' template_argument!*,',':args '>'", 15)], {operator_function_id: ('g', 6), template_name: ('g', 2), '~': ('s', 422), IDENTIFIER: ('s', 423), conversion_function_id: ('g', 424), unqualified_id: ('g', 770), 'template': ('s', 753), 'operator': ('s', 8), template_id: ('g', 26), type_name: ('g', 427)}, 1066),
        ]

    TABLE.rules = [
        Rule(postfix_expression, 4, 'ExprAttributeAccess', ([], {'t': True, 'v': Ref(0), 'id': Ref(3)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(template_name, 1, 'COPY', ([Ref(0)], {})),
        Rule(elaborated_type_specifier, 4, 'TypeTypename', ([], {'glbl': True, 'nns': Ref(2), 'name': Ref(3)})),
        Rule(_73, 1, 'LIST', ([Ref(0)], {})),
        Rule(namespace_name, 1, 'NameNamespace', ([], {'name': Ref(0)})),
        Rule(type_name, 1, 'NameType', ([], {'name': Ref(0)})),
        Rule(class_name, 1, 'NameClass', ([], {'name': Ref(0)})),
        Rule(direct_abstract_declarator, 4, 'AbsDtorFunction', ([], {'d': None, 'excspec': None, 'cv': Ref(3), 'params': Ref(1)})),
        Rule(simple_declaration, 2, 'COPY', ([Ref(0)], {})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(postfix_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(class_head, 2, 'DICT', ([], {'t': Ref(0), 'bases': Ref(1)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(cd_id, 4, 'DtorDestructor', ([], {'glbl': True, 'nns': Ref(1), 'name': Ref(3)})),
        Rule(translation_unit, 1, 'TranslationUnit', ([], {'decls': Ref(0)})),
        Rule(type_parameter, 8, 'TypeParamTemplate', ([], {'plist': Ref(2), 'default': Ref(7), 'name': Ref(5)})),
        Rule(_74, 1, 'LIST', ([Ref(0)], {})),
        Rule(type_parameter, 5, 'TypeParamTemplate', ([], {'plist': Ref(2), 'name': None})),
        Rule(parameter_declaration_clause, 0, 'ParamList', ([], {'plist': [], 'etc': False})),
        Rule(raw_type_descriptor, 1, 'COPY', ([Ref(0)], {})),
        Rule(literal, 1, 'LiteralBool', ([], {'v': Ref(0)})),
        Rule(new_expression, 3, 'ExprNew', ([], {'t': Ref(1), 'place': None, 'glbl': False, 'init': Ref(2)})),
        Rule(inclusive_or_expression, 3, 'ExprBitwiseOr', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(class_key, 1, 'COPY', ([Ref(0)], {})),
        Rule(type_parameter, 1, 'TypeParameter', ([], {'name': None})),
        Rule(ptr_operator, 1, 'PtrOpRef', ([], {})),
        Rule(base_specifier, 3, 'base_specifier_1', ([], {'glbl': True, 'acc': None, 'name': Ref(2), 'nns': None})),
        Rule(base_specifier, 4, 'ClassBase', ([], {'v': True, 'glbl': True, 'acc': Ref(0), 'name': Ref(3), 'nns': None})),
        Rule(base_specifier, 4, 'base_specifier_1', ([], {'glbl': False, 'acc': Ref(1), 'name': Ref(3), 'nns': Ref(2)})),
        Rule(iteration_statement, 7, 'StmtDoWhile', ([], {'cond': Ref(4), 'st': Ref(1)})),
        Rule(function_head, 1, 'DeclFunctionHead', ([], {'dtor': Ref(0), 'attrs': []})),
        Rule(member_cd_declarator, 1, 'COPY', ([Ref(0)], {})),
        Rule(_73, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(class_head, 4, 'DICT', ([], {'t': Ref(0), 'tid': Ref(2), 'nns': Ref(1), 'bases': Ref(3)})),
        Rule(and_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(_100, 3, 'APPEND', ([Ref(0), Ref(2)], {})),
        Rule(postfix_expression, 7, 'ExprQualifiedTemplateCreate', ([], {'args': Ref(5), 'id': Ref(3), 'glbl': False, 'nns': Ref(1)})),
        Rule(unary_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(new_expression, 5, 'ExprNew', ([], {'t': Ref(3), 'place': Ref(2), 'glbl': True, 'init': Ref(4)})),
        Rule(new_expression, 4, 'ExprNew', ([], {'t': Ref(2), 'place': None, 'glbl': False, 'init': None})),
        Rule(simple_declaration, 2, 'COPY', ([Ref(0)], {})),
        Rule(pseudo_destructor_name, 6, 'PseudoDestructorNormal', ([], {'t': Ref(2), 'glbl': True, 'nns': Ref(1), 'tn': Ref(5)})),
        Rule(conditional_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(decl_attrib, 1, 'COPY', ([Ref(0)], {})),
        Rule(member_specification, 1, 'COPY', ([Ref(0)], {})),
        Rule(cd_id, 3, 'DtorDestructor', ([], {'glbl': True, 'nns': None, 'name': Ref(2)})),
        Rule(block_declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(jump_statement, 2, 'StmtReturn', ([], {'v': None})),
        Rule(expression_statement, 2, 'StmtExpression', ([], {'expr': Ref(0)})),
        Rule(decl_attrib, 1, 'COPY', ([Ref(0)], {})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(equality_expression, 3, 'ExprEqual', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(member_declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(direct_abstract_declarator, 3, 'AbsDtorArray', ([], {'d': Ref(0), 'dim': None})),
        Rule(qualified_id, 2, 'IdQualified', ([], {'t': False, 'id': Ref(1), 'glbl': False, 'nns': Ref(0)})),
        Rule(linkage_specification, 5, 'DeclLinkage', ([], {'body': Ref(3), 'link': Ref(1)})),
        Rule(_123, 3, 'APPEND', ([Ref(0), Ref(2)], {})),
        Rule(qualified_id, 2, 'qualified_id_2', ([Ref(1)], {})),
        Rule(template_parameter, 1, 'COPY', ([Ref(0)], {})),
        Rule(postfix_expression, 7, 'ExprStaticCast', ([], {'t': Ref(2), 'v': Ref(5)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(simple_type_specifier, 1, 'COPY', ([Ref(0)], {})),
        Rule(member_declarator, 3, 'DtorSize', ([], {'size': Ref(2), 'name': Ref(0)})),
        Rule(elaborated_type_specifier, 4, 'TypeTemplate', ([], {'id': Ref(3), 'glbl': True, 'nns': Ref(2)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(parameter_declaration_clause, 1, 'ParamList', ([], {'plist': Ref(0), 'etc': False})),
        Rule(base_specifier, 2, 'ClassBase', ([], {'v': False, 'glbl': False, 'acc': Ref(0), 'name': Ref(1), 'nns': None})),
        Rule(namespace_body, 1, 'COPY', ([Ref(0)], {})),
        Rule(_127, 3, 'APPEND', ([Ref(0), Ref(2)], {})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(jump_statement, 2, 'StmtBreak', ([], {})),
        Rule(enumerator_definition, 3, 'Enumerator', ([], {'v': Ref(2), 'name': Ref(0)})),
        Rule(type_parameter, 7, 'TypeParamTemplate', ([], {'plist': Ref(2), 'default': Ref(6), 'name': None})),
        Rule(enum_specifier, 4, 'DeclEnum', ([], {'elist': Ref(2), 'name': None})),
        Rule(base_clause, 2, 'COPY', ([Ref(1)], {})),
        Rule(new_initializer, 3, 'COPY', ([Ref(1)], {})),
        Rule(literal, 1, 'LiteralFloat', ([], {'v': Ref(0)})),
        Rule(_130, 1, 'LIST', ([Ref(0)], {})),
        Rule(for_init_statement, 1, 'StmtDeclaration', ([], {'decl': Ref(0)})),
        Rule(named_type_specifier, 2, 'TypeQualified', ([], {'glbl': False, 'nns': Ref(0), 'name': Ref(1)})),
        Rule(_117, 1, 'LIST', ([Ref(0)], {})),
        Rule(_1, 1, 'LIST', ([Ref(0)], {})),
        Rule(new_declarator, 1, 'COPY', ([Ref(0)], {})),
        Rule(conversion_type_id, 1, 'IdConversionFn', ([], {'dtor': None, 'type': Ref(0)})),
        Rule(for_init_statement, 1, 'COPY', ([Ref(0)], {})),
        Rule(iteration_statement, 7, 'StmtFor', ([], {'cond': Ref(3), 'st': Ref(6), 'init': Ref(2), 'inc': None})),
        Rule(relational_expression, 3, 'ExprLT', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(operator, 3, 'operator_new_arr', ([], {})),
        Rule(statement, 1, 'COPY', ([Ref(0)], {})),
        Rule(template_id, 4, 'IdTemplate', ([], {'args': Ref(2), 'name': Ref(0)})),
        Rule(initializer_clause, 2, 'initializer_clause_2', ([], {})),
        Rule(unqualified_id, 1, 'IdIdentifier', ([], {'id': Ref(0)})),
        Rule(statement, 1, 'COPY', ([Ref(0)], {})),
        Rule(parameter_declaration, 2, 'Parameter', ([], {'dtor': Ref(1), 'type': Ref(0)})),
        Rule(parameter_declaration, 1, 'Parameter', ([], {'dtor': None, 'type': Ref(0)})),
        Rule(statement, 1, 'COPY', ([Ref(0)], {})),
        Rule(postfix_expression, 3, 'ExprPseudoDestructor', ([], {'v': Ref(0), 'name': Ref(2)})),
        Rule(base_specifier, 3, 'base_specifier_1', ([], {'glbl': False, 'acc': Ref(1), 'name': Ref(2), 'nns': None})),
        Rule(id_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(postfix_expression, 6, 'ExprQualifiedTemplateCreate', ([], {'args': [], 'id': Ref(3), 'glbl': True, 'nns': Ref(2)})),
        Rule(statement, 1, 'COPY', ([Ref(0)], {})),
        Rule(type_name, 1, 'COPY', ([Ref(0)], {})),
        Rule(pseudo_destructor_name, 7, 'PseudoDestructorTemplate', ([], {'t': Ref(3), 'glbl': True, 'nns': Ref(1), 'tn': Ref(6)})),
        Rule(_75, 1, 'LIST', ([Ref(0)], {})),
        Rule(logical_or_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(direct_declarator, 5, 'DtorFunction', ([], {'d': Ref(0), 'excspec': None, 'cv': Ref(4), 'params': Ref(2)})),
        Rule(elaborated_type_specifier, 3, 'TypeTemplate', ([], {'id': Ref(2), 'glbl': False, 'nns': Ref(1)})),
        Rule(logical_and_expression, 3, 'ExprLogicalAnd', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(new_expression, 6, 'ExprNew', ([], {'t': Ref(4), 'place': Ref(2), 'glbl': True, 'init': None})),
        Rule(base_specifier, 2, 'base_specifier_1', ([], {'glbl': False, 'acc': None, 'name': Ref(1), 'nns': None})),
        Rule(template_declaration, 6, 'DeclTemplate', ([], {'plist': Ref(3), 'exp': True, 'decl': Ref(5)})),
        Rule(unary_expression, 2, 'ExprUnary', ([], {'v': Ref(1), 'op': Ref(0)})),
        Rule(labeled_statement, 4, 'StmtCase', ([], {'st': Ref(3), 'c': Ref(1)})),
        Rule(type_parameter, 1, 'TypeParameter', ([], {'name': None})),
        Rule(base_specifier, 3, 'ClassBase', ([], {'glbl': True, 'nns': Ref(1), 'name': Ref(2)})),
        Rule(ptr_operator, 2, 'PtrOpQualified', ([], {'glbl': False, 'nns': Ref(0), 'cv': []})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(iteration_statement, 7, 'StmtFor', ([], {'cond': None, 'st': Ref(6), 'init': Ref(2), 'inc': Ref(4)})),
        Rule(base_specifier, 3, 'ClassBase', ([], {'v': False, 'glbl': False, 'acc': Ref(0), 'name': Ref(2), 'nns': Ref(1)})),
        Rule(raw_type_descriptor, 1, 'COPY', ([Ref(0)], {})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(direct_abstract_declarator, 3, 'AbsDtorFunction', ([], {'d': None, 'excspec': None, 'cv': [], 'params': Ref(1)})),
        Rule(elaborated_type_specifier, 3, 'TypeEnum', ([], {'glbl': True, 'nns': None, 'name': Ref(2)})),
        Rule(pseudo_destructor_name, 5, 'PseudoDestructorNormal', ([], {'t': Ref(1), 'glbl': False, 'nns': Ref(0), 'tn': Ref(4)})),
        Rule(postfix_expression, 7, 'ExprQualifiedCreate', ([], {'args': Ref(5), 'glbl': True, 'nns': Ref(2), 'name': Ref(3)})),
        Rule(member_declarator, 2, 'DtorPure', ([], {'d': Ref(0)})),
        Rule(_100, 1, 'LIST', ([Ref(0)], {})),
        Rule(declarator, 2, 'DtorPtr', ([], {'d': Ref(1), 'op': Ref(0)})),
        Rule(condition, 4, 'ConditionDeclare', ([], {'dtor': Ref(1), 'v': Ref(3), 'type': Ref(0)})),
        Rule(using_declaration, 4, 'DeclUsingGlobal', ([], {'id': Ref(2)})),
        Rule(member_declaration, 3, 'MemberId', ([], {'t': False, 'id': Ref(1), 'glbl': False, 'nns': Ref(0)})),
        Rule(handler, 5, 'StmtCatch', ([], {'exc': Ref(2), 'body': Ref(4)})),
        Rule(new_expression, 5, 'ExprNew', ([], {'t': Ref(3), 'place': Ref(1), 'glbl': False, 'init': None})),
        Rule(class_key, 1, 'COPY', ([Ref(0)], {})),
        Rule(postfix_expression, 8, 'ExprQualifiedTemplateCreate', ([], {'args': Ref(6), 'id': Ref(4), 'glbl': True, 'nns': Ref(2)})),
        Rule(primary_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(inclusive_or_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(abstract_declarator, 1, 'AbsDtorPtr', ([], {'d': None, 'op': Ref(0)})),
        Rule(labeled_statement, 3, 'StmtDefault', ([], {'st': Ref(2)})),
        Rule(direct_abstract_declarator, 5, 'AbsDtorFunction', ([], {'d': Ref(0), 'excspec': None, 'cv': Ref(4), 'params': Ref(2)})),
        Rule(new_expression, 5, 'ExprNew', ([], {'t': Ref(2), 'place': None, 'glbl': False, 'init': Ref(4)})),
        Rule(direct_abstract_declarator, 3, 'COPY', ([Ref(1)], {})),
        Rule(_123, 1, 'LIST', ([Ref(0)], {})),
        Rule(named_type_specifier, 4, 'TypeQualifiedTemplate', ([], {'id': Ref(3), 'glbl': True, 'nns': Ref(1)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(new_expression, 7, 'ExprNew', ([], {'t': Ref(4), 'place': Ref(2), 'glbl': True, 'init': Ref(6)})),
        Rule(type_descriptor, 2, 'TypeCV', ([], {'t': Ref(1), 'cv': Ref(0)})),
        Rule(iteration_statement, 5, 'StmtWhile', ([], {'cond': Ref(2), 'st': Ref(4)})),
        Rule(direct_new_declarator, 4, 'NewDeclaratorArray', ([], {'dtor': Ref(0), 'size': Ref(2)})),
        Rule(conversion_type_id, 2, 'IdConversionFn', ([], {'dtor': Ref(1), 'type': Ref(0)})),
        Rule(type_parameter, 2, 'TypeParameter', ([], {'name': Ref(1)})),
        Rule(parameter_declaration, 4, 'Parameter', ([], {'dtor': Ref(1), 'type': Ref(0), 'default': Ref(3)})),
        Rule(exception_declaration, 2, 'DeclException', ([], {'dtor': Ref(1), 'type': Ref(0)})),
        Rule(type_parameter, 3, 'TypeParameter', ([], {'default': Ref(2), 'name': None})),
        Rule(qualified_namespace_specifier, 1, 'IdQualifiedNamespace', ([], {'glbl': False, 'nns': None, 'name': Ref(0)})),
        Rule(operator, 2, 'operator_index', ([], {})),
        Rule(exclusive_or_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(pseudo_destructor_name, 2, 'PseudoDestructorAnon', ([], {'t': Ref(1), 'glbl': False, 'nns': None})),
        Rule(cv_qualifier, 1, 'COPY', ([Ref(0)], {})),
        Rule(function_head, 2, 'DeclFunctionHead', ([], {'dtor': Ref(1), 'attrs': Ref(0)})),
        Rule(declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(throw_expression, 2, 'ExprThrow', ([], {'v': Ref(1)})),
        Rule(_127, 1, 'LIST', ([Ref(0)], {})),
        Rule(parameter_declaration_clause, 2, 'ParamList', ([], {'plist': Ref(0), 'etc': True})),
        Rule(statement, 1, 'COPY', ([Ref(0)], {})),
        Rule(qualified_namespace_specifier, 2, 'IdQualifiedNamespace', ([], {'glbl': False, 'nns': Ref(0), 'name': Ref(1)})),
        Rule(explicit_specialization, 4, 'DeclExplicitSpec', ([], {'decl': Ref(3)})),
        Rule(class_name, 1, 'COPY', ([Ref(0)], {})),
        Rule(class_head, 2, 'DICT', ([], {'t': Ref(0), 'tid': Ref(1), 'nns': None, 'bases': None})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(assignment_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(postfix_expression, 3, 'ExprCall', ([], {'args': [], 'v': Ref(0)})),
        Rule(unary_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(named_type_specifier, 3, 'TypeQualified', ([], {'glbl': True, 'nns': Ref(1), 'name': Ref(2)})),
        Rule(cd_id, 3, 'DtorConstructor', ([], {'glbl': True, 'nns': Ref(1), 'name': Ref(2)})),
        Rule(type_parameter, 4, 'TypeParameter', ([], {'default': Ref(3), 'name': Ref(1)})),
        Rule(unnamed_namespace_definition, 4, 'DeclNamespaceUnnamed', ([], {'body': Ref(2)})),
        Rule(member_declaration, 2, 'DeclSimple', ([], {'dtor': Ref(0), 'attrs': []})),
        Rule(cd_id, 1, 'DtorConstructor', ([], {'glbl': False, 'nns': None, 'name': Ref(0)})),
        Rule(postfix_expression, 4, 'ExprIndex', ([], {'v': Ref(0), 'i': Ref(2)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(unary_expression, 2, 'ExprPreDec', ([], {'v': Ref(1)})),
        Rule(_57, 1, 'LIST', ([Ref(0)], {})),
        Rule(iteration_statement, 6, 'StmtFor', ([], {'cond': None, 'st': Ref(5), 'init': Ref(2), 'inc': None})),
        Rule(elaborated_type_specifier, 2, 'TypeEnum', ([], {'glbl': False, 'nns': None, 'name': Ref(1)})),
        Rule(_120, 1, 'LIST', ([Ref(0)], {})),
        Rule(conditional_expression, 5, 'ExprCondition', ([], {'a': Ref(2), 'b': Ref(4), 'c': Ref(0)})),
        Rule(postfix_expression, 3, 'ExprIndirectPseudoDestructor', ([], {'v': Ref(0), 'name': Ref(2)})),
        Rule(named_type_specifier, 1, 'TypeQualified', ([], {'glbl': False, 'nns': None, 'name': Ref(0)})),
        Rule(new_expression, 6, 'ExprNew', ([], {'t': Ref(3), 'place': Ref(1), 'glbl': False, 'init': Ref(5)})),
        Rule(simple_type_specifier, 1, 'simple_builtin_type', ([], {'kw': Ref(0)})),
        Rule(base_specifier, 5, 'base_specifier_1', ([], {'glbl': True, 'acc': Ref(1), 'name': Ref(4), 'nns': Ref(3)})),
        Rule(delete_expression, 4, 'ExprDeleteArray', ([], {'v': Ref(3)})),
        Rule(assignment_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(postfix_expression, 4, 'ExprCall', ([], {'args': Ref(2), 'v': Ref(0)})),
        Rule(conversion_declarator, 1, 'AbsDtorPtr', ([], {'d': None, 'op': Ref(0)})),
        Rule(asm_definition, 4, 'DeclAssembly', ([], {'asm': Ref(2)})),
        Rule(_130, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(condition, 1, 'COPY', ([Ref(0)], {})),
        Rule(function_definition, 3, 'DeclFunction', ([], {'body': Ref(2), 'head': Ref(0), 'init': Ref(1)})),
        Rule(declarator_id, 1, 'COPY', ([Ref(0)], {})),
        Rule(base_specifier, 3, 'ClassBase', ([], {'v': True, 'glbl': False, 'acc': Ref(0), 'name': Ref(2), 'nns': None})),
        Rule(ptr_operator, 2, 'PtrOpPtr', ([], {'cv': Ref(1)})),
        Rule(postfix_expression, 7, 'ExprConstCast', ([], {'t': Ref(2), 'v': Ref(5)})),
        Rule(using_directive, 5, 'DeclUsingNamespace', ([], {'glbl': True, 'nns': None, 'name': Ref(3)})),
        Rule(postfix_expression, 3, 'ExprCreate', ([], {'t': Ref(0), 'args': []})),
        Rule(ptr_operator, 3, 'PtrOpQualified', ([], {'glbl': True, 'nns': Ref(1), 'cv': []})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(initializer_clause, 3, 'InitList', ([], {'data': Ref(1)})),
        Rule(decl_attrib, 1, 'COPY', ([Ref(0)], {})),
        Rule(new_expression, 4, 'ExprNew', ([], {'t': Ref(2), 'place': None, 'glbl': True, 'init': Ref(3)})),
        Rule(unary_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(class_head, 3, 'DICT', ([], {'t': Ref(0), 'tid': Ref(2), 'nns': Ref(1), 'bases': None})),
        Rule(multiplicative_expression, 3, 'ExprDiv', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(exception_declaration, 1, 'DeclException', ([], {'type': Ref(0)})),
        Rule(postfix_expression, 7, 'ExprDynamicCast', ([], {'t': Ref(2), 'v': Ref(5)})),
        Rule(_128, 1, 'LIST', ([Ref(0)], {})),
        Rule(type_parameter, 3, 'TypeParameter', ([], {'default': Ref(2), 'name': None})),
        Rule(raw_type_descriptor, 1, 'COPY', ([Ref(0)], {})),
        Rule(member_declarator, 2, 'DtorSize', ([], {'size': Ref(1), 'name': None})),
        Rule(unary_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(direct_new_declarator, 3, 'NewDeclaratorArray', ([], {'dtor': None, 'size': Ref(1)})),
        Rule(postfix_expression, 4, 'ExprCreate', ([], {'t': Ref(0), 'args': Ref(2)})),
        Rule(postfix_expression, 7, 'ExprQualifiedTemplateCreate', ([], {'args': Ref(5), 'id': Ref(3), 'glbl': True, 'nns': Ref(2)})),
        Rule(class_specifier, 3, 'DeclClass', ([], {'body': [], '!!': [Ref(0)]})),
        Rule(declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(named_type_specifier, 2, 'TypeQualified', ([], {'glbl': True, 'nns': None, 'name': Ref(1)})),
        Rule(namespace_definition, 1, 'COPY', ([Ref(0)], {})),
        Rule(_1, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(unary_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(_128, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(parameter_declaration_clause, 3, 'parameter_declaration_clause_1', ([], {'plist': Ref(0)})),
        Rule(expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(assignment_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(pm_expression, 3, 'ExprPtrToMembDereference', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(using_declaration, 6, 'DeclUsingNonGlobal', ([], {'id': Ref(4), 'glbl': True, 'nns': Ref(3), 'tn': True})),
        Rule(member_declaration, 2, 'DeclSimple', ([], {'dtor': [], 'type': Ref(0), 'attrs': []})),
        Rule(qualified_id, 2, 'qualified_id_2', ([Ref(1)], {})),
        Rule(simple_declaration, 2, 'COPY', ([Ref(0)], {})),
        Rule(postfix_expression, 7, 'ExprReinterpretCast', ([], {'t': Ref(2), 'v': Ref(5)})),
        Rule(relational_expression, 3, 'ExprGE', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(nested_name_specifier, 3, 'NestedNameSpecifier', ([], {'nns': Ref(2), 'name': Ref(0)})),
        Rule(new_expression, 3, 'ExprNew', ([], {'t': Ref(2), 'place': None, 'glbl': True, 'init': None})),
        Rule(class_head, 2, 'DICT', ([], {'t': Ref(0), 'name': Ref(1), 'nns': None, 'bases': None})),
        Rule(elaborated_type_specifier, 2, 'TypeClass', ([], {'glbl': False, 'nns': None, 'name': Ref(1)})),
        Rule(function_try_block, 4, 'FuncTryBlock', ([], {'handlers': Ref(3), 'body': Ref(2), 'init': Ref(1)})),
        Rule(operator, 2, 'operator_call', ([], {})),
        Rule(equality_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(shift_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(direct_declarator, 4, 'DtorArray', ([], {'d': Ref(0), 'dim': Ref(2)})),
        Rule(throw_expression, 1, 'ExprThrow', ([], {'v': None})),
        Rule(pseudo_destructor_name, 6, 'PseudoDestructorTemplate', ([], {'t': Ref(2), 'glbl': False, 'nns': Ref(0), 'tn': Ref(5)})),
        Rule(postfix_expression, 7, 'ExprQualifiedTemplateCreate', ([], {'args': [], 'id': Ref(4), 'glbl': True, 'nns': Ref(2)})),
        Rule(elaborated_type_specifier, 5, 'TypeTemplate', ([], {'id': Ref(4), 'glbl': True, 'nns': Ref(2)})),
        Rule(nested_name_specifier, 2, 'NestedNameSpecifier', ([], {'nns': None, 'name': Ref(0)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(_114, 3, 'APPEND', ([Ref(0), Ref(2)], {})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(shift_expression, 3, 'ExprRightShift', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(member_declarator, 1, 'DtorInit', ([], {'d': Ref(0), 'init': None})),
        Rule(function_head, 3, 'DeclFunctionHead', ([], {'dtor': Ref(2), 'type': Ref(1), 'attrs': Ref(0)})),
        Rule(postfix_expression, 6, 'ExprQualifiedCreate', ([], {'args': [], 'glbl': True, 'nns': Ref(2), 'name': Ref(3)})),
        Rule(cd_declarator, 5, 'DtorFunction', ([], {'d': Ref(0), 'excspec': Ref(4), 'params': Ref(2)})),
        Rule(parameter_declaration, 2, 'Parameter', ([], {'dtor': Ref(1), 'type': Ref(0)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(direct_abstract_declarator, 3, 'AbsDtorArray', ([], {'d': None, 'dim': Ref(1)})),
        Rule(_107, 1, 'LIST', ([Ref(0)], {})),
        Rule(translation_unit, 0, 'TranslationUnit', ([], {'decls': []})),
        Rule(member_declaration, 2, 'COPY', ([Ref(0)], {})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(postfix_expression, 4, 'ExprTypeIdType', ([], {'t': Ref(2)})),
        Rule(cd_id, 1, 'DtorConversion', ([], {'glbl': False, 'nns': None, 'name': Ref(0)})),
        Rule(namespace_body, 0, 'COPY', ([[]], {})),
        Rule(declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(multiplicative_expression, 3, 'ExprMod', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(elaborated_type_specifier, 3, 'TypeEnum', ([], {'glbl': False, 'nns': Ref(1), 'name': Ref(2)})),
        Rule(operator_function_id, 2, 'IdOperatorFn', ([], {'op': Ref(1)})),
        Rule(elaborated_type_specifier, 4, 'TypeEnum', ([], {'glbl': True, 'nns': Ref(2), 'name': Ref(3)})),
        Rule(base_specifier, 5, 'ClassBase', ([], {'v': True, 'glbl': True, 'acc': Ref(0), 'name': Ref(4), 'nns': Ref(3)})),
        Rule(linkage_specification, 4, 'DeclLinkage', ([], {'body': [], 'link': Ref(1)})),
        Rule(ptr_operator, 4, 'PtrOpQualified', ([], {'glbl': True, 'nns': Ref(1), 'cv': Ref(3)})),
        Rule(raw_type_descriptor, 1, 'COPY', ([Ref(0)], {})),
        Rule(selection_statement, 7, 'StmtIf', ([], {'elsest': Ref(6), 'cond': Ref(2), 'thenst': Ref(4)})),
        Rule(declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(relational_expression, 3, 'ExprGT', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(pseudo_destructor_name, 4, 'PseudoDestructorNormal', ([], {'t': Ref(0), 'glbl': False, 'nns': None, 'tn': Ref(3)})),
        Rule(raw_type_descriptor, 1, 'TypeBuiltin', ([], {'kws': Ref(0)})),
        Rule(direct_declarator, 6, 'DtorFunction', ([], {'d': Ref(0), 'excspec': Ref(5), 'cv': Ref(4), 'params': Ref(2)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(conversion_declarator, 2, 'AbsDtorPtr', ([], {'d': Ref(1), 'op': Ref(0)})),
        Rule(unary_expression, 2, 'ExprSizeof', ([], {'v': Ref(1)})),
        Rule(elaborated_type_specifier, 4, 'TypeClass', ([], {'glbl': True, 'nns': Ref(2), 'name': Ref(3)})),
        Rule(unqualified_id, 1, 'COPY', ([Ref(0)], {})),
        Rule(pure_specifier, 2, 'pure_specifier_0', ([], {'i': Ref(1)})),
        Rule(literal, 1, 'LiteralInt', ([], {'v': Ref(0)})),
        Rule(base_specifier, 2, 'ClassBase', ([], {'glbl': False, 'nns': Ref(0), 'name': Ref(1)})),
        Rule(_109, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(member_declaration, 3, 'DeclSimple', ([], {'dtor': Ref(1), 'attrs': Ref(0)})),
        Rule(_15, 3, 'APPEND', ([Ref(0), Ref(2)], {})),
        Rule(cd_id, 2, 'DtorConstructor', ([], {'glbl': False, 'nns': Ref(0), 'name': Ref(1)})),
        Rule(base_specifier, 4, 'ClassBase', ([], {'v': True, 'glbl': False, 'acc': Ref(0), 'name': Ref(3), 'nns': Ref(2)})),
        Rule(exception_specification, 5, 'ExceptionSpecification', ([], {'xlist': Ref(3)})),
        Rule(_84, 1, 'LIST', ([Ref(0)], {})),
        Rule(class_head, 1, 'DICT', ([], {'t': Ref(0), 'bases': None})),
        Rule(new_type_id, 1, 'NewTypeId', ([], {'dtor': None, 'type': Ref(0)})),
        Rule(base_specifier, 1, 'ClassBase', ([], {'glbl': False, 'nns': None, 'name': Ref(0)})),
        Rule(original_namespace_definition, 5, 'DeclNamespaceOriginal', ([], {'body': Ref(3), 'name': Ref(1)})),
        Rule(ptr_operator, 3, 'PtrOpQualified', ([], {'glbl': False, 'nns': Ref(0), 'cv': Ref(2)})),
        Rule(access_specifier, 1, 'COPY', ([Ref(0)], {})),
        Rule(function_definition, 2, 'DeclFunction', ([], {'tryb': Ref(1), 'head': Ref(0)})),
        Rule(_109, 1, 'LIST', ([Ref(0)], {})),
        Rule(pseudo_destructor_name, 5, 'PseudoDestructorNormal', ([], {'t': Ref(1), 'glbl': True, 'nns': None, 'tn': Ref(4)})),
        Rule(postfix_expression, 6, 'ExprQualifiedCreate', ([], {'args': Ref(4), 'glbl': False, 'nns': Ref(1), 'name': Ref(2)})),
        Rule(selection_statement, 5, 'StmtSwitch', ([], {'cond': Ref(2), 'st': Ref(4)})),
        Rule(ptr_operator, 1, 'PtrOpPtr', ([], {'cv': []})),
        Rule(postfix_expression, 6, 'ExprQualifiedTemplateCreate', ([], {'args': [], 'id': Ref(3), 'glbl': False, 'nns': Ref(1)})),
        Rule(elaborated_type_specifier, 4, 'TypeTemplate', ([], {'id': Ref(3), 'glbl': False, 'nns': Ref(1)})),
        Rule(pseudo_destructor_name, 3, 'PseudoDestructorAnon', ([], {'t': Ref(2), 'glbl': True, 'nns': None})),
        Rule(mem_initializer_id, 2, 'ClassBase', ([], {'glbl': True, 'nns': None, 'name': Ref(1)})),
        Rule(enum_specifier, 4, 'DeclEnum', ([], {'elist': [], 'name': Ref(1)})),
        Rule(nested_name_specifier, 4, 'nested_name_specifier_1', ([Ref(0), Ref(3)], {})),
        Rule(template_id, 3, 'IdTemplate', ([], {'args': [], 'name': Ref(0)})),
        Rule(pseudo_destructor_name, 4, 'PseudoDestructorAnon', ([], {'t': Ref(3), 'glbl': True, 'nns': Ref(1)})),
        Rule(cd_id, 2, 'DtorDestructor', ([], {'glbl': False, 'nns': None, 'name': Ref(1)})),
        Rule(cd_declarator, 4, 'DtorFunction', ([], {'d': Ref(0), 'excspec': None, 'params': Ref(2)})),
        Rule(mem_initializer, 4, 'MemInitializer', ([], {'args': Ref(2), 'id': Ref(0)})),
        Rule(postfix_expression, 2, 'ExprPostDec', ([], {'v': Ref(0)})),
        Rule(member_declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(_117, 3, 'APPEND', ([Ref(0), Ref(2)], {})),
        Rule(elaborated_type_specifier, 3, 'TypeTypename', ([], {'glbl': False, 'nns': Ref(1), 'name': Ref(2)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(exception_specification, 4, 'ExceptionSpecification', ([], {'xlist': Ref(2)})),
        Rule(_57, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(unary_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(direct_declarator, 4, 'DtorFunction', ([], {'d': Ref(0), 'excspec': None, 'cv': [], 'params': Ref(2)})),
        Rule(base_specifier, 3, 'ClassBase', ([], {'v': False, 'glbl': True, 'acc': Ref(0), 'name': Ref(2), 'nns': None})),
        Rule(new_expression, 4, 'ExprNew', ([], {'t': Ref(2), 'place': Ref(1), 'glbl': False, 'init': Ref(3)})),
        Rule(new_expression, 6, 'ExprNew', ([], {'t': Ref(3), 'place': None, 'glbl': True, 'init': Ref(5)})),
        Rule(member_cd_declarator, 2, 'DtorPure', ([], {'d': Ref(0)})),
        Rule(simple_declaration, 3, 'DeclSimple', ([], {'dtor': Ref(1), 'type': Ref(0), 'attrs': []})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(nested_name_specifier, 4, 'nested_name_specifier_1', ([Ref(0), Ref(3)], {})),
        Rule(pm_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(_80, 1, 'LIST', ([Ref(0)], {})),
        Rule(postfix_expression, 4, 'ExprTypeId', ([], {'v': Ref(2)})),
        Rule(statement, 1, 'COPY', ([Ref(0)], {})),
        Rule(qualified_namespace_specifier, 2, 'IdQualifiedNamespace', ([], {'glbl': True, 'nns': None, 'name': Ref(1)})),
        Rule(named_type_specifier, 3, 'TypeQualifiedTemplate', ([], {'id': Ref(2), 'glbl': False, 'nns': Ref(0)})),
        Rule(_74, 3, 'APPEND', ([Ref(0), Ref(2)], {})),
        Rule(function_head, 2, 'DeclFunctionHead', ([], {'dtor': Ref(1), 'type': Ref(0), 'attrs': []})),
        Rule(declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(postfix_expression, 2, 'ExprPostInc', ([], {'v': Ref(0)})),
        Rule(cd_id, 2, 'DtorConversion', ([], {'glbl': True, 'nns': None, 'name': Ref(1)})),
        Rule(template_argument, 1, 'TmpltArgValue', ([], {'v': Ref(0)})),
        Rule(class_specifier, 4, 'DeclClass', ([], {'body': Ref(2), '!!': [Ref(0)]})),
        Rule(_113, 1, 'LIST', ([Ref(0)], {})),
        Rule(cd_id, 3, 'DtorConversion', ([], {'glbl': True, 'nns': Ref(1), 'name': Ref(2)})),
        Rule(base_specifier, 4, 'base_specifier_1', ([], {'glbl': True, 'acc': None, 'name': Ref(3), 'nns': Ref(2)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(elaborated_type_specifier, 3, 'TypeClass', ([], {'glbl': False, 'nns': Ref(1), 'name': Ref(2)})),
        Rule(class_head, 3, 'DICT', ([], {'t': Ref(0), 'name': Ref(2), 'nns': Ref(1), 'bases': None})),
        Rule(direct_declarator, 5, 'DtorFunction', ([], {'d': Ref(0), 'excspec': Ref(4), 'cv': [], 'params': Ref(2)})),
        Rule(declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(type_parameter, 6, 'TypeParamTemplate', ([], {'plist': Ref(2), 'name': Ref(5)})),
        Rule(qualified_id, 3, 'IdQualified', ([], {'t': True, 'id': Ref(2), 'glbl': False, 'nns': Ref(0)})),
        Rule(class_head, 4, 'DICT', ([], {'t': Ref(0), 'name': Ref(2), 'nns': Ref(1), 'bases': Ref(3)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(cv_qualifier, 1, 'COPY', ([Ref(0)], {})),
        Rule(member_specification, 2, 'DeclAccess', ([], {'access': Ref(0)})),
        Rule(logical_and_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(unary_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(multiplicative_expression, 3, 'ExprMul', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(try_block, 3, 'StmtTry', ([], {'handlers': Ref(2), 'body': Ref(1)})),
        Rule(ctor_initializer, 2, 'COPY', ([Ref(1)], {})),
        Rule(nested_name_specifier, 2, 'NestedNameSpecifier', ([], {'nns': None, 'name': Ref(0)})),
        Rule(unqualified_id, 1, 'COPY', ([Ref(0)], {})),
        Rule(cd_id, 2, 'DtorConversion', ([], {'glbl': False, 'nns': Ref(0), 'name': Ref(1)})),
        Rule(class_head, 3, 'DICT', ([], {'t': Ref(0), 'tid': Ref(1), 'nns': None, 'bases': Ref(2)})),
        Rule(multiplicative_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(jump_statement, 2, 'StmtContinue', ([], {})),
        Rule(using_directive, 4, 'DeclUsingNamespace', ([], {'glbl': False, 'nns': None, 'name': Ref(2)})),
        Rule(declarator, 1, 'COPY', ([Ref(0)], {})),
        Rule(delete_expression, 3, 'ExprDelete', ([], {'v': Ref(2)})),
        Rule(new_initializer, 2, 'COPY', ([[]], {})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(_80, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(iteration_statement, 8, 'StmtFor', ([], {'cond': Ref(3), 'st': Ref(7), 'init': Ref(2), 'inc': Ref(5)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(member_declaration, 4, 'MemberId', ([], {'t': False, 'id': Ref(2), 'glbl': True, 'nns': Ref(1)})),
        Rule(mem_initializer_id, 2, 'ClassBase', ([], {'glbl': False, 'nns': Ref(0), 'name': Ref(1)})),
        Rule(_15, 1, 'LIST', ([Ref(0)], {})),
        Rule(enumerator, 1, 'COPY', ([Ref(0)], {})),
        Rule(class_key, 1, 'COPY', ([Ref(0)], {})),
        Rule(_107, 3, 'APPEND', ([Ref(0), Ref(2)], {})),
        Rule(block_declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(additive_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(assignment_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(statement, 1, 'COPY', ([Ref(0)], {})),
        Rule(assignment_expression, 3, 'ExprAssign', ([], {'lhs': Ref(0), 'op': Ref(1), 'rhs': Ref(2)})),
        Rule(_81, 1, 'LIST', ([Ref(0)], {})),
        Rule(exception_declaration, 1, 'DeclExceptionAny', ([], {})),
        Rule(direct_abstract_declarator, 4, 'AbsDtorArray', ([], {'d': Ref(0), 'dim': Ref(2)})),
        Rule(mem_initializer_id, 1, 'IdMember', ([], {'name': Ref(0)})),
        Rule(named_namespace_definition, 1, 'COPY', ([Ref(0)], {})),
        Rule(initializer, 3, 'InitConstructor', ([], {'args': Ref(1)})),
        Rule(class_head, 3, 'DICT', ([], {'t': Ref(0), 'name': Ref(1), 'nns': None, 'bases': Ref(2)})),
        Rule(assignment_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(member_declaration, 2, 'COPY', ([Ref(0)], {})),
        Rule(block_declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(type_id, 1, 'TypeId', ([], {'d': None, 'type': Ref(0)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(relational_expression, 3, 'ExprLE', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(direct_declarator, 1, 'COPY', ([Ref(0)], {})),
        Rule(operator, 3, 'operator_delete_arr', ([], {})),
        Rule(assignment_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(assignment_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(direct_declarator, 3, 'COPY', ([Ref(1)], {})),
        Rule(selection_statement, 5, 'StmtIf', ([], {'cond': Ref(2), 'thenst': Ref(4)})),
        Rule(assignment_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(member_declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(abstract_declarator, 2, 'AbsDtorPtr', ([], {'d': Ref(1), 'op': Ref(0)})),
        Rule(new_expression, 5, 'ExprNew', ([], {'t': Ref(3), 'place': None, 'glbl': True, 'init': None})),
        Rule(exception_declaration, 2, 'DeclException', ([], {'dtor': Ref(1), 'type': Ref(0)})),
        Rule(constant_initializer, 2, 'COPY', ([Ref(1)], {})),
        Rule(statement, 1, 'COPY', ([Ref(0)], {})),
        Rule(new_declarator, 2, 'NewDeclaratorPtr', ([], {'dtor': Ref(1), 'op': Ref(0)})),
        Rule(initializer_clause, 1, 'COPY', ([Ref(0)], {})),
        Rule(new_expression, 3, 'ExprNew', ([], {'t': Ref(2), 'place': Ref(1), 'glbl': False, 'init': None})),
        Rule(_113, 3, 'APPEND', ([Ref(0), Ref(2)], {})),
        Rule(additive_expression, 3, 'ExprSub', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(primary_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(member_declaration, 4, 'DeclSimple', ([], {'dtor': Ref(2), 'type': Ref(1), 'attrs': Ref(0)})),
        Rule(constant_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(init_declarator, 1, 'DtorInit', ([], {'d': Ref(0), 'init': None})),
        Rule(type_descriptor, 1, 'COPY', ([Ref(0)], {})),
        Rule(abstract_declarator, 1, 'COPY', ([Ref(0)], {})),
        Rule(initializer, 2, 'COPY', ([Ref(1)], {})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(conversion_function_id, 2, 'COPY', ([Ref(1)], {})),
        Rule(declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(linkage_specification, 3, 'linkage_specification_single', ([], {'decl': Ref(2), 'link': Ref(1)})),
        Rule(unary_expression, 4, 'ExprSizeofType', ([], {'t': Ref(2)})),
        Rule(new_placement, 3, 'COPY', ([Ref(1)], {})),
        Rule(init_declarator, 2, 'DtorInit', ([], {'d': Ref(0), 'init': Ref(1)})),
        Rule(compound_statement, 3, 'StmtCompound', ([], {'sts': Ref(1)})),
        Rule(mem_initializer_id, 1, 'ClassBase', ([], {'glbl': False, 'nns': None, 'name': Ref(0)})),
        Rule(pm_expression, 3, 'ExprIndirectPtrToMembDereference', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(cd_id, 2, 'DtorConstructor', ([], {'glbl': True, 'nns': None, 'name': Ref(1)})),
        Rule(mem_initializer, 3, 'MemInitializer', ([], {'args': [], 'id': Ref(0)})),
        Rule(elaborated_type_specifier, 3, 'TypeClass', ([], {'glbl': True, 'nns': None, 'name': Ref(2)})),
        Rule(pseudo_destructor_name, 3, 'PseudoDestructorAnon', ([], {'t': Ref(2), 'glbl': False, 'nns': Ref(0)})),
        Rule(raw_type_descriptor, 1, 'TypeAuto', ([], {})),
        Rule(cast_expression, 4, 'ExprCCast', ([], {'t': Ref(1), 'v': Ref(3)})),
        Rule(postfix_expression, 6, 'ExprQualifiedTemplateCreate', ([], {'args': Ref(4), 'id': Ref(2), 'glbl': False, 'nns': Ref(1)})),
        Rule(equality_expression, 3, 'ExprNotEqual', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(qualified_id, 4, 'IdQualified', ([], {'t': True, 'id': Ref(3), 'glbl': True, 'nns': Ref(1)})),
        Rule(type_id, 2, 'TypeId', ([], {'d': Ref(1), 'type': Ref(0)})),
        Rule(block_declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(mem_initializer_id, 3, 'ClassBase', ([], {'glbl': True, 'nns': Ref(1), 'name': Ref(2)})),
        Rule(new_type_id, 2, 'NewTypeId', ([], {'dtor': Ref(1), 'type': Ref(0)})),
        Rule(enum_specifier, 5, 'DeclEnum', ([], {'elist': Ref(3), 'name': Ref(1)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(postfix_expression, 5, 'ExprQualifiedTemplateCreate', ([], {'args': [], 'id': Ref(2), 'glbl': False, 'nns': Ref(1)})),
        Rule(primary_expression, 3, 'COPY', ([Ref(1)], {})),
        Rule(direct_abstract_declarator, 4, 'AbsDtorFunction', ([], {'d': None, 'excspec': Ref(3), 'cv': [], 'params': Ref(1)})),
        Rule(parameter_declaration, 3, 'Parameter', ([], {'dtor': None, 'type': Ref(0), 'default': Ref(2)})),
        Rule(direct_abstract_declarator, 6, 'AbsDtorFunction', ([], {'d': Ref(0), 'excspec': Ref(5), 'cv': Ref(4), 'params': Ref(2)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(assignment_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(qualified_id, 2, 'qualified_id_1', ([Ref(1)], {})),
        Rule(qualified_id, 3, 'IdQualified', ([], {'t': False, 'id': Ref(2), 'glbl': True, 'nns': Ref(1)})),
        Rule(assignment_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(member_declarator, 2, 'DtorInit', ([], {'d': Ref(0), 'init': Ref(1)})),
        Rule(cast_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(cd_id, 3, 'DtorDestructor', ([], {'glbl': False, 'nns': Ref(0), 'name': Ref(2)})),
        Rule(declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(id_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(initializer_clause, 4, 'InitList', ([], {'data': Ref(1)})),
        Rule(base_specifier, 3, 'base_specifier_1', ([], {'glbl': False, 'acc': None, 'name': Ref(2), 'nns': Ref(1)})),
        Rule(using_declaration, 5, 'DeclUsingNonGlobal', ([], {'id': Ref(3), 'glbl': True, 'nns': Ref(2), 'tn': False})),
        Rule(parameter_declaration_clause, 1, 'ParamList', ([], {'plist': [], 'etc': True})),
        Rule(type_parameter, 4, 'TypeParameter', ([], {'default': Ref(3), 'name': Ref(1)})),
        Rule(using_directive, 6, 'DeclUsingNamespace', ([], {'glbl': True, 'nns': Ref(3), 'name': Ref(4)})),
        Rule(delete_expression, 5, 'ExprDeleteArray', ([], {'v': Ref(4)})),
        Rule(_75, 3, 'APPEND', ([Ref(0), Ref(2)], {})),
        Rule(parameter_declaration, 4, 'Parameter', ([], {'dtor': Ref(1), 'type': Ref(0), 'default': Ref(3)})),
        Rule(new_declarator, 1, 'NewDeclaratorPtr', ([], {'dtor': None, 'op': Ref(0)})),
        Rule(assignment_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(_120, 3, 'APPEND', ([Ref(0), Ref(2)], {})),
        Rule(nested_name_specifier, 3, 'NestedNameSpecifier', ([], {'nns': Ref(2), 'name': Ref(0)})),
        Rule(member_declaration, 3, 'DeclSimple', ([], {'dtor': [], 'type': Ref(1), 'attrs': Ref(0)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(decl_attrib, 1, 'COPY', ([Ref(0)], {})),
        Rule(postfix_expression, 5, 'ExprQualifiedCreate', ([], {'args': [], 'glbl': False, 'nns': Ref(1), 'name': Ref(2)})),
        Rule(qualified_namespace_specifier, 3, 'IdQualifiedNamespace', ([], {'glbl': True, 'nns': Ref(1), 'name': Ref(2)})),
        Rule(enum_specifier, 3, 'DeclEnum', ([], {'elist': [], 'name': None})),
        Rule(explicit_instantiation, 2, 'DeclExplicitInst', ([], {'decl': Ref(1)})),
        Rule(jump_statement, 3, 'StmtGoto', ([], {'lbl': Ref(1)})),
        Rule(direct_abstract_declarator, 2, 'AbsDtorArray', ([], {'d': None, 'dim': None})),
        Rule(using_directive, 5, 'DeclUsingNamespace', ([], {'glbl': False, 'nns': Ref(2), 'name': Ref(3)})),
        Rule(block_declaration, 1, 'COPY', ([Ref(0)], {})),
        Rule(postfix_expression, 4, 'ExprIndirectAttributeAccess', ([], {'t': True, 'v': Ref(0), 'id': Ref(3)})),
        Rule(delete_expression, 2, 'ExprDelete', ([], {'v': Ref(1)})),
        Rule(relational_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(direct_abstract_declarator, 4, 'AbsDtorFunction', ([], {'d': Ref(0), 'excspec': None, 'cv': [], 'params': Ref(2)})),
        Rule(using_declaration, 4, 'DeclUsingNonGlobal', ([], {'id': Ref(2), 'glbl': False, 'nns': Ref(1), 'tn': False})),
        Rule(direct_abstract_declarator, 5, 'AbsDtorFunction', ([], {'d': None, 'excspec': Ref(4), 'cv': Ref(3), 'params': Ref(1)})),
        Rule(new_expression, 4, 'ExprNew', ([], {'t': Ref(3), 'place': Ref(2), 'glbl': True, 'init': None})),
        Rule(namespace_definition, 1, 'COPY', ([Ref(0)], {})),
        Rule(member_declaration, 5, 'MemberId', ([], {'t': True, 'id': Ref(3), 'glbl': True, 'nns': Ref(1)})),
        Rule(assignment_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(member_declaration, 4, 'MemberId', ([], {'t': True, 'id': Ref(2), 'glbl': False, 'nns': Ref(0)})),
        Rule(declaration_statement, 1, 'StmtDeclaration', ([], {'decl': Ref(0)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(compound_statement, 2, 'StmtCompound', ([], {'sts': []})),
        Rule(literal, 1, 'LiteralStr', ([], {'v': Ref(0)})),
        Rule(function_body, 1, 'COPY', ([Ref(0)], {})),
        Rule(_84, 3, 'APPEND', ([Ref(0), Ref(2)], {})),
        Rule(function_try_block, 3, 'FuncTryBlock', ([], {'handlers': Ref(2), 'body': Ref(1), 'init': None})),
        Rule(using_declaration, 5, 'DeclUsingNonGlobal', ([], {'id': Ref(3), 'glbl': False, 'nns': Ref(2), 'tn': True})),
        Rule(template_argument, 1, 'TmpltArgType', ([], {'t': Ref(0)})),
        Rule(direct_declarator, 3, 'DtorArray', ([], {'d': Ref(0), 'dim': None})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(namespace_alias_definition, 5, 'DeclNamespaceAlias', ([], {'ns': Ref(3), 'name': Ref(1)})),
        Rule(simple_declaration, 3, 'DeclSimple', ([], {'dtor': Ref(1), 'attrs': Ref(0)})),
        Rule(unary_expression, 2, 'ExprPreInc', ([], {'v': Ref(1)})),
        Rule(unary_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(statement, 1, 'COPY', ([Ref(0)], {})),
        Rule(base_specifier, 4, 'ClassBase', ([], {'v': False, 'glbl': True, 'acc': Ref(0), 'name': Ref(3), 'nns': Ref(2)})),
        Rule(base_specifier, 4, 'base_specifier_1', ([], {'glbl': True, 'acc': Ref(1), 'name': Ref(3), 'nns': None})),
        Rule(labeled_statement, 3, 'StmtLabeled', ([], {'lbl': Ref(0), 'st': Ref(2)})),
        Rule(new_expression, 2, 'ExprNew', ([], {'t': Ref(1), 'place': None, 'glbl': False, 'init': None})),
        Rule(and_expression, 3, 'ExprBitwiseAnd', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(postfix_expression, 3, 'ExprAttributeAccess', ([], {'t': False, 'v': Ref(0), 'id': Ref(2)})),
        Rule(type_parameter, 2, 'TypeParameter', ([], {'name': Ref(1)})),
        Rule(unary_expression, 1, 'COPY', ([Ref(0)], {})),
        Rule(function_definition, 2, 'DeclFunction', ([], {'body': Ref(1), 'head': Ref(0), 'init': None})),
        Rule(base_specifier, 2, 'ClassBase', ([], {'glbl': True, 'nns': None, 'name': Ref(1)})),
        Rule(postfix_expression, 3, 'ExprIndirectAttributeAccess', ([], {'t': False, 'v': Ref(0), 'id': Ref(2)})),
        Rule(expression, 3, 'ExprComma', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(assignment_operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(simple_declaration, 2, 'DeclSimple', ([], {'dtor': Ref(0), 'attrs': []})),
        Rule(enumerator_definition, 1, 'Enumerator', ([], {'name': Ref(0)})),
        Rule(direct_abstract_declarator, 5, 'AbsDtorFunction', ([], {'d': Ref(0), 'excspec': Ref(4), 'cv': [], 'params': Ref(2)})),
        Rule(_81, 2, 'APPEND', ([Ref(0), Ref(1)], {})),
        Rule(_114, 1, 'LIST', ([Ref(0)], {})),
        Rule(primary_expression, 1, 'ExprThis', ([], {})),
        Rule(member_declaration, 3, 'DeclSimple', ([], {'dtor': Ref(1), 'type': Ref(0), 'attrs': []})),
        Rule(shift_expression, 3, 'ExprLeftShift', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(unqualified_id, 2, 'IdFinaliser', ([], {'name': Ref(1)})),
        Rule(template_parameter, 1, 'COPY', ([Ref(0)], {})),
        Rule(logical_or_expression, 3, 'ExprLogicalOr', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(simple_declaration, 4, 'DeclSimple', ([], {'dtor': Ref(2), 'type': Ref(1), 'attrs': Ref(0)})),
        Rule(template_declaration, 5, 'DeclTemplate', ([], {'plist': Ref(2), 'exp': False, 'decl': Ref(4)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(jump_statement, 3, 'StmtReturn', ([], {'v': Ref(1)})),
        Rule(literal, 1, 'LiteralChar', ([], {'v': Ref(0)})),
        Rule(exclusive_or_expression, 3, 'ExprBitwiseXOr', ([], {'a': Ref(0), 'b': Ref(2)})),
        Rule(operator, 1, 'COPY', ([Ref(0)], {})),
        Rule(additive_expression, 3, 'ExprAdd', ([], {'a': Ref(0), 'b': Ref(2)})),
        ]


for n,s in enumerate(CXXParser.TABLE.states): s.n = n
